--
-- PostgreSQL database dump
--

SET statement_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = off;
SET check_function_bodies = false;
SET client_min_messages = warning;
SET escape_string_warning = off;

SET search_path = public, pg_catalog;

SET default_tablespace = '';

SET default_with_oids = false;

--
-- Name: authorization_group; Type: TABLE; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE TABLE authorization_group (
    id text NOT NULL,
    name text,
    created timestamp without time zone
);


ALTER TABLE public.authorization_group OWNER TO ckantest;

--
-- Name: authorization_group_role; Type: TABLE; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE TABLE authorization_group_role (
    user_object_role_id text NOT NULL,
    authorization_group_id text
);


ALTER TABLE public.authorization_group_role OWNER TO ckantest;

--
-- Name: authorization_group_user; Type: TABLE; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE TABLE authorization_group_user (
    id text NOT NULL,
    authorization_group_id text NOT NULL,
    user_id text NOT NULL
);


ALTER TABLE public.authorization_group_user OWNER TO ckantest;

--
-- Name: change; Type: TABLE; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE TABLE change (
    ref text,
    diff text,
    changeset_id text
);


ALTER TABLE public.change OWNER TO ckantest;

--
-- Name: changemask; Type: TABLE; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE TABLE changemask (
    ref text NOT NULL,
    "timestamp" timestamp without time zone
);


ALTER TABLE public.changemask OWNER TO ckantest;

--
-- Name: changeset; Type: TABLE; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE TABLE changeset (
    id text NOT NULL,
    closes_id text,
    follows_id text,
    meta text,
    branch text,
    "timestamp" timestamp without time zone,
    is_working boolean,
    revision_id text,
    added_here timestamp without time zone
);


ALTER TABLE public.changeset OWNER TO ckantest;

--
-- Name: group; Type: TABLE; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE TABLE "group" (
    id text NOT NULL,
    name text NOT NULL,
    title text,
    description text,
    created timestamp without time zone,
    state text,
    revision_id text
);


ALTER TABLE public."group" OWNER TO ckantest;

--
-- Name: group_extra; Type: TABLE; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE TABLE group_extra (
    id text NOT NULL,
    group_id text,
    key text,
    value text,
    state text,
    revision_id text
);


ALTER TABLE public.group_extra OWNER TO ckantest;

--
-- Name: group_extra_revision; Type: TABLE; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE TABLE group_extra_revision (
    id text NOT NULL,
    group_id text,
    key text,
    value text,
    state text,
    revision_id text,
    continuity_id text
);


ALTER TABLE public.group_extra_revision OWNER TO ckantest;

--
-- Name: group_revision; Type: TABLE; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE TABLE group_revision (
    id text NOT NULL,
    name text NOT NULL,
    title text,
    description text,
    created timestamp without time zone,
    state text,
    revision_id text,
    continuity_id text
);


ALTER TABLE public.group_revision OWNER TO ckantest;

--
-- Name: group_role; Type: TABLE; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE TABLE group_role (
    user_object_role_id text NOT NULL,
    group_id text
);


ALTER TABLE public.group_role OWNER TO ckantest;

--
-- Name: harvest_source; Type: TABLE; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE TABLE harvest_source (
    id text NOT NULL,
    url text NOT NULL,
    description text,
    user_ref text,
    publisher_ref text,
    created timestamp without time zone
);


ALTER TABLE public.harvest_source OWNER TO ckantest;

--
-- Name: harvested_document; Type: TABLE; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE TABLE harvested_document (
    id text NOT NULL,
    guid text,
    created timestamp without time zone,
    content text NOT NULL,
    source_id text,
    package_id text
);


ALTER TABLE public.harvested_document OWNER TO ckantest;

--
-- Name: harvesting_job; Type: TABLE; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE TABLE harvesting_job (
    id text NOT NULL,
    status text NOT NULL,
    created timestamp without time zone,
    user_ref text NOT NULL,
    report text,
    source_id text
);


ALTER TABLE public.harvesting_job OWNER TO ckantest;

--
-- Name: migrate_version; Type: TABLE; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE TABLE migrate_version (
    repository_id character varying(255) NOT NULL,
    repository_path text,
    version integer
);


ALTER TABLE public.migrate_version OWNER TO ckantest;

--
-- Name: package; Type: TABLE; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE TABLE package (
    id text NOT NULL,
    name character varying(100) NOT NULL,
    title text,
    version character varying(100),
    url text,
    author text,
    author_email text,
    maintainer text,
    maintainer_email text,
    notes text,
    license_id text,
    state text,
    revision_id text
);


ALTER TABLE public.package OWNER TO ckantest;

--
-- Name: package_extra; Type: TABLE; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE TABLE package_extra (
    id text NOT NULL,
    package_id text,
    key text,
    value text,
    state text,
    revision_id text
);


ALTER TABLE public.package_extra OWNER TO ckantest;

--
-- Name: package_extra_revision; Type: TABLE; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE TABLE package_extra_revision (
    id text NOT NULL,
    package_id text,
    key text,
    value text,
    state text,
    revision_id text NOT NULL,
    continuity_id text
);


ALTER TABLE public.package_extra_revision OWNER TO ckantest;

--
-- Name: package_group; Type: TABLE; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE TABLE package_group (
    id text NOT NULL,
    package_id text,
    group_id text,
    state text,
    revision_id text
);


ALTER TABLE public.package_group OWNER TO ckantest;

--
-- Name: package_group_revision; Type: TABLE; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE TABLE package_group_revision (
    id text NOT NULL,
    package_id text,
    group_id text,
    state text,
    revision_id text,
    continuity_id text
);


ALTER TABLE public.package_group_revision OWNER TO ckantest;

--
-- Name: package_relationship; Type: TABLE; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE TABLE package_relationship (
    id text NOT NULL,
    subject_package_id text,
    object_package_id text,
    type text,
    comment text,
    state text,
    revision_id text
);


ALTER TABLE public.package_relationship OWNER TO ckantest;

--
-- Name: package_relationship_revision; Type: TABLE; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE TABLE package_relationship_revision (
    id text NOT NULL,
    subject_package_id text,
    object_package_id text,
    type text,
    comment text,
    state text,
    revision_id text NOT NULL,
    continuity_id text
);


ALTER TABLE public.package_relationship_revision OWNER TO ckantest;

--
-- Name: package_resource; Type: TABLE; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE TABLE package_resource (
    id text NOT NULL,
    package_id text,
    url text NOT NULL,
    format text,
    description text,
    hash text,
    "position" integer,
    state text,
    revision_id text
);


ALTER TABLE public.package_resource OWNER TO ckantest;

--
-- Name: package_resource_revision; Type: TABLE; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE TABLE package_resource_revision (
    id text NOT NULL,
    package_id text,
    url text NOT NULL,
    format text,
    description text,
    hash text,
    "position" integer,
    state text,
    revision_id text NOT NULL,
    continuity_id text
);


ALTER TABLE public.package_resource_revision OWNER TO ckantest;

--
-- Name: package_revision; Type: TABLE; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE TABLE package_revision (
    id text NOT NULL,
    name character varying(100) NOT NULL,
    title text,
    version character varying(100),
    url text,
    author text,
    author_email text,
    maintainer text,
    maintainer_email text,
    notes text,
    license_id text,
    state text,
    revision_id text NOT NULL,
    continuity_id text
);


ALTER TABLE public.package_revision OWNER TO ckantest;

--
-- Name: package_role; Type: TABLE; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE TABLE package_role (
    user_object_role_id text NOT NULL,
    package_id text
);


ALTER TABLE public.package_role OWNER TO ckantest;

--
-- Name: package_search; Type: TABLE; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE TABLE package_search (
    package_id text NOT NULL,
    search_vector tsvector
);


ALTER TABLE public.package_search OWNER TO ckantest;

--
-- Name: package_tag; Type: TABLE; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE TABLE package_tag (
    id text NOT NULL,
    package_id text,
    tag_id text,
    state text,
    revision_id text
);


ALTER TABLE public.package_tag OWNER TO ckantest;

--
-- Name: package_tag_revision; Type: TABLE; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE TABLE package_tag_revision (
    id text NOT NULL,
    package_id text,
    tag_id text,
    state text,
    revision_id text NOT NULL,
    continuity_id text
);


ALTER TABLE public.package_tag_revision OWNER TO ckantest;

--
-- Name: rating; Type: TABLE; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE TABLE rating (
    id text NOT NULL,
    user_id text,
    user_ip_address text,
    package_id text,
    rating real,
    created timestamp without time zone
);


ALTER TABLE public.rating OWNER TO ckantest;

--
-- Name: revision; Type: TABLE; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE TABLE revision (
    id text NOT NULL,
    "timestamp" timestamp without time zone,
    author character varying(200),
    message text,
    state text
);


ALTER TABLE public.revision OWNER TO ckantest;

--
-- Name: role_action; Type: TABLE; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE TABLE role_action (
    id text NOT NULL,
    role text,
    context text NOT NULL,
    action text
);


ALTER TABLE public.role_action OWNER TO ckantest;

--
-- Name: system_role; Type: TABLE; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE TABLE system_role (
    user_object_role_id text NOT NULL
);


ALTER TABLE public.system_role OWNER TO ckantest;

--
-- Name: tag; Type: TABLE; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE TABLE tag (
    id text NOT NULL,
    name character varying(100) NOT NULL
);


ALTER TABLE public.tag OWNER TO ckantest;

--
-- Name: user; Type: TABLE; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE TABLE "user" (
    id text NOT NULL,
    name text,
    apikey text,
    created timestamp without time zone,
    about text,
    openid text,
    password text,
    fullname text,
    email text
);


ALTER TABLE public."user" OWNER TO ckantest;

--
-- Name: user_object_role; Type: TABLE; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE TABLE user_object_role (
    id text NOT NULL,
    user_id text,
    authorized_group_id text,
    context text NOT NULL,
    role text
);


ALTER TABLE public.user_object_role OWNER TO ckantest;

--
-- Data for Name: authorization_group; Type: TABLE DATA; Schema: public; Owner: ckantest
--

COPY authorization_group (id, name, created) FROM stdin;
\.


--
-- Data for Name: authorization_group_role; Type: TABLE DATA; Schema: public; Owner: ckantest
--

COPY authorization_group_role (user_object_role_id, authorization_group_id) FROM stdin;
\.


--
-- Data for Name: authorization_group_user; Type: TABLE DATA; Schema: public; Owner: ckantest
--

COPY authorization_group_user (id, authorization_group_id, user_id) FROM stdin;
\.


--
-- Data for Name: change; Type: TABLE DATA; Schema: public; Owner: ckantest
--

COPY change (ref, diff, changeset_id) FROM stdin;
\.


--
-- Data for Name: changemask; Type: TABLE DATA; Schema: public; Owner: ckantest
--

COPY changemask (ref, "timestamp") FROM stdin;
\.


--
-- Data for Name: changeset; Type: TABLE DATA; Schema: public; Owner: ckantest
--

COPY changeset (id, closes_id, follows_id, meta, branch, "timestamp", is_working, revision_id, added_here) FROM stdin;
\.


--
-- Data for Name: group; Type: TABLE DATA; Schema: public; Owner: ckantest
--

COPY "group" (id, name, title, description, created, state, revision_id) FROM stdin;
\.


--
-- Data for Name: group_extra; Type: TABLE DATA; Schema: public; Owner: ckantest
--

COPY group_extra (id, group_id, key, value, state, revision_id) FROM stdin;
\.


--
-- Data for Name: group_extra_revision; Type: TABLE DATA; Schema: public; Owner: ckantest
--

COPY group_extra_revision (id, group_id, key, value, state, revision_id, continuity_id) FROM stdin;
\.


--
-- Data for Name: group_revision; Type: TABLE DATA; Schema: public; Owner: ckantest
--

COPY group_revision (id, name, title, description, created, state, revision_id, continuity_id) FROM stdin;
\.


--
-- Data for Name: group_role; Type: TABLE DATA; Schema: public; Owner: ckantest
--

COPY group_role (user_object_role_id, group_id) FROM stdin;
\.


--
-- Data for Name: harvest_source; Type: TABLE DATA; Schema: public; Owner: ckantest
--

COPY harvest_source (id, url, description, user_ref, publisher_ref, created) FROM stdin;
\.


--
-- Data for Name: harvested_document; Type: TABLE DATA; Schema: public; Owner: ckantest
--

COPY harvested_document (id, guid, created, content, source_id, package_id) FROM stdin;
\.


--
-- Data for Name: harvesting_job; Type: TABLE DATA; Schema: public; Owner: ckantest
--

COPY harvesting_job (id, status, created, user_ref, report, source_id) FROM stdin;
\.


--
-- Data for Name: migrate_version; Type: TABLE DATA; Schema: public; Owner: ckantest
--

COPY migrate_version (repository_id, repository_path, version) FROM stdin;
Ckan	/home/ckan/pyenv/src/ckan/ckan/migration	31
\.


--
-- Data for Name: package; Type: TABLE DATA; Schema: public; Owner: ckantest
--

COPY package (id, name, title, version, url, author, author_email, maintainer, maintainer_email, notes, license_id, state, revision_id) FROM stdin;
4402487d-3e8d-4618-8444-b400c6337834	isf2009	Impôt de Solidarité sur la Fortune par commune 2009	\N	http://www.impots.gouv.fr/portal/deploiement/p1/fichedescriptive_5582/fichedescriptive_5582.xls	Ministère du budget	\N	\N	\N	Impôt de Solidarité sur la Fortune\r\nANNEE 2009\r\nVilles de plus de 20 000 habitants ayant plus de 50 redevables à l'ISF	notspecified	active	9bae0509-72a9-4de7-a4f4-f24c8532fcda
587ed76e-1c2f-4cc7-a23a-f9beb2415c77	taux_fiscalite_2001_2009	Taux de Fiscalité Directe Locale par région 2001-2009	\N	http://www.impots.gouv.fr/portal/deploiement/p1/fichedescriptive_5458/fichedescriptive_5458.xls	Ministère du budget	\N	\N	\N	\N	notspecified	active	db5217fd-ac78-4ac0-9a7a-1dbd76d734eb
4235252c-aa21-46b5-8c52-110f95bdc583	resultats-des-elections-presidentielles-2007	Résultats des élections présidentielles 2007	\N	http://www.regardscitoyens.org/publication/#donnees	Ministère de l'intérieur	\N	Regards Citoyens	contact@regardscitoyens.org	Données obtenues auprès du ministère de l'intérieur. Elles correspondent aux résultats des deux tours de l'élection présidentielle de 2007, bureaux de vote par bureaux de vote.	cc-by-sa	active	235bde9c-3506-4225-8038-e865d0b97e75
e3424ea9-f7c0-4d80-832b-890c3de0f744	resultats-des-elections-municipales-du-tarn	Résultats des élections municipales du tarn	\N	http://www.tarn.pref.gouv.fr/elections/CM2008/	Préfecture du Tarn	\N	\N	\N	Résultats des élections municipales de 2008 dans le tarn au format xml. Un fichier par commune, le fichier est débute par 081 (code du département) et est suivit du code INSEE de la commune	\N	active	a6a5efac-b108-40c8-847c-e06530596dae
db34f769-ed94-45d3-8b66-5ebaf9b091ff	exportation-et-importation-de-produit-sur-trois-ans	Exportation et importation de produit sur trois ans	\N	http://lekiosque.finances.gouv.fr/Appchiffre/LEO/surcadre_LEO.asp	Le douanes	\N	\N	\N	L'interface de ce site permet de consulter et télécharger en csv les exportations et importations enregistrées par les douanes sur trois ans.\r\n\r\nLes produits sont catégorisés par une "nomenclature combinée" NC8. Pour accéder aux données, il faut donc connaitre le code NC8 du produit dont on cherche à connaitre les importations et exportations.	\N	active	53b7a5cf-ae69-4bb1-b239-940facaeb014
97b2cf1e-91f4-4b08-a7d8-2e6bd1dca37e	taux-de-fiscalit-directe-des-communes	Taux de fiscalité directe des communes	\N	http://www.dgcl.interieur.gouv.fr/sections/a_votre_service/statistiques/fiscalite_locale/communes/	Direction générale des collectivités locales	\N	\N	\N	Répertorie le taux de fiscalité direct voté par les communes de plus de 10 000 habitants	\N	active	a5bfd523-f3c2-41e2-9e1a-1624d786767c
e4c69e90-1056-4f46-9619-57d0a18d1737	taux-de-fiscalit-directe-des-groupement-de-communes	Taux de fiscalité directe des groupement de communes	\N	http://www.dgcl.interieur.gouv.fr/sections/a_votre_service/statistiques/fiscalite_locale/groupements_de_commu/	Direction générale des collectivités locales	\N	\N	\N	Taux de fiscalité des communautés urbaines et communautés d'agglomération entre 2006 et 2010.	\N	active	19979634-e047-4bef-b09b-396ebbbf7fd0
43c3cc44-3a6c-469b-80fe-913927d2c283	donnees-transport-rennes-metropole	Données transport de Rennes métropole	2010.10.13	http://data.keolis-rennes.com/fr/les-donnees/donnees-telechargeables.html	Keolis Rennes	\N	\N	\N	Données du réseau STAR et du service LE vélo STAR, réseau de transport public de Rennes Métropole, opéré par Keolis Rennes, au format <a href="http://code.google.com/intl/fr/transit/spec/transit_feed_specification.html">GTFS</a>.\r\n\r\nLa licence est spécifique et intitulée <a href="http://www.data.rennes-metropole.fr/fr/lentrepot/licence-dutilisation.html">"Licence de réutilisation des données publiques - Rennes Métropole en accès libre"</a>	\N	active	487378c3-79fa-4f69-8a37-3ad81f3fca33
1901d722-a38d-4e79-a13c-ca51d61bae30	donnees-geographiques-insee	Données géographiques INSEE	1	http://rdf.insee.fr/geo/	INSEE	publication-xml-dg@insee.fr	\N	\N	L'Insee publie dans cette section des données issues du code officiel géographique (COG) modélisées selon le standard RDF du web sémantique.\r\n\r\nDe nombreux autres fichiers RDF correspondants aux arrondissements et cantons sont disponibles sur la page spécifiée.\r\n\r\nLa licence : http://www.insee.fr/fr/publications-et-services/default.asp?page=copyright.htm	\N	active	b2b4b103-d694-4105-86d7-fa937445826f
3aa0d5ce-cef6-4158-b51e-ddee8ece7b5e	entreprises-polluantes	Entreprises produisant des émissions polluantes	\N	http://www.pollutionsindustrielles.ecologie.gouv.fr/IREP/	Ministère de l'écologie	\N	\N	\N	Le registre français des émissions polluantes publie les entreprises ayant été répertoriées comme émettant des polluants.\r\n\r\nLa base est téléchargeable en plusieurs fichiers CSV.	cada	active	f2a6db5d-8947-477a-b302-ea0660e033af
5e86134f-2cb5-40e9-affa-f80d934a14b9	observatoire-des-prix-et-des-marges	Observatoire des prix et des marges	\N	http://www.dgccrf.bercy.gouv.fr/concurrence/prix/observatoire_prix.htm	Direction générale de la concurrence, de la consommation et de la répression des fraudes	webmestre@dgccrf.finances.gouv.fr	Jean-Luc Ambroise	\N	Il s'agit d'un ensemble de données concernant l'observation des prix et des marges depuis 2008 dans différentes filières. Ces données sont au format HTML ou PDF et proposées par la direction générale de la concurrence, de la consommation\r\net de la répression des fraudes.	cada	active	bf59cab9-2d7a-47a2-b5a7-f070f5a5fd58
5b23d4f4-058e-44e0-945d-ae9035fb1e15	liste-des-maires-de-seine-maritime	Liste des maires de Seine Maritime	\N	\N	Préfecture de Seine Maritime	\N	\N	\N	Liste de tous les maires de Seine-Maritime.	\N	active	c358b6bb-4b0a-48ee-9421-0854d1f68fca
be516eed-8a37-436c-af75-b623f0806f39	donnees-de-trafic-de-grandes-villes	Données de Trafic de grandes villes	\N	http://www.bison-fute.equipement.gouv.fr/fr/article.php3?id_article=274	Bison Futé	\N	\N	\N	Bison Futé met à disposition en XML des données de trafic de 13 villes françaises : Bordeaux, Lyon, Marseille, Lille, Caen, Rennes, Nantes, Saint Étienne, Grenoble, Strasbourg, Clermont-Ferrand, Limoge, et la Savoie.\r\n\r\nLes données de trafic sont actualisées toutes les 6 minutes.\r\n\r\n\r\nVoir aussi la page http://www.bison-fute.equipement.gouv.fr/fr/article.php3?id_article=545	\N	active	df68a822-74c8-41c1-8cfe-d0d1a685c74f
f6c6aac7-3c9b-4a3c-80bc-d6709bc95d4b	rsultat-des-lections-lgislatives-2007-et-application-au-redcoupage-de-2012	Résultats des élections législatives 2007 et application au redécoupage de 2012	1.1	http://www.regardscitoyens.org/redecoupage/	Regards Citoyens	contact@regardscitoyens.org	\N	\N	Résultats de 2007 par circonscription et par bureau de vote avec informations démographiques associées et prévisions de résultats sur la carte prévisionnelle des circonscriptions pour l'élection 2012 à partir de la relocalisation des résultats de 2007	odc-odbl	active	c42aefff-d420-4504-95d7-3d69e49d3c8a
69361720-3428-417e-beb4-d21df542992c	comptes-regionalises-des-administrations-publiques-locales-en-2007	Comptes régionalisés des administrations publiques locales en 2007 	\N	http://www.insee.fr/fr/themes/detail.asp?reg_id=99&ref_id=apul-regions	INSEE	\N	\N	\N	\N	notspecified	active	8b208a3e-558c-4884-9cc1-297a0dc0e174
65d7e18e-c5ab-4736-bb9e-c47de2dc41e1	import-export-par-pays	Import export par pays	\N	http://lekiosque.finances.gouv.fr/Appchiffre/pays/surcadre_pays.asp	Direction générale des douanes	\N	\N	\N	La libération de ces données a été organisée ici :\r\n\r\nhttp://www.nosdonnees.fr/wiki/index.php/Donn%C3%A9es_d%27import_export_par_pays	odc-odbl	active	a5675df6-074d-4301-8987-bf9d514050f4
6968ef13-1d2f-4de3-b533-706bc9c0f604	golocalisation-des-bureaux-de-votes	Géolocalisation des bureaux de votes	\N	http://elections.regardscitoyens.org/etrac/browser/elections/trunk	Regards Citoyens	contact@regardscitoyens.org	\N	\N	Géolocalisation des bureaux de vote par régions/départements en csv. Parcourir l'arbre pour consulter les fichiers csv générés à partir de combinaisons d'extraiots des xls et pdf des préfectures et du crowdsourcing réalisé grâce à l'application de 22 Mars.\r\nToutes les informations sur : http://elections.regardscitoyens.org/etrac\r\n	odc-odbl	active	dca1567f-bb5c-4f07-ba22-d27778ebde69
34269022-c891-4a8e-a814-3af2b0fea526	donnes-gographiques-des-communes-par-code-insee	Données géographiques des communes par code INSEE	01-01-2009	http://www.insee.fr/fr/themes/detail.asp?reg_id=99&ref_id=base-cc-table-appartenance-geo-communes	INSEE	\N	\N	\N	Table d'appartenance géographique des communes.\r\n\r\nCe fichier fournit pour toutes les communes le code géographique des niveaux géographiques supérieurs auxquels elles appartiennent.\r\n\r\nRelié aux tables d'indicateurs Chiffres clés, ce fichier permet d'obtenir des résultats agrégés d'indicateurs sur un territoire communal personnalisé ou des territoires supra-communaux. 	odc-odbl	active	a23213e4-603f-42b1-88e7-f9f17b4bdb6d
6d999f74-d520-4a8c-8188-5a5c13c6bbec	donnees-sante-france	Données Santé France	\N	http://www.ecosante.fr/index.php?langs=FRA&langh=FRA&sessionid=	IRDES	ecosante@irdes.fr	\N	\N	Dépenses de santé; Etat de santé; Professions de santé; Hôpitaux; Secteur pharmaceutique; Protection sociale; Démographie; Indicateurs économiques	\N	active	0f921f9a-fa99-4cb7-90ef-aab5c836c057
a1019da5-cdac-4e09-8b60-831994b5f275	horairesbibliothequesnantes	HorairesBibliothequesNantes	0.1	http://www.bm.nantes.fr/	Mairie de Nantes	\N	Arthur Lutz	arthur.lutz@gmail.com	\N	notspecified	active	37fbb496-6950-4dfe-96b7-1b2dc46a8c68
29772378-f226-4fc8-8e01-9a87c5e43a00	pegase	Pétrole, Électricité, Gaz et Autres Statistiques de l’Énergie	\N	http://www.statistiques.equipement.gouv.fr/article.php3?id_article=1315	Ministère de l'Écologie, de l'Energie, du Développement durable et de la Mer, en charge des Technologies vertes et des Négociations sur le climat	\N	\N	\N	La base Pégase (acronyme de Pétrole, Électricité, Gaz et Autres Statistiques de l’Énergie) enregistre et diffuse les statistiques de l’énergie rassemblées par le Service de l’observation et des statistiques (SOeS).	cada	active	c3d4f682-208d-482a-bc84-08462a334b80
cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	activit-des-dputs-de-lassemble-nationale-13me-lgislature	Activité des députés de l'Assemblée nationale (13ème législature)	2011-03-01	http://www.regardscitoyens.org/telechargement/donnees/	Regards Citoyens	contact@regardscitoyens.org	\N	\N	Ensemble des données parlementaires sur les députés. Informations extraites du site de l'Assemblée nationale et du Journal Officiel pour la constitution du site http://NosDeputes.fr\r\nCes données comprennent toutes les informations disponibles sur chaque député, toutes les questions et interventions en séance publique et en commissions ainsi que tous les amendements, propositions de lois et rapports produits depuis le début de la législature.\r\nCes données sont celles en date du 1er du mois en cours et sont remises à jour mensuellement.\r\n\r\nUne API est également disponible pour accéder aux données : http://cpc.regardscitoyens.org/trac/wiki/API	cc-by-sa	active	ca799f60-69a3-4c16-bd13-b8a9e4e8a360
f3d8ca3c-32b9-4485-95d9-0b1fd4a5dd4e	prsence-des-dputs-au-cours-de-la-session-2009-2010	Présence des députés au cours de la session 2009-2010	2010-07	http://www.nosdeputes.fr/confiseurs/2010/	Regards Citoyens	contact@regardscitoyens.org	\N	\N	Données relatives aux sanctions encourues par les députés insuffisamment présents à l'Assemblée au cours de la session 2009-2010.\r\nLe collectif Regards Citoyens a mené une étude à partir des données de http://NosDeputes.fr visant à évaluer l'incidence des modifications du règlement sur la participation des députés aux travaux de l'Assemblée, notamment aux réunions des commissions. Le règlement impose en effet avec ses articles 42 et 159 des sanctions financières sur l'indemnité de fonction des députés manifestant des absences répétées aux réunions de leur commission permanente le mercredi matin ou aux scrutins solennels en hémicycle.	odc-odbl	active	df2739ce-379a-42e2-acce-04b95b44d349
0e14dccb-9c28-4f89-b3b2-cb1011be06d1	financement-des-associations-par-l-etat	Financement des associations par l'état	\N	http://www.performance-publique.gouv.fr/farandole/2010/jaune.html#resultat	Ministère du Budget, des Comptes publics, de la Fonction publique et de la Réforme de l'État (=> Bercy)	\N	bboissin	\N	Dans les plans de finance, il y a des données financières notamment sur le financement des associations. Elles se trouvent dans le tome 3 des annexes jaunes.\r\n\r\nUne extraction de ces données a été réalisée à l'occasion de la préparation de la loi de finance 2010.\r\n\r\nRemarque : Le PDF http://www.performance-publique.budget.gouv.fr/fileadmin/medias/documents/ressources/circulaires/1BLF-07-774_guide.pdf semble montrer la structure des données en interne.	cc-by	active	0b54823d-ebef-4a0a-934c-e408c127861a
3fabe36b-965b-498d-9b3a-0649bbbfd0a5	statistique-des-remboursements-du-regime-general-de-sante	Statistique des remboursements du régime général de santé	\N	http://www.ameli.fr/l-assurance-maladie/statistiques-et-publications/analyse-des-depenses/depenses-les-remboursements-depuis-1-an/les-statistiques-mensuelles-du-regime-general.php	Caisse nationale de l'Assurance Maladie des travailleurs salariés	\N	\N	\N	Ventilation des dépenses de l'Assurance Maladie selon les différentes catégories de professionnels de santé qui ont dispensé ces soins :\r\n\r\n* Le suivi de la dépense totale, les dépenses remboursables et les dépenses remboursées ;\r\n* Les soins de ville par lieu d'exécution ;\r\n* Les honoraires des médecins par spécialité et lieu d'exécution ;\r\n* Les dépenses d'hospitalisation (y.c les honoraires en cliniques privées) ;\r\n* Les dépenses par région.	cada	active	2f2740b4-eedd-416c-98a0-bd76359cdd12
2502f9a7-15fa-439d-8a48-f61f38cb6f55	donnes-gographiques---rgions-dpartements-arrondissements-cantons	Données géographiques: Régions, Départements, Arrondissements, Cantons	\N	http://rdf.insee.fr/geo/	INSEE	publication-xml-dg@insee.fr	INSEE	publication-xml-dg@insee.fr	L'Insee publie dans cette section des données issues du code officiel géographique (COG) modélisées selon le standard RDF du web sémantique.\r\n\r\n\r\n* Le fichier "Régions" contient la liste des régions ainsi que leur chef-lieu et les départements inclus dans ces régions.\r\n* Le fichier "Départements" contient la liste des départements, leurs chef-lieux ainsi que les arrondissements inclus dans ces départements\r\n* Le fichier "Arrondissements" incluant la liste des communes et cantons par arrondissement du département.\r\n* Le fichier "Cantons", qui modélise les liens entre communes et cantons ainsi que les relations de voisinage entre communes (y compris les communes limitrophes du département).	cada	active	39219937-0939-40ca-86a8-f8493a35a337
4276f7df-c7e9-44e1-8886-20ad41ebda0a	diplome-national-du-brevet-session-2009	Diplôme national du brevet, Session 2009	\N	http://www.education.gouv.fr/cid53600/diplome-national-du-brevet-session-2009.html	MEN-DEPP	depp.documentation@education.gouv.fr	MEN-DEPP	depp.diffusion@education.gouv.fr	En 2009, 609 400 candidats ont obtenu le diplôme national du brevet (DNB), soit un taux de réussite de 82,7 %, en légère hausse par rapport à la session 2008.\r\nLes écarts de réussite entre les départements de la métropole restent importants (15 points), mais se réduisent d’une session à l’autre.\r\nPrès de neuf élèves sur dix passent le DNB série collège, qui présente le taux de réussite le plus élevé (83,6 %), cinq élèves sur cent présentent la série technologique avec une réussite de 82,1 %, et un peu plus de cinq élèves sur cent la série professionnelle dont le taux de réussite est le plus faible (68 %).\r\nLes filles ont de meilleurs résultats que les garçons (+ 6 points) et un tiers d’entre elles obtiennent une mention bien ou très bien.\r\nL’origine sociale marque fortement la réussite au brevet: le taux de réussite passe ainsi de 68 % à 95 % selon que l’élève a un parent sans activité professionnelle ou cadre. De même, les chances d’obtenir une mention bien ou très bien varient de un à trois selon le milieu social: 44 % des enfants de cadres sont concernés, contre seulement 14 % des enfants dont le responsable est sans activité professionnelle.	notspecified	active	8b876446-18be-45e9-98d2-2ad4a1b1e7fa
f4517261-c1ee-4380-b3ad-0de5a0edc09a	resultats-definitifs-de-la-session-2009-du-baccalaurat	Résultats définitifs de la session 2009 du baccalauréat	\N	http://www.education.gouv.fr/cid51136/resultats-definitifs-de-la-session-2009-du-baccalaureat.html	MEN-DEPP	depp.documentation@education.gouv.fr	MEN-DEPP	depp.diffusion@education.gouv.fr	Avec 625 700 candidats et 539 100 lauréats, le taux de réussite à la session 2009 s’élève à 86,2 %. Les effectifs des bacheliers, comme ceux des candidats, ont augmenté par rapport à 2008 dans les voies générale et professionnelle, et ont diminué dans la voie technologique. La proportion de bacheliers dans une génération augmente de 3,2 points par rapport à l’an passé.\r\nEn 2009, 65,6 % des jeunes d’une génération obtiennent le baccalauréat : 35,1 % dans une série générale, 16,0 % dans une série technologique, 14,5 dans une une série professionnelle. La hausse du taux de réussite est due, en grande partie, au baccalauréat professionnel. En effet, avec la mise en place à la session 2009 d’épreuves de rattrapage, le taux de réussite au baccalauréat professionnel atteint 87,3 %, soit une hausse de 10,3 points par rapport à 2008.\r\nDans la voie générale, le taux de réussite augmente légèrement (+ 1 point par rapport à 2008) et s’élève ainsi à 88,9 %, niveau jamais atteint au cours des années précédentes.\r\nDans la voie technologique, le nombre de lauréats a baissé plus fortement que le nombre de candidats, entraînant ainsi une diminution du taux de réussite de 0,5 point (79,8 % contre 80,3 % en 2008).	notspecified	active	ab96c2af-06af-4bad-8c4f-00ec10f98776
9382520e-adb5-4403-848d-5bd5ea476202	liste-des-candidats-aux-cantonales-2011-1er-tour	Liste des candidats aux cantonales 2011 (1er tour)	\N	\N	Ministère de l'intérieur	\N	\N	\N	La liste de tous les candidats aux élections cantonale de mars 2011	cada	active	9a1682ec-e74a-4539-8bc2-a4437c678515
09d5ff25-7a8a-4228-9093-bb437bb70f1a	resultats-des-elections-cantonales-de-mars-2011-1-tour	Résultats des élections cantonales de mars 2011 (1er tour)	\N	\N	Ministère de l'intérieur	\N	\N	\N	Résultat du premier tour des élections cantonales de mars 2011 au niveau canton.	cada	active	f39b8053-1f8c-44b5-9f81-07236807d0ea
430e39ad-4906-44ba-83bc-8f2bc6f2d039	elus-premier-tour-aux-cantonales-2011	Élus premier tour aux cantonales 2011	\N	\N	Ministère de l'intérieur	\N	\N	\N	Élus au 1er tour des élections cantonales de mars 2011	cada	active	b937f726-cd40-44b2-9cc5-47d2c3e7ebc3
48a03f6f-f8f4-4758-8672-f8ab8bd10acb	liste-des-candidats-aux-cantonales-2011-2d-tour	Liste des candidats aux cantonales 2011 (2d tour)	\N	\N	Ministère de l'intérieur	\N	\N	\N	Liste des candidats aux deuxième tour des cantonales de mars 2011	cada	active	333fdd79-d6b5-4196-8aca-c31496de0a7b
cd2385b8-fa33-4be9-82a8-9ceda07fdc75	resultats-des-elections-cantonales-de-mars-2011-2d-tour	Résultats des élections cantonales de mars 2011 (2d tour)	\N	\N	Ministère de l'intérieur	\N	\N	\N	Résultats du 2d tour des élections cantonales de mars 2011	cada	active	0afcdd05-5c6a-4d38-8ccc-62520a9ea0ed
6c0ea5a3-dd48-4015-8f65-77d56bf54bb3	elus-aux-elections-cantonales-2011	Élus aux élections cantonales 2011	\N	\N	Ministère de l'intérieur	\N	\N	\N	Les élus aux élections cantonales de mars 2011. 	cada	active	b8bede64-bf67-44d3-8697-8261f01f9d7b
78e9e396-2ab2-4d61-9eea-fe08b840dbf9	influence-auditions-deputes-lobbying	Influence - Listing des auditions réalisées par les députés pour leurs rapports	2011-03-16	http://www.regardscitoyens.org/transparence-france/etude-lobbying	Regards Citoyens	etudeetude.lobbying.tifrance.rc@regardscitoyens.org	\N	\N	Transparence International France et Regards Citoyens ont convenu en juillet 2010 d’un partenariat original, pour livrer ensemble au débat public et aux Français, des informations nouvelles sur les rencontres connues entre députés et acteurs publics et privés. Si ces informations sont toutes publiques, elles sont présentées ici de façon inédite afin d’être accessibles à tous. Elles ont vocation à être affinées, dans un processus collaboratif, avec le concours souhaité de toutes les personnes intéressées par le fonctionnement de la vie publique.\r\n\r\n1 174 rapports parlementaires ont été passés en revue grâce à l'aide de plus de 3 000 internautes. Entre juillet 2007 et juillet 2010, 9 300 auditions, de près de 5000 organismes, représentés par plus de 16 000 personnes, ont été recensées. D’emblée on le voit, les chiffres sont très éloignés des quelques 120 représentants d'intérêt inscrits en mars 2011 au registre officiel de l'Assemblée nationale !	odc-odbl	active	bdb5cf3d-56bf-428c-9151-2a3bb3c7669a
a8f061a9-6ba5-46df-89cd-6e65bfa28fe5	cboutet	Dotations aux collectivités locales 2011	\N	http://modules.dgcl.interieur.gouv.fr/dgcl_dotation/consultation/accueil.php	DGCL	\N	\N	\N	Site de publication de la DGCL de la dotation globale des collectivités pour l'année 2011	cada	active	172732b9-20c1-4478-8adb-045bc9d3092c
5c29c0cd-e773-4697-8172-ab1b075490c2	calcul-de-la-mare	Calcul de la marée	\N	http://www.shom.fr/ann_marees/cgi-bin/predit_ext/choixp?zone=0&opt=10&port=0&portsel=map	SHOM	\N	\N	\N	Site du SHOM fournissant les prévisions de marée pour les principaux ports mondiaux	cada	active	28169ed8-3c47-4522-a8d5-4474173aca5c
3c175c09-a896-4a88-9603-2b5ea27ef1a1	qualit-de-lair	Qualité de l'air	\N	http://www.prevair.org/fr/index.php	Prevair	\N	\N	\N	Page d'accueil du site prevair édité par le Ministère de l'écologique, aggrégeant les mesures de qualité de l'air réalisées par les différents acteurs sur le territoire français.	notspecified	active	99223c1a-1e29-42d1-8256-85f44520866f
2364edf3-baf9-4a60-a75e-46387f235726	indices-annuels-de-qualit-de-lair	Indices Annuels de qualité de l'air	\N	http://www.buldair.org/Statistiques/indice-annuel.php	Buld'air	\N	\N	\N	Publication des indices annuels de qualité de l'air pour les grandes villes.\r\nLa visualisation se fait en flash	notspecified	active	2f410629-bce8-453d-bac0-fc0b1e286dce
624552ff-a7cd-427d-88e3-f31ec6dba89b	nomenclature-des-sites-sportifs	Nomenclature des sites sportifs	\N	http://www.res.sports.gouv.fr/Page_Telechargements.aspx	Ministère des sports	\N	\N	\N	Nomenclature des sites sportifs français servant au recensement des sites dans http://www.res.sports.gouv.fr/Rech_Equipement.aspx	\N	active	440a2815-bfe0-486e-8a47-7e3a125f8c91
8d447067-389f-4c39-ba51-63430a736df4	les-communes-face-aux-risques-majeurs	Les communes face aux risques majeurs	\N	http://macommune.prim.net/	Ministère du Développement Durable	\N	\N	\N	Site de visualisation des risques majeurs accessible par code insee ou nom  de la commune	\N	active	9704b3e5-ce20-4be1-8a7d-d9cb211f0cf6
0a048cd8-5468-4fcd-bd67-50675c83002d	carte-de-la-sismicit-en-france	Carte de la sismicité en france	\N	http://www.sisfrance.net/	BRGM	\N	\N	\N	Carte de la sismicité et des tsunamis en france et dans les dom-tom par départements et communes	\N	active	add4fc8c-cacc-4c21-a011-10586b13504c
584d3863-eecc-4595-8a18-145ba2b213f7	qualit-des-eaux-de-baignade	Qualité des eaux de baignade	\N	http://baignades.sante.gouv.fr/navigMap.do?idCarte=baignades_metropole&listeActive=dpt#a	Ministère de la Santé	\N	\N	\N	Site de la qualité des eaux de baignade, avec visualisation sur carte par communes et possibilité de génération de rapports en .pdf	notspecified	active	bc33ab95-a7ce-4722-8c71-55da9972020d
529d4aba-d25d-44d6-ba1b-d6ad314d6158	carte-des-mouvements-de-terrain-en-france	Carte des mouvements de terrain en france	\N	http://www.bdmvt.net/donnees_liste.asp	BRGM	\N	\N	\N	Carte des mouvements de terrains, éboulements, coulées de boues. les données concernant un événement sont exportables en .cvs.	notspecified	active	95696de0-b33b-4771-b20d-9b71dff9c316
8d7560cf-6d61-45dd-bf05-44ae257e97a4	carte-des-radars-fixes	Carte des radars fixes	\N	http://radars.securite-routiere.gouv.fr	Ministère de l'Écologie, du Développement durable, des Transports et du Logement	\N	\N	\N	Carte des radars fixes en france par communes, précédement la liste des radars était téléchargeable.	notspecified	active	fbd13c36-5e50-49d2-abd4-049e7e027453
4acf41b9-9c8b-4a1e-a32e-a754abdce116	base-de-donnes-basol-sur-les-sites-et-sols-pollus	Base de données BASOL sur les sites et sols pollués	\N	http://basol.ecologie.gouv.fr/recherche.php	Ministère de l'Écologie, du Développement durable, des Transports et du Logement	\N	\N	\N	Base de données de sols pollués, recherche par commune	notspecified	active	12d7a85a-8498-40e0-ae5a-24239d9c82f7
c67a2104-aa5f-4e9f-830f-662ce97995d6	annuaire-de-ladministration	Annuaire de l'administration	\N	http://lannuaire.service-public.fr/	Dila	\N	\N	\N	Annuaire de l'administration édité par la Dila	notspecified	active	36a22994-298b-4c91-aad0-bfe101e12bbe
5a3d4806-974f-4754-b6cb-65a7dfa27548	bibliothques-publiques-du-dpartement-des-vosges	Bibliothèques publiques du département des Vosges	\N	http://www.vosges-bdp.com/CartesBibliotheque88/bibliorecherche.asp	CG88	\N	\N	\N	Carte des bibliothèques publiques du département des Vosges.	notspecified	active	75cb2baa-b33b-4762-b981-b4f97364ed22
4dbf7c31-5115-4700-963d-91f23f76aaa4	recensement-des-quipements-sportifs	Recensement des équipements sportifs	\N	http://www.res.sports.gouv.fr/Rech_Equipement.aspx	Ministère des sports	\N	\N	\N	Page de recherche des équipements sportifs en france.\r\nEn fonction de la typologie de recherche les résultats sont téléchargeables en .cvs ou xml.	lo	active	da5cfa24-ee10-4a43-b6a6-1780c5c56c14
9db98dbb-0a64-4588-8e57-533f05a6e050	tablissement-labelliss-qualit-tourisme	Établissement labellisés qualité tourisme	\N	http://www.qualite-tourisme.gouv.fr/index.php?reference=304	DGCIS Sous-direction du tourisme	\N	\N	\N	Établissement labellisés qualité tourisme en mars 2011, un .pdf téléchargeable par région.	notspecified	active	33125ba6-51d0-49db-88f0-d15ab1cfbb0e
205c33b6-106f-40c3-804c-a2835f6104a9	basias-inventaire-historique-de-sites-indutriels	Basias inventaire historique de sites industriels	\N	http://basias.brgm.fr/donnees_liste.asp?	BRGM	\N	\N	\N	Basias, inventaire historique de sites industriels, édité par le BRGM. Localisation par commune.\r\n	notspecified	active	1d906f97-b22c-408a-b23a-823cf809d1c0
f7a32926-f029-47f4-8649-e3b2997f69d3	innondations-carte-des-remontes-de-nappes	Inondations carte des remontées de nappes	\N	http://www.inondationsnappes.fr/donnees.asp?	BRGM	\N	\N	\N	Inondations, carte des remontées de nappes, localisation par communes.\r\nTéléchargement possible par département depuis http://www.inondationsnappes.fr/donneesDownload.asp?DPT=aucun en remplaçant aucun par le numéro du département.	notspecified	active	ddf7860e-3a1d-4321-ac1c-65e9157d813a
ced8947c-7c6b-4874-ad5e-c28ba91f8073	ala-de-retrait-de-gonflement-des-argiles	Aléa de retrait de gonflement des argiles	\N	http://www.argiles.fr/donneesDownLoad.asp?DPT=aucun	BRGM	\N	\N	\N	Carte des aléas de retrait de gonflement des argiles éditée par le BRGM. Téléchargement possible au format MIF−MID.	notspecified	active	2eb6042c-7740-4c4f-b636-76ce8ce6a357
b9582bd1-bfff-41e1-990f-962c18084f4d	villes-et-pays-dart-et-dhistoire	Villes et Pays d'art et d'histoire	\N	http://www.vpah.culture.fr/vpah/france/france.htm	Ministère de la Culture	\N	\N	\N	Carte des villes et Pays d'art et d'histoire, éditée par le Ministère de la Culture.	notspecified	active	9bdd4aa6-2e18-4e58-8914-1c4adf1b8916
1c17435c-508d-4194-9d06-f923d31c60cf	registre-des-cultures-ogm	Registre des cultures OGM	\N	http://www.ogm.gouv.fr/article.php3?id_article=110	OGM.fr	\N	\N	\N	Registre des cultures OGM, site interministériel. Les données sont celles de 2007. 	notspecified	active	1504af47-63ff-4fbf-b415-13f245e3530f
e3623259-d93b-4596-930a-0282a07b5666	carte-des-monuments-nationaux	Carte des monuments nationaux	\N	http://www.monuments-nationaux.fr/fr/monuments/carte-des-monuments/	Centre des monuments nationaux	\N	\N	\N	Carte des monuments nationaux sur fond google maps.	notspecified	active	f29df221-7759-4fe2-bf70-c1c0f0f4d049
b57f2ed1-ee10-469b-afcc-a4d7636d39c7	banatic-base-nationale-sur-lintercommunalit	Banatic base nationale sur l'intercommunalité	\N	http://www.banatic.interieur.gouv.fr/Banatic2/	DGCL Ministère de l'intérieur	\N	\N	\N	Base de la DGCL du ministère de l'intérieur sur l'intercommunalité	cada	active	b349135d-a405-4e84-a347-9acbd6b9c0a5
f22a7938-303f-4ac6-92da-526a4ad2a207	situation-mensuelle-du-budget-de-ltat	Situation mensuelle du budget de l'état	\N	http://www.budget.gouv.fr/themes/finances_etat/budget/directions_services-budget-situation_mensuelle-sommaire.php	Ministère du Budget	\N	\N	\N	Situation mensuelle du budget de l'état, 4 mois sur l'année 2010	notspecified	active	5f4eb519-36a4-444a-bed2-c545d3f4d20b
3d4e64cc-54c0-4b3e-b865-2fff3d9845e7	comptes-collectifs-des-communes	Comptes collectifs des communes	\N	http://www.colloc.bercy.gouv.fr/colo_struct_fina_loca/comp_coll/comm.html	Ministère du Budget	\N	\N	\N	Comptes collectifs des communes quelques jeux de données disponible au format .pdf.	notspecified	active	117f797d-1662-4d4f-8779-08a5af2ca1aa
83e56067-9ee5-48b2-83d0-91e723eb8b3d	donnes-hydromtriques-temps-rel-du-bassin-rhne-mditerrane	Données hydrométriques temps réel du bassin Rhône Méditerranée	\N	http://www.rdbrmc.com/hydroreel2/	Ministère de l'Écologie, du Développement durable, des Transports et du Logement	\N	\N	\N	Données hydrométriques temps réel du bassin Rhône Méditerranée. possibilité de voir en temps réel le débit des cours d'eau et de disposer de différents niveaux de statistique	notspecified	active	b5c703cf-ee4d-4b5d-b9fe-e5385976b7d9
e1b56ce2-aea6-4d44-b877-86a13f92697c	vigicrues---information-sur-la-vigilance-crues	Vigicrues : Information sur la vigilance "crues"	\N	http://www.vigicrues.gouv.fr/	Ministère de l'Écologie, du Développement durable, des Transports et du Logement	\N	\N	\N	Carte d'information sur la vigilance crues	notspecified	active	b4a1d15b-e861-453a-a288-467e743dd51b
60e23204-8e78-487c-92bd-5de0c6102067	zonage-sismique-de-la-france	Zonage sismique de la France	\N	http://www.planseisme.fr/Zonage-sismique-de-la-France.html	BRGM	\N	\N	\N	Nouveau zonage sismique divisant le territoire national en cinq zones de sismicité croissante en fonction de la probabilité d’occurrence des séismes.	\N	active	9072590d-3b6f-4ac1-89d3-0751de5632a7
4654898f-58f4-482f-a91f-23aa5e192fd8	finances-des-communes-de-moins-de-10-000-habitants-en-2009	Finances des communes de moins de 10 000 habitants en 2009	\N	http://www.dgcl.interieur.gouv.fr/sections/a_votre_service/statistiques/budgets_locaux/finances_des_commune/les_finances_des_com5179/view	DGCL Ministère de l'intérieur	\N	\N	\N	\N	\N	active	2d7fa951-5b6e-494f-ad7e-a7afcea2cd4f
20100c39-31ae-4fd4-ad35-bfeabe396b5f	les-collectivites-locales-en-chiffres-2011	Les collectivités locales en chiffres 2011	\N	http://www.dgcl.interieur.gouv.fr/sections/a_votre_service/statistiques/collectivites_locale/les_ciollectivites_l/view	DGCL Ministère de l'intérieur	\N	\N	\N	Vingt-et-unième édition des Collectivités locales en chiffres. Son objectif est de fournir annuellement les informations statistiques essentielles sur les collectivités locales.	\N	active	12caea82-db74-4ffa-b7ed-c149e2352e9a
497e8d74-14c2-401e-bc0d-a4b473f77eb1	mises-en-service-dans-le-parc-social-de-1999-2009	Mises en service dans le parc social, de 1999 à 2009	\N	\N	Ministère de l'environnement	\N	\N	\N	\N	cada	active	fc63ab3d-50cd-4753-9ff3-12aa14ce6692
b99894af-7866-4a81-beee-30e0e384b708	comptes-individuels-des-communes	Comptes individuels des communes	\N	http://www.colloc.bercy.gouv.fr/colo_otherfiles/divers/communes.html	Ministère du Budget	\N	\N	\N	Comptes individuels des communes entre 2000 et 2010.	notspecified	active	f579ee41-b9dd-4c74-a8e7-e8260d76ce8b
fe7cd753-376f-4f22-a721-caa482aa1116	cartographie-de-lobservatoire-du-val-de-saone	Cartographie de l'observatoire du val de Saône	\N	http://www.observatoire-saone.fr/index.php?id=96	EPTB Saône et Doubs	\N	\N	\N	Carte interactive avec téléchargements possibles en .pdf sur la qualité des eaux, protection et mise en valeur des milieux naturels, gestion de l'inondabilité, mise en valeur	other-closed	active	22c78088-f8e8-4d24-b35a-fc6c6c65ea47
1cf46091-d128-4e38-a7b7-97901d423aaf	dcisions-du-conseil-constitutionnel	Décisions du Conseil Constitutionnel	10-06-2011	http://datablog.owni.fr/2011/06/10/scraper-un-site-en-ruby-pour-les-nuls-ou-presque/	OWNI	\N	Julien Kirch	archiloque@archiloque.net	Toutes les décisions du Conseil Constitutionnel entre le 22 novembre 1958 et le 6 mai 2011 (Année, Numéro, Date, N°, Type, Intitulé, Décision, URL) parsées à partir du site du CC à l'aide d'un script ruby en vue d'une enquête datajournalisme d'OWNI.\r\n	odc-odbl	active	15736681-e084-4bb1-bd3b-c6a7af777d00
ece794a5-613f-4607-9046-fb37906f87ce	marchs-publics-du-ministre-de-la-culture-2009	Marchés publics du Ministère de la Culture 2009	2009	http://www.culture.gouv.fr/mcc/Media/Fichiers/marches-2009	Ministère de la Culture et de la Communication	\N	\N	\N	Liste des marchés publics notifiés par le Ministère de la Culture et de la Communication en 2009	cada	active	1cc6d560-7a4a-4505-81e8-290e440c9c0b
d794f07a-06d3-4b59-a969-c00af70ff8db	marchs-publics-du-ministre-de-la-culture-2010	Marchés publics du Ministère de la Culture 2010	2010	http://www.culture.gouv.fr/mcc/Appels-d-offres/Liste-des-marches-2010	\tMinistère de la Culture et de la Communication	\N	Regards Citoyens	contact@regardscitoyens.org	Liste des marchés publics notifiés par le Ministère de la Culture et de la Communication en 2010	cada	active	5ec1bdc2-fcbf-4932-b6a6-247c87ed9377
5efedd90-782d-4129-8e71-fdd3b6e1c7df	marchs-publics-du-ministre-de-la-culture-2007	Marchés publics du Ministère de la Culture 2007	2007	http://www.culture.gouv.fr/mcc/Media/Fichiers/marches-2007	Ministère de la Culture et de la Communication	\N	\N	\N	Liste des marchés publics notifiés par le Ministère de la Culture et de la Communication en 2007	cada	active	195959a3-77de-4e3d-95e4-8c5989ddd65d
f1261a91-9d52-4520-837e-e9c793f28dcc	marchs-publics-du-ministre-de-la-culture-2008	Marchés publics du Ministère de la Culture 2008	2008	http://www.culture.gouv.fr/mcc/Media/Fichiers/marches-2008	Ministère de la Culture et de la Communication	\N	\N	\N	Liste des marchés publics notifiés par le Ministère de la Culture et de la Communication en 2008	cada	active	df459aea-8e94-463f-835f-cdcd6ec1327c
df63f81c-7a27-49d1-86c8-8d5e49883d40	rseaux-sociaux-et-presse-en-li	Réseaux sociaux et presse en ligne	2011-08-17	http://www.rue89.com/presse-sans-presses/2011/08/17/reseaux-sociaux-le-monde-est-champion-france-24-cartonne-218204	Yann Guégan	\N	\N	\N	Présence de 45 sites de presse français sur les réseaux sociaux Facebook et Twitter entre décembre 2010 et août 2011.	notspecified	active	b1f45939-ae99-4295-88a4-a4ad552f048f
d6c6d3f9-5d8d-46c8-bc92-d8507d1e6f04	prix-des-terres-agricoles	Prix des terres agricoles	\N	http://agreste.agriculture.gouv.fr/enquetes/territoire-prix-des-terres/valeur-venale-des-terres-agricoles/	Ministère de l'Agriculture	\N	\N	\N	Valeur vénales des terres agricoles différents pdf et XLS à télécharger.\r\nSource: http://agreste.agriculture.gouv.fr/enquetes/territoire-prix-des-terres/valeur-venale-des-terres-agricoles/ où on trouve les définitions et méthodologies.	notspecified	active	2f7105eb-514c-4a4b-9271-b33aef907680
196340e0-5246-4bc2-8b69-54c66a48b399	projet-de-loi-de-finances-2012-rpartition-des-recettes-et-dpenses	Projet de loi de finances 2012 Répartition des recettes et dépenses	2012-09-29	http://www.lemonde.fr/politique/visuel/2011/09/28/visualisez-le-projet-de-loi-de-finances-2012_1578820_823448.html	Ministère des finances	\N	\N	\N	Il s'agit des données fournies par le [Ministère duBudget](http://www.budget.gouv.fr/budget/presentation-projet-loi-finances-pour-2012-plf) à [Alexandre Lechenet](http://twitter.com/#!/Alphoenix), journaliste de [LeMonde.fr](http://www.lemonde.fr) pour la réalisation d'une [visualisation en treemap du projet de loi de finances du gouvernement pour 2012](http://www.lemonde.fr/politique/visuel/2011/09/28/visualisez-le-projet-de-loi-de-finances-2012_1578820_823448.html).	cada	active	91626032-ae06-4cc2-8b0c-19befe231a93
cdc13d67-6360-43a6-bb99-cd68b64ee3f3	occupation-physique-du-territoire-insee	Occupation physique du territoire INSEE	\N	http://www.insee.fr/fr/themes/tableau.asp?reg_id=0&ref_id=NATTEF01337	\N	\N	\N	\N	Occupation physique du territoire.	notspecified	active	081aa116-4b83-4ecc-b179-41fc2f9c398b
ac051eb3-275f-40a5-b160-e224d13902e7	les-dputs-franais	Les députés français	1.0	http://www.assemblee-nationale.fr/	Assemblée Nationale	\N	Alexandre Léchenet	lechenet@lemonde.fr	Données provenant d'un scrap du fiches députés de l'Assemblée, en se focalisant notamment sur les anciens mandats de députés et leur âge. Récupéré le 11 novembre 2011. Il y a à ce moment 562 députés en fonction.\r\nLa date de naissance, la date du début du premier mandat en timestamp. L'id correspond à la fiche sur le site de l'Assemblée. \r\nUne deuxième table contient tous les anciens mandats tels que décrits par le site. Date de début et de fin en timestamp.	notspecified	active	a778d7d3-e61b-408b-99c7-1f89c7798181
67906f75-4298-4b6a-aa62-d8314be33f15	prsence-des-dputs-au-cours-de-la-session-2010-2011	Présence des députés au cours de la session 2010-2011	2011-08	http://www.nosdeputes.fr/confiseurs/2011/	Regards CitoyensCitoyens	contact@regardscitoyens.org	\N	\N	Données relatives aux sanctions encourues par les députés insuffisamment présents à l'Assemblée au cours de la session 2010-2011.\r\nLe collectif Regards Citoyens a mené une étude à partir des données de http://NosDeputes.fr visant à évaluer l'incidence des modifications du règlement sur la participation des députés aux travaux de l'Assemblée, notamment aux réunions des commissions. Le règlement impose en effet avec ses articles 42 et 159 des sanctions financières sur l'indemnité de fonction des députés manifestant des absences répétées aux réunions de leur commission permanente le mercredi matin ou aux scrutins solennels en hémicycle.	odc-odbl	active	6e196cec-2bdc-4b09-b540-8d55debe949b
7f6c30c6-d6a5-4d39-ae5d-e1ae4cc2d3ef	saone-et-loire	Saône-et-Loire	2011-10-22	http://www.opendata71.fr/	Direction des Systèmes d’Information et de l’Information Géographique du Département de Saône-et-Loire	\N	Pierre Martinerie	contact@cg71.fr	Le Département de Saône-et-Loire (71) libère ses données via le site Opendata71.\r\nhttp://www.opendata71.fr	apie-v2	active	aca77db3-5f9c-43a0-a515-cd093e4e1428
84b91384-8ec9-4b55-8dc9-28ff8c6db62f	horaires-des-quipements-culturels-nantes	Horaires des équipements culturels Nantes	1	http://data.nantes.fr/donnees/detail/?tx_icsoddatastore_pi1[keywords]=horaires&tx_icsoddatastore_pi1[date]=&tx_icsoddatastore_pi1[dateValid]=&tx_icsoddatastore_pi1[uid]=27	Nantes Métropole	contact@mairie-nantes.fr	Nantes Métropole	contact@mairie-nantes.fr	Horaires des équipements culturels de Nantes Métropole.\r\n\r\nIls sont classés en deux catégories :\r\n\r\n- les ouvertures dites normales qui sont schématisées en « semaine type d'ouverture » du lundi au dimanche\r\n\r\n- Les exceptions (ouverture ou fermeture) qui, à une date donnée, annulent et remplacent l'ouverture dite normale de l'équipement culturel\r\n\r\nDate de dernière mise à jour    : 15/11/2011	odc-odbl	active	c5249a7a-fe9d-4d85-ae81-2c8d1c65ebb2
32ccab1e-e85e-4f52-84f5-69bbcc5fa53d	taux-de-chmage-standardis-eurostat	Taux de chômage standardisé - Eurostat	1	http://webstat.banque-france.fr/fr/browse.do?node=5384229	webstat.banque-france.fr	webmestre@banque-france.fr	Banque de France, Armand PUJAL	webmestre@banque-france.fr	Données disponibles sur l'outil Webstat de la Banque de France.\r\nNom du dataset: Taux de chômage ;\r\nPériodicité: Mensuel ;\r\nCorrection statistique: CVS ;\r\nConcept - contexte STS: Taux de chômage ;\r\nClassification - contexte STS: Taux, Total (Tous ages), Total (hommes et femmes) ;\r\nInstitution d`origine: Eurostat ;\r\nVariation - contexte STS: Non spécifié	\N	active	10ac057b-4a62-4be2-9333-99cbb69c179a
89a894cc-c5c8-44e2-9ca3-85ab9a0130f9	budget-de-ltat-2009---2012	Budget de l'État 2009 - 2012	2012-11-28	http://voila-le-travail.data-projet.com/budget2012/	Jean Abbiateci	\N	Regards Citoyens	contact@regardscitoyens.org	Données extraites du site Performance Publique http://www.performance-publique.budget.gouv.fr/ à partir des lois de finances de 2009 à 2012 par Jean Abbiateci pour réaliser la visualisation treemap accessible sur le blog "Et voilà le travail" : http://voila-le-travail.data-projet.com/budget2012/	cada	active	d7f22ef7-54bb-4348-b287-62fcb6da90f0
02970c3a-2240-4a74-8fd3-18af09a9cd61	bases-de-donnes-du-ministre-de-la-culture	Bases de données du ministère de la culture	\N	http://www.culturecommunication.gouv.fr/En-pratique/Bases-de-donnees	Ministère de la Culture	\N	\N	\N	Inventaire des bases de données du Ministère de la culture dont Mémoire et mérimée qui fournissent des données par communes.\r\n\r\nL'ancienne page http://www.culture.gouv.fr/mcc/Bases-de-donnees2 redirige vers http://www.culturecommunication.gouv.fr/En-pratique/Bases-de-donnees suite au changement de site (Culture.gouv.fr a changé fin novembre 2011 pour devenir culturecommunication.gouv.fr)\r\n\r\n* http://www.rhone-alpes.culture.gouv.fr/basepat/ pour la base de données des associations du patrimoine en Rhône-Alpes\r\n\r\nExtrait de la version au 30/11/2011 :\r\n\r\n* TCMH - Techniques contemporaines utilisées dans les monuments historiques\r\nTechniques contemporaines de restauration dans les monuments historiques\r\n* Thesaurus architecture (base Vocabulaires - Thésaurus) : 3.700 termes utiles à la dénomination des oeuvres architecturales et mobilières\r\n* Trouvtou : Liaison des bases de données sur le patrimoine "immeuble". 137.000 notices.\r\n* Ulysse : Images numérisées sur les empires coloniaux français. Photographies, affiches, cartes et plans conservés aux Archives nationales d'outre-mer. 5.000 images\r\n* Vingt années de construction de bibliothèques publiques en Rhône-Alpes 1986 - 2005	notspecified	active	9af8b293-f532-43bf-b8cb-06195f021079
8a7d516b-f3c2-4a5b-afde-d2bdff371937	donnees-cles-du-recensement-agricole-de-2000	Données clés du recensement agricole de 2000	\N	http://agreste.agriculture.gouv.fr/spip.php?page=dc_research&id_rubrique=464&	Ministère de l'Agriculture	\N	\N	\N	Données par communes.\r\n\r\nExemple avec dans le département de l'Eure-et-Loir, dans la commune de Bonneval :\r\n* Nombre d'exploitations \t 24 \r\n* dont nombre d'exploitations professionnelles \t 20 \r\n* Nombre de chefs d'exploitation et de coexploitants \t 30 \r\n* Nombre d'actifs familiaux sur les exploitations \t 43 \r\n* Nombre total d'actif sur les exploitations \r\n(en UTA,équivalent temps plein) \t 35 \r\n* Superficie agricole utilisée des exploitations (ha) \t 2129 \r\n* Terres labourables (ha) \t 2057 \r\n* Superficie toujours en herbe (ha) \t 70 \r\n* Nombre total de vaches \t c \r\n* Rappel : Nombre d'exploitations en 1988 \t 46\r\n\r\nRemarque : D'autres informations sont disponible sur http://agreste.agriculture.gouv.fr/enquetes/recensement-agricole/	\N	active	30c271f8-7b1c-4a14-855c-9dc9420f1ca9
1dacf074-ad54-432a-a04f-cecd3a068d0c	entreprises-controles-par-letat	Entreprises controlées par l'Etat	2010	http://www.insee.fr/fr/themes/detail.asp?ref_id=ir-recme2010&page=irweb/recme2010/dd/recme2010_repertoire.htm	Insee	\N	\N	\N	Voir aussi http://www.insee.fr/fr/themes/detail.asp?ref_id=ir-recme2010&page=irweb/recme2010/dd/recme2010_repertoire.htm (1994-2010)\r\net http://www.insee.fr/fr/themes/detail.asp?ref_id=ir-recme2010	other-closed	active	ee816bc2-0316-4adc-ac10-300df9306594
df6c89f3-4473-424b-a0b0-119977da62c5	liste-des-communes-cantons-arrondissements	Liste des communes, des cantons, des arrondissements	\N	http://www.insee.fr/fr/methodes/nomenclatures/cog/telechargement.asp	Insee	\N	\N	\N	\N	\N	active	177926cc-1263-4323-9dad-14032641b0a5
0460ea96-a830-40bd-adfb-140aad4c31ca	liste-prenoms-declares-etat-civil-paris	Liste des prénoms déclarés à l'état-civil à Paris	\N	http://opendata.paris.fr/opendata/jsp/site/Portal.jsp?document_id=60&portlet_id=106	Ville de Paris	\N	\N	\N	\N	odc-odbl	active	2b5ac88c-ed8c-4fee-b013-103238447a18
159b6644-94ed-406d-8e1e-1f002f265396	prenoms-des-enfants-a-nantes	Prénoms des enfants nés à Nantes	\N	http://data.nantes.fr/donnees/detail/?tx_icsoddatastore_pi1[uid]=59	Ville de Nantes	contact@mairie-nantes.fr	Ville de Nantes	contact@mairie-nantes.fr	Liste des prénoms des enfants nés à Nantes en 2010 avec le nombre d’occurrences de chaque prénom.\r\n\r\nLorsque le nombre d'occurrences est inférieur ou égal à 5, cette donnée n'est pas publiée, conformément aux préconisations de la CNIL.	odc-odbl	active	d8097172-e1a3-4d79-b40a-3c3ec12be908
641c249c-f473-4d8e-bd8e-f385157f2682	epicentres-des-sismes-en-france	Epicentres des séismes en france	\N	http://www.sisfrance.net/	BRGM	\N	\N	\N	Épicentre des séismes ayant eu une incidence en france de 858 à 2007\r\n\r\nFichier France :\r\nListe des épicentres de SisFrance/Métropole d'intensité égale ou supérieure à 5\r\n\r\nPour les Antilles :\r\nListe des épicentres de SisFrance/Métropole d'intensité égale ou supérieure à 5\r\n\r\nPour la Réunion :\r\nListe des épicentres de SisFrance/Réunion d'intensité égale ou supérieure à 4\r\n\r\nSource : BRGM, EDF, IRSN, Base de données nationale de la sismicité historique SisFrance\r\n\r\nPour la Nouvelle-Calédonie :\r\nListe des épicentres de SisFrance/Nouvelle-Calédonie d'intensité égale ou supérieure à 4\r\n\r\nSource : BRGM, Base de données nationale de la sismicité historique SisFrance-Calédonie	notspecified	active	903899a1-b57f-44c8-9818-15fc47ead4da
de5557e1-bf16-433b-87ff-401323a97df5	resultats-des-elections-legislatives-2002	Résultats des élections législatives 2002	\N	\N	Ministère de l'Intérieur	\N	Regards Citoyens	contact@regardscitoyens.org	Données obtenues auprès du ministère de l'intérieur. Elles correspondent aux résultats des deux tours de l'élection législatives de 2002, bureaux de vote par bureaux de vote. 	cada	active	9f2365d7-35db-4301-8a4c-351671cc2694
47034ede-0506-4650-9fb4-1948168440ca	resultats-des-elections-persidentielles-2002	Résultats des présidentielles 2002	\N	\N	Ministère de l'Intérieur	\N	Regards Citoyens	contact@regardscitoyens.org	Données obtenues auprès du ministère de l'intérieur. Elles correspondent aux résultats des deux tours de l'élection présidentielle de 2002, bureaux de vote par bureaux de vote. 	cada	active	db2345f0-bd43-4f1d-b50d-c263b791d1c2
27983c75-8b7c-47bd-ad03-10a9e1ca4d25	ecole	ecole	\N	\N	\N	\N	\N	\N	\N	\N	active	2107f175-c0c5-4f9b-8c79-63eaef240f56
bfd1388a-ec10-4a7b-9d94-916f56f52f98	liste-des-fichiers-de-datagouvfr	Liste des fichiers de data.gouv.fr	\N	\N	Regards Citoyens	\N	Regards Citoyens	\N	Ce fichier CSV mis à jour lorsque de nouvelles données sont détectées sur le site data.gouv.fr permet de connaitre les données mises à disposition sur le portail édité par Étalab.\r\n	odc-odbl	active	853347f0-4e13-4d06-a24d-c4a4c28d4762
8708a912-1b80-441d-9ba3-d607dd2f0c7c	liste-des-tuiles-des-orthophotographies-de-la-communaute-urbaine-de-nantes	Liste des tuiles des orthophotographies de la communauté urbaine de Nantes	\N	http://data.nantes.fr/donnees/orthophotographie-aerienne/	Nantes Métropole	\N	Teymour	\N	URL des zip contenant les tuiles des orthophotos des villes de la communauté urbaine de Nantes. La résolution des images est de 20 cm, la classe de précision est de 40 cm. Les prises de vues sont numériques et ont été réalisées en juin 2005.	odc-odbl	active	153a48b3-24af-44e4-ab07-9d5610e890da
25dd2269-e0f3-4653-98ac-33f64f09d4d3	liste-des-circonscriptions-lgislatives-franaises-suite-au-redcoupage-lectoral-de-2012	Liste des circonscriptions législatives françaises suite au redécoupage électoral de 2012	2012-02-14	http://www.nosdonnees.fr/wiki/index.php/Image:Circonscriptions.csv	Candidats.fr	contact@candidats.fr	Regards Citoyens	contact@regardscitoyens.org	Description de la composition (cantons/communes) des 577 circonscriptions législatives après le redécoupage de 2012.\r\nRéalisé à partir des données de NosDeputes.fr et du Journal officiel pour les besoins des Candidats.fr	odc-odbl	active	4bba233a-f5ab-48de-ab8d-8f9f386fbf77
b815db66-cadf-4c3c-ae0b-73ad5bf1a46e	statistiques-dmographiques-insee-sur-les-nouvelles-circonscriptions-lgislatives-de-2012	Statistiques démographiques INSEE sur les nouvelles circonscriptions législatives de 2012	2012-02-17	http://www.insee.fr/fr/themes/detail.asp?reg_id=0&ref_id=circo_leg-2012	INSEE	\N	Regards Citoyens	contact@regardscitoyens.org	Indicateurs statistiques sur les 556 circonscriptions des départements de métropole, de Guadeloupe, de Martinique, de Guyane et de La Réunion après le redécoupage de 2012.\r\n- population par tranche d'âge\r\n- population par sexe et âge\r\n- population de 15 ans ou plus par sexe et catégorie socioprofessionnelle\r\n- population selon la nationalité\r\n- logements par catégorie\r\n- population des ménages par type de ménage\r\n	odc-odbl	active	78218970-639e-4d24-93ed-244cd4decfcb
275e4c19-2885-4630-b049-e365374c27fb	500-signatures-des-candidats-aux-elections-presidentielles-de-1995-2002-et-20	500 signatures des candidats aux élections présidentielles de 1995, 2002 et 2007	\N	\N	Conseil Constitutionnel	\N	\N	\N	Issu de :\r\n - pour 2007 : \r\nhttp://www.legifrance.gouv.fr/jo_pdf.do?cidTexte=JPDF2403200700000001\r\n - pour 2002 : \r\nhttp://www.legifrance.gouv.fr/affichTexte.do?cidTexte=JORFTEXT000000407519\r\n - pour 1995 : http://www.legifrance.gouv.fr/affichTexte.do?cidTexte=JORFTEXT000000847420\r\n\r\nAttention l'usage statistique est complexe car les 500 signatures sont tirées au sort parmi les signatures présentées aux Conseil Constitutionnel lors du dépôt des candidatures. Ce tirage au sort prend en compte la répartition géographique et les impératif légaux en la matière :  http://www.legifrance.gouv.fr/affichTexte.do?cidTexte=LEGITEXT000006068219&dateTexte=vig	cada	active	cdf50818-ce06-46aa-878f-c837506e82c5
e3e52ca7-2e9e-4f87-a818-5a808823089b	guede97	OBSERVATION ET STATISTIQUES	\N	http://www.statistiques.developpement-durable.gouv.fr/	\N	\N	\N	\N	Base de donnée gigantesque des statistiques sur\r\n\r\nLogement – Construction, Transports, Énergies et climat, Environnement, Développement durable, Conjoncture, Territoires\r\n\r\nprincipalement sous forme de rapports pdf	cada	active	31206ec8-7ac4-40c3-b06d-5f0e5f4f4da0
fea6dcd6-00d6-4ad5-ab2f-eb40f533a5db	listes-des-communes-par-rgions-dpartements-circonscriptions	Listes des communes par régions, départements, circonscriptions	2011-12-31	http://www.nosdonnees.fr/wiki/index.php/Image:EUCircos_Regions_departements_circonscriptions_communes_gps.csv.gz	Regards Citoyens	contact@regardscitoyens.org	Regards Citoyens	contact@regardscitoyens.org	Il s'agit d'une compilation de différentes informations tirées de Wikipedia et du travail de http://www.galichon.com/codesgeo/ donnant pour chaque commune de France les informations précises sur leurs régions (et chefs-lieux), départements (et préfectures), circonscriptions législatives et européennes, codes INSEE, codes postaux et coordonnées GPS pour l'essentiel des communes de métropole.	odc-odbl	active	8412388c-5c82-452d-ad9e-3247056c0cd2
cea11492-fdec-4cfc-a179-a4bbc05cac0b	500-signatures-des-candidats-aux-lections-prsidentielles-de-2012	500 signatures des candidats aux élections présidentielles de 2012	beta	http://www.regardscitoyens.org/telechargement/presidentielles-2012/	Regards Citoyens	contact@regardscitoyens.org	Regards Citoyens	contact@regardscitoyens.org	Issu de : http://www.legifrance.gouv.fr/affichTexte.do?cidTexte=JORFTEXT000025595654\r\nRecoupé avec les affiliations politiques des élus (en cours)	odc-odbl	active	369831c1-22de-4dea-b0b7-b9a33cef2875
41b0a731-3378-42bd-9e08-8b69a1fee83a	resultats-et-participation-l-election-presidentielle-2012	Résultats et participation à l'élection présidentielle 2012	2012-05-12	http://www.regardscitoyens.org/election-presidentielle-2012-le-live-opendata/#data	Ministère de l'Intérieur	\N	Regards Citoyens	contact@regardscitoyens.org	\N	lo	active	c5caedf1-1874-4f69-b34a-af3ae71236d9
c4556598-bcc7-4c45-8ae8-bdafc367eaa2	presidentielle-2012-resultats-par-commes-et-par-circo-des-francais-de-l-etranger-pour-les-deux-t	Présidentielle 2012 : Résultats par commune et par circonscription des français de l'étranger pour les deux tours	\N	\N	Ministère de l'Intérieur	\N	Regards Citoyens	\N	Données fournies par le ministère de l'intérieur divisées en deux fichiers pour chacun des deux tours : un fichier communes françaises et un fichier circonscriptions des français de l'étranger.	lo	active	bc6d4de3-006e-4b29-8a65-5f884d994708
1399fe4b-2c07-4bda-a720-9df928d51816	dclarations-patrimoniales-presidents	Déclarations patrimoniales des derniers présidents de la République	2	http://www.nosdonnees.fr/wiki/index.php/Image:Declarations_Patrimoines_Presidents.csv	Caro_lm	carolinelemoign@gmail.com	Regards Citoyens	contact@regardscitoyens.org	Déclaration patrimoniale de Nicolas Sarkozy au 11 mai 2007 et au 24 mars 2012 et de François Hollande au 11 mai 2012, selon les déclaration JORF n°109 du 11 mai 2007 page 8458 \r\ntexte n° 2, et JORF n°0072 du 24 mars 2012 page 5363 \r\ntexte n° 1 et JORF n°0110 du 11 mai 2012 page 9000\r\ntexte n° 2  (legifrance)	odc-odbl	active	59317601-caee-4b10-bc04-8f4ce5006fcc
2a4bae91-082b-4ae5-9729-08c86e000ab5	comptes-de-lassociation-regards-citoyens	Comptes de l'association Regards Citoyens	quotidienne	http://www.regardscitoyens.org/qui-sommes-nous/	Regards Citoyens	contact@regardscitoyens.org	Regards Citoyens	contact@regardscitoyens.org	Par souci de transparence, Regards Citoyens publie le détail de ses comptes de fonctionnement mis-à-jour quotidiennement.	odc-odbl	active	133e9e8e-01da-481e-909d-367708fce0c2
cd42a806-cac1-452c-9b0d-116d8ead4d64	liste-des-candidats-aux-lections-lgislatives-2012-dans-chaque-circonscription	Liste des candidats aux élections législatives 2012 dans chaque circonscription	2012-05-31	http://komodo.regardscitoyens.org/public/legislatives2012/	Ministère de l'Intérieur	\N	Regards Citoyens	contact@regardscitoyens.org	Le premier tour dans un premier temps.\r\n\r\nLes données ont été progressivement corrigées grâce aux retours des utilisateurs puis à la seconde version fournie par le Ministère.\r\n\r\nLe second fichier enregistré identifie les corrections réalisées chez nous et non présentes dans les données du ministère republiées sur data.gouv.fr <http://www.data.gouv.fr/donnees/view/L%C3%A9gislatives-2012---Liste-des-candidats-du-1er-tour-551833>	lo	active	6976eef5-92e8-45c2-bc2b-9bfc60341674
e657011b-cf83-47ab-8bc8-62f6498046a6	comptes-agenda-et-bilans-de-lassociation-libertic	Comptes, agenda et bilans de l'association LiberTIC	2011	http://libertic.wordpress.com/libertic/	LiberTIC	\N	LiberTIC	\N	Par souci de transparence, LiberTIC publie le détail de son bilan et dossier comptable, ses comptes de fonctionnement et son agenda.\r\n	odc-odbl	active	5ff6213f-387b-4fa1-b818-fd7c5e9151bc
30bcda76-5a1a-4369-a6f3-ed2584ad4031	dclarations-dintrets-des-membres-du-gouvernement-francais	Déclarations d'intérêts des membres du gouvernement français	2012-06-13	http://www.nosdonnees.fr/wiki/index.php/D%C3%A9clarations_Int%C3%A9rets_des_Ministres	Gouvernement français	\N	Regards Citoyens	contact@regardscitoyens.org	Depuis avril 2011, les membres du gouvernement français doivent rendre publiques leurs déclarations d'intérêts sur le site gouvernement.fr\r\n\r\nUn rassemblement et une extration des documents pdf ont été réalisés afin de rendre cette information plus facilement interprétable.\r\n\r\nUn .csv données a été fait pour le gouvernement Fillon, un autre pour le gouvernement Ayrault	odc-odbl	active	6eccd4c9-6c1b-4e45-a065-05553ba71ff6
aac3a30b-36a9-4887-8aab-81c552bfc7d7	toxicode	Countours des circonscriptions des législatives	1.0.0	http://www.toxicode.fr/circonscriptions	Toxicode	\N	Pierre Lancien	\N	Pour construire ces données, nous avons utilisé ces deux sources :\r\n\r\n  - Les contours de communes fournis par l'IGN / GEOFLA\r\n  - Les correspondances entre circonscriptions et communes, fournies par le Ministère de l'intérieur\r\n\r\n### Format des données\r\n\r\n  - code_circonscription : le code du département + le numéro de la circoncription,  ex : 69002\r\n  - departement : la code du département, ex : 69\r\n  - numero : le numéro de circonscription, ex : 2,\r\n  - communes : codes INSEE des communes qui sont (entièrement ou partiellement) dans la circonscription, séparés par le caractère '-'. ex : 69382-69381-69384-69389\r\n  - kml_shape : polygone(s) de la circonscription, au format KML\r\n  - edited_shape : 'false' si le contour est simplement un regroupement des contours de communes. 'true' si nous l'avons édité.\r\n\r\nDavantage d'explications sur [le site de Toxicode](http://www.toxicode.fr/circonscriptions)	odc-odbl	active	ec886521-f454-451d-af59-53aadbcf4bbc
f1b3849e-9568-4cae-a3a0-3cca7f42c079	carte-des-circonscriptions-lgislatives-2012	Carte des circonscriptions législatives françaises (2012+)	1.0	http://www.regardscitoyens.org/telechargement/donnees/	Regards Citoyens	contact@regardscitoyens.org	Regards Citoyens	contact@regardscitoyens.org	Carte réalisée grace aux données suivantes : \r\nFrance métropolitaine et Outre-mer : http://www.nosdonnees.fr/package/toxicode ; Partie de l'Outre-mer manquante : \r\nhttp://www.nosdonnees.fr/package/carte-du-decoupage-des-circonscriptions-electorales-legislatives-2012-	odc-odbl	active	91785866-4772-4249-9659-5484c2c4a91d
27597355-d542-4574-adc8-6493883d1454	redevances-de-rutilisation-dinformations-publique	Redevances de réutilisation d'informations publiques	1.0	http://www.nosdonnees.fr/wiki/index.php/Redevances_de_r%C3%A9utilisation_d_informations_publiques_%C3%A9tablies_avant_le_1er_juillet_2011	Regards Citoyens	contact@regardscitoyens.org	\N	\N	Liste des données soumises à redevance, relevant de l'État et des EPA	odc-odbl	active	8cade445-98c7-4340-8aaa-34f0c304d0e9
382ceece-628f-43b1-8847-ea92ff04376f	comptes-de-campagne-des-candidats-a-l-election-presidentielle-2012	Comptes de campagne des candidats à l'élection présidentielle 2012	2012-08-08	http://www.nosdonnees.fr/wiki/index.php/Image:Comptes_campagne_pr%C3%A9sidentielle_2012.csv	Regards Citoyens	contact@regardscitoyens.org	Regards Citoyens	contact@regardscitoyens.org	Le Journal Officiel propose en PDF toutes ces informations : [http://www.regardscitoyens.org/temp/120731-JORF-Presidentielle-ComptesCampagne.pdf](http://www.regardscitoyens.org/temp/120731-JORF-Presidentielle-ComptesCampagne.pdf)\r\n\r\nDataPublica les a numérises dans un tableur multi-feuillets :\r\n[http://www.data-publica.com/data/14417--comptes-de-campagne-declares-des-candidats-a-l-election-presidentielle-2012](http://www.data-publica.com/data/14417--comptes-de-campagne-declares-des-candidats-a-l-election-presidentielle-2012)\r\n\r\nLes voici désormais en données exploitables.	odc-odbl	active	b38759cd-8953-4448-8c61-ba3b596923ed
8d9cf757-de83-4774-919b-00c45c43efd4	fichier-prnoms	Fichier prénoms	1.0	http://insee.fr/fr/	INSEE	\N	\N	\N	Le fichier des prénoms est établi à partir des seuls bulletins de naissance des personnes nées en France y compris les départements d’Outre-mer (DOM). En conséquence, l’exhaustivité n’est pas garantie sur toute la période, notamment pour les années antérieures à 1946. Les utilisateurs pourront donc constater des écarts avec le nombre annuel des naissances évalué par l'Insee. Ces écarts, importants en début de période, vont en s’amenuisant. Après 1946, ils sont peu significatifs.\r\n\r\nLes accents sont absents de ce fichier - "Céline" y est noté "Celine"... Une version accentuée serait beaucoup plus utile.	cada	active	d6fe63e4-8d4f-49c6-8658-6d711c69b848
61d87eb7-e3d3-4f90-a3a8-b43b5362db1a	carte-du-decoupage-des-circonscriptions-electorales-legislatives-2012-	Carte du découpage des circonscriptions électorales législatives 2012+	2012-06	http://www.jeromecukier.net/projects/elections/projections950.html	Jérôme Cukier	@JCukier	Regards Citoyens	contact@regardscitoyens.org	Carte réalisée par Jérôme Cukier pour ses projets de visualisation des données électorales 2012 : http://www.jeromecukier.net/projects/elections/projections950.html\r\n\r\nIdentifiants des zones :\r\nDD = code département (01 à 95 971 à 977 987 988 999)\r\nCC = numéro circonscription (01 à 21)\r\nDépartements : id="gDD" \r\nCirconscriptions : id = "cDDCC"	odc-odbl	active	d283c9b6-1bf8-4e4c-9893-be095c2af78a
4f8c2ed1-52a1-4c94-854e-631daeb1a154	statistiques-des-tribunaux-francais	Statistiques des tribunaux français sur 12 mois	\N	\N	Ministère de la justice	\N	\N	\N	Délais de traitement sur 12 mois (juillet 2011 et juin 2012) et stock des dossiers (30 juin 2012) des différentes cours d'appel, TGI, tribunaux d'instance et conseils des prudhommes français.\r\n\r\nD'après <http://www.nosdeputes.fr/14/question/QE/4092>	cada	active	fdb4b6ae-6ce5-4741-aac1-877119b6d04b
e6833b4c-3f1e-4394-a547-790258b451e5	rattachement-financier-aux-partis-politiques-des-dputs-de-la-14me-lgislature	Rattachement financier aux partis politiques des députés de la 14ème législature	121205	http://www.assemblee-nationale.fr/qui/	Assemblee nationale	\N	Regards Citoyens	contact@regardscitoyens.org	En vue d'attribuer la seconde part du financement public des partis politiques, les parlementaires doivent chaque année déclarer leurs rattachement à un parti politique. Pour la première fois en 2012, l'Assemblée nationale publie un document précisant ces informations :[http://www.assemblee-nationale.fr/qui/Rattachement_partis.pdf](http://www.assemblee-nationale.fr/qui/Rattachement_partis.pdf)	odc-odbl	active	3fb0c1db-fff3-4704-8bea-a69cff4f441e
\.


--
-- Data for Name: package_extra; Type: TABLE DATA; Schema: public; Owner: ckantest
--

COPY package_extra (id, package_id, key, value, state, revision_id) FROM stdin;
421e47f8-6551-46fb-bec4-ecb2ba73ac64	a1019da5-cdac-4e09-8b60-831994b5f275	bibliothèques	"bibliothèques"	active	e771822d-8bb6-409d-bcf8-663b887d0a4c
a8a9ff3e-59fc-49e2-aeab-cedf9602998a	a1019da5-cdac-4e09-8b60-831994b5f275	nantes	"nantes"	deleted	58ff28dc-f3eb-40a2-bcf8-3912f26472e7
d17000d3-0ade-4870-96d6-015ac6c8e2e6	a1019da5-cdac-4e09-8b60-831994b5f275	horaires	"horaires"	deleted	58ff28dc-f3eb-40a2-bcf8-3912f26472e7
2390bdfc-33bd-439a-880e-2f87717f3d40	4dbf7c31-5115-4700-963d-91f23f76aaa4	rthzrthy	"ztrzy"	active	da5cfa24-ee10-4a43-b6a6-1780c5c56c14
95e1cf56-ee01-4a1c-a0d8-0ca3bb667935	4dbf7c31-5115-4700-963d-91f23f76aaa4	sllmkijmlh	"zrhh"	active	da5cfa24-ee10-4a43-b6a6-1780c5c56c14
7a5fe895-a21a-442f-8c11-4da7332b3377	4dbf7c31-5115-4700-963d-91f23f76aaa4	zshzsrh	"ayy"	active	da5cfa24-ee10-4a43-b6a6-1780c5c56c14
\.


--
-- Data for Name: package_extra_revision; Type: TABLE DATA; Schema: public; Owner: ckantest
--

COPY package_extra_revision (id, package_id, key, value, state, revision_id, continuity_id) FROM stdin;
a8a9ff3e-59fc-49e2-aeab-cedf9602998a	a1019da5-cdac-4e09-8b60-831994b5f275	nantes	"nantes"	active	e771822d-8bb6-409d-bcf8-663b887d0a4c	a8a9ff3e-59fc-49e2-aeab-cedf9602998a
421e47f8-6551-46fb-bec4-ecb2ba73ac64	a1019da5-cdac-4e09-8b60-831994b5f275	bibliothèques	"bibliothèques"	active	e771822d-8bb6-409d-bcf8-663b887d0a4c	421e47f8-6551-46fb-bec4-ecb2ba73ac64
d17000d3-0ade-4870-96d6-015ac6c8e2e6	a1019da5-cdac-4e09-8b60-831994b5f275	horaires	"horaires"	active	e771822d-8bb6-409d-bcf8-663b887d0a4c	d17000d3-0ade-4870-96d6-015ac6c8e2e6
a8a9ff3e-59fc-49e2-aeab-cedf9602998a	a1019da5-cdac-4e09-8b60-831994b5f275	nantes	"nantes"	deleted	58ff28dc-f3eb-40a2-bcf8-3912f26472e7	a8a9ff3e-59fc-49e2-aeab-cedf9602998a
d17000d3-0ade-4870-96d6-015ac6c8e2e6	a1019da5-cdac-4e09-8b60-831994b5f275	horaires	"horaires"	deleted	58ff28dc-f3eb-40a2-bcf8-3912f26472e7	d17000d3-0ade-4870-96d6-015ac6c8e2e6
2390bdfc-33bd-439a-880e-2f87717f3d40	4dbf7c31-5115-4700-963d-91f23f76aaa4	rthzrthy	"ztrzy"	active	da5cfa24-ee10-4a43-b6a6-1780c5c56c14	2390bdfc-33bd-439a-880e-2f87717f3d40
95e1cf56-ee01-4a1c-a0d8-0ca3bb667935	4dbf7c31-5115-4700-963d-91f23f76aaa4	sllmkijmlh	"zrhh"	active	da5cfa24-ee10-4a43-b6a6-1780c5c56c14	95e1cf56-ee01-4a1c-a0d8-0ca3bb667935
7a5fe895-a21a-442f-8c11-4da7332b3377	4dbf7c31-5115-4700-963d-91f23f76aaa4	zshzsrh	"ayy"	active	da5cfa24-ee10-4a43-b6a6-1780c5c56c14	7a5fe895-a21a-442f-8c11-4da7332b3377
\.


--
-- Data for Name: package_group; Type: TABLE DATA; Schema: public; Owner: ckantest
--

COPY package_group (id, package_id, group_id, state, revision_id) FROM stdin;
\.


--
-- Data for Name: package_group_revision; Type: TABLE DATA; Schema: public; Owner: ckantest
--

COPY package_group_revision (id, package_id, group_id, state, revision_id, continuity_id) FROM stdin;
\.


--
-- Data for Name: package_relationship; Type: TABLE DATA; Schema: public; Owner: ckantest
--

COPY package_relationship (id, subject_package_id, object_package_id, type, comment, state, revision_id) FROM stdin;
\.


--
-- Data for Name: package_relationship_revision; Type: TABLE DATA; Schema: public; Owner: ckantest
--

COPY package_relationship_revision (id, subject_package_id, object_package_id, type, comment, state, revision_id, continuity_id) FROM stdin;
\.


--
-- Data for Name: package_resource; Type: TABLE DATA; Schema: public; Owner: ckantest
--

COPY package_resource (id, package_id, url, format, description, hash, "position", state, revision_id) FROM stdin;
5c5da933-fc46-48b9-ba85-2986bd048c7a	587ed76e-1c2f-4cc7-a23a-f9beb2415c77	http://www.impots.gouv.fr/portal/deploiement/p1/fichedescriptive_5458/fichedescriptive_5458.xls	XLS			0	active	f74141f1-d57b-4f3f-9ee2-d1469d1a00a9
b7af4934-b700-4c1f-8e91-a49228269b51	e3424ea9-f7c0-4d80-832b-890c3de0f744	http://www.tarn.pref.gouv.fr/elections/CM2008/	XML	un fichier par commune dont le nom est : 0<Département><Code INSEE commune>.xml		0	active	a6a5efac-b108-40c8-847c-e06530596dae
0c371831-0896-49c0-a7c7-46fa6be4ff71	97b2cf1e-91f4-4b08-a7d8-2e6bd1dca37e	http://www.dgcl.interieur.gouv.fr/sections/a_votre_service/statistiques/fiscalite_locale/communes/copy4_of_taux_de_fiscalite_di/downloadFile/attachedFile/p10000_07.csv	CSV	En 2007		3	active	a5bfd523-f3c2-41e2-9e1a-1624d786767c
829a2cbf-f1fa-4639-a62c-1ac797a2a6fa	97b2cf1e-91f4-4b08-a7d8-2e6bd1dca37e	http://www.dgcl.interieur.gouv.fr/sections/a_votre_service/statistiques/fiscalite_locale/communes/copy4_of_taux_de_fiscalite_di/downloadFile/attachedFile/p10000_06.csv	CSV	En 2006		4	active	a5bfd523-f3c2-41e2-9e1a-1624d786767c
7b898350-44e8-4904-ab07-204e0f41a7c3	97b2cf1e-91f4-4b08-a7d8-2e6bd1dca37e	http://www.dgcl.interieur.gouv.fr/sections/a_votre_service/statistiques/fiscalite_locale/communes/copy4_of_taux_de_fiscalite_di/downloadFile/attachedFile/p10000_05.csv	CSV	En 2005		5	active	a5bfd523-f3c2-41e2-9e1a-1624d786767c
6a1d3267-e479-44c2-93d8-38f323de8d24	97b2cf1e-91f4-4b08-a7d8-2e6bd1dca37e	http://www.dgcl.interieur.gouv.fr/sections/a_votre_service/statistiques/fiscalite_locale/communes/copy4_of_taux_de_fiscalite_di/downloadFile/attachedFile/p10000_04.csv	CSV	En 2004		6	active	a5bfd523-f3c2-41e2-9e1a-1624d786767c
55955265-69ff-426d-b64d-a285b4ec2ed0	97b2cf1e-91f4-4b08-a7d8-2e6bd1dca37e	http://www.dgcl.interieur.gouv.fr/sections/a_votre_service/statistiques/fiscalite_locale/communes/copy4_of_taux_de_fiscalite_di/downloadFile/attachedFile/p10000_03.csv	CSV	En 2003		7	active	a5bfd523-f3c2-41e2-9e1a-1624d786767c
5ad00446-67da-4c64-afc0-53428f7b3e16	97b2cf1e-91f4-4b08-a7d8-2e6bd1dca37e	http://www.dgcl.interieur.gouv.fr/sections/a_votre_service/statistiques/fiscalite_locale/communes/copy4_of_taux_de_fiscalite_di/downloadFile/attachedFile/p10000_02.csv	CSV	En 2002		8	active	a5bfd523-f3c2-41e2-9e1a-1624d786767c
97bca925-30f3-4354-971c-68e5e51af939	e4c69e90-1056-4f46-9619-57d0a18d1737	http://www.dgcl.interieur.gouv.fr/sections/a_votre_service/statistiques/fiscalite_locale/groupements_de_commu/taux_de_fiscalite_di/downloadFile/attachedFile/ca_07.csv	CSV	Communautés d'agglo en 2007		0	active	19979634-e047-4bef-b09b-396ebbbf7fd0
15dd30b4-d455-4466-9cac-ba81facb975b	e4c69e90-1056-4f46-9619-57d0a18d1737	http://www.dgcl.interieur.gouv.fr/sections/a_votre_service/statistiques/fiscalite_locale/groupements_de_commu/copy_of_taux_de_fiscalite_di/downloadFile/attachedFile/ca_06.csv	CSV	Communautés d'agglo en 2006		1	active	19979634-e047-4bef-b09b-396ebbbf7fd0
5feb4d89-65a7-4e5b-843f-2fdd4426d860	e4c69e90-1056-4f46-9619-57d0a18d1737	http://www.dgcl.interieur.gouv.fr/sections/a_votre_service/statistiques/fiscalite_locale/groupements_de_commu/taux_de_fiscalite_di1463/downloadFile/attachedFile/cu_07.csv	CSV	Communautés urbaines en 2007		2	active	19979634-e047-4bef-b09b-396ebbbf7fd0
2cc9f307-96c4-4178-a618-b976aac1b77a	e4c69e90-1056-4f46-9619-57d0a18d1737	http://www.dgcl.interieur.gouv.fr/sections/a_votre_service/statistiques/fiscalite_locale/groupements_de_commu/taux_de_fiscalite_di1463/downloadFile/attachedFile/cu_06.csv	CSV	Communautés urbaines en 2006		3	active	19979634-e047-4bef-b09b-396ebbbf7fd0
6915276b-2bdd-405b-86e2-e8c5ac81335d	e4c69e90-1056-4f46-9619-57d0a18d1737	http://www.dgcl.interieur.gouv.fr/sections/a_votre_service/statistiques/fiscalite_locale/groupements_de_commu/copy2_of_taux_de_fiscalite_di/downloadFile/attachedFile/CA_2008.xls	XLS	Communautés d'agglo en 2008		4	active	19979634-e047-4bef-b09b-396ebbbf7fd0
a97d8472-7bfd-4d9b-a2a9-789e095b7057	e4c69e90-1056-4f46-9619-57d0a18d1737	http://www.dgcl.interieur.gouv.fr/sections/a_votre_service/statistiques/fiscalite_locale/groupements_de_commu/copy2_of_taux_de_fiscalite_di1463/downloadFile/attachedFile/CU_2008.xls	XLS	Communautés urbaines en 2008		5	active	19979634-e047-4bef-b09b-396ebbbf7fd0
7a0d3a01-386f-454f-a5d9-1c22a391e531	e4c69e90-1056-4f46-9619-57d0a18d1737	http://www.dgcl.interieur.gouv.fr/sections/a_votre_service/statistiques/fiscalite_locale/groupements_de_commu/taux_de_fiscalite_di9800/downloadFile/attachedFile/tx_CA_2009.xls	XLS	Communautés d'agglo en 2009		6	active	19979634-e047-4bef-b09b-396ebbbf7fd0
91aa5080-4087-4330-ba3f-4547637790b6	e4c69e90-1056-4f46-9619-57d0a18d1737	http://www.dgcl.interieur.gouv.fr/sections/a_votre_service/statistiques/fiscalite_locale/groupements_de_commu/taux_de_fiscalite_di7268/downloadFile/attachedFile/tx_CU_2009_corr.xls	XLS	Communauté urbaines en 2009		7	active	19979634-e047-4bef-b09b-396ebbbf7fd0
a407e03d-5ac0-42d8-a0e9-7cce00f4f6d2	e4c69e90-1056-4f46-9619-57d0a18d1737	http://www.dgcl.interieur.gouv.fr/sections/a_votre_service/statistiques/fiscalite_locale/groupements_de_commu/taux_de_fiscalite_di9162/downloadFile/file/txCA2010.xls	XLS	Communauté d'agglo en 2010		8	active	19979634-e047-4bef-b09b-396ebbbf7fd0
3c816815-2978-4d25-9fa4-176dd356e1c0	4235252c-aa21-46b5-8c52-110f95bdc583	http://www.regardscitoyens.org/telechargement/donnees_publiques/Donnees_Presidentielles_2007_Officielles_cvs.zip	CSV	csv zippé		0	active	0376e537-073c-47ff-8397-bad8797ea48a
0aae0494-8eaf-4172-b33b-43c0833b1ad9	97b2cf1e-91f4-4b08-a7d8-2e6bd1dca37e	http://www.nosdonnees.fr/wiki/images/e/e7/Com_sup_10_000_hab_2008_DEF.csv	CSV	En 2008		2	active	945fbb14-dfc2-4bda-9259-43f438951fa7
1e217aae-f364-4513-8c24-fe361751274e	97b2cf1e-91f4-4b08-a7d8-2e6bd1dca37e	http://www.nosdonnees.fr/wiki/images/f/fd/Txcommunessup10000_en_2010.csv	CSV	En 2010		0	active	945fbb14-dfc2-4bda-9259-43f438951fa7
5ed3b40f-d43a-4470-bf5b-413c5ccc5a29	97b2cf1e-91f4-4b08-a7d8-2e6bd1dca37e	http://www.nosdonnees.fr/wiki/images/5/5e/Tx_com_sup_10000_hab_en_2009.csv	CSV	En 2009		1	active	945fbb14-dfc2-4bda-9259-43f438951fa7
c207867d-b17e-434c-a57d-c180ba9fb5c4	4402487d-3e8d-4618-8444-b400c6337834	http://www.impots.gouv.fr/portal/deploiement/p1/fichedescriptive_5582/fichedescriptive_5582.xls	XLS	Annee 2009		0	active	0906792a-0391-484a-a503-86206888bdc5
a4b0a0c6-d585-46f6-bced-ad2f0270e508	e4c69e90-1056-4f46-9619-57d0a18d1737	http://www.dgcl.interieur.gouv.fr/sections/a_votre_service/statistiques/fiscalite_locale/groupements_de_commu/taux_de_fiscalite_di8290/downloadFile/file/txCU2010.xls	XLS	Communauté urbaines en 2010		9	active	19979634-e047-4bef-b09b-396ebbbf7fd0
146f7a49-cca4-4edb-adc2-c650c14e4ba7	43c3cc44-3a6c-469b-80fe-913927d2c283	http://data.keolis-rennes.com/fileadmin/OpenDataFiles/GTFS/GTFS-20101013.zip	GTFS			0	active	5b3fb26f-b388-4423-88e3-076c7476b2cc
5ab0ed94-acd0-4840-b79f-47380b40e059	3aa0d5ce-cef6-4158-b51e-ddee8ece7b5e	http://www.pollutionsindustrielles.ecologie.gouv.fr/IREP/downloads/etablissements.csv	CSV	liste des établissements poluants		1	active	1e4eae84-e18c-4226-a08b-ddb330973624
6cbd57b5-ee74-418c-b2c1-5ffbfa0b12fc	3aa0d5ce-cef6-4158-b51e-ddee8ece7b5e	http://www.pollutionsindustrielles.ecologie.gouv.fr/IREP/XML/dump.php	CSV	Toute la base contenue dans zip contenant plusieurs CVS		0	active	1e4eae84-e18c-4226-a08b-ddb330973624
d23e4296-9459-4f13-a71f-d07590fa30a0	1901d722-a38d-4e79-a13c-ca51d61bae30	http://rdf.insee.fr/geo/regions-2010.rdf	RDF	Régions 2010		0	active	b2b4b103-d694-4105-86d7-fa937445826f
25d8f445-bb31-4bfa-9270-50af1818f3aa	1901d722-a38d-4e79-a13c-ca51d61bae30	http://rdf.insee.fr/geo/departements-2010.rdf	RDF	Départements 2010		1	active	b2b4b103-d694-4105-86d7-fa937445826f
0bb5958b-cf27-4715-a3f0-e8f54eab1be6	5b23d4f4-058e-44e0-945d-ae9035fb1e15	http://seine-maritime.gouv.fr/IMG/ods/Liste_des_maires.ods	ODS			0	active	f9d8651f-75dd-4a22-8190-ea0df1fb83d1
614e9656-5db9-442d-bef3-102ee3393a5e	f6c6aac7-3c9b-4a3c-80bc-d6709bc95d4b	http://www.regardscitoyens.org/telechargement/redecoupage/2009121601_synthese.csv.gz	CSV	Une ligne par circonscription avec les résultats en 2007 et la projection des résultats avec le nouveau découpage (couleur politique, parti gagnant et score en en %) (599 enregistrements)		0	active	a78d4faa-842b-4cec-8ba4-2e9993ff99ca
61f30314-333f-41ca-8c2a-082a631aa6d2	f6c6aac7-3c9b-4a3c-80bc-d6709bc95d4b	http://www.regardscitoyens.org/telechargement/redecoupage/2009121601_resultats.csv.gz	CSV	        une ligne par candidat, par bureau de vote et par tour en 2007 avec les informations nécessaires pour affecter le bureau de vote à la nouvelle circonscription ainsi que cette affectation (965286 enregistrements)		1	active	a78d4faa-842b-4cec-8ba4-2e9993ff99ca
e4d15c16-7a1c-44f1-a074-543287adf763	f3d8ca3c-32b9-4485-95d9-0b1fd4a5dd4e	http://www.regardscitoyens.org/telechargement/confiseurs/sanctions-commissions.csv	CSV	Nous avons établi la liste des députés qui correspond aux critères définis par le règlement. Les absences justifiées et valables au regard du règlement ont été prises en compte au regard des informations disponibles publiquement, et chacun des députés a été contacté individuellement en vue de vérifier l'oubli éventuel d'excuses. Le CSV contient une ligne par mois et par député concerné.		0	active	d78247f0-fc65-4fb3-bc7e-81f3ad80e69b
14c0083c-5d9f-4da4-94d1-c022e8dcba46	f3d8ca3c-32b9-4485-95d9-0b1fd4a5dd4e	http://www.regardscitoyens.org/telechargement/confiseurs/scrutins-solennels.csv	CSV	Le fichier CSV proposé chiffre le nombre de scrutins auxquels chaque député a participé ou s'est fait représenter au cours de la session écoulée, en plus d'informations complémentaires relatives au mandat de chacun.		1	active	d78247f0-fc65-4fb3-bc7e-81f3ad80e69b
bc26bfac-6b07-4608-a835-d7c0e53ffa4c	69361720-3428-417e-beb4-d21df542992c	http://www.insee.fr/fr/ppp/bases-de-donnees/donnees-detaillees/apul-regions/apul_region-07.xls	XLS	Comptes régionalisés des administrations publiques locales en 2007		0	active	8b208a3e-558c-4884-9cc1-297a0dc0e174
1d3fe6f0-9c5a-45a9-9418-89ad4a672bea	34269022-c891-4a8e-a814-3af2b0fea526	http://www.nosdonnees.fr/wiki/images/5/52/INSEE-localisation-communes-010109.tar.gz	CSV	    * Pour chaque commune, le code des niveaux géographiques supérieurs :        - région, département, arrondissement, canton ville, zone d'emploi, unité urbaine 1999, espace urbain 1999, aire urbaine 1999, tranche d'aire urbaine, tranche de commune, tranche d'unité urbaine, tranche détaillée d'unité urbaine, bassin de vie, code d'EPCI, type d'EPCI, code de la catégorie de la commune dans les aires et espaces urbains 1999 (ZAUER) ;        - la population sans double compte 1999 ;        - la population municipale 2007.      * Le nombre de communes qui composent tous les niveaux géographiques supra-communaux et complétées par la PSDC 99 et la population municipale 2007 (ces deux dernières variables figurent également pour les arrondissements municipaux de Lyon, Marseille et Paris).        En complément des données, la table comprend :        - une documentation sur les variables présentes dans la table,        - le libellé de tous les niveaux géographiques,        - les modifications territoriales intervenues depuis le 1er janvier 2000.		0	active	a23213e4-603f-42b1-88e7-f9f17b4bdb6d
336e232b-8d8f-4cfd-bf5c-875de9d9cfb3	6d999f74-d520-4a8c-8188-5a5c13c6bbec	http://www.ecosante.fr/index2.php?base=FRAN&langh=FRA&langs=FRA&sessionid=	csv	données santé france régions département		0	deleted	0f921f9a-fa99-4cb7-90ef-aab5c836c057
6d5eafca-2d23-4068-a133-7d4452c692d7	0e14dccb-9c28-4f89-b3b2-cb1011be06d1	http://perso.ens-lyon.fr/benoit.boissinot/upload/jaune-asso-2010.csv	CSV	2007 et 2008		0	active	f059768e-f5ee-4b64-94cb-cdecbde8e898
8a3df4b0-12b5-478d-9a9b-bc2223c06a56	0e14dccb-9c28-4f89-b3b2-cb1011be06d1	http://perso.ens-lyon.fr/benoit.boissinot/upload/jaune-asso-2010.ods	ODS	2007 et 2008		1	active	f059768e-f5ee-4b64-94cb-cdecbde8e898
d351f497-c9bd-423e-a246-f866e5596a95	65d7e18e-c5ab-4736-bb9e-c47de2dc41e1	http://www.nosdonnees.fr/wiki/images/0/05/Import_export_france_pays.csv.gz	CSV	gzipé au 4 décembre (contient les données 2008, 2009 et 9 derniers mois 2010)		0	active	f7eebe7b-6c57-41bb-9ecf-0eefbffd501e
ca2b3710-17e5-4c8b-b1ab-7095b7784911	a1019da5-cdac-4e09-8b60-831994b5f275	http://www.nosdonnees.fr/wiki/images/4/4e/Horaires_bibliotheques.csv	csv	horaires bibliothèques Nantes		0	active	37fbb496-6950-4dfe-96b7-1b2dc46a8c68
e1855a6d-bdc0-49b1-bff5-8e8969b05ccb	a1019da5-cdac-4e09-8b60-831994b5f275	http://www.nosdonnees.fr/wiki/images/1/1f/HorairesBibliothequesNantes.txt	json	horaires bibliothèques Nantes		1	active	37fbb496-6950-4dfe-96b7-1b2dc46a8c68
2c6b0d8c-aa8b-440c-8dd2-398a3d082a23	2502f9a7-15fa-439d-8a48-f61f38cb6f55	http://rdf.insee.fr/geo/regions-2010.rdf	RDF	Régions		0	active	39219937-0939-40ca-86a8-f8493a35a337
3b63add7-268c-4210-ac5c-6284740dcf58	2502f9a7-15fa-439d-8a48-f61f38cb6f55	http://rdf.insee.fr/geo/departements-2010.rdf	RDF	Départements		1	active	39219937-0939-40ca-86a8-f8493a35a337
3139b4c5-d669-4191-bb65-adc11b3c2786	2502f9a7-15fa-439d-8a48-f61f38cb6f55	http://rdf.insee.fr/geo/archive-2010.zip	RDF	Régions, départements, arrondissements, cantons		2	active	39219937-0939-40ca-86a8-f8493a35a337
953f6a15-b311-4961-87e2-dc1dd15245a6	4276f7df-c7e9-44e1-8886-20ad41ebda0a	http://media.education.gouv.fr/file/2010/04/8/NI-10-16_158048.xls	XLS	Diplôme national du brevet, Session 2009		0	active	8b876446-18be-45e9-98d2-2ad4a1b1e7fa
609e530e-ebfb-4e9d-95da-0f89651812e1	f4517261-c1ee-4380-b3ad-0de5a0edc09a	http://media.education.gouv.fr/file/2010/82/4/NI-10-06_142824.xls	XLS	Résultats définitifs de la session 2009 du baccalauréat		0	active	ab96c2af-06af-4bad-8c4f-00ec10f98776
93e6f9c6-015a-415b-9588-f7b05e4fafac	9382520e-adb5-4403-848d-5bd5ea476202	http://www.nosdonnees.fr/wiki/images/9/98/Cantonales_2011_Candidats_T1_FE.ods	ods			0	active	df6d8a52-2f22-493d-8be5-645488c266ea
bb0f18ca-59b7-4d98-9ef5-10ef62280f72	09d5ff25-7a8a-4228-9093-bb437bb70f1a	http://www.nosdonnees.fr/wiki/images/3/33/Cantonales_2011_R%C3%A9sultats_Can_FE_T1.ods	ods			0	active	c0b8f3fb-e0c0-4ec9-8d66-a6604dcf12bd
89c9e8f8-b19d-4c31-b09d-697dbc4104d7	430e39ad-4906-44ba-83bc-8f2bc6f2d039	http://www.nosdonnees.fr/wiki/images/2/2e/Cantonales_2011_Elus_T1.ods	ods			0	active	65cf3b14-0851-41dd-8891-c545d5d33b8f
a08ce488-02ea-4bd0-b11f-0b5ba4f9c218	48a03f6f-f8f4-4758-8672-f8ab8bd10acb	http://www.nosdonnees.fr/wiki/images/8/8a/Cantonales_2011_Candidats_T2_FE.ods	ods			0	active	cbb8cf9d-1615-4a30-9c69-bcc03cae3034
be27fe54-d78e-4f41-b70a-60ad3832b063	09d5ff25-7a8a-4228-9093-bb437bb70f1a	http://www.nosdonnees.fr/wiki/images/6/63/Cantonales_2011_R%C3%A9sultats_Can_FE_T1.csv.gz	csv			1	active	0513d47f-23df-4180-80e9-dc62a6eb95b7
33b883e4-f164-47d3-8c62-bea5425e8b2d	cd2385b8-fa33-4be9-82a8-9ceda07fdc75	http://www.nosdonnees.fr/wiki/images/9/95/Cantonales_2011_R%C3%A9sultats_Can_FE_T2.ods	ods			0	active	0afcdd05-5c6a-4d38-8ccc-62520a9ea0ed
8c323d13-4138-42a8-a586-1fd973c5cb2c	cd2385b8-fa33-4be9-82a8-9ceda07fdc75	http://www.nosdonnees.fr/wiki/images/a/a0/Cantonales_2011_R%C3%A9sultats_Can_FE_T2.csv.gz	csv			1	active	0afcdd05-5c6a-4d38-8ccc-62520a9ea0ed
14969953-267a-4298-b52d-8fcd7b510e4e	6c0ea5a3-dd48-4015-8f65-77d56bf54bb3	http://www.nosdonnees.fr/wiki/images/c/c8/Cantonales_2011_elus_T1T2.ods	ods			0	active	b8bede64-bf67-44d3-8697-8261f01f9d7b
54c0a2ed-4e09-4494-9d74-ca591b4a642c	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	http://www.regardscitoyens.org/telechargement/donnees/20110301_nosdeputes.fr_donnees.tgz	SQL	Dump SQL de la base de données de NosDéputés.fr contenant toutes les tables sur l'activité des députés. Description des tables dans l'archive		0	active	5fd549d6-e139-4705-94a1-805d6ce85222
9e806b44-ad72-4f2d-a233-512977054fbb	78e9e396-2ab2-4d61-9eea-fe08b840dbf9	http://www.regardscitoyens.org/transparence-france/etude-lobbying/t%C3%A9l%C3%A9chargement/auditionsDonnées individuelles relatives des auditions.csv.gz	CSV	Données relatives aux auditions individuelles		0	active	bdb5cf3d-56bf-428c-9151-2a3bb3c7669a
682f5dd6-8a50-4b30-96f2-779857553d5d	78e9e396-2ab2-4d61-9eea-fe08b840dbf9	http://www.regardscitoyens.org/transparence-france/etude-lobbying/t%C3%A9l%C3%A9chargement/auditions.sql.gz	SQL	Données relatives aux auditions individuelles		1	active	bdb5cf3d-56bf-428c-9151-2a3bb3c7669a
1579f014-b247-47d9-9b50-1365568892bd	78e9e396-2ab2-4d61-9eea-fe08b840dbf9	http://www.regardscitoyens.org/transparence-france/etude-lobbying/t%C3%A9l%C3%A9chargement/influence.csv.gz	CSV	Données utilisées par l'application de visualisation présentant les auditions groupées par organisation et rapport		2	active	bdb5cf3d-56bf-428c-9151-2a3bb3c7669a
048e467b-4d58-4cf1-871f-bd96cdd03553	78e9e396-2ab2-4d61-9eea-fe08b840dbf9	http://www.regardscitoyens.org/transparence-france/etude-lobbying/t%C3%A9l%C3%A9chargement/influence.sql.gz	SQL	Données utilisées par l'application de visualisation présentant les auditions groupées par organisation et rapport		3	active	bdb5cf3d-56bf-428c-9151-2a3bb3c7669a
fab8ff40-8646-45ae-84f1-8860f4aa3ef4	78e9e396-2ab2-4d61-9eea-fe08b840dbf9	http://www.regardscitoyens.org/transparence-france/etude-lobbying/t%C3%A9l%C3%A9chargement/registre_an.csv.gz	CSV	Données issues du registre officiel des représentants d'intérêt de l'Assemblée		4	active	bdb5cf3d-56bf-428c-9151-2a3bb3c7669a
ca7f2945-53a5-4581-9794-3c08c7c64eb4	78e9e396-2ab2-4d61-9eea-fe08b840dbf9	http://www.regardscitoyens.org/transparence-france/etude-lobbying/t%C3%A9l%C3%A9chargement/registre_an.csv.gz	SQL	Données issues du registre officiel des représentants d'intérêt de l'Assemblée		5	active	bdb5cf3d-56bf-428c-9151-2a3bb3c7669a
8bd077be-768d-4230-8598-14b8c41a1844	2364edf3-baf9-4a60-a75e-46387f235726	http://www.buldair.org/Statistiques/indice-annuel.php		indices de qualité de l'air		0	active	2f410629-bce8-453d-bac0-fc0b1e286dce
68f69e43-ed53-40e9-90ed-875556a449ce	624552ff-a7cd-427d-88e3-f31ec6dba89b	http://www.res.sports.gouv.fr/documents/Annexe1_RES_2010_V1.pdf	pdf	nomenclature des sites sportifs		0	active	440a2815-bfe0-486e-8a47-7e3a125f8c91
ffb62e73-46ab-42ed-83c8-a0f8a56446b0	641c249c-f473-4d8e-bd8e-f385157f2682	http://www.sisfrance.net/export_liste_epicentres.asp	txt	épicentres des séismes en france		0	active	8b78ef6a-380d-4f62-a3aa-84f6256a8d15
34b6e740-4d3e-4194-b4ab-7e632bf7889f	584d3863-eecc-4595-8a18-145ba2b213f7	http://baignades.sante.gouv.fr/genererPDF.do?gen=no	pdf	génération de rapports		0	active	bc33ab95-a7ce-4722-8c71-55da9972020d
eca7aba4-77b0-489a-aee5-fb0a0650cb7f	9db98dbb-0a64-4588-8e57-533f05a6e050	http://www.qualite-tourisme.gouv.fr/index.php?reference=304	pdf	téléchargement par région		0	active	33125ba6-51d0-49db-88f0-d15ab1cfbb0e
7a8d43c5-1334-4959-a074-7e3d84ab5837	f7a32926-f029-47f4-8649-e3b2997f69d3	http://www.inondationsnappes.fr/donneesDownload.asp?DPT=aucun	SHP	remplacer aucun par le numéro du dpt		0	active	ddf7860e-3a1d-4321-ac1c-65e9157d813a
20867081-b65a-47ae-b075-d0af80fa761a	ced8947c-7c6b-4874-ad5e-c28ba91f8073	http://www.argiles.fr/donneesDownload.asp	MIF−MID	données de gonflemnt des argiles		0	active	2eb6042c-7740-4c4f-b636-76ce8ce6a357
64ade8ad-f353-4216-bcaf-127c1c9656ba	1c17435c-508d-4194-9d06-f923d31c60cf	http://www.ogm.gouv.fr/IMG/xls/04092007_REGISTRE_PUBLIC_cle85e138.xls	xls	registre au format xls		0	active	1504af47-63ff-4fbf-b415-13f245e3530f
7877da79-163c-47f0-a4e0-ac4d91868b01	1c17435c-508d-4194-9d06-f923d31c60cf	http://www.ogm.gouv.fr/IMG/html/Carte_des_parcelles_OGM_cle8eb1f6.html	HTML	registre au format html		1	active	1504af47-63ff-4fbf-b415-13f245e3530f
6142f945-4f66-4b53-a36c-dc9e39efe788	b57f2ed1-ee10-469b-afcc-a4d7636d39c7	http://www.banatic.interieur.gouv.fr/Banatic2/php/ba-France.php	xls	développement de l'intercommunalité		0	active	b349135d-a405-4e84-a347-9acbd6b9c0a5
5c7a2a17-e793-453f-af64-d79faa11ba92	b57f2ed1-ee10-469b-afcc-a4d7636d39c7	http://www.banatic.interieur.gouv.fr/Banatic2/php/ba-Region.php	xls	données par régions et départements		1	active	b349135d-a405-4e84-a347-9acbd6b9c0a5
54dbbd2e-1d03-43ad-912f-71d360fe12bf	f22a7938-303f-4ac6-92da-526a4ad2a207	http://www.budget.gouv.fr/directions_services/budget/situation_mensuelle/2010/100131.pdf	pdf	janvier		0	active	5f4eb519-36a4-444a-bed2-c545d3f4d20b
f8556c82-78b2-46c7-a396-381fe26bb3a4	f22a7938-303f-4ac6-92da-526a4ad2a207	http://www.budget.gouv.fr/directions_services/budget/situation_mensuelle/2010/100228.pdf	pdf	février		1	active	5f4eb519-36a4-444a-bed2-c545d3f4d20b
b04b0ca9-a110-4521-bde7-48e3f12c9b4a	f22a7938-303f-4ac6-92da-526a4ad2a207	http://www.budget.gouv.fr/directions_services/budget/situation_mensuelle/2010/100331.pdf	pdf	mars		2	active	5f4eb519-36a4-444a-bed2-c545d3f4d20b
9dd7a66c-c224-412c-83ef-44107cbeab34	f22a7938-303f-4ac6-92da-526a4ad2a207	http://www.budget.gouv.fr/directions_services/budget/situation_mensuelle/2010/100430.pdf	pdf	avril		3	active	5f4eb519-36a4-444a-bed2-c545d3f4d20b
d963439a-4e69-4321-ba17-3f848a393564	3d4e64cc-54c0-4b3e-b865-2fff3d9845e7	http://www.colloc.bercy.gouv.fr/colo_otherfiles_fina_loca/telecharger/brochurecom_2008.pdf	pdf	analyse 2008		0	active	117f797d-1662-4d4f-8779-08a5af2ca1aa
42e7672b-6634-468e-9bdb-7da8b373a6a8	3d4e64cc-54c0-4b3e-b865-2fff3d9845e7	http://www.colloc.bercy.gouv.fr/colo_otherfiles_fina_loca/telecharger/brochure_2007_commune3.pdf	pdf	analyse 2007		1	active	117f797d-1662-4d4f-8779-08a5af2ca1aa
4a7ebbe3-f943-4f6f-8a62-e1900278d556	3d4e64cc-54c0-4b3e-b865-2fff3d9845e7	http://www.colloc.bercy.gouv.fr/colo_struct_fina_loca/comp_coll/comm/lana_comp_6.html	html	analyse 2006		2	active	117f797d-1662-4d4f-8779-08a5af2ca1aa
abdc6294-d827-4c94-86da-f64df399c46e	3d4e64cc-54c0-4b3e-b865-2fff3d9845e7	http://www.colloc.bercy.gouv.fr/colo_otherfiles_fina_loca/telecharger/brochure_communes_2005_2.pdf	pdf	analyse 2005		3	active	117f797d-1662-4d4f-8779-08a5af2ca1aa
63b4ac19-27a9-4912-9981-c0843e8a24b4	3d4e64cc-54c0-4b3e-b865-2fff3d9845e7	http://www.colloc.bercy.gouv.fr/colo_otherfiles_fina_loca/telecharger/communes_2004_brochure_v2.pdf	pdf	analyse 2004		4	active	117f797d-1662-4d4f-8779-08a5af2ca1aa
ee05827c-7c5f-47d1-8364-efc1e6426c84	3d4e64cc-54c0-4b3e-b865-2fff3d9845e7	http://www.colloc.bercy.gouv.fr/colo_otherfiles_fina_loca/telecharger/brochcom03.pdf	pdf	analyse 2003		5	active	117f797d-1662-4d4f-8779-08a5af2ca1aa
2a9fd922-9db6-46ed-8f3d-ee444ed4751d	3d4e64cc-54c0-4b3e-b865-2fff3d9845e7	http://www.colloc.bercy.gouv.fr/colo_otherfiles_fina_loca/telecharger/com02.pdf	pdf	analyse 2002		6	active	117f797d-1662-4d4f-8779-08a5af2ca1aa
e10758bd-41b6-4e36-bad4-18d393eedd08	3d4e64cc-54c0-4b3e-b865-2fff3d9845e7	http://www.colloc.bercy.gouv.fr/colo_otherfiles_fina_loca/telecharger/com01.pdf	pdf	analyse 2001		7	active	117f797d-1662-4d4f-8779-08a5af2ca1aa
9d31dd68-7a12-4393-b5d3-e8d757c5d9d3	3d4e64cc-54c0-4b3e-b865-2fff3d9845e7	http://www.colloc.bercy.gouv.fr/colo_otherfiles_fina_loca/telecharger/compcom.pdf	pdf	analyse 2000		8	active	117f797d-1662-4d4f-8779-08a5af2ca1aa
d9927b6e-01e3-4e92-ba5a-b0f59afadf4d	60e23204-8e78-487c-92bd-5de0c6102067	http://www.planseisme.fr/IMG/xls/zonage_sismique_par_communes.xls	xls	zonage sismique par commune		0	active	9072590d-3b6f-4ac1-89d3-0751de5632a7
b9592d7d-24f8-47f6-bdfb-ce31e545ef2c	4654898f-58f4-482f-a91f-23aa5e192fd8	http://manage.dgcl.interieur.gouv.fr/workspaces/members/desl/documents/finances/commune/capc2009/capc2009_00/downloadFile/file/CAPC2009_00.pdf?nocache=1303806614.94	pdf	Comptes 2009 des communes de moins de 10 000 habitants		0	active	2d7fa951-5b6e-494f-ad7e-a7afcea2cd4f
ea103e7f-9d16-4a5b-a117-1dcd65c70ef2	20100c39-31ae-4fd4-ad35-bfeabe396b5f	http://manage.dgcl.interieur.gouv.fr/workspaces/members/desl/documents/clench/2011/publication_globale/downloadFile/file/publication-globale.pdf?nocache=1302527601.79	pdf	collectivités locales en chiffres 2011		0	active	12caea82-db74-4ffa-b7ed-c149e2352e9a
31c9cf7b-0726-4ef5-96c8-a93757aa21a0	497e8d74-14c2-401e-bc0d-a4b473f77eb1	http://dl.dropbox.com/u/28303770/donnees%20EPLS%20mise%20en%20service%20%281%29.zip	XML			0	active	fc63ab3d-50cd-4753-9ff3-12aa14ce6692
f379f840-f21c-47ee-8310-41daed42deb4	1cf46091-d128-4e38-a7b7-97901d423aaf	http://datablog.owni.fr/files/2011/06/conseil_constitutionel.csv	CSV	Toutes les décisions du Conseil Constitutionnel entre nov 1958 et mai 2011		0	active	66b128d0-c36c-48b8-a78a-92b6182586d1
97c1a7cf-f804-4b6c-9c4b-13554270e3ce	fe7cd753-376f-4f22-a721-caa482aa1116	http://www.observatoire-saone.fr/index.php?id=96	pdf	différents téléchargements possibles		0	active	22c78088-f8e8-4d24-b35a-fc6c6c65ea47
e3cde4c3-1e43-4c40-9aa1-a28c61c41334	ece794a5-613f-4607-9046-fb37906f87ce	http://www.culture.gouv.fr/mcc/content/download/6761/46206/file/March%C3%A9s%20%20MCC%20%20notifi%C3%A9s%20en%202009%20VERSION%20A%20PUBLIER.pdf	PDF	Liste des marchés publics notifiés par le Ministère de la Culture et de la Communication en 2009		0	active	1cc6d560-7a4a-4505-81e8-290e440c9c0b
006c185b-ca0f-4191-9947-2f3a7a3f0e49	d794f07a-06d3-4b59-a969-c00af70ff8db	http://www.culture.gouv.fr/mcc/content/download/10613/71013/file/Liste%20des%20march%C3%A9s%20notifi%C3%A9s%20par%20le%20MCC%20en%202010%20(publication%20internet%20avril%20201)-2.xls	XLS	Liste des marchés publics notifiés par le Ministère de la Culture et de la Communication en 2010 (source XLS)		0	active	5ec1bdc2-fcbf-4932-b6a6-247c87ed9377
72124b3b-1399-44a7-bdb4-23e7f2e2aac7	d794f07a-06d3-4b59-a969-c00af70ff8db	http://www.nosdonnees.fr/wiki/images/c/c1/Liste_des_march%C3%A9s_notifi%C3%A9s_par_le_MCC_en_2010_%28publication_internet_avril_201%29.ods	ODS	Liste des marchés publics notifiés par le Ministère de la Culture et de la Communication en 2010 (conversion ODS)		1	active	5ec1bdc2-fcbf-4932-b6a6-247c87ed9377
fd1abd08-2096-496f-95cf-32fa966251ab	d794f07a-06d3-4b59-a969-c00af70ff8db	http://www.nosdonnees.fr/wiki/images/9/9e/Liste_des_march%C3%A9s_notifi%C3%A9s_par_le_MCC_en_2010_%28publication_internet_avril_201%29.csv	CSV	Liste des marchés publics notifiés par le Ministère de la Culture et de la Communication en 2010 (conversion CSV)		2	active	5ec1bdc2-fcbf-4932-b6a6-247c87ed9377
18a000fb-8a1c-4d83-931b-2840f653e83d	5efedd90-782d-4129-8e71-fdd3b6e1c7df	http://www.culture.gouv.fr/mcc/content/download/6763/46214/file/recencement_marches%20_CdA_mcc2007.pdf	PDF	Liste des marchés publics notifiés par le Ministère de la Culture et de la Communication en 2007		0	active	195959a3-77de-4e3d-95e4-8c5989ddd65d
45bcec2c-3abd-4cf7-96f2-0f80d357a11a	f1261a91-9d52-4520-837e-e9c793f28dcc	http://www.culture.gouv.fr/mcc/content/download/6762/46210/file/Liste_Marches-MCC%202008-2.pdf	PDF	Liste des marchés publics notifiés par le Ministère de la Culture et de la Communication en 2008		0	active	df459aea-8e94-463f-835f-cdcd6ec1327c
3af3f271-92e9-43ab-8476-c008c46620e0	6968ef13-1d2f-4de3-b533-706bc9c0f604	http://elections.regardscitoyens.org/etrac/browser/elections/trunk	csv			0	active	3731e364-32f0-4a8c-924a-1c94cc311553
cc57d829-8602-46a8-a186-5573b0b7f8da	4402487d-3e8d-4618-8444-b400c6337834	http://www.impots.gouv.fr/portal/deploiement/p1/fichedescriptive_5128/fichedescriptive_5128.xls	XLS	Annee 2008		1	active	0906792a-0391-484a-a503-86206888bdc5
a11f4723-404c-4b5d-a5ff-06a251945020	4402487d-3e8d-4618-8444-b400c6337834	http://www.impots.gouv.fr/portal/deploiement/p1/fichedescriptive_4691/fichedescriptive_4691.xls	XLS	Annee 2007		2	active	0906792a-0391-484a-a503-86206888bdc5
92edcbb2-86d1-4783-9f3c-38e4801b6edb	4402487d-3e8d-4618-8444-b400c6337834	http://www.impots.gouv.fr/portal/deploiement/p1/fichedescriptive_4249/fichedescriptive_4249.xls	XLS	Annee 2006		3	active	0906792a-0391-484a-a503-86206888bdc5
09c2d352-aa6e-4ade-9631-3ef2b4837125	4402487d-3e8d-4618-8444-b400c6337834	http://www.impots.gouv.fr/portal/deploiement/p1/fichedescriptive_3725/fichedescriptive_3725.xls	XLS	Annee 2005		4	active	0906792a-0391-484a-a503-86206888bdc5
4f155e76-54d3-4f49-abdf-8205986c2840	4402487d-3e8d-4618-8444-b400c6337834	http://www.impots.gouv.fr/portal/deploiement/p1/fichedescriptive_2989/fichedescriptive_2989.xls	XLS	Annee 2004		5	active	0906792a-0391-484a-a503-86206888bdc5
aa16c60b-a6cf-4b5e-ac5d-045fdf46fa31	4402487d-3e8d-4618-8444-b400c6337834	http://www.impots.gouv.fr/portal/deploiement/p1/fichedescriptive_2395/fichedescriptive_2395.xls	XLS	Annee 2003		6	active	0906792a-0391-484a-a503-86206888bdc5
0f2d4ba5-1ffd-4d24-a74e-7e9dcd2e6435	4402487d-3e8d-4618-8444-b400c6337834	http://www.impots.gouv.fr/portal/deploiement/p1/fichedescriptive_1377/fichedescriptive_1377.xls	XLS	Annee 2002		7	active	0906792a-0391-484a-a503-86206888bdc5
493f3da8-3d38-4d3d-901d-f012ee6604f6	df63f81c-7a27-49d1-86c8-8d5e49883d40	http://asset.rue89.com/files/yanng/palmares_actu_reseaux_sociaux_ls.ods	ods			0	active	0f7316bd-5b12-443c-b846-ea48cd376a1c
ca62a914-c178-43f0-8ba6-02bd28af6626	196340e0-5246-4bc2-8b69-54c66a48b399	http://www.nosdonnees.fr/wiki/images/3/30/PJL2012-recettes-depenses.csv	CSV			0	active	1220be1d-b2b7-491a-a02a-708eb1f990d7
644aaae1-1f84-40ca-b147-614958f6f5a2	7f6c30c6-d6a5-4d39-ae5d-e1ae4cc2d3ef	http://opendata71interactive.cloudapp.net/DataBrowser/DownloadCsv?container=data&entitySet=Limites71&filter=NOFILTER	CSV	Tracé des limites du département de Saône et Loire (71)		0	active	fb039b32-eb70-48ac-8532-ac1572e12acc
169ccf21-5657-472b-9c66-2e587d644de1	3c175c09-a896-4a88-9603-2b5ea27ef1a1	http://www.prevair.org/fr/observation_03.php		Observation du dioxyde d'azote - Non Accessible (Forbidden)		1	active	4cc259ea-31a7-46d3-9db1-9b93ce24ed27
3b773120-1293-4062-800e-381ba507589b	3c175c09-a896-4a88-9603-2b5ea27ef1a1	http://www.prevair.org/fr/observation_24.php		Observation des particules PM 10 - Non Accessible (Forbidden)		3	active	4cc259ea-31a7-46d3-9db1-9b93ce24ed27
7301ba12-db82-4e95-9b19-1fca16f0541a	3c175c09-a896-4a88-9603-2b5ea27ef1a1	http://www.prevair.org/fr/observation_08.php		Observation de l'ozone - Non Accessible (Forbidden)		0	active	4cc259ea-31a7-46d3-9db1-9b93ce24ed27
d8cc9c41-b3cb-4e64-b711-2d624e1860fd	3c175c09-a896-4a88-9603-2b5ea27ef1a1	http://www.prevair.org/fr/observation_39.php		Observation des particules PM 2.5 - Non Accessible (Forbidden)		2	active	4cc259ea-31a7-46d3-9db1-9b93ce24ed27
a4e68efb-6fea-42b5-9d82-0fc46a842aea	cdc13d67-6360-43a6-bb99-cd68b64ee3f3	http://www.insee.fr/fr/ffc/figure/NATTEF01337.xls	XLS	Occupation physique du territoire de 1981 à 2009		0	active	081aa116-4b83-4ecc-b179-41fc2f9c398b
c56d0c7d-9003-43f9-adfc-51e82e663d40	ac051eb3-275f-40a5-b160-e224d13902e7	http://dev.alphoenix.net/data/deputes.csv	csv	Présentation des députés au 11 novembre.		0	active	9bd678be-b57f-4582-9c02-1a5c106f9f2c
7b4d422d-fe6f-4ef8-b28e-c51a0a98cbb7	ac051eb3-275f-40a5-b160-e224d13902e7	http://dev.alphoenix.net/data/anciensMandatsDepute.csv	csv	Anciens mandats.		1	active	9bd678be-b57f-4582-9c02-1a5c106f9f2c
9438bbee-c2f4-4e53-84b2-8b58c2c766b9	67906f75-4298-4b6a-aa62-d8314be33f15	http://www.regardscitoyens.org/telechargement/confiseurs/sanctions-commissions-2010-2011.csv	CSV	Nous avons établi la liste des députés qui correspond aux critères définis par le règlement. Les absences justifiées et valables au regard du règlement ont été prises en compte au regard des informations disponibles publiquement, et chacun des députés a été contacté individuellement en vue de vérifier l'oubli éventuel d'excuses. Le CSV contient une ligne par mois et par député concerné.		0	active	6e196cec-2bdc-4b09-b540-8d55debe949b
592337e6-a2d3-4966-a87c-e6d30e838362	67906f75-4298-4b6a-aa62-d8314be33f15	http://www.regardscitoyens.org/telechargement/confiseurs/scrutins-solennels-2010-2011.csv	CSV	Le fichier CSV proposé chiffre le nombre de scrutins auxquels chaque député a participé ou s'est fait représenter au cours de la session écoulée, en plus d'informations complémentaires relatives au mandat de chacun.		1	active	6e196cec-2bdc-4b09-b540-8d55debe949b
20fb0508-dcf0-4aa9-a51f-7827a2991a37	84b91384-8ec9-4b55-8dc9-28ff8c6db62f	http://data.nantes.fr/fileadmin/data/datastore/3-publication/culture/horaire_equip_culturels/horaire_equip_culturels_csv.zip	csv			0	active	e4086bee-133a-43fd-b352-10bacd65ee70
4f6b567b-956b-4b0c-be15-a82a12385698	84b91384-8ec9-4b55-8dc9-28ff8c6db62f	http://data.nantes.fr/fileadmin/data/datastore/3-publication/culture/horaire_equip_culturels/horaire_equip_culturels_xls.zip	xls			1	active	e4086bee-133a-43fd-b352-10bacd65ee70
20c5d699-31a3-4e5a-bbf1-8ee804b15864	1dacf074-ad54-432a-a04f-cecd3a068d0c	http://www.insee.fr/fr/ppp/bases-de-donnees/irweb/recme2010/dd/excel/recme2010_T2010.xls	xls			0	active	5c5b9cbd-eac0-40d0-86f0-0d9c9ae096b7
9c6a6794-93f5-4871-9936-50a06a985590	32ccab1e-e85e-4f52-84f5-69bbcc5fa53d	http://webstat.banque-france.fr/fr/quickviewexport.do?trans=&start=&end=&snapshot=&periodSortOrder=&SERIES_KEY=227.STS.M.AT.S.UNEH.RTT000.4.000&type=csv	CSV	Autriche depuis 1993Jan		0	active	10ac057b-4a62-4be2-9333-99cbb69c179a
fc4a00da-6ad6-4391-8872-b82b374bc9d4	32ccab1e-e85e-4f52-84f5-69bbcc5fa53d	http://webstat.banque-france.fr/fr/quickviewexport.do?trans=&start=&end=&snapshot=&periodSortOrder=&SERIES_KEY=227.STS.M.BE.S.UNEH.RTT000.4.000&type=csv	CSV	Belgique depuis 1983Jan		1	active	10ac057b-4a62-4be2-9333-99cbb69c179a
d297586a-fde8-47f0-8692-0fd62d285e85	32ccab1e-e85e-4f52-84f5-69bbcc5fa53d	http://webstat.banque-france.fr/fr/quickviewexport.do?trans=&start=&end=&snapshot=&periodSortOrder=&SERIES_KEY=227.STS.M.CY.S.UNEH.RTT000.4.000&type=csv	CSV	Chypre depuis 2000Jan		2	active	10ac057b-4a62-4be2-9333-99cbb69c179a
1a8b0021-b1d2-484f-acdc-df3136e11e03	32ccab1e-e85e-4f52-84f5-69bbcc5fa53d	http://webstat.banque-france.fr/fr/quickviewexport.do?trans=&start=&end=&snapshot=&periodSortOrder=&SERIES_KEY=227.STS.M.DE.S.UNEH.RTT000.4.000&type=csv	CSV	Allemagne depuis 1991Jan		3	active	10ac057b-4a62-4be2-9333-99cbb69c179a
dc771d7c-1b2b-4786-85d2-593b85c8541c	32ccab1e-e85e-4f52-84f5-69bbcc5fa53d	http://webstat.banque-france.fr/fr/quickviewexport.do?trans=&start=&end=&snapshot=&periodSortOrder=&SERIES_KEY=227.STS.M.ES.S.UNEH.RTT000.4.000&type=csv	CSV	Espagne depuis 1986Apr		4	active	10ac057b-4a62-4be2-9333-99cbb69c179a
06e11e20-eb0b-405a-b8dc-61ed781f4485	32ccab1e-e85e-4f52-84f5-69bbcc5fa53d	http://webstat.banque-france.fr/fr/quickviewexport.do?trans=&start=&end=&snapshot=&periodSortOrder=&SERIES_KEY=227.STS.M.FI.S.UNEH.RTT000.4.000&type=csv	CSV	Finlande depuis 1988Jan		5	active	10ac057b-4a62-4be2-9333-99cbb69c179a
eaec3754-b0ba-40d5-b793-816ecdc49266	32ccab1e-e85e-4f52-84f5-69bbcc5fa53d	http://webstat.banque-france.fr/fr/quickviewexport.do?trans=&start=&end=&snapshot=&periodSortOrder=&SERIES_KEY=227.STS.M.FR.S.UNEH.RTT000.4.000&type=csv	CSV	France depuis 1983Jan		6	active	10ac057b-4a62-4be2-9333-99cbb69c179a
30fcf5e6-2491-41b9-a54a-d3257689f9df	32ccab1e-e85e-4f52-84f5-69bbcc5fa53d	http://webstat.banque-france.fr/fr/quickviewexport.do?trans=&start=&end=&snapshot=&periodSortOrder=&SERIES_KEY=227.STS.M.GR.S.UNEH.RTT000.4.000&type=csv	CSV	Grèce depuis 1983Apr		7	active	10ac057b-4a62-4be2-9333-99cbb69c179a
6fd368b7-9c32-4e9d-94e8-3a0bed185810	32ccab1e-e85e-4f52-84f5-69bbcc5fa53d	http://webstat.banque-france.fr/fr/quickviewexport.do?trans=&start=&end=&snapshot=&periodSortOrder=&SERIES_KEY=227.STS.M.IE.S.UNEH.RTT000.4.000&type=csv	CSV	Irlande depuis 1983Jan		8	active	10ac057b-4a62-4be2-9333-99cbb69c179a
293d927e-416e-4176-8afc-c2713306145f	32ccab1e-e85e-4f52-84f5-69bbcc5fa53d	http://webstat.banque-france.fr/fr/quickviewexport.do?trans=&start=&end=&snapshot=&periodSortOrder=&SERIES_KEY=227.STS.M.IT.S.UNEH.RTT000.4.000&type=csv	CSV	Italie depuis 1983Jan		9	active	10ac057b-4a62-4be2-9333-99cbb69c179a
7a907047-be22-492e-8ab0-aed3c615f1b2	32ccab1e-e85e-4f52-84f5-69bbcc5fa53d	http://webstat.banque-france.fr/fr/quickviewexport.do?trans=&start=&end=&snapshot=&periodSortOrder=&SERIES_KEY=227.STS.M.LU.S.UNEH.RTT000.4.000&type=csv	CSV	Luxembourg depuis 1983Jan		10	active	10ac057b-4a62-4be2-9333-99cbb69c179a
15ea33df-7329-49c8-87c1-37f4773a542b	32ccab1e-e85e-4f52-84f5-69bbcc5fa53d	http://webstat.banque-france.fr/fr/quickviewexport.do?trans=&start=&end=&snapshot=&periodSortOrder=&SERIES_KEY=227.STS.M.MT.S.UNEH.RTT000.4.000&type=csv	CSV	Malte depuis 2000Jan		11	active	10ac057b-4a62-4be2-9333-99cbb69c179a
a1a48f6e-427e-41bf-8df9-80c974aa805e	32ccab1e-e85e-4f52-84f5-69bbcc5fa53d	http://webstat.banque-france.fr/fr/quickviewexport.do?trans=&start=&end=&snapshot=&periodSortOrder=&SERIES_KEY=227.STS.M.NL.S.UNEH.RTT000.4.000&type=csv	CSV	Pays-Bas depuis 1983Jan		12	active	10ac057b-4a62-4be2-9333-99cbb69c179a
364da824-6585-448f-8fe3-9da52645ab3c	32ccab1e-e85e-4f52-84f5-69bbcc5fa53d	http://webstat.banque-france.fr/fr/quickviewexport.do?trans=&start=&end=&snapshot=&periodSortOrder=&SERIES_KEY=227.STS.M.PT.S.UNEH.RTT000.4.000&type=csv	CSV	Portugal depuis 1983Jan		13	active	10ac057b-4a62-4be2-9333-99cbb69c179a
ddf72517-ade1-4186-a8dc-bcbb446ae959	32ccab1e-e85e-4f52-84f5-69bbcc5fa53d	http://webstat.banque-france.fr/fr/quickviewexport.do?trans=&start=&end=&snapshot=&periodSortOrder=&SERIES_KEY=227.STS.M.SI.S.UNEH.RTT000.4.000&type=csv	CSV	Slovénie depuis 1996Jan		14	active	10ac057b-4a62-4be2-9333-99cbb69c179a
5b58d7da-f14f-4123-83ec-86e3c1732719	32ccab1e-e85e-4f52-84f5-69bbcc5fa53d	http://webstat.banque-france.fr/fr/quickviewexport.do?trans=&start=&end=&snapshot=&periodSortOrder=&SERIES_KEY=227.STS.M.SK.S.UNEH.RTT000.4.000&type=csv	CSV	Slovaquie depuis 1998Jan		15	active	10ac057b-4a62-4be2-9333-99cbb69c179a
fde8a3f9-df95-4d68-aac9-bb39d40b34bf	32ccab1e-e85e-4f52-84f5-69bbcc5fa53d	http://webstat.banque-france.fr/fr/quickviewexport.do?trans=&start=&end=&snapshot=&periodSortOrder=&SERIES_KEY=227.STS.M.I5.S.UNEH.RTT000.4.000&type=csv	CSV	Zone euro (16 pays) depuis 1995Jan		16	active	10ac057b-4a62-4be2-9333-99cbb69c179a
b4d8c812-a009-496d-9121-a19280f4983f	89a894cc-c5c8-44e2-9ca3-85ab9a0130f9	https://docs.google.com/spreadsheet/ccc?key=0AvW9Q_v2XAGTdDd0cHQyazhSMFZRcWJjX1hHbmxpdkE#gid=0	CSV	Google spreadsheet exportable		0	active	d7f22ef7-54bb-4348-b287-62fcb6da90f0
b447c99d-3c04-4bb4-9277-6a3d10a57900	be516eed-8a37-436c-af75-b623f0806f39	http://www.bison-fute.equipement.gouv.fr/diffusions/datex2/base/bordeaux_mvs/TraficStatus_cigt_alienor_maintenant.xml	format Datex 2 version 1.0, see http://www.datex2.eu/	Bordeaux		0	active	df68a822-74c8-41c1-8cfe-d0d1a685c74f
2e2bda98-5653-45ba-821b-314a05da5194	be516eed-8a37-436c-af75-b623f0806f39	http://www.bison-fute.equipement.gouv.fr/diffusions/datex2/base/marseille_mvs/TraficStatus_cigt_marseille_maintenant.xml	xml	Marseille		1	active	df68a822-74c8-41c1-8cfe-d0d1a685c74f
f1e8d998-b7d5-4a11-83d3-73ae12ae0139	be516eed-8a37-436c-af75-b623f0806f39	http://www.bison-fute.equipement.gouv.fr/diffusions/datex2/base/savoie_mvs/TraficStatus_cigt_osiris_maintenant.xml	xml	Savoie		2	active	df68a822-74c8-41c1-8cfe-d0d1a685c74f
87c76e70-8296-4e56-b77b-19b1b472b91d	be516eed-8a37-436c-af75-b623f0806f39	http://www.bison-fute.equipement.gouv.fr/diffusions/datex2/base/lille_mvs/TraficStatus_cigt_allegro_maintenant.xml	xml	Lille		3	active	df68a822-74c8-41c1-8cfe-d0d1a685c74f
9eb393d9-7a87-4f98-a1f5-1c60ed9d622b	be516eed-8a37-436c-af75-b623f0806f39	http://www.bison-fute.equipement.gouv.fr/diffusions/datex2/base/caen_mvs/TraficStatus_cigt_caen_maintenant.xml	xml	Caen		4	active	df68a822-74c8-41c1-8cfe-d0d1a685c74f
ff78123f-ce9c-4f8f-a384-f412e2b3cd6a	be516eed-8a37-436c-af75-b623f0806f39	http://www.bison-fute.equipement.gouv.fr/diffusions/datex2/base/a20_mvs/TraficStatus_cigt_a20_maintenant.xml	xml	A20 Limoges - Chateauroux		5	active	df68a822-74c8-41c1-8cfe-d0d1a685c74f
68adc024-62ef-4098-905c-4ca07e73594f	be516eed-8a37-436c-af75-b623f0806f39	http://www.bison-fute.equipement.gouv.fr/diffusions/datex2/base/lyon_mvs/TraficStatus_cigt_coraly_maintenant.xml	xml	Lyon		6	active	df68a822-74c8-41c1-8cfe-d0d1a685c74f
5a11fbe5-6e3c-4414-be59-40a3d8a6ad2b	be516eed-8a37-436c-af75-b623f0806f39	http://www.bison-fute.equipement.gouv.fr/diffusions/datex2/base/a75_mvs/TraficStatus_a75_mivi_maintenant.xml	xml	A75 Clermont-Ferrand Béziers		7	active	df68a822-74c8-41c1-8cfe-d0d1a685c74f
7ae9942b-45a4-4ce9-bfd1-787fab948c4e	be516eed-8a37-436c-af75-b623f0806f39	http://www.bison-fute.equipement.gouv.fr/diffusions/datex2/base/stetienne_mvs/TraficStatus_cigt_stetienne_maintenant.xml	xml	Saint Etienne		8	active	df68a822-74c8-41c1-8cfe-d0d1a685c74f
a7daff8a-0f74-470c-adb7-34df3db15a0e	be516eed-8a37-436c-af75-b623f0806f39	http://www.bison-fute.equipement.gouv.fr/diffusions/datex2/base/grenoble_mvs/TraficStatus_cigt_grenoble_maintenant.xml	xml	Grenoble		9	active	df68a822-74c8-41c1-8cfe-d0d1a685c74f
8735d000-0454-42f9-85d4-810b25e52386	be516eed-8a37-436c-af75-b623f0806f39	http://www.bison-fute.equipement.gouv.fr/diffusions/datex2/base/strasbourg_mvs/TraficStatus_cigt_gutenberg_maintenant.xml	xml	Strasbourg		10	active	df68a822-74c8-41c1-8cfe-d0d1a685c74f
987a685c-f95d-4de3-8bb2-4497e857e4ab	be516eed-8a37-436c-af75-b623f0806f39	http://www.bison-fute.equipement.gouv.fr/diffusions/datex2/base/rennes_mvs/TraficStatus_cigt_dor_breizh_maintenant.xml	xml	Rennes		11	active	df68a822-74c8-41c1-8cfe-d0d1a685c74f
b37cf82c-cc7d-4e78-a479-62270e1e6464	be516eed-8a37-436c-af75-b623f0806f39	http://www.bison-fute.equipement.gouv.fr/diffusions/datex2/base/Nantes_mvs/TraficStatus_cigt_nantes_maintenant.xml	xml	Nantes		12	active	df68a822-74c8-41c1-8cfe-d0d1a685c74f
7f852e30-0bad-4286-91d7-6cabdfdd960f	b9582bd1-bfff-41e1-990f-962c18084f4d	http://www.vpah.culture.fr/vpah/villes/pdf/liste_VPAH_2010.pdf	pdf	149 territoires labellisés, classés par région		0	active	a18e1408-fa8e-444d-bf0f-996db5a55463
f11835eb-2bbd-455c-abca-bd0c368e2390	1dacf074-ad54-432a-a04f-cecd3a068d0c	http://www.insee.fr/fr/ppp/bases-de-donnees/irweb/recme2010/dd/dbase/recme2010_T2010.dbf	dbase			1	active	ee816bc2-0316-4adc-ac10-300df9306594
2d6672c3-dd68-4dc3-ada3-68abaa34cc99	df6c89f3-4473-424b-a0b0-119977da62c5	http://www.insee.fr/fr/methodes/nomenclatures/cog/telechargement/2011/txt/comsimp2011.zip	txt	Liste des communes existantes au 1er janvier 2011		0	active	177926cc-1263-4323-9dad-14032641b0a5
55eb9b42-8a6e-4663-9f5e-f8ad5ac48c00	df6c89f3-4473-424b-a0b0-119977da62c5	http://www.insee.fr/fr/methodes/nomenclatures/cog/telechargement/2011/dbf/comsimp2011.zip	dbase	Liste des communes existantes au 1er janvier 2011		1	active	177926cc-1263-4323-9dad-14032641b0a5
aae5b9b3-efeb-46c6-862d-519112a32ac7	0460ea96-a830-40bd-adfb-140aad4c31ca	http://opendata.paris.fr/opendata/document?id=60&id_attribute=64	xls			0	active	2b5ac88c-ed8c-4fee-b013-103238447a18
d3d68db0-d07a-4cec-8b75-a11ec77fd169	0460ea96-a830-40bd-adfb-140aad4c31ca	http://opendata.paris.fr/opendata/document?id=60&id_attribute=101	csv			1	active	2b5ac88c-ed8c-4fee-b013-103238447a18
8cbb9b0d-d508-404e-a510-d70eef8e2f9f	0460ea96-a830-40bd-adfb-140aad4c31ca	http://opendata.paris.fr/opendata/document?id=60&id_attribute=103	ods			2	active	2b5ac88c-ed8c-4fee-b013-103238447a18
acf62651-c3af-4581-83a1-a9ad2b35d0d4	159b6644-94ed-406d-8e1e-1f002f265396	http://data.nantes.fr/fileadmin/data/datastore/3-publication/citoyennete/prenoms_enfants_nantes/prenoms_enfants_nantes_2010_csv.zip	csv	2010		0	active	d8097172-e1a3-4d79-b40a-3c3ec12be908
d4194aa4-b21e-41e0-b52c-16acc9f2581f	159b6644-94ed-406d-8e1e-1f002f265396	http://data.nantes.fr/fileadmin/data/datastore/3-publication/citoyennete/prenoms_enfants_nantes/prenoms_enfants_nantes_2010_xls.zip	xls	2010		1	active	d8097172-e1a3-4d79-b40a-3c3ec12be908
c92f92d8-e4f1-41fa-b9cd-bb7a31c9eeb9	159b6644-94ed-406d-8e1e-1f002f265396	http://data.nantes.fr/fileadmin/data/datastore/3-publication/citoyennete/prenoms_enfants_nantes/prenoms_enfants_nantes_2009_csv.zip	csv	2009		2	active	d8097172-e1a3-4d79-b40a-3c3ec12be908
50051982-d08d-49a4-9e6e-802e90bc99a2	159b6644-94ed-406d-8e1e-1f002f265396	http://data.nantes.fr/fileadmin/data/datastore/3-publication/citoyennete/prenoms_enfants_nantes/prenoms_enfants_nantes_2009_xls.zip	xls	2009		3	active	d8097172-e1a3-4d79-b40a-3c3ec12be908
94e71a48-b19a-49d0-ae23-4719259d90ea	159b6644-94ed-406d-8e1e-1f002f265396	http://data.nantes.fr/fileadmin/data/datastore/3-publication/citoyennete/prenoms_enfants_nantes/prenoms_enfants_nantes_2008_csv.zip	csv	2008		4	active	d8097172-e1a3-4d79-b40a-3c3ec12be908
020e6e0b-5a62-4599-8c42-6c1265b1ac11	159b6644-94ed-406d-8e1e-1f002f265396	http://data.nantes.fr/fileadmin/data/datastore/3-publication/citoyennete/prenoms_enfants_nantes/prenoms_enfants_nantes_2008_xls.zip	xls	2008		5	active	d8097172-e1a3-4d79-b40a-3c3ec12be908
ceac9814-0b60-49ee-9715-c868c4c8ab60	159b6644-94ed-406d-8e1e-1f002f265396	http://data.nantes.fr/fileadmin/data/datastore/3-publication/citoyennete/prenoms_enfants_nantes/prenoms_enfants_nantes_2007_csv.zip	csv	2007		6	active	d8097172-e1a3-4d79-b40a-3c3ec12be908
c56ece07-fd9d-48bf-97a4-3f61bab7fe2f	159b6644-94ed-406d-8e1e-1f002f265396	http://data.nantes.fr/fileadmin/data/datastore/3-publication/citoyennete/prenoms_enfants_nantes/prenoms_enfants_nantes_2007_xls.zip	xls	2007		7	active	d8097172-e1a3-4d79-b40a-3c3ec12be908
77cfdb9c-7509-4eb9-ae89-f139fc707cd2	159b6644-94ed-406d-8e1e-1f002f265396	http://data.nantes.fr/fileadmin/data/datastore/3-publication/citoyennete/prenoms_enfants_nantes/prenoms_enfants_nantes_2006_csv.zip	csv	2006		8	active	d8097172-e1a3-4d79-b40a-3c3ec12be908
9090d793-9c60-440a-baef-3f3a9a1ef305	159b6644-94ed-406d-8e1e-1f002f265396	http://data.nantes.fr/fileadmin/data/datastore/3-publication/citoyennete/prenoms_enfants_nantes/prenoms_enfants_nantes_2006_xls.zip	xls	2006		9	active	d8097172-e1a3-4d79-b40a-3c3ec12be908
112629f9-6448-47ca-ab6d-3d7200a95890	159b6644-94ed-406d-8e1e-1f002f265396	http://data.nantes.fr/fileadmin/data/datastore/3-publication/citoyennete/prenoms_enfants_nantes/prenoms_enfants_nantes_2005_csv.zip	csv	2005		10	active	d8097172-e1a3-4d79-b40a-3c3ec12be908
c46e5cd4-1348-4124-9f0a-e4f824216729	159b6644-94ed-406d-8e1e-1f002f265396	http://data.nantes.fr/fileadmin/data/datastore/3-publication/citoyennete/prenoms_enfants_nantes/prenoms_enfants_nantes_2005_xls.zip	xls	2005		11	active	d8097172-e1a3-4d79-b40a-3c3ec12be908
13acf9a5-9b7f-483b-b143-9e081a4b73f7	159b6644-94ed-406d-8e1e-1f002f265396	http://data.nantes.fr/fileadmin/data/datastore/3-publication/citoyennete/prenoms_enfants_nantes/prenoms_enfants_nantes_2004_csv.zip	csv	2004		12	active	d8097172-e1a3-4d79-b40a-3c3ec12be908
4b587ae6-be12-493d-ad87-78b82031ce56	159b6644-94ed-406d-8e1e-1f002f265396	http://data.nantes.fr/fileadmin/data/datastore/3-publication/citoyennete/prenoms_enfants_nantes/prenoms_enfants_nantes_2004_xls.zip	xls	2004		13	active	d8097172-e1a3-4d79-b40a-3c3ec12be908
bce33048-e8f0-4778-959a-18cfa66eb1dd	159b6644-94ed-406d-8e1e-1f002f265396	http://data.nantes.fr/fileadmin/data/datastore/3-publication/citoyennete/prenoms_enfants_nantes/prenoms_enfants_nantes_2003_csv.zip	csv	2003		14	active	d8097172-e1a3-4d79-b40a-3c3ec12be908
e1ffad24-2e39-46a0-a747-6d0f00284b74	159b6644-94ed-406d-8e1e-1f002f265396	http://data.nantes.fr/fileadmin/data/datastore/3-publication/citoyennete/prenoms_enfants_nantes/prenoms_enfants_nantes_2003_xls.zip	xls	2003		15	active	d8097172-e1a3-4d79-b40a-3c3ec12be908
10124181-5ac0-4a86-b202-c012b333361a	159b6644-94ed-406d-8e1e-1f002f265396	http://data.nantes.fr/fileadmin/data/datastore/3-publication/citoyennete/prenoms_enfants_nantes/prenoms_enfants_nantes_2002_csv.zip	csv	2002		16	active	d8097172-e1a3-4d79-b40a-3c3ec12be908
6f6806fb-b908-4076-9bf9-9d050d48c103	159b6644-94ed-406d-8e1e-1f002f265396	http://data.nantes.fr/fileadmin/data/datastore/3-publication/citoyennete/prenoms_enfants_nantes/prenoms_enfants_nantes_2002_xls.zip	xls	2002		17	active	d8097172-e1a3-4d79-b40a-3c3ec12be908
d4564cc0-ddd4-4c81-b93e-c4af2eabcb53	159b6644-94ed-406d-8e1e-1f002f265396	http://data.nantes.fr/fileadmin/data/datastore/3-publication/citoyennete/prenoms_enfants_nantes/prenoms_enfants_nantes_2001_csv.zip	csv	2001		18	active	d8097172-e1a3-4d79-b40a-3c3ec12be908
5a211aac-efd2-417e-8d73-4e1a37340279	159b6644-94ed-406d-8e1e-1f002f265396	http://data.nantes.fr/fileadmin/data/datastore/3-publication/citoyennete/prenoms_enfants_nantes/prenoms_enfants_nantes_2001_xls.zip	xls	2001		19	active	d8097172-e1a3-4d79-b40a-3c3ec12be908
e6831011-9e1e-4f33-954f-4ebe756f8dad	641c249c-f473-4d8e-bd8e-f385157f2682	http://www.sisfrance.net/Antilles/export_liste_epicentres.asp	txt	épicentres des séismes aux Antilles françaises et dans l'archipel des Caraïbes		1	active	903899a1-b57f-44c8-9818-15fc47ead4da
40a20fc9-25d7-4ff3-9265-8270936f6921	641c249c-f473-4d8e-bd8e-f385157f2682	http://www.sisfrance.net/Reunion/export_liste_epicentres.asp	txt	épicentres des séismes à la Réunion et à Mayotte		2	active	903899a1-b57f-44c8-9818-15fc47ead4da
1e943df7-a3d1-4ce8-ac5e-a9420d4b1cdb	641c249c-f473-4d8e-bd8e-f385157f2682	http://www.sisfrance.net/Caledonie/export_liste_epicentres.asp	txt	épicentres des séismes en Nouvelle-Calédonie et à Wallis et Futuna		3	active	903899a1-b57f-44c8-9818-15fc47ead4da
e934456c-6d6e-433a-84f3-468e90e9fbff	fea6dcd6-00d6-4ad5-ab2f-eb40f533a5db	http://www.nosdonnees.fr/wiki/images/b/b5/EUCircos_Regions_departements_circonscriptions_communes_gps.csv.gz	CSV	EUcirco ; code_région ; nom_région ; chef-lieu_région ; numéro_département ; nom_département ; préfecture ; numéro_circonscription ; nom_commune ; codes_postaux ; code_insee ; la titude ; longitude ; éloignement		0	active	071df672-626c-420e-ad32-08320d35074e
2adc1ae6-f4a1-44e6-aec9-a8adee23176c	de5557e1-bf16-433b-87ff-401323a97df5	http://www.regardscitoyens.org/telechargement/donnees_publiques/resultats_elections_legislatives_2002.tgz	csv	csv gzipé		0	active	9f2365d7-35db-4301-8a4c-351671cc2694
448b7da1-2f8b-4596-b366-e92de05b7254	47034ede-0506-4650-9fb4-1948168440ca	http://www.regardscitoyens.org/telechargement/donnees_publiques/resultats_elections_presidentielles_2002.tgz	csv	csv gzipé		0	active	db2345f0-bd43-4f1d-b50d-c263b791d1c2
c90de3de-5853-4226-9d25-c698141266db	bfd1388a-ec10-4a7b-9d94-916f56f52f98	http://www.debug-data-gouv.fr/data.gouv.fr.csv	csv			0	active	5037ad29-b65d-490a-bd23-d79c405ec466
a446006c-1c42-4fad-9e7b-04d6f278a8e2	8708a912-1b80-441d-9ba3-d607dd2f0c7c	https://gitorious.org/sharedscrapers/orthonantes/blobs/raw/master/data/orthonantes.csv	CSV	Ville et url des zip contenant les tuiles		0	active	153a48b3-24af-44e4-ab07-9d5610e890da
284f33e1-39d2-464d-bf04-4b7f4a2f869d	25dd2269-e0f3-4653-98ac-33f64f09d4d3	http://www.nosdonnees.fr/wiki/images/e/ed/Circonscriptions.csv	CSV	nom_dptmt;num_dptmt;num_circo;composition		0	active	4bba233a-f5ab-48de-ab8d-8f9f386fbf77
2e95551a-1291-477d-987d-026ad1b5b136	b815db66-cadf-4c3c-ae0b-73ad5bf1a46e	http://www.nosdonnees.fr/wiki/images/1/1c/Circonscriptions-stats-insee.csv	CSV			0	active	78218970-639e-4d24-93ed-244cd4decfcb
74f8b2b3-d2e6-49c1-9ea5-23f7a6544372	b815db66-cadf-4c3c-ae0b-73ad5bf1a46e	http://www.insee.fr/fr/ppp/bases-de-donnees/donnees-detaillees/circo_leg/circo_leg-2012/tableau/circonscriptions.xls	XLS			1	active	78218970-639e-4d24-93ed-244cd4decfcb
a1009ace-9f3a-45d8-90cc-a8bab75762f1	275e4c19-2885-4630-b049-e365374c27fb	http://www.nosdonnees.fr/wiki/images/7/74/500_signatures_de_1995_%C3%A0_2007.csv.gz	csv	csv gzipé		0	active	35fc3cd3-516a-494d-b6fa-b82140444685
2872cacf-f3dc-492a-b468-a3345d03c125	cea11492-fdec-4cfc-a179-a4bbc05cac0b	http://www.regardscitoyens.org/telechargement/presidentielles-2012/signatures_candidats_2012.csv	CSV	candidat;prénom;nom;sexe;fonction;localité;département;dept_num;n_sign;affiliation;profession		0	active	369831c1-22de-4dea-b0b7-b9a33cef2875
ddf49824-b994-480d-babb-7d9c47f8c942	41b0a731-3378-42bd-9e08-8b69a1fee83a	http://komodo.regardscitoyens.org/public/presidentielles2012/historique/participation.csv	CSV	Participation à midi et 17h en 2002, 2007 et 2012		0	active	0d252ab1-5819-41f4-af54-4036c3226e98
c95ce511-abf7-4800-8148-6c289d1169d7	27597355-d542-4574-adc8-6493883d1454	http://www.nosdonnees.fr/wiki/index.php/Image:Donnees-soumises-a-redevance.csv	CSV			0	active	8cade445-98c7-4340-8aaa-34f0c304d0e9
91d76a3e-a85f-43f6-8011-ea55b5916479	cd42a806-cac1-452c-9b0d-116d8ead4d64	http://komodo.regardscitoyens.org/public/legislatives2012/candidats.csv	CSV	#hashtag_circonscription;date_donnees\ttype_election\ttour_election\tdate_election\tnumero_departement\tcode_departement\tdepartement\tnumero_circonscription\tcirconscription\tnumero_panneau\tnumero_depot\tsexe\tnom\tprenom\tdate_naissance\tnuance_politique\tetiquette_nuance_politique\tprofession\tpersonnalité\tcandidat_sortant\tsuppleant_sexe\tsuppleant_nom\tsuppleant_prenom\tsuppleant_date_naissance\tsuppleant_nuance_politique\tsuppleant_personnalité\tsuppleant_candidat_sortant		0	active	485c12a1-334b-4fb6-82e6-96f3556f892e
b0ca96ef-4937-4c8f-b1e6-c985e026a174	cd42a806-cac1-452c-9b0d-116d8ead4d64	http://komodo.regardscitoyens.org/public/legislatives2012/candidats.csv.ministere.diff	CSV	Corrections non appliquées par le Ministère		1	active	6976eef5-92e8-45c2-bc2b-9bfc60341674
c5d9b8f5-827e-420f-b844-8632712fb7c0	e657011b-cf83-47ab-8bc8-62f6498046a6	https://www.dropbox.com/sh/2l54eef1s7a4u6m/3oo4C45ypS	CSV+ODS+PDF			0	active	5ff6213f-387b-4fa1-b818-fd7c5e9151bc
4b93ae92-5b9c-4aa9-8d2e-d95465f01883	41b0a731-3378-42bd-9e08-8b69a1fee83a	http://komodo.regardscitoyens.org/public/presidentielles2012/resultats/resultats_departements_final_T1.csv	CSV	Résultats 2012 par département		4	deleted	f47561d1-b04c-4969-bdc1-06cef53149e5
b8b941af-8e05-4f97-b8a6-9f602dc9c3b3	41b0a731-3378-42bd-9e08-8b69a1fee83a	http://komodo.regardscitoyens.org/public/presidentielles2012/resultats/resultats_circonscriptions_T1.csv	CSV	Résultats 2012 par circonscription législative (tour 1 - avant CC)		1	active	f47561d1-b04c-4969-bdc1-06cef53149e5
ddfdce71-0fb8-4a10-902b-f8ea5acc2dc0	41b0a731-3378-42bd-9e08-8b69a1fee83a	http://komodo.regardscitoyens.org/public/presidentielles2012/resultats/resultats_communes_T1.csv.zip	CSV	Résultats 2012 par commune		5	deleted	f47561d1-b04c-4969-bdc1-06cef53149e5
0723ace3-0f7b-441c-9125-0fb8626f6944	41b0a731-3378-42bd-9e08-8b69a1fee83a	http://komodo.regardscitoyens.org/public/presidentielles2012/resultats/Presidentielle_2012_T2_CirconscriptionLégislatives.csv	CSV	Résultats 2012 par circonscription législative (tour 2 - avant CC)		2	active	5c5d0f67-78c8-4431-8adc-11ee6652d158
525a38fa-ef24-4661-a420-eedfe1d8be25	c4556598-bcc7-4c45-8ae8-bdafc367eaa2	http://komodo.regardscitoyens.org/public/presidentielles2012/resultats/Presidentielle_2012_Resultats_Valides.zip	zip csv utf8	CSV encodés en utf8 avec séparateur ;		0	active	82588466-66be-4f7f-bb1e-2f0aee7ae5d3
f2a6bbe4-422e-4ae2-8dab-ecc4221043c2	41b0a731-3378-42bd-9e08-8b69a1fee83a	http://komodo.regardscitoyens.org/public/presidentielles2012/resultats/Presidentielle_2012_Resultats_Valides.zip	CSV	Résultats des deux tours validés par le Conseil Constitutionnel par commune pour la France et par circonscription pour les français de l'étranger (UTF8, séparateur ;)		3	active	43600948-f915-4cc3-8ecf-3b1eca937184
6842912a-f556-42a7-ac48-54a1166a568d	1399fe4b-2c07-4bda-a720-9df928d51816	http://www.nosdonnees.fr/wiki/images/a/ad/Declarations_Patrimoine_Presidents.csv	csv	Déclarations patrimoniales des derniers présidents de la République		0	active	59317601-caee-4b10-bc04-8f4ce5006fcc
488d2dee-f5f7-412e-905d-004428f1cc4d	1399fe4b-2c07-4bda-a720-9df928d51816	http://www.nosdonnees.fr/wiki/images/c/ca/Patrimoine_Nicolas_Sarkozy.csv	csv	Déclaration patrimoniale de Nicolas Sarkozy (travail original de C. Le Moign)		1	active	11183ab6-8a61-4c67-848f-f51347641664
ffcada14-71c1-42ba-881e-bc660857075a	2a4bae91-082b-4ae5-9729-08c86e000ab5	http://www.regardscitoyens.org/documents/RegardsCitoyens-comptes.ods	ODS			0	active	133e9e8e-01da-481e-909d-367708fce0c2
06595897-9352-4960-bfee-f1d3e9b8711f	61d87eb7-e3d3-4f90-a3a8-b43b5362db1a	http://komodo.regardscitoyens.org/public/legislatives2012/resultats/circos.svg	SVG			0	active	b062326e-1f5d-48e3-a67b-9114ca9e15a4
b9315ffa-a40a-4aff-bba9-411dfee834a0	aac3a30b-36a9-4887-8aab-81c552bfc7d7	http://www.toxicode.fr/circonscriptions_download	CSV	Countours des circonscriptions des législatives		0	active	ec886521-f454-451d-af59-53aadbcf4bbc
9b49881e-6a1d-41c6-93fb-88f3785273be	f1b3849e-9568-4cae-a3a0-3cca7f42c079	http://www.regardscitoyens.org/telechargement/donnees/circonscriptions.svg	SVG	Carte des circonscriptions législatives françaises (2012+)		0	active	91785866-4772-4249-9659-5484c2c4a91d
d41e3f68-f4de-47ec-bfc0-fa2ef9092924	382ceece-628f-43b1-8847-ea92ff04376f	http://www.nosdonnees.fr/wiki/images/a/a7/Comptes_campagne_pr%C3%A9sidentielle_2012.csv	CSV	candidat ; recette/dépense ; catégorie ; frais du mandataire ; frais de la formation politique ; concours en nature ; total		0	active	d982c3cc-785b-44af-9d31-fd3fb152558b
4da8bc6a-641d-438c-a018-de62ecca58e1	30bcda76-5a1a-4369-a6f3-ed2584ad4031	http://www.nosdonnees.fr/wiki/images/3/35/20120613_RegardsCitoyens_declaration_dinterets.csv	CSV	Gouvernement Ayrault 1 06/12		1	active	c102275a-5305-461f-be5d-99ec2b312329
f20622c5-b9f0-4284-89d3-4295a540c07f	30bcda76-5a1a-4369-a6f3-ed2584ad4031	http://www.nosdonnees.fr/wiki/images/0/04/20110421_RegardsCitoyens_declaration_dinterets.csv	CSV	Gouvernement Fillon 3 04/11		2	active	c102275a-5305-461f-be5d-99ec2b312329
eb7ec7a5-e07a-4c16-9706-2fccd5913d41	30bcda76-5a1a-4369-a6f3-ed2584ad4031	http://www.nosdonnees.fr/wiki/images/9/97/20120903_RegardsCitoyens_declaration_dinterets.csv	CSV	Gouvernement Ayrault 2 09/12		0	active	63fc2d16-945c-4443-bbc0-0bd4600d9581
02b623d2-f980-4004-9732-ecb709aca813	d6c6d3f9-5d8d-46c8-bc92-d8507d1e6f04	http://agreste.agriculture.gouv.fr/IMG/pdf/venale2012bareme.pdf	pdf	Barême indicatif de la valeur vénale des terres en 2011 2006		4	active	2f7105eb-514c-4a4b-9271-b33aef907680
29bb4ae7-01b6-482e-ac32-3315ed34dde9	d6c6d3f9-5d8d-46c8-bc92-d8507d1e6f04	http://agreste.agriculture.gouv.fr/IMG/xls/venale2012T1.xls	xls	 Prix des terres et prés de 1997 à 2011 par région et au niveau national		1	active	2f7105eb-514c-4a4b-9271-b33aef907680
cd21067b-6575-4c73-ad1c-219cc0921896	d6c6d3f9-5d8d-46c8-bc92-d8507d1e6f04	http://agreste.agriculture.gouv.fr/IMG/xls/venale2012T3.xls	xls	Prix des vignes de 1991 à 2011 par catégorie de vignes, niveau national, par bassin viticole, par région et par département		2	active	2f7105eb-514c-4a4b-9271-b33aef907680
d92153d0-672c-40f9-8759-d4bff2378fed	d6c6d3f9-5d8d-46c8-bc92-d8507d1e6f04	http://agreste.agriculture.gouv.fr/IMG/xls/venale2012T4.xls	xls	Valeur vénale des terres agricoles dans les DOM de 2000 à 2011, par catégorie de terres et par zones géographiques		3	active	2f7105eb-514c-4a4b-9271-b33aef907680
e8e18117-8242-4e62-af20-0e8e5abf68ae	d6c6d3f9-5d8d-46c8-bc92-d8507d1e6f04	http://agreste.agriculture.gouv.fr/IMG/xls/venale2012T2.xls	xls	Prix dPrix moyen des terres et prés de 1999 à 2011, par département et par groupement de petites régions agricoles		0	active	2f7105eb-514c-4a4b-9271-b33aef907680
96937b63-9dd3-469f-9f45-2562b6f67a4b	8d9cf757-de83-4774-919b-00c45c43efd4	https://api.scraperwiki.com/api/1.0/datastore/sqlite?format=csv&name=prenoms&query=select+*+from+%60swdata%60&apikey=	CSV	id, année, nombre de naissances, ID du prénom, prénom		0	active	c0737967-984c-480f-81ce-d34a53bf21c4
d9c7f3a6-16c3-4cb6-9050-b4f3ec38837c	4f8c2ed1-52a1-4c94-854e-631daeb1a154	http://www.nosdonnees.fr/wiki/images/a/a9/20120630_MinistereJustice_StatsTraitement12moisEtStockFinJuin.csv	csv			0	active	b4fc3c0a-6704-495c-b092-cbeec8f14ace
d363564f-63a8-4cce-8fc2-b44359b71247	e6833b4c-3f1e-4394-a547-790258b451e5	http://www.regardscitoyens.org/telechargement/donnees/rattachement_partis.csv	CSV	nom_complet;prenom;parti_ou_groupement_politique_de_rattachement;groupe_details;groupe_sigle		0	active	da99599d-79c0-47b0-8f59-3f2fc4bf3bed
ef217959-5dc9-4735-81b4-53fd93872d10	e6833b4c-3f1e-4394-a547-790258b451e5	http://www.nosdeputes.fr/deputes/csv	CSV	export API de NosDéputés.fr avc metadonnées complémentaires		1	active	da99599d-79c0-47b0-8f59-3f2fc4bf3bed
6c64cac7-7528-4e73-b3c5-277273647f6b	f1b3849e-9568-4cae-a3a0-3cca7f42c079	http://www.regardscitoyens.org/telechargement/donnees/circonscriptions.svg	SVG	Carte		1	deleted	a17fc946-239f-4bf6-96ce-076b5342fe5e
\.


--
-- Data for Name: package_resource_revision; Type: TABLE DATA; Schema: public; Owner: ckantest
--

COPY package_resource_revision (id, package_id, url, format, description, hash, "position", state, revision_id, continuity_id) FROM stdin;
5c5da933-fc46-48b9-ba85-2986bd048c7a	587ed76e-1c2f-4cc7-a23a-f9beb2415c77	http://www.impots.gouv.fr/portal/deploiement/p1/fichedescriptive_5458/fichedescriptive_5458.xls	XLS			0	active	f74141f1-d57b-4f3f-9ee2-d1469d1a00a9	5c5da933-fc46-48b9-ba85-2986bd048c7a
c207867d-b17e-434c-a57d-c180ba9fb5c4	4402487d-3e8d-4618-8444-b400c6337834	http://www.impots.gouv.fr/portal/deploiement/p1/fichedescriptive_5582/fichedescriptive_5582.xls	XLS			0	active	6aafed2f-a1a7-48cc-b275-0e0986710b13	c207867d-b17e-434c-a57d-c180ba9fb5c4
3c816815-2978-4d25-9fa4-176dd356e1c0	4235252c-aa21-46b5-8c52-110f95bdc583	http://www.regardscitoyens.org/telechargement/donnees_publiques/Donnees_Presidentielles_2007_Officielles_cvs.zip	csv	csv zippé		0	active	e538d820-448e-4081-9616-dd0122780c60	3c816815-2978-4d25-9fa4-176dd356e1c0
b7af4934-b700-4c1f-8e91-a49228269b51	e3424ea9-f7c0-4d80-832b-890c3de0f744	http://www.tarn.pref.gouv.fr/elections/CM2008/	XML	un fichier par commune dont le nom est : 0<Département><Code INSEE commune>.xml		0	active	a6a5efac-b108-40c8-847c-e06530596dae	b7af4934-b700-4c1f-8e91-a49228269b51
6cbd57b5-ee74-418c-b2c1-5ffbfa0b12fc	3aa0d5ce-cef6-4158-b51e-ddee8ece7b5e	http://www.pollutionsindustrielles.ecologie.gouv.fr/IREP/XML/dump.php	CVS	Toute la base contenue dans zip contenant plusieurs CVS		0	active	ceb18013-a90d-44d6-a245-b199633faf0b	6cbd57b5-ee74-418c-b2c1-5ffbfa0b12fc
5ab0ed94-acd0-4840-b79f-47380b40e059	3aa0d5ce-cef6-4158-b51e-ddee8ece7b5e	http://www.pollutionsindustrielles.ecologie.gouv.fr/IREP/downloads/etablissements.csv	CVS	liste des établissements poluants		1	active	ceb18013-a90d-44d6-a245-b199633faf0b	5ab0ed94-acd0-4840-b79f-47380b40e059
5ad00446-67da-4c64-afc0-53428f7b3e16	97b2cf1e-91f4-4b08-a7d8-2e6bd1dca37e	http://www.dgcl.interieur.gouv.fr/sections/a_votre_service/statistiques/fiscalite_locale/communes/copy4_of_taux_de_fiscalite_di/downloadFile/attachedFile/p10000_02.csv	CSV	En 2002		8	active	a5bfd523-f3c2-41e2-9e1a-1624d786767c	5ad00446-67da-4c64-afc0-53428f7b3e16
7b898350-44e8-4904-ab07-204e0f41a7c3	97b2cf1e-91f4-4b08-a7d8-2e6bd1dca37e	http://www.dgcl.interieur.gouv.fr/sections/a_votre_service/statistiques/fiscalite_locale/communes/copy4_of_taux_de_fiscalite_di/downloadFile/attachedFile/p10000_05.csv	CSV	En 2005		5	active	a5bfd523-f3c2-41e2-9e1a-1624d786767c	7b898350-44e8-4904-ab07-204e0f41a7c3
829a2cbf-f1fa-4639-a62c-1ac797a2a6fa	97b2cf1e-91f4-4b08-a7d8-2e6bd1dca37e	http://www.dgcl.interieur.gouv.fr/sections/a_votre_service/statistiques/fiscalite_locale/communes/copy4_of_taux_de_fiscalite_di/downloadFile/attachedFile/p10000_06.csv	CSV	En 2006		4	active	a5bfd523-f3c2-41e2-9e1a-1624d786767c	829a2cbf-f1fa-4639-a62c-1ac797a2a6fa
55955265-69ff-426d-b64d-a285b4ec2ed0	97b2cf1e-91f4-4b08-a7d8-2e6bd1dca37e	http://www.dgcl.interieur.gouv.fr/sections/a_votre_service/statistiques/fiscalite_locale/communes/copy4_of_taux_de_fiscalite_di/downloadFile/attachedFile/p10000_03.csv	CSV	En 2003		7	active	a5bfd523-f3c2-41e2-9e1a-1624d786767c	55955265-69ff-426d-b64d-a285b4ec2ed0
5ed3b40f-d43a-4470-bf5b-413c5ccc5a29	97b2cf1e-91f4-4b08-a7d8-2e6bd1dca37e	http://www.dgcl.interieur.gouv.fr/sections/a_votre_service/statistiques/fiscalite_locale/communes/taux_de_fiscalite_di8452/downloadFile/file/tx_com_sup_10000_hab_en_2009.xls	XLS	En 2009		1	active	a5bfd523-f3c2-41e2-9e1a-1624d786767c	5ed3b40f-d43a-4470-bf5b-413c5ccc5a29
6a1d3267-e479-44c2-93d8-38f323de8d24	97b2cf1e-91f4-4b08-a7d8-2e6bd1dca37e	http://www.dgcl.interieur.gouv.fr/sections/a_votre_service/statistiques/fiscalite_locale/communes/copy4_of_taux_de_fiscalite_di/downloadFile/attachedFile/p10000_04.csv	CSV	En 2004		6	active	a5bfd523-f3c2-41e2-9e1a-1624d786767c	6a1d3267-e479-44c2-93d8-38f323de8d24
0c371831-0896-49c0-a7c7-46fa6be4ff71	97b2cf1e-91f4-4b08-a7d8-2e6bd1dca37e	http://www.dgcl.interieur.gouv.fr/sections/a_votre_service/statistiques/fiscalite_locale/communes/copy4_of_taux_de_fiscalite_di/downloadFile/attachedFile/p10000_07.csv	CSV	En 2007		3	active	a5bfd523-f3c2-41e2-9e1a-1624d786767c	0c371831-0896-49c0-a7c7-46fa6be4ff71
0aae0494-8eaf-4172-b33b-43c0833b1ad9	97b2cf1e-91f4-4b08-a7d8-2e6bd1dca37e	http://www.dgcl.interieur.gouv.fr/sections/a_votre_service/statistiques/fiscalite_locale/communes/taux_de_fiscalite_20/downloadFile/file/com_sup_10_000_hab_2008_DEF.xls	XLS	En 2008		2	active	a5bfd523-f3c2-41e2-9e1a-1624d786767c	0aae0494-8eaf-4172-b33b-43c0833b1ad9
1e217aae-f364-4513-8c24-fe361751274e	97b2cf1e-91f4-4b08-a7d8-2e6bd1dca37e	http://www.dgcl.interieur.gouv.fr/sections/a_votre_service/statistiques/fiscalite_locale/communes/taux_de_fiscalite_di3758/downloadFile/file/txcommunessup10000_en_2010.xls	XLS	En 2010		0	active	a5bfd523-f3c2-41e2-9e1a-1624d786767c	1e217aae-f364-4513-8c24-fe361751274e
15dd30b4-d455-4466-9cac-ba81facb975b	e4c69e90-1056-4f46-9619-57d0a18d1737	http://www.dgcl.interieur.gouv.fr/sections/a_votre_service/statistiques/fiscalite_locale/groupements_de_commu/copy_of_taux_de_fiscalite_di/downloadFile/attachedFile/ca_06.csv	CSV	Communautés d'agglo en 2006		1	active	19979634-e047-4bef-b09b-396ebbbf7fd0	15dd30b4-d455-4466-9cac-ba81facb975b
a407e03d-5ac0-42d8-a0e9-7cce00f4f6d2	e4c69e90-1056-4f46-9619-57d0a18d1737	http://www.dgcl.interieur.gouv.fr/sections/a_votre_service/statistiques/fiscalite_locale/groupements_de_commu/taux_de_fiscalite_di9162/downloadFile/file/txCA2010.xls	XLS	Communauté d'agglo en 2010		8	active	19979634-e047-4bef-b09b-396ebbbf7fd0	a407e03d-5ac0-42d8-a0e9-7cce00f4f6d2
97bca925-30f3-4354-971c-68e5e51af939	e4c69e90-1056-4f46-9619-57d0a18d1737	http://www.dgcl.interieur.gouv.fr/sections/a_votre_service/statistiques/fiscalite_locale/groupements_de_commu/taux_de_fiscalite_di/downloadFile/attachedFile/ca_07.csv	CSV	Communautés d'agglo en 2007		0	active	19979634-e047-4bef-b09b-396ebbbf7fd0	97bca925-30f3-4354-971c-68e5e51af939
a4b0a0c6-d585-46f6-bced-ad2f0270e508	e4c69e90-1056-4f46-9619-57d0a18d1737	http://www.dgcl.interieur.gouv.fr/sections/a_votre_service/statistiques/fiscalite_locale/groupements_de_commu/taux_de_fiscalite_di8290/downloadFile/file/txCU2010.xls	XLS	Communauté urbaines en 2010		9	active	19979634-e047-4bef-b09b-396ebbbf7fd0	a4b0a0c6-d585-46f6-bced-ad2f0270e508
7a0d3a01-386f-454f-a5d9-1c22a391e531	e4c69e90-1056-4f46-9619-57d0a18d1737	http://www.dgcl.interieur.gouv.fr/sections/a_votre_service/statistiques/fiscalite_locale/groupements_de_commu/taux_de_fiscalite_di9800/downloadFile/attachedFile/tx_CA_2009.xls	XLS	Communautés d'agglo en 2009		6	active	19979634-e047-4bef-b09b-396ebbbf7fd0	7a0d3a01-386f-454f-a5d9-1c22a391e531
91aa5080-4087-4330-ba3f-4547637790b6	e4c69e90-1056-4f46-9619-57d0a18d1737	http://www.dgcl.interieur.gouv.fr/sections/a_votre_service/statistiques/fiscalite_locale/groupements_de_commu/taux_de_fiscalite_di7268/downloadFile/attachedFile/tx_CU_2009_corr.xls	XLS	Communauté urbaines en 2009		7	active	19979634-e047-4bef-b09b-396ebbbf7fd0	91aa5080-4087-4330-ba3f-4547637790b6
a97d8472-7bfd-4d9b-a2a9-789e095b7057	e4c69e90-1056-4f46-9619-57d0a18d1737	http://www.dgcl.interieur.gouv.fr/sections/a_votre_service/statistiques/fiscalite_locale/groupements_de_commu/copy2_of_taux_de_fiscalite_di1463/downloadFile/attachedFile/CU_2008.xls	XLS	Communautés urbaines en 2008		5	active	19979634-e047-4bef-b09b-396ebbbf7fd0	a97d8472-7bfd-4d9b-a2a9-789e095b7057
6915276b-2bdd-405b-86e2-e8c5ac81335d	e4c69e90-1056-4f46-9619-57d0a18d1737	http://www.dgcl.interieur.gouv.fr/sections/a_votre_service/statistiques/fiscalite_locale/groupements_de_commu/copy2_of_taux_de_fiscalite_di/downloadFile/attachedFile/CA_2008.xls	XLS	Communautés d'agglo en 2008		4	active	19979634-e047-4bef-b09b-396ebbbf7fd0	6915276b-2bdd-405b-86e2-e8c5ac81335d
2cc9f307-96c4-4178-a618-b976aac1b77a	e4c69e90-1056-4f46-9619-57d0a18d1737	http://www.dgcl.interieur.gouv.fr/sections/a_votre_service/statistiques/fiscalite_locale/groupements_de_commu/taux_de_fiscalite_di1463/downloadFile/attachedFile/cu_06.csv	CSV	Communautés urbaines en 2006		3	active	19979634-e047-4bef-b09b-396ebbbf7fd0	2cc9f307-96c4-4178-a618-b976aac1b77a
5feb4d89-65a7-4e5b-843f-2fdd4426d860	e4c69e90-1056-4f46-9619-57d0a18d1737	http://www.dgcl.interieur.gouv.fr/sections/a_votre_service/statistiques/fiscalite_locale/groupements_de_commu/taux_de_fiscalite_di1463/downloadFile/attachedFile/cu_07.csv	CSV	Communautés urbaines en 2007		2	active	19979634-e047-4bef-b09b-396ebbbf7fd0	5feb4d89-65a7-4e5b-843f-2fdd4426d860
146f7a49-cca4-4edb-adc2-c650c14e4ba7	43c3cc44-3a6c-469b-80fe-913927d2c283	http://data.keolis-rennes.com/fileadmin/OpenDataFiles/GTFS/GTFS-20101013.zip	GTFS			0	active	5b3fb26f-b388-4423-88e3-076c7476b2cc	146f7a49-cca4-4edb-adc2-c650c14e4ba7
5ab0ed94-acd0-4840-b79f-47380b40e059	3aa0d5ce-cef6-4158-b51e-ddee8ece7b5e	http://www.pollutionsindustrielles.ecologie.gouv.fr/IREP/downloads/etablissements.csv	CSV	liste des établissements poluants		1	active	1e4eae84-e18c-4226-a08b-ddb330973624	5ab0ed94-acd0-4840-b79f-47380b40e059
6cbd57b5-ee74-418c-b2c1-5ffbfa0b12fc	3aa0d5ce-cef6-4158-b51e-ddee8ece7b5e	http://www.pollutionsindustrielles.ecologie.gouv.fr/IREP/XML/dump.php	CSV	Toute la base contenue dans zip contenant plusieurs CVS		0	active	1e4eae84-e18c-4226-a08b-ddb330973624	6cbd57b5-ee74-418c-b2c1-5ffbfa0b12fc
d23e4296-9459-4f13-a71f-d07590fa30a0	1901d722-a38d-4e79-a13c-ca51d61bae30	http://rdf.insee.fr/geo/regions-2010.rdf	RDF	Régions 2010		0	active	b2b4b103-d694-4105-86d7-fa937445826f	d23e4296-9459-4f13-a71f-d07590fa30a0
25d8f445-bb31-4bfa-9270-50af1818f3aa	1901d722-a38d-4e79-a13c-ca51d61bae30	http://rdf.insee.fr/geo/departements-2010.rdf	RDF	Départements 2010		1	active	b2b4b103-d694-4105-86d7-fa937445826f	25d8f445-bb31-4bfa-9270-50af1818f3aa
3c816815-2978-4d25-9fa4-176dd356e1c0	4235252c-aa21-46b5-8c52-110f95bdc583	http://www.regardscitoyens.org/telechargement/donnees_publiques/Donnees_Presidentielles_2007_Officielles_cvs.zip	CSV	csv zippé		0	active	0376e537-073c-47ff-8397-bad8797ea48a	3c816815-2978-4d25-9fa4-176dd356e1c0
0bb5958b-cf27-4715-a3f0-e8f54eab1be6	5b23d4f4-058e-44e0-945d-ae9035fb1e15	http://seine-maritime.gouv.fr/IMG/ods/Liste_des_maires.ods	ODS			0	active	f9d8651f-75dd-4a22-8190-ea0df1fb83d1	0bb5958b-cf27-4715-a3f0-e8f54eab1be6
336e232b-8d8f-4cfd-bf5c-875de9d9cfb3	6d999f74-d520-4a8c-8188-5a5c13c6bbec	http://www.ecosante.fr/index2.php?base=FRAN&langh=FRA&langs=FRA&sessionid=	csv	données santé france régions département		0	active	792ec941-9e46-472a-8f28-ee06aeaa4e5b	336e232b-8d8f-4cfd-bf5c-875de9d9cfb3
54c0a2ed-4e09-4494-9d74-ca591b4a642c	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	http://www.regardscitoyens.org/telechargement/donnees/20101201_nosdeputes.fr_donnees.tgz	SQL	Dump SQL de la base de données de NosDéputés.fr contenant toutes les tables sur l'activité des députés. Description des tables dans l'archive		0	active	85392283-0794-47c2-a7e4-2862636d3e55	54c0a2ed-4e09-4494-9d74-ca591b4a642c
614e9656-5db9-442d-bef3-102ee3393a5e	f6c6aac7-3c9b-4a3c-80bc-d6709bc95d4b	http://www.regardscitoyens.org/telechargement/redecoupage/2009121601_synthese.csv.gz	CSV	Une ligne par circonscription avec les résultats en 2007 et la projection des résultats avec le nouveau découpage (couleur politique, parti gagnant et score en en %) (599 enregistrements)		0	active	a78d4faa-842b-4cec-8ba4-2e9993ff99ca	614e9656-5db9-442d-bef3-102ee3393a5e
61f30314-333f-41ca-8c2a-082a631aa6d2	f6c6aac7-3c9b-4a3c-80bc-d6709bc95d4b	http://www.regardscitoyens.org/telechargement/redecoupage/2009121601_resultats.csv.gz	CSV	        une ligne par candidat, par bureau de vote et par tour en 2007 avec les informations nécessaires pour affecter le bureau de vote à la nouvelle circonscription ainsi que cette affectation (965286 enregistrements)		1	active	a78d4faa-842b-4cec-8ba4-2e9993ff99ca	61f30314-333f-41ca-8c2a-082a631aa6d2
0aae0494-8eaf-4172-b33b-43c0833b1ad9	97b2cf1e-91f4-4b08-a7d8-2e6bd1dca37e	http://www.nosdonnees.fr/wiki/images/e/e7/Com_sup_10_000_hab_2008_DEF.csv	CSV	En 2008		2	active	945fbb14-dfc2-4bda-9259-43f438951fa7	0aae0494-8eaf-4172-b33b-43c0833b1ad9
1e217aae-f364-4513-8c24-fe361751274e	97b2cf1e-91f4-4b08-a7d8-2e6bd1dca37e	http://www.nosdonnees.fr/wiki/images/f/fd/Txcommunessup10000_en_2010.csv	CSV	En 2010		0	active	945fbb14-dfc2-4bda-9259-43f438951fa7	1e217aae-f364-4513-8c24-fe361751274e
5ed3b40f-d43a-4470-bf5b-413c5ccc5a29	97b2cf1e-91f4-4b08-a7d8-2e6bd1dca37e	http://www.nosdonnees.fr/wiki/images/5/5e/Tx_com_sup_10000_hab_en_2009.csv	CSV	En 2009		1	active	945fbb14-dfc2-4bda-9259-43f438951fa7	5ed3b40f-d43a-4470-bf5b-413c5ccc5a29
e4d15c16-7a1c-44f1-a074-543287adf763	f3d8ca3c-32b9-4485-95d9-0b1fd4a5dd4e	http://www.regardscitoyens.org/telechargement/confiseurs/sanctions-commissions.csv	CSV	Nous avons établi la liste des députés qui correspond aux critères définis par le règlement. Les absences justifiées et valables au regard du règlement ont été prises en compte au regard des informations disponibles publiquement, et chacun des députés a été contacté individuellement en vue de vérifier l'oubli éventuel d'excuses. Le CSV contient une ligne par mois et par député concerné.		0	active	d78247f0-fc65-4fb3-bc7e-81f3ad80e69b	e4d15c16-7a1c-44f1-a074-543287adf763
14c0083c-5d9f-4da4-94d1-c022e8dcba46	f3d8ca3c-32b9-4485-95d9-0b1fd4a5dd4e	http://www.regardscitoyens.org/telechargement/confiseurs/scrutins-solennels.csv	CSV	Le fichier CSV proposé chiffre le nombre de scrutins auxquels chaque député a participé ou s'est fait représenter au cours de la session écoulée, en plus d'informations complémentaires relatives au mandat de chacun.		1	active	d78247f0-fc65-4fb3-bc7e-81f3ad80e69b	14c0083c-5d9f-4da4-94d1-c022e8dcba46
bc26bfac-6b07-4608-a835-d7c0e53ffa4c	69361720-3428-417e-beb4-d21df542992c	http://www.insee.fr/fr/ppp/bases-de-donnees/donnees-detaillees/apul-regions/apul_region-07.xls	XLS	Comptes régionalisés des administrations publiques locales en 2007		0	active	8b208a3e-558c-4884-9cc1-297a0dc0e174	bc26bfac-6b07-4608-a835-d7c0e53ffa4c
d351f497-c9bd-423e-a246-f866e5596a95	65d7e18e-c5ab-4736-bb9e-c47de2dc41e1	http://www.nosdonnees.fr/wiki/images/0/05/Import_export_france_pays.csv.gz	csv	gzipé au 4 décembre (contient les données 2008, 2009 et 9 derniers mois 2010)		0	active	e4cf8b5e-d018-4c0b-9c86-f6b0e85edcfd	d351f497-c9bd-423e-a246-f866e5596a95
8a3df4b0-12b5-478d-9a9b-bc2223c06a56	0e14dccb-9c28-4f89-b3b2-cb1011be06d1	http://perso.ens-lyon.fr/benoit.boissinot/upload/jaune-asso-2010.ods	ods	2007 et 2008		1	active	fb37d996-fe0c-49bf-8cb0-29b99087b3d2	8a3df4b0-12b5-478d-9a9b-bc2223c06a56
6d5eafca-2d23-4068-a133-7d4452c692d7	0e14dccb-9c28-4f89-b3b2-cb1011be06d1	http://perso.ens-lyon.fr/benoit.boissinot/upload/jaune-asso-2010.csv	csv	2007 et 2008		0	active	fb37d996-fe0c-49bf-8cb0-29b99087b3d2	6d5eafca-2d23-4068-a133-7d4452c692d7
1d3fe6f0-9c5a-45a9-9418-89ad4a672bea	34269022-c891-4a8e-a814-3af2b0fea526	http://www.nosdonnees.fr/wiki/images/5/52/INSEE-localisation-communes-010109.tar.gz	CSV	    * Pour chaque commune, le code des niveaux géographiques supérieurs :        - région, département, arrondissement, canton ville, zone d'emploi, unité urbaine 1999, espace urbain 1999, aire urbaine 1999, tranche d'aire urbaine, tranche de commune, tranche d'unité urbaine, tranche détaillée d'unité urbaine, bassin de vie, code d'EPCI, type d'EPCI, code de la catégorie de la commune dans les aires et espaces urbains 1999 (ZAUER) ;        - la population sans double compte 1999 ;        - la population municipale 2007.      * Le nombre de communes qui composent tous les niveaux géographiques supra-communaux et complétées par la PSDC 99 et la population municipale 2007 (ces deux dernières variables figurent également pour les arrondissements municipaux de Lyon, Marseille et Paris).        En complément des données, la table comprend :        - une documentation sur les variables présentes dans la table,        - le libellé de tous les niveaux géographiques,        - les modifications territoriales intervenues depuis le 1er janvier 2000.		0	active	a23213e4-603f-42b1-88e7-f9f17b4bdb6d	1d3fe6f0-9c5a-45a9-9418-89ad4a672bea
336e232b-8d8f-4cfd-bf5c-875de9d9cfb3	6d999f74-d520-4a8c-8188-5a5c13c6bbec	http://www.ecosante.fr/index2.php?base=FRAN&langh=FRA&langs=FRA&sessionid=	csv	données santé france régions département		0	deleted	0f921f9a-fa99-4cb7-90ef-aab5c836c057	336e232b-8d8f-4cfd-bf5c-875de9d9cfb3
8a3df4b0-12b5-478d-9a9b-bc2223c06a56	0e14dccb-9c28-4f89-b3b2-cb1011be06d1	http://perso.ens-lyon.fr/benoit.boissinot/upload/jaune-asso-2010.ods	ODS	2007 et 2008		1	active	f059768e-f5ee-4b64-94cb-cdecbde8e898	8a3df4b0-12b5-478d-9a9b-bc2223c06a56
6d5eafca-2d23-4068-a133-7d4452c692d7	0e14dccb-9c28-4f89-b3b2-cb1011be06d1	http://perso.ens-lyon.fr/benoit.boissinot/upload/jaune-asso-2010.csv	CSV	2007 et 2008		0	active	f059768e-f5ee-4b64-94cb-cdecbde8e898	6d5eafca-2d23-4068-a133-7d4452c692d7
d351f497-c9bd-423e-a246-f866e5596a95	65d7e18e-c5ab-4736-bb9e-c47de2dc41e1	http://www.nosdonnees.fr/wiki/images/0/05/Import_export_france_pays.csv.gz	CSV	gzipé au 4 décembre (contient les données 2008, 2009 et 9 derniers mois 2010)		0	active	f7eebe7b-6c57-41bb-9ecf-0eefbffd501e	d351f497-c9bd-423e-a246-f866e5596a95
ca2b3710-17e5-4c8b-b1ab-7095b7784911	a1019da5-cdac-4e09-8b60-831994b5f275	http://www.nosdonnees.fr/wiki/images/4/4e/Horaires_bibliotheques.csv	csv	horaires bibliothèques Nantes		0	active	37fbb496-6950-4dfe-96b7-1b2dc46a8c68	ca2b3710-17e5-4c8b-b1ab-7095b7784911
e1855a6d-bdc0-49b1-bff5-8e8969b05ccb	a1019da5-cdac-4e09-8b60-831994b5f275	http://www.nosdonnees.fr/wiki/images/1/1f/HorairesBibliothequesNantes.txt	json	horaires bibliothèques Nantes		1	active	37fbb496-6950-4dfe-96b7-1b2dc46a8c68	e1855a6d-bdc0-49b1-bff5-8e8969b05ccb
3139b4c5-d669-4191-bb65-adc11b3c2786	2502f9a7-15fa-439d-8a48-f61f38cb6f55	http://rdf.insee.fr/geo/archive-2010.zip	RDF	Régions, départements, arrondissements, cantons		2	active	39219937-0939-40ca-86a8-f8493a35a337	3139b4c5-d669-4191-bb65-adc11b3c2786
3b63add7-268c-4210-ac5c-6284740dcf58	2502f9a7-15fa-439d-8a48-f61f38cb6f55	http://rdf.insee.fr/geo/departements-2010.rdf	RDF	Départements		1	active	39219937-0939-40ca-86a8-f8493a35a337	3b63add7-268c-4210-ac5c-6284740dcf58
2c6b0d8c-aa8b-440c-8dd2-398a3d082a23	2502f9a7-15fa-439d-8a48-f61f38cb6f55	http://rdf.insee.fr/geo/regions-2010.rdf	RDF	Régions		0	active	39219937-0939-40ca-86a8-f8493a35a337	2c6b0d8c-aa8b-440c-8dd2-398a3d082a23
953f6a15-b311-4961-87e2-dc1dd15245a6	4276f7df-c7e9-44e1-8886-20ad41ebda0a	http://media.education.gouv.fr/file/2010/04/8/NI-10-16_158048.xls	XLS	Diplôme national du brevet, Session 2009		0	active	8b876446-18be-45e9-98d2-2ad4a1b1e7fa	953f6a15-b311-4961-87e2-dc1dd15245a6
609e530e-ebfb-4e9d-95da-0f89651812e1	f4517261-c1ee-4380-b3ad-0de5a0edc09a	http://media.education.gouv.fr/file/2010/82/4/NI-10-06_142824.xls	XLS	Résultats définitifs de la session 2009 du baccalauréat		0	active	ab96c2af-06af-4bad-8c4f-00ec10f98776	609e530e-ebfb-4e9d-95da-0f89651812e1
93e6f9c6-015a-415b-9588-f7b05e4fafac	9382520e-adb5-4403-848d-5bd5ea476202	http://www.nosdonnees.fr/wiki/images/9/98/Cantonales_2011_Candidats_T1_FE.ods	ods			0	active	df6d8a52-2f22-493d-8be5-645488c266ea	93e6f9c6-015a-415b-9588-f7b05e4fafac
bb0f18ca-59b7-4d98-9ef5-10ef62280f72	09d5ff25-7a8a-4228-9093-bb437bb70f1a	http://www.nosdonnees.fr/wiki/images/3/33/Cantonales_2011_R%C3%A9sultats_Can_FE_T1.ods	ods			0	active	c0b8f3fb-e0c0-4ec9-8d66-a6604dcf12bd	bb0f18ca-59b7-4d98-9ef5-10ef62280f72
89c9e8f8-b19d-4c31-b09d-697dbc4104d7	430e39ad-4906-44ba-83bc-8f2bc6f2d039	http://www.nosdonnees.fr/wiki/images/2/2e/Cantonales_2011_Elus_T1.ods	ods			0	active	65cf3b14-0851-41dd-8891-c545d5d33b8f	89c9e8f8-b19d-4c31-b09d-697dbc4104d7
a08ce488-02ea-4bd0-b11f-0b5ba4f9c218	48a03f6f-f8f4-4758-8672-f8ab8bd10acb	http://www.nosdonnees.fr/wiki/images/8/8a/Cantonales_2011_Candidats_T2_FE.ods	ods			0	active	cbb8cf9d-1615-4a30-9c69-bcc03cae3034	a08ce488-02ea-4bd0-b11f-0b5ba4f9c218
be27fe54-d78e-4f41-b70a-60ad3832b063	09d5ff25-7a8a-4228-9093-bb437bb70f1a	http://www.nosdonnees.fr/wiki/images/6/63/Cantonales_2011_R%C3%A9sultats_Can_FE_T1.csv.gz	csv			1	active	0513d47f-23df-4180-80e9-dc62a6eb95b7	be27fe54-d78e-4f41-b70a-60ad3832b063
8c323d13-4138-42a8-a586-1fd973c5cb2c	cd2385b8-fa33-4be9-82a8-9ceda07fdc75	http://www.nosdonnees.fr/wiki/images/a/a0/Cantonales_2011_R%C3%A9sultats_Can_FE_T2.csv.gz	csv			1	active	0afcdd05-5c6a-4d38-8ccc-62520a9ea0ed	8c323d13-4138-42a8-a586-1fd973c5cb2c
33b883e4-f164-47d3-8c62-bea5425e8b2d	cd2385b8-fa33-4be9-82a8-9ceda07fdc75	http://www.nosdonnees.fr/wiki/images/9/95/Cantonales_2011_R%C3%A9sultats_Can_FE_T2.ods	ods			0	active	0afcdd05-5c6a-4d38-8ccc-62520a9ea0ed	33b883e4-f164-47d3-8c62-bea5425e8b2d
14969953-267a-4298-b52d-8fcd7b510e4e	6c0ea5a3-dd48-4015-8f65-77d56bf54bb3	http://www.nosdonnees.fr/wiki/images/c/c8/Cantonales_2011_elus_T1T2.ods	ods			0	active	b8bede64-bf67-44d3-8697-8261f01f9d7b	14969953-267a-4298-b52d-8fcd7b510e4e
54c0a2ed-4e09-4494-9d74-ca591b4a642c	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	http://www.regardscitoyens.org/telechargement/donnees/20110301_nosdeputes.fr_donnees.tgz	SQL	Dump SQL de la base de données de NosDéputés.fr contenant toutes les tables sur l'activité des députés. Description des tables dans l'archive		0	active	5fd549d6-e139-4705-94a1-805d6ce85222	54c0a2ed-4e09-4494-9d74-ca591b4a642c
9e806b44-ad72-4f2d-a233-512977054fbb	78e9e396-2ab2-4d61-9eea-fe08b840dbf9	http://www.regardscitoyens.org/transparence-france/etude-lobbying/t%C3%A9l%C3%A9chargement/auditionsDonnées individuelles relatives des auditions.csv.gz	CSV	Données relatives aux auditions individuelles		0	active	bdb5cf3d-56bf-428c-9151-2a3bb3c7669a	9e806b44-ad72-4f2d-a233-512977054fbb
048e467b-4d58-4cf1-871f-bd96cdd03553	78e9e396-2ab2-4d61-9eea-fe08b840dbf9	http://www.regardscitoyens.org/transparence-france/etude-lobbying/t%C3%A9l%C3%A9chargement/influence.sql.gz	SQL	Données utilisées par l'application de visualisation présentant les auditions groupées par organisation et rapport		3	active	bdb5cf3d-56bf-428c-9151-2a3bb3c7669a	048e467b-4d58-4cf1-871f-bd96cdd03553
1579f014-b247-47d9-9b50-1365568892bd	78e9e396-2ab2-4d61-9eea-fe08b840dbf9	http://www.regardscitoyens.org/transparence-france/etude-lobbying/t%C3%A9l%C3%A9chargement/influence.csv.gz	CSV	Données utilisées par l'application de visualisation présentant les auditions groupées par organisation et rapport		2	active	bdb5cf3d-56bf-428c-9151-2a3bb3c7669a	1579f014-b247-47d9-9b50-1365568892bd
ca7f2945-53a5-4581-9794-3c08c7c64eb4	78e9e396-2ab2-4d61-9eea-fe08b840dbf9	http://www.regardscitoyens.org/transparence-france/etude-lobbying/t%C3%A9l%C3%A9chargement/registre_an.csv.gz	SQL	Données issues du registre officiel des représentants d'intérêt de l'Assemblée		5	active	bdb5cf3d-56bf-428c-9151-2a3bb3c7669a	ca7f2945-53a5-4581-9794-3c08c7c64eb4
682f5dd6-8a50-4b30-96f2-779857553d5d	78e9e396-2ab2-4d61-9eea-fe08b840dbf9	http://www.regardscitoyens.org/transparence-france/etude-lobbying/t%C3%A9l%C3%A9chargement/auditions.sql.gz	SQL	Données relatives aux auditions individuelles		1	active	bdb5cf3d-56bf-428c-9151-2a3bb3c7669a	682f5dd6-8a50-4b30-96f2-779857553d5d
fab8ff40-8646-45ae-84f1-8860f4aa3ef4	78e9e396-2ab2-4d61-9eea-fe08b840dbf9	http://www.regardscitoyens.org/transparence-france/etude-lobbying/t%C3%A9l%C3%A9chargement/registre_an.csv.gz	CSV	Données issues du registre officiel des représentants d'intérêt de l'Assemblée		4	active	bdb5cf3d-56bf-428c-9151-2a3bb3c7669a	fab8ff40-8646-45ae-84f1-8860f4aa3ef4
f20622c5-b9f0-4284-89d3-4295a540c07f	30bcda76-5a1a-4369-a6f3-ed2584ad4031	http://www.nosdonnees.fr/wiki/images/0/04/20110421_RegardsCitoyens_declaration_dinterets.csv	csv			0	active	ae90eec5-4c4a-4cf4-83f3-238eb3d162e7	f20622c5-b9f0-4284-89d3-4295a540c07f
3b773120-1293-4062-800e-381ba507589b	3c175c09-a896-4a88-9603-2b5ea27ef1a1	http://www.prevair.org/fr/observation_24.php		Observation des particules PM 10		3	active	99223c1a-1e29-42d1-8256-85f44520866f	3b773120-1293-4062-800e-381ba507589b
d8cc9c41-b3cb-4e64-b711-2d624e1860fd	3c175c09-a896-4a88-9603-2b5ea27ef1a1	http://www.prevair.org/fr/observation_39.php		Observation des particules PM 2.5		2	active	99223c1a-1e29-42d1-8256-85f44520866f	d8cc9c41-b3cb-4e64-b711-2d624e1860fd
169ccf21-5657-472b-9c66-2e587d644de1	3c175c09-a896-4a88-9603-2b5ea27ef1a1	http://www.prevair.org/fr/observation_03.php		Observation du dioxyde d'azote		1	active	99223c1a-1e29-42d1-8256-85f44520866f	169ccf21-5657-472b-9c66-2e587d644de1
7301ba12-db82-4e95-9b19-1fca16f0541a	3c175c09-a896-4a88-9603-2b5ea27ef1a1	http://www.prevair.org/fr/observation_08.php		Observation de l'ozone		0	active	99223c1a-1e29-42d1-8256-85f44520866f	7301ba12-db82-4e95-9b19-1fca16f0541a
8bd077be-768d-4230-8598-14b8c41a1844	2364edf3-baf9-4a60-a75e-46387f235726	http://www.buldair.org/Statistiques/indice-annuel.php		indices de qualité de l'air		0	active	2f410629-bce8-453d-bac0-fc0b1e286dce	8bd077be-768d-4230-8598-14b8c41a1844
68f69e43-ed53-40e9-90ed-875556a449ce	624552ff-a7cd-427d-88e3-f31ec6dba89b	http://www.res.sports.gouv.fr/documents/Annexe1_RES_2010_V1.pdf	pdf	nomenclature des sites sportifs		0	active	440a2815-bfe0-486e-8a47-7e3a125f8c91	68f69e43-ed53-40e9-90ed-875556a449ce
ffb62e73-46ab-42ed-83c8-a0f8a56446b0	641c249c-f473-4d8e-bd8e-f385157f2682	http://www.sisfrance.net/export_liste_epicentres.asp	txt	épicentres des séismes en france		0	active	8b78ef6a-380d-4f62-a3aa-84f6256a8d15	ffb62e73-46ab-42ed-83c8-a0f8a56446b0
34b6e740-4d3e-4194-b4ab-7e632bf7889f	584d3863-eecc-4595-8a18-145ba2b213f7	http://baignades.sante.gouv.fr/genererPDF.do?gen=no	pdf	génération de rapports		0	active	bc33ab95-a7ce-4722-8c71-55da9972020d	34b6e740-4d3e-4194-b4ab-7e632bf7889f
eca7aba4-77b0-489a-aee5-fb0a0650cb7f	9db98dbb-0a64-4588-8e57-533f05a6e050	http://www.qualite-tourisme.gouv.fr/index.php?reference=304	pdf	téléchargement par région		0	active	33125ba6-51d0-49db-88f0-d15ab1cfbb0e	eca7aba4-77b0-489a-aee5-fb0a0650cb7f
7a8d43c5-1334-4959-a074-7e3d84ab5837	f7a32926-f029-47f4-8649-e3b2997f69d3	http://www.inondationsnappes.fr/donneesDownload.asp?DPT=aucun	SHP	remplacer aucun par le numéro du dpt		0	active	ddf7860e-3a1d-4321-ac1c-65e9157d813a	7a8d43c5-1334-4959-a074-7e3d84ab5837
20867081-b65a-47ae-b075-d0af80fa761a	ced8947c-7c6b-4874-ad5e-c28ba91f8073	http://www.argiles.fr/donneesDownload.asp	MIF−MID	données de gonflemnt des argiles		0	active	2eb6042c-7740-4c4f-b636-76ce8ce6a357	20867081-b65a-47ae-b075-d0af80fa761a
7877da79-163c-47f0-a4e0-ac4d91868b01	1c17435c-508d-4194-9d06-f923d31c60cf	http://www.ogm.gouv.fr/IMG/html/Carte_des_parcelles_OGM_cle8eb1f6.html	HTML	registre au format html		1	active	1504af47-63ff-4fbf-b415-13f245e3530f	7877da79-163c-47f0-a4e0-ac4d91868b01
64ade8ad-f353-4216-bcaf-127c1c9656ba	1c17435c-508d-4194-9d06-f923d31c60cf	http://www.ogm.gouv.fr/IMG/xls/04092007_REGISTRE_PUBLIC_cle85e138.xls	xls	registre au format xls		0	active	1504af47-63ff-4fbf-b415-13f245e3530f	64ade8ad-f353-4216-bcaf-127c1c9656ba
5c7a2a17-e793-453f-af64-d79faa11ba92	b57f2ed1-ee10-469b-afcc-a4d7636d39c7	http://www.banatic.interieur.gouv.fr/Banatic2/php/ba-Region.php	xls	données par régions et départements		1	active	b349135d-a405-4e84-a347-9acbd6b9c0a5	5c7a2a17-e793-453f-af64-d79faa11ba92
6142f945-4f66-4b53-a36c-dc9e39efe788	b57f2ed1-ee10-469b-afcc-a4d7636d39c7	http://www.banatic.interieur.gouv.fr/Banatic2/php/ba-France.php	xls	développement de l'intercommunalité		0	active	b349135d-a405-4e84-a347-9acbd6b9c0a5	6142f945-4f66-4b53-a36c-dc9e39efe788
9dd7a66c-c224-412c-83ef-44107cbeab34	f22a7938-303f-4ac6-92da-526a4ad2a207	http://www.budget.gouv.fr/directions_services/budget/situation_mensuelle/2010/100430.pdf	pdf	avril		3	active	5f4eb519-36a4-444a-bed2-c545d3f4d20b	9dd7a66c-c224-412c-83ef-44107cbeab34
b04b0ca9-a110-4521-bde7-48e3f12c9b4a	f22a7938-303f-4ac6-92da-526a4ad2a207	http://www.budget.gouv.fr/directions_services/budget/situation_mensuelle/2010/100331.pdf	pdf	mars		2	active	5f4eb519-36a4-444a-bed2-c545d3f4d20b	b04b0ca9-a110-4521-bde7-48e3f12c9b4a
54dbbd2e-1d03-43ad-912f-71d360fe12bf	f22a7938-303f-4ac6-92da-526a4ad2a207	http://www.budget.gouv.fr/directions_services/budget/situation_mensuelle/2010/100131.pdf	pdf	janvier		0	active	5f4eb519-36a4-444a-bed2-c545d3f4d20b	54dbbd2e-1d03-43ad-912f-71d360fe12bf
f8556c82-78b2-46c7-a396-381fe26bb3a4	f22a7938-303f-4ac6-92da-526a4ad2a207	http://www.budget.gouv.fr/directions_services/budget/situation_mensuelle/2010/100228.pdf	pdf	février		1	active	5f4eb519-36a4-444a-bed2-c545d3f4d20b	f8556c82-78b2-46c7-a396-381fe26bb3a4
2a9fd922-9db6-46ed-8f3d-ee444ed4751d	3d4e64cc-54c0-4b3e-b865-2fff3d9845e7	http://www.colloc.bercy.gouv.fr/colo_otherfiles_fina_loca/telecharger/com02.pdf	pdf	analyse 2002		6	active	117f797d-1662-4d4f-8779-08a5af2ca1aa	2a9fd922-9db6-46ed-8f3d-ee444ed4751d
d963439a-4e69-4321-ba17-3f848a393564	3d4e64cc-54c0-4b3e-b865-2fff3d9845e7	http://www.colloc.bercy.gouv.fr/colo_otherfiles_fina_loca/telecharger/brochurecom_2008.pdf	pdf	analyse 2008		0	active	117f797d-1662-4d4f-8779-08a5af2ca1aa	d963439a-4e69-4321-ba17-3f848a393564
abdc6294-d827-4c94-86da-f64df399c46e	3d4e64cc-54c0-4b3e-b865-2fff3d9845e7	http://www.colloc.bercy.gouv.fr/colo_otherfiles_fina_loca/telecharger/brochure_communes_2005_2.pdf	pdf	analyse 2005		3	active	117f797d-1662-4d4f-8779-08a5af2ca1aa	abdc6294-d827-4c94-86da-f64df399c46e
4a7ebbe3-f943-4f6f-8a62-e1900278d556	3d4e64cc-54c0-4b3e-b865-2fff3d9845e7	http://www.colloc.bercy.gouv.fr/colo_struct_fina_loca/comp_coll/comm/lana_comp_6.html	html	analyse 2006		2	active	117f797d-1662-4d4f-8779-08a5af2ca1aa	4a7ebbe3-f943-4f6f-8a62-e1900278d556
42e7672b-6634-468e-9bdb-7da8b373a6a8	3d4e64cc-54c0-4b3e-b865-2fff3d9845e7	http://www.colloc.bercy.gouv.fr/colo_otherfiles_fina_loca/telecharger/brochure_2007_commune3.pdf	pdf	analyse 2007		1	active	117f797d-1662-4d4f-8779-08a5af2ca1aa	42e7672b-6634-468e-9bdb-7da8b373a6a8
e10758bd-41b6-4e36-bad4-18d393eedd08	3d4e64cc-54c0-4b3e-b865-2fff3d9845e7	http://www.colloc.bercy.gouv.fr/colo_otherfiles_fina_loca/telecharger/com01.pdf	pdf	analyse 2001		7	active	117f797d-1662-4d4f-8779-08a5af2ca1aa	e10758bd-41b6-4e36-bad4-18d393eedd08
ee05827c-7c5f-47d1-8364-efc1e6426c84	3d4e64cc-54c0-4b3e-b865-2fff3d9845e7	http://www.colloc.bercy.gouv.fr/colo_otherfiles_fina_loca/telecharger/brochcom03.pdf	pdf	analyse 2003		5	active	117f797d-1662-4d4f-8779-08a5af2ca1aa	ee05827c-7c5f-47d1-8364-efc1e6426c84
9d31dd68-7a12-4393-b5d3-e8d757c5d9d3	3d4e64cc-54c0-4b3e-b865-2fff3d9845e7	http://www.colloc.bercy.gouv.fr/colo_otherfiles_fina_loca/telecharger/compcom.pdf	pdf	analyse 2000		8	active	117f797d-1662-4d4f-8779-08a5af2ca1aa	9d31dd68-7a12-4393-b5d3-e8d757c5d9d3
63b4ac19-27a9-4912-9981-c0843e8a24b4	3d4e64cc-54c0-4b3e-b865-2fff3d9845e7	http://www.colloc.bercy.gouv.fr/colo_otherfiles_fina_loca/telecharger/communes_2004_brochure_v2.pdf	pdf	analyse 2004		4	active	117f797d-1662-4d4f-8779-08a5af2ca1aa	63b4ac19-27a9-4912-9981-c0843e8a24b4
d92153d0-672c-40f9-8759-d4bff2378fed	d6c6d3f9-5d8d-46c8-bc92-d8507d1e6f04	http://agreste.agriculture.gouv.fr/IMG/pdf_venale2009T4.pdf	pdf	Valeur vénale des terres agricoles dans les DOM de 2000 à 2009		3	active	a7e3dd94-6c86-413f-abfe-3bed55bf9d85	d92153d0-672c-40f9-8759-d4bff2378fed
cd21067b-6575-4c73-ad1c-219cc0921896	d6c6d3f9-5d8d-46c8-bc92-d8507d1e6f04	http://agreste.agriculture.gouv.fr/IMG/pdf_venale2009T2.pdf	pdf	Prix moyen des vignes, évolution de 1991 à 2009		2	active	a7e3dd94-6c86-413f-abfe-3bed55bf9d85	cd21067b-6575-4c73-ad1c-219cc0921896
29bb4ae7-01b6-482e-ac32-3315ed34dde9	d6c6d3f9-5d8d-46c8-bc92-d8507d1e6f04	http://agreste.agriculture.gouv.fr/IMG/pdf/venale2008T3.pdf	pdf	 Prix des terres et prés par région, département en 2007, évolution 2007/2006 		1	active	a7e3dd94-6c86-413f-abfe-3bed55bf9d85	29bb4ae7-01b6-482e-ac32-3315ed34dde9
e8e18117-8242-4e62-af20-0e8e5abf68ae	d6c6d3f9-5d8d-46c8-bc92-d8507d1e6f04	http://agreste.agriculture.gouv.fr/IMG/pdf/venale2008T1bis.pdf	pdf	Prix des terres et prés, évolution de 1991 à 2007		0	active	a7e3dd94-6c86-413f-abfe-3bed55bf9d85	e8e18117-8242-4e62-af20-0e8e5abf68ae
02b623d2-f980-4004-9732-ecb709aca813	d6c6d3f9-5d8d-46c8-bc92-d8507d1e6f04	http://agreste.agriculture.gouv.fr/IMG/pdf/primeur199.pdf	pdf	La valeur vénale des terres agricoles en 2006		4	active	a7e3dd94-6c86-413f-abfe-3bed55bf9d85	02b623d2-f980-4004-9732-ecb709aca813
97c1a7cf-f804-4b6c-9c4b-13554270e3ce	fe7cd753-376f-4f22-a721-caa482aa1116	http://www.observatoire-saone.fr/index.php?id=96	.pdf	différents téléchargements possibles		0	active	34579160-706c-4b4e-86e7-1deddb37f9e0	97c1a7cf-f804-4b6c-9c4b-13554270e3ce
d9927b6e-01e3-4e92-ba5a-b0f59afadf4d	60e23204-8e78-487c-92bd-5de0c6102067	http://www.planseisme.fr/IMG/xls/zonage_sismique_par_communes.xls	xls	zonage sismique par commune		0	active	9072590d-3b6f-4ac1-89d3-0751de5632a7	d9927b6e-01e3-4e92-ba5a-b0f59afadf4d
b9592d7d-24f8-47f6-bdfb-ce31e545ef2c	4654898f-58f4-482f-a91f-23aa5e192fd8	http://manage.dgcl.interieur.gouv.fr/workspaces/members/desl/documents/finances/commune/capc2009/capc2009_00/downloadFile/file/CAPC2009_00.pdf?nocache=1303806614.94	pdf	Comptes 2009 des communes de moins de 10 000 habitants		0	active	2d7fa951-5b6e-494f-ad7e-a7afcea2cd4f	b9592d7d-24f8-47f6-bdfb-ce31e545ef2c
ea103e7f-9d16-4a5b-a117-1dcd65c70ef2	20100c39-31ae-4fd4-ad35-bfeabe396b5f	http://manage.dgcl.interieur.gouv.fr/workspaces/members/desl/documents/clench/2011/publication_globale/downloadFile/file/publication-globale.pdf?nocache=1302527601.79	pdf	collectivités locales en chiffres 2011		0	active	12caea82-db74-4ffa-b7ed-c149e2352e9a	ea103e7f-9d16-4a5b-a117-1dcd65c70ef2
31c9cf7b-0726-4ef5-96c8-a93757aa21a0	497e8d74-14c2-401e-bc0d-a4b473f77eb1	http://dl.dropbox.com/u/28303770/donnees%20EPLS%20mise%20en%20service%20%281%29.zip	XML			0	active	fc63ab3d-50cd-4753-9ff3-12aa14ce6692	31c9cf7b-0726-4ef5-96c8-a93757aa21a0
f379f840-f21c-47ee-8310-41daed42deb4	1cf46091-d128-4e38-a7b7-97901d423aaf	http://datablog.owni.fr/files/2011/06/conseil_constitutionel.csv	CSV	Toutes les décisions du Conseil Constitutionnel entre nov 1958 et mai 2011		0	active	66b128d0-c36c-48b8-a78a-92b6182586d1	f379f840-f21c-47ee-8310-41daed42deb4
e3cde4c3-1e43-4c40-9aa1-a28c61c41334	ece794a5-613f-4607-9046-fb37906f87ce	http://www.culture.gouv.fr/mcc/content/download/6761/46206/file/March%C3%A9s%20%20MCC%20%20notifi%C3%A9s%20en%202009%20VERSION%20A%20PUBLIER.pdf	PDF	Liste des marchés publics notifiés par le Ministère de la Culture et de la Communication en 2009		0	active	1cc6d560-7a4a-4505-81e8-290e440c9c0b	e3cde4c3-1e43-4c40-9aa1-a28c61c41334
006c185b-ca0f-4191-9947-2f3a7a3f0e49	d794f07a-06d3-4b59-a969-c00af70ff8db	http://www.culture.gouv.fr/mcc/content/download/10613/71013/file/Liste%20des%20march%C3%A9s%20notifi%C3%A9s%20par%20le%20MCC%20en%202010%20(publication%20internet%20avril%20201)-2.xls	XLS	Liste des marchés publics notifiés par le Ministère de la Culture et de la Communication en 2010 (source XLS)		0	active	5ec1bdc2-fcbf-4932-b6a6-247c87ed9377	006c185b-ca0f-4191-9947-2f3a7a3f0e49
fd1abd08-2096-496f-95cf-32fa966251ab	d794f07a-06d3-4b59-a969-c00af70ff8db	http://www.nosdonnees.fr/wiki/images/9/9e/Liste_des_march%C3%A9s_notifi%C3%A9s_par_le_MCC_en_2010_%28publication_internet_avril_201%29.csv	CSV	Liste des marchés publics notifiés par le Ministère de la Culture et de la Communication en 2010 (conversion CSV)		2	active	5ec1bdc2-fcbf-4932-b6a6-247c87ed9377	fd1abd08-2096-496f-95cf-32fa966251ab
72124b3b-1399-44a7-bdb4-23e7f2e2aac7	d794f07a-06d3-4b59-a969-c00af70ff8db	http://www.nosdonnees.fr/wiki/images/c/c1/Liste_des_march%C3%A9s_notifi%C3%A9s_par_le_MCC_en_2010_%28publication_internet_avril_201%29.ods	ODS	Liste des marchés publics notifiés par le Ministère de la Culture et de la Communication en 2010 (conversion ODS)		1	active	5ec1bdc2-fcbf-4932-b6a6-247c87ed9377	72124b3b-1399-44a7-bdb4-23e7f2e2aac7
18a000fb-8a1c-4d83-931b-2840f653e83d	5efedd90-782d-4129-8e71-fdd3b6e1c7df	http://www.culture.gouv.fr/mcc/content/download/6763/46214/file/recencement_marches%20_CdA_mcc2007.pdf	PDF	Liste des marchés publics notifiés par le Ministère de la Culture et de la Communication en 2007		0	active	195959a3-77de-4e3d-95e4-8c5989ddd65d	18a000fb-8a1c-4d83-931b-2840f653e83d
45bcec2c-3abd-4cf7-96f2-0f80d357a11a	f1261a91-9d52-4520-837e-e9c793f28dcc	http://www.culture.gouv.fr/mcc/content/download/6762/46210/file/Liste_Marches-MCC%202008-2.pdf	PDF	Liste des marchés publics notifiés par le Ministère de la Culture et de la Communication en 2008		0	active	df459aea-8e94-463f-835f-cdcd6ec1327c	45bcec2c-3abd-4cf7-96f2-0f80d357a11a
3af3f271-92e9-43ab-8476-c008c46620e0	6968ef13-1d2f-4de3-b533-706bc9c0f604	http://elections.regardscitoyens.org/etrac/browser/elections/trunk	csv			0	active	3731e364-32f0-4a8c-924a-1c94cc311553	3af3f271-92e9-43ab-8476-c008c46620e0
c207867d-b17e-434c-a57d-c180ba9fb5c4	4402487d-3e8d-4618-8444-b400c6337834	http://www.impots.gouv.fr/portal/deploiement/p1/fichedescriptive_5582/fichedescriptive_5582.xls	XLS	Annee 2009		0	active	0906792a-0391-484a-a503-86206888bdc5	c207867d-b17e-434c-a57d-c180ba9fb5c4
aa16c60b-a6cf-4b5e-ac5d-045fdf46fa31	4402487d-3e8d-4618-8444-b400c6337834	http://www.impots.gouv.fr/portal/deploiement/p1/fichedescriptive_2395/fichedescriptive_2395.xls	XLS	Annee 2003		6	active	0906792a-0391-484a-a503-86206888bdc5	aa16c60b-a6cf-4b5e-ac5d-045fdf46fa31
a11f4723-404c-4b5d-a5ff-06a251945020	4402487d-3e8d-4618-8444-b400c6337834	http://www.impots.gouv.fr/portal/deploiement/p1/fichedescriptive_4691/fichedescriptive_4691.xls	XLS	Annee 2007		2	active	0906792a-0391-484a-a503-86206888bdc5	a11f4723-404c-4b5d-a5ff-06a251945020
92edcbb2-86d1-4783-9f3c-38e4801b6edb	4402487d-3e8d-4618-8444-b400c6337834	http://www.impots.gouv.fr/portal/deploiement/p1/fichedescriptive_4249/fichedescriptive_4249.xls	XLS	Annee 2006		3	active	0906792a-0391-484a-a503-86206888bdc5	92edcbb2-86d1-4783-9f3c-38e4801b6edb
4f155e76-54d3-4f49-abdf-8205986c2840	4402487d-3e8d-4618-8444-b400c6337834	http://www.impots.gouv.fr/portal/deploiement/p1/fichedescriptive_2989/fichedescriptive_2989.xls	XLS	Annee 2004		5	active	0906792a-0391-484a-a503-86206888bdc5	4f155e76-54d3-4f49-abdf-8205986c2840
0f2d4ba5-1ffd-4d24-a74e-7e9dcd2e6435	4402487d-3e8d-4618-8444-b400c6337834	http://www.impots.gouv.fr/portal/deploiement/p1/fichedescriptive_1377/fichedescriptive_1377.xls	XLS	Annee 2002		7	active	0906792a-0391-484a-a503-86206888bdc5	0f2d4ba5-1ffd-4d24-a74e-7e9dcd2e6435
cc57d829-8602-46a8-a186-5573b0b7f8da	4402487d-3e8d-4618-8444-b400c6337834	http://www.impots.gouv.fr/portal/deploiement/p1/fichedescriptive_5128/fichedescriptive_5128.xls	XLS	Annee 2008		1	active	0906792a-0391-484a-a503-86206888bdc5	cc57d829-8602-46a8-a186-5573b0b7f8da
09c2d352-aa6e-4ade-9631-3ef2b4837125	4402487d-3e8d-4618-8444-b400c6337834	http://www.impots.gouv.fr/portal/deploiement/p1/fichedescriptive_3725/fichedescriptive_3725.xls	XLS	Annee 2005		4	active	0906792a-0391-484a-a503-86206888bdc5	09c2d352-aa6e-4ade-9631-3ef2b4837125
493f3da8-3d38-4d3d-901d-f012ee6604f6	df63f81c-7a27-49d1-86c8-8d5e49883d40	http://asset.rue89.com/files/yanng/palmares_actu_reseaux_sociaux_ls.ods	ods			0	active	0f7316bd-5b12-443c-b846-ea48cd376a1c	493f3da8-3d38-4d3d-901d-f012ee6604f6
96937b63-9dd3-469f-9f45-2562b6f67a4b	8d9cf757-de83-4774-919b-00c45c43efd4	http://nkb.fr/temp/fichier_prenoms.csv	CSV	id, année, nombre de naissances, ID du prénom, prénom		0	active	657e1e1a-5a1b-40d4-b09c-61db5208662f	96937b63-9dd3-469f-9f45-2562b6f67a4b
ca62a914-c178-43f0-8ba6-02bd28af6626	196340e0-5246-4bc2-8b69-54c66a48b399	http://www.nosdonnees.fr/wiki/images/3/30/PJL2012-recettes-depenses.csv	CSV			0	active	1220be1d-b2b7-491a-a02a-708eb1f990d7	ca62a914-c178-43f0-8ba6-02bd28af6626
644aaae1-1f84-40ca-b147-614958f6f5a2	7f6c30c6-d6a5-4d39-ae5d-e1ae4cc2d3ef	http://opendata71interactive.cloudapp.net/DataBrowser/DownloadCsv?container=data&entitySet=Limites71&filter=NOFILTER	CSV	Tracé des limites du département de Saône et Loire (71)		0	active	fb039b32-eb70-48ac-8532-ac1572e12acc	644aaae1-1f84-40ca-b147-614958f6f5a2
3b773120-1293-4062-800e-381ba507589b	3c175c09-a896-4a88-9603-2b5ea27ef1a1	http://www.prevair.org/fr/observation_24.php		Observation des particules PM 10 - Non Accessible (Forbidden)		3	active	4cc259ea-31a7-46d3-9db1-9b93ce24ed27	3b773120-1293-4062-800e-381ba507589b
7301ba12-db82-4e95-9b19-1fca16f0541a	3c175c09-a896-4a88-9603-2b5ea27ef1a1	http://www.prevair.org/fr/observation_08.php		Observation de l'ozone - Non Accessible (Forbidden)		0	active	4cc259ea-31a7-46d3-9db1-9b93ce24ed27	7301ba12-db82-4e95-9b19-1fca16f0541a
d8cc9c41-b3cb-4e64-b711-2d624e1860fd	3c175c09-a896-4a88-9603-2b5ea27ef1a1	http://www.prevair.org/fr/observation_39.php		Observation des particules PM 2.5 - Non Accessible (Forbidden)		2	active	4cc259ea-31a7-46d3-9db1-9b93ce24ed27	d8cc9c41-b3cb-4e64-b711-2d624e1860fd
169ccf21-5657-472b-9c66-2e587d644de1	3c175c09-a896-4a88-9603-2b5ea27ef1a1	http://www.prevair.org/fr/observation_03.php		Observation du dioxyde d'azote - Non Accessible (Forbidden)		1	active	4cc259ea-31a7-46d3-9db1-9b93ce24ed27	169ccf21-5657-472b-9c66-2e587d644de1
a4e68efb-6fea-42b5-9d82-0fc46a842aea	cdc13d67-6360-43a6-bb99-cd68b64ee3f3	http://www.insee.fr/fr/ffc/figure/NATTEF01337.xls	XLS	Occupation physique du territoire de 1981 à 2009		0	active	081aa116-4b83-4ecc-b179-41fc2f9c398b	a4e68efb-6fea-42b5-9d82-0fc46a842aea
7b4d422d-fe6f-4ef8-b28e-c51a0a98cbb7	ac051eb3-275f-40a5-b160-e224d13902e7	http://dev.alphoenix.net/data/anciensMandatsDepute.csv	csv	Anciens mandats.		1	active	9bd678be-b57f-4582-9c02-1a5c106f9f2c	7b4d422d-fe6f-4ef8-b28e-c51a0a98cbb7
c56d0c7d-9003-43f9-adfc-51e82e663d40	ac051eb3-275f-40a5-b160-e224d13902e7	http://dev.alphoenix.net/data/deputes.csv	csv	Présentation des députés au 11 novembre.		0	active	9bd678be-b57f-4582-9c02-1a5c106f9f2c	c56d0c7d-9003-43f9-adfc-51e82e663d40
592337e6-a2d3-4966-a87c-e6d30e838362	67906f75-4298-4b6a-aa62-d8314be33f15	http://www.regardscitoyens.org/telechargement/confiseurs/scrutins-solennels-2010-2011.csv	CSV	Le fichier CSV proposé chiffre le nombre de scrutins auxquels chaque député a participé ou s'est fait représenter au cours de la session écoulée, en plus d'informations complémentaires relatives au mandat de chacun.		1	active	6e196cec-2bdc-4b09-b540-8d55debe949b	592337e6-a2d3-4966-a87c-e6d30e838362
9438bbee-c2f4-4e53-84b2-8b58c2c766b9	67906f75-4298-4b6a-aa62-d8314be33f15	http://www.regardscitoyens.org/telechargement/confiseurs/sanctions-commissions-2010-2011.csv	CSV	Nous avons établi la liste des députés qui correspond aux critères définis par le règlement. Les absences justifiées et valables au regard du règlement ont été prises en compte au regard des informations disponibles publiquement, et chacun des députés a été contacté individuellement en vue de vérifier l'oubli éventuel d'excuses. Le CSV contient une ligne par mois et par député concerné.		0	active	6e196cec-2bdc-4b09-b540-8d55debe949b	9438bbee-c2f4-4e53-84b2-8b58c2c766b9
4f6b567b-956b-4b0c-be15-a82a12385698	84b91384-8ec9-4b55-8dc9-28ff8c6db62f	http://data.nantes.fr/fileadmin/data/datastore/3-publication/culture/horaire_equip_culturels/horaire_equip_culturels_xls.zip	xls			1	active	e4086bee-133a-43fd-b352-10bacd65ee70	4f6b567b-956b-4b0c-be15-a82a12385698
20fb0508-dcf0-4aa9-a51f-7827a2991a37	84b91384-8ec9-4b55-8dc9-28ff8c6db62f	http://data.nantes.fr/fileadmin/data/datastore/3-publication/culture/horaire_equip_culturels/horaire_equip_culturels_csv.zip	csv			0	active	e4086bee-133a-43fd-b352-10bacd65ee70	20fb0508-dcf0-4aa9-a51f-7827a2991a37
20c5d699-31a3-4e5a-bbf1-8ee804b15864	1dacf074-ad54-432a-a04f-cecd3a068d0c	http://www.insee.fr/fr/ppp/bases-de-donnees/irweb/recme2010/dd/excel/recme2010_T2010.xls	xls			0	active	5c5b9cbd-eac0-40d0-86f0-0d9c9ae096b7	20c5d699-31a3-4e5a-bbf1-8ee804b15864
5b58d7da-f14f-4123-83ec-86e3c1732719	32ccab1e-e85e-4f52-84f5-69bbcc5fa53d	http://webstat.banque-france.fr/fr/quickviewexport.do?trans=&start=&end=&snapshot=&periodSortOrder=&SERIES_KEY=227.STS.M.SK.S.UNEH.RTT000.4.000&type=csv	CSV	Slovaquie depuis 1998Jan		15	active	10ac057b-4a62-4be2-9333-99cbb69c179a	5b58d7da-f14f-4123-83ec-86e3c1732719
364da824-6585-448f-8fe3-9da52645ab3c	32ccab1e-e85e-4f52-84f5-69bbcc5fa53d	http://webstat.banque-france.fr/fr/quickviewexport.do?trans=&start=&end=&snapshot=&periodSortOrder=&SERIES_KEY=227.STS.M.PT.S.UNEH.RTT000.4.000&type=csv	CSV	Portugal depuis 1983Jan		13	active	10ac057b-4a62-4be2-9333-99cbb69c179a	364da824-6585-448f-8fe3-9da52645ab3c
7a907047-be22-492e-8ab0-aed3c615f1b2	32ccab1e-e85e-4f52-84f5-69bbcc5fa53d	http://webstat.banque-france.fr/fr/quickviewexport.do?trans=&start=&end=&snapshot=&periodSortOrder=&SERIES_KEY=227.STS.M.LU.S.UNEH.RTT000.4.000&type=csv	CSV	Luxembourg depuis 1983Jan		10	active	10ac057b-4a62-4be2-9333-99cbb69c179a	7a907047-be22-492e-8ab0-aed3c615f1b2
30fcf5e6-2491-41b9-a54a-d3257689f9df	32ccab1e-e85e-4f52-84f5-69bbcc5fa53d	http://webstat.banque-france.fr/fr/quickviewexport.do?trans=&start=&end=&snapshot=&periodSortOrder=&SERIES_KEY=227.STS.M.GR.S.UNEH.RTT000.4.000&type=csv	CSV	Grèce depuis 1983Apr		7	active	10ac057b-4a62-4be2-9333-99cbb69c179a	30fcf5e6-2491-41b9-a54a-d3257689f9df
fc4a00da-6ad6-4391-8872-b82b374bc9d4	32ccab1e-e85e-4f52-84f5-69bbcc5fa53d	http://webstat.banque-france.fr/fr/quickviewexport.do?trans=&start=&end=&snapshot=&periodSortOrder=&SERIES_KEY=227.STS.M.BE.S.UNEH.RTT000.4.000&type=csv	CSV	Belgique depuis 1983Jan		1	active	10ac057b-4a62-4be2-9333-99cbb69c179a	fc4a00da-6ad6-4391-8872-b82b374bc9d4
fde8a3f9-df95-4d68-aac9-bb39d40b34bf	32ccab1e-e85e-4f52-84f5-69bbcc5fa53d	http://webstat.banque-france.fr/fr/quickviewexport.do?trans=&start=&end=&snapshot=&periodSortOrder=&SERIES_KEY=227.STS.M.I5.S.UNEH.RTT000.4.000&type=csv	CSV	Zone euro (16 pays) depuis 1995Jan		16	active	10ac057b-4a62-4be2-9333-99cbb69c179a	fde8a3f9-df95-4d68-aac9-bb39d40b34bf
eaec3754-b0ba-40d5-b793-816ecdc49266	32ccab1e-e85e-4f52-84f5-69bbcc5fa53d	http://webstat.banque-france.fr/fr/quickviewexport.do?trans=&start=&end=&snapshot=&periodSortOrder=&SERIES_KEY=227.STS.M.FR.S.UNEH.RTT000.4.000&type=csv	CSV	France depuis 1983Jan		6	active	10ac057b-4a62-4be2-9333-99cbb69c179a	eaec3754-b0ba-40d5-b793-816ecdc49266
d297586a-fde8-47f0-8692-0fd62d285e85	32ccab1e-e85e-4f52-84f5-69bbcc5fa53d	http://webstat.banque-france.fr/fr/quickviewexport.do?trans=&start=&end=&snapshot=&periodSortOrder=&SERIES_KEY=227.STS.M.CY.S.UNEH.RTT000.4.000&type=csv	CSV	Chypre depuis 2000Jan		2	active	10ac057b-4a62-4be2-9333-99cbb69c179a	d297586a-fde8-47f0-8692-0fd62d285e85
a1a48f6e-427e-41bf-8df9-80c974aa805e	32ccab1e-e85e-4f52-84f5-69bbcc5fa53d	http://webstat.banque-france.fr/fr/quickviewexport.do?trans=&start=&end=&snapshot=&periodSortOrder=&SERIES_KEY=227.STS.M.NL.S.UNEH.RTT000.4.000&type=csv	CSV	Pays-Bas depuis 1983Jan		12	active	10ac057b-4a62-4be2-9333-99cbb69c179a	a1a48f6e-427e-41bf-8df9-80c974aa805e
9c6a6794-93f5-4871-9936-50a06a985590	32ccab1e-e85e-4f52-84f5-69bbcc5fa53d	http://webstat.banque-france.fr/fr/quickviewexport.do?trans=&start=&end=&snapshot=&periodSortOrder=&SERIES_KEY=227.STS.M.AT.S.UNEH.RTT000.4.000&type=csv	CSV	Autriche depuis 1993Jan		0	active	10ac057b-4a62-4be2-9333-99cbb69c179a	9c6a6794-93f5-4871-9936-50a06a985590
293d927e-416e-4176-8afc-c2713306145f	32ccab1e-e85e-4f52-84f5-69bbcc5fa53d	http://webstat.banque-france.fr/fr/quickviewexport.do?trans=&start=&end=&snapshot=&periodSortOrder=&SERIES_KEY=227.STS.M.IT.S.UNEH.RTT000.4.000&type=csv	CSV	Italie depuis 1983Jan		9	active	10ac057b-4a62-4be2-9333-99cbb69c179a	293d927e-416e-4176-8afc-c2713306145f
6fd368b7-9c32-4e9d-94e8-3a0bed185810	32ccab1e-e85e-4f52-84f5-69bbcc5fa53d	http://webstat.banque-france.fr/fr/quickviewexport.do?trans=&start=&end=&snapshot=&periodSortOrder=&SERIES_KEY=227.STS.M.IE.S.UNEH.RTT000.4.000&type=csv	CSV	Irlande depuis 1983Jan		8	active	10ac057b-4a62-4be2-9333-99cbb69c179a	6fd368b7-9c32-4e9d-94e8-3a0bed185810
1a8b0021-b1d2-484f-acdc-df3136e11e03	32ccab1e-e85e-4f52-84f5-69bbcc5fa53d	http://webstat.banque-france.fr/fr/quickviewexport.do?trans=&start=&end=&snapshot=&periodSortOrder=&SERIES_KEY=227.STS.M.DE.S.UNEH.RTT000.4.000&type=csv	CSV	Allemagne depuis 1991Jan		3	active	10ac057b-4a62-4be2-9333-99cbb69c179a	1a8b0021-b1d2-484f-acdc-df3136e11e03
ddf72517-ade1-4186-a8dc-bcbb446ae959	32ccab1e-e85e-4f52-84f5-69bbcc5fa53d	http://webstat.banque-france.fr/fr/quickviewexport.do?trans=&start=&end=&snapshot=&periodSortOrder=&SERIES_KEY=227.STS.M.SI.S.UNEH.RTT000.4.000&type=csv	CSV	Slovénie depuis 1996Jan		14	active	10ac057b-4a62-4be2-9333-99cbb69c179a	ddf72517-ade1-4186-a8dc-bcbb446ae959
dc771d7c-1b2b-4786-85d2-593b85c8541c	32ccab1e-e85e-4f52-84f5-69bbcc5fa53d	http://webstat.banque-france.fr/fr/quickviewexport.do?trans=&start=&end=&snapshot=&periodSortOrder=&SERIES_KEY=227.STS.M.ES.S.UNEH.RTT000.4.000&type=csv	CSV	Espagne depuis 1986Apr		4	active	10ac057b-4a62-4be2-9333-99cbb69c179a	dc771d7c-1b2b-4786-85d2-593b85c8541c
06e11e20-eb0b-405a-b8dc-61ed781f4485	32ccab1e-e85e-4f52-84f5-69bbcc5fa53d	http://webstat.banque-france.fr/fr/quickviewexport.do?trans=&start=&end=&snapshot=&periodSortOrder=&SERIES_KEY=227.STS.M.FI.S.UNEH.RTT000.4.000&type=csv	CSV	Finlande depuis 1988Jan		5	active	10ac057b-4a62-4be2-9333-99cbb69c179a	06e11e20-eb0b-405a-b8dc-61ed781f4485
15ea33df-7329-49c8-87c1-37f4773a542b	32ccab1e-e85e-4f52-84f5-69bbcc5fa53d	http://webstat.banque-france.fr/fr/quickviewexport.do?trans=&start=&end=&snapshot=&periodSortOrder=&SERIES_KEY=227.STS.M.MT.S.UNEH.RTT000.4.000&type=csv	CSV	Malte depuis 2000Jan		11	active	10ac057b-4a62-4be2-9333-99cbb69c179a	15ea33df-7329-49c8-87c1-37f4773a542b
b4d8c812-a009-496d-9121-a19280f4983f	89a894cc-c5c8-44e2-9ca3-85ab9a0130f9	https://docs.google.com/spreadsheet/ccc?key=0AvW9Q_v2XAGTdDd0cHQyazhSMFZRcWJjX1hHbmxpdkE#gid=0	CSV	Google spreadsheet exportable		0	active	d7f22ef7-54bb-4348-b287-62fcb6da90f0	b4d8c812-a009-496d-9121-a19280f4983f
d4194aa4-b21e-41e0-b52c-16acc9f2581f	159b6644-94ed-406d-8e1e-1f002f265396	http://data.nantes.fr/fileadmin/data/datastore/3-publication/citoyennete/prenoms_enfants_nantes/prenoms_enfants_nantes_2010_xls.zip	xls	8 kb		1	active	502b47d9-44a6-4b77-8f21-1f36c2d6eeb9	d4194aa4-b21e-41e0-b52c-16acc9f2581f
acf62651-c3af-4581-83a1-a9ad2b35d0d4	159b6644-94ed-406d-8e1e-1f002f265396	http://data.nantes.fr/fileadmin/data/datastore/3-publication/citoyennete/prenoms_enfants_nantes/prenoms_enfants_nantes_2010_csv.zip	csv	2 kb		0	active	502b47d9-44a6-4b77-8f21-1f36c2d6eeb9	acf62651-c3af-4581-83a1-a9ad2b35d0d4
87c76e70-8296-4e56-b77b-19b1b472b91d	be516eed-8a37-436c-af75-b623f0806f39	http://www.bison-fute.equipement.gouv.fr/diffusions/datex2/base/lille_mvs/TraficStatus_cigt_allegro_maintenant.xml	xml	Lille		3	active	df68a822-74c8-41c1-8cfe-d0d1a685c74f	87c76e70-8296-4e56-b77b-19b1b472b91d
f1e8d998-b7d5-4a11-83d3-73ae12ae0139	be516eed-8a37-436c-af75-b623f0806f39	http://www.bison-fute.equipement.gouv.fr/diffusions/datex2/base/savoie_mvs/TraficStatus_cigt_osiris_maintenant.xml	xml	Savoie		2	active	df68a822-74c8-41c1-8cfe-d0d1a685c74f	f1e8d998-b7d5-4a11-83d3-73ae12ae0139
b447c99d-3c04-4bb4-9277-6a3d10a57900	be516eed-8a37-436c-af75-b623f0806f39	http://www.bison-fute.equipement.gouv.fr/diffusions/datex2/base/bordeaux_mvs/TraficStatus_cigt_alienor_maintenant.xml	format Datex 2 version 1.0, see http://www.datex2.eu/	Bordeaux		0	active	df68a822-74c8-41c1-8cfe-d0d1a685c74f	b447c99d-3c04-4bb4-9277-6a3d10a57900
ff78123f-ce9c-4f8f-a384-f412e2b3cd6a	be516eed-8a37-436c-af75-b623f0806f39	http://www.bison-fute.equipement.gouv.fr/diffusions/datex2/base/a20_mvs/TraficStatus_cigt_a20_maintenant.xml	xml	A20 Limoges - Chateauroux		5	active	df68a822-74c8-41c1-8cfe-d0d1a685c74f	ff78123f-ce9c-4f8f-a384-f412e2b3cd6a
987a685c-f95d-4de3-8bb2-4497e857e4ab	be516eed-8a37-436c-af75-b623f0806f39	http://www.bison-fute.equipement.gouv.fr/diffusions/datex2/base/rennes_mvs/TraficStatus_cigt_dor_breizh_maintenant.xml	xml	Rennes		11	active	df68a822-74c8-41c1-8cfe-d0d1a685c74f	987a685c-f95d-4de3-8bb2-4497e857e4ab
9eb393d9-7a87-4f98-a1f5-1c60ed9d622b	be516eed-8a37-436c-af75-b623f0806f39	http://www.bison-fute.equipement.gouv.fr/diffusions/datex2/base/caen_mvs/TraficStatus_cigt_caen_maintenant.xml	xml	Caen		4	active	df68a822-74c8-41c1-8cfe-d0d1a685c74f	9eb393d9-7a87-4f98-a1f5-1c60ed9d622b
5a11fbe5-6e3c-4414-be59-40a3d8a6ad2b	be516eed-8a37-436c-af75-b623f0806f39	http://www.bison-fute.equipement.gouv.fr/diffusions/datex2/base/a75_mvs/TraficStatus_a75_mivi_maintenant.xml	xml	A75 Clermont-Ferrand Béziers		7	active	df68a822-74c8-41c1-8cfe-d0d1a685c74f	5a11fbe5-6e3c-4414-be59-40a3d8a6ad2b
b37cf82c-cc7d-4e78-a479-62270e1e6464	be516eed-8a37-436c-af75-b623f0806f39	http://www.bison-fute.equipement.gouv.fr/diffusions/datex2/base/Nantes_mvs/TraficStatus_cigt_nantes_maintenant.xml	xml	Nantes		12	active	df68a822-74c8-41c1-8cfe-d0d1a685c74f	b37cf82c-cc7d-4e78-a479-62270e1e6464
8735d000-0454-42f9-85d4-810b25e52386	be516eed-8a37-436c-af75-b623f0806f39	http://www.bison-fute.equipement.gouv.fr/diffusions/datex2/base/strasbourg_mvs/TraficStatus_cigt_gutenberg_maintenant.xml	xml	Strasbourg		10	active	df68a822-74c8-41c1-8cfe-d0d1a685c74f	8735d000-0454-42f9-85d4-810b25e52386
68adc024-62ef-4098-905c-4ca07e73594f	be516eed-8a37-436c-af75-b623f0806f39	http://www.bison-fute.equipement.gouv.fr/diffusions/datex2/base/lyon_mvs/TraficStatus_cigt_coraly_maintenant.xml	xml	Lyon		6	active	df68a822-74c8-41c1-8cfe-d0d1a685c74f	68adc024-62ef-4098-905c-4ca07e73594f
2e2bda98-5653-45ba-821b-314a05da5194	be516eed-8a37-436c-af75-b623f0806f39	http://www.bison-fute.equipement.gouv.fr/diffusions/datex2/base/marseille_mvs/TraficStatus_cigt_marseille_maintenant.xml	xml	Marseille		1	active	df68a822-74c8-41c1-8cfe-d0d1a685c74f	2e2bda98-5653-45ba-821b-314a05da5194
7ae9942b-45a4-4ce9-bfd1-787fab948c4e	be516eed-8a37-436c-af75-b623f0806f39	http://www.bison-fute.equipement.gouv.fr/diffusions/datex2/base/stetienne_mvs/TraficStatus_cigt_stetienne_maintenant.xml	xml	Saint Etienne		8	active	df68a822-74c8-41c1-8cfe-d0d1a685c74f	7ae9942b-45a4-4ce9-bfd1-787fab948c4e
a7daff8a-0f74-470c-adb7-34df3db15a0e	be516eed-8a37-436c-af75-b623f0806f39	http://www.bison-fute.equipement.gouv.fr/diffusions/datex2/base/grenoble_mvs/TraficStatus_cigt_grenoble_maintenant.xml	xml	Grenoble		9	active	df68a822-74c8-41c1-8cfe-d0d1a685c74f	a7daff8a-0f74-470c-adb7-34df3db15a0e
7f852e30-0bad-4286-91d7-6cabdfdd960f	b9582bd1-bfff-41e1-990f-962c18084f4d	http://www.vpah.culture.fr/vpah/villes/pdf/liste_VPAH_2010.pdf	pdf	149 territoires labellisés, classés par région		0	active	a18e1408-fa8e-444d-bf0f-996db5a55463	7f852e30-0bad-4286-91d7-6cabdfdd960f
97c1a7cf-f804-4b6c-9c4b-13554270e3ce	fe7cd753-376f-4f22-a721-caa482aa1116	http://www.observatoire-saone.fr/index.php?id=96	pdf	différents téléchargements possibles		0	active	22c78088-f8e8-4d24-b35a-fc6c6c65ea47	97c1a7cf-f804-4b6c-9c4b-13554270e3ce
f11835eb-2bbd-455c-abca-bd0c368e2390	1dacf074-ad54-432a-a04f-cecd3a068d0c	http://www.insee.fr/fr/ppp/bases-de-donnees/irweb/recme2010/dd/dbase/recme2010_T2010.dbf	dbase			1	active	ee816bc2-0316-4adc-ac10-300df9306594	f11835eb-2bbd-455c-abca-bd0c368e2390
2d6672c3-dd68-4dc3-ada3-68abaa34cc99	df6c89f3-4473-424b-a0b0-119977da62c5	http://www.insee.fr/fr/methodes/nomenclatures/cog/telechargement/2011/txt/comsimp2011.zip	txt	Liste des communes existantes au 1er janvier 2011		0	active	177926cc-1263-4323-9dad-14032641b0a5	2d6672c3-dd68-4dc3-ada3-68abaa34cc99
55eb9b42-8a6e-4663-9f5e-f8ad5ac48c00	df6c89f3-4473-424b-a0b0-119977da62c5	http://www.insee.fr/fr/methodes/nomenclatures/cog/telechargement/2011/dbf/comsimp2011.zip	dbase	Liste des communes existantes au 1er janvier 2011		1	active	177926cc-1263-4323-9dad-14032641b0a5	55eb9b42-8a6e-4663-9f5e-f8ad5ac48c00
d3d68db0-d07a-4cec-8b75-a11ec77fd169	0460ea96-a830-40bd-adfb-140aad4c31ca	http://opendata.paris.fr/opendata/document?id=60&id_attribute=101	csv			1	active	2b5ac88c-ed8c-4fee-b013-103238447a18	d3d68db0-d07a-4cec-8b75-a11ec77fd169
aae5b9b3-efeb-46c6-862d-519112a32ac7	0460ea96-a830-40bd-adfb-140aad4c31ca	http://opendata.paris.fr/opendata/document?id=60&id_attribute=64	xls			0	active	2b5ac88c-ed8c-4fee-b013-103238447a18	aae5b9b3-efeb-46c6-862d-519112a32ac7
8cbb9b0d-d508-404e-a510-d70eef8e2f9f	0460ea96-a830-40bd-adfb-140aad4c31ca	http://opendata.paris.fr/opendata/document?id=60&id_attribute=103	ods			2	active	2b5ac88c-ed8c-4fee-b013-103238447a18	8cbb9b0d-d508-404e-a510-d70eef8e2f9f
acf62651-c3af-4581-83a1-a9ad2b35d0d4	159b6644-94ed-406d-8e1e-1f002f265396	http://data.nantes.fr/fileadmin/data/datastore/3-publication/citoyennete/prenoms_enfants_nantes/prenoms_enfants_nantes_2010_csv.zip	csv	2010		0	active	d8097172-e1a3-4d79-b40a-3c3ec12be908	acf62651-c3af-4581-83a1-a9ad2b35d0d4
bce33048-e8f0-4778-959a-18cfa66eb1dd	159b6644-94ed-406d-8e1e-1f002f265396	http://data.nantes.fr/fileadmin/data/datastore/3-publication/citoyennete/prenoms_enfants_nantes/prenoms_enfants_nantes_2003_csv.zip	csv	2003		14	active	d8097172-e1a3-4d79-b40a-3c3ec12be908	bce33048-e8f0-4778-959a-18cfa66eb1dd
d4194aa4-b21e-41e0-b52c-16acc9f2581f	159b6644-94ed-406d-8e1e-1f002f265396	http://data.nantes.fr/fileadmin/data/datastore/3-publication/citoyennete/prenoms_enfants_nantes/prenoms_enfants_nantes_2010_xls.zip	xls	2010		1	active	d8097172-e1a3-4d79-b40a-3c3ec12be908	d4194aa4-b21e-41e0-b52c-16acc9f2581f
9090d793-9c60-440a-baef-3f3a9a1ef305	159b6644-94ed-406d-8e1e-1f002f265396	http://data.nantes.fr/fileadmin/data/datastore/3-publication/citoyennete/prenoms_enfants_nantes/prenoms_enfants_nantes_2006_xls.zip	xls	2006		9	active	d8097172-e1a3-4d79-b40a-3c3ec12be908	9090d793-9c60-440a-baef-3f3a9a1ef305
6f6806fb-b908-4076-9bf9-9d050d48c103	159b6644-94ed-406d-8e1e-1f002f265396	http://data.nantes.fr/fileadmin/data/datastore/3-publication/citoyennete/prenoms_enfants_nantes/prenoms_enfants_nantes_2002_xls.zip	xls	2002		17	active	d8097172-e1a3-4d79-b40a-3c3ec12be908	6f6806fb-b908-4076-9bf9-9d050d48c103
50051982-d08d-49a4-9e6e-802e90bc99a2	159b6644-94ed-406d-8e1e-1f002f265396	http://data.nantes.fr/fileadmin/data/datastore/3-publication/citoyennete/prenoms_enfants_nantes/prenoms_enfants_nantes_2009_xls.zip	xls	2009		3	active	d8097172-e1a3-4d79-b40a-3c3ec12be908	50051982-d08d-49a4-9e6e-802e90bc99a2
77cfdb9c-7509-4eb9-ae89-f139fc707cd2	159b6644-94ed-406d-8e1e-1f002f265396	http://data.nantes.fr/fileadmin/data/datastore/3-publication/citoyennete/prenoms_enfants_nantes/prenoms_enfants_nantes_2006_csv.zip	csv	2006		8	active	d8097172-e1a3-4d79-b40a-3c3ec12be908	77cfdb9c-7509-4eb9-ae89-f139fc707cd2
d4564cc0-ddd4-4c81-b93e-c4af2eabcb53	159b6644-94ed-406d-8e1e-1f002f265396	http://data.nantes.fr/fileadmin/data/datastore/3-publication/citoyennete/prenoms_enfants_nantes/prenoms_enfants_nantes_2001_csv.zip	csv	2001		18	active	d8097172-e1a3-4d79-b40a-3c3ec12be908	d4564cc0-ddd4-4c81-b93e-c4af2eabcb53
4b587ae6-be12-493d-ad87-78b82031ce56	159b6644-94ed-406d-8e1e-1f002f265396	http://data.nantes.fr/fileadmin/data/datastore/3-publication/citoyennete/prenoms_enfants_nantes/prenoms_enfants_nantes_2004_xls.zip	xls	2004		13	active	d8097172-e1a3-4d79-b40a-3c3ec12be908	4b587ae6-be12-493d-ad87-78b82031ce56
c46e5cd4-1348-4124-9f0a-e4f824216729	159b6644-94ed-406d-8e1e-1f002f265396	http://data.nantes.fr/fileadmin/data/datastore/3-publication/citoyennete/prenoms_enfants_nantes/prenoms_enfants_nantes_2005_xls.zip	xls	2005		11	active	d8097172-e1a3-4d79-b40a-3c3ec12be908	c46e5cd4-1348-4124-9f0a-e4f824216729
112629f9-6448-47ca-ab6d-3d7200a95890	159b6644-94ed-406d-8e1e-1f002f265396	http://data.nantes.fr/fileadmin/data/datastore/3-publication/citoyennete/prenoms_enfants_nantes/prenoms_enfants_nantes_2005_csv.zip	csv	2005		10	active	d8097172-e1a3-4d79-b40a-3c3ec12be908	112629f9-6448-47ca-ab6d-3d7200a95890
10124181-5ac0-4a86-b202-c012b333361a	159b6644-94ed-406d-8e1e-1f002f265396	http://data.nantes.fr/fileadmin/data/datastore/3-publication/citoyennete/prenoms_enfants_nantes/prenoms_enfants_nantes_2002_csv.zip	csv	2002		16	active	d8097172-e1a3-4d79-b40a-3c3ec12be908	10124181-5ac0-4a86-b202-c012b333361a
e1ffad24-2e39-46a0-a747-6d0f00284b74	159b6644-94ed-406d-8e1e-1f002f265396	http://data.nantes.fr/fileadmin/data/datastore/3-publication/citoyennete/prenoms_enfants_nantes/prenoms_enfants_nantes_2003_xls.zip	xls	2003		15	active	d8097172-e1a3-4d79-b40a-3c3ec12be908	e1ffad24-2e39-46a0-a747-6d0f00284b74
020e6e0b-5a62-4599-8c42-6c1265b1ac11	159b6644-94ed-406d-8e1e-1f002f265396	http://data.nantes.fr/fileadmin/data/datastore/3-publication/citoyennete/prenoms_enfants_nantes/prenoms_enfants_nantes_2008_xls.zip	xls	2008		5	active	d8097172-e1a3-4d79-b40a-3c3ec12be908	020e6e0b-5a62-4599-8c42-6c1265b1ac11
c92f92d8-e4f1-41fa-b9cd-bb7a31c9eeb9	159b6644-94ed-406d-8e1e-1f002f265396	http://data.nantes.fr/fileadmin/data/datastore/3-publication/citoyennete/prenoms_enfants_nantes/prenoms_enfants_nantes_2009_csv.zip	csv	2009		2	active	d8097172-e1a3-4d79-b40a-3c3ec12be908	c92f92d8-e4f1-41fa-b9cd-bb7a31c9eeb9
c56ece07-fd9d-48bf-97a4-3f61bab7fe2f	159b6644-94ed-406d-8e1e-1f002f265396	http://data.nantes.fr/fileadmin/data/datastore/3-publication/citoyennete/prenoms_enfants_nantes/prenoms_enfants_nantes_2007_xls.zip	xls	2007		7	active	d8097172-e1a3-4d79-b40a-3c3ec12be908	c56ece07-fd9d-48bf-97a4-3f61bab7fe2f
13acf9a5-9b7f-483b-b143-9e081a4b73f7	159b6644-94ed-406d-8e1e-1f002f265396	http://data.nantes.fr/fileadmin/data/datastore/3-publication/citoyennete/prenoms_enfants_nantes/prenoms_enfants_nantes_2004_csv.zip	csv	2004		12	active	d8097172-e1a3-4d79-b40a-3c3ec12be908	13acf9a5-9b7f-483b-b143-9e081a4b73f7
5a211aac-efd2-417e-8d73-4e1a37340279	159b6644-94ed-406d-8e1e-1f002f265396	http://data.nantes.fr/fileadmin/data/datastore/3-publication/citoyennete/prenoms_enfants_nantes/prenoms_enfants_nantes_2001_xls.zip	xls	2001		19	active	d8097172-e1a3-4d79-b40a-3c3ec12be908	5a211aac-efd2-417e-8d73-4e1a37340279
94e71a48-b19a-49d0-ae23-4719259d90ea	159b6644-94ed-406d-8e1e-1f002f265396	http://data.nantes.fr/fileadmin/data/datastore/3-publication/citoyennete/prenoms_enfants_nantes/prenoms_enfants_nantes_2008_csv.zip	csv	2008		4	active	d8097172-e1a3-4d79-b40a-3c3ec12be908	94e71a48-b19a-49d0-ae23-4719259d90ea
ceac9814-0b60-49ee-9715-c868c4c8ab60	159b6644-94ed-406d-8e1e-1f002f265396	http://data.nantes.fr/fileadmin/data/datastore/3-publication/citoyennete/prenoms_enfants_nantes/prenoms_enfants_nantes_2007_csv.zip	csv	2007		6	active	d8097172-e1a3-4d79-b40a-3c3ec12be908	ceac9814-0b60-49ee-9715-c868c4c8ab60
e6831011-9e1e-4f33-954f-4ebe756f8dad	641c249c-f473-4d8e-bd8e-f385157f2682	http://www.sisfrance.net/Antilles/export_liste_epicentres.asp	txt	épicentres des séismes aux Antilles françaises et dans l'archipel des Caraïbes		1	active	903899a1-b57f-44c8-9818-15fc47ead4da	e6831011-9e1e-4f33-954f-4ebe756f8dad
1e943df7-a3d1-4ce8-ac5e-a9420d4b1cdb	641c249c-f473-4d8e-bd8e-f385157f2682	http://www.sisfrance.net/Caledonie/export_liste_epicentres.asp	txt	épicentres des séismes en Nouvelle-Calédonie et à Wallis et Futuna		3	active	903899a1-b57f-44c8-9818-15fc47ead4da	1e943df7-a3d1-4ce8-ac5e-a9420d4b1cdb
40a20fc9-25d7-4ff3-9265-8270936f6921	641c249c-f473-4d8e-bd8e-f385157f2682	http://www.sisfrance.net/Reunion/export_liste_epicentres.asp	txt	épicentres des séismes à la Réunion et à Mayotte		2	active	903899a1-b57f-44c8-9818-15fc47ead4da	40a20fc9-25d7-4ff3-9265-8270936f6921
e934456c-6d6e-433a-84f3-468e90e9fbff	fea6dcd6-00d6-4ad5-ab2f-eb40f533a5db	http://www.nosdonnees.fr/wiki/images/0/0c/Regions_departements_circonscriptions_communes_gps.csv.gz	CSV	code_région;nom_région;chef-lieu_région;numéro_département;nom_département;préfecture;numéro_circonscription;nom_commune;codes_postaux;code_insee;la titude;longitude;éloignement		0	active	cc7f9237-21a1-4e74-ac5f-5cfa6dc1c499	e934456c-6d6e-433a-84f3-468e90e9fbff
e934456c-6d6e-433a-84f3-468e90e9fbff	fea6dcd6-00d6-4ad5-ab2f-eb40f533a5db	http://www.nosdonnees.fr/wiki/images/0/0c/Regions_departements_circonscriptions_communes_gps.csv.gz	CSV	code_région ; nom_région ; chef-lieu_région ; numéro_département ; nom_département ; préfecture ; numéro_circonscription ; nom_commune ; codes_postaux ; code_insee ; la titude ; longitude ; éloignement		0	active	cdcfa48c-0892-463b-8f68-ff3be6344f9b	e934456c-6d6e-433a-84f3-468e90e9fbff
2adc1ae6-f4a1-44e6-aec9-a8adee23176c	de5557e1-bf16-433b-87ff-401323a97df5	http://www.regardscitoyens.org/telechargement/donnees_publiques/resultats_elections_legislatives_2002.tgz	csv	csv gzipé		0	active	9f2365d7-35db-4301-8a4c-351671cc2694	2adc1ae6-f4a1-44e6-aec9-a8adee23176c
448b7da1-2f8b-4596-b366-e92de05b7254	47034ede-0506-4650-9fb4-1948168440ca	http://www.regardscitoyens.org/telechargement/donnees_publiques/resultats_elections_presidentielles_2002.tgz	csv	csv gzipé		0	active	db2345f0-bd43-4f1d-b50d-c263b791d1c2	448b7da1-2f8b-4596-b366-e92de05b7254
c90de3de-5853-4226-9d25-c698141266db	bfd1388a-ec10-4a7b-9d94-916f56f52f98	http://www.debug-data-gouv.fr/data.gouv.fr.csv	csv			0	active	5037ad29-b65d-490a-bd23-d79c405ec466	c90de3de-5853-4226-9d25-c698141266db
a446006c-1c42-4fad-9e7b-04d6f278a8e2	8708a912-1b80-441d-9ba3-d607dd2f0c7c	https://gitorious.org/sharedscrapers/orthonantes/blobs/raw/master/data/orthonantes.csv	CSV	Ville et url des zip contenant les tuiles		0	active	153a48b3-24af-44e4-ab07-9d5610e890da	a446006c-1c42-4fad-9e7b-04d6f278a8e2
284f33e1-39d2-464d-bf04-4b7f4a2f869d	25dd2269-e0f3-4653-98ac-33f64f09d4d3	http://www.nosdonnees.fr/wiki/images/e/ed/Circonscriptions.csv	CSV	nom_dptmt;num_dptmt;num_circo;composition		0	active	4bba233a-f5ab-48de-ab8d-8f9f386fbf77	284f33e1-39d2-464d-bf04-4b7f4a2f869d
2e95551a-1291-477d-987d-026ad1b5b136	b815db66-cadf-4c3c-ae0b-73ad5bf1a46e	http://www.nosdonnees.fr/wiki/images/1/1c/Circonscriptions-stats-insee.csv	CSV			0	active	78218970-639e-4d24-93ed-244cd4decfcb	2e95551a-1291-477d-987d-026ad1b5b136
74f8b2b3-d2e6-49c1-9ea5-23f7a6544372	b815db66-cadf-4c3c-ae0b-73ad5bf1a46e	http://www.insee.fr/fr/ppp/bases-de-donnees/donnees-detaillees/circo_leg/circo_leg-2012/tableau/circonscriptions.xls	XLS			1	active	78218970-639e-4d24-93ed-244cd4decfcb	74f8b2b3-d2e6-49c1-9ea5-23f7a6544372
a1009ace-9f3a-45d8-90cc-a8bab75762f1	275e4c19-2885-4630-b049-e365374c27fb	http://www.nosdonnees.fr/wiki/images/7/74/500_signatures_de_1995_%C3%A0_2007.csv.gz	csv	csv gzipé		0	active	35fc3cd3-516a-494d-b6fa-b82140444685	a1009ace-9f3a-45d8-90cc-a8bab75762f1
e934456c-6d6e-433a-84f3-468e90e9fbff	fea6dcd6-00d6-4ad5-ab2f-eb40f533a5db	http://www.nosdonnees.fr/wiki/images/b/b5/EUCircos_Regions_departements_circonscriptions_communes_gps.csv.gz	CSV	EUcirco_code_région ; nom_région ; chef-lieu_région ; numéro_département ; nom_département ; préfecture ; numéro_circonscription ; nom_commune ; codes_postaux ; code_insee ; la titude ; longitude ; éloignement		0	active	8412388c-5c82-452d-ad9e-3247056c0cd2	e934456c-6d6e-433a-84f3-468e90e9fbff
e934456c-6d6e-433a-84f3-468e90e9fbff	fea6dcd6-00d6-4ad5-ab2f-eb40f533a5db	http://www.nosdonnees.fr/wiki/images/b/b5/EUCircos_Regions_departements_circonscriptions_communes_gps.csv.gz	CSV	EUcirco ; code_région ; nom_région ; chef-lieu_région ; numéro_département ; nom_département ; préfecture ; numéro_circonscription ; nom_commune ; codes_postaux ; code_insee ; la titude ; longitude ; éloignement		0	active	071df672-626c-420e-ad32-08320d35074e	e934456c-6d6e-433a-84f3-468e90e9fbff
6842912a-f556-42a7-ac48-54a1166a568d	1399fe4b-2c07-4bda-a720-9df928d51816	http://www.nosdonnees.fr/wiki/index.php/Image:Patrimoine_Nicolas_Sarkozy.csv	csv	Déclaration patrimoniale de Nicolas Sarkozy		0	active	46739a51-d0ab-416a-9dff-632a03351fcf	6842912a-f556-42a7-ac48-54a1166a568d
6842912a-f556-42a7-ac48-54a1166a568d	1399fe4b-2c07-4bda-a720-9df928d51816	http://www.nosdonnees.fr/wiki/images/c/ca/Patrimoine_Nicolas_Sarkozy.csv	csv	Déclaration patrimoniale de Nicolas Sarkozy		0	active	3cc87d4f-2cf8-4a02-877d-a84be8f8f7a6	6842912a-f556-42a7-ac48-54a1166a568d
2872cacf-f3dc-492a-b468-a3345d03c125	cea11492-fdec-4cfc-a179-a4bbc05cac0b	http://www.regardscitoyens.org/telechargement/presidentielles-2012/signatures_candidats_2012.csv	CSV	candidat;prénom;nom;sexe;fonction;localité;département;dept_num;n_sign;affiliation;profession		0	active	369831c1-22de-4dea-b0b7-b9a33cef2875	2872cacf-f3dc-492a-b468-a3345d03c125
4b93ae92-5b9c-4aa9-8d2e-d95465f01883	41b0a731-3378-42bd-9e08-8b69a1fee83a	http://komodo.regardscitoyens.org/public/presidentielles2012/resultats/resultats_departements_final_T1.csv	CSV	Résultats 2012 par département		1	active	0d252ab1-5819-41f4-af54-4036c3226e98	4b93ae92-5b9c-4aa9-8d2e-d95465f01883
b8b941af-8e05-4f97-b8a6-9f602dc9c3b3	41b0a731-3378-42bd-9e08-8b69a1fee83a	http://komodo.regardscitoyens.org/public/presidentielles2012/resultats/resultats_circonscriptions_T1.csv	CSV	Résultats 2012 par circonscription législative		3	active	0d252ab1-5819-41f4-af54-4036c3226e98	b8b941af-8e05-4f97-b8a6-9f602dc9c3b3
ddf49824-b994-480d-babb-7d9c47f8c942	41b0a731-3378-42bd-9e08-8b69a1fee83a	http://komodo.regardscitoyens.org/public/presidentielles2012/historique/participation.csv	CSV	Participation à midi et 17h en 2002, 2007 et 2012		0	active	0d252ab1-5819-41f4-af54-4036c3226e98	ddf49824-b994-480d-babb-7d9c47f8c942
ddfdce71-0fb8-4a10-902b-f8ea5acc2dc0	41b0a731-3378-42bd-9e08-8b69a1fee83a	http://komodo.regardscitoyens.org/public/presidentielles2012/resultats/resultats_communes_T1.csv.zip	CSV	Résultats 2012 par commune		2	active	0d252ab1-5819-41f4-af54-4036c3226e98	ddfdce71-0fb8-4a10-902b-f8ea5acc2dc0
525a38fa-ef24-4661-a420-eedfe1d8be25	c4556598-bcc7-4c45-8ae8-bdafc367eaa2	http://komodo.regardscitoyens.org/public/presidentielles2012/resultats/Presidentielle_2012_Resultats_Valides.zip	zip csv utf8	CSV encodés en utf8 avec séparateur ;		0	active	16ca20be-8985-498c-a6b3-29ecc4358399	525a38fa-ef24-4661-a420-eedfe1d8be25
0723ace3-0f7b-441c-9125-0fb8626f6944	41b0a731-3378-42bd-9e08-8b69a1fee83a	http://komodo.regardscitoyens.org/public/presidentielles2012/resultats/Presidentielle_2012_Resultats_Valides.zip	CSV	Résultats 2012 validé par le conseil constitutionnel par commune pour la france et par circo pour les français de l'étranger (UTF8, séparateur ;)		4	active	99b202f2-e5fe-4e54-beed-2722204ba204	0723ace3-0f7b-441c-9125-0fb8626f6944
4b93ae92-5b9c-4aa9-8d2e-d95465f01883	41b0a731-3378-42bd-9e08-8b69a1fee83a	http://komodo.regardscitoyens.org/public/presidentielles2012/resultats/resultats_departements_final_T1.csv	CSV	Résultats 2012 par département		3	deleted	1abb1bc3-9af2-4d48-ac1f-6ecbb7b8f3d0	4b93ae92-5b9c-4aa9-8d2e-d95465f01883
ddfdce71-0fb8-4a10-902b-f8ea5acc2dc0	41b0a731-3378-42bd-9e08-8b69a1fee83a	http://komodo.regardscitoyens.org/public/presidentielles2012/resultats/resultats_communes_T1.csv.zip	CSV	Résultats 2012 par commune		4	deleted	1abb1bc3-9af2-4d48-ac1f-6ecbb7b8f3d0	ddfdce71-0fb8-4a10-902b-f8ea5acc2dc0
b8b941af-8e05-4f97-b8a6-9f602dc9c3b3	41b0a731-3378-42bd-9e08-8b69a1fee83a	http://komodo.regardscitoyens.org/public/presidentielles2012/resultats/resultats_circonscriptions_T1.csv	CSV	Résultats 2012 par circonscription législative		1	active	1abb1bc3-9af2-4d48-ac1f-6ecbb7b8f3d0	b8b941af-8e05-4f97-b8a6-9f602dc9c3b3
0723ace3-0f7b-441c-9125-0fb8626f6944	41b0a731-3378-42bd-9e08-8b69a1fee83a	http://komodo.regardscitoyens.org/public/presidentielles2012/resultats/Presidentielle_2012_Resultats_Valides.zip	CSV	Résultats des deux tours validé par le conseil constitutionnel par commune pour la france et par circo pour les français de l'étranger (UTF8, séparateur ;)		2	active	1abb1bc3-9af2-4d48-ac1f-6ecbb7b8f3d0	0723ace3-0f7b-441c-9125-0fb8626f6944
f2a6bbe4-422e-4ae2-8dab-ecc4221043c2	41b0a731-3378-42bd-9e08-8b69a1fee83a	http://komodo.regardscitoyens.org/public/presidentielles2012/resultats/Presidentielle_2012_Resultats_Valides.zip	CSV	Résultats des deux tours validé par le conseil constitutionnel par commune pour la france et par circo pour les français de l'étranger (UTF8, séparateur ;)		3	active	f47561d1-b04c-4969-bdc1-06cef53149e5	f2a6bbe4-422e-4ae2-8dab-ecc4221043c2
4b93ae92-5b9c-4aa9-8d2e-d95465f01883	41b0a731-3378-42bd-9e08-8b69a1fee83a	http://komodo.regardscitoyens.org/public/presidentielles2012/resultats/resultats_departements_final_T1.csv	CSV	Résultats 2012 par département		4	deleted	f47561d1-b04c-4969-bdc1-06cef53149e5	4b93ae92-5b9c-4aa9-8d2e-d95465f01883
b8b941af-8e05-4f97-b8a6-9f602dc9c3b3	41b0a731-3378-42bd-9e08-8b69a1fee83a	http://komodo.regardscitoyens.org/public/presidentielles2012/resultats/resultats_circonscriptions_T1.csv	CSV	Résultats 2012 par circonscription législative (tour 1 - avant CC)		1	active	f47561d1-b04c-4969-bdc1-06cef53149e5	b8b941af-8e05-4f97-b8a6-9f602dc9c3b3
ddfdce71-0fb8-4a10-902b-f8ea5acc2dc0	41b0a731-3378-42bd-9e08-8b69a1fee83a	http://komodo.regardscitoyens.org/public/presidentielles2012/resultats/resultats_communes_T1.csv.zip	CSV	Résultats 2012 par commune		5	deleted	f47561d1-b04c-4969-bdc1-06cef53149e5	ddfdce71-0fb8-4a10-902b-f8ea5acc2dc0
0723ace3-0f7b-441c-9125-0fb8626f6944	41b0a731-3378-42bd-9e08-8b69a1fee83a	http://komodo.regardscitoyens.org/public/presidentielles2012/resultats/resultats_circonscriptions_T2.csv	CSV	Résultats 2012 par circonscription législative (tour 2 - avant CC)		2	active	f47561d1-b04c-4969-bdc1-06cef53149e5	0723ace3-0f7b-441c-9125-0fb8626f6944
0723ace3-0f7b-441c-9125-0fb8626f6944	41b0a731-3378-42bd-9e08-8b69a1fee83a	http://komodo.regardscitoyens.org/public/presidentielles2012/resultats/Presidentielle_2012_T2_CirconscriptionLégislatives.csv	CSV	Résultats 2012 par circonscription législative (tour 2 - avant CC)		2	active	5c5d0f67-78c8-4431-8adc-11ee6652d158	0723ace3-0f7b-441c-9125-0fb8626f6944
525a38fa-ef24-4661-a420-eedfe1d8be25	c4556598-bcc7-4c45-8ae8-bdafc367eaa2	http://komodo.regardscitoyens.org/public/presidentielles2012/resultats/Presidentielle_2012_Rncodés en utf8 avec séparateur ;esultats_Valides.zip	zip csv utf8	CSV encodés en utf8 avec séparateur ;		0	active	bc6d4de3-006e-4b29-8a65-5f884d994708	525a38fa-ef24-4661-a420-eedfe1d8be25
f2a6bbe4-422e-4ae2-8dab-ecc4221043c2	41b0a731-3378-42bd-9e08-8b69a1fee83a	http://komodo.regardscitoyens.org/public/presidentielles2012/resultats/Presidentielle_2012_Resultats_Valides.zip	CSV	Résultats des deux tours validés par le Conseil Constitutionnel par commune pour la France et par circonscription pour les français de l'étranger (UTF8, séparateur ;)		3	active	43600948-f915-4cc3-8ecf-3b1eca937184	f2a6bbe4-422e-4ae2-8dab-ecc4221043c2
6842912a-f556-42a7-ac48-54a1166a568d	1399fe4b-2c07-4bda-a720-9df928d51816	http://www.nosdonnees.fr/wiki/images/a/ad/Declarations_Patrimoine_Presidents.csv	csv	Déclarations patrimoniales des derniers présidents de la République		0	active	59317601-caee-4b10-bc04-8f4ce5006fcc	6842912a-f556-42a7-ac48-54a1166a568d
488d2dee-f5f7-412e-905d-004428f1cc4d	1399fe4b-2c07-4bda-a720-9df928d51816	http://www.nosdonnees.fr/wiki/images/c/ca/Patrimoine_Nicolas_Sarkozy.csv	csv	Déclaration patrimoniale de Nicolas Sarkozy		1	active	59317601-caee-4b10-bc04-8f4ce5006fcc	488d2dee-f5f7-412e-905d-004428f1cc4d
488d2dee-f5f7-412e-905d-004428f1cc4d	1399fe4b-2c07-4bda-a720-9df928d51816	http://www.nosdonnees.fr/wiki/images/c/ca/Patrimoine_Nicolas_Sarkozy.csv	csv	Déclaration patrimoniale de Nicolas Sarkozy (travail original de C. Le Moign)		1	active	11183ab6-8a61-4c67-848f-f51347641664	488d2dee-f5f7-412e-905d-004428f1cc4d
ffcada14-71c1-42ba-881e-bc660857075a	2a4bae91-082b-4ae5-9729-08c86e000ab5	http://www.regardscitoyens.org/documents/RegardsCitoyens-comptes.ods 	ODS			0	active	0a8e67c3-482a-4ef4-ac82-1a64eb975d4a	ffcada14-71c1-42ba-881e-bc660857075a
ffcada14-71c1-42ba-881e-bc660857075a	2a4bae91-082b-4ae5-9729-08c86e000ab5	http://www.regardscitoyens.org/documents/RegardsCitoyens-comptes.ods	ODS			0	active	133e9e8e-01da-481e-909d-367708fce0c2	ffcada14-71c1-42ba-881e-bc660857075a
91d76a3e-a85f-43f6-8011-ea55b5916479	cd42a806-cac1-452c-9b0d-116d8ead4d64	http://komodo.regardscitoyens.org/public/legislatives2012/candidats.csv	CSV	date_donnees;type_election;tour_election;annee_election;mois_election;jour_election;num_departement;code_departement;departement;num_circonscription;num_candidat;nom_candidat;prenom_candidat;sexe_candidat;etiquette_candidat;nuance_candidat;		0	active	85ec5f06-1543-41ef-9aaa-fa4f60123d60	91d76a3e-a85f-43f6-8011-ea55b5916479
91d76a3e-a85f-43f6-8011-ea55b5916479	cd42a806-cac1-452c-9b0d-116d8ead4d64	http://komodo.regardscitoyens.org/public/legislatives2012/candidats.csv	CSV	#date_donnees\ttype_election\ttour_election\tdate_election\tnumero_departement\tcode_departement\tdepartement\tnumero_circonscription\tcirconscription\tnumero_panneau\tnumero_depot\tsexe\tnom\tprenom\tdate_naissance\tnuance_politique\tetiquette_nuance_politique\tprofession\tpersonnalité\tcandidat_sortant\tsuppleant_sexe\tsuppleant_nom\tsuppleant_prenom\tsuppleant_date_naissance\tsuppleant_nuance_politique\tsuppleant_personnalité\tsuppleant_candidat_sortant		0	active	d3237a95-d367-4144-b757-5bbd1a150f21	91d76a3e-a85f-43f6-8011-ea55b5916479
91d76a3e-a85f-43f6-8011-ea55b5916479	cd42a806-cac1-452c-9b0d-116d8ead4d64	http://komodo.regardscitoyens.org/public/legislatives2012/candidats.csv	CSV	#hashtag_circonscription;date_donnees\ttype_election\ttour_election\tdate_election\tnumero_departement\tcode_departement\tdepartement\tnumero_circonscription\tcirconscription\tnumero_panneau\tnumero_depot\tsexe\tnom\tprenom\tdate_naissance\tnuance_politique\tetiquette_nuance_politique\tprofession\tpersonnalité\tcandidat_sortant\tsuppleant_sexe\tsuppleant_nom\tsuppleant_prenom\tsuppleant_date_naissance\tsuppleant_nuance_politique\tsuppleant_personnalité\tsuppleant_candidat_sortant		0	active	485c12a1-334b-4fb6-82e6-96f3556f892e	91d76a3e-a85f-43f6-8011-ea55b5916479
b0ca96ef-4937-4c8f-b1e6-c985e026a174	cd42a806-cac1-452c-9b0d-116d8ead4d64	http://komodo.regardscitoyens.org/public/legislatives2012/candidats.csv.ministere.diff	CSV	Corrections non appliquées par le Ministère		1	active	6976eef5-92e8-45c2-bc2b-9bfc60341674	b0ca96ef-4937-4c8f-b1e6-c985e026a174
c5d9b8f5-827e-420f-b844-8632712fb7c0	e657011b-cf83-47ab-8bc8-62f6498046a6	https://www.dropbox.com/sh/2l54eef1s7a4u6m/3oo4C45ypS	CSV+ODS+PDF			0	active	5ff6213f-387b-4fa1-b818-fd7c5e9151bc	c5d9b8f5-827e-420f-b844-8632712fb7c0
4da8bc6a-641d-438c-a018-de62ecca58e1	30bcda76-5a1a-4369-a6f3-ed2584ad4031	http://www.nosdonnees.fr/wiki/images/6/61/201206-DeclarationInteretMinistres.tar.gz	cvs	Gouvernement Ayrault 06/12		0	active	8f541934-f087-4b2d-8130-3cf847c85689	4da8bc6a-641d-438c-a018-de62ecca58e1
f20622c5-b9f0-4284-89d3-4295a540c07f	30bcda76-5a1a-4369-a6f3-ed2584ad4031	http://www.nosdonnees.fr/wiki/images/0/04/20110421_RegardsCitoyens_declaration_dinterets.csv	csv	Gouvernement Fillon 2 04/11		1	active	8f541934-f087-4b2d-8130-3cf847c85689	f20622c5-b9f0-4284-89d3-4295a540c07f
4da8bc6a-641d-438c-a018-de62ecca58e1	30bcda76-5a1a-4369-a6f3-ed2584ad4031	http://www.nosdonnees.fr/wiki/images/6/61/201206-DeclarationInteretMinistres.tar.gz	CSV	Gouvernement Ayrault 06/12		0	active	6eccd4c9-6c1b-4e45-a065-05553ba71ff6	4da8bc6a-641d-438c-a018-de62ecca58e1
f20622c5-b9f0-4284-89d3-4295a540c07f	30bcda76-5a1a-4369-a6f3-ed2584ad4031	http://www.nosdonnees.fr/wiki/images/0/04/20110421_RegardsCitoyens_declaration_dinterets.csv	CSV	Gouvernement Fillon 2 04/11		1	active	6eccd4c9-6c1b-4e45-a065-05553ba71ff6	f20622c5-b9f0-4284-89d3-4295a540c07f
06595897-9352-4960-bfee-f1d3e9b8711f	61d87eb7-e3d3-4f90-a3a8-b43b5362db1a	http://komodo.regardscitoyens.org/public/legislatives2012/resultats/circos.svg	SVG			0	active	b062326e-1f5d-48e3-a67b-9114ca9e15a4	06595897-9352-4960-bfee-f1d3e9b8711f
b9315ffa-a40a-4aff-bba9-411dfee834a0	aac3a30b-36a9-4887-8aab-81c552bfc7d7	http://www.toxicode.fr/circonscriptions_download	CSV	Countours des circonscriptions des législatives		0	active	ec886521-f454-451d-af59-53aadbcf4bbc	b9315ffa-a40a-4aff-bba9-411dfee834a0
f20622c5-b9f0-4284-89d3-4295a540c07f	30bcda76-5a1a-4369-a6f3-ed2584ad4031	http://www.nosdonnees.fr/wiki/images/0/04/20110421_RegardsCitoyens_declaration_dinterets.csv	CSV	Gouvernement Fillon 3 04/11		1	active	f13aec90-d533-403f-a48e-1cf78bcc8709	f20622c5-b9f0-4284-89d3-4295a540c07f
4da8bc6a-641d-438c-a018-de62ecca58e1	30bcda76-5a1a-4369-a6f3-ed2584ad4031	http://www.nosdonnees.fr/wiki/images/3/35/20120613_RegardsCitoyens_declaration_dinterets.csv	CSV	Gouvernement Ayrault 06/12		0	active	f13aec90-d533-403f-a48e-1cf78bcc8709	4da8bc6a-641d-438c-a018-de62ecca58e1
9b49881e-6a1d-41c6-93fb-88f3785273be	f1b3849e-9568-4cae-a3a0-3cca7f42c079	http://www.regardscitoyens.org/telechargement/donnees/circonscriptions.svg	SVG	Carte des circonscriptions législatives 2012		0	active	9fbb919a-209f-482e-89aa-7fd9e82a7989	9b49881e-6a1d-41c6-93fb-88f3785273be
9b49881e-6a1d-41c6-93fb-88f3785273be	f1b3849e-9568-4cae-a3a0-3cca7f42c079	http://www.regardscitoyens.org/telechargement/donnees/circonscriptions.svg	SVG	Carte des circonscriptions législatives françaises (2012+)		0	active	91785866-4772-4249-9659-5484c2c4a91d	9b49881e-6a1d-41c6-93fb-88f3785273be
c95ce511-abf7-4800-8148-6c289d1169d7	27597355-d542-4574-adc8-6493883d1454	http://www.nosdonnees.fr/wiki/index.php/Image:Donnees-soumises-a-redevance.csv	cvs			0	active	4859fec8-5318-4618-83d3-564fa1dcffd9	c95ce511-abf7-4800-8148-6c289d1169d7
c95ce511-abf7-4800-8148-6c289d1169d7	27597355-d542-4574-adc8-6493883d1454	http://www.nosdonnees.fr/wiki/index.php/Image:Donnees-soumises-a-redevance.csv	CSV			0	active	8cade445-98c7-4340-8aaa-34f0c304d0e9	c95ce511-abf7-4800-8148-6c289d1169d7
6c64cac7-7528-4e73-b3c5-277273647f6b	f1b3849e-9568-4cae-a3a0-3cca7f42c079	http://www.regardscitoyens.org/telechargement/donnees/circonscriptions.svg	SVG	Carte		1	active	253b2edc-2e40-4d29-b353-0354c6636afe	6c64cac7-7528-4e73-b3c5-277273647f6b
d41e3f68-f4de-47ec-bfc0-fa2ef9092924	382ceece-628f-43b1-8847-ea92ff04376f	http://www.nosdonnees.fr/wiki/images/a/a7/Comptes_campagne_pr%C3%A9sidentielle_2012.csv	CSV	candidat ; recette/dépense ; catégorie ; frais du mandataire ; frais de la formation politique ; concours en nature ; total		0	active	d982c3cc-785b-44af-9d31-fd3fb152558b	d41e3f68-f4de-47ec-bfc0-fa2ef9092924
4da8bc6a-641d-438c-a018-de62ecca58e1	30bcda76-5a1a-4369-a6f3-ed2584ad4031	http://www.nosdonnees.fr/wiki/images/3/35/20120613_RegardsCitoyens_declaration_dinterets.csv	CSV	Gouvernement Ayrault 1 06/12		1	active	c102275a-5305-461f-be5d-99ec2b312329	4da8bc6a-641d-438c-a018-de62ecca58e1
f20622c5-b9f0-4284-89d3-4295a540c07f	30bcda76-5a1a-4369-a6f3-ed2584ad4031	http://www.nosdonnees.fr/wiki/images/0/04/20110421_RegardsCitoyens_declaration_dinterets.csv	CSV	Gouvernement Fillon 3 04/11		2	active	c102275a-5305-461f-be5d-99ec2b312329	f20622c5-b9f0-4284-89d3-4295a540c07f
eb7ec7a5-e07a-4c16-9706-2fccd5913d41	30bcda76-5a1a-4369-a6f3-ed2584ad4031	http://www.nosdonnees.fr/wiki/images/9/97/20120903_RegardsCitoyens_declaration_dinterets.csv		Gouvernement Ayrault 2 09/12		0	active	c102275a-5305-461f-be5d-99ec2b312329	eb7ec7a5-e07a-4c16-9706-2fccd5913d41
eb7ec7a5-e07a-4c16-9706-2fccd5913d41	30bcda76-5a1a-4369-a6f3-ed2584ad4031	http://www.nosdonnees.fr/wiki/images/9/97/20120903_RegardsCitoyens_declaration_dinterets.csv	CSV	Gouvernement Ayrault 2 09/12		0	active	63fc2d16-945c-4443-bbc0-0bd4600d9581	eb7ec7a5-e07a-4c16-9706-2fccd5913d41
cd21067b-6575-4c73-ad1c-219cc0921896	d6c6d3f9-5d8d-46c8-bc92-d8507d1e6f04	http://agreste.agriculture.gouv.fr/IMG/xls/venale2012T3.xls	xls	Prix des vignes de 1991 à 2011 par catégorie de vignes, niveau national, par bassin viticole, par région et par département		2	active	2f7105eb-514c-4a4b-9271-b33aef907680	cd21067b-6575-4c73-ad1c-219cc0921896
d92153d0-672c-40f9-8759-d4bff2378fed	d6c6d3f9-5d8d-46c8-bc92-d8507d1e6f04	http://agreste.agriculture.gouv.fr/IMG/xls/venale2012T4.xls	xls	Valeur vénale des terres agricoles dans les DOM de 2000 à 2011, par catégorie de terres et par zones géographiques		3	active	2f7105eb-514c-4a4b-9271-b33aef907680	d92153d0-672c-40f9-8759-d4bff2378fed
29bb4ae7-01b6-482e-ac32-3315ed34dde9	d6c6d3f9-5d8d-46c8-bc92-d8507d1e6f04	http://agreste.agriculture.gouv.fr/IMG/xls/venale2012T1.xls	xls	 Prix des terres et prés de 1997 à 2011 par région et au niveau national		1	active	2f7105eb-514c-4a4b-9271-b33aef907680	29bb4ae7-01b6-482e-ac32-3315ed34dde9
02b623d2-f980-4004-9732-ecb709aca813	d6c6d3f9-5d8d-46c8-bc92-d8507d1e6f04	http://agreste.agriculture.gouv.fr/IMG/pdf/venale2012bareme.pdf	pdf	Barême indicatif de la valeur vénale des terres en 2011 2006		4	active	2f7105eb-514c-4a4b-9271-b33aef907680	02b623d2-f980-4004-9732-ecb709aca813
e8e18117-8242-4e62-af20-0e8e5abf68ae	d6c6d3f9-5d8d-46c8-bc92-d8507d1e6f04	http://agreste.agriculture.gouv.fr/IMG/xls/venale2012T2.xls	xls	Prix dPrix moyen des terres et prés de 1999 à 2011, par département et par groupement de petites régions agricoles		0	active	2f7105eb-514c-4a4b-9271-b33aef907680	e8e18117-8242-4e62-af20-0e8e5abf68ae
96937b63-9dd3-469f-9f45-2562b6f67a4b	8d9cf757-de83-4774-919b-00c45c43efd4	https://api.scraperwiki.com/api/1.0/datastore/sqlite?format=csv&name=prenoms&query=select+*+from+%60swdata%60&apikey=	CSV	id, année, nombre de naissances, ID du prénom, prénom		0	active	c0737967-984c-480f-81ce-d34a53bf21c4	96937b63-9dd3-469f-9f45-2562b6f67a4b
525a38fa-ef24-4661-a420-eedfe1d8be25	c4556598-bcc7-4c45-8ae8-bdafc367eaa2	http://komodo.regardscitoyens.org/public/presidentielles2012/resultats/Presidentielle_2012_Resultats_Valides.zip	zip csv utf8	CSV encodés en utf8 avec séparateur ;		0	active	82588466-66be-4f7f-bb1e-2f0aee7ae5d3	525a38fa-ef24-4661-a420-eedfe1d8be25
d9c7f3a6-16c3-4cb6-9050-b4f3ec38837c	4f8c2ed1-52a1-4c94-854e-631daeb1a154	http://www.nosdonnees.fr/wiki/images/a/a9/20120630_MinistereJustice_StatsTraitement12moisEtStockFinJuin.csv	csv			0	active	b4fc3c0a-6704-495c-b092-cbeec8f14ace	d9c7f3a6-16c3-4cb6-9050-b4f3ec38837c
d363564f-63a8-4cce-8fc2-b44359b71247	e6833b4c-3f1e-4394-a547-790258b451e5	http://www.regardscitoyens.org/telechargement/donnees/rattachement_partis.csv	CSV	nom_complet;prenom;parti_ou_groupement_politique_de_rattachement;groupe_details;groupe_sigle		0	active	da99599d-79c0-47b0-8f59-3f2fc4bf3bed	d363564f-63a8-4cce-8fc2-b44359b71247
ef217959-5dc9-4735-81b4-53fd93872d10	e6833b4c-3f1e-4394-a547-790258b451e5	http://www.nosdeputes.fr/deputes/csv	CSV	export API de NosDéputés.fr avc metadonnées complémentaires		1	active	da99599d-79c0-47b0-8f59-3f2fc4bf3bed	ef217959-5dc9-4735-81b4-53fd93872d10
6c64cac7-7528-4e73-b3c5-277273647f6b	f1b3849e-9568-4cae-a3a0-3cca7f42c079	http://www.regardscitoyens.org/telechargement/donnees/circonscriptions.svg	SVG	Carte		1	deleted	a17fc946-239f-4bf6-96ce-076b5342fe5e	6c64cac7-7528-4e73-b3c5-277273647f6b
\.


--
-- Data for Name: package_revision; Type: TABLE DATA; Schema: public; Owner: ckantest
--

COPY package_revision (id, name, title, version, url, author, author_email, maintainer, maintainer_email, notes, license_id, state, revision_id, continuity_id) FROM stdin;
587ed76e-1c2f-4cc7-a23a-f9beb2415c77	nkb	Taux de Fiscalité Directe Locale par région 2001-2009	\N	http://www.impots.gouv.fr/portal/deploiement/p1/fichedescriptive_5458/fichedescriptive_5458.xls	Ministère du budget	\N	\N	\N	\N	notspecified	active	f74141f1-d57b-4f3f-9ee2-d1469d1a00a9	587ed76e-1c2f-4cc7-a23a-f9beb2415c77
4402487d-3e8d-4618-8444-b400c6337834	nkb_	Impôt de Solidarité sur la Fortune par commune 2009	\N	http://www.impots.gouv.fr/portal/deploiement/p1/fichedescriptive_5582/fichedescriptive_5582.xls	Ministère du budget	\N	\N	\N	Impôt de Solidarité sur la Fortune\r\nANNEE 2009\r\nVilles de plus de 20 000 habitants ayant plus de 50 redevables à l'ISF	notspecified	active	6aafed2f-a1a7-48cc-b275-0e0986710b13	4402487d-3e8d-4618-8444-b400c6337834
4402487d-3e8d-4618-8444-b400c6337834	isf2009	Impôt de Solidarité sur la Fortune par commune 2009	\N	http://www.impots.gouv.fr/portal/deploiement/p1/fichedescriptive_5582/fichedescriptive_5582.xls	Ministère du budget	\N	\N	\N	Impôt de Solidarité sur la Fortune\r\nANNEE 2009\r\nVilles de plus de 20 000 habitants ayant plus de 50 redevables à l'ISF	notspecified	active	9bae0509-72a9-4de7-a4f4-f24c8532fcda	4402487d-3e8d-4618-8444-b400c6337834
587ed76e-1c2f-4cc7-a23a-f9beb2415c77	taux_fiscalite_2001_2009	Taux de Fiscalité Directe Locale par région 2001-2009	\N	http://www.impots.gouv.fr/portal/deploiement/p1/fichedescriptive_5458/fichedescriptive_5458.xls	Ministère du budget	\N	\N	\N	\N	notspecified	active	db5217fd-ac78-4ac0-9a7a-1dbd76d734eb	587ed76e-1c2f-4cc7-a23a-f9beb2415c77
4235252c-aa21-46b5-8c52-110f95bdc583	rsultats-aux-lections-prsidentielles-2007	Résultats aux élections présidentielles 2007	\N	http://www.regardscitoyens.org/publication/#donnees	Ministère de l'intérieur	\N	Regards Citoyens	contact@regardscitoyens.org	Données obtenues auprès du ministère de l'intérieur	notspecified	active	e538d820-448e-4081-9616-dd0122780c60	4235252c-aa21-46b5-8c52-110f95bdc583
4235252c-aa21-46b5-8c52-110f95bdc583	rsultats-aux-lections-prsidentielles-2007	Résultats aux élections présidentielles 2007	\N	http://www.regardscitoyens.org/publication/#donnees	Ministère de l'intérieur	\N	Regards Citoyens	contact@regardscitoyens.org	Données obtenues auprès du ministère de l'intérieur	cc-by-sa	active	817afdd6-8c2c-4b47-a925-9cc7d994834c	4235252c-aa21-46b5-8c52-110f95bdc583
4235252c-aa21-46b5-8c52-110f95bdc583	rsultats-aux-lections-prsidentielles-2007	Résultats aux élections présidentielles 2007	\N	http://www.regardscitoyens.org/publication/#donnees	Ministère de l'intérieur	\N	Regards Citoyens	contact@regardscitoyens.org	Données obtenues auprès du ministère de l'intérieur	notspecified	active	21404ab1-66b4-43b3-8bbd-4d3a3644478b	4235252c-aa21-46b5-8c52-110f95bdc583
4235252c-aa21-46b5-8c52-110f95bdc583	rsultats-aux-lections-prsidentielles-2007	Résultats aux élections présidentielles 2007	\N	http://www.regardscitoyens.org/publication/#donnees	Ministère de l'intérieur	\N	Regards Citoyens	contact@regardscitoyens.org	Données obtenues auprès du ministère de l'intérieur	cc-by-sa	active	43627482-31b6-45a8-a384-1009f06bceb4	4235252c-aa21-46b5-8c52-110f95bdc583
4235252c-aa21-46b5-8c52-110f95bdc583	rsultats-aux-lections-prsidentielles-2007	Résultats aux élections présidentielles 2007	\N	http://www.regardscitoyens.org/publication/#donnees	Ministère de l'intérieur	\N	Regards Citoyens	contact@regardscitoyens.org	Données obtenues auprès du ministère de l'intérieur. Elles correspondent aux résultats des deux tours de l'élection présidentielle de 2007, bureaux de vote par bureaux de vote.	cc-by-sa	active	dbfdfdbf-2d3c-473a-8cee-c5c2d7367ffc	4235252c-aa21-46b5-8c52-110f95bdc583
4235252c-aa21-46b5-8c52-110f95bdc583	resultats-des-elections-presidentielles-2007	Résultats des élections présidentielles 2007	\N	http://www.regardscitoyens.org/publication/#donnees	Ministère de l'intérieur	\N	Regards Citoyens	contact@regardscitoyens.org	Données obtenues auprès du ministère de l'intérieur. Elles correspondent aux résultats des deux tours de l'élection présidentielle de 2007, bureaux de vote par bureaux de vote.	cc-by-sa	active	4032bd87-a45c-49e3-9414-55ad06c9cb82	4235252c-aa21-46b5-8c52-110f95bdc583
4235252c-aa21-46b5-8c52-110f95bdc583	resultats-des-elections-presidentielles-2007	Résultats des élections présidentielles 2007	\N	http://www.regardscitoyens.org/publication/#donnees	Ministère de l'intérieur	\N	Regards Citoyens	contact@regardscitoyens.org	Données obtenues auprès du ministère de l'intérieur. Elles correspondent aux résultats des deux tours de l'élection présidentielle de 2007, bureaux de vote par bureaux de vote.	odc-odbl	active	fbef7487-8d50-4d9d-aa8b-eb81e4a4fefb	4235252c-aa21-46b5-8c52-110f95bdc583
4235252c-aa21-46b5-8c52-110f95bdc583	resultats-des-elections-presidentielles-2007	Résultats des élections présidentielles 2007	\N	http://www.regardscitoyens.org/publication/#donnees	Ministère de l'intérieur	\N	Regards Citoyens	contact@regardscitoyens.org	Données obtenues auprès du ministère de l'intérieur. Elles correspondent aux résultats des deux tours de l'élection présidentielle de 2007, bureaux de vote par bureaux de vote.	notspecified	active	a318ad2c-bc5c-4c55-a5fe-4f3cfbb61468	4235252c-aa21-46b5-8c52-110f95bdc583
4235252c-aa21-46b5-8c52-110f95bdc583	resultats-des-elections-presidentielles-2007	Résultats des élections présidentielles 2007	\N	http://www.regardscitoyens.org/publication/#donnees	Ministère de l'intérieur	\N	Regards Citoyens	contact@regardscitoyens.org	Données obtenues auprès du ministère de l'intérieur. Elles correspondent aux résultats des deux tours de l'élection présidentielle de 2007, bureaux de vote par bureaux de vote.	cc-by-sa	active	235bde9c-3506-4225-8038-e865d0b97e75	4235252c-aa21-46b5-8c52-110f95bdc583
e3424ea9-f7c0-4d80-832b-890c3de0f744	resultats-des-elections-municipales-du-tarn	Résultats des élections municipales du tarn	\N	http://www.tarn.pref.gouv.fr/elections/CM2008/	Préfecture du Tarn	\N	\N	\N	Résultats des élections municipales de 2008 dans le tarn au format xml. Un fichier par commune, le fichier est débute par 081 (code du département) et est suivit du code INSEE de la commune	\N	active	a6a5efac-b108-40c8-847c-e06530596dae	e3424ea9-f7c0-4d80-832b-890c3de0f744
db34f769-ed94-45d3-8b66-5ebaf9b091ff	exportation-et-importation-de-produit-sur-trois-ans	Exportation et importation de produit sur trois ans	\N	http://lekiosque.finances.gouv.fr/Appchiffre/LEO/surcadre_LEO.asp	Le douanes	\N	\N	\N	L'interface de ce site permet de consulter et télécharger en csv les exportations et importations enregistrées par les douanes sur trois ans.\r\n\r\nLes produits sont catégorisés par une "nomenclature combinée" NC8. Pour accéder aux données, il faut donc connaitre le code NC8 du produit dont on cherche à connaitre les importations et exportations.	\N	active	53b7a5cf-ae69-4bb1-b239-940facaeb014	db34f769-ed94-45d3-8b66-5ebaf9b091ff
1901d722-a38d-4e79-a13c-ca51d61bae30	donnees-geographiques-insee	Données géographiques INSEE	1	http://rdf.insee.fr/geo/	INSEE	publication-xml-dg@insee.fr	\N	\N	L'Insee publie dans cette section des données issues du code officiel géographique (COG) modélisées selon le standard RDF du web sémantique.\r\n\r\nDe nombreux autres fichiers RDF correspondants aux arrondissements et cantons sont disponibles sur la page spécifiée.\r\n\r\nLa licence : http://www.insee.fr/fr/publications-et-services/default.asp?page=copyright.htm	\N	active	b2b4b103-d694-4105-86d7-fa937445826f	1901d722-a38d-4e79-a13c-ca51d61bae30
65d7e18e-c5ab-4736-bb9e-c47de2dc41e1	import-export-par-pays	Import export par pays	\N	http://lekiosque.finances.gouv.fr/Appchiffre/pays/surcadre_pays.asp	Commerce extérieur	\N	\N	\N	Cette interface permet de télécharger en csv les données d'import et d'export entre la france et d'autres pays.\r\n\r\nLes données sont accessibles :\r\n - aggrégées\r\n - par zone géographique\r\n - par pays\r\n\r\nPour directement télécharger les données par pays, vous pouvez construire les urls suivante :\r\n\r\nhttp://lekiosque.finances.gouv.fr/Appchiffre/pays/transfert_long_cpf.asp?serie=P10<CODE_PAYS>&Flux=<IMPORT_EXPORT>\r\n\r\nAvec les arguments :\r\n - <CODE_PAYS> : deux lettres identifiant le pays ([issues de la nomenclature du commerce extérieur](http://lekiosque.finances.gouv.fr/Appchiffre/guide/images/Table_Pays.pdf))\r\n - <IMPORT_EXPORT> : 1 pour import ; 2 pour export	\N	active	46aec451-5c77-4e88-b1bb-b14ef364f759	65d7e18e-c5ab-4736-bb9e-c47de2dc41e1
65d7e18e-c5ab-4736-bb9e-c47de2dc41e1	import-export-par-pays	Import export par pays	\N	http://lekiosque.finances.gouv.fr/Appchiffre/pays/surcadre_pays.asp	Commerce extérieur	\N	\N	\N	Cette interface permet de télécharger en csv les données d'import et d'export entre la france et d'autres pays.\r\n\r\nLes données sont accessibles :\r\n* aggrégées\r\n* par zone géographique\r\n* par pays\r\n\r\nPour directement télécharger les données par pays, vous pouvez construire les urls suivante :\r\n\r\nhttp://lekiosque.finances.gouv.fr/Appchiffre/pays/transfert_long_cpf.asp?serie=P10CODE_PAYS&Flux=IMPORT_EXPORT\r\n\r\nAvec les arguments :\r\n* CODE_PAYS : deux lettres identifiant le pays ([issues de la nomenclature du commerce extérieur](http://lekiosque.finances.gouv.fr/Appchiffre/guide/images/Table_Pays.pdf))\r\n* IMPORT_EXPORT : 1 pour import ; 2 pour export	\N	active	edfc6915-85fb-4f7e-b4b5-1fc9a60bae76	65d7e18e-c5ab-4736-bb9e-c47de2dc41e1
65d7e18e-c5ab-4736-bb9e-c47de2dc41e1	import-export-par-pays	Import export par pays	\N	http://lekiosque.finances.gouv.fr/Appchiffre/pays/surcadre_pays.asp	Commerce extérieur	\N	\N	\N	Cette interface permet de télécharger en csv les données d'import et d'export entre la france et d'autres pays.\r\n\r\nLes données sont accessibles :\r\n\r\n * agrégées\r\n*   par zone géographique\r\n*   par pays\r\n\r\nPour directement télécharger les données par pays, vous pouvez construire les urls suivante :\r\n\r\nhttp://lekiosque.finances.gouv.fr/Appchiffre/pays/transfert_long_cpf.asp?serie=P10CODE_PAYS&Flux=IMPORT_EXPORT\r\n\r\nAvec les arguments :\r\n\r\n* CODE_PAYS : deux lettres identifiant le pays ([issues de la nomenclature du commerce extérieur](http://lekiosque.finances.gouv.fr/Appchiffre/guide/images/Table_Pays.pdf))\r\n* IMPORT_EXPORT : 1 pour import ; 2 pour export	\N	active	e1cdc053-a74b-4b24-8057-cbe623942ce4	65d7e18e-c5ab-4736-bb9e-c47de2dc41e1
65d7e18e-c5ab-4736-bb9e-c47de2dc41e1	import-export-par-pays	Import export par pays	\N	http://lekiosque.finances.gouv.fr/Appchiffre/pays/surcadre_pays.asp	Direction générale des douanes	\N	\N	\N	Cette interface permet de télécharger en csv les données d'import et d'export entre la france et d'autres pays.\r\n\r\nLes données sont accessibles :\r\n\r\n * agrégées\r\n*   par zone géographique\r\n*   par pays\r\n\r\nPour directement télécharger les données par pays, vous pouvez construire les urls suivante :\r\n\r\nhttp://lekiosque.finances.gouv.fr/Appchiffre/pays/transfert_long_cpf.asp?serie=P10CODE_PAYS&Flux=IMPORT_EXPORT\r\n\r\nAvec les arguments :\r\n\r\n* CODE_PAYS : deux lettres identifiant le pays ([issues de la nomenclature du commerce extérieur](http://lekiosque.finances.gouv.fr/Appchiffre/guide/images/Table_Pays.pdf))\r\n* IMPORT_EXPORT : 1 pour import ; 2 pour export	\N	active	8562e242-52ef-4521-95fe-53fcf1a8fe0b	65d7e18e-c5ab-4736-bb9e-c47de2dc41e1
3aa0d5ce-cef6-4158-b51e-ddee8ece7b5e	entreprises-poluantes	Entreprises produitant des émissions poluantes	\N	http://www.pollutionsindustrielles.ecologie.gouv.fr/IREP/	Ministère l'écologie	\N	\N	\N	Le registre français des émissions polluantes publie les entreprises ayant été répertoriées comme émettant des polluants.\r\n\r\nLa base est téléchargeable en plusieurs fichiers CVS.	\N	active	ceb18013-a90d-44d6-a245-b199633faf0b	3aa0d5ce-cef6-4158-b51e-ddee8ece7b5e
3aa0d5ce-cef6-4158-b51e-ddee8ece7b5e	entreprises-poluantes	Entreprises produisant des émissions poluantes	\N	http://www.pollutionsindustrielles.ecologie.gouv.fr/IREP/	Ministère l'écologie	\N	\N	\N	Le registre français des émissions polluantes publie les entreprises ayant été répertoriées comme émettant des polluants.\r\n\r\nLa base est téléchargeable en plusieurs fichiers CVS.	\N	active	8ab6af92-18de-4dbc-9cdb-a8d2cc156cea	3aa0d5ce-cef6-4158-b51e-ddee8ece7b5e
97b2cf1e-91f4-4b08-a7d8-2e6bd1dca37e	taux-de-fiscalit-directe-des-communes	Taux de fiscalité directe des communes	\N	http://www.dgcl.interieur.gouv.fr/sections/a_votre_service/statistiques/fiscalite_locale/communes/	Direction générale des collectivités locales	\N	\N	\N	Répertorie le taux de fiscalité direct voté par les communes de plus de 10 000 habitants	\N	active	a5bfd523-f3c2-41e2-9e1a-1624d786767c	97b2cf1e-91f4-4b08-a7d8-2e6bd1dca37e
e4c69e90-1056-4f46-9619-57d0a18d1737	taux-de-fiscalit-directe-des-groupement-de-communes	Taux de fiscalité directe des groupement de communes	\N	http://www.dgcl.interieur.gouv.fr/sections/a_votre_service/statistiques/fiscalite_locale/groupements_de_commu/	Direction générale des collectivités locales	\N	\N	\N	Taux de fiscalité des communautés urbaines et communautés d'agglomération entre 2006 et 2010.	\N	active	19979634-e047-4bef-b09b-396ebbbf7fd0	e4c69e90-1056-4f46-9619-57d0a18d1737
43c3cc44-3a6c-469b-80fe-913927d2c283	donnes-transport-rennes-metropole	Données transport de Rennes métropole	2010.10.13	http://data.keolis-rennes.com/fr/les-donnees/donnees-telechargeables.html	Keolis Rennes	\N	\N	\N	Données du réseau STAR et du service LE vélo STAR, réseau de transport public de Rennes Métropole, opéré par Keolis Rennes, au format <a href="http://code.google.com/intl/fr/transit/spec/transit_feed_specification.html">GTFS</a>.\r\n\r\nLa licence est spécifique et intitulée <a href="http://www.data.rennes-metropole.fr/fr/lentrepot/licence-dutilisation.html">"Licence de réutilisation des données publiques - Rennes Métropole en accès libre"</a>	\N	active	5b3fb26f-b388-4423-88e3-076c7476b2cc	43c3cc44-3a6c-469b-80fe-913927d2c283
43c3cc44-3a6c-469b-80fe-913927d2c283	donnees-transport-rennes-metropole	Données transport de Rennes métropole	2010.10.13	http://data.keolis-rennes.com/fr/les-donnees/donnees-telechargeables.html	Keolis Rennes	\N	\N	\N	Données du réseau STAR et du service LE vélo STAR, réseau de transport public de Rennes Métropole, opéré par Keolis Rennes, au format <a href="http://code.google.com/intl/fr/transit/spec/transit_feed_specification.html">GTFS</a>.\r\n\r\nLa licence est spécifique et intitulée <a href="http://www.data.rennes-metropole.fr/fr/lentrepot/licence-dutilisation.html">"Licence de réutilisation des données publiques - Rennes Métropole en accès libre"</a>	\N	active	487378c3-79fa-4f69-8a37-3ad81f3fca33	43c3cc44-3a6c-469b-80fe-913927d2c283
3aa0d5ce-cef6-4158-b51e-ddee8ece7b5e	entreprises-polluantes	Entreprises produisant des émissions polluantes	\N	http://www.pollutionsindustrielles.ecologie.gouv.fr/IREP/	Ministère de l'écologie	\N	\N	\N	Le registre français des émissions polluantes publie les entreprises ayant été répertoriées comme émettant des polluants.\r\n\r\nLa base est téléchargeable en plusieurs fichiers CSV.	\N	active	1e4eae84-e18c-4226-a08b-ddb330973624	3aa0d5ce-cef6-4158-b51e-ddee8ece7b5e
5b23d4f4-058e-44e0-945d-ae9035fb1e15	liste-des-maires-de-seine-maritime	Liste des maires de Seine Maritime	\N	\N	Préfecture de Seine Maritime	\N	\N	\N	Liste de tous les maires de seine maritime.	\N	active	f9d8651f-75dd-4a22-8190-ea0df1fb83d1	5b23d4f4-058e-44e0-945d-ae9035fb1e15
be516eed-8a37-436c-af75-b623f0806f39	donnees-de-trafic-de-grandes-villes	Données de Trafic de grandes villes	\N	http://www.bison-fute.equipement.gouv.fr/fr/article.php3?id_article=274	Bison Futé	\N	\N	\N	Bison futé met à disposition en XML des données de trafic de 13 villes françaises : Bordeaux, Lyon, Marseille, Lille, Caen, Rennes, Nantes, Saint Étienne, Grenoble, Strasbourg, Clermont-Ferrand, Limoge, et la Savoie.\r\n\r\n	\N	active	e5f47372-8631-4d88-9613-f26a40b1ad80	be516eed-8a37-436c-af75-b623f0806f39
5e86134f-2cb5-40e9-affa-f80d934a14b9	observatoire-des-prix-et-des-marges	Observatoire des prix et des marges	\N	http://www.dgccrf.bercy.gouv.fr/concurrence/prix/observatoire_prix.htm	Direction générale de la concurrence, de la consommation et de la répression des fraudes	webmestre@dgccrf.finances.gouv.fr	Jean-Luc Ambroise	\N	Il s'agit d'un ensemble de données concernant l'observation des prix et des marges depuis 2008 dans différentes filières. Ces données sont au format HTML ou PDF et proposées par la direction générale de la concurrence, de la consommation\r\net de la répression des fraudes.	notspecified	active	affa5e72-9823-4011-8ea4-8ef8c2305fe6	5e86134f-2cb5-40e9-affa-f80d934a14b9
6d999f74-d520-4a8c-8188-5a5c13c6bbec	donnees-sante-france	Données Santé France	\N	http://www.ecosante.fr/index.php?langs=FRA&langh=FRA&sessionid=	\N	\N	\N	\N	Dépenses de santé; Etat de santé; Professions de santé; Hôpitaux; Secteur pharmaceutique; Protection sociale; Démographie; Indicateurs économiques	notspecified	active	792ec941-9e46-472a-8f28-ee06aeaa4e5b	6d999f74-d520-4a8c-8188-5a5c13c6bbec
6d999f74-d520-4a8c-8188-5a5c13c6bbec	donnees-sante-france	Données Santé France	\N	http://www.ecosante.fr/index.php?langs=FRA&langh=FRA&sessionid=	IRDES	\N	\N	\N	Dépenses de santé; Etat de santé; Professions de santé; Hôpitaux; Secteur pharmaceutique; Protection sociale; Démographie; Indicateurs économiques	notspecified	active	81ae4f0f-e6b1-424a-b17c-870e1642db20	6d999f74-d520-4a8c-8188-5a5c13c6bbec
6d999f74-d520-4a8c-8188-5a5c13c6bbec	donnees-sante-france	Données Santé France	\N	http://www.ecosante.fr/index.php?langs=FRA&langh=FRA&sessionid=	IRDES	ecosante@irdes.fr	\N	\N	Dépenses de santé; Etat de santé; Professions de santé; Hôpitaux; Secteur pharmaceutique; Protection sociale; Démographie; Indicateurs économiques	notspecified	active	7df7eeb0-c854-4690-a1ee-da0f9e9897ab	6d999f74-d520-4a8c-8188-5a5c13c6bbec
cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	activit-des-dputs-de-lasseemble-nationale-13me-lgislature	Activité des députés de l'Asseemblée nationale (13ème législature)	\N	http://www.regardscitoyens.org/telechargement/donnees/	Regards Citoyens	contact@regardscitoyens.org	\N	\N	Ensemble des données parlementaires sur les députés. Informations extraites du site de l'Assemblée nationale et du Journal Officiel pour la constitution du site http://NosDeputes.fr\r\nCes données comprennent toutes les informations disponibles sur chaque député, toutes les questions et interventions en séance publique et en commissions ainsi que tous les amendements, propositions de lois et rapports produits depuis le début de la législature.\r\nCes données sont celles en date du 1er du mois en cours et sont remises à jour mensuellement.	cc-nc	active	85392283-0794-47c2-a7e4-2862636d3e55	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab
cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	activit-des-dputs-de-lassemble-nationale-13me-lgislature	Activité des députés de l'Assemblée nationale (13ème législature)	\N	http://www.regardscitoyens.org/telechargement/donnees/	Regards Citoyens	contact@regardscitoyens.org	\N	\N	Ensemble des données parlementaires sur les députés. Informations extraites du site de l'Assemblée nationale et du Journal Officiel pour la constitution du site http://NosDeputes.fr\r\nCes données comprennent toutes les informations disponibles sur chaque député, toutes les questions et interventions en séance publique et en commissions ainsi que tous les amendements, propositions de lois et rapports produits depuis le début de la législature.\r\nCes données sont celles en date du 1er du mois en cours et sont remises à jour mensuellement.	cc-by-sa	active	b4aafcd7-ff6c-44e1-8471-c7790e9379fd	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab
f6c6aac7-3c9b-4a3c-80bc-d6709bc95d4b	rsultat-des-lections-lgislatives-2007-et-application-au-redcoupage-de-2012	Résultat des élections législatives 2007 et application au redécoupage de 2012	1.1	http://www.regardscitoyens.org/redecoupage/	Regards Citoyens	contact@regardscitoyens.org	\N	\N	Résultats de 2007 par circonscription et par bureau de vote avec informations démographiques associées et prévisions de résultats sur la carte prévisionnelle des circonscriptions pour l'élection 2012 à partir de la relocalisation des résultats de 2007	odc-odbl	active	a78d4faa-842b-4cec-8ba4-2e9993ff99ca	f6c6aac7-3c9b-4a3c-80bc-d6709bc95d4b
6968ef13-1d2f-4de3-b533-706bc9c0f604	golocalisation-des-bureaux-de-votees	Géolocalisation des bureaux de votees	\N	http://elections.regardscitoyens.org/etrac/browser/elections/trunk	Regards Citoyens	contact@regardscitoyens.org	\N	\N	Géolocalisation des bureaux de vote par régions/départements en csv. Parcourir l'arbre pour consulter les fichiers csv générés à partir de combinaisons d'extraiots des xls et pdf des préfectures et du crowdsourcing réalisé grâce à l'application de 22 Mars.\r\nToutes les informations sur : http://elections.regardscitoyens.org/etrac\r\n	odc-odbl	active	29796bcf-b80b-4c83-a40e-c792a50e8802	6968ef13-1d2f-4de3-b533-706bc9c0f604
f6c6aac7-3c9b-4a3c-80bc-d6709bc95d4b	rsultat-des-lections-lgislatives-2007-et-application-au-redcoupage-de-2012	Résultats des élections législatives 2007 et application au redécoupage de 2012	1.1	http://www.regardscitoyens.org/redecoupage/	Regards Citoyens	contact@regardscitoyens.org	\N	\N	Résultats de 2007 par circonscription et par bureau de vote avec informations démographiques associées et prévisions de résultats sur la carte prévisionnelle des circonscriptions pour l'élection 2012 à partir de la relocalisation des résultats de 2007	odc-odbl	active	c42aefff-d420-4504-95d7-3d69e49d3c8a	f6c6aac7-3c9b-4a3c-80bc-d6709bc95d4b
f3d8ca3c-32b9-4485-95d9-0b1fd4a5dd4e	prsence-des-dputs-au-cours-de-la-session-2009-2010	Présence des députés au cours de la session 2009-2010	2010-07	http://www.nosdeputes.fr/confiseurs/index.php	Regards Citoyens	contact@regardscitoyens.org	\N	\N	Données relatives aux sanctions encourues par les députés insuffisamment présents à l'Assemblée au cours de la session 2009-2010.\r\nLe collectif Regards Citoyens a mené une étude à partir des données de http://NosDeputes.fr visant à évaluer l'incidence des modifications du règlement sur la participation des députés aux travaux de l'Assemblée, notamment aux réunions des commissions. Le règlement impose en effet avec ses articles 42 et 159 des sanctions financières sur l'indemnité de fonction des députés manifestant des absences répétées aux réunions de leur commission permanente le mercredi matin ou aux scrutins solennels en hémicycle.	odc-odbl	active	d78247f0-fc65-4fb3-bc7e-81f3ad80e69b	f3d8ca3c-32b9-4485-95d9-0b1fd4a5dd4e
69361720-3428-417e-beb4-d21df542992c	comptes-regionalises-des-administrations-publiques-locales-en-2007	Comptes régionalisés des administrations publiques locales en 2007 	\N	http://www.insee.fr/fr/themes/detail.asp?reg_id=99&ref_id=apul-regions	INSEE	\N	\N	\N	\N	notspecified	active	8b208a3e-558c-4884-9cc1-297a0dc0e174	69361720-3428-417e-beb4-d21df542992c
65d7e18e-c5ab-4736-bb9e-c47de2dc41e1	import-export-par-pays	Import export par pays	\N	http://lekiosque.finances.gouv.fr/Appchiffre/pays/surcadre_pays.asp	Direction générale des douanes	\N	\N	\N	Cette interface permet de télécharger en csv les données d'import et d'export entre la france et d'autres pays.\r\n\r\nLes données sont accessibles :\r\n\r\n * agrégées\r\n*   par zone géographique\r\n*   par pays\r\n\r\nPour directement télécharger les données par pays, vous pouvez construire les urls suivante :\r\n\r\nhttp://lekiosque.finances.gouv.fr/Appchiffre/pays/transfert_long_cpf.asp?serie=P10CODE_PAYS&Flux=IMPORT_EXPORT\r\n\r\nAvec les arguments :\r\n\r\n* CODE_PAYS : deux lettres identifiant le pays ([issues de la nomenclature du commerce extérieur](http://lekiosque.finances.gouv.fr/Appchiffre/guide/images/Table_Pays.pdf))\r\n* IMPORT_EXPORT : 1 pour import ; 2 pour export	odc-odbl	active	e4cf8b5e-d018-4c0b-9c86-f6b0e85edcfd	65d7e18e-c5ab-4736-bb9e-c47de2dc41e1
65d7e18e-c5ab-4736-bb9e-c47de2dc41e1	import-export-par-pays	Import export par pays	\N	http://lekiosque.finances.gouv.fr/Appchiffre/pays/surcadre_pays.asp	Direction générale des douanes	\N	\N	\N	La libération de ces données a été organisée ici :\r\n\r\nhttp://www.nosdonnees.fr/wiki/index.php/Donn%C3%A9es_d%27import_export_par_pays	odc-odbl	active	a5675df6-074d-4301-8987-bf9d514050f4	65d7e18e-c5ab-4736-bb9e-c47de2dc41e1
6968ef13-1d2f-4de3-b533-706bc9c0f604	golocalisation-des-bureaux-de-votes	Géolocalisation des bureaux de votes	\N	http://elections.regardscitoyens.org/etrac/browser/elections/trunk	Regards Citoyens	contact@regardscitoyens.org	\N	\N	Géolocalisation des bureaux de vote par régions/départements en csv. Parcourir l'arbre pour consulter les fichiers csv générés à partir de combinaisons d'extraiots des xls et pdf des préfectures et du crowdsourcing réalisé grâce à l'application de 22 Mars.\r\nToutes les informations sur : http://elections.regardscitoyens.org/etrac\r\n	odc-odbl	active	dca1567f-bb5c-4f07-ba22-d27778ebde69	6968ef13-1d2f-4de3-b533-706bc9c0f604
0e14dccb-9c28-4f89-b3b2-cb1011be06d1	financement-des-associations-par-l-etat	Financement des associations par l'état	\N	http://www.performance-publique.gouv.fr/farandole/2010/jaune.html#resultat	Ministère de bercy	\N	bboissin	\N	Dans les plans de finance, il y a des données financières notamment sur le financement des associations. Elles se trouvent dans le tome 3 des annexes jaunes.\r\n\r\nUne extraction de ces données a été réalisée à l'occasion de la préparation de la loi de finance 2010	cc-by	active	fb37d996-fe0c-49bf-8cb0-29b99087b3d2	0e14dccb-9c28-4f89-b3b2-cb1011be06d1
34269022-c891-4a8e-a814-3af2b0fea526	donnes-gographiques-des-communes-par-code-insee	Données géographiques des communes par code INSEE	01-01-2009	http://www.insee.fr/fr/themes/detail.asp?reg_id=99&ref_id=base-cc-table-appartenance-geo-communes	INSEE	\N	\N	\N	Table d'appartenance géographique des communes.\r\n\r\nCe fichier fournit pour toutes les communes le code géographique des niveaux géographiques supérieurs auxquels elles appartiennent.\r\n\r\nRelié aux tables d'indicateurs Chiffres clés, ce fichier permet d'obtenir des résultats agrégés d'indicateurs sur un territoire communal personnalisé ou des territoires supra-communaux. 	odc-odbl	active	a23213e4-603f-42b1-88e7-f9f17b4bdb6d	34269022-c891-4a8e-a814-3af2b0fea526
6d999f74-d520-4a8c-8188-5a5c13c6bbec	donnees-sante-france	Données Santé France	\N	http://www.ecosante.fr/index.php?langs=FRA&langh=FRA&sessionid=	IRDES	ecosante@irdes.fr	\N	\N	Dépenses de santé; Etat de santé; Professions de santé; Hôpitaux; Secteur pharmaceutique; Protection sociale; Démographie; Indicateurs économiques	\N	active	0f921f9a-fa99-4cb7-90ef-aab5c836c057	6d999f74-d520-4a8c-8188-5a5c13c6bbec
a1019da5-cdac-4e09-8b60-831994b5f275	horairesbibliothequesnantes	HorairesBibliothequesNantes	0.1	http://www.bm.nantes.fr/	Mairie de Nantes	\N	Arthur Lutz	arthur.lutz@gmail.com	\N	notspecified	active	37fbb496-6950-4dfe-96b7-1b2dc46a8c68	a1019da5-cdac-4e09-8b60-831994b5f275
29772378-f226-4fc8-8e01-9a87c5e43a00	pegase	Pétrole, Électricité, Gaz et Autres Statistiques de l’Énergie	\N	http://www.statistiques.equipement.gouv.fr/article.php3?id_article=1315	inistère de l'Écologie, de l'Energie, du Développement durable et de la Mer, en charge des Technologies vertes et des Négociations sur le climat	\N	\N	\N	La base Pégase (acronyme de Pétrole, Électricité, Gaz et Autres Statistiques de l’Énergie) enregistre et diffuse les statistiques de l’énergie rassemblées par le Service de l’observation et des statistiques (SOeS).	notspecified	active	14d1f443-8fc7-42d8-a730-c7747178aa8e	29772378-f226-4fc8-8e01-9a87c5e43a00
29772378-f226-4fc8-8e01-9a87c5e43a00	pegase	Pétrole, Électricité, Gaz et Autres Statistiques de l’Énergie	\N	http://www.statistiques.equipement.gouv.fr/article.php3?id_article=1315	Ministère de l'Écologie, de l'Energie, du Développement durable et de la Mer, en charge des Technologies vertes et des Négociations sur le climat	\N	\N	\N	La base Pégase (acronyme de Pétrole, Électricité, Gaz et Autres Statistiques de l’Énergie) enregistre et diffuse les statistiques de l’énergie rassemblées par le Service de l’observation et des statistiques (SOeS).	notspecified	active	32c35f04-41df-4a73-9a0f-112eeb800058	29772378-f226-4fc8-8e01-9a87c5e43a00
3fabe36b-965b-498d-9b3a-0649bbbfd0a5	statistique-des-remboursements-du-regime-general-de-sante	Statistique des remboursements du régime général de santé	\N	http://www.ameli.fr/l-assurance-maladie/statistiques-et-publications/analyse-des-depenses/depenses-les-remboursements-depuis-1-an/les-statistiques-mensuelles-du-regime-general.php	Caisse nationale de l'Assurance Maladie des travailleurs salariés	\N	\N	\N	Ventilation des dépenses de l'Assurance Maladie selon les différentes catégories de professionnels de santé qui ont dispensé ces soins :\r\n\r\n* Le suivi de la dépense totale, les dépenses remboursables et les dépenses remboursées ;\r\n* Les soins de ville par lieu d'exécution ;\r\n* Les honoraires des médecins par spécialité et lieu d'exécution ;\r\n* Les dépenses d'hospitalisation (y.c les honoraires en cliniques privées) ;\r\n* Les dépenses par région.	notspecified	active	6279dd25-4840-4072-ac60-e988063feae6	3fabe36b-965b-498d-9b3a-0649bbbfd0a5
3aa0d5ce-cef6-4158-b51e-ddee8ece7b5e	entreprises-polluantes	Entreprises produisant des émissions polluantes	\N	http://www.pollutionsindustrielles.ecologie.gouv.fr/IREP/	Ministère de l'écologie	\N	\N	\N	Le registre français des émissions polluantes publie les entreprises ayant été répertoriées comme émettant des polluants.\r\n\r\nLa base est téléchargeable en plusieurs fichiers CSV.	cada	active	f2a6db5d-8947-477a-b302-ea0660e033af	3aa0d5ce-cef6-4158-b51e-ddee8ece7b5e
430e39ad-4906-44ba-83bc-8f2bc6f2d039	elus-permier-tours-aux-cantonales-2011	Élus permier tours aux cantonales 2011	\N	\N	Ministère de l'intérieur	\N	\N	\N	Élus au 1er tours des élections cantonales de mars 2011	cada	active	65cf3b14-0851-41dd-8891-c545d5d33b8f	430e39ad-4906-44ba-83bc-8f2bc6f2d039
3fabe36b-965b-498d-9b3a-0649bbbfd0a5	statistique-des-remboursements-du-regime-general-de-sante	Statistique des remboursements du régime général de santé	\N	http://www.ameli.fr/l-assurance-maladie/statistiques-et-publications/analyse-des-depenses/depenses-les-remboursements-depuis-1-an/les-statistiques-mensuelles-du-regime-general.php	Caisse nationale de l'Assurance Maladie des travailleurs salariés	\N	\N	\N	Ventilation des dépenses de l'Assurance Maladie selon les différentes catégories de professionnels de santé qui ont dispensé ces soins :\r\n\r\n* Le suivi de la dépense totale, les dépenses remboursables et les dépenses remboursées ;\r\n* Les soins de ville par lieu d'exécution ;\r\n* Les honoraires des médecins par spécialité et lieu d'exécution ;\r\n* Les dépenses d'hospitalisation (y.c les honoraires en cliniques privées) ;\r\n* Les dépenses par région.	cada	active	2f2740b4-eedd-416c-98a0-bd76359cdd12	3fabe36b-965b-498d-9b3a-0649bbbfd0a5
29772378-f226-4fc8-8e01-9a87c5e43a00	pegase	Pétrole, Électricité, Gaz et Autres Statistiques de l’Énergie	\N	http://www.statistiques.equipement.gouv.fr/article.php3?id_article=1315	Ministère de l'Écologie, de l'Energie, du Développement durable et de la Mer, en charge des Technologies vertes et des Négociations sur le climat	\N	\N	\N	La base Pégase (acronyme de Pétrole, Électricité, Gaz et Autres Statistiques de l’Énergie) enregistre et diffuse les statistiques de l’énergie rassemblées par le Service de l’observation et des statistiques (SOeS).	cada	active	c3d4f682-208d-482a-bc84-08462a334b80	29772378-f226-4fc8-8e01-9a87c5e43a00
5e86134f-2cb5-40e9-affa-f80d934a14b9	observatoire-des-prix-et-des-marges	Observatoire des prix et des marges	\N	http://www.dgccrf.bercy.gouv.fr/concurrence/prix/observatoire_prix.htm	Direction générale de la concurrence, de la consommation et de la répression des fraudes	webmestre@dgccrf.finances.gouv.fr	Jean-Luc Ambroise	\N	Il s'agit d'un ensemble de données concernant l'observation des prix et des marges depuis 2008 dans différentes filières. Ces données sont au format HTML ou PDF et proposées par la direction générale de la concurrence, de la consommation\r\net de la répression des fraudes.	cada	active	bf59cab9-2d7a-47a2-b5a7-f070f5a5fd58	5e86134f-2cb5-40e9-affa-f80d934a14b9
2502f9a7-15fa-439d-8a48-f61f38cb6f55	donnes-gographiques---rgions-dpartements-arrondissements-cantons	Données géographiques: Régions, Départements, Arrondissements, Cantons	\N	http://rdf.insee.fr/geo/	INSEE	publication-xml-dg@insee.fr	INSEE	publication-xml-dg@insee.fr	L'Insee publie dans cette section des données issues du code officiel géographique (COG) modélisées selon le standard RDF du web sémantique.\r\n\r\n\r\n* Le fichier "Régions" contient la liste des régions ainsi que leur chef-lieu et les départements inclus dans ces régions.\r\n* Le fichier "Départements" contient la liste des départements, leurs chef-lieux ainsi que les arrondissements inclus dans ces départements\r\n* Le fichier "Arrondissements" incluant la liste des communes et cantons par arrondissement du département.\r\n* Le fichier "Cantons", qui modélise les liens entre communes et cantons ainsi que les relations de voisinage entre communes (y compris les communes limitrophes du département).	cada	active	39219937-0939-40ca-86a8-f8493a35a337	2502f9a7-15fa-439d-8a48-f61f38cb6f55
4276f7df-c7e9-44e1-8886-20ad41ebda0a	diplome-national-du-brevet-session-2009	Diplôme national du brevet, Session 2009	\N	http://www.education.gouv.fr/cid53600/diplome-national-du-brevet-session-2009.html	MEN-DEPP	depp.documentation@education.gouv.fr	MEN-DEPP	depp.diffusion@education.gouv.fr	En 2009, 609 400 candidats ont obtenu le diplôme national du brevet (DNB), soit un taux de réussite de 82,7 %, en légère hausse par rapport à la session 2008.\r\nLes écarts de réussite entre les départements de la métropole restent importants (15 points), mais se réduisent d’une session à l’autre.\r\nPrès de neuf élèves sur dix passent le DNB série collège, qui présente le taux de réussite le plus élevé (83,6 %), cinq élèves sur cent présentent la série technologique avec une réussite de 82,1 %, et un peu plus de cinq élèves sur cent la série professionnelle dont le taux de réussite est le plus faible (68 %).\r\nLes filles ont de meilleurs résultats que les garçons (+ 6 points) et un tiers d’entre elles obtiennent une mention bien ou très bien.\r\nL’origine sociale marque fortement la réussite au brevet: le taux de réussite passe ainsi de 68 % à 95 % selon que l’élève a un parent sans activité professionnelle ou cadre. De même, les chances d’obtenir une mention bien ou très bien varient de un à trois selon le milieu social: 44 % des enfants de cadres sont concernés, contre seulement 14 % des enfants dont le responsable est sans activité professionnelle.	notspecified	active	8b876446-18be-45e9-98d2-2ad4a1b1e7fa	4276f7df-c7e9-44e1-8886-20ad41ebda0a
f4517261-c1ee-4380-b3ad-0de5a0edc09a	resultats-definitifs-de-la-session-2009-du-baccalaurat	Résultats définitifs de la session 2009 du baccalauréat	\N	http://www.education.gouv.fr/cid51136/resultats-definitifs-de-la-session-2009-du-baccalaureat.html	MEN-DEPP	depp.documentation@education.gouv.fr	MEN-DEPP	depp.diffusion@education.gouv.fr	Avec 625 700 candidats et 539 100 lauréats, le taux de réussite à la session 2009 s’élève à 86,2 %. Les effectifs des bacheliers, comme ceux des candidats, ont augmenté par rapport à 2008 dans les voies générale et professionnelle, et ont diminué dans la voie technologique. La proportion de bacheliers dans une génération augmente de 3,2 points par rapport à l’an passé.\r\nEn 2009, 65,6 % des jeunes d’une génération obtiennent le baccalauréat : 35,1 % dans une série générale, 16,0 % dans une série technologique, 14,5 dans une une série professionnelle. La hausse du taux de réussite est due, en grande partie, au baccalauréat professionnel. En effet, avec la mise en place à la session 2009 d’épreuves de rattrapage, le taux de réussite au baccalauréat professionnel atteint 87,3 %, soit une hausse de 10,3 points par rapport à 2008.\r\nDans la voie générale, le taux de réussite augmente légèrement (+ 1 point par rapport à 2008) et s’élève ainsi à 88,9 %, niveau jamais atteint au cours des années précédentes.\r\nDans la voie technologique, le nombre de lauréats a baissé plus fortement que le nombre de candidats, entraînant ainsi une diminution du taux de réussite de 0,5 point (79,8 % contre 80,3 % en 2008).	notspecified	active	ab96c2af-06af-4bad-8c4f-00ec10f98776	f4517261-c1ee-4380-b3ad-0de5a0edc09a
9382520e-adb5-4403-848d-5bd5ea476202	liste-des-candidats-aux-cantonales-2011-1er-tour	Liste des candidats aux cantonales 2011 (1er tour)	\N	\N	Ministère de l'intérieur	\N	\N	\N	\N	cada	active	df6d8a52-2f22-493d-8be5-645488c266ea	9382520e-adb5-4403-848d-5bd5ea476202
9382520e-adb5-4403-848d-5bd5ea476202	liste-des-candidats-aux-cantonales-2011-1er-tour	Liste des candidats aux cantonales 2011 (1er tour)	\N	\N	Ministère de l'intérieur	\N	\N	\N	La liste de tous les candidats aux élections cantonale de mars 2011	cada	active	9a1682ec-e74a-4539-8bc2-a4437c678515	9382520e-adb5-4403-848d-5bd5ea476202
09d5ff25-7a8a-4228-9093-bb437bb70f1a	rsultats-des-lections-cantonales-de-mars-2011	Résultats des élections cantonales de mars 2011	\N	\N	Ministère de l'intérieur	\N	\N	\N	Résultat du premier tours des élections cantonales de mars 2011 au niveau canton.	cada	active	c0b8f3fb-e0c0-4ec9-8d66-a6604dcf12bd	09d5ff25-7a8a-4228-9093-bb437bb70f1a
09d5ff25-7a8a-4228-9093-bb437bb70f1a	resultats-des-elections-cantonales-de-mars-2011-1-tour	Résultats des élections cantonales de mars 2011 (1er tour)	\N	\N	Ministère de l'intérieur	\N	\N	\N	Résultat du premier tour des élections cantonales de mars 2011 au niveau canton.	cada	active	f39b8053-1f8c-44b5-9f81-07236807d0ea	09d5ff25-7a8a-4228-9093-bb437bb70f1a
430e39ad-4906-44ba-83bc-8f2bc6f2d039	elus-permier-tour-aux-cantonales-2011	Élus permier tour aux cantonales 2011	\N	\N	Ministère de l'intérieur	\N	\N	\N	Élus au 1er tour des élections cantonales de mars 2011	cada	active	79e83d1f-3aa6-4144-a610-76428572404a	430e39ad-4906-44ba-83bc-8f2bc6f2d039
430e39ad-4906-44ba-83bc-8f2bc6f2d039	elus-premier-tour-aux-cantonales-2011	Élus premier tour aux cantonales 2011	\N	\N	Ministère de l'intérieur	\N	\N	\N	Élus au 1er tour des élections cantonales de mars 2011	cada	active	b937f726-cd40-44b2-9cc5-47d2c3e7ebc3	430e39ad-4906-44ba-83bc-8f2bc6f2d039
48a03f6f-f8f4-4758-8672-f8ab8bd10acb	liste-des-candidats-aux-cantonales-2011-2d-tour	Liste des candidats aux cantonales 2011 (2d tour)	\N	\N	Ministère de l'intérieur	\N	\N	\N	Liste des candidats aux deuxième tour des cantonales de mars 2011	\N	active	cbb8cf9d-1615-4a30-9c69-bcc03cae3034	48a03f6f-f8f4-4758-8672-f8ab8bd10acb
48a03f6f-f8f4-4758-8672-f8ab8bd10acb	liste-des-candidats-aux-cantonales-2011-2d-tour	Liste des candidats aux cantonales 2011 (2d tour)	\N	\N	Ministère de l'intérieur	\N	\N	\N	Liste des candidats aux deuxième tour des cantonales de mars 2011	cada	active	333fdd79-d6b5-4196-8aca-c31496de0a7b	48a03f6f-f8f4-4758-8672-f8ab8bd10acb
cd2385b8-fa33-4be9-82a8-9ceda07fdc75	resultats-des-elections-cantonales-de-mars-2011-2d-tour	Résultats des élections cantonales de mars 2011 (2d tour)	\N	\N	Ministère de l'intérieur	\N	\N	\N	Résultats du 2d tour des élections cantonales de mars 2011	cada	active	0afcdd05-5c6a-4d38-8ccc-62520a9ea0ed	cd2385b8-fa33-4be9-82a8-9ceda07fdc75
6c0ea5a3-dd48-4015-8f65-77d56bf54bb3	elus-aux-elections-cantonales-2011	Élus aux élections cantonales 2011	\N	\N	Ministère de l'intérieur	\N	\N	\N	Les élus aux élections cantonales de mars 2011. 	cada	active	b8bede64-bf67-44d3-8697-8261f01f9d7b	6c0ea5a3-dd48-4015-8f65-77d56bf54bb3
cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	activit-des-dputs-de-lassemble-nationale-13me-lgislature	Activité des députés de l'Assemblée nationale (13ème législature)	2011-03-01	http://www.regardscitoyens.org/telechargement/donnees/	Regards Citoyens	contact@regardscitoyens.org	\N	\N	Ensemble des données parlementaires sur les députés. Informations extraites du site de l'Assemblée nationale et du Journal Officiel pour la constitution du site http://NosDeputes.fr\r\nCes données comprennent toutes les informations disponibles sur chaque député, toutes les questions et interventions en séance publique et en commissions ainsi que tous les amendements, propositions de lois et rapports produits depuis le début de la législature.\r\nCes données sont celles en date du 1er du mois en cours et sont remises à jour mensuellement.	cc-by-sa	active	5fd549d6-e139-4705-94a1-805d6ce85222	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab
78e9e396-2ab2-4d61-9eea-fe08b840dbf9	influence-auditions-deputes-lobbying	Influence - Listing des auditions réalisées par les députés pour leurs rapports	2011-03-16	http://www.regardscitoyens.org/transparence-france/etude-lobbying	Regards Citoyens	etudeetude.lobbying.tifrance.rc@regardscitoyens.org	\N	\N	Transparence International France et Regards Citoyens ont convenu en juillet 2010 d’un partenariat original, pour livrer ensemble au débat public et aux Français, des informations nouvelles sur les rencontres connues entre députés et acteurs publics et privés. Si ces informations sont toutes publiques, elles sont présentées ici de façon inédite afin d’être accessibles à tous. Elles ont vocation à être affinées, dans un processus collaboratif, avec le concours souhaité de toutes les personnes intéressées par le fonctionnement de la vie publique.\r\n\r\n1 174 rapports parlementaires ont été passés en revue grâce à l'aide de plus de 3 000 internautes. Entre juillet 2007 et juillet 2010, 9 300 auditions, de près de 5000 organismes, représentés par plus de 16 000 personnes, ont été recensées. D’emblée on le voit, les chiffres sont très éloignés des quelques 120 représentants d'intérêt inscrits en mars 2011 au registre officiel de l'Assemblée nationale !	odc-odbl	active	bdb5cf3d-56bf-428c-9151-2a3bb3c7669a	78e9e396-2ab2-4d61-9eea-fe08b840dbf9
30bcda76-5a1a-4369-a6f3-ed2584ad4031	dclarations-dintrets-des-membres-du-gouvernement-francais	Déclarations d'intérets des membres du gouvernement français	\N	http://www.nosdonnees.fr/wiki/index.php/D%C3%A9clarations_Int%C3%A9rets_des_Ministres	\N	\N	\N	\N	Depuis avril 2011, les membres du gouvernement français doivent rendre public leur déclaration d'intéret sur le site gouvernement.fr\r\n\r\nUne rassemblement et une extration des documents pdf a été réalisée afin de rendre cette information plus facilement interprétable.	cada	active	ae90eec5-4c4a-4cf4-83f3-238eb3d162e7	30bcda76-5a1a-4369-a6f3-ed2584ad4031
30bcda76-5a1a-4369-a6f3-ed2584ad4031	dclarations-dintrets-des-membres-du-gouvernement-francais	Déclarations d'intérêts des membres du gouvernement français	2011-04-21	http://www.nosdonnees.fr/wiki/index.php/D%C3%A9clarations_Int%C3%A9rets_des_Ministres	Gouvernement français	\N	Regards Citoyens	contact@regardscitoyens.org	Depuis avril 2011, les membres du gouvernement français doivent rendre publiques leurs déclarations d'intérêts sur le site gouvernement.fr\r\n\r\nUn rassemblement et une extration des documents pdf ont été réalisés afin de rendre cette information plus facilement interprétable.	cada	active	ea04b09e-6bcf-4718-9480-1461698f30ac	30bcda76-5a1a-4369-a6f3-ed2584ad4031
a8f061a9-6ba5-46df-89cd-6e65bfa28fe5	dotations-aux-collectivits-locales-2011	Dotations aux collectivités locales 2011	\N	http://modules.dgcl.interieur.gouv.fr/dgcl_dotation/consultation/accueil.php	\N	\N	\N	\N	Site de publication de la DGCL de la dotation globale des collectivités pour l'année 2011	notspecified	active	9ef4d8c5-6298-450e-8cfe-09b683b28b92	a8f061a9-6ba5-46df-89cd-6e65bfa28fe5
a8f061a9-6ba5-46df-89cd-6e65bfa28fe5	cboutet	Dotations aux collectivités locales 2011	\N	http://modules.dgcl.interieur.gouv.fr/dgcl_dotation/consultation/accueil.php	Christophe Boutet	\N	\N	\N	Site de publication de la DGCL de la dotation globale des collectivités pour l'année 2011	cada	active	73525b24-71fe-4d8c-bf6e-82479c209548	a8f061a9-6ba5-46df-89cd-6e65bfa28fe5
a8f061a9-6ba5-46df-89cd-6e65bfa28fe5	cboutet	Dotations aux collectivités locales 2011	\N	http://modules.dgcl.interieur.gouv.fr/dgcl_dotation/consultation/accueil.php	DGCL	\N	\N	\N	Site de publication de la DGCL de la dotation globale des collectivités pour l'année 2011	cada	active	172732b9-20c1-4478-8adb-045bc9d3092c	a8f061a9-6ba5-46df-89cd-6e65bfa28fe5
5c29c0cd-e773-4697-8172-ab1b075490c2	calcul-de-la-mare	Calcul de la marée	\N	http://www.shom.fr/ann_marees/cgi-bin/predit_ext/choixp?zone=0&opt=10&port=0&portsel=map	SHOM	\N	\N	\N	Site du SHOM fournissant les prévisions de marée pour les principaux ports mondiaux	cada	active	28169ed8-3c47-4522-a8d5-4474173aca5c	5c29c0cd-e773-4697-8172-ab1b075490c2
3c175c09-a896-4a88-9603-2b5ea27ef1a1	qualit-de-lair	Qualité de l'air	\N	http://www.prevair.org/fr/index.php	Prevair	\N	\N	\N	Page d'accueil du site prevair édité par le Ministère de l'écologique, aggrégeant les mesures de qualité de l'air réalisées par les différents acteurs sur le territoire français.	notspecified	active	99223c1a-1e29-42d1-8256-85f44520866f	3c175c09-a896-4a88-9603-2b5ea27ef1a1
2364edf3-baf9-4a60-a75e-46387f235726	indices-annuels-de-qualit-de-lair	Indices Annuels de qualité de l'air	\N	http://www.buldair.org/Statistiques/indice-annuel.php	Buld'air	\N	\N	\N	Publication des indices annuels de qualité de l'air pour les grandes villes.\r\nLa visualisation se fait en flash	notspecified	active	2f410629-bce8-453d-bac0-fc0b1e286dce	2364edf3-baf9-4a60-a75e-46387f235726
624552ff-a7cd-427d-88e3-f31ec6dba89b	nomenclature-des-sites-sportifs	Nomenclature des sites sportifs	\N	http://www.res.sports.gouv.fr/Page_Telechargements.aspx	Ministère des sports	\N	\N	\N	Nomenclature des sites sportifs français servant au recensement des sites dans http://www.res.sports.gouv.fr/Rech_Equipement.aspx	\N	active	440a2815-bfe0-486e-8a47-7e3a125f8c91	624552ff-a7cd-427d-88e3-f31ec6dba89b
4dbf7c31-5115-4700-963d-91f23f76aaa4	recensement-des-quipements-sportifs	Recensement des équipements sportifs	\N	http://www.res.sports.gouv.fr/Rech_Equipement.aspx	Ministère des sports	\N	\N	\N	Page de recherche des équipements sportifs en france.\r\nEn fonction de la typologie de recherche les résultats sont téléchargeables en .cvs ou xml.	\N	active	e96a0ae8-1830-40ae-bdd3-7d2f25961373	4dbf7c31-5115-4700-963d-91f23f76aaa4
8d447067-389f-4c39-ba51-63430a736df4	les-communes-face-aux-risques-majeurs	Les communes face aux risques majeurs	\N	http://macommune.prim.net/	Ministère du Développement Durable	\N	\N	\N	Site de visualisation des risques majeurs accessible par code insee ou nom  de la commune	\N	active	9704b3e5-ce20-4be1-8a7d-d9cb211f0cf6	8d447067-389f-4c39-ba51-63430a736df4
641c249c-f473-4d8e-bd8e-f385157f2682	epicentres-des-sismes-en-france	Epicentres des séismes en france	\N	http://www.sisfrance.net/	BRGM	\N	\N	\N	Épicentre des séismes ayant eu une incidence en france de 858 à 2007	notspecified	active	8b78ef6a-380d-4f62-a3aa-84f6256a8d15	641c249c-f473-4d8e-bd8e-f385157f2682
0a048cd8-5468-4fcd-bd67-50675c83002d	carte-de-la-sismicit-en-france	Carte de la sismicité en france	\N	http://www.sisfrance.net/	BRGM	\N	\N	\N	Carte de la sismicité et des tsunamis en france et dans les dom-tom par départements et communes	\N	active	add4fc8c-cacc-4c21-a011-10586b13504c	0a048cd8-5468-4fcd-bd67-50675c83002d
584d3863-eecc-4595-8a18-145ba2b213f7	qualit-des-eaux-de-baignade	Qualité des eaux de baignade	\N	http://baignades.sante.gouv.fr/navigMap.do?idCarte=baignades_metropole&listeActive=dpt#a	Ministère de la Santé	\N	\N	\N	Site de la qualité des eaux de baignade, avec visualisation sur carte par communes et possibilité de génération de rapports en .pdf	notspecified	active	bc33ab95-a7ce-4722-8c71-55da9972020d	584d3863-eecc-4595-8a18-145ba2b213f7
529d4aba-d25d-44d6-ba1b-d6ad314d6158	carte-des-mouvements-de-terrain-en-france	Carte des mouvements de terrain en france	\N	http://www.bdmvt.net/donnees_liste.asp	BRGM	\N	\N	\N	Carte des mouvements de terrains, éboulements, coulées de boues. les données concernant un événement sont exportables en .cvs.	notspecified	active	95696de0-b33b-4771-b20d-9b71dff9c316	529d4aba-d25d-44d6-ba1b-d6ad314d6158
8d7560cf-6d61-45dd-bf05-44ae257e97a4	carte-des-radars-fixes	Carte des radars fixes	\N	http://radars.securite-routiere.gouv.fr	Ministère de l'Écologie, du Développement durable, des Transports et du Logement	\N	\N	\N	Carte des radars fixes en france par communes, précédement la liste des radars était téléchargeable.	notspecified	active	fbd13c36-5e50-49d2-abd4-049e7e027453	8d7560cf-6d61-45dd-bf05-44ae257e97a4
02970c3a-2240-4a74-8fd3-18af09a9cd61	bases-de-donnes-du-ministre-de-la-culture	Bases de données du ministère de la culture	\N	http://www.culture.gouv.fr/mcc/Bases-de-donnees2	Ministère de la Culture	\N	\N	\N	Inventaire des bases de données du Ministère de la culture dont Mémoire et mérimée qui fournissent des données par communes.	notspecified	active	74d9b0ab-1a2e-4016-9f18-1afa11ead13b	02970c3a-2240-4a74-8fd3-18af09a9cd61
4acf41b9-9c8b-4a1e-a32e-a754abdce116	base-de-donnes-basol-sur-les-sites-et-sols-pollus	Base de données BASOL sur les sites et sols pollués	\N	http://basol.ecologie.gouv.fr/recherche.php	Ministère de l'Écologie, du Développement durable, des Transports et du Logement	\N	\N	\N	Base de données de sols pollués, recherche par commune	notspecified	active	12d7a85a-8498-40e0-ae5a-24239d9c82f7	4acf41b9-9c8b-4a1e-a32e-a754abdce116
c67a2104-aa5f-4e9f-830f-662ce97995d6	annuaire-de-ladministration	Annuaire de l'administration	\N	http://lannuaire.service-public.fr/	Dila	\N	\N	\N	Annuaire de l'administration édité par la Dila	notspecified	active	36a22994-298b-4c91-aad0-bfe101e12bbe	c67a2104-aa5f-4e9f-830f-662ce97995d6
5a3d4806-974f-4754-b6cb-65a7dfa27548	bibliothques-publiques-du-dpartement-des-vosges	Bibliothèques publiques du département des Vosges	\N	http://www.vosges-bdp.com/CartesBibliotheque88/bibliorecherche.asp	CG88	\N	\N	\N	Carte des bibliothèques publiques du département des Vosges.	notspecified	active	75cb2baa-b33b-4762-b981-b4f97364ed22	5a3d4806-974f-4754-b6cb-65a7dfa27548
9db98dbb-0a64-4588-8e57-533f05a6e050	tablissement-labelliss-qualit-tourisme	Établissement labellisés qualité tourisme	\N	http://www.qualite-tourisme.gouv.fr/index.php?reference=304	DGCIS Sous-direction du tourisme	\N	\N	\N	Établissement labellisés qualité tourisme en mars 2011, un .pdf téléchargeable par région.	notspecified	active	33125ba6-51d0-49db-88f0-d15ab1cfbb0e	9db98dbb-0a64-4588-8e57-533f05a6e050
205c33b6-106f-40c3-804c-a2835f6104a9	basias-inventaire-historique-de-sites-indutriels	Basias inventaire historique de sites indutriels	\N	http://basias.brgm.fr/donnees_liste.asp?	BRGM	\N	\N	\N	Basias, inventaire historique de sites indutriels, édité par le BRGM. Localisation par commune.\r\n	notspecified	active	7ffae5cf-57bd-40cf-ac63-1d66fb93e429	205c33b6-106f-40c3-804c-a2835f6104a9
f7a32926-f029-47f4-8649-e3b2997f69d3	innondations-carte-des-remontes-de-nappes	Innondations carte des remontées de nappes	\N	http://www.inondationsnappes.fr/donnees.asp?	BRGM	\N	\N	\N	Innondations, carte des remontées de nappes, localisation par communes.	notspecified	active	a945bf8f-ad7d-43e1-9374-bacf83b24c8b	f7a32926-f029-47f4-8649-e3b2997f69d3
f7a32926-f029-47f4-8649-e3b2997f69d3	innondations-carte-des-remontes-de-nappes	Inondations carte des remontées de nappes	\N	http://www.inondationsnappes.fr/donnees.asp?	BRGM	\N	\N	\N	Inondations, carte des remontées de nappes, localisation par communes.\r\nTéléchargement possible par département depuis http://www.inondationsnappes.fr/donneesDownload.asp?DPT=aucun en remplaçant aucun par le numéro du département.	notspecified	active	ddf7860e-3a1d-4321-ac1c-65e9157d813a	f7a32926-f029-47f4-8649-e3b2997f69d3
ced8947c-7c6b-4874-ad5e-c28ba91f8073	ala-de-retrait-de-gonflement-des-argiles	Aléa de retrait de gonflement des argiles	\N	http://www.argiles.fr/donneesDownLoad.asp?DPT=aucun	BRGM	\N	\N	\N	Carte des aléas de retrait de gonflement des argiles éditée par le BRGM. Téléchargement possible au format MIF−MID.	notspecified	active	2eb6042c-7740-4c4f-b636-76ce8ce6a357	ced8947c-7c6b-4874-ad5e-c28ba91f8073
b9582bd1-bfff-41e1-990f-962c18084f4d	villes-et-pays-dart-et-dhistoire	Villes et Pays d'art et d'histoire	\N	http://www.vpah.culture.fr/vpah/france/france.htm	Ministère de la Culture	\N	\N	\N	Carte des villes et Pays d'art et d'histoire, éditée par le Ministère de la Culture.	notspecified	active	9bdd4aa6-2e18-4e58-8914-1c4adf1b8916	b9582bd1-bfff-41e1-990f-962c18084f4d
1c17435c-508d-4194-9d06-f923d31c60cf	registre-des-cultures-ogm	Registre des cultures OGM	\N	http://www.ogm.gouv.fr/article.php3?id_article=110	OGM.fr	\N	\N	\N	Registre des cultures OGM, site interministériel. Les données sont celles de 2007. 	notspecified	active	1504af47-63ff-4fbf-b415-13f245e3530f	1c17435c-508d-4194-9d06-f923d31c60cf
e3623259-d93b-4596-930a-0282a07b5666	carte-des-monuments-nationaux	Carte des monuments nationaux	\N	http://www.monuments-nationaux.fr/fr/monuments/carte-des-monuments/	Centre des monuments nationaux	\N	\N	\N	Carte des monuments nationaux sur fond google maps.	notspecified	active	f29df221-7759-4fe2-bf70-c1c0f0f4d049	e3623259-d93b-4596-930a-0282a07b5666
b57f2ed1-ee10-469b-afcc-a4d7636d39c7	banatic-base-nationale-sur-lintercommunalit	Banatic base nationale sur l'intercommunalité	\N	http://www.banatic.interieur.gouv.fr/Banatic2/	DGCL Ministère de l'intérieur	\N	\N	\N	Base de la DGCL du ministère de l'intérieur sur l'intercommunalité	cada	active	b349135d-a405-4e84-a347-9acbd6b9c0a5	b57f2ed1-ee10-469b-afcc-a4d7636d39c7
f22a7938-303f-4ac6-92da-526a4ad2a207	situation-mensuelle-du-budget-de-ltat	Situation mensuelle du budget de l'état	\N	http://www.budget.gouv.fr/themes/finances_etat/budget/directions_services-budget-situation_mensuelle-sommaire.php	Ministère du Budget	\N	\N	\N	Situation mensuelle du budget de l'état, 4 mois sur l'année 2010	notspecified	active	5f4eb519-36a4-444a-bed2-c545d3f4d20b	f22a7938-303f-4ac6-92da-526a4ad2a207
b99894af-7866-4a81-beee-30e0e384b708	comptes-individuels-des-communes	Comptes individuels des communes	\N	http://www.colloc.bercy.gouv.fr/colo_otherfiles/divers/communes.html	Ministère du Budget	\N	\N	\N	Comptes individuels des communes entre 2000 et 2009.	notspecified	active	b87e9ad0-7f68-473d-a15b-64ca1f253bfc	b99894af-7866-4a81-beee-30e0e384b708
3d4e64cc-54c0-4b3e-b865-2fff3d9845e7	comptes-collectifs-des-communes	Comptes collectifs des communes	\N	http://www.colloc.bercy.gouv.fr/colo_struct_fina_loca/comp_coll/comm.html	Ministère du Budget	\N	\N	\N	Comptes collectifs des communes quelques jeux de données disponible au format .pdf.	notspecified	active	117f797d-1662-4d4f-8779-08a5af2ca1aa	3d4e64cc-54c0-4b3e-b865-2fff3d9845e7
83e56067-9ee5-48b2-83d0-91e723eb8b3d	donnes-hydromtriques-temps-rel-du-bassin-rhne-mditerrane	Données hydrométriques temps réel du bassin Rhône Méditerranée	\N	http://www.rdbrmc.com/hydroreel2/	Ministère de l'Écologie, du Développement durable, des Transports et du Logement	\N	\N	\N	Données hydrométriques temps réel du bassin Rhône Méditerranée. possibilité de voir en temps réel le débit des cours d'eau et de disposer de différents niveaux de statistique	notspecified	active	b5c703cf-ee4d-4b5d-b9fe-e5385976b7d9	83e56067-9ee5-48b2-83d0-91e723eb8b3d
e1b56ce2-aea6-4d44-b877-86a13f92697c	vigicrues---information-sur-la-vigilance-crues	Vigicrues : Information sur la vigilance "crues"	\N	http://www.vigicrues.gouv.fr/	Ministère de l'Écologie, du Développement durable, des Transports et du Logement	\N	\N	\N	Carte d'information sur la vigilance crues	notspecified	active	b4a1d15b-e861-453a-a288-467e743dd51b	e1b56ce2-aea6-4d44-b877-86a13f92697c
d6c6d3f9-5d8d-46c8-bc92-d8507d1e6f04	prix-des-terres-agricoles	Prix des terres agricoles	\N	http://agreste.agriculture.gouv.fr/enquetes/territoire-prix-des-terres/valeur-venale-des-terres-agricoles/	Ministère de l'Agriculture	\N	\N	\N	Valeur vénales des terres agricoles différents pdf à télécharger	notspecified	active	a7e3dd94-6c86-413f-abfe-3bed55bf9d85	d6c6d3f9-5d8d-46c8-bc92-d8507d1e6f04
8a7d516b-f3c2-4a5b-afde-d2bdff371937	donnees-cles-du-recensement-agricole-de-2000	Données clés du recensement agricole de 2000	\N	http://agreste.agriculture.gouv.fr/spip.php?page=dc_research&id_rubrique=464&	Ministère de l'Agriculture	\N	\N	\N	Données par communes.	\N	active	ce9bcc80-ad33-4db0-82d4-fb3cab033fd5	8a7d516b-f3c2-4a5b-afde-d2bdff371937
fe7cd753-376f-4f22-a721-caa482aa1116	cartographie-de-lobservatoire-du-val-de-saone	Cartographie de l'observatoire du val de Saône	\N	http://agreste.agriculture.gouv.fr/spip.php?page=dc_research&id_rubrique=464&	EPTB Saône et Doubs	\N	\N	\N	Carte interactive avec téléchargements possibles en .pdf sur la qualité des eaux, protection et mise en valeur des milieux naturels, gestion de l'inondabilité, mise en valeur	\N	active	34579160-706c-4b4e-86e7-1deddb37f9e0	fe7cd753-376f-4f22-a721-caa482aa1116
60e23204-8e78-487c-92bd-5de0c6102067	zonage-sismique-de-la-france	Zonage sismique de la France	\N	http://www.planseisme.fr/Zonage-sismique-de-la-France.html	BRGM	\N	\N	\N	Nouveau zonage sismique divisant le territoire national en cinq zones de sismicité croissante en fonction de la probabilité d’occurrence des séismes.	\N	active	9072590d-3b6f-4ac1-89d3-0751de5632a7	60e23204-8e78-487c-92bd-5de0c6102067
4654898f-58f4-482f-a91f-23aa5e192fd8	finances-des-communes-de-moins-de-10-000-habitants-en-2009	Finances des communes de moins de 10 000 habitants en 2009	\N	http://www.dgcl.interieur.gouv.fr/sections/a_votre_service/statistiques/budgets_locaux/finances_des_commune/les_finances_des_com5179/view	DGCL Ministère de l'intérieur	\N	\N	\N	\N	\N	active	2d7fa951-5b6e-494f-ad7e-a7afcea2cd4f	4654898f-58f4-482f-a91f-23aa5e192fd8
20100c39-31ae-4fd4-ad35-bfeabe396b5f	les-collectivites-locales-en-chiffres-2011	Les collectivités locales en chiffres 2011	\N	http://www.dgcl.interieur.gouv.fr/sections/a_votre_service/statistiques/collectivites_locale/les_ciollectivites_l/view	DGCL Ministère de l'intérieur	\N	\N	\N	Vingt-et-unième édition des Collectivités locales en chiffres. Son objectif est de fournir annuellement les informations statistiques essentielles sur les collectivités locales.	\N	active	12caea82-db74-4ffa-b7ed-c149e2352e9a	20100c39-31ae-4fd4-ad35-bfeabe396b5f
497e8d74-14c2-401e-bc0d-a4b473f77eb1	mises-en-service-dans-le-parc-social-de-1999-2009	Mises en service dans le parc social, de 1999 à 2009	\N	\N	Ministère de l'environnement	\N	\N	\N	\N	cada	active	fc63ab3d-50cd-4753-9ff3-12aa14ce6692	497e8d74-14c2-401e-bc0d-a4b473f77eb1
205c33b6-106f-40c3-804c-a2835f6104a9	basias-inventaire-historique-de-sites-indutriels	Basias inventaire historique de sites industriels	\N	http://basias.brgm.fr/donnees_liste.asp?	BRGM	\N	\N	\N	Basias, inventaire historique de sites industriels, édité par le BRGM. Localisation par commune.\r\n	notspecified	active	1d906f97-b22c-408a-b23a-823cf809d1c0	205c33b6-106f-40c3-804c-a2835f6104a9
1cf46091-d128-4e38-a7b7-97901d423aaf	dcisions-du-conseil-constitutionnel	Décisions du Conseil Constitutionnel	10-06-2011	http://datablog.owni.fr/2011/06/10/scraper-un-site-en-ruby-pour-les-nuls-ou-presque/	OWNI	\N	Sabine Blanc	\N	Toutes les décisions du Conseil Constitutionnel entre le 22 novembre 1958 et le 6 mai 2011 (Année, Numéro, Date, N°, Type, Intitulé, Décision, URL) parsées à partir du site du CC à l'aide d'un script ruby en vue d'une enquête datajournalisme d'OWNI.\r\n	cada	active	66b128d0-c36c-48b8-a78a-92b6182586d1	1cf46091-d128-4e38-a7b7-97901d423aaf
1cf46091-d128-4e38-a7b7-97901d423aaf	dcisions-du-conseil-constitutionnel	Décisions du Conseil Constitutionnel	10-06-2011	http://datablog.owni.fr/2011/06/10/scraper-un-site-en-ruby-pour-les-nuls-ou-presque/	OWNI	\N	Julien Kirch	archiloque@archiloque.net	Toutes les décisions du Conseil Constitutionnel entre le 22 novembre 1958 et le 6 mai 2011 (Année, Numéro, Date, N°, Type, Intitulé, Décision, URL) parsées à partir du site du CC à l'aide d'un script ruby en vue d'une enquête datajournalisme d'OWNI.\r\n	odc-odbl	active	15736681-e084-4bb1-bd3b-c6a7af777d00	1cf46091-d128-4e38-a7b7-97901d423aaf
ece794a5-613f-4607-9046-fb37906f87ce	marchs-publics-du-ministre-de-la-culture-2009	Marchés publics du Ministère de la Culture 2009	2009	http://www.culture.gouv.fr/mcc/Media/Fichiers/marches-2009	Ministère de la Culture et de la Communication	\N	\N	\N	Liste des marchés publics notifiés par le Ministère de la Culture et de la Communication en 2009	cada	active	1cc6d560-7a4a-4505-81e8-290e440c9c0b	ece794a5-613f-4607-9046-fb37906f87ce
d794f07a-06d3-4b59-a969-c00af70ff8db	marchs-publics-du-ministre-de-la-culture-2010	Marchés publics du Ministère de la Culture 2010	2010	http://www.culture.gouv.fr/mcc/Appels-d-offres/Liste-des-marches-2010	\tMinistère de la Culture et de la Communication	\N	Regards Citoyens	contact@regardscitoyens.org	Liste des marchés publics notifiés par le Ministère de la Culture et de la Communication en 2010	cada	active	5ec1bdc2-fcbf-4932-b6a6-247c87ed9377	d794f07a-06d3-4b59-a969-c00af70ff8db
5efedd90-782d-4129-8e71-fdd3b6e1c7df	marchs-publics-du-ministre-de-la-culture-2007	Marchés publics du Ministère de la Culture 2007	2007	http://www.culture.gouv.fr/mcc/Media/Fichiers/marches-2007	Ministère de la Culture et de la Communication	\N	\N	\N	Liste des marchés publics notifiés par le Ministère de la Culture et de la Communication en 2007	cada	active	195959a3-77de-4e3d-95e4-8c5989ddd65d	5efedd90-782d-4129-8e71-fdd3b6e1c7df
f1261a91-9d52-4520-837e-e9c793f28dcc	marchs-publics-du-ministre-de-la-culture-2008	Marchés publics du Ministère de la Culture 2008	2008	http://www.culture.gouv.fr/mcc/Media/Fichiers/marches-2008	Ministère de la Culture et de la Communication	\N	\N	\N	Liste des marchés publics notifiés par le Ministère de la Culture et de la Communication en 2008	cada	active	df459aea-8e94-463f-835f-cdcd6ec1327c	f1261a91-9d52-4520-837e-e9c793f28dcc
cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	activit-des-dputs-de-lassemble-nationale-13me-lgislature	Activité des députés de l'Assemblée nationale (13ème législature)	2011-03-01	http://www.regardscitoyens.org/telechargement/donnees/	Regards Citoyens	contact@regardscitoyens.org	\N	\N	Ensemble des données parlementaires sur les députés. Informations extraites du site de l'Assemblée nationale et du Journal Officiel pour la constitution du site http://NosDeputes.fr\r\nCes données comprennent toutes les informations disponibles sur chaque député, toutes les questions et interventions en séance publique et en commissions ainsi que tous les amendements, propositions de lois et rapports produits depuis le début de la législature.\r\nCes données sont celles en date du 1er du mois en cours et sont remises à jour mensuellement.\r\n\r\nUne API est également disponible pour accéder aux données : http://cpc.regardscitoyens.org/trac/wiki/API	cc-by-sa	active	ca799f60-69a3-4c16-bd13-b8a9e4e8a360	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab
df63f81c-7a27-49d1-86c8-8d5e49883d40	rseaux-sociaux-et-presse-en-li	Réseaux sociaux et presse en ligne	\N	http://www.rue89.com/presse-sans-presses/2011/08/17/reseaux-sociaux-le-monde-est-champion-france-24-cartonne-218204	Yann Guégan	\N	\N	\N	Présence de 45 sites de presse français sur les réseaux sociaux Facebook et Twitter entre décembre 2010 et août 2011.	notspecified	active	0f7316bd-5b12-443c-b846-ea48cd376a1c	df63f81c-7a27-49d1-86c8-8d5e49883d40
df63f81c-7a27-49d1-86c8-8d5e49883d40	rseaux-sociaux-et-presse-en-li	Réseaux sociaux et presse en ligne	2011-08-17	http://www.rue89.com/presse-sans-presses/2011/08/17/reseaux-sociaux-le-monde-est-champion-france-24-cartonne-218204	Yann Guégan	\N	\N	\N	Présence de 45 sites de presse français sur les réseaux sociaux Facebook et Twitter entre décembre 2010 et août 2011.	notspecified	active	b1f45939-ae99-4295-88a4-a4ad552f048f	df63f81c-7a27-49d1-86c8-8d5e49883d40
8d9cf757-de83-4774-919b-00c45c43efd4	fichier-prnoms	Fichier prénoms	1.0	http://insee.fr/fr/	INSEE	\N	\N	\N	Le fichier des prénoms est établi à partir des seuls bulletins de naissance des personnes nées en France y compris les départements d’Outre-mer (DOM). En conséquence, l’exhaustivité n’est pas garantie sur toute la période, notamment pour les années antérieures à 1946. Les utilisateurs pourront donc constater des écarts avec le nombre annuel des naissances évalué par l'Insee. Ces écarts, importants en début de période, vont en s’amenuisant. Après 1946, ils sont peu significatifs.	notspecified	active	657e1e1a-5a1b-40d4-b09c-61db5208662f	8d9cf757-de83-4774-919b-00c45c43efd4
8d9cf757-de83-4774-919b-00c45c43efd4	fichier-prnoms	Fichier prénoms	1.0	http://insee.fr/fr/	INSEE	\N	\N	\N	Le fichier des prénoms est établi à partir des seuls bulletins de naissance des personnes nées en France y compris les départements d’Outre-mer (DOM). En conséquence, l’exhaustivité n’est pas garantie sur toute la période, notamment pour les années antérieures à 1946. Les utilisateurs pourront donc constater des écarts avec le nombre annuel des naissances évalué par l'Insee. Ces écarts, importants en début de période, vont en s’amenuisant. Après 1946, ils sont peu significatifs.\r\n\r\nLes accents sont absents de ce fichier - "Céline" y est noté "Celine"... Une version accentuée serait beaucoup plus utile.	notspecified	active	55e7285f-efa1-4cb3-bdba-8dc749cbc7df	8d9cf757-de83-4774-919b-00c45c43efd4
196340e0-5246-4bc2-8b69-54c66a48b399	projet-de-loi-de-finances-2012-rpartition-des-recettes-et-dpenses	Projet de loi de finances 2012 Répartition des recettes et dépenses	2012-09-29	http://www.lemonde.fr/politique/visuel/2011/09/28/visualisez-le-projet-de-loi-de-finances-2012_1578820_823448.html	Ministère des finances	\N	\N	\N	Il s'agit des données fournies par le Ministère des Finances à [Alexandre Lechenet]("http://twitter.com/#!/Alphoenix"), journaliste de [LeMonde.fr]("http://www.lemonde.fr") pour la réalisation d'une [visualisation en treemap du projet de loi de finances du gouvernement pour 2012]("http://www.lemonde.fr/politique/visuel/2011/09/28/visualisez-le-projet-de-loi-de-finances-2012_1578820_823448.html").	cada	active	1220be1d-b2b7-491a-a02a-708eb1f990d7	196340e0-5246-4bc2-8b69-54c66a48b399
196340e0-5246-4bc2-8b69-54c66a48b399	projet-de-loi-de-finances-2012-rpartition-des-recettes-et-dpenses	Projet de loi de finances 2012 Répartition des recettes et dépenses	2012-09-29	http://www.lemonde.fr/politique/visuel/2011/09/28/visualisez-le-projet-de-loi-de-finances-2012_1578820_823448.html	Ministère des finances	\N	\N	\N	Il s'agit des données fournies par le Ministère des Finances à [Alexandre Lechenet](http://twitter.com/#!/Alphoenix), journaliste de [LeMonde.fr](http://www.lemonde.fr) pour la réalisation d'une [visualisation en treemap du projet de loi de finances du gouvernement pour 2012](http://www.lemonde.fr/politique/visuel/2011/09/28/visualisez-le-projet-de-loi-de-finances-2012_1578820_823448.html).	cada	active	d5cb2af1-959e-4994-ac00-6b16b90f6a0d	196340e0-5246-4bc2-8b69-54c66a48b399
196340e0-5246-4bc2-8b69-54c66a48b399	projet-de-loi-de-finances-2012-rpartition-des-recettes-et-dpenses	Projet de loi de finances 2012 Répartition des recettes et dépenses	2012-09-29	http://www.lemonde.fr/politique/visuel/2011/09/28/visualisez-le-projet-de-loi-de-finances-2012_1578820_823448.html	Ministère des finances	\N	\N	\N	Il s'agit des données fournies par le [Ministère duBudget](http://www.budget.gouv.fr/budget/presentation-projet-loi-finances-pour-2012-plf) à [Alexandre Lechenet](http://twitter.com/#!/Alphoenix), journaliste de [LeMonde.fr](http://www.lemonde.fr) pour la réalisation d'une [visualisation en treemap du projet de loi de finances du gouvernement pour 2012](http://www.lemonde.fr/politique/visuel/2011/09/28/visualisez-le-projet-de-loi-de-finances-2012_1578820_823448.html).	cada	active	91626032-ae06-4cc2-8b0c-19befe231a93	196340e0-5246-4bc2-8b69-54c66a48b399
7f6c30c6-d6a5-4d39-ae5d-e1ae4cc2d3ef	saone-et-loire	Saône-et-Loire	2011-10-22	http://www.opendata71.fr/	Direction des Systèmes d’Information et de l’Information Géographique du Département de Saône-et-Loire	\N	Pierre Martinerie	contact@cg71.fr	Le Département de Saône-et-Loire libère ses données.	lip	active	daf6450f-138d-42d9-acc4-c2f02339def3	7f6c30c6-d6a5-4d39-ae5d-e1ae4cc2d3ef
7f6c30c6-d6a5-4d39-ae5d-e1ae4cc2d3ef	saone-et-loire	Saône-et-Loire	2011-10-22	http://www.opendata71.fr/	Direction des Systèmes d’Information et de l’Information Géographique du Département de Saône-et-Loire	\N	Pierre Martinerie	contact@cg71.fr	Le Département de Saône-et-Loire (71) libère ses données via le site Opendata71.\r\nhttp://www.opendata71.fr	lip	active	a4331fba-6792-42b7-8843-715629e9d2b7	7f6c30c6-d6a5-4d39-ae5d-e1ae4cc2d3ef
cdc13d67-6360-43a6-bb99-cd68b64ee3f3	occupation-physique-du-territoire-insee	Occupation physique du territoire INSEE	\N	http://www.insee.fr/fr/themes/tableau.asp?reg_id=0&ref_id=NATTEF01337	\N	\N	\N	\N	Occupation physique du territoire.	notspecified	active	081aa116-4b83-4ecc-b179-41fc2f9c398b	cdc13d67-6360-43a6-bb99-cd68b64ee3f3
b99894af-7866-4a81-beee-30e0e384b708	comptes-individuels-des-communes	Comptes individuels des communes	\N	http://www.colloc.bercy.gouv.fr/colo_otherfiles/divers/communes.html	Ministère du Budget	\N	\N	\N	Comptes individuels des communes entre 2000 et 2010.	notspecified	active	f579ee41-b9dd-4c74-a8e7-e8260d76ce8b	b99894af-7866-4a81-beee-30e0e384b708
ac051eb3-275f-40a5-b160-e224d13902e7	les-dputs-franais	Les députés français	1.0	http://www.assemblee-nationale.fr/	Assemblée Nationale	http://www.assemblee-nationale.fr/	Alexandre Léchenet	lechenet@lemonde.fr	Données provenant d'un scrap du fiches députés de l'Assemblée, en se focalisant notamment sur les anciens mandats de députés et leur âge. Récupéré le 11 novembre 2011. Il y a à ce moment 562 députés en fonction.\r\nLa date de naissance, la date du début du premier mandat en timestamp. L'id correspond à la fiche sur le site de l'Assemblée. \r\nUne deuxième table contient tous les anciens mandats tels que décrits par le site. Date de début et de fin en timestamp.	notspecified	active	9bd678be-b57f-4582-9c02-1a5c106f9f2c	ac051eb3-275f-40a5-b160-e224d13902e7
ac051eb3-275f-40a5-b160-e224d13902e7	les-dputs-franais	Les députés français	1.0	http://www.assemblee-nationale.fr/	Assemblée Nationale	\N	Alexandre Léchenet	lechenet@lemonde.fr	Données provenant d'un scrap du fiches députés de l'Assemblée, en se focalisant notamment sur les anciens mandats de députés et leur âge. Récupéré le 11 novembre 2011. Il y a à ce moment 562 députés en fonction.\r\nLa date de naissance, la date du début du premier mandat en timestamp. L'id correspond à la fiche sur le site de l'Assemblée. \r\nUne deuxième table contient tous les anciens mandats tels que décrits par le site. Date de début et de fin en timestamp.	notspecified	active	a778d7d3-e61b-408b-99c7-1f89c7798181	ac051eb3-275f-40a5-b160-e224d13902e7
67906f75-4298-4b6a-aa62-d8314be33f15	azdada	azdada	\N	\N	\N	\N	\N	\N	\N	\N	active	b2d865df-9629-4ee2-9b55-17e1b8c7a715	67906f75-4298-4b6a-aa62-d8314be33f15
67906f75-4298-4b6a-aa62-d8314be33f15	prsence-des-dputs-au-cours-de-la-session-2010-2011	Présence des députés au cours de la session 2010-2011	2011-08	http://www.nosdeputes.fr/confiseurs/2011/	Regards CitoyensCitoyens	contact@regardscitoyens.org	\N	\N	Données relatives aux sanctions encourues par les députés insuffisamment présents à l'Assemblée au cours de la session 2010-2011.\r\nLe collectif Regards Citoyens a mené une étude à partir des données de http://NosDeputes.fr visant à évaluer l'incidence des modifications du règlement sur la participation des députés aux travaux de l'Assemblée, notamment aux réunions des commissions. Le règlement impose en effet avec ses articles 42 et 159 des sanctions financières sur l'indemnité de fonction des députés manifestant des absences répétées aux réunions de leur commission permanente le mercredi matin ou aux scrutins solennels en hémicycle.	odc-odbl	active	6e196cec-2bdc-4b09-b540-8d55debe949b	67906f75-4298-4b6a-aa62-d8314be33f15
f3d8ca3c-32b9-4485-95d9-0b1fd4a5dd4e	prsence-des-dputs-au-cours-de-la-session-2009-2010	Présence des députés au cours de la session 2009-2010	2010-07	http://www.nosdeputes.fr/confiseurs/2010/	Regards Citoyens	contact@regardscitoyens.org	\N	\N	Données relatives aux sanctions encourues par les députés insuffisamment présents à l'Assemblée au cours de la session 2009-2010.\r\nLe collectif Regards Citoyens a mené une étude à partir des données de http://NosDeputes.fr visant à évaluer l'incidence des modifications du règlement sur la participation des députés aux travaux de l'Assemblée, notamment aux réunions des commissions. Le règlement impose en effet avec ses articles 42 et 159 des sanctions financières sur l'indemnité de fonction des députés manifestant des absences répétées aux réunions de leur commission permanente le mercredi matin ou aux scrutins solennels en hémicycle.	odc-odbl	active	df2739ce-379a-42e2-acce-04b95b44d349	f3d8ca3c-32b9-4485-95d9-0b1fd4a5dd4e
7f6c30c6-d6a5-4d39-ae5d-e1ae4cc2d3ef	saone-et-loire	Saône-et-Loire	2011-10-22	http://www.opendata71.fr/	Direction des Systèmes d’Information et de l’Information Géographique du Département de Saône-et-Loire	\N	Pierre Martinerie	contact@cg71.fr	Le Département de Saône-et-Loire (71) libère ses données via le site Opendata71.\r\nhttp://www.opendata71.fr	apie-v2	active	aca77db3-5f9c-43a0-a515-cd093e4e1428	7f6c30c6-d6a5-4d39-ae5d-e1ae4cc2d3ef
84b91384-8ec9-4b55-8dc9-28ff8c6db62f	horaires-des-quipements-culturels-nantes	Horaires des équipements culturels Nantes	1	http://data.nantes.fr/donnees/detail/?tx_icsoddatastore_pi1[keywords]=horaires&tx_icsoddatastore_pi1[date]=&tx_icsoddatastore_pi1[dateValid]=&tx_icsoddatastore_pi1[uid]=27	Nantes Métropole	contact@mairie-nantes.fr	Nantes Métropole	contact@mairie-nantes.fr	Horaires des équipements culturels de Nantes Métropole.\r\n\r\nIls sont classés en deux catégories :\r\n\r\n- les ouvertures dites normales qui sont schématisées en « semaine type d'ouverture » du lundi au dimanche\r\n\r\n- Les exceptions (ouverture ou fermeture) qui, à une date donnée, annulent et remplacent l'ouverture dite normale de l'équipement culturel\r\n\r\nDate de dernière mise à jour    : 15/11/2011                                    	odc-odbl	active	e4086bee-133a-43fd-b352-10bacd65ee70	84b91384-8ec9-4b55-8dc9-28ff8c6db62f
84b91384-8ec9-4b55-8dc9-28ff8c6db62f	horaires-des-quipements-culturels-nantes	Horaires des équipements culturels Nantes	1	http://data.nantes.fr/donnees/detail/?tx_icsoddatastore_pi1[keywords]=horaires&tx_icsoddatastore_pi1[date]=&tx_icsoddatastore_pi1[dateValid]=&tx_icsoddatastore_pi1[uid]=27	Nantes Métropole	contact@mairie-nantes.fr	Nantes Métropole	contact@mairie-nantes.fr	Horaires des équipements culturels de Nantes Métropole.\r\n\r\nIls sont classés en deux catégories :\r\n\r\n- les ouvertures dites normales qui sont schématisées en « semaine type d'ouverture » du lundi au dimanche\r\n\r\n- Les exceptions (ouverture ou fermeture) qui, à une date donnée, annulent et remplacent l'ouverture dite normale de l'équipement culturel\r\n\r\nDate de dernière mise à jour    : 15/11/2011	odc-odbl	active	c5249a7a-fe9d-4d85-ae81-2c8d1c65ebb2	84b91384-8ec9-4b55-8dc9-28ff8c6db62f
1dacf074-ad54-432a-a04f-cecd3a068d0c	entreprises-controles-par-letat	Entreprises controlées par l'Etat	2010	http://www.insee.fr/fr/themes/detail.asp?ref_id=ir-recme2010&page=irweb/recme2010/dd/recme2010_repertoire.htm	Insee	\N	\N	\N	\N	\N	active	5c5b9cbd-eac0-40d0-86f0-0d9c9ae096b7	1dacf074-ad54-432a-a04f-cecd3a068d0c
1dacf074-ad54-432a-a04f-cecd3a068d0c	entreprises-controles-par-letat	Entreprises controlées par l'Etat	2010	http://www.insee.fr/fr/themes/detail.asp?ref_id=ir-recme2010&page=irweb/recme2010/dd/recme2010_repertoire.htm	Insee	\N	\N	\N	\N	other-closed	active	53c90be2-0cdf-4365-adf1-024e2dbae590	1dacf074-ad54-432a-a04f-cecd3a068d0c
32ccab1e-e85e-4f52-84f5-69bbcc5fa53d	taux-de-chmage-standardis-eurostat	Taux de chômage standardisé - Eurostat	1	http://webstat.banque-france.fr/fr/browse.do?node=5384229	webstat.banque-france.fr	webmestre@banque-france.fr	Banque de France, Armand PUJAL	webmestre@banque-france.fr	Données disponibles sur l'outil Webstat de la Banque de France.\r\nNom du dataset: Taux de chômage ;\r\nPériodicité: Mensuel ;\r\nCorrection statistique: CVS ;\r\nConcept - contexte STS: Taux de chômage ;\r\nClassification - contexte STS: Taux, Total (Tous ages), Total (hommes et femmes) ;\r\nInstitution d`origine: Eurostat ;\r\nVariation - contexte STS: Non spécifié	\N	active	10ac057b-4a62-4be2-9333-99cbb69c179a	32ccab1e-e85e-4f52-84f5-69bbcc5fa53d
89a894cc-c5c8-44e2-9ca3-85ab9a0130f9	budget-de-ltat-2009---2012	Budget de l'État 2009 - 2012	2012-11-28	http://voila-le-travail.data-projet.com/budget2012/	Jean Abbiateci	\N	Regards Citoyens	contact@regardscitoyens.org	Données extraites du site Performance Publique http://www.performance-publique.budget.gouv.fr/ à partir des lois de finances de 2009 à 2012 par Jean Abbiateci pour réaliser la visualisation treemap accessible sur le blog "Et voilà le travail" : http://voila-le-travail.data-projet.com/budget2012/	cada	active	d7f22ef7-54bb-4348-b287-62fcb6da90f0	89a894cc-c5c8-44e2-9ca3-85ab9a0130f9
5b23d4f4-058e-44e0-945d-ae9035fb1e15	liste-des-maires-de-seine-maritime	Liste des maires de Seine Maritime	\N	\N	Préfecture de Seine Maritime	\N	\N	\N	Liste de tous les maires de Seine-Maritime.	\N	active	c358b6bb-4b0a-48ee-9421-0854d1f68fca	5b23d4f4-058e-44e0-945d-ae9035fb1e15
159b6644-94ed-406d-8e1e-1f002f265396	prenoms-des-enfants-a-nantes-en-2010	Prénoms des enfants nés à Nantes (2010)	\N	http://data.nantes.fr/donnees/detail/?tx_icsoddatastore_pi1[uid]=59	Ville de Nantes	contact@mairie-nantes.fr	Ville de Nantes	contact@mairie-nantes.fr	Liste des prénoms des enfants nés à Nantes en 2010 avec le nombre d’occurrences de chaque prénom.\r\n\r\nLorsque le nombre d'occurrences est inférieur ou égal à 5, cette donnée n'est pas publiée, conformément aux préconisations de la CNIL.	odc-odbl	active	502b47d9-44a6-4b77-8f21-1f36c2d6eeb9	159b6644-94ed-406d-8e1e-1f002f265396
be516eed-8a37-436c-af75-b623f0806f39	donnees-de-trafic-de-grandes-villes	Données de Trafic de grandes villes	\N	http://www.bison-fute.equipement.gouv.fr/fr/article.php3?id_article=274	Bison Futé	\N	\N	\N	Bison Futé met à disposition en XML des données de trafic de 13 villes françaises : Bordeaux, Lyon, Marseille, Lille, Caen, Rennes, Nantes, Saint Étienne, Grenoble, Strasbourg, Clermont-Ferrand, Limoge, et la Savoie.\r\n\r\nLes données de trafic sont actualisées toutes les 6 minutes.\r\n\r\n\r\nVoir aussi la page http://www.bison-fute.equipement.gouv.fr/fr/article.php3?id_article=545	\N	active	df68a822-74c8-41c1-8cfe-d0d1a685c74f	be516eed-8a37-436c-af75-b623f0806f39
0e14dccb-9c28-4f89-b3b2-cb1011be06d1	financement-des-associations-par-l-etat	Financement des associations par l'état	\N	http://www.performance-publique.gouv.fr/farandole/2010/jaune.html#resultat	Ministère du Budget, des Comptes publics, de la Fonction publique et de la Réforme de l'État (=> Bercy)	\N	bboissin	\N	Dans les plans de finance, il y a des données financières notamment sur le financement des associations. Elles se trouvent dans le tome 3 des annexes jaunes.\r\n\r\nUne extraction de ces données a été réalisée à l'occasion de la préparation de la loi de finance 2010.\r\n\r\nRemarque : Le PDF http://www.performance-publique.budget.gouv.fr/fileadmin/medias/documents/ressources/circulaires/1BLF-07-774_guide.pdf semble montrer la structure des données en interne.	cc-by	active	0b54823d-ebef-4a0a-934c-e408c127861a	0e14dccb-9c28-4f89-b3b2-cb1011be06d1
02970c3a-2240-4a74-8fd3-18af09a9cd61	bases-de-donnes-du-ministre-de-la-culture	Bases de données du ministère de la culture	\N	http://www.culturecommunication.gouv.fr/En-pratique/Bases-de-donnees	Ministère de la Culture	\N	\N	\N	Inventaire des bases de données du Ministère de la culture dont Mémoire et mérimée qui fournissent des données par communes.\r\n\r\nL'ancienne page http://www.culture.gouv.fr/mcc/Bases-de-donnees2 redirige vers http://www.culturecommunication.gouv.fr/En-pratique/Bases-de-donnees suite au changement de site (Culture.gouv.fr a changé fin novembre 2011 pour devenir culturecommunication.gouv.fr)\r\n\r\n* http://www.rhone-alpes.culture.gouv.fr/basepat/ pour la base de données des associations du patrimoine en Rhône-Alpes\r\n\r\nExtrait de la version au 30/11/2011 :\r\n\r\n* TCMH - Techniques contemporaines utilisées dans les monuments historiques\r\nTechniques contemporaines de restauration dans les monuments historiques\r\n* Thesaurus architecture (base Vocabulaires - Thésaurus) : 3.700 termes utiles à la dénomination des oeuvres architecturales et mobilières\r\n* Trouvtou : Liaison des bases de données sur le patrimoine "immeuble". 137.000 notices.\r\n* Ulysse : Images numérisées sur les empires coloniaux français. Photographies, affiches, cartes et plans conservés aux Archives nationales d'outre-mer. 5.000 images\r\n* Vingt années de construction de bibliothèques publiques en Rhône-Alpes 1986 - 2005	notspecified	active	9af8b293-f532-43bf-b8cb-06195f021079	02970c3a-2240-4a74-8fd3-18af09a9cd61
fe7cd753-376f-4f22-a721-caa482aa1116	cartographie-de-lobservatoire-du-val-de-saone	Cartographie de l'observatoire du val de Saône	\N	http://www.observatoire-saone.fr/index.php?id=96	EPTB Saône et Doubs	\N	\N	\N	Carte interactive avec téléchargements possibles en .pdf sur la qualité des eaux, protection et mise en valeur des milieux naturels, gestion de l'inondabilité, mise en valeur	other-closed	active	22c78088-f8e8-4d24-b35a-fc6c6c65ea47	fe7cd753-376f-4f22-a721-caa482aa1116
8a7d516b-f3c2-4a5b-afde-d2bdff371937	donnees-cles-du-recensement-agricole-de-2000	Données clés du recensement agricole de 2000	\N	http://agreste.agriculture.gouv.fr/spip.php?page=dc_research&id_rubrique=464&	Ministère de l'Agriculture	\N	\N	\N	Données par communes.\r\n\r\nExemple avec dans le département de l'Eure-et-Loir, dans la commune de Bonneval :\r\n* Nombre d'exploitations \t 24 \r\n* dont nombre d'exploitations professionnelles \t 20 \r\n* Nombre de chefs d'exploitation et de coexploitants \t 30 \r\n* Nombre d'actifs familiaux sur les exploitations \t 43 \r\n* Nombre total d'actif sur les exploitations \r\n(en UTA,équivalent temps plein) \t 35 \r\n* Superficie agricole utilisée des exploitations (ha) \t 2129 \r\n* Terres labourables (ha) \t 2057 \r\n* Superficie toujours en herbe (ha) \t 70 \r\n* Nombre total de vaches \t c \r\n* Rappel : Nombre d'exploitations en 1988 \t 46\r\n\r\nRemarque : D'autres informations sont disponible sur http://agreste.agriculture.gouv.fr/enquetes/recensement-agricole/	\N	active	30c271f8-7b1c-4a14-855c-9dc9420f1ca9	8a7d516b-f3c2-4a5b-afde-d2bdff371937
1dacf074-ad54-432a-a04f-cecd3a068d0c	entreprises-controles-par-letat	Entreprises controlées par l'Etat	2010	http://www.insee.fr/fr/themes/detail.asp?ref_id=ir-recme2010&page=irweb/recme2010/dd/recme2010_repertoire.htm	Insee	\N	\N	\N	Voir aussi http://www.insee.fr/fr/themes/detail.asp?ref_id=ir-recme2010&page=irweb/recme2010/dd/recme2010_repertoire.htm (1994-2010)\r\net http://www.insee.fr/fr/themes/detail.asp?ref_id=ir-recme2010	other-closed	active	ee816bc2-0316-4adc-ac10-300df9306594	1dacf074-ad54-432a-a04f-cecd3a068d0c
df6c89f3-4473-424b-a0b0-119977da62c5	liste-des-communes-cantons-arrondissements	Liste des communes, des cantons, des arrondissements	\N	http://www.insee.fr/fr/methodes/nomenclatures/cog/telechargement.asp	Insee	\N	\N	\N	\N	\N	active	177926cc-1263-4323-9dad-14032641b0a5	df6c89f3-4473-424b-a0b0-119977da62c5
0460ea96-a830-40bd-adfb-140aad4c31ca	liste-prenoms-declares-etat-civil-paris	Liste des prénoms déclarés à l'état-civil à Paris	\N	http://opendata.paris.fr/opendata/jsp/site/Portal.jsp?document_id=60&portlet_id=106	Ville de Paris	\N	\N	\N	\N	odc-odbl	active	2b5ac88c-ed8c-4fee-b013-103238447a18	0460ea96-a830-40bd-adfb-140aad4c31ca
159b6644-94ed-406d-8e1e-1f002f265396	prenoms-des-enfants-a-nantes	Prénoms des enfants nés à Nantes	\N	http://data.nantes.fr/donnees/detail/?tx_icsoddatastore_pi1[uid]=59	Ville de Nantes	contact@mairie-nantes.fr	Ville de Nantes	contact@mairie-nantes.fr	Liste des prénoms des enfants nés à Nantes en 2010 avec le nombre d’occurrences de chaque prénom.\r\n\r\nLorsque le nombre d'occurrences est inférieur ou égal à 5, cette donnée n'est pas publiée, conformément aux préconisations de la CNIL.	odc-odbl	active	d8097172-e1a3-4d79-b40a-3c3ec12be908	159b6644-94ed-406d-8e1e-1f002f265396
641c249c-f473-4d8e-bd8e-f385157f2682	epicentres-des-sismes-en-france	Epicentres des séismes en france	\N	http://www.sisfrance.net/	BRGM	\N	\N	\N	Épicentre des séismes ayant eu une incidence en france de 858 à 2007\r\n\r\nFichier France :\r\nListe des épicentres de SisFrance/Métropole d'intensité égale ou supérieure à 5\r\n\r\nPour les Antilles :\r\nListe des épicentres de SisFrance/Métropole d'intensité égale ou supérieure à 5\r\n\r\nPour la Réunion :\r\nListe des épicentres de SisFrance/Réunion d'intensité égale ou supérieure à 4\r\n\r\nSource : BRGM, EDF, IRSN, Base de données nationale de la sismicité historique SisFrance\r\n\r\nPour la Nouvelle-Calédonie :\r\nListe des épicentres de SisFrance/Nouvelle-Calédonie d'intensité égale ou supérieure à 4\r\n\r\nSource : BRGM, Base de données nationale de la sismicité historique SisFrance-Calédonie	notspecified	active	903899a1-b57f-44c8-9818-15fc47ead4da	641c249c-f473-4d8e-bd8e-f385157f2682
fea6dcd6-00d6-4ad5-ab2f-eb40f533a5db	listes-des-communes-par-rgions-dpartements-circonscriptions	Listes des communes par régions, départements, circonscriptions	2011-12-31	http://www.nosdonnees.fr/wiki/index.php/Image:Regions_departements_circonscriptions_communes_gps.csv.gz	Regards Citoyens	contact@regardscitoyens.org	Regards Citoyens	contact@regardscitoyens.org	Il s'agit d'une compilation de différentes informations tirées de Wikipedia et du travail de http://www.galichon.com/codesgeo/ donnant pour chaque commune de France les informations précises sur leurs régions (et chefs-lieux), départements (et préfectures), circonscriptions, codes INSEE, codes postaux et coordonnées GPS pour l'essentiel des communes de métropole.	odc-odbl	active	cc7f9237-21a1-4e74-ac5f-5cfa6dc1c499	fea6dcd6-00d6-4ad5-ab2f-eb40f533a5db
de5557e1-bf16-433b-87ff-401323a97df5	resultats-des-elections-legislatives-2002	Résultats des élections législatives 2002	\N	\N	Ministère de l'Intérieur	\N	Regards Citoyens	contact@regardscitoyens.org	Données obtenues auprès du ministère de l'intérieur. Elles correspondent aux résultats des deux tours de l'élection législatives de 2002, bureaux de vote par bureaux de vote. 	cada	active	9f2365d7-35db-4301-8a4c-351671cc2694	de5557e1-bf16-433b-87ff-401323a97df5
47034ede-0506-4650-9fb4-1948168440ca	resultats-des-elections-persidentielles-2002	Résultats des présidentielles 2002	\N	\N	Ministère de l'Intérieur	\N	Regards Citoyens	contact@regardscitoyens.org	Données obtenues auprès du ministère de l'intérieur. Elles correspondent aux résultats des deux tours de l'élection présidentielle de 2002, bureaux de vote par bureaux de vote. 	cada	active	db2345f0-bd43-4f1d-b50d-c263b791d1c2	47034ede-0506-4650-9fb4-1948168440ca
27983c75-8b7c-47bd-ad03-10a9e1ca4d25	ecole	ecole	\N	\N	\N	\N	\N	\N	\N	\N	active	2107f175-c0c5-4f9b-8c79-63eaef240f56	27983c75-8b7c-47bd-ad03-10a9e1ca4d25
bfd1388a-ec10-4a7b-9d94-916f56f52f98	liste-des-fichiers-de-datagouvfr	Liste des fichiers de data.gouv.fr	\N	\N	Regards Citoyens	\N	\N	\N	Ce fichier CSV mis à jour lorsque de nouvelles données sont détectées sur le site data.gouv.fr permet de connaitre les données mises à disposition sur le portail édité par Étalab.\r\n	odc-odbl	active	5037ad29-b65d-490a-bd23-d79c405ec466	bfd1388a-ec10-4a7b-9d94-916f56f52f98
bfd1388a-ec10-4a7b-9d94-916f56f52f98	liste-des-fichiers-de-datagouvfr	Liste des fichiers de data.gouv.fr	\N	\N	Regards Citoyens	\N	Regards Citoyens	\N	Ce fichier CSV mis à jour lorsque de nouvelles données sont détectées sur le site data.gouv.fr permet de connaitre les données mises à disposition sur le portail édité par Étalab.\r\n	odc-odbl	active	853347f0-4e13-4d06-a24d-c4a4c28d4762	bfd1388a-ec10-4a7b-9d94-916f56f52f98
8708a912-1b80-441d-9ba3-d607dd2f0c7c	liste-des-tuiles-des-orthophotographies-de-la-communaute-urbaine-de-nantes	Liste des tuiles des orthophotographies de la communauté urbaine de Nantes	\N	http://data.nantes.fr/donnees/orthophotographie-aerienne/	Nantes Métropole	\N	Teymour	\N	URL des zip contenant les tuiles des orthophotos des villes de la communauté urbaine de Nantes. La résolution des images est de 20 cm, la classe de précision est de 40 cm. Les prises de vues sont numériques et ont été réalisées en juin 2005.	odc-odbl	active	153a48b3-24af-44e4-ab07-9d5610e890da	8708a912-1b80-441d-9ba3-d607dd2f0c7c
25dd2269-e0f3-4653-98ac-33f64f09d4d3	liste-des-circonscriptions-lgislatives-franaises-suite-au-redcoupage-lectoral-de-2012	Liste des circonscriptions législatives françaises suite au redécoupage électoral de 2012	2012-02-14	http://www.nosdonnees.fr/wiki/index.php/Image:Circonscriptions.csv	Candidats.fr	contact@candidats.fr	Regards Citoyens	contact@regardscitoyens.org	Description de la composition (cantons/communes) des 577 circonscriptions législatives après le redécoupage de 2012.\r\nRéalisé à partir des données de NosDeputes.fr et du Journal officiel pour les besoins des Candidats.fr	odc-odbl	active	4bba233a-f5ab-48de-ab8d-8f9f386fbf77	25dd2269-e0f3-4653-98ac-33f64f09d4d3
b815db66-cadf-4c3c-ae0b-73ad5bf1a46e	statistiques-dmographiques-insee-sur-les-nouvelles-circonscriptions-lgislatives-de-2012	Statistiques démographiques INSEE sur les nouvelles circonscriptions législatives de 2012	2012-02-17	http://www.insee.fr/fr/themes/detail.asp?reg_id=0&ref_id=circo_leg-2012	INSEE	\N	Regards Citoyens	contact@regardscitoyens.org	Indicateurs statistiques sur les 556 circonscriptions des départements de métropole, de Guadeloupe, de Martinique, de Guyane et de La Réunion après le redécoupage de 2012.\r\n- population par tranche d'âge\r\n- population par sexe et âge\r\n- population de 15 ans ou plus par sexe et catégorie socioprofessionnelle\r\n- population selon la nationalité\r\n- logements par catégorie\r\n- population des ménages par type de ménage\r\n	odc-odbl	active	78218970-639e-4d24-93ed-244cd4decfcb	b815db66-cadf-4c3c-ae0b-73ad5bf1a46e
275e4c19-2885-4630-b049-e365374c27fb	500-signatures-des-candidats-aux-elections-presidentielles-de-1995-2002-et-20	500 signatures des candidats aux élections présidentielles de 1995, 2002 et 2007	\N	\N	\N	\N	\N	\N	Issu de :\r\n - pour 2007 : \r\nhttp://www.legifrance.gouv.fr/jo_pdf.do?cidTexte=JPDF2403200700000001\r\n - pour 2002 : \r\nhttp://www.legifrance.gouv.fr/affichTexte.do?cidTexte=JORFTEXT000000407519\r\n - pour 1995 : http://www.legifrance.gouv.fr/affichTexte.do?cidTexte=JORFTEXT000000847420\r\n\r\nAttention l'usage statistique est complexe car les 500 signatures sont tirées au sort parmi les signatures présentées aux Conseil Constitutionnel lors du dépôt des candidatures. Ce tirage au sort prend en compte la répartition géographique et les impératif légaux en la matière :  http://www.legifrance.gouv.fr/affichTexte.do?cidTexte=LEGITEXT000006068219&dateTexte=vig	\N	active	35fc3cd3-516a-494d-b6fa-b82140444685	275e4c19-2885-4630-b049-e365374c27fb
275e4c19-2885-4630-b049-e365374c27fb	500-signatures-des-candidats-aux-elections-presidentielles-de-1995-2002-et-20	500 signatures des candidats aux élections présidentielles de 1995, 2002 et 2007	\N	\N	Conseil Constitutionnel	\N	\N	\N	Issu de :\r\n - pour 2007 : \r\nhttp://www.legifrance.gouv.fr/jo_pdf.do?cidTexte=JPDF2403200700000001\r\n - pour 2002 : \r\nhttp://www.legifrance.gouv.fr/affichTexte.do?cidTexte=JORFTEXT000000407519\r\n - pour 1995 : http://www.legifrance.gouv.fr/affichTexte.do?cidTexte=JORFTEXT000000847420\r\n\r\nAttention l'usage statistique est complexe car les 500 signatures sont tirées au sort parmi les signatures présentées aux Conseil Constitutionnel lors du dépôt des candidatures. Ce tirage au sort prend en compte la répartition géographique et les impératif légaux en la matière :  http://www.legifrance.gouv.fr/affichTexte.do?cidTexte=LEGITEXT000006068219&dateTexte=vig	cada	active	cdf50818-ce06-46aa-878f-c837506e82c5	275e4c19-2885-4630-b049-e365374c27fb
e3e52ca7-2e9e-4f87-a818-5a808823089b	guede97	OBSERVATION ET STATISTIQUES	\N	http://www.statistiques.developpement-durable.gouv.fr/	\N	\N	\N	\N	Base de donnée gigantesque des statistiques sur\r\n\r\nLogement – Construction, Transports, Énergies et climat, Environnement, Développement durable, Conjoncture, Territoires\r\n\r\nprincipalement sous forme de rapports pdf	cada	active	31206ec8-7ac4-40c3-b06d-5f0e5f4f4da0	e3e52ca7-2e9e-4f87-a818-5a808823089b
fea6dcd6-00d6-4ad5-ab2f-eb40f533a5db	listes-des-communes-par-rgions-dpartements-circonscriptions	Listes des communes par régions, départements, circonscriptions	2011-12-31	http://www.nosdonnees.fr/wiki/index.php/Image:EUCircos_Regions_departements_circonscriptions_communes_gps.csv.gz	Regards Citoyens	contact@regardscitoyens.org	Regards Citoyens	contact@regardscitoyens.org	Il s'agit d'une compilation de différentes informations tirées de Wikipedia et du travail de http://www.galichon.com/codesgeo/ donnant pour chaque commune de France les informations précises sur leurs régions (et chefs-lieux), départements (et préfectures), circonscriptions législatives et européennes, codes INSEE, codes postaux et coordonnées GPS pour l'essentiel des communes de métropole.	odc-odbl	active	8412388c-5c82-452d-ad9e-3247056c0cd2	fea6dcd6-00d6-4ad5-ab2f-eb40f533a5db
1399fe4b-2c07-4bda-a720-9df928d51816	dclaration-patrimoniale-nicolas-sarkozy	Déclaration patrimoniale Nicolas Sarkozy	1	http://www.nosdonnees.fr/wiki/index.php/Image:Patrimoine_Nicolas_Sarkozy.csv	Caro_lm	carolinelemoign@gmail.com	\N	\N	Déclaration patrimoniale de Nicolas Sarkozy au 11 mai 2006 et au 24 mars 2012, selon les déclaration JORF n°109 du 11 mai 2007 page 8458 \r\ntexte n° 2, et JORF n°0072 du 24 mars 2012 page 5363 \r\ntexte n° 1 (legifrance)	odc-odbl	active	46739a51-d0ab-416a-9dff-632a03351fcf	1399fe4b-2c07-4bda-a720-9df928d51816
cea11492-fdec-4cfc-a179-a4bbc05cac0b	500-signatures-des-candidats-aux-lections-prsidentielles-de-2012	500 signatures des candidats aux élections présidentielles de 2012	beta	http://www.regardscitoyens.org/telechargement/presidentielles-2012/	Regards Citoyens	contact@regardscitoyens.org	Regards Citoyens	contact@regardscitoyens.org	Issu de : http://www.legifrance.gouv.fr/affichTexte.do?cidTexte=JORFTEXT000025595654\r\nRecoupé avec les affiliations politiques des élus (en cours)	odc-odbl	active	369831c1-22de-4dea-b0b7-b9a33cef2875	cea11492-fdec-4cfc-a179-a4bbc05cac0b
41b0a731-3378-42bd-9e08-8b69a1fee83a	rsultats-et-participation-llection-prsidentielle-2012	Résultats et participation à l'élection présidentielle 2012	2012-04-23	http://www.regardscitoyens.org/election-presidentielle-2012-le-live-opendata/#data	Ministère de l'Intérieur	\N	Regards Citoyens	contact@regardscitoyens.org	\N	odc-odbl	active	0d252ab1-5819-41f4-af54-4036c3226e98	41b0a731-3378-42bd-9e08-8b69a1fee83a
4dbf7c31-5115-4700-963d-91f23f76aaa4	recensement-des-quipements-sportifs	Recensement des équipements sportifs	\N	http://www.res.sports.gouv.fr/Rech_Equipement.aspx	Ministère des sports	\N	\N	\N	Page de recherche des équipements sportifs en france.\r\nEn fonction de la typologie de recherche les résultats sont téléchargeables en .cvs ou xml.	lo	active	da5cfa24-ee10-4a43-b6a6-1780c5c56c14	4dbf7c31-5115-4700-963d-91f23f76aaa4
c4556598-bcc7-4c45-8ae8-bdafc367eaa2	presidentielle-2012-resultats-par-commes-et-par-circo-des-franais-de-l-etranger-pour-les-deux-t	Présidentielle 2012 : Résultats par commes et par circo des français de l'étranger pour les deux tours	\N	\N	Ministère de l'Intérieur	\N	Regards Citoyens	\N	Données fournies par le ministère de l'intérieur divisés en deux fichiers pour chacun des deux tours : un fichier communes françaises et un fichier circonscription des français de l'étranger.	lo	active	16ca20be-8985-498c-a6b3-29ecc4358399	c4556598-bcc7-4c45-8ae8-bdafc367eaa2
c4556598-bcc7-4c45-8ae8-bdafc367eaa2	presidentielle-2012-resultats-par-commes-et-par-circo-des-francais-de-l-etranger-pour-les-deux-t	Présidentielle 2012 : Résultats par commes et par circo des français de l'étranger pour les deux tours	\N	\N	Ministère de l'Intérieur	\N	Regards Citoyens	\N	Données fournies par le ministère de l'intérieur divisés en deux fichiers pour chacun des deux tours : un fichier communes françaises et un fichier circonscription des français de l'étranger.	lo	active	6f381a79-d61c-4bf9-bbd2-4c96c8b058d8	c4556598-bcc7-4c45-8ae8-bdafc367eaa2
41b0a731-3378-42bd-9e08-8b69a1fee83a	resultats-et-participation-l-election-presidentielle-2012	Résultats et participation à l'élection présidentielle 2012	2012-04-23	http://www.regardscitoyens.org/election-presidentielle-2012-le-live-opendata/#data	Ministère de l'Intérieur	\N	Regards Citoyens	contact@regardscitoyens.org	\N	lo	active	99b202f2-e5fe-4e54-beed-2722204ba204	41b0a731-3378-42bd-9e08-8b69a1fee83a
c4556598-bcc7-4c45-8ae8-bdafc367eaa2	presidentielle-2012-resultats-par-commes-et-par-circo-des-francais-de-l-etranger-pour-les-deux-t	Présidentielle 2012 : Résultats par commune et par circonscription des français de l'étranger pour les deux tours	\N	\N	Ministère de l'Intérieur	\N	Regards Citoyens	\N	Données fournies par le ministère de l'intérieur divisées en deux fichiers pour chacun des deux tours : un fichier communes françaises et un fichier circonscriptions des français de l'étranger.	lo	active	bc6d4de3-006e-4b29-8a65-5f884d994708	c4556598-bcc7-4c45-8ae8-bdafc367eaa2
41b0a731-3378-42bd-9e08-8b69a1fee83a	resultats-et-participation-l-election-presidentielle-2012	Résultats et participation à l'élection présidentielle 2012	2012-05-12	http://www.regardscitoyens.org/election-presidentielle-2012-le-live-opendata/#data	Ministère de l'Intérieur	\N	Regards Citoyens	contact@regardscitoyens.org	\N	lo	active	c5caedf1-1874-4f69-b34a-af3ae71236d9	41b0a731-3378-42bd-9e08-8b69a1fee83a
1399fe4b-2c07-4bda-a720-9df928d51816	dclarations-patrimoniales-presidents	Déclarations patrimoniales des derniers présidents de la République	2	http://www.nosdonnees.fr/wiki/index.php/Image:Declarations_Patrimoines_Presidents.csv	Caro_lm	carolinelemoign@gmail.com	Regards Citoyens	contact@regardscitoyens.org	Déclaration patrimoniale de Nicolas Sarkozy au 11 mai 2007 et au 24 mars 2012 et de François Hollande au 11 mai 2012, selon les déclaration JORF n°109 du 11 mai 2007 page 8458 \r\ntexte n° 2, et JORF n°0072 du 24 mars 2012 page 5363 \r\ntexte n° 1 et JORF n°0110 du 11 mai 2012 page 9000\r\ntexte n° 2  (legifrance)	odc-odbl	active	59317601-caee-4b10-bc04-8f4ce5006fcc	1399fe4b-2c07-4bda-a720-9df928d51816
2a4bae91-082b-4ae5-9729-08c86e000ab5	comptes-de-lassociation-regards-citouyens	Comptes de l'association Regards Citoyens	quotidienne	http://www.regardscitoyens.org/qui-sommes-nous/	Regards Citoyens	contact@regardscitoyens.org	Regards Citoyens	contact@regardscitoyens.org	Par souci de transparence, Regards Citoyens publie le détail de ses comptes de fonctionnement mis-à-jour quotidiennement.	odc-odbl	active	0a8e67c3-482a-4ef4-ac82-1a64eb975d4a	2a4bae91-082b-4ae5-9729-08c86e000ab5
2a4bae91-082b-4ae5-9729-08c86e000ab5	comptes-de-lassociation-regards-citoyens	Comptes de l'association Regards Citoyens	quotidienne	http://www.regardscitoyens.org/qui-sommes-nous/	Regards Citoyens	contact@regardscitoyens.org	Regards Citoyens	contact@regardscitoyens.org	Par souci de transparence, Regards Citoyens publie le détail de ses comptes de fonctionnement mis-à-jour quotidiennement.	odc-odbl	active	133e9e8e-01da-481e-909d-367708fce0c2	2a4bae91-082b-4ae5-9729-08c86e000ab5
cd42a806-cac1-452c-9b0d-116d8ead4d64	liste-des-candidats-aux-lections-lgislatives-2012-dans-chaque-circonscription	Liste des candidats aux élections législatives 2012 dans chaque circonscription	2012-05-21	http://komodo.regardscitoyens.org/public/legislatives2012/	Ministère de l'Intérieur	\N	Regards Citoyens	contact@regardscitoyens.org	Le premier tour dans un premier temps.	lo	active	85ec5f06-1543-41ef-9aaa-fa4f60123d60	cd42a806-cac1-452c-9b0d-116d8ead4d64
cd42a806-cac1-452c-9b0d-116d8ead4d64	liste-des-candidats-aux-lections-lgislatives-2012-dans-chaque-circonscription	Liste des candidats aux élections législatives 2012 dans chaque circonscription	2012-05-31	http://komodo.regardscitoyens.org/public/legislatives2012/	Ministère de l'Intérieur	\N	Regards Citoyens	contact@regardscitoyens.org	Le premier tour dans un premier temps.\r\n\r\nLes données ont été progressivement corrigées grâce aux retours des utilisateurs puis à la seconde version fournie par le Ministère.\r\n\r\nLe second fichier enregistré identifie les corrections réalisées chez nous et non présentes dans les données du ministère republiées sur data.gouv.fr <http://www.data.gouv.fr/donnees/view/L%C3%A9gislatives-2012---Liste-des-candidats-du-1er-tour-551833>	lo	active	6976eef5-92e8-45c2-bc2b-9bfc60341674	cd42a806-cac1-452c-9b0d-116d8ead4d64
e657011b-cf83-47ab-8bc8-62f6498046a6	comptes-agenda-et-bilans-de-lassociation-libertic	Comptes, agenda et bilans de l'association LiberTIC	2011	http://libertic.wordpress.com/libertic/	LiberTIC	\N	LiberTIC	\N	Par souci de transparence, LiberTIC publie le détail de son bilan et dossier comptable, ses comptes de fonctionnement et son agenda.\r\n	odc-odbl	active	5ff6213f-387b-4fa1-b818-fd7c5e9151bc	e657011b-cf83-47ab-8bc8-62f6498046a6
30bcda76-5a1a-4369-a6f3-ed2584ad4031	dclarations-dintrets-des-membres-du-gouvernement-francais	Déclarations d'intérêts des membres du gouvernement français	2012-06-13	http://www.nosdonnees.fr/wiki/index.php/D%C3%A9clarations_Int%C3%A9rets_des_Ministres	Gouvernement français	\N	Regards Citoyens	contact@regardscitoyens.org	Depuis avril 2011, les membres du gouvernement français doivent rendre publiques leurs déclarations d'intérêts sur le site gouvernement.fr\r\n\r\nUn rassemblement et une extration des documents pdf ont été réalisés afin de rendre cette information plus facilement interprétable.\r\n\r\nUn .csv données a été fait pour le gouvernement Fillon, un autre pour le gouvernement Ayrault	cada	active	8f541934-f087-4b2d-8130-3cf847c85689	30bcda76-5a1a-4369-a6f3-ed2584ad4031
30bcda76-5a1a-4369-a6f3-ed2584ad4031	dclarations-dintrets-des-membres-du-gouvernement-francais	Déclarations d'intérêts des membres du gouvernement français	2012-06-13	http://www.nosdonnees.fr/wiki/index.php/D%C3%A9clarations_Int%C3%A9rets_des_Ministres	Gouvernement français	\N	Regards Citoyens	contact@regardscitoyens.org	Depuis avril 2011, les membres du gouvernement français doivent rendre publiques leurs déclarations d'intérêts sur le site gouvernement.fr\r\n\r\nUn rassemblement et une extration des documents pdf ont été réalisés afin de rendre cette information plus facilement interprétable.\r\n\r\nUn .csv données a été fait pour le gouvernement Fillon, un autre pour le gouvernement Ayrault	odc-odbl	active	6eccd4c9-6c1b-4e45-a065-05553ba71ff6	30bcda76-5a1a-4369-a6f3-ed2584ad4031
d6c6d3f9-5d8d-46c8-bc92-d8507d1e6f04	prix-des-terres-agricoles	Prix des terres agricoles	\N	http://agreste.agriculture.gouv.fr/enquetes/territoire-prix-des-terres/valeur-venale-des-terres-agricoles/	Ministère de l'Agriculture	\N	\N	\N	Valeur vénales des terres agricoles différents pdf et XLS à télécharger.\r\nSource: http://agreste.agriculture.gouv.fr/enquetes/territoire-prix-des-terres/valeur-venale-des-terres-agricoles/ où on trouve les définitions et méthodologies.	notspecified	active	2f7105eb-514c-4a4b-9271-b33aef907680	d6c6d3f9-5d8d-46c8-bc92-d8507d1e6f04
61d87eb7-e3d3-4f90-a3a8-b43b5362db1a	carte-du-decoupage-des-circonscriptions-electorales-legislatives-2012-	Carte du découpage des circonscriptions électorales législatives (2012+)	2012-06	http://www.jeromecukier.net/projects/elections/projections950.html	Jérôme Cukier	@JCukier	Regards Citoyens	contact@regardscitoyens.org	Carte réalisée par Jérôme Cukier pour ses projets de visualisation des données électorales 2012 : http://www.jeromecukier.net/projects/elections/projections950.html\r\n\r\nIdentifiants des zones :\r\nDD = code département (01 à 95 971 à 977 987 988 999)\r\nCC = numéro circonscription (01 à 21)\r\nDépartements : id="gDD" \r\nCirconscriptions : id = "cDDCC"	odc-odbl	active	b062326e-1f5d-48e3-a67b-9114ca9e15a4	61d87eb7-e3d3-4f90-a3a8-b43b5362db1a
aac3a30b-36a9-4887-8aab-81c552bfc7d7	toxicode	Countours des circonscriptions des législatives	1.0.0	http://www.toxicode.fr/circonscriptions	Toxicode	\N	Pierre Lancien	\N	Pour construire ces données, nous avons utilisé ces deux sources :\r\n\r\n  - Les contours de communes fournis par l'IGN / GEOFLA\r\n  - Les correspondances entre circonscriptions et communes, fournies par le Ministère de l'intérieur\r\n\r\n### Format des données\r\n\r\n  - code_circonscription : le code du département + le numéro de la circoncription,  ex : 69002\r\n  - departement : la code du département, ex : 69\r\n  - numero : le numéro de circonscription, ex : 2,\r\n  - communes : codes INSEE des communes qui sont (entièrement ou partiellement) dans la circonscription, séparés par le caractère '-'. ex : 69382-69381-69384-69389\r\n  - kml_shape : polygone(s) de la circonscription, au format KML\r\n  - edited_shape : 'false' si le contour est simplement un regroupement des contours de communes. 'true' si nous l'avons édité.\r\n\r\nDavantage d'explications sur [le site de Toxicode](http://www.toxicode.fr/circonscriptions)	odc-odbl	active	ec886521-f454-451d-af59-53aadbcf4bbc	aac3a30b-36a9-4887-8aab-81c552bfc7d7
f1b3849e-9568-4cae-a3a0-3cca7f42c079	carte-des-circonscriptions-lgislatives-2012	Carte des circonscriptions législatives 2012	1.0	http://www.regardscitoyens.org/telechargement/donnees/	Regards Citoyens	contact@regardscitoyens.org	Regards Citoyens	contact@regardscitoyens.org	\N	odc-odbl	active	9fbb919a-209f-482e-89aa-7fd9e82a7989	f1b3849e-9568-4cae-a3a0-3cca7f42c079
f1b3849e-9568-4cae-a3a0-3cca7f42c079	carte-des-circonscriptions-lgislatives-2012	Carte des circonscriptions législatives françaises (2012+)	1.0	http://www.regardscitoyens.org/telechargement/donnees/	Regards Citoyens	contact@regardscitoyens.org	Regards Citoyens	contact@regardscitoyens.org	Carte réalisée grace aux données suivantes : \r\nFrance métropolitaine et Outre-mer : http://www.nosdonnees.fr/package/toxicode ; Partie de l'Outre-mer manquante : \r\nhttp://www.nosdonnees.fr/package/carte-du-decoupage-des-circonscriptions-electorales-legislatives-2012-	odc-odbl	active	91785866-4772-4249-9659-5484c2c4a91d	f1b3849e-9568-4cae-a3a0-3cca7f42c079
27597355-d542-4574-adc8-6493883d1454	redevances-de-rutilisation-dinformations-publique	Redevances de réutilisation d'informations publique	1.0	http://www.nosdonnees.fr/wiki/index.php/Redevances_de_r%C3%A9utilisation_d_informations_publiques_%C3%A9tablies_avant_le_1er_juillet_2011	\N	\N	\N	\N	Liste des données soumises à redevance, relevant de l'État et des EPA, avant le 1er juillet 2011.	odc-odbl	active	4859fec8-5318-4618-83d3-564fa1dcffd9	27597355-d542-4574-adc8-6493883d1454
27597355-d542-4574-adc8-6493883d1454	redevances-de-rutilisation-dinformations-publique	Redevances de réutilisation d'informations publiques	1.0	http://www.nosdonnees.fr/wiki/index.php/Redevances_de_r%C3%A9utilisation_d_informations_publiques_%C3%A9tablies_avant_le_1er_juillet_2011	Regards Citoyens	contact@regardscitoyens.org	\N	\N	Liste des données soumises à redevance, relevant de l'État et des EPA	odc-odbl	active	8cade445-98c7-4340-8aaa-34f0c304d0e9	27597355-d542-4574-adc8-6493883d1454
382ceece-628f-43b1-8847-ea92ff04376f	comptes-de-campagne-des-candidats-llection-prsidentielle-2012	Comptes de campagne des candidats à l'élection présidentielle 2012	2012-08-08	http://www.nosdonnees.fr/wiki/index.php/Image:Comptes_campagne_pr%C3%A9sidentielle_2012.csv	Regards Citoyens	contact@regardscitoyens.org	Regards Citoyens	contact@regardscitoyens.org	Le Journal Officiel propose en PDF toutes ces informations : http://www.regardscitoyens.org/temp/120731-JORF-Presidentielle-ComptesCampagne.pdf\r\n\r\nDataPublica les a numérises dans un tableur multi-feuillets\r\nhttp://www.data-publica.com/data/14417--comptes-de-campagne-declares-des-candidats-a-l-election-presidentielle-2012\r\n\r\nLes voici désormais en données exploitables.	odc-odbl	active	d982c3cc-785b-44af-9d31-fd3fb152558b	382ceece-628f-43b1-8847-ea92ff04376f
382ceece-628f-43b1-8847-ea92ff04376f	comptes-de-campagne-des-candidats-a-l-election-presidentielle-2012	Comptes de campagne des candidats à l'élection présidentielle 2012	2012-08-08	http://www.nosdonnees.fr/wiki/index.php/Image:Comptes_campagne_pr%C3%A9sidentielle_2012.csv	Regards Citoyens	contact@regardscitoyens.org	Regards Citoyens	contact@regardscitoyens.org	Le Journal Officiel propose en PDF toutes ces informations : http://www.regardscitoyens.org/temp/120731-JORF-Presidentielle-ComptesCampagne.pdf\r\n\r\nDataPublica les a numérises dans un tableur multi-feuillets\r\nhttp://www.data-publica.com/data/14417--comptes-de-campagne-declares-des-candidats-a-l-election-presidentielle-2012\r\n\r\nLes voici désormais en données exploitables.	odc-odbl	active	85c539c3-04f1-49e6-8749-07470b4ee6a6	382ceece-628f-43b1-8847-ea92ff04376f
382ceece-628f-43b1-8847-ea92ff04376f	comptes-de-campagne-des-candidats-a-l-election-presidentielle-2012	Comptes de campagne des candidats à l'élection présidentielle 2012	2012-08-08	http://www.nosdonnees.fr/wiki/index.php/Image:Comptes_campagne_pr%C3%A9sidentielle_2012.csv	Regards Citoyens	contact@regardscitoyens.org	Regards Citoyens	contact@regardscitoyens.org	Le Journal Officiel propose en PDF toutes ces informations : [http://www.regardscitoyens.org/temp/120731-JORF-Presidentielle-ComptesCampagne.pdf](http://www.regardscitoyens.org/temp/120731-JORF-Presidentielle-ComptesCampagne.pdf)\r\n\r\nDataPublica les a numérises dans un tableur multi-feuillets :\r\n[http://www.data-publica.com/data/14417--comptes-de-campagne-declares-des-candidats-a-l-election-presidentielle-2012](http://www.data-publica.com/data/14417--comptes-de-campagne-declares-des-candidats-a-l-election-presidentielle-2012)\r\n\r\nLes voici désormais en données exploitables.	odc-odbl	active	b38759cd-8953-4448-8c61-ba3b596923ed	382ceece-628f-43b1-8847-ea92ff04376f
8d9cf757-de83-4774-919b-00c45c43efd4	fichier-prnoms	Fichier prénoms	1.0	http://insee.fr/fr/	INSEE	\N	\N	\N	Le fichier des prénoms est établi à partir des seuls bulletins de naissance des personnes nées en France y compris les départements d’Outre-mer (DOM). En conséquence, l’exhaustivité n’est pas garantie sur toute la période, notamment pour les années antérieures à 1946. Les utilisateurs pourront donc constater des écarts avec le nombre annuel des naissances évalué par l'Insee. Ces écarts, importants en début de période, vont en s’amenuisant. Après 1946, ils sont peu significatifs.\r\n\r\nLes accents sont absents de ce fichier - "Céline" y est noté "Celine"... Une version accentuée serait beaucoup plus utile.	cada	active	d6fe63e4-8d4f-49c6-8658-6d711c69b848	8d9cf757-de83-4774-919b-00c45c43efd4
61d87eb7-e3d3-4f90-a3a8-b43b5362db1a	carte-du-decoupage-des-circonscriptions-electorales-legislatives-2012-	Carte du découpage des circonscriptions électorales législatives 2012+	2012-06	http://www.jeromecukier.net/projects/elections/projections950.html	Jérôme Cukier	@JCukier	Regards Citoyens	contact@regardscitoyens.org	Carte réalisée par Jérôme Cukier pour ses projets de visualisation des données électorales 2012 : http://www.jeromecukier.net/projects/elections/projections950.html\r\n\r\nIdentifiants des zones :\r\nDD = code département (01 à 95 971 à 977 987 988 999)\r\nCC = numéro circonscription (01 à 21)\r\nDépartements : id="gDD" \r\nCirconscriptions : id = "cDDCC"	odc-odbl	active	d283c9b6-1bf8-4e4c-9893-be095c2af78a	61d87eb7-e3d3-4f90-a3a8-b43b5362db1a
4f8c2ed1-52a1-4c94-854e-631daeb1a154	statistiques-des-tribunaux-francais	Statistiques des tribunaux français sur 12 mois	\N	\N	Ministère de la justice	\N	\N	\N	Délais de traitement sur 12 mois (juillet 2011 et juin 2012) et stock des dossiers (30 juin 2012) des différentes cours d'appel, TGI, tribunaux d'instance et conseils des prudhommes français.	cada	active	b4fc3c0a-6704-495c-b092-cbeec8f14ace	4f8c2ed1-52a1-4c94-854e-631daeb1a154
4f8c2ed1-52a1-4c94-854e-631daeb1a154	statistiques-des-tribunaux-francais	Statistiques des tribunaux français sur 12 mois	\N	\N	Ministère de la justice	\N	\N	\N	Délais de traitement sur 12 mois (juillet 2011 et juin 2012) et stock des dossiers (30 juin 2012) des différentes cours d'appel, TGI, tribunaux d'instance et conseils des prudhommes français.\r\n\r\nD'après http://www.nosdeputes.fr/frontend_dev.php/14/question/QE/4092	cada	active	363e3792-e7f3-4248-84bc-3c828c049ba3	4f8c2ed1-52a1-4c94-854e-631daeb1a154
4f8c2ed1-52a1-4c94-854e-631daeb1a154	statistiques-des-tribunaux-francais	Statistiques des tribunaux français sur 12 mois	\N	\N	Ministère de la justice	\N	\N	\N	Délais de traitement sur 12 mois (juillet 2011 et juin 2012) et stock des dossiers (30 juin 2012) des différentes cours d'appel, TGI, tribunaux d'instance et conseils des prudhommes français.\r\n\r\nD'après <http://www.nosdeputes.fr/14/question/QE/4092>	cada	active	fdb4b6ae-6ce5-4741-aac1-877119b6d04b	4f8c2ed1-52a1-4c94-854e-631daeb1a154
e6833b4c-3f1e-4394-a547-790258b451e5	rattachement-financier-aux-partis-politiques-des-dputs-de-la-14me-lgislature	Rattachement financier aux partis politiques des députés de la 14ème législature	121205	http://www.assemblee-nationale.fr/qui/	Assemblee nationale	\N	Regards Citoyens	contact@regardscitoyens.org	En vue d'attribuer la seconde part du financement public des partis politiques, les parlementaires doivent chaque année déclarer leurs rattachement à un parti politique. Pour la première fois en 2012, l'Assemblée nationale publie un document précisant ces informations:[http://www.assemblee-nationale.fr/qui/Rattachement_partis.pdf](http://www.assemblee-nationale.fr/qui/Rattachement_partis.pdf)	odc-odbl	active	da99599d-79c0-47b0-8f59-3f2fc4bf3bed	e6833b4c-3f1e-4394-a547-790258b451e5
e6833b4c-3f1e-4394-a547-790258b451e5	rattachement-financier-aux-partis-politiques-des-dputs-de-la-14me-lgislature	Rattachement financier aux partis politiques des députés de la 14ème législature	121205	http://www.assemblee-nationale.fr/qui/	Assemblee nationale	\N	Regards Citoyens	contact@regardscitoyens.org	En vue d'attribuer la seconde part du financement public des partis politiques, les parlementaires doivent chaque année déclarer leurs rattachement à un parti politique. Pour la première fois en 2012, l'Assemblée nationale publie un document précisant ces informations :[http://www.assemblee-nationale.fr/qui/Rattachement_partis.pdf](http://www.assemblee-nationale.fr/qui/Rattachement_partis.pdf)	odc-odbl	active	3fb0c1db-fff3-4704-8bea-a69cff4f441e	e6833b4c-3f1e-4394-a547-790258b451e5
\.


--
-- Data for Name: package_role; Type: TABLE DATA; Schema: public; Owner: ckantest
--

COPY package_role (user_object_role_id, package_id) FROM stdin;
598e779b-759b-42fc-8924-33f7592c9600	587ed76e-1c2f-4cc7-a23a-f9beb2415c77
ff24fa50-de23-4f18-a03b-a4fa1b64e6f7	587ed76e-1c2f-4cc7-a23a-f9beb2415c77
c2ff8eb6-fc11-4403-85ec-178e8f55f1da	4402487d-3e8d-4618-8444-b400c6337834
d76bd78b-7efb-477e-8c60-d505370ff781	4402487d-3e8d-4618-8444-b400c6337834
7dd1da41-6e7a-4ace-b504-598bc92601eb	4235252c-aa21-46b5-8c52-110f95bdc583
49f647ca-2fd9-483c-b677-1b629b44b6ce	4235252c-aa21-46b5-8c52-110f95bdc583
340e7e82-f25e-4dc0-9cfc-c977042c4944	e3424ea9-f7c0-4d80-832b-890c3de0f744
61993bcb-7124-4620-843b-a53da69cabc0	e3424ea9-f7c0-4d80-832b-890c3de0f744
c9f5922c-29fe-4923-9ac1-9cd5503dab84	db34f769-ed94-45d3-8b66-5ebaf9b091ff
6bd66cf4-b714-460c-9994-524224205739	db34f769-ed94-45d3-8b66-5ebaf9b091ff
ed21c306-305d-4556-8d64-42045a3ddd27	65d7e18e-c5ab-4736-bb9e-c47de2dc41e1
61e6691b-879d-4a26-bc8b-5d516e4e5921	65d7e18e-c5ab-4736-bb9e-c47de2dc41e1
0fd97672-0b59-4574-b22a-1a53e5518ee6	3aa0d5ce-cef6-4158-b51e-ddee8ece7b5e
9ef8994a-87a7-49f3-8ef5-714f0d6c4c9e	3aa0d5ce-cef6-4158-b51e-ddee8ece7b5e
29bf7fbb-43fc-467d-9baa-df9c5b474ccd	97b2cf1e-91f4-4b08-a7d8-2e6bd1dca37e
b6ca7202-fe64-43b7-92d1-80b0dd1751c9	97b2cf1e-91f4-4b08-a7d8-2e6bd1dca37e
5fa640da-17eb-4c73-a007-0740ec880842	e4c69e90-1056-4f46-9619-57d0a18d1737
3d85a6ff-7bf8-4d1c-958c-200b20d7ac2a	e4c69e90-1056-4f46-9619-57d0a18d1737
40e448df-8ff4-4cd1-98e6-128586842f11	43c3cc44-3a6c-469b-80fe-913927d2c283
c9844b00-38e1-41ea-b9e9-e2e418706a42	43c3cc44-3a6c-469b-80fe-913927d2c283
867e9b3c-ff6e-4542-80c0-92589b700a69	43c3cc44-3a6c-469b-80fe-913927d2c283
c028b37f-d404-4526-988a-8b00a45a5c01	1901d722-a38d-4e79-a13c-ca51d61bae30
8a7a24e9-22f0-499e-bb0b-9bc7b21f6181	1901d722-a38d-4e79-a13c-ca51d61bae30
4fe50cec-967a-4db8-8910-77a7b76766be	1901d722-a38d-4e79-a13c-ca51d61bae30
015f0bb5-8075-42b2-91b9-2070a401ac8f	5b23d4f4-058e-44e0-945d-ae9035fb1e15
93ab98fc-fd23-4b34-8734-fb57d2663274	5b23d4f4-058e-44e0-945d-ae9035fb1e15
a2e1ad93-b436-4181-b9f1-80a510410105	be516eed-8a37-436c-af75-b623f0806f39
067b184f-b089-42e4-bba0-af4a18e4fd87	be516eed-8a37-436c-af75-b623f0806f39
5c0955e7-beea-412d-b412-e5e4b7b4caa5	5e86134f-2cb5-40e9-affa-f80d934a14b9
647b5cfa-96a1-4012-ab92-2a9e5a396d9a	5e86134f-2cb5-40e9-affa-f80d934a14b9
fd3f7aa8-8148-4ac8-9615-0ad9102012bb	5e86134f-2cb5-40e9-affa-f80d934a14b9
c819c4e3-28e1-4e49-a35d-e16d1a2bf479	6d999f74-d520-4a8c-8188-5a5c13c6bbec
4f217ee0-cbf7-46ad-ae9f-b51f70cd7cc0	6d999f74-d520-4a8c-8188-5a5c13c6bbec
620d12ca-35ca-4ef9-9236-53839ae79509	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab
ec610b89-0b09-4b3b-865e-0e403e881414	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab
bf30030b-e1d0-4ee0-a3ac-5c02d9f3f8a3	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab
463c1f22-dcef-4f88-af9e-6146889ece0c	f6c6aac7-3c9b-4a3c-80bc-d6709bc95d4b
c482eebd-bdb4-4b3e-88e7-33241c33ae23	f6c6aac7-3c9b-4a3c-80bc-d6709bc95d4b
0a6b9951-4ebb-48f9-91a5-0168401c86b2	f6c6aac7-3c9b-4a3c-80bc-d6709bc95d4b
be67cc57-1145-4f67-a174-40e1d5fb2e1c	6968ef13-1d2f-4de3-b533-706bc9c0f604
6ae317ea-8123-413e-a52d-316eb406bb6d	6968ef13-1d2f-4de3-b533-706bc9c0f604
a06d76ca-7747-4e42-944a-8c3319b16074	6968ef13-1d2f-4de3-b533-706bc9c0f604
0ceef28a-eca5-4df7-bc9f-af6d57579cc7	f3d8ca3c-32b9-4485-95d9-0b1fd4a5dd4e
b3766e5a-94ca-4e05-ae49-7d1f1cabc4c6	f3d8ca3c-32b9-4485-95d9-0b1fd4a5dd4e
664c5312-7207-42fb-8403-2bcbe83779e5	f3d8ca3c-32b9-4485-95d9-0b1fd4a5dd4e
4f2a1638-ffb1-4305-baa8-f27a53d12661	69361720-3428-417e-beb4-d21df542992c
e62af199-e3af-4e34-9117-0db336b918d6	69361720-3428-417e-beb4-d21df542992c
744721a9-7e44-4683-a600-99362a68a44b	69361720-3428-417e-beb4-d21df542992c
9a5b2e63-a320-4ab1-977c-9c21659b7e89	0e14dccb-9c28-4f89-b3b2-cb1011be06d1
3c4da846-93f3-4324-9848-c8c9733b7045	0e14dccb-9c28-4f89-b3b2-cb1011be06d1
c879d153-36d1-454e-bb64-61ccb190ef4b	34269022-c891-4a8e-a814-3af2b0fea526
5c1541a2-1efc-4c64-94a1-5bbdd9701417	34269022-c891-4a8e-a814-3af2b0fea526
7edf0268-981c-4a3d-a81e-50b0af2255a2	a1019da5-cdac-4e09-8b60-831994b5f275
b8eee993-7bf0-413a-a2d1-09908fc5e0d8	a1019da5-cdac-4e09-8b60-831994b5f275
dab93e14-fa2b-4424-b9f0-65576ddc9614	a1019da5-cdac-4e09-8b60-831994b5f275
67cf321d-e74f-4012-867e-225837a9f5d6	29772378-f226-4fc8-8e01-9a87c5e43a00
e90d3919-95d4-4f66-9c2e-6beefca1a54f	29772378-f226-4fc8-8e01-9a87c5e43a00
08442e90-4240-44c4-85a1-83b53f4fd357	29772378-f226-4fc8-8e01-9a87c5e43a00
67842479-cd88-4c48-9e1c-704b5f33b902	3fabe36b-965b-498d-9b3a-0649bbbfd0a5
da51e49b-70a5-4f47-a398-b7f67f81b727	3fabe36b-965b-498d-9b3a-0649bbbfd0a5
bf1cf1f5-e40c-4d71-a98e-305764b2eb95	3fabe36b-965b-498d-9b3a-0649bbbfd0a5
200c6ed7-0084-441c-b191-feacdd9fdcef	2502f9a7-15fa-439d-8a48-f61f38cb6f55
2157f13a-0e15-4bd9-b044-0bfe8a653300	2502f9a7-15fa-439d-8a48-f61f38cb6f55
15b23ed9-81dd-4886-9158-1e929818d8e2	2502f9a7-15fa-439d-8a48-f61f38cb6f55
6fd9cc14-b617-446d-a336-647def9514ca	4276f7df-c7e9-44e1-8886-20ad41ebda0a
4d95b21b-ca54-4f0c-8395-a44a42d78592	4276f7df-c7e9-44e1-8886-20ad41ebda0a
2c7518d7-ba29-4303-a00d-72d9328969fc	4276f7df-c7e9-44e1-8886-20ad41ebda0a
9852d952-8280-4358-820e-afce9bb306d5	f4517261-c1ee-4380-b3ad-0de5a0edc09a
4501832e-1121-4f7c-b3e8-31e3f2b0d54e	f4517261-c1ee-4380-b3ad-0de5a0edc09a
6dea6ba7-de99-456f-9895-d21981075027	f4517261-c1ee-4380-b3ad-0de5a0edc09a
674d5e58-db09-4262-ad03-c2e8865f883a	9382520e-adb5-4403-848d-5bd5ea476202
921a8a1b-a863-4232-b6ed-470879b66916	9382520e-adb5-4403-848d-5bd5ea476202
c474ea91-0b8f-454b-9e96-b6f7d90a055c	9382520e-adb5-4403-848d-5bd5ea476202
54620246-a52c-47aa-8e7b-ef586d81629b	09d5ff25-7a8a-4228-9093-bb437bb70f1a
b72c8e85-5575-4921-b0bd-89e7ed53d5d9	09d5ff25-7a8a-4228-9093-bb437bb70f1a
eff7ace7-7fb0-4cfa-88a5-2fe8a8bacd5f	09d5ff25-7a8a-4228-9093-bb437bb70f1a
36f7a472-805d-442c-97c2-0b6803573a2f	430e39ad-4906-44ba-83bc-8f2bc6f2d039
f9ad8797-8293-4eb7-a32f-2606e503af04	430e39ad-4906-44ba-83bc-8f2bc6f2d039
ef800461-3486-450d-8b4d-defc5c64824a	430e39ad-4906-44ba-83bc-8f2bc6f2d039
4ee475c0-e956-4b15-8849-cfee166c128b	48a03f6f-f8f4-4758-8672-f8ab8bd10acb
b6b8772d-ec63-4e12-92ab-f7f8a981a788	48a03f6f-f8f4-4758-8672-f8ab8bd10acb
94da7a8e-caa4-486a-a662-5b49fbc4cd8b	48a03f6f-f8f4-4758-8672-f8ab8bd10acb
bd90d607-2a07-46a8-8665-28d6f7dedd17	cd2385b8-fa33-4be9-82a8-9ceda07fdc75
a12541a9-e2c1-4132-9320-b0a14383c285	cd2385b8-fa33-4be9-82a8-9ceda07fdc75
8dd49f0e-420a-477b-afaa-cea7b37bd9df	cd2385b8-fa33-4be9-82a8-9ceda07fdc75
f40cdfca-78d7-4e7e-b8c0-8f3a0879919c	6c0ea5a3-dd48-4015-8f65-77d56bf54bb3
56dbc200-297f-4c86-ad88-8f5713abb996	6c0ea5a3-dd48-4015-8f65-77d56bf54bb3
5148f322-5c34-40c7-a2a6-cb1dcef354f6	6c0ea5a3-dd48-4015-8f65-77d56bf54bb3
0a67db4c-c0ff-4f0f-bcde-a9ba5a9dd5ed	78e9e396-2ab2-4d61-9eea-fe08b840dbf9
82110757-2e86-4bce-8fbb-1f901ec4d550	78e9e396-2ab2-4d61-9eea-fe08b840dbf9
5a8fffbb-7139-4308-b922-05509f5e1bf8	78e9e396-2ab2-4d61-9eea-fe08b840dbf9
5311ba9d-fa7a-436c-8a58-9d79ee1cac54	30bcda76-5a1a-4369-a6f3-ed2584ad4031
97310ca4-516c-41cb-be59-2ccd5eb6bfe8	30bcda76-5a1a-4369-a6f3-ed2584ad4031
4322b7e7-7882-4a8d-9b3a-2f4ffb5a558a	a8f061a9-6ba5-46df-89cd-6e65bfa28fe5
10fa5ccc-1e25-437e-9d16-1f0e3651a552	a8f061a9-6ba5-46df-89cd-6e65bfa28fe5
f4ff656c-a6a6-4b4f-9b31-15ea0263fa9c	a8f061a9-6ba5-46df-89cd-6e65bfa28fe5
f9b38171-3190-4c09-997b-84f722145c8e	5c29c0cd-e773-4697-8172-ab1b075490c2
121c9cc0-a6a1-49ea-b2b4-0e432e6232ae	5c29c0cd-e773-4697-8172-ab1b075490c2
b035ada2-0f8e-481c-ba30-e04a341e136a	5c29c0cd-e773-4697-8172-ab1b075490c2
bfc84183-87b2-46a5-80ed-a0b39f68d639	3c175c09-a896-4a88-9603-2b5ea27ef1a1
aeaa0b88-77a9-41da-95e4-c74741901e98	3c175c09-a896-4a88-9603-2b5ea27ef1a1
d7e92ed2-6c69-4790-a01a-398f993851f4	3c175c09-a896-4a88-9603-2b5ea27ef1a1
7651cef1-6277-4822-9e06-19b4ec098d8b	2364edf3-baf9-4a60-a75e-46387f235726
d041f12f-d86a-4a2b-a829-29fe1157c19f	2364edf3-baf9-4a60-a75e-46387f235726
c4551fb7-6812-4f2d-bdf7-0bcea78f4265	2364edf3-baf9-4a60-a75e-46387f235726
d02a1f1b-d6c5-4253-9090-05ac3e6b3822	624552ff-a7cd-427d-88e3-f31ec6dba89b
0b93d391-05df-4440-9bd1-524a53879f54	624552ff-a7cd-427d-88e3-f31ec6dba89b
284efe6e-4319-483c-804f-ec15f51fccf6	624552ff-a7cd-427d-88e3-f31ec6dba89b
a7eae6a4-4dc7-447c-9f61-d181d3c5c42d	4dbf7c31-5115-4700-963d-91f23f76aaa4
54a89d58-28e9-4cc9-9ffc-7ecef32015d3	4dbf7c31-5115-4700-963d-91f23f76aaa4
9e1b35b6-5993-4fd5-9c9e-db7da2864713	4dbf7c31-5115-4700-963d-91f23f76aaa4
5d233493-33ec-4cf1-9435-ac1d13f55e3b	8d447067-389f-4c39-ba51-63430a736df4
b71441ec-b1ee-4deb-a821-8ca2ecdd07b0	8d447067-389f-4c39-ba51-63430a736df4
28cd32f0-c1cc-4920-808c-a61d2bb93a29	8d447067-389f-4c39-ba51-63430a736df4
d4d961b4-557f-4106-bc87-af7e0a68890b	641c249c-f473-4d8e-bd8e-f385157f2682
854488cb-5bdc-4e8c-8f53-99acec7e150b	641c249c-f473-4d8e-bd8e-f385157f2682
8b63fa86-682f-48fa-8645-37a97bd3b80f	641c249c-f473-4d8e-bd8e-f385157f2682
dfa00fe8-a74c-4539-9da4-ac3a97f2afbb	0a048cd8-5468-4fcd-bd67-50675c83002d
3d20faa2-671b-4d7d-a23c-c84019ceaf2a	0a048cd8-5468-4fcd-bd67-50675c83002d
67edc37c-c66e-4b62-b5fd-3e7d2dfc8afc	0a048cd8-5468-4fcd-bd67-50675c83002d
110ad223-42de-4c3a-89b2-4bba2372d5f6	584d3863-eecc-4595-8a18-145ba2b213f7
efb59a3a-82f4-49a6-9869-47dcfc09df60	584d3863-eecc-4595-8a18-145ba2b213f7
58949068-acaa-446b-9254-e65ac6c5db3b	584d3863-eecc-4595-8a18-145ba2b213f7
1cc7ffdf-013d-4038-a1d7-74571f174754	529d4aba-d25d-44d6-ba1b-d6ad314d6158
4fb7e2a1-d9c7-43a8-98e8-1c433b8130d3	529d4aba-d25d-44d6-ba1b-d6ad314d6158
e3d960fd-4cbf-4d23-9201-0f845e6d8454	529d4aba-d25d-44d6-ba1b-d6ad314d6158
384ef8fb-0e06-4169-9596-9530c06282b1	8d7560cf-6d61-45dd-bf05-44ae257e97a4
73683cb8-043e-4cfe-b68a-ab5ed7c06389	8d7560cf-6d61-45dd-bf05-44ae257e97a4
218939d2-7006-4b3c-a26c-134db75904e1	8d7560cf-6d61-45dd-bf05-44ae257e97a4
30e733eb-6d9a-4d7a-b423-007b0fe09c7b	02970c3a-2240-4a74-8fd3-18af09a9cd61
8a7058d7-2698-46fc-a060-a6af3308c7ca	02970c3a-2240-4a74-8fd3-18af09a9cd61
cc1c1e3e-65e9-4d51-a348-36764337cd0e	02970c3a-2240-4a74-8fd3-18af09a9cd61
f9178672-95de-49a5-9ab1-4e4b96aab9b9	4acf41b9-9c8b-4a1e-a32e-a754abdce116
54b4e543-01d4-4a40-9669-bc1e07ac6536	4acf41b9-9c8b-4a1e-a32e-a754abdce116
6f821f2c-a18c-4964-8bc2-312070de0d8a	4acf41b9-9c8b-4a1e-a32e-a754abdce116
95c3f6b3-2713-43f3-bb54-dba3ed57df3b	c67a2104-aa5f-4e9f-830f-662ce97995d6
92687892-b808-42b7-8eb7-0cfab7a222e6	c67a2104-aa5f-4e9f-830f-662ce97995d6
35d136b0-b203-4473-a22d-51af1c7709c9	c67a2104-aa5f-4e9f-830f-662ce97995d6
2e96c1d4-1a80-4565-844e-dab995783d67	5a3d4806-974f-4754-b6cb-65a7dfa27548
4667f249-e65d-4eff-927f-93d267483891	5a3d4806-974f-4754-b6cb-65a7dfa27548
e4c42f7b-9bf3-4719-9e99-0dfb1f2608a4	5a3d4806-974f-4754-b6cb-65a7dfa27548
dbaf33ba-3717-4dd1-ac35-fce958355dfb	9db98dbb-0a64-4588-8e57-533f05a6e050
f7dd5400-a446-4dc8-8e9e-965e3825a2e6	9db98dbb-0a64-4588-8e57-533f05a6e050
6eaa8bf4-079e-40ae-94d8-071b19abb6b6	9db98dbb-0a64-4588-8e57-533f05a6e050
769e3b05-bef4-4556-ac79-963350241541	205c33b6-106f-40c3-804c-a2835f6104a9
8ea4b134-6213-4442-aa2b-da13c3942ff4	205c33b6-106f-40c3-804c-a2835f6104a9
a64f3232-0aa4-4cc8-8716-5340635fad7d	205c33b6-106f-40c3-804c-a2835f6104a9
c6b78f77-ce9c-47bc-9925-7885d2b93325	f7a32926-f029-47f4-8649-e3b2997f69d3
403cb1da-9024-420b-b097-d6266482fddc	f7a32926-f029-47f4-8649-e3b2997f69d3
f4989df6-6b62-40d0-9966-dd37a1fedbf8	f7a32926-f029-47f4-8649-e3b2997f69d3
042723a9-2e7d-4e46-9b17-aec9cf018fce	ced8947c-7c6b-4874-ad5e-c28ba91f8073
326db9ba-8729-465e-b657-dab6f29bd2f3	ced8947c-7c6b-4874-ad5e-c28ba91f8073
117df479-11f9-429b-8abe-497be19b8658	ced8947c-7c6b-4874-ad5e-c28ba91f8073
d97e2acd-6473-487b-bcb9-c84072e1af58	b9582bd1-bfff-41e1-990f-962c18084f4d
6c73a23d-cbc9-40fb-9eea-ee9625a92790	b9582bd1-bfff-41e1-990f-962c18084f4d
ba031fe1-d517-42b9-8ff9-c8790b45192f	b9582bd1-bfff-41e1-990f-962c18084f4d
932d330f-14e0-4d57-b112-92b39a797182	1c17435c-508d-4194-9d06-f923d31c60cf
2abd977e-a5aa-4516-91d5-dd94d91b5e42	1c17435c-508d-4194-9d06-f923d31c60cf
1b144d89-fa6a-47b0-a3b6-57171458b0ec	1c17435c-508d-4194-9d06-f923d31c60cf
6a096396-1d57-459f-b857-846624ecbc38	e3623259-d93b-4596-930a-0282a07b5666
fc90efba-172c-43fd-b16d-f8da94cb971f	e3623259-d93b-4596-930a-0282a07b5666
373ef38c-f10b-41f6-b8ee-6573c2c48f92	e3623259-d93b-4596-930a-0282a07b5666
93d3f724-f8e3-4c96-ae52-2a519e1d533a	b57f2ed1-ee10-469b-afcc-a4d7636d39c7
b67f0c5e-891b-4728-b9cb-8f9d63b246cf	b57f2ed1-ee10-469b-afcc-a4d7636d39c7
6643203f-a170-411a-a28e-74727492333f	b57f2ed1-ee10-469b-afcc-a4d7636d39c7
a2de6d65-7273-47bd-b3f7-997ea4034fc3	f22a7938-303f-4ac6-92da-526a4ad2a207
f0ee8f98-8321-4292-9946-0859de70b50a	f22a7938-303f-4ac6-92da-526a4ad2a207
2e29335c-319b-4766-9929-8e4f8e7be607	f22a7938-303f-4ac6-92da-526a4ad2a207
46645d32-e903-4dee-a1fd-0cd0a4a10e22	b99894af-7866-4a81-beee-30e0e384b708
bfaa3b71-75d1-41c5-bb33-a209c5cba7e0	b99894af-7866-4a81-beee-30e0e384b708
225270b5-bb32-4c66-a8c0-ecda578fdc4a	b99894af-7866-4a81-beee-30e0e384b708
20623454-dbcb-4f93-8e20-0dac9ddeb6d7	3d4e64cc-54c0-4b3e-b865-2fff3d9845e7
b3a676f6-e7ef-4ac2-90f4-5a0274e2a502	3d4e64cc-54c0-4b3e-b865-2fff3d9845e7
08155421-4582-4d82-84d1-9d4c3d9a7bb9	3d4e64cc-54c0-4b3e-b865-2fff3d9845e7
64f530a8-d10c-48e2-9afd-a8ac525a01c7	83e56067-9ee5-48b2-83d0-91e723eb8b3d
b74dcfa0-aaf8-4f66-8d0b-b8e53669b8c4	83e56067-9ee5-48b2-83d0-91e723eb8b3d
b76a5b36-9fd2-4854-a7ed-3e65bc027484	83e56067-9ee5-48b2-83d0-91e723eb8b3d
a0ca310b-727d-42dd-9e42-48fc2498a9eb	e1b56ce2-aea6-4d44-b877-86a13f92697c
3cdc2c3c-43a8-485b-a1a5-feadb5683897	e1b56ce2-aea6-4d44-b877-86a13f92697c
4f4f551e-8a87-44af-84bd-5e104509101b	e1b56ce2-aea6-4d44-b877-86a13f92697c
be0a2595-2d4a-4944-bb54-e04b764efd46	d6c6d3f9-5d8d-46c8-bc92-d8507d1e6f04
9d88f7da-7e1f-445a-bab8-bb36800500be	d6c6d3f9-5d8d-46c8-bc92-d8507d1e6f04
08c02fcd-170e-442e-9819-363a5109c5bb	d6c6d3f9-5d8d-46c8-bc92-d8507d1e6f04
a9042a61-7e7e-4577-b205-47979823c62c	8a7d516b-f3c2-4a5b-afde-d2bdff371937
fd06e690-051c-4a1d-b82d-0d669da71798	8a7d516b-f3c2-4a5b-afde-d2bdff371937
b0ec3074-076a-4c45-b18d-229edc447917	8a7d516b-f3c2-4a5b-afde-d2bdff371937
7b8008a7-17f9-4d8f-a9ca-f5cd29334513	fe7cd753-376f-4f22-a721-caa482aa1116
5592aee3-ef57-489e-afb9-530c7923c519	fe7cd753-376f-4f22-a721-caa482aa1116
e74ee73c-8434-4a82-8507-5ceb85068291	fe7cd753-376f-4f22-a721-caa482aa1116
10c3eb2c-d840-4242-b842-edacb4b55013	60e23204-8e78-487c-92bd-5de0c6102067
74ed1c1b-2d0e-4c9e-b7bd-6240f64a180e	60e23204-8e78-487c-92bd-5de0c6102067
9c01953f-6c9f-41ad-b7c3-b6bda1b96a64	60e23204-8e78-487c-92bd-5de0c6102067
31d7f324-bd98-4340-a33f-ef2eb0963d93	4654898f-58f4-482f-a91f-23aa5e192fd8
2606fe96-c57c-42d3-9acf-ce2c60d8375e	4654898f-58f4-482f-a91f-23aa5e192fd8
9fac9e7c-e96a-41e7-8524-02c3da31f718	4654898f-58f4-482f-a91f-23aa5e192fd8
485a1f74-8268-43ac-b86a-d58de52aeedf	20100c39-31ae-4fd4-ad35-bfeabe396b5f
00be2cdd-8c76-4e6b-85e5-1fbddac9fe7b	20100c39-31ae-4fd4-ad35-bfeabe396b5f
08ca8d35-cac6-46d0-91c4-1a3228830fc9	20100c39-31ae-4fd4-ad35-bfeabe396b5f
1f257a96-a580-4af9-93ba-73773feb3e73	497e8d74-14c2-401e-bc0d-a4b473f77eb1
5f864fa8-1733-4e44-8235-385c84bedc8f	497e8d74-14c2-401e-bc0d-a4b473f77eb1
050864f3-e9a1-4587-a74a-6893b049a4b3	497e8d74-14c2-401e-bc0d-a4b473f77eb1
80c87b7c-3ba7-4ca2-9f94-c17c9869d3df	1cf46091-d128-4e38-a7b7-97901d423aaf
0bad4781-09f6-4e76-85d6-593996489baf	1cf46091-d128-4e38-a7b7-97901d423aaf
ac93483e-3fda-43b0-826e-92dd53a2739b	ece794a5-613f-4607-9046-fb37906f87ce
e4230feb-1cdf-414b-9165-3f95740a40aa	ece794a5-613f-4607-9046-fb37906f87ce
e5ce8bc1-615b-4be5-bd10-e382d6fc4f5a	d794f07a-06d3-4b59-a969-c00af70ff8db
863f7bbd-a7bf-41e5-b598-98ac8b50b0f3	d794f07a-06d3-4b59-a969-c00af70ff8db
09e81d92-eb13-4a8a-a2ae-01918c7ae72c	5efedd90-782d-4129-8e71-fdd3b6e1c7df
1283f28b-d12e-428e-b8cc-aae17fb64c1a	5efedd90-782d-4129-8e71-fdd3b6e1c7df
74cb413e-a9e5-4bb4-839a-e1892d6a5ac7	f1261a91-9d52-4520-837e-e9c793f28dcc
3aab5747-d006-4c05-8bdc-d1d4e01c6bc9	f1261a91-9d52-4520-837e-e9c793f28dcc
448adb89-8795-46d6-9bef-649f1db75fa9	df63f81c-7a27-49d1-86c8-8d5e49883d40
d52959e6-971e-482e-97d0-34a832e968bd	df63f81c-7a27-49d1-86c8-8d5e49883d40
03bd6a35-5945-4268-8821-22fc12d26d17	8d9cf757-de83-4774-919b-00c45c43efd4
13fae940-beb6-4837-bb34-e1d30aa6db25	8d9cf757-de83-4774-919b-00c45c43efd4
16ff5be4-c197-4e38-9d20-773eb3e1d9f6	8d9cf757-de83-4774-919b-00c45c43efd4
c77cb4fa-826a-4d8a-8922-8868081ffde4	196340e0-5246-4bc2-8b69-54c66a48b399
02fad430-cc4b-4fad-8b07-f0289cb5f06c	196340e0-5246-4bc2-8b69-54c66a48b399
beb106fd-ddd7-4d5d-a924-d037e30e96cf	7f6c30c6-d6a5-4d39-ae5d-e1ae4cc2d3ef
8c99c6db-a9c2-4cfc-8758-b5797aafd4b9	7f6c30c6-d6a5-4d39-ae5d-e1ae4cc2d3ef
6d17cd75-3b06-457f-a778-54ee050be956	7f6c30c6-d6a5-4d39-ae5d-e1ae4cc2d3ef
ce95950f-c183-4210-a573-4d3760d9d153	cdc13d67-6360-43a6-bb99-cd68b64ee3f3
3b8fd299-262d-4fdd-a2a8-8a410530634f	cdc13d67-6360-43a6-bb99-cd68b64ee3f3
f4d8b93b-3f28-4935-b921-8f49b20a27a3	cdc13d67-6360-43a6-bb99-cd68b64ee3f3
cfa57c66-474f-4759-ac07-37d17e3acda8	ac051eb3-275f-40a5-b160-e224d13902e7
c8f8bec4-532b-43e2-995e-c0f433d95eab	ac051eb3-275f-40a5-b160-e224d13902e7
bdbb9d7b-f2f8-42f0-a9db-8cf4f9b1b44f	ac051eb3-275f-40a5-b160-e224d13902e7
2d4f4d0f-4319-42cb-b696-6546a4e2a625	67906f75-4298-4b6a-aa62-d8314be33f15
973b4f98-2c29-45de-9701-653e9d6ee179	67906f75-4298-4b6a-aa62-d8314be33f15
eed7a8ea-ac54-497e-a73e-6f752d2412bd	84b91384-8ec9-4b55-8dc9-28ff8c6db62f
b9a88e31-c2c0-47d8-9f23-d0cdbc8b4793	84b91384-8ec9-4b55-8dc9-28ff8c6db62f
b454f8cd-a214-4a35-8818-82037135a5ea	84b91384-8ec9-4b55-8dc9-28ff8c6db62f
aaca196c-9cbf-401a-881a-005334d9fab6	1dacf074-ad54-432a-a04f-cecd3a068d0c
f0f042ba-6221-4cc1-9730-72bf0406fd62	1dacf074-ad54-432a-a04f-cecd3a068d0c
30f73203-5002-447c-8572-41ea60c890c4	1dacf074-ad54-432a-a04f-cecd3a068d0c
fccdccb6-917a-4387-b41c-07e1dcbe911e	32ccab1e-e85e-4f52-84f5-69bbcc5fa53d
9a9094cd-d11a-4cbb-950b-7d252cf4f639	32ccab1e-e85e-4f52-84f5-69bbcc5fa53d
7550ec28-5563-418d-949d-90b70feb1491	32ccab1e-e85e-4f52-84f5-69bbcc5fa53d
bad36cda-20c4-4339-a71e-f2c5a6f6e9d3	89a894cc-c5c8-44e2-9ca3-85ab9a0130f9
4304a050-1181-4d40-8598-dbc85c163774	89a894cc-c5c8-44e2-9ca3-85ab9a0130f9
bdc64f09-a076-4115-85cd-7562efcd59cb	159b6644-94ed-406d-8e1e-1f002f265396
4ffb9935-1fcc-407b-b52c-7eec9f5ed0d5	159b6644-94ed-406d-8e1e-1f002f265396
49068403-524d-490a-9f51-1966b12942a2	159b6644-94ed-406d-8e1e-1f002f265396
5d68a284-2925-41f2-b381-d0c4bc4a2089	df6c89f3-4473-424b-a0b0-119977da62c5
a2d99710-1c58-4c35-9ef3-bbbb5c26adb4	df6c89f3-4473-424b-a0b0-119977da62c5
ed25dbeb-798a-4bee-ab50-13a4cf147f4a	df6c89f3-4473-424b-a0b0-119977da62c5
9ffc6d49-6649-4f14-8267-077847eb8cfa	0460ea96-a830-40bd-adfb-140aad4c31ca
e5a13f60-3203-41b5-b62b-9a0b5528658f	0460ea96-a830-40bd-adfb-140aad4c31ca
9159b067-e606-44e5-b958-32710a597004	0460ea96-a830-40bd-adfb-140aad4c31ca
730a51fa-2304-45cd-8012-ac5e996a7a45	fea6dcd6-00d6-4ad5-ab2f-eb40f533a5db
6f7c5cb2-03a5-4fd8-9292-105ce9ea485d	fea6dcd6-00d6-4ad5-ab2f-eb40f533a5db
6de101bf-3bce-415b-9e35-d0029822be6c	de5557e1-bf16-433b-87ff-401323a97df5
fb2d5b44-d838-46b5-94b8-65d197bb7782	de5557e1-bf16-433b-87ff-401323a97df5
1ae4042c-a987-43bf-84bc-84b2d70756a6	47034ede-0506-4650-9fb4-1948168440ca
7b880bbe-e3ed-4ef1-87e9-6556c290eafc	47034ede-0506-4650-9fb4-1948168440ca
a72dcfa7-88ba-499d-9d28-7bace5475931	27983c75-8b7c-47bd-ad03-10a9e1ca4d25
16101ce3-5848-4ef5-869f-6f459984b30e	27983c75-8b7c-47bd-ad03-10a9e1ca4d25
48830b74-9ab8-4ff9-bd9b-95f6ad16f794	bfd1388a-ec10-4a7b-9d94-916f56f52f98
aa05bf22-4f07-491b-a13f-90a71d7b4644	bfd1388a-ec10-4a7b-9d94-916f56f52f98
ac9e7515-5970-40f6-b9cc-0420e72402b2	8708a912-1b80-441d-9ba3-d607dd2f0c7c
0fe156d9-497b-4fe9-b8b3-4b0fe90acfef	8708a912-1b80-441d-9ba3-d607dd2f0c7c
6b63bc93-8c29-4e46-8f02-b4957083a788	25dd2269-e0f3-4653-98ac-33f64f09d4d3
8969f5f6-707f-4127-a617-39d0f13279a7	25dd2269-e0f3-4653-98ac-33f64f09d4d3
a2cd31ab-a38f-40a5-87e7-330b3456f8e0	b815db66-cadf-4c3c-ae0b-73ad5bf1a46e
c908304c-105e-40e4-a888-1c5c9ec6541b	b815db66-cadf-4c3c-ae0b-73ad5bf1a46e
c099caac-e4b7-494e-805c-8e5b3e5c6066	275e4c19-2885-4630-b049-e365374c27fb
9a6bcc9b-2d8b-4472-a157-6dc068b4b1b5	275e4c19-2885-4630-b049-e365374c27fb
004ebeda-aa69-43d8-8ff6-9bb12a699988	e3e52ca7-2e9e-4f87-a818-5a808823089b
dcc76883-5823-4120-bda1-c616d71da3c2	e3e52ca7-2e9e-4f87-a818-5a808823089b
b221cae7-ef89-4e81-851c-aee64177d4a2	1399fe4b-2c07-4bda-a720-9df928d51816
e0d7134a-1053-4b12-b573-effdb0e31ead	1399fe4b-2c07-4bda-a720-9df928d51816
88668e03-45df-40df-8764-41e57a90bf63	1399fe4b-2c07-4bda-a720-9df928d51816
2f9822bb-f121-4c65-8b65-bea868e083d4	cea11492-fdec-4cfc-a179-a4bbc05cac0b
efe274fb-3317-4b6e-88cb-aaf6d4deb3ac	cea11492-fdec-4cfc-a179-a4bbc05cac0b
aea2d180-0441-470b-90ed-319f63f61562	41b0a731-3378-42bd-9e08-8b69a1fee83a
71a51cf7-a1ff-4fd6-9a17-3096cd3b1828	41b0a731-3378-42bd-9e08-8b69a1fee83a
ab843a02-a81c-443b-bdcf-ba5d27c67ff3	c4556598-bcc7-4c45-8ae8-bdafc367eaa2
9b1e5c22-4782-45e4-9ee6-bfaacd56b31c	c4556598-bcc7-4c45-8ae8-bdafc367eaa2
9ce0226f-0e45-4b5e-9746-458c0db29943	2a4bae91-082b-4ae5-9729-08c86e000ab5
21dc43ec-18fa-47b6-9e3c-e7c02e2c51be	2a4bae91-082b-4ae5-9729-08c86e000ab5
bb3b1ddf-b3d9-4eab-8c0a-32c3d449b056	cd42a806-cac1-452c-9b0d-116d8ead4d64
2f38331a-21fe-4d0d-b6bd-8c7377f2243c	cd42a806-cac1-452c-9b0d-116d8ead4d64
dbe90aaf-b073-46b1-8c1b-5c4d077886f1	e657011b-cf83-47ab-8bc8-62f6498046a6
ae6e10e2-2376-4e6b-9755-4e9f63513f51	e657011b-cf83-47ab-8bc8-62f6498046a6
85ced8db-0084-4c61-b168-c0f13e767ff3	61d87eb7-e3d3-4f90-a3a8-b43b5362db1a
86264885-907a-4188-a99c-756343d3f773	61d87eb7-e3d3-4f90-a3a8-b43b5362db1a
61ed6d84-096e-4755-b2ab-3104f9e8ce0d	aac3a30b-36a9-4887-8aab-81c552bfc7d7
660fb05d-2d4d-43a2-84db-5ffb92cce3ae	aac3a30b-36a9-4887-8aab-81c552bfc7d7
3e33b1ef-2c96-43a2-afc7-2d7322857950	f1b3849e-9568-4cae-a3a0-3cca7f42c079
37e4f178-b76a-4883-a3f0-510e24047ade	f1b3849e-9568-4cae-a3a0-3cca7f42c079
85caae33-4a9d-40e7-8d8d-d9451304fe27	27597355-d542-4574-adc8-6493883d1454
3bcf9467-08b4-4609-bc77-90f43e9662be	27597355-d542-4574-adc8-6493883d1454
70bbfe1f-9457-4c83-9d3a-fdd29be2ea5f	27597355-d542-4574-adc8-6493883d1454
1434ff18-7624-41d6-ac83-4b3d973044ce	382ceece-628f-43b1-8847-ea92ff04376f
3ede5f17-4f16-4eed-bc0e-3e67acc8a856	382ceece-628f-43b1-8847-ea92ff04376f
2993089d-4451-424e-9982-6715cf11648d	4f8c2ed1-52a1-4c94-854e-631daeb1a154
eb1c11f9-608d-4758-a193-815a8db3ccf4	4f8c2ed1-52a1-4c94-854e-631daeb1a154
d389ba0a-46a9-472c-b65f-8a514c27083a	e6833b4c-3f1e-4394-a547-790258b451e5
0bf12777-7392-4cc3-8736-4ece7f24701f	e6833b4c-3f1e-4394-a547-790258b451e5
\.


--
-- Data for Name: package_search; Type: TABLE DATA; Schema: public; Owner: ckantest
--

COPY package_search (package_id, search_vector) FROM stdin;
587ed76e-1c2f-4cc7-a23a-f9beb2415c77	'-2009':10A '2001':9A 'budget':16 'direct':5A 'fiscal':4A,11 'impôt':12 'local':6A 'minister':14 'nkb':1A 'région':8A,13 'taux':2A
4402487d-3e8d-4618-8444-b400c6337834	'000':24 '20':23 '2009':10A,18 '50':29 'anne':17 'budget':34,42 'commun':9A,35 'fiscal':36 'fortun':7A,16 'habit':25 'impôt':2A,11,37 'isf':33,38 'isf2009':1A 'minister':40 'plus':21,27 'redev':30 'solidar':4A,13 'tax':39 'vill':19
\.


--
-- Data for Name: package_tag; Type: TABLE DATA; Schema: public; Owner: ckantest
--

COPY package_tag (id, package_id, tag_id, state, revision_id) FROM stdin;
20aeecc2-876e-4073-90df-56117361a979	587ed76e-1c2f-4cc7-a23a-f9beb2415c77	3d24f7b8-4401-4ef1-87d2-955c4628689d	active	f74141f1-d57b-4f3f-9ee2-d1469d1a00a9
711f0e6d-72ca-4181-93f9-cec694003e2c	587ed76e-1c2f-4cc7-a23a-f9beb2415c77	cecfa504-4a92-4103-beb6-e1d15bbac444	active	f74141f1-d57b-4f3f-9ee2-d1469d1a00a9
5bef0987-888e-4675-9274-96bb9522c02b	587ed76e-1c2f-4cc7-a23a-f9beb2415c77	d6b5bc12-83dc-42b7-abf3-2839547f6b03	active	f74141f1-d57b-4f3f-9ee2-d1469d1a00a9
f21f0b69-b665-4b49-847d-c1ffb7ce6057	4402487d-3e8d-4618-8444-b400c6337834	3d24f7b8-4401-4ef1-87d2-955c4628689d	active	6aafed2f-a1a7-48cc-b275-0e0986710b13
259aa836-18a9-42e8-811e-9d8f9f947197	4402487d-3e8d-4618-8444-b400c6337834	f59be7f4-6494-42a9-b21f-388930fca8cd	active	6aafed2f-a1a7-48cc-b275-0e0986710b13
2d1ce0ad-747f-4134-aef9-f2a4d2bf3727	4402487d-3e8d-4618-8444-b400c6337834	27eecd38-da7f-437c-aa78-e0468be5b594	active	6aafed2f-a1a7-48cc-b275-0e0986710b13
19689c73-d0bf-4da7-897b-d090c89f36b5	4402487d-3e8d-4618-8444-b400c6337834	a23706cf-7ada-4bc7-a323-8cdc6f649701	active	6aafed2f-a1a7-48cc-b275-0e0986710b13
8d214e63-77c4-4c6c-bcf0-49dc81814911	4402487d-3e8d-4618-8444-b400c6337834	d6b5bc12-83dc-42b7-abf3-2839547f6b03	active	6aafed2f-a1a7-48cc-b275-0e0986710b13
6142ddf9-ecb0-4142-aa76-d9736f8dc40f	4402487d-3e8d-4618-8444-b400c6337834	471360c0-f000-4c1a-b462-3d26a1009d8d	active	6aafed2f-a1a7-48cc-b275-0e0986710b13
6fc6f1c4-a865-4251-a4c5-46bdd72e364c	4235252c-aa21-46b5-8c52-110f95bdc583	e8584566-2520-4ffc-bcf6-202169e737a7	active	dbfdfdbf-2d3c-473a-8cee-c5c2d7367ffc
822a5a81-5dc2-48a0-b289-681a6c267ccf	4235252c-aa21-46b5-8c52-110f95bdc583	1986e4ca-61a8-41a6-95c2-940e526d50f1	active	dbfdfdbf-2d3c-473a-8cee-c5c2d7367ffc
21fd3447-ae99-49aa-8748-d1d589c578fc	4235252c-aa21-46b5-8c52-110f95bdc583	89f5db50-4b21-4808-a4fe-523ec4ff414c	active	dbfdfdbf-2d3c-473a-8cee-c5c2d7367ffc
4d34ca12-ab5b-491c-aa40-409095cfc813	e3424ea9-f7c0-4d80-832b-890c3de0f744	e8584566-2520-4ffc-bcf6-202169e737a7	active	a6a5efac-b108-40c8-847c-e06530596dae
76701645-e7a5-4253-b58a-f5a95df7a5bd	e3424ea9-f7c0-4d80-832b-890c3de0f744	4904453a-6192-4b55-90e8-b8d185b31af7	active	a6a5efac-b108-40c8-847c-e06530596dae
101e842b-257c-4456-84e2-684b949c379d	e3424ea9-f7c0-4d80-832b-890c3de0f744	9d86e388-cc10-4cf2-b2e7-84d8de81ac84	active	a6a5efac-b108-40c8-847c-e06530596dae
0dbc19fd-d69b-4cac-bacb-5d4ede02e215	e3424ea9-f7c0-4d80-832b-890c3de0f744	89f5db50-4b21-4808-a4fe-523ec4ff414c	active	a6a5efac-b108-40c8-847c-e06530596dae
c76f444c-b90e-4e6e-add0-00f88a7c53d2	db34f769-ed94-45d3-8b66-5ebaf9b091ff	f50e4f48-a55e-4d54-996e-dea429b042c8	active	53b7a5cf-ae69-4bb1-b239-940facaeb014
8ff35d23-6119-4bf0-88d0-521e3d1807d6	db34f769-ed94-45d3-8b66-5ebaf9b091ff	130ae24f-aa62-4d20-8987-265a1d4d1861	active	53b7a5cf-ae69-4bb1-b239-940facaeb014
88240498-cb11-409c-8ee0-059e4e548209	db34f769-ed94-45d3-8b66-5ebaf9b091ff	74f41828-1aad-4c1c-bdb7-06ad82909375	active	53b7a5cf-ae69-4bb1-b239-940facaeb014
eb28d2e4-a790-4233-852c-a7edc5e95f9c	db34f769-ed94-45d3-8b66-5ebaf9b091ff	7dffaf3a-a450-4435-b385-44a4e9d0ef61	active	53b7a5cf-ae69-4bb1-b239-940facaeb014
f60f7e08-4094-4407-bfb2-fb2b79eb4767	db34f769-ed94-45d3-8b66-5ebaf9b091ff	5b2978e4-1837-4164-9070-ad935a080c0c	active	53b7a5cf-ae69-4bb1-b239-940facaeb014
54791239-40d9-4a0c-8e1b-7ed4734f67b3	65d7e18e-c5ab-4736-bb9e-c47de2dc41e1	130ae24f-aa62-4d20-8987-265a1d4d1861	active	46aec451-5c77-4e88-b1bb-b14ef364f759
cba75e35-567b-41ba-bcdb-860ff3bb1bd8	65d7e18e-c5ab-4736-bb9e-c47de2dc41e1	7dffaf3a-a450-4435-b385-44a4e9d0ef61	active	46aec451-5c77-4e88-b1bb-b14ef364f759
4d666cee-3447-4da8-8ae1-15df7ad0ae97	65d7e18e-c5ab-4736-bb9e-c47de2dc41e1	e27ac12a-a758-4c98-9198-8663e4d52fa6	active	46aec451-5c77-4e88-b1bb-b14ef364f759
dd261a55-8ca0-431a-b739-37a3803f9f35	65d7e18e-c5ab-4736-bb9e-c47de2dc41e1	db2920d7-c288-4ebd-86b8-a4fdf4689c91	active	46aec451-5c77-4e88-b1bb-b14ef364f759
fe373ad9-bf8a-409c-aacf-0c403fab757a	3aa0d5ce-cef6-4158-b51e-ddee8ece7b5e	705d6aed-b1d5-4b89-ad38-be4a1daba35d	active	ceb18013-a90d-44d6-a245-b199633faf0b
de3db1a5-f43a-46a5-9f5b-41c312dced3f	3aa0d5ce-cef6-4158-b51e-ddee8ece7b5e	adcb0b79-7ada-4467-8f7d-ca6ce7a60405	active	ceb18013-a90d-44d6-a245-b199633faf0b
60fc2283-8da2-4551-9523-514bf9cc9284	3aa0d5ce-cef6-4158-b51e-ddee8ece7b5e	dd3612df-5f1b-479e-9a3c-22737dd68f70	active	ceb18013-a90d-44d6-a245-b199633faf0b
8eeb167f-c899-40ec-90f9-4029c9754054	97b2cf1e-91f4-4b08-a7d8-2e6bd1dca37e	f59be7f4-6494-42a9-b21f-388930fca8cd	active	a5bfd523-f3c2-41e2-9e1a-1624d786767c
4408f151-baae-4685-84dd-57361207dea0	97b2cf1e-91f4-4b08-a7d8-2e6bd1dca37e	d6b5bc12-83dc-42b7-abf3-2839547f6b03	active	a5bfd523-f3c2-41e2-9e1a-1624d786767c
132671c9-a9e3-4163-8179-46401d06ad58	e4c69e90-1056-4f46-9619-57d0a18d1737	f59be7f4-6494-42a9-b21f-388930fca8cd	active	19979634-e047-4bef-b09b-396ebbbf7fd0
87901e4d-fd6a-46aa-925a-df81f2e3fa4e	e4c69e90-1056-4f46-9619-57d0a18d1737	5e81f122-08fc-491b-9320-55eeb783e1bb	active	19979634-e047-4bef-b09b-396ebbbf7fd0
45b2bce3-1744-4315-86ae-6801ccc0793d	e4c69e90-1056-4f46-9619-57d0a18d1737	d6b5bc12-83dc-42b7-abf3-2839547f6b03	active	19979634-e047-4bef-b09b-396ebbbf7fd0
5400ce7f-1274-41fd-b1f8-fbb05b00712d	43c3cc44-3a6c-469b-80fe-913927d2c283	8b6bc9ac-d129-4a8b-bb7f-d062c566f4b3	active	5b3fb26f-b388-4423-88e3-076c7476b2cc
8413fe5b-2e46-4dff-96fc-5f662a0dbfa7	43c3cc44-3a6c-469b-80fe-913927d2c283	7e40bdf7-20b4-4b73-a65e-f7fe50feb8a2	active	5b3fb26f-b388-4423-88e3-076c7476b2cc
730165c7-bb1b-4078-b10d-21c60d9fb586	43c3cc44-3a6c-469b-80fe-913927d2c283	d3cb78ca-0862-45df-9f56-b47a4038adfa	active	5b3fb26f-b388-4423-88e3-076c7476b2cc
ba03eec3-29be-4c54-a1bb-1a53c3e89037	1901d722-a38d-4e79-a13c-ca51d61bae30	f59be7f4-6494-42a9-b21f-388930fca8cd	active	b2b4b103-d694-4105-86d7-fa937445826f
87c1cc7c-f2a1-431a-afb1-b153f295b5f5	1901d722-a38d-4e79-a13c-ca51d61bae30	9f47f113-6785-4448-b15c-8b3eaf2032c9	active	b2b4b103-d694-4105-86d7-fa937445826f
31848822-b663-4557-99a0-2790dd408ba7	1901d722-a38d-4e79-a13c-ca51d61bae30	cecfa504-4a92-4103-beb6-e1d15bbac444	active	b2b4b103-d694-4105-86d7-fa937445826f
2fdd65b2-fd3f-4b1f-a165-ca56fb2592e2	1901d722-a38d-4e79-a13c-ca51d61bae30	b59b9b95-d0f4-4c43-9204-4328b391accb	active	b2b4b103-d694-4105-86d7-fa937445826f
7728b248-c1da-4a18-a20f-aeba6a5cbb75	97b2cf1e-91f4-4b08-a7d8-2e6bd1dca37e	2d6031a5-1753-481d-8c0b-ce6d3cf08464	deleted	d8e30bba-2d57-45ea-8134-0794051afc25
b5525e9f-b798-4dae-99e6-fba61d86d62d	e4c69e90-1056-4f46-9619-57d0a18d1737	2d6031a5-1753-481d-8c0b-ce6d3cf08464	deleted	4b18699d-de47-485f-af9e-a8569d139c47
188154ef-7953-4d36-9820-1bafaf7aaeeb	1901d722-a38d-4e79-a13c-ca51d61bae30	b7438d75-793c-46a4-aa9d-c61fcfa17632	active	b2b4b103-d694-4105-86d7-fa937445826f
ffb4fea7-beba-4eb3-b61a-31e206f17aa2	3aa0d5ce-cef6-4158-b51e-ddee8ece7b5e	d58a8241-1622-4e11-936e-4eab9c55ba4b	deleted	17737307-867d-490f-8558-a3225789c916
01ce052b-8099-4146-9ee0-2f9212810c5d	3aa0d5ce-cef6-4158-b51e-ddee8ece7b5e	9a09c86e-d08e-4fa9-bb79-6c864acec8d7	active	17737307-867d-490f-8558-a3225789c916
64808080-9bb6-4f57-960e-fe9f6a3fd771	3aa0d5ce-cef6-4158-b51e-ddee8ece7b5e	b6813c1f-5d9c-474d-885d-e839f43e100e	active	17737307-867d-490f-8558-a3225789c916
6b4c947c-af24-4b10-ac55-7f26557ecb25	97b2cf1e-91f4-4b08-a7d8-2e6bd1dca37e	3d24f7b8-4401-4ef1-87d2-955c4628689d	active	d8e30bba-2d57-45ea-8134-0794051afc25
c405ed41-da8e-443d-845f-ba4523953591	e4c69e90-1056-4f46-9619-57d0a18d1737	3d24f7b8-4401-4ef1-87d2-955c4628689d	active	4b18699d-de47-485f-af9e-a8569d139c47
902cc5b6-2efa-4a22-81cd-8c912a9c67f2	5b23d4f4-058e-44e0-945d-ae9035fb1e15	b417e47b-f741-4033-8945-1663a28d3697	active	f9d8651f-75dd-4a22-8190-ea0df1fb83d1
5a936481-41ac-418c-8c76-93b7efce4f5d	5b23d4f4-058e-44e0-945d-ae9035fb1e15	b14d995b-b893-4284-b948-eaaeb1f5f252	active	f9d8651f-75dd-4a22-8190-ea0df1fb83d1
f8f8094f-d265-4598-ab4a-40c3340c845f	5b23d4f4-058e-44e0-945d-ae9035fb1e15	bd44cae3-27be-4c3c-b851-ec460a1d0440	active	f9d8651f-75dd-4a22-8190-ea0df1fb83d1
58f2e70d-e04e-4a92-92f7-9762f8eaf9a0	5b23d4f4-058e-44e0-945d-ae9035fb1e15	1bef7b23-a8cd-4000-94b9-2a5d2fdd9c58	active	f9d8651f-75dd-4a22-8190-ea0df1fb83d1
50bb5cd1-0b1e-494e-9ba8-60e096e4c749	be516eed-8a37-436c-af75-b623f0806f39	f3c50e34-5dcb-409b-a06c-8c16d220c756	active	e5f47372-8631-4d88-9613-f26a40b1ad80
58f17250-6230-434e-b1e5-a1dfba4331bf	be516eed-8a37-436c-af75-b623f0806f39	d539b83c-b99c-4577-b773-83fa4c6f5518	active	e5f47372-8631-4d88-9613-f26a40b1ad80
cc8d940a-aa41-4ec9-9ea1-fa0320a89361	be516eed-8a37-436c-af75-b623f0806f39	d984ccec-aa4b-4645-8301-28a3c57392b2	active	e5f47372-8631-4d88-9613-f26a40b1ad80
8904710e-50db-48d4-9d81-5f9d66d48741	5e86134f-2cb5-40e9-affa-f80d934a14b9	55546b47-fe3c-40bc-acc9-f78d285d9f13	active	affa5e72-9823-4011-8ea4-8ef8c2305fe6
74775ead-456e-4075-8243-c53641f0765d	5e86134f-2cb5-40e9-affa-f80d934a14b9	8e7f1f27-d0bb-4860-a969-93960fa02e9e	active	affa5e72-9823-4011-8ea4-8ef8c2305fe6
a21aa2ef-62e8-4ff3-927b-6c96b83808cd	6d999f74-d520-4a8c-8188-5a5c13c6bbec	4233e616-3f33-49fb-aa6c-7b54554dec19	active	792ec941-9e46-472a-8f28-ee06aeaa4e5b
4fc7c96b-ecd8-472d-99cb-0332c34df023	6d999f74-d520-4a8c-8188-5a5c13c6bbec	babf872e-41d5-470e-88b1-8dedc68cf97d	active	792ec941-9e46-472a-8f28-ee06aeaa4e5b
e4f805c5-6c34-411e-bec5-587b6b97a3aa	6d999f74-d520-4a8c-8188-5a5c13c6bbec	6e387a45-5862-4587-a6ed-e576a8dfdfa5	active	792ec941-9e46-472a-8f28-ee06aeaa4e5b
9cd9ccd7-3e9f-4f91-9603-7a2b28313221	6d999f74-d520-4a8c-8188-5a5c13c6bbec	430484c2-faac-4f88-b6c5-df6d5db26382	active	792ec941-9e46-472a-8f28-ee06aeaa4e5b
40a5fb5f-0bee-4bc8-897b-c804d4e512bc	6d999f74-d520-4a8c-8188-5a5c13c6bbec	eaff4bf2-c366-495a-b68f-23b9c65e9b7f	active	792ec941-9e46-472a-8f28-ee06aeaa4e5b
723a9cb4-8ffe-4e6c-8828-3908dcaddf66	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	2a33d5a2-9d58-4d8e-975d-ee07da3d6b0e	active	85392283-0794-47c2-a7e4-2862636d3e55
89f9f736-05c5-4bff-93f6-219137c252a0	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	8ca0b522-b29a-4155-907b-8142c500dcce	active	85392283-0794-47c2-a7e4-2862636d3e55
6e423f96-1e45-482d-acef-d20e6f9da69d	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	0f779fa2-6ef8-40d9-ba61-6687b5e82fa0	active	85392283-0794-47c2-a7e4-2862636d3e55
91a388a6-6295-4f81-91ed-0bfb264c8b57	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	46caf164-0cb1-4ab1-85a7-22ba97d7b8fc	active	85392283-0794-47c2-a7e4-2862636d3e55
6ab61f5f-0d6b-4bd8-b66b-7fa9fe5009c1	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	c8cc7acf-e055-4755-8aca-da325baeef12	active	85392283-0794-47c2-a7e4-2862636d3e55
7c85f4a4-a225-4861-b9af-8eb8627d0359	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	473f15dd-47c0-40a6-89e9-3a053ab172a4	active	85392283-0794-47c2-a7e4-2862636d3e55
825aa471-39bd-4380-8be1-3eabbdd9fac1	f6c6aac7-3c9b-4a3c-80bc-d6709bc95d4b	2a33d5a2-9d58-4d8e-975d-ee07da3d6b0e	active	a78d4faa-842b-4cec-8ba4-2e9993ff99ca
3b6b7e48-db41-44c7-a421-6ce959b67592	f6c6aac7-3c9b-4a3c-80bc-d6709bc95d4b	e8584566-2520-4ffc-bcf6-202169e737a7	active	a78d4faa-842b-4cec-8ba4-2e9993ff99ca
11015585-b3c7-44b4-b606-878d9c483f1a	f6c6aac7-3c9b-4a3c-80bc-d6709bc95d4b	c061a5ce-5435-47f8-840a-e36a4f315367	active	a78d4faa-842b-4cec-8ba4-2e9993ff99ca
db8692f3-578d-40d3-a738-dbf7ca2ad37c	f6c6aac7-3c9b-4a3c-80bc-d6709bc95d4b	76b6bb6a-de74-4522-b4db-14a74a7320ba	active	a78d4faa-842b-4cec-8ba4-2e9993ff99ca
975c89c7-5d3b-4b41-84a3-11aca3504a1c	f6c6aac7-3c9b-4a3c-80bc-d6709bc95d4b	a7cee6ce-5b52-448c-8a41-c612a5d0b3b9	active	a78d4faa-842b-4cec-8ba4-2e9993ff99ca
d6766ab7-317e-4abd-8f97-1aa11d74da08	f6c6aac7-3c9b-4a3c-80bc-d6709bc95d4b	1812b303-186d-4734-a4cb-1345949485d9	active	a78d4faa-842b-4cec-8ba4-2e9993ff99ca
17fcff91-588c-48ca-ab27-55656c3637ee	f6c6aac7-3c9b-4a3c-80bc-d6709bc95d4b	5ff7e7e2-383d-479b-90f7-6b0d3bcaa51a	active	a78d4faa-842b-4cec-8ba4-2e9993ff99ca
edc5627d-7c1b-48ab-8406-940aeb9946ab	f6c6aac7-3c9b-4a3c-80bc-d6709bc95d4b	151588d7-81bf-4f3d-a866-891e5849a939	active	a78d4faa-842b-4cec-8ba4-2e9993ff99ca
de15d807-dee7-4ab7-8cc5-da8592438f61	f6c6aac7-3c9b-4a3c-80bc-d6709bc95d4b	d057758e-a4a2-4125-82bd-83b96a2136da	active	a78d4faa-842b-4cec-8ba4-2e9993ff99ca
0d89c36e-1a1e-4490-b064-1dec137f324f	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	2af7acb6-6f04-4766-b560-efd1b100596b	deleted	053a6cde-e92d-4f32-9bcb-d4ee6fe05a74
2fcca417-5914-40c3-a43a-02da0ed64e78	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	8cdd235e-33ca-4ffe-9c73-eaa92f08f92d	deleted	053a6cde-e92d-4f32-9bcb-d4ee6fe05a74
3a591d72-7a9d-4f94-a47d-5e8d2966a2d0	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	49a7a707-a579-4de2-940f-1a846b22e741	deleted	3eefe87a-10dc-47ae-8e06-ed0f9fd04235
3246f399-7a53-4993-a8be-8d8abedf1ad8	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	ca526aec-bf03-499f-943f-d303a222c6cb	deleted	053a6cde-e92d-4f32-9bcb-d4ee6fe05a74
57aca32a-1ed7-4d16-82a8-f079e35cf896	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	c34cb669-4bf2-4571-895f-d9dfe3f945bf	deleted	053a6cde-e92d-4f32-9bcb-d4ee6fe05a74
a46cf6bd-85f5-424a-933e-02a30af37220	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	7ecb1d10-e6c7-4a8a-8c63-0a1b1e65fc0b	deleted	053a6cde-e92d-4f32-9bcb-d4ee6fe05a74
b7455f2f-e483-4d8e-989c-79813a74ba3d	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	a45f616e-ae34-4a83-aaf3-de06faca7caf	active	053a6cde-e92d-4f32-9bcb-d4ee6fe05a74
935bb69a-7e9e-4f52-8831-8fbf56706fe3	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	07b86a93-6171-4f6d-a4ec-8982c30ffbfd	active	053a6cde-e92d-4f32-9bcb-d4ee6fe05a74
121ce32c-d084-4072-9cfa-b9f3bcff1c67	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	ee1bf582-8672-4f86-a84e-c958ff2e7205	active	053a6cde-e92d-4f32-9bcb-d4ee6fe05a74
4a09766f-7ca0-46e0-bf4a-de6b2790a343	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	1812b303-186d-4734-a4cb-1345949485d9	active	053a6cde-e92d-4f32-9bcb-d4ee6fe05a74
4dacec06-1947-4b4b-8fae-f3c2145f6dc8	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	5ff7e7e2-383d-479b-90f7-6b0d3bcaa51a	active	053a6cde-e92d-4f32-9bcb-d4ee6fe05a74
043ea8f1-e230-411b-be3b-4656b9d0fa79	6968ef13-1d2f-4de3-b533-706bc9c0f604	9f47f113-6785-4448-b15c-8b3eaf2032c9	active	29796bcf-b80b-4c83-a40e-c792a50e8802
b5f46c37-f1de-4b88-aabd-9b2e5956fee6	6968ef13-1d2f-4de3-b533-706bc9c0f604	e8584566-2520-4ffc-bcf6-202169e737a7	active	29796bcf-b80b-4c83-a40e-c792a50e8802
c25386e3-2a60-41b7-8b36-e437e81182b5	6968ef13-1d2f-4de3-b533-706bc9c0f604	1986e4ca-61a8-41a6-95c2-940e526d50f1	active	29796bcf-b80b-4c83-a40e-c792a50e8802
129a4147-f0f5-4ef6-8a18-5049a0f4e96b	6968ef13-1d2f-4de3-b533-706bc9c0f604	a7cee6ce-5b52-448c-8a41-c612a5d0b3b9	active	29796bcf-b80b-4c83-a40e-c792a50e8802
275464ea-f12f-41f4-a010-38ac7dcd0c12	6968ef13-1d2f-4de3-b533-706bc9c0f604	cecfa504-4a92-4103-beb6-e1d15bbac444	active	29796bcf-b80b-4c83-a40e-c792a50e8802
136bcf61-6a28-454e-b7e6-977eaf25cc1c	6968ef13-1d2f-4de3-b533-706bc9c0f604	eb059ff9-81d9-48be-82d9-a2bb74e596de	active	29796bcf-b80b-4c83-a40e-c792a50e8802
35da204c-a484-4fd6-b50f-06fbd596048e	f6c6aac7-3c9b-4a3c-80bc-d6709bc95d4b	1986e4ca-61a8-41a6-95c2-940e526d50f1	active	2c169a3a-8172-4566-832b-982d79709f1a
4cea99e8-cb79-41da-b201-48e50e46d9e8	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	7fdbeb86-6300-4260-ac9a-4327519c6bb7	deleted	3eefe87a-10dc-47ae-8e06-ed0f9fd04235
ad6b6c3c-1aaf-4fe9-b6db-cb1832cb81b4	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	920f0530-0a9e-49c0-9978-f3d9ff3925c4	active	3eefe87a-10dc-47ae-8e06-ed0f9fd04235
700b0c8e-ee60-4022-99e7-cd7c07c01f11	f6c6aac7-3c9b-4a3c-80bc-d6709bc95d4b	89f5db50-4b21-4808-a4fe-523ec4ff414c	active	c42aefff-d420-4504-95d7-3d69e49d3c8a
56619650-909d-4b8e-99f5-45a634eadfd3	f3d8ca3c-32b9-4485-95d9-0b1fd4a5dd4e	ee1bf582-8672-4f86-a84e-c958ff2e7205	active	d78247f0-fc65-4fb3-bc7e-81f3ad80e69b
c47227ca-082c-4000-8b74-fe8f6f365e2a	f3d8ca3c-32b9-4485-95d9-0b1fd4a5dd4e	b57f29c3-0179-4d53-8f0e-f400acab0e07	active	d78247f0-fc65-4fb3-bc7e-81f3ad80e69b
51fdc4da-0364-4eb4-9e2e-aceb5e3e6d7e	f3d8ca3c-32b9-4485-95d9-0b1fd4a5dd4e	1812b303-186d-4734-a4cb-1345949485d9	active	d78247f0-fc65-4fb3-bc7e-81f3ad80e69b
ca01afd9-a5bc-485a-a5cb-29d6fad2bb7e	f3d8ca3c-32b9-4485-95d9-0b1fd4a5dd4e	920f0530-0a9e-49c0-9978-f3d9ff3925c4	active	d78247f0-fc65-4fb3-bc7e-81f3ad80e69b
3c888a2b-7c65-4fb8-bf85-7c9a1af76f4e	f3d8ca3c-32b9-4485-95d9-0b1fd4a5dd4e	aac980e1-0aa5-41e0-b6e0-eebbab19c7c9	active	d78247f0-fc65-4fb3-bc7e-81f3ad80e69b
1719f68f-b476-4d71-897e-872ce8bfc487	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	a6428b13-2aea-4468-b051-a7b7b2c81ad2	active	23851c5d-9680-440f-82b7-b0c72d7db67a
af75a212-d855-4252-ab2d-07ace7fc007b	f3d8ca3c-32b9-4485-95d9-0b1fd4a5dd4e	a6428b13-2aea-4468-b051-a7b7b2c81ad2	active	1efed480-60dd-42bd-8380-84b7a8c22587
de7321cb-921f-480a-b989-cef4be41d0da	6968ef13-1d2f-4de3-b533-706bc9c0f604	a6428b13-2aea-4468-b051-a7b7b2c81ad2	active	baa66947-52d1-48c5-bfd5-11a3c7353d7d
068e484e-5305-4195-aa7c-8d1e823d0e9c	f6c6aac7-3c9b-4a3c-80bc-d6709bc95d4b	a6428b13-2aea-4468-b051-a7b7b2c81ad2	active	632fb8b8-5a20-4e3e-b50c-fa86591bdfa1
02b10f45-8d7b-481d-9479-bd8bb5be1550	97b2cf1e-91f4-4b08-a7d8-2e6bd1dca37e	a6428b13-2aea-4468-b051-a7b7b2c81ad2	active	d37666ea-df46-411a-bc6c-3d1b808ebefc
78c7cdca-1d45-49b1-bdd4-bc71148a7568	69361720-3428-417e-beb4-d21df542992c	a6428b13-2aea-4468-b051-a7b7b2c81ad2	active	8b208a3e-558c-4884-9cc1-297a0dc0e174
01abd1d3-7043-4b94-aab8-bc2cf7e9868a	69361720-3428-417e-beb4-d21df542992c	a0da534f-3b88-4e01-bdda-f58bf9b11407	active	8b208a3e-558c-4884-9cc1-297a0dc0e174
5448864f-ae69-46f5-840f-74e5fcba0d4d	0e14dccb-9c28-4f89-b3b2-cb1011be06d1	be807861-8861-4f83-80fd-ad22da22d1d8	active	fb37d996-fe0c-49bf-8cb0-29b99087b3d2
fa68ad69-6a26-4783-9144-2b1104383fff	0e14dccb-9c28-4f89-b3b2-cb1011be06d1	9aaf0eec-fc2a-4117-a8c4-c4e160b53db5	active	fb37d996-fe0c-49bf-8cb0-29b99087b3d2
f14775c5-1b89-44aa-8b68-b4f3996cc547	0e14dccb-9c28-4f89-b3b2-cb1011be06d1	f1cfeeff-4ba7-4172-ba51-550d8183db28	active	fb37d996-fe0c-49bf-8cb0-29b99087b3d2
493b45b7-33ea-4827-9b3f-dc1b4f9275ba	34269022-c891-4a8e-a814-3af2b0fea526	f59be7f4-6494-42a9-b21f-388930fca8cd	active	a23213e4-603f-42b1-88e7-f9f17b4bdb6d
ff415931-7071-4ccb-a278-2e2b72cfa739	34269022-c891-4a8e-a814-3af2b0fea526	9f47f113-6785-4448-b15c-8b3eaf2032c9	active	a23213e4-603f-42b1-88e7-f9f17b4bdb6d
5a852848-beb8-4fdb-a79e-db6130af6c9f	34269022-c891-4a8e-a814-3af2b0fea526	a0da534f-3b88-4e01-bdda-f58bf9b11407	active	a23213e4-603f-42b1-88e7-f9f17b4bdb6d
946b2f12-e2a6-44a9-95f0-3f5e508ae653	34269022-c891-4a8e-a814-3af2b0fea526	cecfa504-4a92-4103-beb6-e1d15bbac444	active	a23213e4-603f-42b1-88e7-f9f17b4bdb6d
bc9480bd-4e51-4ced-a136-2decb39f63ea	34269022-c891-4a8e-a814-3af2b0fea526	a6428b13-2aea-4468-b051-a7b7b2c81ad2	active	a23213e4-603f-42b1-88e7-f9f17b4bdb6d
a51cedec-153a-4287-9d63-8169d2a6f31b	a1019da5-cdac-4e09-8b60-831994b5f275	780ba1c1-34a2-4573-98f9-9a8c6661e44c	active	58ff28dc-f3eb-40a2-bcf8-3912f26472e7
41899738-f946-420c-b189-27e8233b9b64	a1019da5-cdac-4e09-8b60-831994b5f275	3640e8d5-1d55-4a85-968e-539f45ed137e	active	58ff28dc-f3eb-40a2-bcf8-3912f26472e7
3b24746e-b3d8-41d0-b568-6b80fb633aac	a1019da5-cdac-4e09-8b60-831994b5f275	f13fdde8-8913-46b8-852f-8508edfc112c	active	58ff28dc-f3eb-40a2-bcf8-3912f26472e7
d889656e-d040-4c3e-a5ab-d061228988d0	29772378-f226-4fc8-8e01-9a87c5e43a00	111088ad-6b35-4bc9-82be-c74e6013cb39	active	14d1f443-8fc7-42d8-a730-c7747178aa8e
41a98b08-0100-4cb6-9735-7640975cb426	29772378-f226-4fc8-8e01-9a87c5e43a00	3f8a8351-34ce-4e10-b785-fb7a57c5e7cd	active	14d1f443-8fc7-42d8-a730-c7747178aa8e
e29bb438-fafd-46c8-a28d-c4bfe7db359c	29772378-f226-4fc8-8e01-9a87c5e43a00	711dcc85-fc2a-465e-8e61-bbf63861b31f	active	14d1f443-8fc7-42d8-a730-c7747178aa8e
1ca07d25-fe90-4fd0-82cb-fe2caf3b86c1	29772378-f226-4fc8-8e01-9a87c5e43a00	5306f500-62cf-4f9b-a9e4-00c2e76f9756	active	14d1f443-8fc7-42d8-a730-c7747178aa8e
19621b94-d422-45f2-84b1-66e8800d6288	29772378-f226-4fc8-8e01-9a87c5e43a00	eea77cb1-5d48-4158-bbf3-8e079a744986	active	14d1f443-8fc7-42d8-a730-c7747178aa8e
c0fd536c-914a-4764-981d-f1364e5f5d95	3fabe36b-965b-498d-9b3a-0649bbbfd0a5	430484c2-faac-4f88-b6c5-df6d5db26382	active	6279dd25-4840-4072-ac60-e988063feae6
33c0ed5e-51de-4508-b161-25351e5e1b5d	3fabe36b-965b-498d-9b3a-0649bbbfd0a5	6e982e5e-81cf-4953-a39f-40f2fe80089a	active	6279dd25-4840-4072-ac60-e988063feae6
1369bf32-0649-4c54-873b-b16cf54d235d	2502f9a7-15fa-439d-8a48-f61f38cb6f55	a0da534f-3b88-4e01-bdda-f58bf9b11407	active	39219937-0939-40ca-86a8-f8493a35a337
b4ce3c17-285d-432b-b34b-a6d4dbc8127b	2502f9a7-15fa-439d-8a48-f61f38cb6f55	cce9f9ec-ea17-43b8-bf15-5f56dbf32f20	active	39219937-0939-40ca-86a8-f8493a35a337
40786c16-8a1d-4135-af07-30af47462fba	4276f7df-c7e9-44e1-8886-20ad41ebda0a	73da3e0a-e98a-4da2-8d17-e2559d9d1841	active	8b876446-18be-45e9-98d2-2ad4a1b1e7fa
60e48d4b-970c-4825-80ef-674e24c2bc3d	f4517261-c1ee-4380-b3ad-0de5a0edc09a	73da3e0a-e98a-4da2-8d17-e2559d9d1841	active	ab96c2af-06af-4bad-8c4f-00ec10f98776
98a2b51c-b515-4331-bc79-62d1f9c7e0b0	9382520e-adb5-4403-848d-5bd5ea476202	e8584566-2520-4ffc-bcf6-202169e737a7	active	df6d8a52-2f22-493d-8be5-645488c266ea
8d6cd35c-ac64-44f5-a8e2-86ce18ec5125	9382520e-adb5-4403-848d-5bd5ea476202	fd6ac7dd-6519-4f44-a78d-486fc41579eb	active	df6d8a52-2f22-493d-8be5-645488c266ea
4db21954-319a-47d0-ab40-076757d0259a	9382520e-adb5-4403-848d-5bd5ea476202	665b67c7-9381-42db-85de-07f33b37217e	active	df6d8a52-2f22-493d-8be5-645488c266ea
f37b4a72-b627-4889-a0ed-b7e0b49a81f1	9382520e-adb5-4403-848d-5bd5ea476202	90d603f6-c175-4a13-98b5-4692581b294c	active	9a1682ec-e74a-4539-8bc2-a4437c678515
a704ad26-4885-44be-932a-d55a8698898f	09d5ff25-7a8a-4228-9093-bb437bb70f1a	665b67c7-9381-42db-85de-07f33b37217e	active	c0b8f3fb-e0c0-4ec9-8d66-a6604dcf12bd
27327b60-bcd8-414c-8b9b-9d98f4471c06	09d5ff25-7a8a-4228-9093-bb437bb70f1a	e8584566-2520-4ffc-bcf6-202169e737a7	active	c0b8f3fb-e0c0-4ec9-8d66-a6604dcf12bd
63c6996e-d703-48e4-865c-0aaacb8e6f2e	09d5ff25-7a8a-4228-9093-bb437bb70f1a	90d603f6-c175-4a13-98b5-4692581b294c	active	c0b8f3fb-e0c0-4ec9-8d66-a6604dcf12bd
084566d3-6ea9-4727-8da4-e8e4df0588c5	09d5ff25-7a8a-4228-9093-bb437bb70f1a	89f5db50-4b21-4808-a4fe-523ec4ff414c	active	c0b8f3fb-e0c0-4ec9-8d66-a6604dcf12bd
3f2f5a8d-7fac-430e-b8b1-6ae367ededc1	430e39ad-4906-44ba-83bc-8f2bc6f2d039	665b67c7-9381-42db-85de-07f33b37217e	active	65cf3b14-0851-41dd-8891-c545d5d33b8f
96094477-b694-4176-985b-1f676352d373	430e39ad-4906-44ba-83bc-8f2bc6f2d039	e8584566-2520-4ffc-bcf6-202169e737a7	active	65cf3b14-0851-41dd-8891-c545d5d33b8f
be03f70b-dded-473f-a390-f2cb57413f05	430e39ad-4906-44ba-83bc-8f2bc6f2d039	90d603f6-c175-4a13-98b5-4692581b294c	active	65cf3b14-0851-41dd-8891-c545d5d33b8f
0df77de4-a272-40f4-9fac-fdf3d89352bc	430e39ad-4906-44ba-83bc-8f2bc6f2d039	89f5db50-4b21-4808-a4fe-523ec4ff414c	active	65cf3b14-0851-41dd-8891-c545d5d33b8f
d5f366bf-f6da-4d88-a171-7c4aa51720a6	09d5ff25-7a8a-4228-9093-bb437bb70f1a	e2fbbd65-d33f-46a9-b1d6-2a49bd1c8497	active	f39b8053-1f8c-44b5-9f81-07236807d0ea
461d7c36-9737-49c5-a4be-f1e487a131b3	430e39ad-4906-44ba-83bc-8f2bc6f2d039	877d5f3d-b996-4c07-8ffd-b3e3a7a42043	deleted	79e83d1f-3aa6-4144-a610-76428572404a
acd2ba11-95e8-46c0-94ae-625ff6e424ed	430e39ad-4906-44ba-83bc-8f2bc6f2d039	e2fbbd65-d33f-46a9-b1d6-2a49bd1c8497	active	79e83d1f-3aa6-4144-a610-76428572404a
60c0a19a-ed5e-4916-8bed-645cd7f42074	48a03f6f-f8f4-4758-8672-f8ab8bd10acb	fd6ac7dd-6519-4f44-a78d-486fc41579eb	active	cbb8cf9d-1615-4a30-9c69-bcc03cae3034
e9afd4d6-f497-447f-847a-523c2703a32c	48a03f6f-f8f4-4758-8672-f8ab8bd10acb	e8584566-2520-4ffc-bcf6-202169e737a7	active	cbb8cf9d-1615-4a30-9c69-bcc03cae3034
4cd06b85-ae81-48b9-9948-79f397cda901	48a03f6f-f8f4-4758-8672-f8ab8bd10acb	90d603f6-c175-4a13-98b5-4692581b294c	active	cbb8cf9d-1615-4a30-9c69-bcc03cae3034
eaea080a-d7b7-4d35-9fe8-33a5aed763ca	48a03f6f-f8f4-4758-8672-f8ab8bd10acb	665b67c7-9381-42db-85de-07f33b37217e	active	cbb8cf9d-1615-4a30-9c69-bcc03cae3034
bd474ab9-7eaf-4527-8b98-932c8e6e24b2	cd2385b8-fa33-4be9-82a8-9ceda07fdc75	665b67c7-9381-42db-85de-07f33b37217e	active	0afcdd05-5c6a-4d38-8ccc-62520a9ea0ed
dd4ac5d0-4484-40b0-b0d0-fe960a7297bd	cd2385b8-fa33-4be9-82a8-9ceda07fdc75	e8584566-2520-4ffc-bcf6-202169e737a7	active	0afcdd05-5c6a-4d38-8ccc-62520a9ea0ed
4d601975-551b-40e2-9966-d578defca71a	cd2385b8-fa33-4be9-82a8-9ceda07fdc75	0f11fb91-d0f4-41e4-8934-53c2d6a8b598	active	0afcdd05-5c6a-4d38-8ccc-62520a9ea0ed
011af705-2a88-49bb-9231-34d25fc1d805	cd2385b8-fa33-4be9-82a8-9ceda07fdc75	90d603f6-c175-4a13-98b5-4692581b294c	active	0afcdd05-5c6a-4d38-8ccc-62520a9ea0ed
a8c24e2b-af9d-40c9-9d91-32021f57c618	cd2385b8-fa33-4be9-82a8-9ceda07fdc75	89f5db50-4b21-4808-a4fe-523ec4ff414c	active	0afcdd05-5c6a-4d38-8ccc-62520a9ea0ed
01c7453e-d8f0-4702-96a0-ea988dc4ae69	6c0ea5a3-dd48-4015-8f65-77d56bf54bb3	665b67c7-9381-42db-85de-07f33b37217e	active	b8bede64-bf67-44d3-8697-8261f01f9d7b
b9f7a58b-0628-4584-b599-fd7874b06011	6c0ea5a3-dd48-4015-8f65-77d56bf54bb3	e8584566-2520-4ffc-bcf6-202169e737a7	active	b8bede64-bf67-44d3-8697-8261f01f9d7b
b466f566-0315-4a2f-923a-fc476e0a1e47	6c0ea5a3-dd48-4015-8f65-77d56bf54bb3	90d603f6-c175-4a13-98b5-4692581b294c	active	b8bede64-bf67-44d3-8697-8261f01f9d7b
fd7247e3-549e-4ef8-ab93-6256741aa4cf	6c0ea5a3-dd48-4015-8f65-77d56bf54bb3	f5fbd7a0-64b5-4051-8780-c8b8e22f2b42	active	b8bede64-bf67-44d3-8697-8261f01f9d7b
88774cec-9c60-4f05-9178-dda1eb8674b1	78e9e396-2ab2-4d61-9eea-fe08b840dbf9	2af7acb6-6f04-4766-b560-efd1b100596b	active	bdb5cf3d-56bf-428c-9151-2a3bb3c7669a
44be4c97-f116-4c49-91ec-c91c1df3665f	78e9e396-2ab2-4d61-9eea-fe08b840dbf9	920f0530-0a9e-49c0-9978-f3d9ff3925c4	active	bdb5cf3d-56bf-428c-9151-2a3bb3c7669a
68a7a438-1219-4830-92e4-89b7db42d52f	78e9e396-2ab2-4d61-9eea-fe08b840dbf9	6eecd056-cd48-4bba-9b38-5f18a7c98e04	active	bdb5cf3d-56bf-428c-9151-2a3bb3c7669a
bc3bc2ad-ddf2-46cd-9523-d66acb77afd2	78e9e396-2ab2-4d61-9eea-fe08b840dbf9	1d7180fa-9e9d-46a0-ad05-9ab69efc774f	active	bdb5cf3d-56bf-428c-9151-2a3bb3c7669a
94c7e138-dba6-4c97-8faf-ee2db4a2e601	78e9e396-2ab2-4d61-9eea-fe08b840dbf9	7348e0d0-c94b-4f7e-b2ce-f79fe79f1449	active	bdb5cf3d-56bf-428c-9151-2a3bb3c7669a
42599114-c74e-4230-acc0-4a6148f4e9c2	78e9e396-2ab2-4d61-9eea-fe08b840dbf9	1812b303-186d-4734-a4cb-1345949485d9	active	bdb5cf3d-56bf-428c-9151-2a3bb3c7669a
2f5bed7a-4492-4f72-84b7-440e3f426365	78e9e396-2ab2-4d61-9eea-fe08b840dbf9	46caf164-0cb1-4ab1-85a7-22ba97d7b8fc	active	bdb5cf3d-56bf-428c-9151-2a3bb3c7669a
37ee845d-5043-4a38-9f8f-cf03322a44a6	78e9e396-2ab2-4d61-9eea-fe08b840dbf9	7fdbeb86-6300-4260-ac9a-4327519c6bb7	active	bdb5cf3d-56bf-428c-9151-2a3bb3c7669a
1c7a3bb5-cedf-4e45-a63c-478dd3d33577	78e9e396-2ab2-4d61-9eea-fe08b840dbf9	c34cb669-4bf2-4571-895f-d9dfe3f945bf	active	bdb5cf3d-56bf-428c-9151-2a3bb3c7669a
cffd4f73-1f86-47f2-9512-c10882514a53	30bcda76-5a1a-4369-a6f3-ed2584ad4031	4233e616-3f33-49fb-aa6c-7b54554dec19	active	ae90eec5-4c4a-4cf4-83f3-238eb3d162e7
88b0d909-a5c2-4ec4-9a5e-93857670b165	30bcda76-5a1a-4369-a6f3-ed2584ad4031	f31876a3-434f-4557-aa0a-dc437ee39b2d	active	ae90eec5-4c4a-4cf4-83f3-238eb3d162e7
c1bd4ebc-0a02-4fea-9fee-66f29f055fb9	30bcda76-5a1a-4369-a6f3-ed2584ad4031	d2ce4bc4-45c9-47bb-8623-f22b540da0f6	active	ae90eec5-4c4a-4cf4-83f3-238eb3d162e7
15e8dac4-3702-41d6-b191-651c0ca4eb0d	30bcda76-5a1a-4369-a6f3-ed2584ad4031	9cdf19fd-7d75-4e61-b6b2-0ebf17582683	active	ae90eec5-4c4a-4cf4-83f3-238eb3d162e7
3121eb9c-0735-43e6-a18e-8011a463cfb5	30bcda76-5a1a-4369-a6f3-ed2584ad4031	03ff86ed-50c4-495a-9264-6680e479c1b5	deleted	ea04b09e-6bcf-4718-9480-1461698f30ac
7be5b6a5-0337-4e7a-bef5-1207c3f51253	30bcda76-5a1a-4369-a6f3-ed2584ad4031	1d7180fa-9e9d-46a0-ad05-9ab69efc774f	active	ea04b09e-6bcf-4718-9480-1461698f30ac
246bd8f5-a162-469d-94d2-dc0fc37518be	30bcda76-5a1a-4369-a6f3-ed2584ad4031	f9631259-7d78-4ecf-a94d-941d769c5084	active	ea04b09e-6bcf-4718-9480-1461698f30ac
26641102-1956-479b-a933-7769dd1c54e9	a8f061a9-6ba5-46df-89cd-6e65bfa28fe5	90d603f6-c175-4a13-98b5-4692581b294c	active	9ef4d8c5-6298-450e-8cfe-09b683b28b92
61192d9e-b3b7-47a1-8464-4e37c57f75fb	a8f061a9-6ba5-46df-89cd-6e65bfa28fe5	e8a4383f-b9bf-44c2-ab85-421406a5d069	active	9ef4d8c5-6298-450e-8cfe-09b683b28b92
800b18fa-b921-4569-bbfd-b07a0425ac42	a8f061a9-6ba5-46df-89cd-6e65bfa28fe5	23f8e389-394e-45ea-b71e-fcbf0bada070	active	9ef4d8c5-6298-450e-8cfe-09b683b28b92
19ac5fc3-97b8-4ba3-9d72-359d952e55f6	a8f061a9-6ba5-46df-89cd-6e65bfa28fe5	517528cf-48ce-4495-8d55-78f96cf6b13d	active	9ef4d8c5-6298-450e-8cfe-09b683b28b92
a337042a-56ca-4336-9264-0c0c6b7efb6e	5c29c0cd-e773-4697-8172-ab1b075490c2	7d8a923a-2a0c-406c-9c36-141a0324cb61	active	28169ed8-3c47-4522-a8d5-4474173aca5c
0343f2b1-8536-4ad8-8829-f5fe66187569	5c29c0cd-e773-4697-8172-ab1b075490c2	01e3a3ad-3b21-4973-a581-8c8ad9938f68	active	28169ed8-3c47-4522-a8d5-4474173aca5c
f3dd0c52-7359-45f3-b33a-449b19c233b6	3c175c09-a896-4a88-9603-2b5ea27ef1a1	4cc6503a-742d-473e-9e6c-11624b7e8c58	active	99223c1a-1e29-42d1-8256-85f44520866f
22b36c20-44a5-4c06-acea-e3f82d3bfaf3	3c175c09-a896-4a88-9603-2b5ea27ef1a1	0f248678-dc01-469e-8c34-d9c1e2c0caee	active	99223c1a-1e29-42d1-8256-85f44520866f
765169c5-f038-40db-993b-b698786cc802	3c175c09-a896-4a88-9603-2b5ea27ef1a1	9b2a0ebd-c9d5-4c1c-bd75-41263d755c3b	active	99223c1a-1e29-42d1-8256-85f44520866f
7505c563-3650-406d-8d66-26af1591cf7e	2364edf3-baf9-4a60-a75e-46387f235726	9b2a0ebd-c9d5-4c1c-bd75-41263d755c3b	active	2f410629-bce8-453d-bac0-fc0b1e286dce
6dee7615-f50c-48c9-94b1-a36bb02c7103	2364edf3-baf9-4a60-a75e-46387f235726	2c08add6-301e-4273-bc09-56c3cf51c00b	active	2f410629-bce8-453d-bac0-fc0b1e286dce
e67d2cbf-e9ed-4b71-9f32-971417603967	624552ff-a7cd-427d-88e3-f31ec6dba89b	ad516677-fb7f-42e8-9e00-51be02bfff39	active	440a2815-bfe0-486e-8a47-7e3a125f8c91
b4213149-fafb-46a3-9a79-193c2f56c0e5	624552ff-a7cd-427d-88e3-f31ec6dba89b	1b2a9770-8542-400b-b2c4-4743032a4ff2	active	440a2815-bfe0-486e-8a47-7e3a125f8c91
c12c9116-0f99-400a-bd9f-0ac425d81919	624552ff-a7cd-427d-88e3-f31ec6dba89b	6a1062c8-afb6-45d3-9b3f-302d223c8943	active	440a2815-bfe0-486e-8a47-7e3a125f8c91
1d7f11e9-78a8-492f-8d21-1a4276fa60e3	4dbf7c31-5115-4700-963d-91f23f76aaa4	1b2a9770-8542-400b-b2c4-4743032a4ff2	active	e96a0ae8-1830-40ae-bdd3-7d2f25961373
f1ce3435-01bb-48a1-a9de-0e66001f71d1	4dbf7c31-5115-4700-963d-91f23f76aaa4	06483163-62aa-491a-b118-cbfa7a6fb1c9	active	e96a0ae8-1830-40ae-bdd3-7d2f25961373
7e982f8c-38a9-41a2-adcc-6793fb1c74f0	8d447067-389f-4c39-ba51-63430a736df4	f59be7f4-6494-42a9-b21f-388930fca8cd	active	9704b3e5-ce20-4be1-8a7d-d9cb211f0cf6
8f5367ec-ffcc-4905-a962-de64c5bad479	8d447067-389f-4c39-ba51-63430a736df4	f8eecc43-fefb-4202-8113-cd5ce0de917c	active	9704b3e5-ce20-4be1-8a7d-d9cb211f0cf6
9b13d911-85b1-462c-beec-87895236dc4a	641c249c-f473-4d8e-bd8e-f385157f2682	aa907186-83cf-4307-bb57-e02f3aec858f	active	b5adad2b-96ce-4b33-90c0-108f760a18d9
7330a697-976d-4801-900f-fe4356065d3c	641c249c-f473-4d8e-bd8e-f385157f2682	50250d17-669d-4203-b47f-41ab706120d3	active	b5adad2b-96ce-4b33-90c0-108f760a18d9
d24dbc6e-cc4f-46ff-96d5-30a507a406ca	0a048cd8-5468-4fcd-bd67-50675c83002d	f59be7f4-6494-42a9-b21f-388930fca8cd	active	add4fc8c-cacc-4c21-a011-10586b13504c
04fdd4e1-c8b8-4e5e-87d6-a7defea857b6	0a048cd8-5468-4fcd-bd67-50675c83002d	cbf2c5a9-2f74-440c-ac6b-e93bdf9b3f28	active	add4fc8c-cacc-4c21-a011-10586b13504c
a2307a21-6294-4d86-a187-eb48a14ed989	0a048cd8-5468-4fcd-bd67-50675c83002d	1694ffba-704f-4aa0-b1c4-a4037869972d	active	add4fc8c-cacc-4c21-a011-10586b13504c
9fa56913-d20f-41d0-9503-f69d92ce454c	584d3863-eecc-4595-8a18-145ba2b213f7	f59be7f4-6494-42a9-b21f-388930fca8cd	active	bc33ab95-a7ce-4722-8c71-55da9972020d
33b1002d-2d6f-40ae-853f-582acfc38c4c	584d3863-eecc-4595-8a18-145ba2b213f7	713e34bc-6b1c-48fe-8030-c755f956251e	active	bc33ab95-a7ce-4722-8c71-55da9972020d
1f606951-5f2b-4c94-acb8-16560a86f352	584d3863-eecc-4595-8a18-145ba2b213f7	c9ca84a2-f86d-4915-b3f4-48344ff4ceeb	active	bc33ab95-a7ce-4722-8c71-55da9972020d
eb5a6270-b576-4e5c-ab71-2eb4548b4e8f	529d4aba-d25d-44d6-ba1b-d6ad314d6158	f59be7f4-6494-42a9-b21f-388930fca8cd	active	95696de0-b33b-4771-b20d-9b71dff9c316
6a60f67f-8a20-49b0-85c3-7616e2044c44	529d4aba-d25d-44d6-ba1b-d6ad314d6158	d60df706-4b72-4f4d-9651-7cba326de6ac	active	95696de0-b33b-4771-b20d-9b71dff9c316
b427f78d-1fa5-4a8d-b099-d35c88a2e23c	529d4aba-d25d-44d6-ba1b-d6ad314d6158	e921ebf0-76d3-4435-912d-f3ae9292a706	active	95696de0-b33b-4771-b20d-9b71dff9c316
4331f816-6ae7-4b18-a835-25da1535b0ac	8d7560cf-6d61-45dd-bf05-44ae257e97a4	f59be7f4-6494-42a9-b21f-388930fca8cd	active	fbd13c36-5e50-49d2-abd4-049e7e027453
8935e03e-a2d1-4bf5-9a94-e4ab49251e52	8d7560cf-6d61-45dd-bf05-44ae257e97a4	32a67c24-0082-46fb-ad13-6329df70ac2f	active	fbd13c36-5e50-49d2-abd4-049e7e027453
15082a16-3d66-4eb1-98e0-42df0a2ab5d8	02970c3a-2240-4a74-8fd3-18af09a9cd61	f59be7f4-6494-42a9-b21f-388930fca8cd	active	74d9b0ab-1a2e-4016-9f18-1afa11ead13b
0065d905-784c-4fbc-b7ae-76abf126a482	02970c3a-2240-4a74-8fd3-18af09a9cd61	896438ce-8705-4cc8-bc5b-8212b9cca4c6	active	74d9b0ab-1a2e-4016-9f18-1afa11ead13b
b7d4c808-2eb5-438e-be0c-360b8d1760bf	02970c3a-2240-4a74-8fd3-18af09a9cd61	4795e4e6-ad26-49af-bee3-0561571bb728	active	74d9b0ab-1a2e-4016-9f18-1afa11ead13b
6a5d10e5-3ca1-47cd-b6a3-708526a7c9b9	02970c3a-2240-4a74-8fd3-18af09a9cd61	284b86f0-43c9-4079-b62d-ec572aa48cf7	active	74d9b0ab-1a2e-4016-9f18-1afa11ead13b
c4d6eb08-9f75-46ea-9d24-3c5a0306d8df	4acf41b9-9c8b-4a1e-a32e-a754abdce116	f59be7f4-6494-42a9-b21f-388930fca8cd	active	12d7a85a-8498-40e0-ae5a-24239d9c82f7
2d924b7c-1ec8-41d6-b75c-db89a4a0b3f9	4acf41b9-9c8b-4a1e-a32e-a754abdce116	4d699059-2886-444e-9c0b-95540ff4bf93	active	12d7a85a-8498-40e0-ae5a-24239d9c82f7
fae10c5e-3f76-48f9-9a1b-001c0249b08a	4acf41b9-9c8b-4a1e-a32e-a754abdce116	b6813c1f-5d9c-474d-885d-e839f43e100e	active	12d7a85a-8498-40e0-ae5a-24239d9c82f7
88a13d1c-2ccc-4a37-b1f9-5a4298b2c723	5a3d4806-974f-4754-b6cb-65a7dfa27548	f59be7f4-6494-42a9-b21f-388930fca8cd	active	75cb2baa-b33b-4762-b981-b4f97364ed22
e14031e5-9eb5-4dcf-aaf4-3ac558b14bda	5a3d4806-974f-4754-b6cb-65a7dfa27548	79a75000-387f-45e9-b858-a7766c451f00	active	75cb2baa-b33b-4762-b981-b4f97364ed22
9b2a328d-6e76-45dd-83ac-20ab7fcab1bd	5a3d4806-974f-4754-b6cb-65a7dfa27548	780ba1c1-34a2-4573-98f9-9a8c6661e44c	active	75cb2baa-b33b-4762-b981-b4f97364ed22
f517ac12-baca-4618-8e62-90fac8c2e42c	5a3d4806-974f-4754-b6cb-65a7dfa27548	896438ce-8705-4cc8-bc5b-8212b9cca4c6	active	75cb2baa-b33b-4762-b981-b4f97364ed22
22cf0b2a-bbd5-446f-b579-0fbe68151f71	9db98dbb-0a64-4588-8e57-533f05a6e050	f59be7f4-6494-42a9-b21f-388930fca8cd	active	33125ba6-51d0-49db-88f0-d15ab1cfbb0e
6a2144ec-fa7d-4e64-837c-92a7a737959c	9db98dbb-0a64-4588-8e57-533f05a6e050	48b28754-6373-4a72-a431-654bf4e5d58e	active	33125ba6-51d0-49db-88f0-d15ab1cfbb0e
bf1a4b7d-dd1b-44c5-be0a-21381e8201cc	205c33b6-106f-40c3-804c-a2835f6104a9	f59be7f4-6494-42a9-b21f-388930fca8cd	active	7ffae5cf-57bd-40cf-ac63-1d66fb93e429
062d9607-11d3-4ffe-ae66-6800daf124a3	205c33b6-106f-40c3-804c-a2835f6104a9	5c72b096-cb94-4c1d-a976-3822e2690dc7	active	7ffae5cf-57bd-40cf-ac63-1d66fb93e429
88c916a2-bc7c-4a1a-80af-4f2289151281	f7a32926-f029-47f4-8649-e3b2997f69d3	f59be7f4-6494-42a9-b21f-388930fca8cd	active	a945bf8f-ad7d-43e1-9374-bacf83b24c8b
4e795149-5b50-4e14-ba22-b02338082d3f	f7a32926-f029-47f4-8649-e3b2997f69d3	ae3a5e55-cbfd-45cc-adbd-1d4e74add7d9	active	a945bf8f-ad7d-43e1-9374-bacf83b24c8b
27cd3fe7-4661-469d-8e0f-e159a841f44a	f7a32926-f029-47f4-8649-e3b2997f69d3	4462f385-b858-4c8f-8088-7fd85b9c9537	active	a945bf8f-ad7d-43e1-9374-bacf83b24c8b
b16b4987-6d06-4019-892b-fc0d9919107c	ced8947c-7c6b-4874-ad5e-c28ba91f8073	f59be7f4-6494-42a9-b21f-388930fca8cd	active	2eb6042c-7740-4c4f-b636-76ce8ce6a357
04887173-fbbd-4604-a557-59a826ff2425	ced8947c-7c6b-4874-ad5e-c28ba91f8073	23c37819-576e-4ad0-bca6-2667137bfe99	active	2eb6042c-7740-4c4f-b636-76ce8ce6a357
84d88583-e649-4118-a058-e9b8ff2a7d8b	ced8947c-7c6b-4874-ad5e-c28ba91f8073	4d699059-2886-444e-9c0b-95540ff4bf93	active	2eb6042c-7740-4c4f-b636-76ce8ce6a357
3522fdb1-f155-4a8f-a4dd-6aa8ad2137f0	b9582bd1-bfff-41e1-990f-962c18084f4d	f59be7f4-6494-42a9-b21f-388930fca8cd	active	9bdd4aa6-2e18-4e58-8914-1c4adf1b8916
1aeecfbb-c4e7-4dd0-9c79-4fb306ec4c74	b9582bd1-bfff-41e1-990f-962c18084f4d	7b407771-8e80-41ab-9223-8cafa6fa4ba4	active	9bdd4aa6-2e18-4e58-8914-1c4adf1b8916
e6780945-ea9c-426b-84c5-b1af3655f240	b9582bd1-bfff-41e1-990f-962c18084f4d	7d11d541-24f7-45fa-b2b7-0c8c663426a5	active	9bdd4aa6-2e18-4e58-8914-1c4adf1b8916
44655d81-4036-4221-a9fb-2467ab2cf45e	1c17435c-508d-4194-9d06-f923d31c60cf	f59be7f4-6494-42a9-b21f-388930fca8cd	active	1504af47-63ff-4fbf-b415-13f245e3530f
cbd6ce82-8c94-4309-a141-c2c6261f260c	1c17435c-508d-4194-9d06-f923d31c60cf	844950d1-bc39-4374-aa5e-3228164fd656	active	1504af47-63ff-4fbf-b415-13f245e3530f
8c4c9c09-14a8-4ff5-ba7f-78d7e8873c6d	e3623259-d93b-4596-930a-0282a07b5666	15932183-9b6f-4cd9-b180-351824d71d96	active	f29df221-7759-4fe2-bf70-c1c0f0f4d049
656b2889-1ccb-4802-8095-d3ad2678f311	b57f2ed1-ee10-469b-afcc-a4d7636d39c7	f59be7f4-6494-42a9-b21f-388930fca8cd	active	b349135d-a405-4e84-a347-9acbd6b9c0a5
94f85963-9039-4bb5-890d-cb589007ca8c	b57f2ed1-ee10-469b-afcc-a4d7636d39c7	c1faa2e7-035c-47d1-9d35-cc497728b8d6	active	b349135d-a405-4e84-a347-9acbd6b9c0a5
33c8d761-f54d-446e-9dc2-7b8debbebfbb	f22a7938-303f-4ac6-92da-526a4ad2a207	f1cfeeff-4ba7-4172-ba51-550d8183db28	active	5f4eb519-36a4-444a-bed2-c545d3f4d20b
b704dcc6-61a2-4d87-9ae5-874100dbafde	f22a7938-303f-4ac6-92da-526a4ad2a207	27eecd38-da7f-437c-aa78-e0468be5b594	active	5f4eb519-36a4-444a-bed2-c545d3f4d20b
79b5708e-fe89-4cff-9f96-1117ad5b36b2	b99894af-7866-4a81-beee-30e0e384b708	f59be7f4-6494-42a9-b21f-388930fca8cd	active	b87e9ad0-7f68-473d-a15b-64ca1f253bfc
a76189a3-342a-4665-9eeb-547bd691d85e	b99894af-7866-4a81-beee-30e0e384b708	c6152eae-a552-4cc0-8b5e-a0c72a6987b0	active	b87e9ad0-7f68-473d-a15b-64ca1f253bfc
7dc75136-1eaf-4f0b-819e-2da37e1e916d	b99894af-7866-4a81-beee-30e0e384b708	27eecd38-da7f-437c-aa78-e0468be5b594	active	b87e9ad0-7f68-473d-a15b-64ca1f253bfc
7ee11be3-5b19-4d6b-ad56-76871e549011	3d4e64cc-54c0-4b3e-b865-2fff3d9845e7	c6152eae-a552-4cc0-8b5e-a0c72a6987b0	active	117f797d-1662-4d4f-8779-08a5af2ca1aa
1378a69e-4b01-4d40-8dcd-8c68862f0db6	3d4e64cc-54c0-4b3e-b865-2fff3d9845e7	f59be7f4-6494-42a9-b21f-388930fca8cd	active	117f797d-1662-4d4f-8779-08a5af2ca1aa
51d70922-bb25-49d6-a02d-6fc71ad81589	3d4e64cc-54c0-4b3e-b865-2fff3d9845e7	27eecd38-da7f-437c-aa78-e0468be5b594	active	117f797d-1662-4d4f-8779-08a5af2ca1aa
f2438ce5-8bf4-45f7-8ea9-ca9c0d84a13e	83e56067-9ee5-48b2-83d0-91e723eb8b3d	713e34bc-6b1c-48fe-8030-c755f956251e	active	b5c703cf-ee4d-4b5d-b9fe-e5385976b7d9
46b46082-3b31-4527-82ca-6dad2e812625	83e56067-9ee5-48b2-83d0-91e723eb8b3d	ef2f172c-e71a-497a-8373-56c47d9cbe5a	active	b5c703cf-ee4d-4b5d-b9fe-e5385976b7d9
35734760-1f8d-4d3a-af90-45a4eac89e2d	83e56067-9ee5-48b2-83d0-91e723eb8b3d	59fc41c4-2a4d-459b-b489-54ad20f26fe7	active	b5c703cf-ee4d-4b5d-b9fe-e5385976b7d9
76e079d8-cd7c-4a5c-822a-bed23f5befad	e1b56ce2-aea6-4d44-b877-86a13f92697c	f59be7f4-6494-42a9-b21f-388930fca8cd	active	b4a1d15b-e861-453a-a288-467e743dd51b
83558327-9d1d-4dac-99ef-9d3d18516def	e1b56ce2-aea6-4d44-b877-86a13f92697c	59fc41c4-2a4d-459b-b489-54ad20f26fe7	active	b4a1d15b-e861-453a-a288-467e743dd51b
42c11b44-9b1c-4de1-9445-61c61c55b1c9	e1b56ce2-aea6-4d44-b877-86a13f92697c	713e34bc-6b1c-48fe-8030-c755f956251e	active	b4a1d15b-e861-453a-a288-467e743dd51b
414ffeb3-f96e-4624-8fb9-133dd5467c92	d6c6d3f9-5d8d-46c8-bc92-d8507d1e6f04	f59be7f4-6494-42a9-b21f-388930fca8cd	active	a7e3dd94-6c86-413f-abfe-3bed55bf9d85
6b57f9a0-d2f9-4e2a-aa9c-4d97f16f6677	d6c6d3f9-5d8d-46c8-bc92-d8507d1e6f04	91dea717-03c4-4fbb-81e0-07bfdc3ec10d	active	a7e3dd94-6c86-413f-abfe-3bed55bf9d85
117d45e3-10fd-4ecd-99ff-e9e1fd5d3e41	d6c6d3f9-5d8d-46c8-bc92-d8507d1e6f04	5315cfeb-aa6e-49e1-b42f-12daed6ad2fa	active	a7e3dd94-6c86-413f-abfe-3bed55bf9d85
363b37c1-e91e-42dd-b7d5-69396e195f48	d6c6d3f9-5d8d-46c8-bc92-d8507d1e6f04	55546b47-fe3c-40bc-acc9-f78d285d9f13	active	a7e3dd94-6c86-413f-abfe-3bed55bf9d85
841c4aec-47f3-4b88-8449-3709edae73a3	8a7d516b-f3c2-4a5b-afde-d2bdff371937	f59be7f4-6494-42a9-b21f-388930fca8cd	active	ce9bcc80-ad33-4db0-82d4-fb3cab033fd5
f342ac86-fb21-47da-b18d-5d3a380e9d8a	8a7d516b-f3c2-4a5b-afde-d2bdff371937	5315cfeb-aa6e-49e1-b42f-12daed6ad2fa	active	ce9bcc80-ad33-4db0-82d4-fb3cab033fd5
d5318895-140d-4ca5-bde5-1bc038e460ec	fe7cd753-376f-4f22-a721-caa482aa1116	f59be7f4-6494-42a9-b21f-388930fca8cd	active	34579160-706c-4b4e-86e7-1deddb37f9e0
310d31bc-18c6-468f-a63a-d81b9c47558c	fe7cd753-376f-4f22-a721-caa482aa1116	3a1a6c2d-976e-41a2-a797-3e59b8165ebd	active	34579160-706c-4b4e-86e7-1deddb37f9e0
37c00005-d6cb-4fad-a94b-3f2736e86244	fe7cd753-376f-4f22-a721-caa482aa1116	8de57ce1-e9cd-4eb3-8432-64aba816c41d	active	34579160-706c-4b4e-86e7-1deddb37f9e0
65b03e32-4fdb-408e-914f-1b573349dc75	fe7cd753-376f-4f22-a721-caa482aa1116	df234aea-eb2b-4510-ac40-53b599633686	active	34579160-706c-4b4e-86e7-1deddb37f9e0
6fbd44e5-769c-4b7e-a909-1d38c35ca9c0	fe7cd753-376f-4f22-a721-caa482aa1116	ccb3fac5-0925-43b0-8ca8-5a797a6bc18f	active	34579160-706c-4b4e-86e7-1deddb37f9e0
740e3aa4-ec65-410f-acf8-5082eaa26f22	60e23204-8e78-487c-92bd-5de0c6102067	f59be7f4-6494-42a9-b21f-388930fca8cd	active	9072590d-3b6f-4ac1-89d3-0751de5632a7
e71787b8-649d-41e3-bbbc-a8658666c08d	60e23204-8e78-487c-92bd-5de0c6102067	aa907186-83cf-4307-bb57-e02f3aec858f	active	9072590d-3b6f-4ac1-89d3-0751de5632a7
ea783b65-b09f-42f1-a585-840ba1491d0b	60e23204-8e78-487c-92bd-5de0c6102067	7ef1856f-5ec1-4c92-aebd-9ec3e4bb78e3	active	9072590d-3b6f-4ac1-89d3-0751de5632a7
cffe6c61-b7f5-491a-99c5-8771908a4788	4654898f-58f4-482f-a91f-23aa5e192fd8	c6152eae-a552-4cc0-8b5e-a0c72a6987b0	active	2d7fa951-5b6e-494f-ad7e-a7afcea2cd4f
280e25eb-98a2-40f6-be3d-47dd514c5dea	4654898f-58f4-482f-a91f-23aa5e192fd8	f59be7f4-6494-42a9-b21f-388930fca8cd	active	2d7fa951-5b6e-494f-ad7e-a7afcea2cd4f
fd8f6f19-0e67-4a63-9932-0e69e2a80303	4654898f-58f4-482f-a91f-23aa5e192fd8	27eecd38-da7f-437c-aa78-e0468be5b594	active	2d7fa951-5b6e-494f-ad7e-a7afcea2cd4f
53b35c4b-55da-4a85-b068-5b6232d05403	20100c39-31ae-4fd4-ad35-bfeabe396b5f	90d603f6-c175-4a13-98b5-4692581b294c	active	12caea82-db74-4ffa-b7ed-c149e2352e9a
cc523ea9-8432-4937-8af6-10079435016e	20100c39-31ae-4fd4-ad35-bfeabe396b5f	f49977cb-1a77-436c-bfb1-02844992933f	active	12caea82-db74-4ffa-b7ed-c149e2352e9a
77bc4616-63ec-492d-9d70-8fc95efb7369	20100c39-31ae-4fd4-ad35-bfeabe396b5f	23f8e389-394e-45ea-b71e-fcbf0bada070	active	12caea82-db74-4ffa-b7ed-c149e2352e9a
24d95415-43fd-4273-a369-a0d41771b83a	497e8d74-14c2-401e-bc0d-a4b473f77eb1	0fa92041-ce27-4e68-b3d3-c9b43f3c6de6	active	fc63ab3d-50cd-4753-9ff3-12aa14ce6692
909719c7-27da-4b62-aa34-dfd9874d8b44	497e8d74-14c2-401e-bc0d-a4b473f77eb1	b746c869-367e-4517-8cb6-8e8fff168bcf	active	fc63ab3d-50cd-4753-9ff3-12aa14ce6692
d3169837-850b-41af-8d1a-6e0b7bdd7cb2	497e8d74-14c2-401e-bc0d-a4b473f77eb1	67067ff6-231d-4cb0-bf1c-53d232693248	active	fc63ab3d-50cd-4753-9ff3-12aa14ce6692
30dce56a-08d9-48ed-a778-3474e0fd59e1	497e8d74-14c2-401e-bc0d-a4b473f77eb1	3ac4b1c0-ef85-4a8a-978d-790935bf856a	active	fc63ab3d-50cd-4753-9ff3-12aa14ce6692
0401285a-82e4-4b1c-8511-a1aaed0c387a	497e8d74-14c2-401e-bc0d-a4b473f77eb1	62cec790-8fe7-401a-8a14-25854875fc87	active	fc63ab3d-50cd-4753-9ff3-12aa14ce6692
49b69ec5-90fb-4a7a-8347-6d96afaeef68	1cf46091-d128-4e38-a7b7-97901d423aaf	473f15dd-47c0-40a6-89e9-3a053ab172a4	active	66b128d0-c36c-48b8-a78a-92b6182586d1
bf3755de-80a5-497e-9f65-f6adf1414c65	1cf46091-d128-4e38-a7b7-97901d423aaf	15bbdb5e-f0f9-4749-bc70-9d3ecd9d4f62	active	66b128d0-c36c-48b8-a78a-92b6182586d1
aa54be22-3284-4e4f-94bd-c61642754d6d	1cf46091-d128-4e38-a7b7-97901d423aaf	a1240961-70a8-4405-8f9d-1f883f120a87	active	66b128d0-c36c-48b8-a78a-92b6182586d1
48bfcc71-8f01-47fd-930e-0e2cb8c95909	1cf46091-d128-4e38-a7b7-97901d423aaf	5667cc10-9e4c-4a5c-9b5f-a1270ec087f5	active	66b128d0-c36c-48b8-a78a-92b6182586d1
b933fa8b-f141-444c-90b6-d95ec13d71e7	1cf46091-d128-4e38-a7b7-97901d423aaf	f00b6c16-7867-409b-8439-4e50dd7f12e1	active	66b128d0-c36c-48b8-a78a-92b6182586d1
b78c9b4a-396c-40db-b7db-4ec987f4c85e	ece794a5-613f-4607-9046-fb37906f87ce	896438ce-8705-4cc8-bc5b-8212b9cca4c6	active	1cc6d560-7a4a-4505-81e8-290e440c9c0b
06c79ad3-91a9-425c-8137-278685f9ea60	ece794a5-613f-4607-9046-fb37906f87ce	f1214aeb-9ad3-4e93-b298-2c6618a02f7e	active	1cc6d560-7a4a-4505-81e8-290e440c9c0b
b5951999-b2f8-49c9-9461-03857afcdcc6	ece794a5-613f-4607-9046-fb37906f87ce	3060b98a-0207-404a-b5a4-96e8e6885767	active	1cc6d560-7a4a-4505-81e8-290e440c9c0b
b86bcd87-92e8-4232-9cfd-62e52299a386	ece794a5-613f-4607-9046-fb37906f87ce	dbdc596b-44c1-42c5-8116-f7d1968cbf13	active	1cc6d560-7a4a-4505-81e8-290e440c9c0b
7a82c38a-e38b-4f65-a71c-79544102167e	ece794a5-613f-4607-9046-fb37906f87ce	705d6aed-b1d5-4b89-ad38-be4a1daba35d	active	1cc6d560-7a4a-4505-81e8-290e440c9c0b
4080f62e-cbf6-43e4-8ddc-68fa3bf7bb06	ece794a5-613f-4607-9046-fb37906f87ce	59177438-4307-4673-b274-0963552ee8b7	active	1cc6d560-7a4a-4505-81e8-290e440c9c0b
91594332-e472-4f78-829d-ed696c483d8a	ece794a5-613f-4607-9046-fb37906f87ce	41ccd9ba-7563-4db6-a0a2-31e93dbf21c5	active	1cc6d560-7a4a-4505-81e8-290e440c9c0b
98c31b41-9727-4b3b-bc35-dce772f915fc	d794f07a-06d3-4b59-a969-c00af70ff8db	f1214aeb-9ad3-4e93-b298-2c6618a02f7e	active	5ec1bdc2-fcbf-4932-b6a6-247c87ed9377
20754bc2-562c-43e0-96ef-66f6814f9598	d794f07a-06d3-4b59-a969-c00af70ff8db	3060b98a-0207-404a-b5a4-96e8e6885767	active	5ec1bdc2-fcbf-4932-b6a6-247c87ed9377
10f6e9fb-511b-451d-8eec-171516743cc6	d794f07a-06d3-4b59-a969-c00af70ff8db	dbdc596b-44c1-42c5-8116-f7d1968cbf13	active	5ec1bdc2-fcbf-4932-b6a6-247c87ed9377
09488764-6ff1-424c-864c-f2b61bb0c06b	d794f07a-06d3-4b59-a969-c00af70ff8db	896438ce-8705-4cc8-bc5b-8212b9cca4c6	active	5ec1bdc2-fcbf-4932-b6a6-247c87ed9377
f991dc6d-50f2-4e07-a810-e183a5d60a9d	d794f07a-06d3-4b59-a969-c00af70ff8db	705d6aed-b1d5-4b89-ad38-be4a1daba35d	active	5ec1bdc2-fcbf-4932-b6a6-247c87ed9377
a651c708-845b-4a46-bc59-45e37dfb5070	d794f07a-06d3-4b59-a969-c00af70ff8db	59177438-4307-4673-b274-0963552ee8b7	active	5ec1bdc2-fcbf-4932-b6a6-247c87ed9377
25fba1e6-59c8-4129-8a73-030f9dc6ccb3	d794f07a-06d3-4b59-a969-c00af70ff8db	41ccd9ba-7563-4db6-a0a2-31e93dbf21c5	active	5ec1bdc2-fcbf-4932-b6a6-247c87ed9377
fc288d85-b987-4db0-948e-e94efba97d95	5efedd90-782d-4129-8e71-fdd3b6e1c7df	f1214aeb-9ad3-4e93-b298-2c6618a02f7e	active	195959a3-77de-4e3d-95e4-8c5989ddd65d
a93022ac-1b23-4839-b89d-931d7550b7c9	5efedd90-782d-4129-8e71-fdd3b6e1c7df	3060b98a-0207-404a-b5a4-96e8e6885767	active	195959a3-77de-4e3d-95e4-8c5989ddd65d
af6d0b94-148c-4199-8e58-d83b56687dbe	5efedd90-782d-4129-8e71-fdd3b6e1c7df	dbdc596b-44c1-42c5-8116-f7d1968cbf13	active	195959a3-77de-4e3d-95e4-8c5989ddd65d
c1f5fcde-eabb-4250-b617-1a65d1598864	5efedd90-782d-4129-8e71-fdd3b6e1c7df	896438ce-8705-4cc8-bc5b-8212b9cca4c6	active	195959a3-77de-4e3d-95e4-8c5989ddd65d
1682f9e2-7f41-4d67-a070-cb43f049d0cc	5efedd90-782d-4129-8e71-fdd3b6e1c7df	705d6aed-b1d5-4b89-ad38-be4a1daba35d	active	195959a3-77de-4e3d-95e4-8c5989ddd65d
e8113246-f746-4e57-b3d6-c3f3783cb31d	5efedd90-782d-4129-8e71-fdd3b6e1c7df	59177438-4307-4673-b274-0963552ee8b7	active	195959a3-77de-4e3d-95e4-8c5989ddd65d
958dee35-44ce-4aca-bb08-01445d8b853b	5efedd90-782d-4129-8e71-fdd3b6e1c7df	41ccd9ba-7563-4db6-a0a2-31e93dbf21c5	active	195959a3-77de-4e3d-95e4-8c5989ddd65d
c6fe6976-7471-4bce-ab39-0ca475bb46d7	f1261a91-9d52-4520-837e-e9c793f28dcc	f1214aeb-9ad3-4e93-b298-2c6618a02f7e	active	df459aea-8e94-463f-835f-cdcd6ec1327c
a64d7da3-de28-4e08-83cf-f295b9116906	f1261a91-9d52-4520-837e-e9c793f28dcc	3060b98a-0207-404a-b5a4-96e8e6885767	active	df459aea-8e94-463f-835f-cdcd6ec1327c
3e6d989d-94ee-4ce0-b0bc-25b6191540c3	f1261a91-9d52-4520-837e-e9c793f28dcc	dbdc596b-44c1-42c5-8116-f7d1968cbf13	active	df459aea-8e94-463f-835f-cdcd6ec1327c
2eb342c8-d136-42b7-b48f-b05e1ad9cf38	f1261a91-9d52-4520-837e-e9c793f28dcc	896438ce-8705-4cc8-bc5b-8212b9cca4c6	active	df459aea-8e94-463f-835f-cdcd6ec1327c
1d8cf078-165e-41ef-95cf-e8aee9687af3	f1261a91-9d52-4520-837e-e9c793f28dcc	705d6aed-b1d5-4b89-ad38-be4a1daba35d	active	df459aea-8e94-463f-835f-cdcd6ec1327c
e1ce66e2-eb55-4b82-931b-145ec39d7024	f1261a91-9d52-4520-837e-e9c793f28dcc	59177438-4307-4673-b274-0963552ee8b7	active	df459aea-8e94-463f-835f-cdcd6ec1327c
ee3fbabb-1c04-4e9f-9c41-cef1f7929011	f1261a91-9d52-4520-837e-e9c793f28dcc	41ccd9ba-7563-4db6-a0a2-31e93dbf21c5	active	df459aea-8e94-463f-835f-cdcd6ec1327c
d328989f-3089-4364-90e1-0453efca3b4e	df63f81c-7a27-49d1-86c8-8d5e49883d40	ee1bf582-8672-4f86-a84e-c958ff2e7205	active	0f7316bd-5b12-443c-b846-ea48cd376a1c
52a76871-e1d1-4515-9d86-7cf6ebb794f2	df63f81c-7a27-49d1-86c8-8d5e49883d40	5fe1c7b0-f733-44c4-abcf-04659911d91a	active	0f7316bd-5b12-443c-b846-ea48cd376a1c
16914a20-1a9d-474d-bddf-6ae67c723bba	df63f81c-7a27-49d1-86c8-8d5e49883d40	2b55a614-018b-47c8-a07c-8acc2071a433	active	0f7316bd-5b12-443c-b846-ea48cd376a1c
a2130704-dfae-47d3-815a-3c1f78781550	8d9cf757-de83-4774-919b-00c45c43efd4	a0da534f-3b88-4e01-bdda-f58bf9b11407	active	657e1e1a-5a1b-40d4-b09c-61db5208662f
ec8bc2f6-39e0-4d85-b823-f1fd3187b546	8d9cf757-de83-4774-919b-00c45c43efd4	071a3720-55dd-4638-a31f-40762c38b6e5	active	657e1e1a-5a1b-40d4-b09c-61db5208662f
71f02ccc-b5a7-4f6f-844b-2d68a0c61e7a	8d9cf757-de83-4774-919b-00c45c43efd4	edaea925-2eef-4da8-a393-faf910b4314f	active	657e1e1a-5a1b-40d4-b09c-61db5208662f
90a45f6c-1177-4f12-8dae-40fa8f4a7170	196340e0-5246-4bc2-8b69-54c66a48b399	27eecd38-da7f-437c-aa78-e0468be5b594	active	1220be1d-b2b7-491a-a02a-708eb1f990d7
f4b3a37a-daa2-48fe-b5db-8fb1a3c9b46b	196340e0-5246-4bc2-8b69-54c66a48b399	5124b3b1-4ada-47c7-863d-db4e72b65371	active	1220be1d-b2b7-491a-a02a-708eb1f990d7
04d3a5e6-f4fe-466d-91da-f90698a36372	196340e0-5246-4bc2-8b69-54c66a48b399	f73dd96b-0c6a-4d09-bd4a-313fe368ddbe	active	1220be1d-b2b7-491a-a02a-708eb1f990d7
30f45143-0e9b-492c-8157-5efab4d9317d	196340e0-5246-4bc2-8b69-54c66a48b399	4007f503-7979-4147-98de-2c29348abc43	active	1220be1d-b2b7-491a-a02a-708eb1f990d7
390dd4fc-e438-4850-b85c-d8d7df7c5cb4	196340e0-5246-4bc2-8b69-54c66a48b399	2d518686-9f62-426f-9a2b-1b2fc94b90e4	active	1220be1d-b2b7-491a-a02a-708eb1f990d7
fd72b1ca-544b-4ec8-8f97-fb2f2fb1f6d9	196340e0-5246-4bc2-8b69-54c66a48b399	5bd30510-2edd-446a-bb97-091a5179e92d	active	1220be1d-b2b7-491a-a02a-708eb1f990d7
e0834d40-e60a-4de8-a7ab-f6bd8a664bb9	196340e0-5246-4bc2-8b69-54c66a48b399	3c7cf1a0-26ba-4460-bdf0-f282b2964c02	active	1220be1d-b2b7-491a-a02a-708eb1f990d7
46433feb-eb27-41dc-9546-12dbe9d9bde1	196340e0-5246-4bc2-8b69-54c66a48b399	3b95f7ef-56e7-4d11-aa64-0c078a4ba24c	active	1220be1d-b2b7-491a-a02a-708eb1f990d7
10a25fe6-d1e3-4da6-8058-7f70a4b6d49e	196340e0-5246-4bc2-8b69-54c66a48b399	d057758e-a4a2-4125-82bd-83b96a2136da	active	1220be1d-b2b7-491a-a02a-708eb1f990d7
7c877b38-4241-4df2-be92-4189a0848f6a	7f6c30c6-d6a5-4d39-ae5d-e1ae4cc2d3ef	a75a070f-44a9-4a8d-8818-368ed36a895d	active	daf6450f-138d-42d9-acc4-c2f02339def3
48c348a8-f38d-46ab-ab38-7435f80706f6	7f6c30c6-d6a5-4d39-ae5d-e1ae4cc2d3ef	44b7a7ef-c7f5-4f0e-bfe9-066ad966f577	active	daf6450f-138d-42d9-acc4-c2f02339def3
6fb38e22-accd-45c0-8ef5-d1118c19d88a	7f6c30c6-d6a5-4d39-ae5d-e1ae4cc2d3ef	4233e616-3f33-49fb-aa6c-7b54554dec19	active	fb039b32-eb70-48ac-8532-ac1572e12acc
6e336f12-6624-405e-ae39-f546b2a99eae	cdc13d67-6360-43a6-bb99-cd68b64ee3f3	a0da534f-3b88-4e01-bdda-f58bf9b11407	active	081aa116-4b83-4ecc-b179-41fc2f9c398b
fe095f6a-3f75-4f0e-ae75-b60f50f50ff3	cdc13d67-6360-43a6-bb99-cd68b64ee3f3	4d699059-2886-444e-9c0b-95540ff4bf93	active	081aa116-4b83-4ecc-b179-41fc2f9c398b
ab6ed41f-5549-40de-b83a-57ecc44627ed	cdc13d67-6360-43a6-bb99-cd68b64ee3f3	6fdeda39-0549-4a0f-964b-51beae1d914c	active	081aa116-4b83-4ecc-b179-41fc2f9c398b
ffa1e935-ccbe-470d-872f-e8212f8c1361	b99894af-7866-4a81-beee-30e0e384b708	4e29bdcb-88d1-4b1d-8e85-4ab68f1e4db7	active	f579ee41-b9dd-4c74-a8e7-e8260d76ce8b
c1ddb79d-1682-4a73-9fab-b8401cf44fc3	ac051eb3-275f-40a5-b160-e224d13902e7	1812b303-186d-4734-a4cb-1345949485d9	active	9bd678be-b57f-4582-9c02-1a5c106f9f2c
77b1f859-9497-4457-bed1-c88aea2ba9b8	ac051eb3-275f-40a5-b160-e224d13902e7	920f0530-0a9e-49c0-9978-f3d9ff3925c4	active	9bd678be-b57f-4582-9c02-1a5c106f9f2c
63ed86b3-e580-4c86-ac38-d297b4149a25	ac051eb3-275f-40a5-b160-e224d13902e7	473f15dd-47c0-40a6-89e9-3a053ab172a4	active	9bd678be-b57f-4582-9c02-1a5c106f9f2c
adc0b6d4-3691-417f-b652-174cb31f3b04	67906f75-4298-4b6a-aa62-d8314be33f15	b57f29c3-0179-4d53-8f0e-f400acab0e07	active	6e196cec-2bdc-4b09-b540-8d55debe949b
8e2f1ce9-f82f-49f8-bd6e-5927a00fdd10	67906f75-4298-4b6a-aa62-d8314be33f15	ee1bf582-8672-4f86-a84e-c958ff2e7205	active	6e196cec-2bdc-4b09-b540-8d55debe949b
e6092105-855d-4442-8d66-b9be92b06d9f	67906f75-4298-4b6a-aa62-d8314be33f15	920f0530-0a9e-49c0-9978-f3d9ff3925c4	active	6e196cec-2bdc-4b09-b540-8d55debe949b
0203f99c-f61d-4f4b-9eae-8532fddf545b	67906f75-4298-4b6a-aa62-d8314be33f15	aac980e1-0aa5-41e0-b6e0-eebbab19c7c9	active	6e196cec-2bdc-4b09-b540-8d55debe949b
dca56ed6-d348-450e-97e7-1325675d9449	67906f75-4298-4b6a-aa62-d8314be33f15	1812b303-186d-4734-a4cb-1345949485d9	active	6e196cec-2bdc-4b09-b540-8d55debe949b
156c912d-716d-463e-9f1b-add249a2237c	67906f75-4298-4b6a-aa62-d8314be33f15	a6428b13-2aea-4468-b051-a7b7b2c81ad2	active	6e196cec-2bdc-4b09-b540-8d55debe949b
d93160e4-04b5-47c7-bac3-be510f037859	84b91384-8ec9-4b55-8dc9-28ff8c6db62f	896438ce-8705-4cc8-bc5b-8212b9cca4c6	active	e4086bee-133a-43fd-b352-10bacd65ee70
34f3a48a-71e8-43f0-840e-a1b4ece471a4	84b91384-8ec9-4b55-8dc9-28ff8c6db62f	3640e8d5-1d55-4a85-968e-539f45ed137e	active	e4086bee-133a-43fd-b352-10bacd65ee70
43226a13-e430-4d20-88d8-b1609cdf3652	84b91384-8ec9-4b55-8dc9-28ff8c6db62f	f13fdde8-8913-46b8-852f-8508edfc112c	active	e4086bee-133a-43fd-b352-10bacd65ee70
1e436203-d6f8-4636-848d-dbf3ff85e6ca	1dacf074-ad54-432a-a04f-cecd3a068d0c	f1cfeeff-4ba7-4172-ba51-550d8183db28	active	5c5b9cbd-eac0-40d0-86f0-0d9c9ae096b7
6f6f025a-ac3a-45ac-b254-4391435f1c72	1dacf074-ad54-432a-a04f-cecd3a068d0c	adcb0b79-7ada-4467-8f7d-ca6ce7a60405	active	5c5b9cbd-eac0-40d0-86f0-0d9c9ae096b7
93b790b4-4db9-4fe2-9e38-0f297e1d206c	32ccab1e-e85e-4f52-84f5-69bbcc5fa53d	2d518686-9f62-426f-9a2b-1b2fc94b90e4	active	10ac057b-4a62-4be2-9333-99cbb69c179a
46b0c5fb-ec0f-40cd-ac25-51647caad9d7	32ccab1e-e85e-4f52-84f5-69bbcc5fa53d	16d6bc5a-fbb0-4356-9ac9-899576f74460	active	10ac057b-4a62-4be2-9333-99cbb69c179a
a3129391-410f-4912-aedf-ba97dd4a7f28	32ccab1e-e85e-4f52-84f5-69bbcc5fa53d	4233e616-3f33-49fb-aa6c-7b54554dec19	active	10ac057b-4a62-4be2-9333-99cbb69c179a
d5121069-3a0b-45f1-99c7-46fc3dc5b214	32ccab1e-e85e-4f52-84f5-69bbcc5fa53d	265b6084-04e7-4f95-85a7-5e9ae3612438	active	10ac057b-4a62-4be2-9333-99cbb69c179a
ee90a2f3-f02b-48e2-a6b3-0b5fb4d29c81	32ccab1e-e85e-4f52-84f5-69bbcc5fa53d	0192674f-4aab-4a85-9451-91de8fb06d35	active	10ac057b-4a62-4be2-9333-99cbb69c179a
ea6b755f-ce23-42c7-acee-09e8a2deb1d9	32ccab1e-e85e-4f52-84f5-69bbcc5fa53d	aa5647cc-7f19-419c-88d2-c643289824bf	active	10ac057b-4a62-4be2-9333-99cbb69c179a
b6f54e88-24fc-4866-9ed3-d31e6c122330	89a894cc-c5c8-44e2-9ca3-85ab9a0130f9	2a33d5a2-9d58-4d8e-975d-ee07da3d6b0e	active	d7f22ef7-54bb-4348-b287-62fcb6da90f0
d5fde912-6e33-4073-b975-bb1084b13348	89a894cc-c5c8-44e2-9ca3-85ab9a0130f9	27eecd38-da7f-437c-aa78-e0468be5b594	active	d7f22ef7-54bb-4348-b287-62fcb6da90f0
462ecc73-7e12-4d54-8b18-cf6cffbb47ba	89a894cc-c5c8-44e2-9ca3-85ab9a0130f9	4233e616-3f33-49fb-aa6c-7b54554dec19	active	d7f22ef7-54bb-4348-b287-62fcb6da90f0
f5e6c9e6-780c-481d-878e-05da02b3982a	89a894cc-c5c8-44e2-9ca3-85ab9a0130f9	34940451-48bb-40f3-9bcf-8fc1a2df5bda	active	d7f22ef7-54bb-4348-b287-62fcb6da90f0
ffb2ab48-ff5a-449b-a5a1-ac50b0fb01b2	89a894cc-c5c8-44e2-9ca3-85ab9a0130f9	3c7cf1a0-26ba-4460-bdf0-f282b2964c02	active	d7f22ef7-54bb-4348-b287-62fcb6da90f0
6b730dda-b9d2-4530-a64b-f5d1ff96de46	89a894cc-c5c8-44e2-9ca3-85ab9a0130f9	12cf3b7a-04a7-464c-be9c-db71b554ddf8	active	d7f22ef7-54bb-4348-b287-62fcb6da90f0
b8e46306-9ba3-41b6-b16f-41224b59f35a	89a894cc-c5c8-44e2-9ca3-85ab9a0130f9	90d603f6-c175-4a13-98b5-4692581b294c	active	d7f22ef7-54bb-4348-b287-62fcb6da90f0
91a502d4-aefc-46a4-b4f9-b06149bb4862	89a894cc-c5c8-44e2-9ca3-85ab9a0130f9	10eda8bb-9840-479a-ba70-b1a6c632db68	active	d7f22ef7-54bb-4348-b287-62fcb6da90f0
bedee48c-362b-4eaf-bfb1-40287a435236	89a894cc-c5c8-44e2-9ca3-85ab9a0130f9	d057758e-a4a2-4125-82bd-83b96a2136da	active	d7f22ef7-54bb-4348-b287-62fcb6da90f0
389a273a-c5fc-4df6-b2ae-23b95b6d407b	5b23d4f4-058e-44e0-945d-ae9035fb1e15	a75a070f-44a9-4a8d-8818-368ed36a895d	active	c358b6bb-4b0a-48ee-9421-0854d1f68fca
75042bb5-182c-4d16-941c-8f84134b67db	159b6644-94ed-406d-8e1e-1f002f265396	071a3720-55dd-4638-a31f-40762c38b6e5	active	502b47d9-44a6-4b77-8f21-1f36c2d6eeb9
b1246808-603f-421c-affb-343f40327a63	159b6644-94ed-406d-8e1e-1f002f265396	edaea925-2eef-4da8-a393-faf910b4314f	active	502b47d9-44a6-4b77-8f21-1f36c2d6eeb9
c1b40feb-4d78-4ede-b921-acc4c36150f8	be516eed-8a37-436c-af75-b623f0806f39	a58d7975-f96e-4089-8e24-64cbdba09a1f	active	df68a822-74c8-41c1-8cfe-d0d1a685c74f
56f96cb2-181e-444e-b5fa-c3622db2b159	be516eed-8a37-436c-af75-b623f0806f39	6ead3562-71c5-4cdb-837e-878cc2da2534	active	df68a822-74c8-41c1-8cfe-d0d1a685c74f
3927f8f9-68a4-4ee2-a487-0175b0df5b37	be516eed-8a37-436c-af75-b623f0806f39	a75a070f-44a9-4a8d-8818-368ed36a895d	active	df68a822-74c8-41c1-8cfe-d0d1a685c74f
80b3cde1-6b7d-41e7-a049-adf9cd89d24c	be516eed-8a37-436c-af75-b623f0806f39	0b672960-f467-436e-9300-fd0019de40c6	active	df68a822-74c8-41c1-8cfe-d0d1a685c74f
20e1ee2b-1c00-4f2b-88ac-8edb455b1abb	be516eed-8a37-436c-af75-b623f0806f39	04d92cc3-efaf-4033-a5f6-40f3856e855e	active	df68a822-74c8-41c1-8cfe-d0d1a685c74f
651b7de2-17d1-49b3-8936-2c2978e2f32c	0e14dccb-9c28-4f89-b3b2-cb1011be06d1	5ff7e7e2-383d-479b-90f7-6b0d3bcaa51a	active	0b54823d-ebef-4a0a-934c-e408c127861a
f68a71bf-8e26-4753-9198-1efa7fe2bfcc	0e14dccb-9c28-4f89-b3b2-cb1011be06d1	2bc8f9aa-0a7a-400c-ac77-1ccc3cd41150	active	0b54823d-ebef-4a0a-934c-e408c127861a
c959be05-b204-480b-8942-37dbc427d3a5	0e14dccb-9c28-4f89-b3b2-cb1011be06d1	e13f7c8f-e29f-4074-ad2e-84177da25028	active	0b54823d-ebef-4a0a-934c-e408c127861a
0554d2a0-cf58-45f3-8d25-dc770c7d7c1c	02970c3a-2240-4a74-8fd3-18af09a9cd61	be807861-8861-4f83-80fd-ad22da22d1d8	active	9af8b293-f532-43bf-b8cb-06195f021079
4bac16ba-88fe-4816-b46b-1e8225f69799	02970c3a-2240-4a74-8fd3-18af09a9cd61	b6afb46b-4d63-46d0-8b7e-f71d6d2fe500	active	9af8b293-f532-43bf-b8cb-06195f021079
7ab83874-3f41-4426-9ae3-a8fc64cc22c7	be516eed-8a37-436c-af75-b623f0806f39	f59be7f4-6494-42a9-b21f-388930fca8cd	active	58a992bd-8ee9-4627-b719-e8cc083d4344
d8770518-bb87-439f-ac71-50ca180f6984	fe7cd753-376f-4f22-a721-caa482aa1116	713e34bc-6b1c-48fe-8030-c755f956251e	active	22c78088-f8e8-4d24-b35a-fc6c6c65ea47
05aeaf86-fedf-4fef-97dc-1b8633b707f8	fe7cd753-376f-4f22-a721-caa482aa1116	d83fcda2-9fcb-429f-8fc5-4b421478a4ca	active	22c78088-f8e8-4d24-b35a-fc6c6c65ea47
3e28a5f7-9a33-4fec-adf4-a736307946b1	fe7cd753-376f-4f22-a721-caa482aa1116	59fc41c4-2a4d-459b-b489-54ad20f26fe7	active	22c78088-f8e8-4d24-b35a-fc6c6c65ea47
447315df-c5c8-4697-808c-7f556af764c8	8a7d516b-f3c2-4a5b-afde-d2bdff371937	b8d19818-8529-4dce-9f46-12035ac43098	deleted	30c271f8-7b1c-4a14-855c-9dc9420f1ca9
a1779e38-301d-44b4-80f9-4c28a3dcf208	89a894cc-c5c8-44e2-9ca3-85ab9a0130f9	ab727572-b10b-4a31-bb9c-fd40fbf9bba6	deleted	474d3077-dbdb-4340-b4a4-2be5b64fa86d
2b597020-7a75-4dd5-aa8a-f358af646d21	8a7d516b-f3c2-4a5b-afde-d2bdff371937	b8d71981-30ab-402a-b29c-da315610bb73	active	30c271f8-7b1c-4a14-855c-9dc9420f1ca9
e1ba9b46-8299-4d43-852e-58ea18577ca7	8a7d516b-f3c2-4a5b-afde-d2bdff371937	dd951909-8a84-4b47-8e70-9b3a083f30ab	active	30c271f8-7b1c-4a14-855c-9dc9420f1ca9
996165ea-1131-469c-8a31-4a95248bc912	8a7d516b-f3c2-4a5b-afde-d2bdff371937	4503e0a6-4871-45bb-ab12-1021a0a4d873	active	30c271f8-7b1c-4a14-855c-9dc9420f1ca9
ae3c0590-63ec-41b9-8b0c-6986ddae3b5e	8a7d516b-f3c2-4a5b-afde-d2bdff371937	37a1d187-97fe-4243-9579-f7e0f12c3d9b	active	30c271f8-7b1c-4a14-855c-9dc9420f1ca9
5b2612b3-60f8-49b5-9cb1-399b308cc4f9	8a7d516b-f3c2-4a5b-afde-d2bdff371937	0c2e2d99-7fd3-41c4-aff6-c7db6c8c91f1	active	30c271f8-7b1c-4a14-855c-9dc9420f1ca9
f4bcbda2-4a1c-4d5f-aef7-ba364b49e001	8a7d516b-f3c2-4a5b-afde-d2bdff371937	4a789077-a8ad-48dc-880e-328e2f99f63a	active	30c271f8-7b1c-4a14-855c-9dc9420f1ca9
b40f1688-7764-4bfb-9d53-93a06d3e3635	8a7d516b-f3c2-4a5b-afde-d2bdff371937	877e6c87-50ab-4b0d-8ed7-40be4f5109c4	active	30c271f8-7b1c-4a14-855c-9dc9420f1ca9
646c5f41-50fd-4ad1-a1d6-bbc2b0f84fe5	1dacf074-ad54-432a-a04f-cecd3a068d0c	001a45c6-9af1-460b-8814-801da17619d3	active	ee816bc2-0316-4adc-ac10-300df9306594
d9b99d96-ca73-4145-b7a2-13d7d84b3ca6	df6c89f3-4473-424b-a0b0-119977da62c5	9f47f113-6785-4448-b15c-8b3eaf2032c9	active	177926cc-1263-4323-9dad-14032641b0a5
5a9ed3e1-0c6f-404a-822c-32184ca1c7a6	df6c89f3-4473-424b-a0b0-119977da62c5	7b099d32-3519-45f6-9b83-542e0fdd6ec8	active	177926cc-1263-4323-9dad-14032641b0a5
834afcc2-9a4d-4b66-89ad-8f9842a15910	df6c89f3-4473-424b-a0b0-119977da62c5	78115c49-086a-4799-be1d-e6ef6eef97a5	active	177926cc-1263-4323-9dad-14032641b0a5
bdb43bac-1d33-4f4a-96c4-82034a3279b8	df6c89f3-4473-424b-a0b0-119977da62c5	f59be7f4-6494-42a9-b21f-388930fca8cd	active	177926cc-1263-4323-9dad-14032641b0a5
7fc431e2-e1f3-4dbf-a4a4-e52359e07073	df6c89f3-4473-424b-a0b0-119977da62c5	b59b9b95-d0f4-4c43-9204-4328b391accb	active	177926cc-1263-4323-9dad-14032641b0a5
67d2f6f3-4f1f-4bca-ad2e-f95409dadab2	df6c89f3-4473-424b-a0b0-119977da62c5	b7438d75-793c-46a4-aa9d-c61fcfa17632	active	177926cc-1263-4323-9dad-14032641b0a5
d6d86ab5-3990-4513-8b47-88879159a415	df6c89f3-4473-424b-a0b0-119977da62c5	cecfa504-4a92-4103-beb6-e1d15bbac444	active	177926cc-1263-4323-9dad-14032641b0a5
5bc6fe29-307b-4785-a100-fa20bc670001	0460ea96-a830-40bd-adfb-140aad4c31ca	edaea925-2eef-4da8-a393-faf910b4314f	active	2b5ac88c-ed8c-4fee-b013-103238447a18
1138f08a-8ba7-48a0-ac07-c25a6b62152e	0460ea96-a830-40bd-adfb-140aad4c31ca	f2d5f66f-3e64-432c-ad74-9df59e78c3e0	active	2b5ac88c-ed8c-4fee-b013-103238447a18
0dd05a36-1b72-4a81-9a76-8415b6b63aab	0460ea96-a830-40bd-adfb-140aad4c31ca	2b526ead-4e35-4bc6-900e-5bf1b32c854e	active	2b5ac88c-ed8c-4fee-b013-103238447a18
be52f89b-ffed-4c9d-82c2-4464077cb0f1	0460ea96-a830-40bd-adfb-140aad4c31ca	d3fe7c4e-9bc0-4718-ab5d-6184e261b926	active	2b5ac88c-ed8c-4fee-b013-103238447a18
ad0eb8e0-57c3-4b3f-bb6c-02d438c267ae	159b6644-94ed-406d-8e1e-1f002f265396	10eda8bb-9840-479a-ba70-b1a6c632db68	deleted	d8097172-e1a3-4d79-b40a-3c3ec12be908
4c83ab8d-1bfb-4a31-959a-50c185ba9b71	159b6644-94ed-406d-8e1e-1f002f265396	a6d6facd-9d1f-4c47-8d38-efab698b3e0d	active	d8097172-e1a3-4d79-b40a-3c3ec12be908
d7adb9cb-96ed-4c22-8aef-182de537f777	159b6644-94ed-406d-8e1e-1f002f265396	f13fdde8-8913-46b8-852f-8508edfc112c	active	d8097172-e1a3-4d79-b40a-3c3ec12be908
0231e6c5-0526-41fd-80ca-9a8f193dd8e7	159b6644-94ed-406d-8e1e-1f002f265396	f2d5f66f-3e64-432c-ad74-9df59e78c3e0	active	d8097172-e1a3-4d79-b40a-3c3ec12be908
ee61a843-8865-4575-a462-768b93ad9e35	641c249c-f473-4d8e-bd8e-f385157f2682	23cb8375-5249-43a8-adb2-a8bc3fc7784c	active	903899a1-b57f-44c8-9818-15fc47ead4da
33d8375e-06e6-486f-9baa-fffcc2217d94	641c249c-f473-4d8e-bd8e-f385157f2682	7b099d32-3519-45f6-9b83-542e0fdd6ec8	active	903899a1-b57f-44c8-9818-15fc47ead4da
538e6b36-9807-4fe3-be04-2b758d33aa64	641c249c-f473-4d8e-bd8e-f385157f2682	c3dce0b0-ce3f-475b-8bae-91f6dc03e0aa	active	903899a1-b57f-44c8-9818-15fc47ead4da
57adb25c-0ece-4552-b12f-b26da00a12ca	641c249c-f473-4d8e-bd8e-f385157f2682	4233e616-3f33-49fb-aa6c-7b54554dec19	active	903899a1-b57f-44c8-9818-15fc47ead4da
fe4cba4c-d51f-4d17-bd0a-b48f1c7e0a62	641c249c-f473-4d8e-bd8e-f385157f2682	66261447-7807-4f0a-a19e-a14dde5e68cb	active	903899a1-b57f-44c8-9818-15fc47ead4da
f1cfa510-eea9-4506-b9ae-3c274b702e0b	641c249c-f473-4d8e-bd8e-f385157f2682	5b0e137b-78e2-45a4-8ab2-bfad40306d69	active	903899a1-b57f-44c8-9818-15fc47ead4da
19c480a5-cef1-4abc-9bd2-bbb70edf77b0	641c249c-f473-4d8e-bd8e-f385157f2682	d76057c8-5d41-4a7a-861a-2b558f8081c9	active	903899a1-b57f-44c8-9818-15fc47ead4da
21f3a257-b6f8-4c5f-b67b-734e81df32c7	641c249c-f473-4d8e-bd8e-f385157f2682	08719c78-ea0a-4731-816c-c8d57d7db76a	active	903899a1-b57f-44c8-9818-15fc47ead4da
d6abecb1-b3b8-479f-8a3a-c1a37a7dacfb	89a894cc-c5c8-44e2-9ca3-85ab9a0130f9	4007f503-7979-4147-98de-2c29348abc43	active	474d3077-dbdb-4340-b4a4-2be5b64fa86d
2d078cf0-fe87-4ad6-b127-0097cfe2cd5b	1cf46091-d128-4e38-a7b7-97901d423aaf	64a66b0a-6a92-4149-ab19-2c5d40856e82	active	95f05f43-c667-4588-8eec-97492bbe098d
d23a3374-d195-4dc3-828b-77cc28604d49	1cf46091-d128-4e38-a7b7-97901d423aaf	3a931aa9-250e-4119-9826-be94e485cb69	active	95f05f43-c667-4588-8eec-97492bbe098d
19c44ed2-8022-4866-8efb-913ea31be2e1	3c175c09-a896-4a88-9603-2b5ea27ef1a1	ca6045bc-34bc-452d-9668-75dc38319ef7	active	3c03ffa2-7549-4757-9869-8bc3aa21aab5
05100f27-b69a-4af4-b432-d9ab696cf8ca	fea6dcd6-00d6-4ad5-ab2f-eb40f533a5db	a0da534f-3b88-4e01-bdda-f58bf9b11407	active	cc7f9237-21a1-4e74-ac5f-5cfa6dc1c499
c89b93a6-1731-4c1e-9e79-41c07685d1e3	fea6dcd6-00d6-4ad5-ab2f-eb40f533a5db	3e50182f-2d55-4375-becb-9e9c0f19b0e1	active	cc7f9237-21a1-4e74-ac5f-5cfa6dc1c499
edd862e1-2bc8-4a67-aeb9-5c4f2144b47a	fea6dcd6-00d6-4ad5-ab2f-eb40f533a5db	f59be7f4-6494-42a9-b21f-388930fca8cd	active	cc7f9237-21a1-4e74-ac5f-5cfa6dc1c499
99556c21-d299-4c86-8a2d-1c02d7acab5b	fea6dcd6-00d6-4ad5-ab2f-eb40f533a5db	c7a4044b-2612-4208-9fe8-ef14878071a7	active	cc7f9237-21a1-4e74-ac5f-5cfa6dc1c499
3a69836a-8401-444e-8969-0223b4755ec6	fea6dcd6-00d6-4ad5-ab2f-eb40f533a5db	a7cee6ce-5b52-448c-8a41-c612a5d0b3b9	active	cc7f9237-21a1-4e74-ac5f-5cfa6dc1c499
b900dac0-ded3-4906-9cba-caa5dd74fe26	fea6dcd6-00d6-4ad5-ab2f-eb40f533a5db	68580412-9553-4778-aef8-6d36f1136b28	active	cc7f9237-21a1-4e74-ac5f-5cfa6dc1c499
915cff59-e496-48fb-ad9e-e00a9a0a4abc	fea6dcd6-00d6-4ad5-ab2f-eb40f533a5db	cecfa504-4a92-4103-beb6-e1d15bbac444	active	cc7f9237-21a1-4e74-ac5f-5cfa6dc1c499
e305d159-71ff-4bb0-bd00-0e36ec31c12e	fea6dcd6-00d6-4ad5-ab2f-eb40f533a5db	a75a070f-44a9-4a8d-8818-368ed36a895d	active	cc7f9237-21a1-4e74-ac5f-5cfa6dc1c499
ce4286bc-18ba-41c6-a328-714cd8732a9c	fea6dcd6-00d6-4ad5-ab2f-eb40f533a5db	4cc50dc6-97e2-416e-96c2-c0b747199fa6	active	cc7f9237-21a1-4e74-ac5f-5cfa6dc1c499
c417e6fa-4823-4c4c-8840-ac97b3bcf50a	fea6dcd6-00d6-4ad5-ab2f-eb40f533a5db	957ba93c-80c9-4709-b716-94089518f4a0	active	cc7f9237-21a1-4e74-ac5f-5cfa6dc1c499
64543062-b26a-4a46-b4c5-9306d3a64a7a	fea6dcd6-00d6-4ad5-ab2f-eb40f533a5db	634397b7-b735-4260-a30c-7e03302f263e	active	cc7f9237-21a1-4e74-ac5f-5cfa6dc1c499
7a5ae58a-c49c-407a-a51e-be48e8484a13	4235252c-aa21-46b5-8c52-110f95bdc583	3007a18b-d717-44fd-8281-943c0bd3d7f9	active	9b89818a-d5ff-4870-bbcf-7580d008a9dd
fa2b59e6-0950-448a-8f2c-b017af28081f	f6c6aac7-3c9b-4a3c-80bc-d6709bc95d4b	3007a18b-d717-44fd-8281-943c0bd3d7f9	active	c710cf20-1e45-4734-8d38-abaa584b67af
498ac86b-18e5-4624-8cce-8b66a94fac7d	de5557e1-bf16-433b-87ff-401323a97df5	e8584566-2520-4ffc-bcf6-202169e737a7	active	9f2365d7-35db-4301-8a4c-351671cc2694
04b81e24-137c-4a9e-b071-7e096c0eb474	de5557e1-bf16-433b-87ff-401323a97df5	1986e4ca-61a8-41a6-95c2-940e526d50f1	active	9f2365d7-35db-4301-8a4c-351671cc2694
4da5d6a0-2943-4d5c-8de7-e213644692a7	de5557e1-bf16-433b-87ff-401323a97df5	3007a18b-d717-44fd-8281-943c0bd3d7f9	active	9f2365d7-35db-4301-8a4c-351671cc2694
d365741d-16ec-4cb6-9fff-f6cb9c4e67e1	de5557e1-bf16-433b-87ff-401323a97df5	89f5db50-4b21-4808-a4fe-523ec4ff414c	active	9f2365d7-35db-4301-8a4c-351671cc2694
4ccf0986-3cdf-451c-ac15-91d0726844ee	47034ede-0506-4650-9fb4-1948168440ca	e8584566-2520-4ffc-bcf6-202169e737a7	active	985b1c06-355c-4311-9f30-47457e636266
406ca2a3-f0ac-49bb-9f24-6ead19aa9d1d	47034ede-0506-4650-9fb4-1948168440ca	1986e4ca-61a8-41a6-95c2-940e526d50f1	active	985b1c06-355c-4311-9f30-47457e636266
4b5d9ecd-a403-4959-955e-198e6981406b	47034ede-0506-4650-9fb4-1948168440ca	3007a18b-d717-44fd-8281-943c0bd3d7f9	active	985b1c06-355c-4311-9f30-47457e636266
21b976cf-f3e0-4951-87f7-6ed7c834c4e4	47034ede-0506-4650-9fb4-1948168440ca	89f5db50-4b21-4808-a4fe-523ec4ff414c	active	985b1c06-355c-4311-9f30-47457e636266
2cc8f004-ee6b-4e31-893c-12c9389e94d9	47034ede-0506-4650-9fb4-1948168440ca	72cd5937-eeda-41d2-9482-13017802414d	active	1cd82cdd-40c4-42dd-b398-44c43ff1b2b1
d978a4bd-c881-4bf4-a7d9-4e8aaf3d95fc	de5557e1-bf16-433b-87ff-401323a97df5	72cd5937-eeda-41d2-9482-13017802414d	active	18fafa4e-7382-4ce9-a04f-ec636c51d56a
b8e00210-784f-42c1-a55a-59cb8af7eb7d	bfd1388a-ec10-4a7b-9d94-916f56f52f98	4233e616-3f33-49fb-aa6c-7b54554dec19	active	5037ad29-b65d-490a-bd23-d79c405ec466
6b1ca109-7711-4fa7-8700-3702c10d0f0a	bfd1388a-ec10-4a7b-9d94-916f56f52f98	34d831fd-404b-4ae7-b4d6-b5d70749ff75	active	5037ad29-b65d-490a-bd23-d79c405ec466
e4a637c5-08ec-4f82-a534-ed8bd93daf83	bfd1388a-ec10-4a7b-9d94-916f56f52f98	dbdd1313-54e2-4816-a108-6e2f2f70002f	active	5037ad29-b65d-490a-bd23-d79c405ec466
4603be8a-840b-4774-b179-9810c717395f	bfd1388a-ec10-4a7b-9d94-916f56f52f98	c90f528f-b9c6-456e-a467-3ca145bb4528	active	5037ad29-b65d-490a-bd23-d79c405ec466
ba08139f-e130-482c-a2b4-6dc3064ea4bb	8708a912-1b80-441d-9ba3-d607dd2f0c7c	f13fdde8-8913-46b8-852f-8508edfc112c	active	153a48b3-24af-44e4-ab07-9d5610e890da
1495b50f-8849-4705-b421-7779540d87d5	8708a912-1b80-441d-9ba3-d607dd2f0c7c	5c943c63-92fa-4038-95af-7c2bc9decf74	active	153a48b3-24af-44e4-ab07-9d5610e890da
220074fe-902c-41d3-b6b7-2484d2e8fc32	8708a912-1b80-441d-9ba3-d607dd2f0c7c	f7c7e083-9b25-47eb-8153-b719b907d907	active	153a48b3-24af-44e4-ab07-9d5610e890da
9996c64c-d82e-4532-971b-953505618092	8708a912-1b80-441d-9ba3-d607dd2f0c7c	91a6b94f-c0c1-44c2-8ae6-15d3b1ae4b60	active	153a48b3-24af-44e4-ab07-9d5610e890da
a7d562ce-a3ff-4f23-8f49-31b91ebc2621	25dd2269-e0f3-4653-98ac-33f64f09d4d3	9f47f113-6785-4448-b15c-8b3eaf2032c9	active	4bba233a-f5ab-48de-ab8d-8f9f386fbf77
9db63356-0600-49c1-996b-70a1f5b767b5	25dd2269-e0f3-4653-98ac-33f64f09d4d3	e8584566-2520-4ffc-bcf6-202169e737a7	active	4bba233a-f5ab-48de-ab8d-8f9f386fbf77
99bc7934-6f81-4c32-b248-7ed1f146c587	25dd2269-e0f3-4653-98ac-33f64f09d4d3	c061a5ce-5435-47f8-840a-e36a4f315367	active	4bba233a-f5ab-48de-ab8d-8f9f386fbf77
23dea012-88c6-49bb-8ae3-46d2255b32a7	25dd2269-e0f3-4653-98ac-33f64f09d4d3	3007a18b-d717-44fd-8281-943c0bd3d7f9	active	4bba233a-f5ab-48de-ab8d-8f9f386fbf77
6e337be2-d635-4d4c-8727-cb3ee3da7c3f	25dd2269-e0f3-4653-98ac-33f64f09d4d3	b7438d75-793c-46a4-aa9d-c61fcfa17632	active	4bba233a-f5ab-48de-ab8d-8f9f386fbf77
c442b9fa-e951-4ae3-a1e7-1790eb45a9d0	25dd2269-e0f3-4653-98ac-33f64f09d4d3	a7cee6ce-5b52-448c-8a41-c612a5d0b3b9	active	4bba233a-f5ab-48de-ab8d-8f9f386fbf77
75d872c8-e3e1-4fcc-853d-a06e1272c80d	25dd2269-e0f3-4653-98ac-33f64f09d4d3	f59be7f4-6494-42a9-b21f-388930fca8cd	active	4bba233a-f5ab-48de-ab8d-8f9f386fbf77
b469b8ac-a9db-4f1e-9c39-5eefeceb6449	25dd2269-e0f3-4653-98ac-33f64f09d4d3	d057758e-a4a2-4125-82bd-83b96a2136da	active	4bba233a-f5ab-48de-ab8d-8f9f386fbf77
286887c1-a93f-4dff-a199-14931eaca336	b815db66-cadf-4c3c-ae0b-73ad5bf1a46e	a0da534f-3b88-4e01-bdda-f58bf9b11407	active	78218970-639e-4d24-93ed-244cd4decfcb
56437574-306d-41bb-b1b4-07ee2a4a9ace	b815db66-cadf-4c3c-ae0b-73ad5bf1a46e	73b0d2dd-0b1d-4d67-b8f9-e7a9a61d2e1b	active	78218970-639e-4d24-93ed-244cd4decfcb
ac2d0f47-b441-41e4-8712-bc24b8a57a64	b815db66-cadf-4c3c-ae0b-73ad5bf1a46e	c1610461-01ce-4a34-89a7-0e93f74f67e7	active	78218970-639e-4d24-93ed-244cd4decfcb
869bdf52-ec33-4522-a668-5fc76a359869	b815db66-cadf-4c3c-ae0b-73ad5bf1a46e	f59be7f4-6494-42a9-b21f-388930fca8cd	active	78218970-639e-4d24-93ed-244cd4decfcb
efc703ac-f058-4638-ace7-441670dff8ab	b815db66-cadf-4c3c-ae0b-73ad5bf1a46e	c061a5ce-5435-47f8-840a-e36a4f315367	active	78218970-639e-4d24-93ed-244cd4decfcb
7004c03e-ab6b-4173-a2c8-915654c9874c	b815db66-cadf-4c3c-ae0b-73ad5bf1a46e	b7438d75-793c-46a4-aa9d-c61fcfa17632	active	78218970-639e-4d24-93ed-244cd4decfcb
4c1a161e-df65-413e-9c80-1cf6b3db7944	b815db66-cadf-4c3c-ae0b-73ad5bf1a46e	a7cee6ce-5b52-448c-8a41-c612a5d0b3b9	active	78218970-639e-4d24-93ed-244cd4decfcb
c8ed1fb5-4ed5-4b88-b074-892b3e9f9980	b815db66-cadf-4c3c-ae0b-73ad5bf1a46e	26e502aa-c39c-48a2-91ab-6569af21ae9e	active	78218970-639e-4d24-93ed-244cd4decfcb
314cb5c3-44f8-4799-8b12-a934bf3145b1	b815db66-cadf-4c3c-ae0b-73ad5bf1a46e	b0aef3fc-2551-44ce-9e59-e2f5e848748a	active	78218970-639e-4d24-93ed-244cd4decfcb
96d05cf9-27d6-4440-a74a-4c426c471585	b815db66-cadf-4c3c-ae0b-73ad5bf1a46e	877e6c87-50ab-4b0d-8ed7-40be4f5109c4	active	78218970-639e-4d24-93ed-244cd4decfcb
bec7f88c-d292-4d5d-ad16-06e4201d4c6f	b815db66-cadf-4c3c-ae0b-73ad5bf1a46e	94e91072-a71c-4b7d-85a4-76d88683c2a0	active	78218970-639e-4d24-93ed-244cd4decfcb
4495b74b-1692-4030-af8a-e8eb4147d513	b815db66-cadf-4c3c-ae0b-73ad5bf1a46e	151588d7-81bf-4f3d-a866-891e5849a939	active	78218970-639e-4d24-93ed-244cd4decfcb
fb39a8dd-5bc2-4994-b7e2-200cb283828c	275e4c19-2885-4630-b049-e365374c27fb	e8584566-2520-4ffc-bcf6-202169e737a7	active	35fc3cd3-516a-494d-b6fa-b82140444685
7ab9b525-9139-46f2-81e7-7c36b1219e1c	275e4c19-2885-4630-b049-e365374c27fb	b7475bec-cae2-48b0-a8fe-1f70658fb5ef	active	35fc3cd3-516a-494d-b6fa-b82140444685
e92b5441-1b1a-422a-a80d-b9268645f546	275e4c19-2885-4630-b049-e365374c27fb	ca903ad5-d738-4dac-b6c2-dfd847522650	active	35fc3cd3-516a-494d-b6fa-b82140444685
63b5bd14-7e99-4683-ab4d-228862fe7818	275e4c19-2885-4630-b049-e365374c27fb	72cd5937-eeda-41d2-9482-13017802414d	active	35fc3cd3-516a-494d-b6fa-b82140444685
9594a82d-fbfa-4f4a-99ad-645323146985	275e4c19-2885-4630-b049-e365374c27fb	87e157c1-1674-49ad-a7c9-14f54cd1b192	active	35fc3cd3-516a-494d-b6fa-b82140444685
0850c0f4-29c3-4b87-9527-191db7cf91bc	275e4c19-2885-4630-b049-e365374c27fb	a85647c2-fc12-4766-a70b-88f4ff6a8465	active	35fc3cd3-516a-494d-b6fa-b82140444685
3083fb28-2f6c-4966-a43f-7f688a60fbf4	275e4c19-2885-4630-b049-e365374c27fb	5ff7e7e2-383d-479b-90f7-6b0d3bcaa51a	active	35fc3cd3-516a-494d-b6fa-b82140444685
8fb6e931-cf52-42de-ac4e-e2d2a81a054c	e3e52ca7-2e9e-4f87-a818-5a808823089b	0fa92041-ce27-4e68-b3d3-c9b43f3c6de6	active	31206ec8-7ac4-40c3-b06d-5f0e5f4f4da0
7d531401-c829-4703-9649-1c6809debfa5	e3e52ca7-2e9e-4f87-a818-5a808823089b	43801850-5d9c-47d5-bc71-31c3aa4a18c5	active	31206ec8-7ac4-40c3-b06d-5f0e5f4f4da0
839e189b-4286-40cb-bcd8-ba9beabb0604	e3e52ca7-2e9e-4f87-a818-5a808823089b	45a0920e-01b6-4f46-9169-98b95fc5f193	active	31206ec8-7ac4-40c3-b06d-5f0e5f4f4da0
459f486f-4733-45fb-adbd-72bd8118d92e	e3e52ca7-2e9e-4f87-a818-5a808823089b	7fde6772-145d-4443-9e39-fc19041008d9	active	31206ec8-7ac4-40c3-b06d-5f0e5f4f4da0
22c29811-68e4-4c6d-b6f3-4813b65adcf9	e3e52ca7-2e9e-4f87-a818-5a808823089b	a739f123-1033-496e-a5fe-87511494480d	active	31206ec8-7ac4-40c3-b06d-5f0e5f4f4da0
fc97aab6-3821-4495-be9b-8548a226bd94	e3e52ca7-2e9e-4f87-a818-5a808823089b	ab7981ff-d3a3-4ce0-af23-6c47307a62ce	active	31206ec8-7ac4-40c3-b06d-5f0e5f4f4da0
56618c5b-29f1-4f34-8381-bb05e487b31e	e3e52ca7-2e9e-4f87-a818-5a808823089b	0192601d-b976-4977-8264-1f517aaa780b	active	31206ec8-7ac4-40c3-b06d-5f0e5f4f4da0
44e732e0-4a6d-48f0-be0d-be5b609d338a	e3e52ca7-2e9e-4f87-a818-5a808823089b	2900d3c6-e08a-459e-b132-69f5a4456acf	active	31206ec8-7ac4-40c3-b06d-5f0e5f4f4da0
f1bdfd21-0159-497c-9f7c-8ccfd13948d7	e3e52ca7-2e9e-4f87-a818-5a808823089b	f7d4c27e-998c-4f03-970c-509739212887	active	31206ec8-7ac4-40c3-b06d-5f0e5f4f4da0
221084c6-89c5-4f37-8c36-0fe2b86ec8f3	e3e52ca7-2e9e-4f87-a818-5a808823089b	9fd054d5-5bf7-402d-9a4b-bcc990552c1c	active	31206ec8-7ac4-40c3-b06d-5f0e5f4f4da0
c7bc0886-f429-4f9f-808b-d332a1a52f0d	e3e52ca7-2e9e-4f87-a818-5a808823089b	b83b6bd3-9559-4c39-9280-1f66345034a2	active	31206ec8-7ac4-40c3-b06d-5f0e5f4f4da0
638adb79-df2e-47e6-af4d-928eea49cae1	1399fe4b-2c07-4bda-a720-9df928d51816	b6afb46b-4d63-46d0-8b7e-f71d6d2fe500	active	46739a51-d0ab-416a-9dff-632a03351fcf
16c15eb7-4379-4b7b-9c49-40da174f24c3	1399fe4b-2c07-4bda-a720-9df928d51816	0ec35598-db54-4019-864f-5e4d310662d2	active	46739a51-d0ab-416a-9dff-632a03351fcf
44d6207b-bf96-4469-b407-2d93291f6d06	1399fe4b-2c07-4bda-a720-9df928d51816	87e157c1-1674-49ad-a7c9-14f54cd1b192	active	46739a51-d0ab-416a-9dff-632a03351fcf
5583815e-6393-4f36-80f8-18952115da3b	cea11492-fdec-4cfc-a179-a4bbc05cac0b	fd6ac7dd-6519-4f44-a78d-486fc41579eb	active	369831c1-22de-4dea-b0b7-b9a33cef2875
36abd121-d9ba-400f-b957-63c4486e938f	cea11492-fdec-4cfc-a179-a4bbc05cac0b	b7475bec-cae2-48b0-a8fe-1f70658fb5ef	active	369831c1-22de-4dea-b0b7-b9a33cef2875
0502a7a4-4139-432f-9095-4c3ac09726ca	cea11492-fdec-4cfc-a179-a4bbc05cac0b	87e157c1-1674-49ad-a7c9-14f54cd1b192	active	369831c1-22de-4dea-b0b7-b9a33cef2875
5b094084-f086-4640-988f-1e83a49025cf	cea11492-fdec-4cfc-a179-a4bbc05cac0b	d057758e-a4a2-4125-82bd-83b96a2136da	active	369831c1-22de-4dea-b0b7-b9a33cef2875
53dd2252-ea9e-4dd6-b8aa-d396854e655f	41b0a731-3378-42bd-9e08-8b69a1fee83a	9f47f113-6785-4448-b15c-8b3eaf2032c9	active	0d252ab1-5819-41f4-af54-4036c3226e98
8ec29bb9-8040-46f7-9e7f-4e73a7351cda	41b0a731-3378-42bd-9e08-8b69a1fee83a	0a14592d-4d81-4ea4-a78a-884d16d67baa	active	0d252ab1-5819-41f4-af54-4036c3226e98
952f4f62-5c73-4a65-8879-29d9bd53af8b	41b0a731-3378-42bd-9e08-8b69a1fee83a	e8584566-2520-4ffc-bcf6-202169e737a7	active	0d252ab1-5819-41f4-af54-4036c3226e98
41e52d99-f758-4ed2-90ba-c422553e1bca	41b0a731-3378-42bd-9e08-8b69a1fee83a	3007a18b-d717-44fd-8281-943c0bd3d7f9	active	0d252ab1-5819-41f4-af54-4036c3226e98
f1955559-b352-47d1-b6ad-cf914ead7d93	41b0a731-3378-42bd-9e08-8b69a1fee83a	71052f94-3fc6-4260-a2e4-dc0354275d88	active	0d252ab1-5819-41f4-af54-4036c3226e98
f3a09b8b-95d8-4f09-abd5-80c99a072b0b	41b0a731-3378-42bd-9e08-8b69a1fee83a	a7cee6ce-5b52-448c-8a41-c612a5d0b3b9	active	0d252ab1-5819-41f4-af54-4036c3226e98
94625d74-5ef2-4a2a-8f4a-4853fdd5a46d	41b0a731-3378-42bd-9e08-8b69a1fee83a	89f5db50-4b21-4808-a4fe-523ec4ff414c	active	0d252ab1-5819-41f4-af54-4036c3226e98
f256d0e5-ca66-44fc-b0e6-ac0b5d03d747	41b0a731-3378-42bd-9e08-8b69a1fee83a	f59be7f4-6494-42a9-b21f-388930fca8cd	active	0d252ab1-5819-41f4-af54-4036c3226e98
2c23da45-0e36-4485-8d25-43a5826d7e47	41b0a731-3378-42bd-9e08-8b69a1fee83a	3ee14257-d6ea-40ee-8f8b-3293ab90cb79	active	0d252ab1-5819-41f4-af54-4036c3226e98
654bcd86-62e6-43ea-a004-88869ff311bd	41b0a731-3378-42bd-9e08-8b69a1fee83a	d057758e-a4a2-4125-82bd-83b96a2136da	active	0d252ab1-5819-41f4-af54-4036c3226e98
8eecd90d-b76e-4d6c-b2ae-f3a242fe9551	c4556598-bcc7-4c45-8ae8-bdafc367eaa2	e8584566-2520-4ffc-bcf6-202169e737a7	active	16ca20be-8985-498c-a6b3-29ecc4358399
192f2255-066f-4174-b5b2-df938d70bd6c	c4556598-bcc7-4c45-8ae8-bdafc367eaa2	0f11fb91-d0f4-41e4-8934-53c2d6a8b598	active	16ca20be-8985-498c-a6b3-29ecc4358399
f66b8ddb-1992-44d5-83b7-b290986e08d0	c4556598-bcc7-4c45-8ae8-bdafc367eaa2	71052f94-3fc6-4260-a2e4-dc0354275d88	active	16ca20be-8985-498c-a6b3-29ecc4358399
30424b16-5688-4188-93f1-c59d995ba798	c4556598-bcc7-4c45-8ae8-bdafc367eaa2	e2fbbd65-d33f-46a9-b1d6-2a49bd1c8497	active	16ca20be-8985-498c-a6b3-29ecc4358399
c022f427-30eb-4c91-b14e-f906ff25b264	c4556598-bcc7-4c45-8ae8-bdafc367eaa2	87e157c1-1674-49ad-a7c9-14f54cd1b192	active	16ca20be-8985-498c-a6b3-29ecc4358399
1b892372-0a80-41f7-9072-b2b0ad723fbf	c4556598-bcc7-4c45-8ae8-bdafc367eaa2	d057758e-a4a2-4125-82bd-83b96a2136da	active	16ca20be-8985-498c-a6b3-29ecc4358399
8f259b93-56c5-4b6d-8bfc-b805d35d5cfb	41b0a731-3378-42bd-9e08-8b69a1fee83a	87e157c1-1674-49ad-a7c9-14f54cd1b192	active	1abb1bc3-9af2-4d48-ac1f-6ecbb7b8f3d0
75893af9-eb1a-4bfa-b965-038350ac1243	1399fe4b-2c07-4bda-a720-9df928d51816	233655da-e83d-43e2-bb2a-cce9c6f3f391	active	59317601-caee-4b10-bc04-8f4ce5006fcc
f08751b2-5921-417d-b193-c1c3ece013ef	1399fe4b-2c07-4bda-a720-9df928d51816	71052f94-3fc6-4260-a2e4-dc0354275d88	active	59317601-caee-4b10-bc04-8f4ce5006fcc
ca830eb5-f520-4e0a-af65-92635e5c62bf	1399fe4b-2c07-4bda-a720-9df928d51816	bf721b6b-74c7-43da-b80d-fc9c086ffc6b	active	59317601-caee-4b10-bc04-8f4ce5006fcc
123b6af9-32fe-4ccc-959d-cbfe6ab2f9d0	1399fe4b-2c07-4bda-a720-9df928d51816	9cdf19fd-7d75-4e61-b6b2-0ebf17582683	active	59317601-caee-4b10-bc04-8f4ce5006fcc
31e103fc-363b-493c-b0fc-b4020de8641a	1399fe4b-2c07-4bda-a720-9df928d51816	cc18bf9c-d21e-4ea2-9cf2-b1b9f16855b1	active	59317601-caee-4b10-bc04-8f4ce5006fcc
cf94e7e0-4a60-4aaf-b147-32d35b5b7ae0	2a4bae91-082b-4ae5-9729-08c86e000ab5	c6152eae-a552-4cc0-8b5e-a0c72a6987b0	active	0a8e67c3-482a-4ef4-ac82-1a64eb975d4a
9396b552-12f1-4639-8e8f-a47ee9966978	2a4bae91-082b-4ae5-9729-08c86e000ab5	be807861-8861-4f83-80fd-ad22da22d1d8	active	0a8e67c3-482a-4ef4-ac82-1a64eb975d4a
9de1caa7-b5e0-40e7-92ca-1347453cbcef	2a4bae91-082b-4ae5-9729-08c86e000ab5	5ff8ddd6-e698-4a94-a563-f28d6cdf06bc	active	0a8e67c3-482a-4ef4-ac82-1a64eb975d4a
d3fd5931-c239-4718-b324-cbc6d7603939	2a4bae91-082b-4ae5-9729-08c86e000ab5	27eecd38-da7f-437c-aa78-e0468be5b594	active	0a8e67c3-482a-4ef4-ac82-1a64eb975d4a
240cf534-997d-48c4-bda8-986b9bcf0dec	2a4bae91-082b-4ae5-9729-08c86e000ab5	7cb00ab4-0502-4fe1-8314-db484a3781f3	active	0a8e67c3-482a-4ef4-ac82-1a64eb975d4a
1a85335a-fa99-4eb7-8823-d2971967aef0	2a4bae91-082b-4ae5-9729-08c86e000ab5	cf947468-a778-4c4b-8c5b-fc4ce7cd9bc0	active	0a8e67c3-482a-4ef4-ac82-1a64eb975d4a
10f4aed3-def8-4402-9c2e-72ca34ed5401	2a4bae91-082b-4ae5-9729-08c86e000ab5	9aaf0eec-fc2a-4117-a8c4-c4e160b53db5	active	0a8e67c3-482a-4ef4-ac82-1a64eb975d4a
308983a3-0f68-4531-b23e-455433130c3c	2a4bae91-082b-4ae5-9729-08c86e000ab5	3b95f7ef-56e7-4d11-aa64-0c078a4ba24c	active	0a8e67c3-482a-4ef4-ac82-1a64eb975d4a
6adc4869-c189-4254-bb23-9865054c9644	cd42a806-cac1-452c-9b0d-116d8ead4d64	9f47f113-6785-4448-b15c-8b3eaf2032c9	active	85ec5f06-1543-41ef-9aaa-fa4f60123d60
8e5c895b-f22e-4616-a13a-9ecadfb00bc3	cd42a806-cac1-452c-9b0d-116d8ead4d64	e8584566-2520-4ffc-bcf6-202169e737a7	active	85ec5f06-1543-41ef-9aaa-fa4f60123d60
51d16926-a876-4147-8d64-599181770722	cd42a806-cac1-452c-9b0d-116d8ead4d64	c061a5ce-5435-47f8-840a-e36a4f315367	active	85ec5f06-1543-41ef-9aaa-fa4f60123d60
6fdd356b-4d8c-4bb9-9b5b-a52586ccd274	cd42a806-cac1-452c-9b0d-116d8ead4d64	3007a18b-d717-44fd-8281-943c0bd3d7f9	active	85ec5f06-1543-41ef-9aaa-fa4f60123d60
f53aefaa-c9c6-4dab-b8cb-5f60ea426885	cd42a806-cac1-452c-9b0d-116d8ead4d64	fd6ac7dd-6519-4f44-a78d-486fc41579eb	active	85ec5f06-1543-41ef-9aaa-fa4f60123d60
85f6b12d-3c22-4982-94a8-347859ad52c9	cd42a806-cac1-452c-9b0d-116d8ead4d64	a7cee6ce-5b52-448c-8a41-c612a5d0b3b9	active	85ec5f06-1543-41ef-9aaa-fa4f60123d60
01a7b1c2-4e57-4c45-a240-029f66d00c7f	cd42a806-cac1-452c-9b0d-116d8ead4d64	d057758e-a4a2-4125-82bd-83b96a2136da	active	85ec5f06-1543-41ef-9aaa-fa4f60123d60
eba965e6-de87-4411-ba63-477c733f47c0	e657011b-cf83-47ab-8bc8-62f6498046a6	c6152eae-a552-4cc0-8b5e-a0c72a6987b0	active	5ff6213f-387b-4fa1-b818-fd7c5e9151bc
92b21f90-9a84-4142-8420-51dff344483a	e657011b-cf83-47ab-8bc8-62f6498046a6	be807861-8861-4f83-80fd-ad22da22d1d8	active	5ff6213f-387b-4fa1-b818-fd7c5e9151bc
642d0e7a-b380-4abc-b061-6da5524fbd8b	e657011b-cf83-47ab-8bc8-62f6498046a6	4b6b96b1-115c-40c9-815c-25a5110597ba	active	5ff6213f-387b-4fa1-b818-fd7c5e9151bc
a0df62e6-a0ab-45b7-b98e-f6613eecca61	e657011b-cf83-47ab-8bc8-62f6498046a6	5ff8ddd6-e698-4a94-a563-f28d6cdf06bc	active	5ff6213f-387b-4fa1-b818-fd7c5e9151bc
59ddf576-b047-455a-9b7f-0ed4682c095c	e657011b-cf83-47ab-8bc8-62f6498046a6	27eecd38-da7f-437c-aa78-e0468be5b594	active	5ff6213f-387b-4fa1-b818-fd7c5e9151bc
0556c7f4-a484-4b2b-9f39-ef32ecc115ef	e657011b-cf83-47ab-8bc8-62f6498046a6	64b894ec-5075-4176-8f3b-ddb173f1deaf	active	5ff6213f-387b-4fa1-b818-fd7c5e9151bc
8ccfb3e5-fa88-4457-94ad-075665a2d86f	e657011b-cf83-47ab-8bc8-62f6498046a6	9a74cff3-b7c7-4128-bb65-ff076be66019	active	5ff6213f-387b-4fa1-b818-fd7c5e9151bc
619be932-002b-4887-981b-a33e8c65874c	e657011b-cf83-47ab-8bc8-62f6498046a6	9aaf0eec-fc2a-4117-a8c4-c4e160b53db5	active	5ff6213f-387b-4fa1-b818-fd7c5e9151bc
5d123234-b2c1-475c-b376-9fef68f7824b	e657011b-cf83-47ab-8bc8-62f6498046a6	3b95f7ef-56e7-4d11-aa64-0c078a4ba24c	active	5ff6213f-387b-4fa1-b818-fd7c5e9151bc
da67eaf7-117b-4262-81f5-23a9f7c45ba7	2a4bae91-082b-4ae5-9729-08c86e000ab5	cf449447-3f45-4c68-8aac-8b5a4ec96f25	active	c5319ccb-aff6-41c5-a33d-6b63b203253d
2d254c7f-a266-4844-8e7c-cee0fa53d9b2	e657011b-cf83-47ab-8bc8-62f6498046a6	cf449447-3f45-4c68-8aac-8b5a4ec96f25	active	a08487f0-d7d1-4e72-be99-f37b95410ba4
79eae32b-9b62-4364-8ada-8b6ef45247fb	61d87eb7-e3d3-4f90-a3a8-b43b5362db1a	920f0530-0a9e-49c0-9978-f3d9ff3925c4	active	b062326e-1f5d-48e3-a67b-9114ca9e15a4
3e389945-bbc2-4ac4-b626-f294343b0476	61d87eb7-e3d3-4f90-a3a8-b43b5362db1a	e8584566-2520-4ffc-bcf6-202169e737a7	active	b062326e-1f5d-48e3-a67b-9114ca9e15a4
315839c4-4175-4274-85f8-9e0344c89820	61d87eb7-e3d3-4f90-a3a8-b43b5362db1a	c061a5ce-5435-47f8-840a-e36a4f315367	active	b062326e-1f5d-48e3-a67b-9114ca9e15a4
2e0b3c2c-75a5-46f9-8dfa-b098723aeb8a	61d87eb7-e3d3-4f90-a3a8-b43b5362db1a	76b6bb6a-de74-4522-b4db-14a74a7320ba	active	b062326e-1f5d-48e3-a67b-9114ca9e15a4
b524f6ca-6c88-4229-9242-9a83a346ea59	61d87eb7-e3d3-4f90-a3a8-b43b5362db1a	3007a18b-d717-44fd-8281-943c0bd3d7f9	active	b062326e-1f5d-48e3-a67b-9114ca9e15a4
f1547c54-e148-4d0c-89b3-4ad3836a1cbb	61d87eb7-e3d3-4f90-a3a8-b43b5362db1a	5c72b096-cb94-4c1d-a976-3822e2690dc7	active	b062326e-1f5d-48e3-a67b-9114ca9e15a4
eb9eb97a-abdd-41c9-97aa-e6e7739c83b5	61d87eb7-e3d3-4f90-a3a8-b43b5362db1a	7fdbeb86-6300-4260-ac9a-4327519c6bb7	active	b062326e-1f5d-48e3-a67b-9114ca9e15a4
0680d36d-c913-441c-9d22-2d062eee071d	61d87eb7-e3d3-4f90-a3a8-b43b5362db1a	c34cb669-4bf2-4571-895f-d9dfe3f945bf	active	b062326e-1f5d-48e3-a67b-9114ca9e15a4
e3f00e75-00cf-4e34-9575-3e021a293c9b	61d87eb7-e3d3-4f90-a3a8-b43b5362db1a	f8ebae5a-f81c-40d6-9a08-5c1f375c4acf	active	b062326e-1f5d-48e3-a67b-9114ca9e15a4
0be6caae-4fc9-4314-a3be-be1f517ab7e1	61d87eb7-e3d3-4f90-a3a8-b43b5362db1a	d057758e-a4a2-4125-82bd-83b96a2136da	active	b062326e-1f5d-48e3-a67b-9114ca9e15a4
55aa0572-75c6-42e3-bfd9-81e53841ccf1	aac3a30b-36a9-4887-8aab-81c552bfc7d7	e8584566-2520-4ffc-bcf6-202169e737a7	active	ec886521-f454-451d-af59-53aadbcf4bbc
ad9902ca-2beb-4971-ac77-13983519ded2	aac3a30b-36a9-4887-8aab-81c552bfc7d7	a7cee6ce-5b52-448c-8a41-c612a5d0b3b9	active	ec886521-f454-451d-af59-53aadbcf4bbc
aa14c4ed-35cc-4347-960a-db8165b4db91	aac3a30b-36a9-4887-8aab-81c552bfc7d7	c061a5ce-5435-47f8-840a-e36a4f315367	active	ec886521-f454-451d-af59-53aadbcf4bbc
dd87f9ae-c573-4d6b-b381-b45aacc25105	f1b3849e-9568-4cae-a3a0-3cca7f42c079	a7cee6ce-5b52-448c-8a41-c612a5d0b3b9	active	9fbb919a-209f-482e-89aa-7fd9e82a7989
b60933b6-c962-4050-baa9-4810d0edb0be	f1b3849e-9568-4cae-a3a0-3cca7f42c079	76b6bb6a-de74-4522-b4db-14a74a7320ba	active	9fbb919a-209f-482e-89aa-7fd9e82a7989
202cba8f-3e63-480b-b0ac-fadb251b9d7d	f1b3849e-9568-4cae-a3a0-3cca7f42c079	c061a5ce-5435-47f8-840a-e36a4f315367	active	9fbb919a-209f-482e-89aa-7fd9e82a7989
79abf9a1-0a5f-4d88-b0b7-c631bce47c9c	f1b3849e-9568-4cae-a3a0-3cca7f42c079	d057758e-a4a2-4125-82bd-83b96a2136da	active	9fbb919a-209f-482e-89aa-7fd9e82a7989
eb941ae1-0602-4dd5-80f7-fd3dfd1fcc96	aac3a30b-36a9-4887-8aab-81c552bfc7d7	f8ebae5a-f81c-40d6-9a08-5c1f375c4acf	active	6c8aeb30-34d5-4425-bfd7-c61adc9b2d8d
079fa64f-21b9-4660-855e-08d55a39972d	27597355-d542-4574-adc8-6493883d1454	eb470e55-aafe-4855-968e-f6b29cfc849a	active	4859fec8-5318-4618-83d3-564fa1dcffd9
dd8ec625-7660-494e-9d65-9b8fa76cb2c6	27597355-d542-4574-adc8-6493883d1454	1b7c7542-cbeb-4d25-84dd-acd74583925c	active	4859fec8-5318-4618-83d3-564fa1dcffd9
a6e62f5a-b7db-4b1e-9046-93367163f6b7	27597355-d542-4574-adc8-6493883d1454	7cf0b9f2-0688-4a33-becf-c4b375d4b1f9	active	4859fec8-5318-4618-83d3-564fa1dcffd9
49f1bcb9-fa5c-4623-8f09-e0081052bc31	27597355-d542-4574-adc8-6493883d1454	212a4b69-4d95-4262-8572-0892788ba9a3	active	4859fec8-5318-4618-83d3-564fa1dcffd9
c3d22762-0d9e-4cb7-a28c-0e4d6b4d80a4	27597355-d542-4574-adc8-6493883d1454	88028489-490a-4507-9f87-2d9a6e2d50bc	active	8cade445-98c7-4340-8aaa-34f0c304d0e9
71fce3f5-9694-45a0-8cc6-9aae4dd7817b	27597355-d542-4574-adc8-6493883d1454	babf872e-41d5-470e-88b1-8dedc68cf97d	active	8cade445-98c7-4340-8aaa-34f0c304d0e9
cc4710c3-e0af-4b08-8e9b-b7e235fadbc1	382ceece-628f-43b1-8847-ea92ff04376f	c6152eae-a552-4cc0-8b5e-a0c72a6987b0	active	d982c3cc-785b-44af-9d31-fd3fb152558b
ffb353f6-0b87-4416-958e-b20a94332db3	382ceece-628f-43b1-8847-ea92ff04376f	c90a28e2-4831-4ad0-bd51-c0649a3c54ee	active	d982c3cc-785b-44af-9d31-fd3fb152558b
265aa9bd-9c1f-4d09-bdf0-5a4e3bbcc6b5	382ceece-628f-43b1-8847-ea92ff04376f	71052f94-3fc6-4260-a2e4-dc0354275d88	active	d982c3cc-785b-44af-9d31-fd3fb152558b
8f0cb708-b4e5-4b7b-ae63-48957ba716e0	382ceece-628f-43b1-8847-ea92ff04376f	fd6ac7dd-6519-4f44-a78d-486fc41579eb	active	d982c3cc-785b-44af-9d31-fd3fb152558b
eb6a35d8-1002-477c-b643-a77ab300ae1d	382ceece-628f-43b1-8847-ea92ff04376f	87e157c1-1674-49ad-a7c9-14f54cd1b192	active	d982c3cc-785b-44af-9d31-fd3fb152558b
6c64fb76-5d85-4687-82c9-7ce4de3a4e8c	382ceece-628f-43b1-8847-ea92ff04376f	97e4fca1-424e-45f2-aeee-db6db61d1737	active	d982c3cc-785b-44af-9d31-fd3fb152558b
2d12128d-da2e-4fb0-9c3f-332faef0b839	382ceece-628f-43b1-8847-ea92ff04376f	d057758e-a4a2-4125-82bd-83b96a2136da	active	d982c3cc-785b-44af-9d31-fd3fb152558b
4aee7973-a182-45bf-97ce-6b9c61468dd5	4f8c2ed1-52a1-4c94-854e-631daeb1a154	0ab529c6-4551-432e-a566-bbfcfabc15b8	active	b4fc3c0a-6704-495c-b092-cbeec8f14ace
4bdc7f8a-e2ef-48ca-aa81-cc3c5a1ebc4c	4f8c2ed1-52a1-4c94-854e-631daeb1a154	705d6aed-b1d5-4b89-ad38-be4a1daba35d	active	b4fc3c0a-6704-495c-b092-cbeec8f14ace
3f65a516-c02d-4e72-bc40-d5c0a1477402	4f8c2ed1-52a1-4c94-854e-631daeb1a154	601cf29e-2b2d-405d-88a9-0dd7c3ae09e3	active	b4fc3c0a-6704-495c-b092-cbeec8f14ace
801e51bc-6596-412a-bd1f-8a3fb83de173	4f8c2ed1-52a1-4c94-854e-631daeb1a154	c51c7ba1-34f9-4eea-9b79-ba2f9fa99f20	active	b4fc3c0a-6704-495c-b092-cbeec8f14ace
28480c4f-a265-48ef-a5da-2e84247171ef	4f8c2ed1-52a1-4c94-854e-631daeb1a154	f839795f-58b2-4351-ad75-3c8d3df7f794	active	b4fc3c0a-6704-495c-b092-cbeec8f14ace
2d09486d-efd7-4616-b2df-798972b7ec3f	4f8c2ed1-52a1-4c94-854e-631daeb1a154	247438c8-f5a4-489a-8918-afd6574bda6c	active	b4fc3c0a-6704-495c-b092-cbeec8f14ace
76079978-10ba-40d4-b18e-b5a64a9c7066	4f8c2ed1-52a1-4c94-854e-631daeb1a154	57a112e5-f2d5-4724-9aa3-c8730f1c19a4	active	b4fc3c0a-6704-495c-b092-cbeec8f14ace
f6b2799a-511d-4c40-a6bb-af82afaa1e5e	4f8c2ed1-52a1-4c94-854e-631daeb1a154	2d518686-9f62-426f-9a2b-1b2fc94b90e4	deleted	363e3792-e7f3-4248-84bc-3c828c049ba3
7ac28701-979e-499e-bd11-6825e82a33a0	e6833b4c-3f1e-4394-a547-790258b451e5	27eecd38-da7f-437c-aa78-e0468be5b594	active	da99599d-79c0-47b0-8f59-3f2fc4bf3bed
8b609621-3046-45a1-bcc2-f8f0d0614960	e6833b4c-3f1e-4394-a547-790258b451e5	bf811c75-eb5f-47e1-8b87-c4119912c88c	active	da99599d-79c0-47b0-8f59-3f2fc4bf3bed
6c9e276a-0ef6-4606-a1f4-21ea865998d7	e6833b4c-3f1e-4394-a547-790258b451e5	0485e497-11ba-4033-b412-fcb97816c5b6	active	da99599d-79c0-47b0-8f59-3f2fc4bf3bed
610e94e2-5671-45c5-9c69-04b8b36e3ae6	e6833b4c-3f1e-4394-a547-790258b451e5	6462e1a0-5395-4bb3-aa23-c73ae5877c25	active	da99599d-79c0-47b0-8f59-3f2fc4bf3bed
3c651dac-8307-4f01-b051-e2d980d41b89	e6833b4c-3f1e-4394-a547-790258b451e5	1812b303-186d-4734-a4cb-1345949485d9	active	da99599d-79c0-47b0-8f59-3f2fc4bf3bed
4f65c13d-8433-45e6-b9ff-bf5344781645	e6833b4c-3f1e-4394-a547-790258b451e5	6535de51-8e81-49ba-9a0f-c81f3688b890	active	da99599d-79c0-47b0-8f59-3f2fc4bf3bed
79f3a614-4329-42dc-b41f-1ee299daa45b	e6833b4c-3f1e-4394-a547-790258b451e5	7fdbeb86-6300-4260-ac9a-4327519c6bb7	active	da99599d-79c0-47b0-8f59-3f2fc4bf3bed
2ff3194d-fea1-49a0-bd82-3ae5f941df27	e6833b4c-3f1e-4394-a547-790258b451e5	9aaf0eec-fc2a-4117-a8c4-c4e160b53db5	active	da99599d-79c0-47b0-8f59-3f2fc4bf3bed
e2ef9941-9068-4a2f-bca2-e5407166d1aa	e6833b4c-3f1e-4394-a547-790258b451e5	473f15dd-47c0-40a6-89e9-3a053ab172a4	active	da99599d-79c0-47b0-8f59-3f2fc4bf3bed
\.


--
-- Data for Name: package_tag_revision; Type: TABLE DATA; Schema: public; Owner: ckantest
--

COPY package_tag_revision (id, package_id, tag_id, state, revision_id, continuity_id) FROM stdin;
711f0e6d-72ca-4181-93f9-cec694003e2c	587ed76e-1c2f-4cc7-a23a-f9beb2415c77	cecfa504-4a92-4103-beb6-e1d15bbac444	active	f74141f1-d57b-4f3f-9ee2-d1469d1a00a9	711f0e6d-72ca-4181-93f9-cec694003e2c
5bef0987-888e-4675-9274-96bb9522c02b	587ed76e-1c2f-4cc7-a23a-f9beb2415c77	d6b5bc12-83dc-42b7-abf3-2839547f6b03	active	f74141f1-d57b-4f3f-9ee2-d1469d1a00a9	5bef0987-888e-4675-9274-96bb9522c02b
20aeecc2-876e-4073-90df-56117361a979	587ed76e-1c2f-4cc7-a23a-f9beb2415c77	3d24f7b8-4401-4ef1-87d2-955c4628689d	active	f74141f1-d57b-4f3f-9ee2-d1469d1a00a9	20aeecc2-876e-4073-90df-56117361a979
19689c73-d0bf-4da7-897b-d090c89f36b5	4402487d-3e8d-4618-8444-b400c6337834	a23706cf-7ada-4bc7-a323-8cdc6f649701	active	6aafed2f-a1a7-48cc-b275-0e0986710b13	19689c73-d0bf-4da7-897b-d090c89f36b5
6142ddf9-ecb0-4142-aa76-d9736f8dc40f	4402487d-3e8d-4618-8444-b400c6337834	471360c0-f000-4c1a-b462-3d26a1009d8d	active	6aafed2f-a1a7-48cc-b275-0e0986710b13	6142ddf9-ecb0-4142-aa76-d9736f8dc40f
259aa836-18a9-42e8-811e-9d8f9f947197	4402487d-3e8d-4618-8444-b400c6337834	f59be7f4-6494-42a9-b21f-388930fca8cd	active	6aafed2f-a1a7-48cc-b275-0e0986710b13	259aa836-18a9-42e8-811e-9d8f9f947197
f21f0b69-b665-4b49-847d-c1ffb7ce6057	4402487d-3e8d-4618-8444-b400c6337834	3d24f7b8-4401-4ef1-87d2-955c4628689d	active	6aafed2f-a1a7-48cc-b275-0e0986710b13	f21f0b69-b665-4b49-847d-c1ffb7ce6057
8d214e63-77c4-4c6c-bcf0-49dc81814911	4402487d-3e8d-4618-8444-b400c6337834	d6b5bc12-83dc-42b7-abf3-2839547f6b03	active	6aafed2f-a1a7-48cc-b275-0e0986710b13	8d214e63-77c4-4c6c-bcf0-49dc81814911
2d1ce0ad-747f-4134-aef9-f2a4d2bf3727	4402487d-3e8d-4618-8444-b400c6337834	27eecd38-da7f-437c-aa78-e0468be5b594	active	6aafed2f-a1a7-48cc-b275-0e0986710b13	2d1ce0ad-747f-4134-aef9-f2a4d2bf3727
21fd3447-ae99-49aa-8748-d1d589c578fc	4235252c-aa21-46b5-8c52-110f95bdc583	89f5db50-4b21-4808-a4fe-523ec4ff414c	active	dbfdfdbf-2d3c-473a-8cee-c5c2d7367ffc	21fd3447-ae99-49aa-8748-d1d589c578fc
822a5a81-5dc2-48a0-b289-681a6c267ccf	4235252c-aa21-46b5-8c52-110f95bdc583	1986e4ca-61a8-41a6-95c2-940e526d50f1	active	dbfdfdbf-2d3c-473a-8cee-c5c2d7367ffc	822a5a81-5dc2-48a0-b289-681a6c267ccf
6fc6f1c4-a865-4251-a4c5-46bdd72e364c	4235252c-aa21-46b5-8c52-110f95bdc583	e8584566-2520-4ffc-bcf6-202169e737a7	active	dbfdfdbf-2d3c-473a-8cee-c5c2d7367ffc	6fc6f1c4-a865-4251-a4c5-46bdd72e364c
0dbc19fd-d69b-4cac-bacb-5d4ede02e215	e3424ea9-f7c0-4d80-832b-890c3de0f744	89f5db50-4b21-4808-a4fe-523ec4ff414c	active	a6a5efac-b108-40c8-847c-e06530596dae	0dbc19fd-d69b-4cac-bacb-5d4ede02e215
76701645-e7a5-4253-b58a-f5a95df7a5bd	e3424ea9-f7c0-4d80-832b-890c3de0f744	4904453a-6192-4b55-90e8-b8d185b31af7	active	a6a5efac-b108-40c8-847c-e06530596dae	76701645-e7a5-4253-b58a-f5a95df7a5bd
101e842b-257c-4456-84e2-684b949c379d	e3424ea9-f7c0-4d80-832b-890c3de0f744	9d86e388-cc10-4cf2-b2e7-84d8de81ac84	active	a6a5efac-b108-40c8-847c-e06530596dae	101e842b-257c-4456-84e2-684b949c379d
4d34ca12-ab5b-491c-aa40-409095cfc813	e3424ea9-f7c0-4d80-832b-890c3de0f744	e8584566-2520-4ffc-bcf6-202169e737a7	active	a6a5efac-b108-40c8-847c-e06530596dae	4d34ca12-ab5b-491c-aa40-409095cfc813
88240498-cb11-409c-8ee0-059e4e548209	db34f769-ed94-45d3-8b66-5ebaf9b091ff	74f41828-1aad-4c1c-bdb7-06ad82909375	active	53b7a5cf-ae69-4bb1-b239-940facaeb014	88240498-cb11-409c-8ee0-059e4e548209
eb28d2e4-a790-4233-852c-a7edc5e95f9c	db34f769-ed94-45d3-8b66-5ebaf9b091ff	7dffaf3a-a450-4435-b385-44a4e9d0ef61	active	53b7a5cf-ae69-4bb1-b239-940facaeb014	eb28d2e4-a790-4233-852c-a7edc5e95f9c
c76f444c-b90e-4e6e-add0-00f88a7c53d2	db34f769-ed94-45d3-8b66-5ebaf9b091ff	f50e4f48-a55e-4d54-996e-dea429b042c8	active	53b7a5cf-ae69-4bb1-b239-940facaeb014	c76f444c-b90e-4e6e-add0-00f88a7c53d2
8ff35d23-6119-4bf0-88d0-521e3d1807d6	db34f769-ed94-45d3-8b66-5ebaf9b091ff	130ae24f-aa62-4d20-8987-265a1d4d1861	active	53b7a5cf-ae69-4bb1-b239-940facaeb014	8ff35d23-6119-4bf0-88d0-521e3d1807d6
f60f7e08-4094-4407-bfb2-fb2b79eb4767	db34f769-ed94-45d3-8b66-5ebaf9b091ff	5b2978e4-1837-4164-9070-ad935a080c0c	active	53b7a5cf-ae69-4bb1-b239-940facaeb014	f60f7e08-4094-4407-bfb2-fb2b79eb4767
4d666cee-3447-4da8-8ae1-15df7ad0ae97	65d7e18e-c5ab-4736-bb9e-c47de2dc41e1	e27ac12a-a758-4c98-9198-8663e4d52fa6	active	46aec451-5c77-4e88-b1bb-b14ef364f759	4d666cee-3447-4da8-8ae1-15df7ad0ae97
dd261a55-8ca0-431a-b739-37a3803f9f35	65d7e18e-c5ab-4736-bb9e-c47de2dc41e1	db2920d7-c288-4ebd-86b8-a4fdf4689c91	active	46aec451-5c77-4e88-b1bb-b14ef364f759	dd261a55-8ca0-431a-b739-37a3803f9f35
cba75e35-567b-41ba-bcdb-860ff3bb1bd8	65d7e18e-c5ab-4736-bb9e-c47de2dc41e1	7dffaf3a-a450-4435-b385-44a4e9d0ef61	active	46aec451-5c77-4e88-b1bb-b14ef364f759	cba75e35-567b-41ba-bcdb-860ff3bb1bd8
54791239-40d9-4a0c-8e1b-7ed4734f67b3	65d7e18e-c5ab-4736-bb9e-c47de2dc41e1	130ae24f-aa62-4d20-8987-265a1d4d1861	active	46aec451-5c77-4e88-b1bb-b14ef364f759	54791239-40d9-4a0c-8e1b-7ed4734f67b3
de3db1a5-f43a-46a5-9f5b-41c312dced3f	3aa0d5ce-cef6-4158-b51e-ddee8ece7b5e	adcb0b79-7ada-4467-8f7d-ca6ce7a60405	active	ceb18013-a90d-44d6-a245-b199633faf0b	de3db1a5-f43a-46a5-9f5b-41c312dced3f
60fc2283-8da2-4551-9523-514bf9cc9284	3aa0d5ce-cef6-4158-b51e-ddee8ece7b5e	dd3612df-5f1b-479e-9a3c-22737dd68f70	active	ceb18013-a90d-44d6-a245-b199633faf0b	60fc2283-8da2-4551-9523-514bf9cc9284
fe373ad9-bf8a-409c-aacf-0c403fab757a	3aa0d5ce-cef6-4158-b51e-ddee8ece7b5e	705d6aed-b1d5-4b89-ad38-be4a1daba35d	active	ceb18013-a90d-44d6-a245-b199633faf0b	fe373ad9-bf8a-409c-aacf-0c403fab757a
ffb4fea7-beba-4eb3-b61a-31e206f17aa2	3aa0d5ce-cef6-4158-b51e-ddee8ece7b5e	d58a8241-1622-4e11-936e-4eab9c55ba4b	active	ceb18013-a90d-44d6-a245-b199633faf0b	ffb4fea7-beba-4eb3-b61a-31e206f17aa2
4408f151-baae-4685-84dd-57361207dea0	97b2cf1e-91f4-4b08-a7d8-2e6bd1dca37e	d6b5bc12-83dc-42b7-abf3-2839547f6b03	active	a5bfd523-f3c2-41e2-9e1a-1624d786767c	4408f151-baae-4685-84dd-57361207dea0
8eeb167f-c899-40ec-90f9-4029c9754054	97b2cf1e-91f4-4b08-a7d8-2e6bd1dca37e	f59be7f4-6494-42a9-b21f-388930fca8cd	active	a5bfd523-f3c2-41e2-9e1a-1624d786767c	8eeb167f-c899-40ec-90f9-4029c9754054
7728b248-c1da-4a18-a20f-aeba6a5cbb75	97b2cf1e-91f4-4b08-a7d8-2e6bd1dca37e	2d6031a5-1753-481d-8c0b-ce6d3cf08464	active	a5bfd523-f3c2-41e2-9e1a-1624d786767c	7728b248-c1da-4a18-a20f-aeba6a5cbb75
132671c9-a9e3-4163-8179-46401d06ad58	e4c69e90-1056-4f46-9619-57d0a18d1737	f59be7f4-6494-42a9-b21f-388930fca8cd	active	19979634-e047-4bef-b09b-396ebbbf7fd0	132671c9-a9e3-4163-8179-46401d06ad58
45b2bce3-1744-4315-86ae-6801ccc0793d	e4c69e90-1056-4f46-9619-57d0a18d1737	d6b5bc12-83dc-42b7-abf3-2839547f6b03	active	19979634-e047-4bef-b09b-396ebbbf7fd0	45b2bce3-1744-4315-86ae-6801ccc0793d
87901e4d-fd6a-46aa-925a-df81f2e3fa4e	e4c69e90-1056-4f46-9619-57d0a18d1737	5e81f122-08fc-491b-9320-55eeb783e1bb	active	19979634-e047-4bef-b09b-396ebbbf7fd0	87901e4d-fd6a-46aa-925a-df81f2e3fa4e
b5525e9f-b798-4dae-99e6-fba61d86d62d	e4c69e90-1056-4f46-9619-57d0a18d1737	2d6031a5-1753-481d-8c0b-ce6d3cf08464	active	19979634-e047-4bef-b09b-396ebbbf7fd0	b5525e9f-b798-4dae-99e6-fba61d86d62d
5400ce7f-1274-41fd-b1f8-fbb05b00712d	43c3cc44-3a6c-469b-80fe-913927d2c283	8b6bc9ac-d129-4a8b-bb7f-d062c566f4b3	active	5b3fb26f-b388-4423-88e3-076c7476b2cc	5400ce7f-1274-41fd-b1f8-fbb05b00712d
8413fe5b-2e46-4dff-96fc-5f662a0dbfa7	43c3cc44-3a6c-469b-80fe-913927d2c283	7e40bdf7-20b4-4b73-a65e-f7fe50feb8a2	active	5b3fb26f-b388-4423-88e3-076c7476b2cc	8413fe5b-2e46-4dff-96fc-5f662a0dbfa7
730165c7-bb1b-4078-b10d-21c60d9fb586	43c3cc44-3a6c-469b-80fe-913927d2c283	d3cb78ca-0862-45df-9f56-b47a4038adfa	active	5b3fb26f-b388-4423-88e3-076c7476b2cc	730165c7-bb1b-4078-b10d-21c60d9fb586
2fdd65b2-fd3f-4b1f-a165-ca56fb2592e2	1901d722-a38d-4e79-a13c-ca51d61bae30	b59b9b95-d0f4-4c43-9204-4328b391accb	active	b2b4b103-d694-4105-86d7-fa937445826f	2fdd65b2-fd3f-4b1f-a165-ca56fb2592e2
ba03eec3-29be-4c54-a1bb-1a53c3e89037	1901d722-a38d-4e79-a13c-ca51d61bae30	f59be7f4-6494-42a9-b21f-388930fca8cd	active	b2b4b103-d694-4105-86d7-fa937445826f	ba03eec3-29be-4c54-a1bb-1a53c3e89037
87c1cc7c-f2a1-431a-afb1-b153f295b5f5	1901d722-a38d-4e79-a13c-ca51d61bae30	9f47f113-6785-4448-b15c-8b3eaf2032c9	active	b2b4b103-d694-4105-86d7-fa937445826f	87c1cc7c-f2a1-431a-afb1-b153f295b5f5
188154ef-7953-4d36-9820-1bafaf7aaeeb	1901d722-a38d-4e79-a13c-ca51d61bae30	b7438d75-793c-46a4-aa9d-c61fcfa17632	active	b2b4b103-d694-4105-86d7-fa937445826f	188154ef-7953-4d36-9820-1bafaf7aaeeb
31848822-b663-4557-99a0-2790dd408ba7	1901d722-a38d-4e79-a13c-ca51d61bae30	cecfa504-4a92-4103-beb6-e1d15bbac444	active	b2b4b103-d694-4105-86d7-fa937445826f	31848822-b663-4557-99a0-2790dd408ba7
64808080-9bb6-4f57-960e-fe9f6a3fd771	3aa0d5ce-cef6-4158-b51e-ddee8ece7b5e	b6813c1f-5d9c-474d-885d-e839f43e100e	active	17737307-867d-490f-8558-a3225789c916	64808080-9bb6-4f57-960e-fe9f6a3fd771
01ce052b-8099-4146-9ee0-2f9212810c5d	3aa0d5ce-cef6-4158-b51e-ddee8ece7b5e	9a09c86e-d08e-4fa9-bb79-6c864acec8d7	active	17737307-867d-490f-8558-a3225789c916	01ce052b-8099-4146-9ee0-2f9212810c5d
ffb4fea7-beba-4eb3-b61a-31e206f17aa2	3aa0d5ce-cef6-4158-b51e-ddee8ece7b5e	d58a8241-1622-4e11-936e-4eab9c55ba4b	deleted	17737307-867d-490f-8558-a3225789c916	ffb4fea7-beba-4eb3-b61a-31e206f17aa2
7728b248-c1da-4a18-a20f-aeba6a5cbb75	97b2cf1e-91f4-4b08-a7d8-2e6bd1dca37e	2d6031a5-1753-481d-8c0b-ce6d3cf08464	deleted	d8e30bba-2d57-45ea-8134-0794051afc25	7728b248-c1da-4a18-a20f-aeba6a5cbb75
6b4c947c-af24-4b10-ac55-7f26557ecb25	97b2cf1e-91f4-4b08-a7d8-2e6bd1dca37e	3d24f7b8-4401-4ef1-87d2-955c4628689d	active	d8e30bba-2d57-45ea-8134-0794051afc25	6b4c947c-af24-4b10-ac55-7f26557ecb25
b5525e9f-b798-4dae-99e6-fba61d86d62d	e4c69e90-1056-4f46-9619-57d0a18d1737	2d6031a5-1753-481d-8c0b-ce6d3cf08464	deleted	4b18699d-de47-485f-af9e-a8569d139c47	b5525e9f-b798-4dae-99e6-fba61d86d62d
c405ed41-da8e-443d-845f-ba4523953591	e4c69e90-1056-4f46-9619-57d0a18d1737	3d24f7b8-4401-4ef1-87d2-955c4628689d	active	4b18699d-de47-485f-af9e-a8569d139c47	c405ed41-da8e-443d-845f-ba4523953591
58f2e70d-e04e-4a92-92f7-9762f8eaf9a0	5b23d4f4-058e-44e0-945d-ae9035fb1e15	1bef7b23-a8cd-4000-94b9-2a5d2fdd9c58	active	f9d8651f-75dd-4a22-8190-ea0df1fb83d1	58f2e70d-e04e-4a92-92f7-9762f8eaf9a0
902cc5b6-2efa-4a22-81cd-8c912a9c67f2	5b23d4f4-058e-44e0-945d-ae9035fb1e15	b417e47b-f741-4033-8945-1663a28d3697	active	f9d8651f-75dd-4a22-8190-ea0df1fb83d1	902cc5b6-2efa-4a22-81cd-8c912a9c67f2
f8f8094f-d265-4598-ab4a-40c3340c845f	5b23d4f4-058e-44e0-945d-ae9035fb1e15	bd44cae3-27be-4c3c-b851-ec460a1d0440	active	f9d8651f-75dd-4a22-8190-ea0df1fb83d1	f8f8094f-d265-4598-ab4a-40c3340c845f
5a936481-41ac-418c-8c76-93b7efce4f5d	5b23d4f4-058e-44e0-945d-ae9035fb1e15	b14d995b-b893-4284-b948-eaaeb1f5f252	active	f9d8651f-75dd-4a22-8190-ea0df1fb83d1	5a936481-41ac-418c-8c76-93b7efce4f5d
cc8d940a-aa41-4ec9-9ea1-fa0320a89361	be516eed-8a37-436c-af75-b623f0806f39	d984ccec-aa4b-4645-8301-28a3c57392b2	active	e5f47372-8631-4d88-9613-f26a40b1ad80	cc8d940a-aa41-4ec9-9ea1-fa0320a89361
58f17250-6230-434e-b1e5-a1dfba4331bf	be516eed-8a37-436c-af75-b623f0806f39	d539b83c-b99c-4577-b773-83fa4c6f5518	active	e5f47372-8631-4d88-9613-f26a40b1ad80	58f17250-6230-434e-b1e5-a1dfba4331bf
50bb5cd1-0b1e-494e-9ba8-60e096e4c749	be516eed-8a37-436c-af75-b623f0806f39	f3c50e34-5dcb-409b-a06c-8c16d220c756	active	e5f47372-8631-4d88-9613-f26a40b1ad80	50bb5cd1-0b1e-494e-9ba8-60e096e4c749
8904710e-50db-48d4-9d81-5f9d66d48741	5e86134f-2cb5-40e9-affa-f80d934a14b9	55546b47-fe3c-40bc-acc9-f78d285d9f13	active	affa5e72-9823-4011-8ea4-8ef8c2305fe6	8904710e-50db-48d4-9d81-5f9d66d48741
74775ead-456e-4075-8243-c53641f0765d	5e86134f-2cb5-40e9-affa-f80d934a14b9	8e7f1f27-d0bb-4860-a969-93960fa02e9e	active	affa5e72-9823-4011-8ea4-8ef8c2305fe6	74775ead-456e-4075-8243-c53641f0765d
a21aa2ef-62e8-4ff3-927b-6c96b83808cd	6d999f74-d520-4a8c-8188-5a5c13c6bbec	4233e616-3f33-49fb-aa6c-7b54554dec19	active	792ec941-9e46-472a-8f28-ee06aeaa4e5b	a21aa2ef-62e8-4ff3-927b-6c96b83808cd
9cd9ccd7-3e9f-4f91-9603-7a2b28313221	6d999f74-d520-4a8c-8188-5a5c13c6bbec	430484c2-faac-4f88-b6c5-df6d5db26382	active	792ec941-9e46-472a-8f28-ee06aeaa4e5b	9cd9ccd7-3e9f-4f91-9603-7a2b28313221
4fc7c96b-ecd8-472d-99cb-0332c34df023	6d999f74-d520-4a8c-8188-5a5c13c6bbec	babf872e-41d5-470e-88b1-8dedc68cf97d	active	792ec941-9e46-472a-8f28-ee06aeaa4e5b	4fc7c96b-ecd8-472d-99cb-0332c34df023
e4f805c5-6c34-411e-bec5-587b6b97a3aa	6d999f74-d520-4a8c-8188-5a5c13c6bbec	6e387a45-5862-4587-a6ed-e576a8dfdfa5	active	792ec941-9e46-472a-8f28-ee06aeaa4e5b	e4f805c5-6c34-411e-bec5-587b6b97a3aa
40a5fb5f-0bee-4bc8-897b-c804d4e512bc	6d999f74-d520-4a8c-8188-5a5c13c6bbec	eaff4bf2-c366-495a-b68f-23b9c65e9b7f	active	792ec941-9e46-472a-8f28-ee06aeaa4e5b	40a5fb5f-0bee-4bc8-897b-c804d4e512bc
7c85f4a4-a225-4861-b9af-8eb8627d0359	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	473f15dd-47c0-40a6-89e9-3a053ab172a4	active	85392283-0794-47c2-a7e4-2862636d3e55	7c85f4a4-a225-4861-b9af-8eb8627d0359
3246f399-7a53-4993-a8be-8d8abedf1ad8	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	ca526aec-bf03-499f-943f-d303a222c6cb	active	85392283-0794-47c2-a7e4-2862636d3e55	3246f399-7a53-4993-a8be-8d8abedf1ad8
6ab61f5f-0d6b-4bd8-b66b-7fa9fe5009c1	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	c8cc7acf-e055-4755-8aca-da325baeef12	active	85392283-0794-47c2-a7e4-2862636d3e55	6ab61f5f-0d6b-4bd8-b66b-7fa9fe5009c1
89f9f736-05c5-4bff-93f6-219137c252a0	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	8ca0b522-b29a-4155-907b-8142c500dcce	active	85392283-0794-47c2-a7e4-2862636d3e55	89f9f736-05c5-4bff-93f6-219137c252a0
a46cf6bd-85f5-424a-933e-02a30af37220	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	7ecb1d10-e6c7-4a8a-8c63-0a1b1e65fc0b	active	85392283-0794-47c2-a7e4-2862636d3e55	a46cf6bd-85f5-424a-933e-02a30af37220
0d89c36e-1a1e-4490-b064-1dec137f324f	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	2af7acb6-6f04-4766-b560-efd1b100596b	active	85392283-0794-47c2-a7e4-2862636d3e55	0d89c36e-1a1e-4490-b064-1dec137f324f
57aca32a-1ed7-4d16-82a8-f079e35cf896	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	c34cb669-4bf2-4571-895f-d9dfe3f945bf	active	85392283-0794-47c2-a7e4-2862636d3e55	57aca32a-1ed7-4d16-82a8-f079e35cf896
6e423f96-1e45-482d-acef-d20e6f9da69d	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	0f779fa2-6ef8-40d9-ba61-6687b5e82fa0	active	85392283-0794-47c2-a7e4-2862636d3e55	6e423f96-1e45-482d-acef-d20e6f9da69d
2fcca417-5914-40c3-a43a-02da0ed64e78	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	8cdd235e-33ca-4ffe-9c73-eaa92f08f92d	active	85392283-0794-47c2-a7e4-2862636d3e55	2fcca417-5914-40c3-a43a-02da0ed64e78
723a9cb4-8ffe-4e6c-8828-3908dcaddf66	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	2a33d5a2-9d58-4d8e-975d-ee07da3d6b0e	active	85392283-0794-47c2-a7e4-2862636d3e55	723a9cb4-8ffe-4e6c-8828-3908dcaddf66
3a591d72-7a9d-4f94-a47d-5e8d2966a2d0	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	49a7a707-a579-4de2-940f-1a846b22e741	active	85392283-0794-47c2-a7e4-2862636d3e55	3a591d72-7a9d-4f94-a47d-5e8d2966a2d0
91a388a6-6295-4f81-91ed-0bfb264c8b57	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	46caf164-0cb1-4ab1-85a7-22ba97d7b8fc	active	85392283-0794-47c2-a7e4-2862636d3e55	91a388a6-6295-4f81-91ed-0bfb264c8b57
975c89c7-5d3b-4b41-84a3-11aca3504a1c	f6c6aac7-3c9b-4a3c-80bc-d6709bc95d4b	a7cee6ce-5b52-448c-8a41-c612a5d0b3b9	active	a78d4faa-842b-4cec-8ba4-2e9993ff99ca	975c89c7-5d3b-4b41-84a3-11aca3504a1c
edc5627d-7c1b-48ab-8406-940aeb9946ab	f6c6aac7-3c9b-4a3c-80bc-d6709bc95d4b	151588d7-81bf-4f3d-a866-891e5849a939	active	a78d4faa-842b-4cec-8ba4-2e9993ff99ca	edc5627d-7c1b-48ab-8406-940aeb9946ab
3b6b7e48-db41-44c7-a421-6ce959b67592	f6c6aac7-3c9b-4a3c-80bc-d6709bc95d4b	e8584566-2520-4ffc-bcf6-202169e737a7	active	a78d4faa-842b-4cec-8ba4-2e9993ff99ca	3b6b7e48-db41-44c7-a421-6ce959b67592
825aa471-39bd-4380-8be1-3eabbdd9fac1	f6c6aac7-3c9b-4a3c-80bc-d6709bc95d4b	2a33d5a2-9d58-4d8e-975d-ee07da3d6b0e	active	a78d4faa-842b-4cec-8ba4-2e9993ff99ca	825aa471-39bd-4380-8be1-3eabbdd9fac1
de15d807-dee7-4ab7-8cc5-da8592438f61	f6c6aac7-3c9b-4a3c-80bc-d6709bc95d4b	d057758e-a4a2-4125-82bd-83b96a2136da	active	a78d4faa-842b-4cec-8ba4-2e9993ff99ca	de15d807-dee7-4ab7-8cc5-da8592438f61
d6766ab7-317e-4abd-8f97-1aa11d74da08	f6c6aac7-3c9b-4a3c-80bc-d6709bc95d4b	1812b303-186d-4734-a4cb-1345949485d9	active	a78d4faa-842b-4cec-8ba4-2e9993ff99ca	d6766ab7-317e-4abd-8f97-1aa11d74da08
11015585-b3c7-44b4-b606-878d9c483f1a	f6c6aac7-3c9b-4a3c-80bc-d6709bc95d4b	c061a5ce-5435-47f8-840a-e36a4f315367	active	a78d4faa-842b-4cec-8ba4-2e9993ff99ca	11015585-b3c7-44b4-b606-878d9c483f1a
17fcff91-588c-48ca-ab27-55656c3637ee	f6c6aac7-3c9b-4a3c-80bc-d6709bc95d4b	5ff7e7e2-383d-479b-90f7-6b0d3bcaa51a	active	a78d4faa-842b-4cec-8ba4-2e9993ff99ca	17fcff91-588c-48ca-ab27-55656c3637ee
db8692f3-578d-40d3-a738-dbf7ca2ad37c	f6c6aac7-3c9b-4a3c-80bc-d6709bc95d4b	76b6bb6a-de74-4522-b4db-14a74a7320ba	active	a78d4faa-842b-4cec-8ba4-2e9993ff99ca	db8692f3-578d-40d3-a738-dbf7ca2ad37c
57aca32a-1ed7-4d16-82a8-f079e35cf896	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	c34cb669-4bf2-4571-895f-d9dfe3f945bf	deleted	053a6cde-e92d-4f32-9bcb-d4ee6fe05a74	57aca32a-1ed7-4d16-82a8-f079e35cf896
4a09766f-7ca0-46e0-bf4a-de6b2790a343	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	1812b303-186d-4734-a4cb-1345949485d9	active	053a6cde-e92d-4f32-9bcb-d4ee6fe05a74	4a09766f-7ca0-46e0-bf4a-de6b2790a343
4cea99e8-cb79-41da-b201-48e50e46d9e8	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	7fdbeb86-6300-4260-ac9a-4327519c6bb7	active	053a6cde-e92d-4f32-9bcb-d4ee6fe05a74	4cea99e8-cb79-41da-b201-48e50e46d9e8
2fcca417-5914-40c3-a43a-02da0ed64e78	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	8cdd235e-33ca-4ffe-9c73-eaa92f08f92d	deleted	053a6cde-e92d-4f32-9bcb-d4ee6fe05a74	2fcca417-5914-40c3-a43a-02da0ed64e78
b7455f2f-e483-4d8e-989c-79813a74ba3d	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	a45f616e-ae34-4a83-aaf3-de06faca7caf	active	053a6cde-e92d-4f32-9bcb-d4ee6fe05a74	b7455f2f-e483-4d8e-989c-79813a74ba3d
4dacec06-1947-4b4b-8fae-f3c2145f6dc8	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	5ff7e7e2-383d-479b-90f7-6b0d3bcaa51a	active	053a6cde-e92d-4f32-9bcb-d4ee6fe05a74	4dacec06-1947-4b4b-8fae-f3c2145f6dc8
3246f399-7a53-4993-a8be-8d8abedf1ad8	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	ca526aec-bf03-499f-943f-d303a222c6cb	deleted	053a6cde-e92d-4f32-9bcb-d4ee6fe05a74	3246f399-7a53-4993-a8be-8d8abedf1ad8
121ce32c-d084-4072-9cfa-b9f3bcff1c67	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	ee1bf582-8672-4f86-a84e-c958ff2e7205	active	053a6cde-e92d-4f32-9bcb-d4ee6fe05a74	121ce32c-d084-4072-9cfa-b9f3bcff1c67
935bb69a-7e9e-4f52-8831-8fbf56706fe3	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	07b86a93-6171-4f6d-a4ec-8982c30ffbfd	active	053a6cde-e92d-4f32-9bcb-d4ee6fe05a74	935bb69a-7e9e-4f52-8831-8fbf56706fe3
a46cf6bd-85f5-424a-933e-02a30af37220	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	7ecb1d10-e6c7-4a8a-8c63-0a1b1e65fc0b	deleted	053a6cde-e92d-4f32-9bcb-d4ee6fe05a74	a46cf6bd-85f5-424a-933e-02a30af37220
0d89c36e-1a1e-4490-b064-1dec137f324f	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	2af7acb6-6f04-4766-b560-efd1b100596b	deleted	053a6cde-e92d-4f32-9bcb-d4ee6fe05a74	0d89c36e-1a1e-4490-b064-1dec137f324f
129a4147-f0f5-4ef6-8a18-5049a0f4e96b	6968ef13-1d2f-4de3-b533-706bc9c0f604	a7cee6ce-5b52-448c-8a41-c612a5d0b3b9	active	29796bcf-b80b-4c83-a40e-c792a50e8802	129a4147-f0f5-4ef6-8a18-5049a0f4e96b
136bcf61-6a28-454e-b7e6-977eaf25cc1c	6968ef13-1d2f-4de3-b533-706bc9c0f604	eb059ff9-81d9-48be-82d9-a2bb74e596de	active	29796bcf-b80b-4c83-a40e-c792a50e8802	136bcf61-6a28-454e-b7e6-977eaf25cc1c
b5f46c37-f1de-4b88-aabd-9b2e5956fee6	6968ef13-1d2f-4de3-b533-706bc9c0f604	e8584566-2520-4ffc-bcf6-202169e737a7	active	29796bcf-b80b-4c83-a40e-c792a50e8802	b5f46c37-f1de-4b88-aabd-9b2e5956fee6
043ea8f1-e230-411b-be3b-4656b9d0fa79	6968ef13-1d2f-4de3-b533-706bc9c0f604	9f47f113-6785-4448-b15c-8b3eaf2032c9	active	29796bcf-b80b-4c83-a40e-c792a50e8802	043ea8f1-e230-411b-be3b-4656b9d0fa79
275464ea-f12f-41f4-a010-38ac7dcd0c12	6968ef13-1d2f-4de3-b533-706bc9c0f604	cecfa504-4a92-4103-beb6-e1d15bbac444	active	29796bcf-b80b-4c83-a40e-c792a50e8802	275464ea-f12f-41f4-a010-38ac7dcd0c12
c25386e3-2a60-41b7-8b36-e437e81182b5	6968ef13-1d2f-4de3-b533-706bc9c0f604	1986e4ca-61a8-41a6-95c2-940e526d50f1	active	29796bcf-b80b-4c83-a40e-c792a50e8802	c25386e3-2a60-41b7-8b36-e437e81182b5
35da204c-a484-4fd6-b50f-06fbd596048e	f6c6aac7-3c9b-4a3c-80bc-d6709bc95d4b	1986e4ca-61a8-41a6-95c2-940e526d50f1	active	2c169a3a-8172-4566-832b-982d79709f1a	35da204c-a484-4fd6-b50f-06fbd596048e
ad6b6c3c-1aaf-4fe9-b6db-cb1832cb81b4	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	920f0530-0a9e-49c0-9978-f3d9ff3925c4	active	3eefe87a-10dc-47ae-8e06-ed0f9fd04235	ad6b6c3c-1aaf-4fe9-b6db-cb1832cb81b4
4cea99e8-cb79-41da-b201-48e50e46d9e8	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	7fdbeb86-6300-4260-ac9a-4327519c6bb7	deleted	3eefe87a-10dc-47ae-8e06-ed0f9fd04235	4cea99e8-cb79-41da-b201-48e50e46d9e8
3a591d72-7a9d-4f94-a47d-5e8d2966a2d0	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	49a7a707-a579-4de2-940f-1a846b22e741	deleted	3eefe87a-10dc-47ae-8e06-ed0f9fd04235	3a591d72-7a9d-4f94-a47d-5e8d2966a2d0
700b0c8e-ee60-4022-99e7-cd7c07c01f11	f6c6aac7-3c9b-4a3c-80bc-d6709bc95d4b	89f5db50-4b21-4808-a4fe-523ec4ff414c	active	c42aefff-d420-4504-95d7-3d69e49d3c8a	700b0c8e-ee60-4022-99e7-cd7c07c01f11
ca01afd9-a5bc-485a-a5cb-29d6fad2bb7e	f3d8ca3c-32b9-4485-95d9-0b1fd4a5dd4e	920f0530-0a9e-49c0-9978-f3d9ff3925c4	active	d78247f0-fc65-4fb3-bc7e-81f3ad80e69b	ca01afd9-a5bc-485a-a5cb-29d6fad2bb7e
c47227ca-082c-4000-8b74-fe8f6f365e2a	f3d8ca3c-32b9-4485-95d9-0b1fd4a5dd4e	b57f29c3-0179-4d53-8f0e-f400acab0e07	active	d78247f0-fc65-4fb3-bc7e-81f3ad80e69b	c47227ca-082c-4000-8b74-fe8f6f365e2a
51fdc4da-0364-4eb4-9e2e-aceb5e3e6d7e	f3d8ca3c-32b9-4485-95d9-0b1fd4a5dd4e	1812b303-186d-4734-a4cb-1345949485d9	active	d78247f0-fc65-4fb3-bc7e-81f3ad80e69b	51fdc4da-0364-4eb4-9e2e-aceb5e3e6d7e
56619650-909d-4b8e-99f5-45a634eadfd3	f3d8ca3c-32b9-4485-95d9-0b1fd4a5dd4e	ee1bf582-8672-4f86-a84e-c958ff2e7205	active	d78247f0-fc65-4fb3-bc7e-81f3ad80e69b	56619650-909d-4b8e-99f5-45a634eadfd3
3c888a2b-7c65-4fb8-bf85-7c9a1af76f4e	f3d8ca3c-32b9-4485-95d9-0b1fd4a5dd4e	aac980e1-0aa5-41e0-b6e0-eebbab19c7c9	active	d78247f0-fc65-4fb3-bc7e-81f3ad80e69b	3c888a2b-7c65-4fb8-bf85-7c9a1af76f4e
1719f68f-b476-4d71-897e-872ce8bfc487	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	a6428b13-2aea-4468-b051-a7b7b2c81ad2	active	23851c5d-9680-440f-82b7-b0c72d7db67a	1719f68f-b476-4d71-897e-872ce8bfc487
af75a212-d855-4252-ab2d-07ace7fc007b	f3d8ca3c-32b9-4485-95d9-0b1fd4a5dd4e	a6428b13-2aea-4468-b051-a7b7b2c81ad2	active	1efed480-60dd-42bd-8380-84b7a8c22587	af75a212-d855-4252-ab2d-07ace7fc007b
de7321cb-921f-480a-b989-cef4be41d0da	6968ef13-1d2f-4de3-b533-706bc9c0f604	a6428b13-2aea-4468-b051-a7b7b2c81ad2	active	baa66947-52d1-48c5-bfd5-11a3c7353d7d	de7321cb-921f-480a-b989-cef4be41d0da
068e484e-5305-4195-aa7c-8d1e823d0e9c	f6c6aac7-3c9b-4a3c-80bc-d6709bc95d4b	a6428b13-2aea-4468-b051-a7b7b2c81ad2	active	632fb8b8-5a20-4e3e-b50c-fa86591bdfa1	068e484e-5305-4195-aa7c-8d1e823d0e9c
02b10f45-8d7b-481d-9479-bd8bb5be1550	97b2cf1e-91f4-4b08-a7d8-2e6bd1dca37e	a6428b13-2aea-4468-b051-a7b7b2c81ad2	active	d37666ea-df46-411a-bc6c-3d1b808ebefc	02b10f45-8d7b-481d-9479-bd8bb5be1550
78c7cdca-1d45-49b1-bdd4-bc71148a7568	69361720-3428-417e-beb4-d21df542992c	a6428b13-2aea-4468-b051-a7b7b2c81ad2	active	8b208a3e-558c-4884-9cc1-297a0dc0e174	78c7cdca-1d45-49b1-bdd4-bc71148a7568
01abd1d3-7043-4b94-aab8-bc2cf7e9868a	69361720-3428-417e-beb4-d21df542992c	a0da534f-3b88-4e01-bdda-f58bf9b11407	active	8b208a3e-558c-4884-9cc1-297a0dc0e174	01abd1d3-7043-4b94-aab8-bc2cf7e9868a
5448864f-ae69-46f5-840f-74e5fcba0d4d	0e14dccb-9c28-4f89-b3b2-cb1011be06d1	be807861-8861-4f83-80fd-ad22da22d1d8	active	fb37d996-fe0c-49bf-8cb0-29b99087b3d2	5448864f-ae69-46f5-840f-74e5fcba0d4d
f14775c5-1b89-44aa-8b68-b4f3996cc547	0e14dccb-9c28-4f89-b3b2-cb1011be06d1	f1cfeeff-4ba7-4172-ba51-550d8183db28	active	fb37d996-fe0c-49bf-8cb0-29b99087b3d2	f14775c5-1b89-44aa-8b68-b4f3996cc547
fa68ad69-6a26-4783-9144-2b1104383fff	0e14dccb-9c28-4f89-b3b2-cb1011be06d1	9aaf0eec-fc2a-4117-a8c4-c4e160b53db5	active	fb37d996-fe0c-49bf-8cb0-29b99087b3d2	fa68ad69-6a26-4783-9144-2b1104383fff
946b2f12-e2a6-44a9-95f0-3f5e508ae653	34269022-c891-4a8e-a814-3af2b0fea526	cecfa504-4a92-4103-beb6-e1d15bbac444	active	a23213e4-603f-42b1-88e7-f9f17b4bdb6d	946b2f12-e2a6-44a9-95f0-3f5e508ae653
ff415931-7071-4ccb-a278-2e2b72cfa739	34269022-c891-4a8e-a814-3af2b0fea526	9f47f113-6785-4448-b15c-8b3eaf2032c9	active	a23213e4-603f-42b1-88e7-f9f17b4bdb6d	ff415931-7071-4ccb-a278-2e2b72cfa739
5a852848-beb8-4fdb-a79e-db6130af6c9f	34269022-c891-4a8e-a814-3af2b0fea526	a0da534f-3b88-4e01-bdda-f58bf9b11407	active	a23213e4-603f-42b1-88e7-f9f17b4bdb6d	5a852848-beb8-4fdb-a79e-db6130af6c9f
bc9480bd-4e51-4ced-a136-2decb39f63ea	34269022-c891-4a8e-a814-3af2b0fea526	a6428b13-2aea-4468-b051-a7b7b2c81ad2	active	a23213e4-603f-42b1-88e7-f9f17b4bdb6d	bc9480bd-4e51-4ced-a136-2decb39f63ea
493b45b7-33ea-4827-9b3f-dc1b4f9275ba	34269022-c891-4a8e-a814-3af2b0fea526	f59be7f4-6494-42a9-b21f-388930fca8cd	active	a23213e4-603f-42b1-88e7-f9f17b4bdb6d	493b45b7-33ea-4827-9b3f-dc1b4f9275ba
41899738-f946-420c-b189-27e8233b9b64	a1019da5-cdac-4e09-8b60-831994b5f275	3640e8d5-1d55-4a85-968e-539f45ed137e	active	58ff28dc-f3eb-40a2-bcf8-3912f26472e7	41899738-f946-420c-b189-27e8233b9b64
3b24746e-b3d8-41d0-b568-6b80fb633aac	a1019da5-cdac-4e09-8b60-831994b5f275	f13fdde8-8913-46b8-852f-8508edfc112c	active	58ff28dc-f3eb-40a2-bcf8-3912f26472e7	3b24746e-b3d8-41d0-b568-6b80fb633aac
a51cedec-153a-4287-9d63-8169d2a6f31b	a1019da5-cdac-4e09-8b60-831994b5f275	780ba1c1-34a2-4573-98f9-9a8c6661e44c	active	58ff28dc-f3eb-40a2-bcf8-3912f26472e7	a51cedec-153a-4287-9d63-8169d2a6f31b
41a98b08-0100-4cb6-9735-7640975cb426	29772378-f226-4fc8-8e01-9a87c5e43a00	3f8a8351-34ce-4e10-b785-fb7a57c5e7cd	active	14d1f443-8fc7-42d8-a730-c7747178aa8e	41a98b08-0100-4cb6-9735-7640975cb426
e29bb438-fafd-46c8-a28d-c4bfe7db359c	29772378-f226-4fc8-8e01-9a87c5e43a00	711dcc85-fc2a-465e-8e61-bbf63861b31f	active	14d1f443-8fc7-42d8-a730-c7747178aa8e	e29bb438-fafd-46c8-a28d-c4bfe7db359c
19621b94-d422-45f2-84b1-66e8800d6288	29772378-f226-4fc8-8e01-9a87c5e43a00	eea77cb1-5d48-4158-bbf3-8e079a744986	active	14d1f443-8fc7-42d8-a730-c7747178aa8e	19621b94-d422-45f2-84b1-66e8800d6288
d889656e-d040-4c3e-a5ab-d061228988d0	29772378-f226-4fc8-8e01-9a87c5e43a00	111088ad-6b35-4bc9-82be-c74e6013cb39	active	14d1f443-8fc7-42d8-a730-c7747178aa8e	d889656e-d040-4c3e-a5ab-d061228988d0
1ca07d25-fe90-4fd0-82cb-fe2caf3b86c1	29772378-f226-4fc8-8e01-9a87c5e43a00	5306f500-62cf-4f9b-a9e4-00c2e76f9756	active	14d1f443-8fc7-42d8-a730-c7747178aa8e	1ca07d25-fe90-4fd0-82cb-fe2caf3b86c1
33c0ed5e-51de-4508-b161-25351e5e1b5d	3fabe36b-965b-498d-9b3a-0649bbbfd0a5	6e982e5e-81cf-4953-a39f-40f2fe80089a	active	6279dd25-4840-4072-ac60-e988063feae6	33c0ed5e-51de-4508-b161-25351e5e1b5d
c0fd536c-914a-4764-981d-f1364e5f5d95	3fabe36b-965b-498d-9b3a-0649bbbfd0a5	430484c2-faac-4f88-b6c5-df6d5db26382	active	6279dd25-4840-4072-ac60-e988063feae6	c0fd536c-914a-4764-981d-f1364e5f5d95
1369bf32-0649-4c54-873b-b16cf54d235d	2502f9a7-15fa-439d-8a48-f61f38cb6f55	a0da534f-3b88-4e01-bdda-f58bf9b11407	active	39219937-0939-40ca-86a8-f8493a35a337	1369bf32-0649-4c54-873b-b16cf54d235d
b4ce3c17-285d-432b-b34b-a6d4dbc8127b	2502f9a7-15fa-439d-8a48-f61f38cb6f55	cce9f9ec-ea17-43b8-bf15-5f56dbf32f20	active	39219937-0939-40ca-86a8-f8493a35a337	b4ce3c17-285d-432b-b34b-a6d4dbc8127b
40786c16-8a1d-4135-af07-30af47462fba	4276f7df-c7e9-44e1-8886-20ad41ebda0a	73da3e0a-e98a-4da2-8d17-e2559d9d1841	active	8b876446-18be-45e9-98d2-2ad4a1b1e7fa	40786c16-8a1d-4135-af07-30af47462fba
60e48d4b-970c-4825-80ef-674e24c2bc3d	f4517261-c1ee-4380-b3ad-0de5a0edc09a	73da3e0a-e98a-4da2-8d17-e2559d9d1841	active	ab96c2af-06af-4bad-8c4f-00ec10f98776	60e48d4b-970c-4825-80ef-674e24c2bc3d
98a2b51c-b515-4331-bc79-62d1f9c7e0b0	9382520e-adb5-4403-848d-5bd5ea476202	e8584566-2520-4ffc-bcf6-202169e737a7	active	df6d8a52-2f22-493d-8be5-645488c266ea	98a2b51c-b515-4331-bc79-62d1f9c7e0b0
8d6cd35c-ac64-44f5-a8e2-86ce18ec5125	9382520e-adb5-4403-848d-5bd5ea476202	fd6ac7dd-6519-4f44-a78d-486fc41579eb	active	df6d8a52-2f22-493d-8be5-645488c266ea	8d6cd35c-ac64-44f5-a8e2-86ce18ec5125
4db21954-319a-47d0-ab40-076757d0259a	9382520e-adb5-4403-848d-5bd5ea476202	665b67c7-9381-42db-85de-07f33b37217e	active	df6d8a52-2f22-493d-8be5-645488c266ea	4db21954-319a-47d0-ab40-076757d0259a
f37b4a72-b627-4889-a0ed-b7e0b49a81f1	9382520e-adb5-4403-848d-5bd5ea476202	90d603f6-c175-4a13-98b5-4692581b294c	active	9a1682ec-e74a-4539-8bc2-a4437c678515	f37b4a72-b627-4889-a0ed-b7e0b49a81f1
a704ad26-4885-44be-932a-d55a8698898f	09d5ff25-7a8a-4228-9093-bb437bb70f1a	665b67c7-9381-42db-85de-07f33b37217e	active	c0b8f3fb-e0c0-4ec9-8d66-a6604dcf12bd	a704ad26-4885-44be-932a-d55a8698898f
27327b60-bcd8-414c-8b9b-9d98f4471c06	09d5ff25-7a8a-4228-9093-bb437bb70f1a	e8584566-2520-4ffc-bcf6-202169e737a7	active	c0b8f3fb-e0c0-4ec9-8d66-a6604dcf12bd	27327b60-bcd8-414c-8b9b-9d98f4471c06
63c6996e-d703-48e4-865c-0aaacb8e6f2e	09d5ff25-7a8a-4228-9093-bb437bb70f1a	90d603f6-c175-4a13-98b5-4692581b294c	active	c0b8f3fb-e0c0-4ec9-8d66-a6604dcf12bd	63c6996e-d703-48e4-865c-0aaacb8e6f2e
084566d3-6ea9-4727-8da4-e8e4df0588c5	09d5ff25-7a8a-4228-9093-bb437bb70f1a	89f5db50-4b21-4808-a4fe-523ec4ff414c	active	c0b8f3fb-e0c0-4ec9-8d66-a6604dcf12bd	084566d3-6ea9-4727-8da4-e8e4df0588c5
461d7c36-9737-49c5-a4be-f1e487a131b3	430e39ad-4906-44ba-83bc-8f2bc6f2d039	877d5f3d-b996-4c07-8ffd-b3e3a7a42043	active	65cf3b14-0851-41dd-8891-c545d5d33b8f	461d7c36-9737-49c5-a4be-f1e487a131b3
3f2f5a8d-7fac-430e-b8b1-6ae367ededc1	430e39ad-4906-44ba-83bc-8f2bc6f2d039	665b67c7-9381-42db-85de-07f33b37217e	active	65cf3b14-0851-41dd-8891-c545d5d33b8f	3f2f5a8d-7fac-430e-b8b1-6ae367ededc1
0df77de4-a272-40f4-9fac-fdf3d89352bc	430e39ad-4906-44ba-83bc-8f2bc6f2d039	89f5db50-4b21-4808-a4fe-523ec4ff414c	active	65cf3b14-0851-41dd-8891-c545d5d33b8f	0df77de4-a272-40f4-9fac-fdf3d89352bc
be03f70b-dded-473f-a390-f2cb57413f05	430e39ad-4906-44ba-83bc-8f2bc6f2d039	90d603f6-c175-4a13-98b5-4692581b294c	active	65cf3b14-0851-41dd-8891-c545d5d33b8f	be03f70b-dded-473f-a390-f2cb57413f05
96094477-b694-4176-985b-1f676352d373	430e39ad-4906-44ba-83bc-8f2bc6f2d039	e8584566-2520-4ffc-bcf6-202169e737a7	active	65cf3b14-0851-41dd-8891-c545d5d33b8f	96094477-b694-4176-985b-1f676352d373
d5f366bf-f6da-4d88-a171-7c4aa51720a6	09d5ff25-7a8a-4228-9093-bb437bb70f1a	e2fbbd65-d33f-46a9-b1d6-2a49bd1c8497	active	f39b8053-1f8c-44b5-9f81-07236807d0ea	d5f366bf-f6da-4d88-a171-7c4aa51720a6
461d7c36-9737-49c5-a4be-f1e487a131b3	430e39ad-4906-44ba-83bc-8f2bc6f2d039	877d5f3d-b996-4c07-8ffd-b3e3a7a42043	deleted	79e83d1f-3aa6-4144-a610-76428572404a	461d7c36-9737-49c5-a4be-f1e487a131b3
acd2ba11-95e8-46c0-94ae-625ff6e424ed	430e39ad-4906-44ba-83bc-8f2bc6f2d039	e2fbbd65-d33f-46a9-b1d6-2a49bd1c8497	active	79e83d1f-3aa6-4144-a610-76428572404a	acd2ba11-95e8-46c0-94ae-625ff6e424ed
60c0a19a-ed5e-4916-8bed-645cd7f42074	48a03f6f-f8f4-4758-8672-f8ab8bd10acb	fd6ac7dd-6519-4f44-a78d-486fc41579eb	active	cbb8cf9d-1615-4a30-9c69-bcc03cae3034	60c0a19a-ed5e-4916-8bed-645cd7f42074
e9afd4d6-f497-447f-847a-523c2703a32c	48a03f6f-f8f4-4758-8672-f8ab8bd10acb	e8584566-2520-4ffc-bcf6-202169e737a7	active	cbb8cf9d-1615-4a30-9c69-bcc03cae3034	e9afd4d6-f497-447f-847a-523c2703a32c
4cd06b85-ae81-48b9-9948-79f397cda901	48a03f6f-f8f4-4758-8672-f8ab8bd10acb	90d603f6-c175-4a13-98b5-4692581b294c	active	cbb8cf9d-1615-4a30-9c69-bcc03cae3034	4cd06b85-ae81-48b9-9948-79f397cda901
eaea080a-d7b7-4d35-9fe8-33a5aed763ca	48a03f6f-f8f4-4758-8672-f8ab8bd10acb	665b67c7-9381-42db-85de-07f33b37217e	active	cbb8cf9d-1615-4a30-9c69-bcc03cae3034	eaea080a-d7b7-4d35-9fe8-33a5aed763ca
011af705-2a88-49bb-9231-34d25fc1d805	cd2385b8-fa33-4be9-82a8-9ceda07fdc75	90d603f6-c175-4a13-98b5-4692581b294c	active	0afcdd05-5c6a-4d38-8ccc-62520a9ea0ed	011af705-2a88-49bb-9231-34d25fc1d805
dd4ac5d0-4484-40b0-b0d0-fe960a7297bd	cd2385b8-fa33-4be9-82a8-9ceda07fdc75	e8584566-2520-4ffc-bcf6-202169e737a7	active	0afcdd05-5c6a-4d38-8ccc-62520a9ea0ed	dd4ac5d0-4484-40b0-b0d0-fe960a7297bd
a8c24e2b-af9d-40c9-9d91-32021f57c618	cd2385b8-fa33-4be9-82a8-9ceda07fdc75	89f5db50-4b21-4808-a4fe-523ec4ff414c	active	0afcdd05-5c6a-4d38-8ccc-62520a9ea0ed	a8c24e2b-af9d-40c9-9d91-32021f57c618
4d601975-551b-40e2-9966-d578defca71a	cd2385b8-fa33-4be9-82a8-9ceda07fdc75	0f11fb91-d0f4-41e4-8934-53c2d6a8b598	active	0afcdd05-5c6a-4d38-8ccc-62520a9ea0ed	4d601975-551b-40e2-9966-d578defca71a
bd474ab9-7eaf-4527-8b98-932c8e6e24b2	cd2385b8-fa33-4be9-82a8-9ceda07fdc75	665b67c7-9381-42db-85de-07f33b37217e	active	0afcdd05-5c6a-4d38-8ccc-62520a9ea0ed	bd474ab9-7eaf-4527-8b98-932c8e6e24b2
01c7453e-d8f0-4702-96a0-ea988dc4ae69	6c0ea5a3-dd48-4015-8f65-77d56bf54bb3	665b67c7-9381-42db-85de-07f33b37217e	active	b8bede64-bf67-44d3-8697-8261f01f9d7b	01c7453e-d8f0-4702-96a0-ea988dc4ae69
fd7247e3-549e-4ef8-ab93-6256741aa4cf	6c0ea5a3-dd48-4015-8f65-77d56bf54bb3	f5fbd7a0-64b5-4051-8780-c8b8e22f2b42	active	b8bede64-bf67-44d3-8697-8261f01f9d7b	fd7247e3-549e-4ef8-ab93-6256741aa4cf
b466f566-0315-4a2f-923a-fc476e0a1e47	6c0ea5a3-dd48-4015-8f65-77d56bf54bb3	90d603f6-c175-4a13-98b5-4692581b294c	active	b8bede64-bf67-44d3-8697-8261f01f9d7b	b466f566-0315-4a2f-923a-fc476e0a1e47
b9f7a58b-0628-4584-b599-fd7874b06011	6c0ea5a3-dd48-4015-8f65-77d56bf54bb3	e8584566-2520-4ffc-bcf6-202169e737a7	active	b8bede64-bf67-44d3-8697-8261f01f9d7b	b9f7a58b-0628-4584-b599-fd7874b06011
88774cec-9c60-4f05-9178-dda1eb8674b1	78e9e396-2ab2-4d61-9eea-fe08b840dbf9	2af7acb6-6f04-4766-b560-efd1b100596b	active	bdb5cf3d-56bf-428c-9151-2a3bb3c7669a	88774cec-9c60-4f05-9178-dda1eb8674b1
37ee845d-5043-4a38-9f8f-cf03322a44a6	78e9e396-2ab2-4d61-9eea-fe08b840dbf9	7fdbeb86-6300-4260-ac9a-4327519c6bb7	active	bdb5cf3d-56bf-428c-9151-2a3bb3c7669a	37ee845d-5043-4a38-9f8f-cf03322a44a6
bc3bc2ad-ddf2-46cd-9523-d66acb77afd2	78e9e396-2ab2-4d61-9eea-fe08b840dbf9	1d7180fa-9e9d-46a0-ad05-9ab69efc774f	active	bdb5cf3d-56bf-428c-9151-2a3bb3c7669a	bc3bc2ad-ddf2-46cd-9523-d66acb77afd2
68a7a438-1219-4830-92e4-89b7db42d52f	78e9e396-2ab2-4d61-9eea-fe08b840dbf9	6eecd056-cd48-4bba-9b38-5f18a7c98e04	active	bdb5cf3d-56bf-428c-9151-2a3bb3c7669a	68a7a438-1219-4830-92e4-89b7db42d52f
42599114-c74e-4230-acc0-4a6148f4e9c2	78e9e396-2ab2-4d61-9eea-fe08b840dbf9	1812b303-186d-4734-a4cb-1345949485d9	active	bdb5cf3d-56bf-428c-9151-2a3bb3c7669a	42599114-c74e-4230-acc0-4a6148f4e9c2
94c7e138-dba6-4c97-8faf-ee2db4a2e601	78e9e396-2ab2-4d61-9eea-fe08b840dbf9	7348e0d0-c94b-4f7e-b2ce-f79fe79f1449	active	bdb5cf3d-56bf-428c-9151-2a3bb3c7669a	94c7e138-dba6-4c97-8faf-ee2db4a2e601
2f5bed7a-4492-4f72-84b7-440e3f426365	78e9e396-2ab2-4d61-9eea-fe08b840dbf9	46caf164-0cb1-4ab1-85a7-22ba97d7b8fc	active	bdb5cf3d-56bf-428c-9151-2a3bb3c7669a	2f5bed7a-4492-4f72-84b7-440e3f426365
1c7a3bb5-cedf-4e45-a63c-478dd3d33577	78e9e396-2ab2-4d61-9eea-fe08b840dbf9	c34cb669-4bf2-4571-895f-d9dfe3f945bf	active	bdb5cf3d-56bf-428c-9151-2a3bb3c7669a	1c7a3bb5-cedf-4e45-a63c-478dd3d33577
44be4c97-f116-4c49-91ec-c91c1df3665f	78e9e396-2ab2-4d61-9eea-fe08b840dbf9	920f0530-0a9e-49c0-9978-f3d9ff3925c4	active	bdb5cf3d-56bf-428c-9151-2a3bb3c7669a	44be4c97-f116-4c49-91ec-c91c1df3665f
cffd4f73-1f86-47f2-9512-c10882514a53	30bcda76-5a1a-4369-a6f3-ed2584ad4031	4233e616-3f33-49fb-aa6c-7b54554dec19	active	ae90eec5-4c4a-4cf4-83f3-238eb3d162e7	cffd4f73-1f86-47f2-9512-c10882514a53
3121eb9c-0735-43e6-a18e-8011a463cfb5	30bcda76-5a1a-4369-a6f3-ed2584ad4031	03ff86ed-50c4-495a-9264-6680e479c1b5	active	ae90eec5-4c4a-4cf4-83f3-238eb3d162e7	3121eb9c-0735-43e6-a18e-8011a463cfb5
15e8dac4-3702-41d6-b191-651c0ca4eb0d	30bcda76-5a1a-4369-a6f3-ed2584ad4031	9cdf19fd-7d75-4e61-b6b2-0ebf17582683	active	ae90eec5-4c4a-4cf4-83f3-238eb3d162e7	15e8dac4-3702-41d6-b191-651c0ca4eb0d
88b0d909-a5c2-4ec4-9a5e-93857670b165	30bcda76-5a1a-4369-a6f3-ed2584ad4031	f31876a3-434f-4557-aa0a-dc437ee39b2d	active	ae90eec5-4c4a-4cf4-83f3-238eb3d162e7	88b0d909-a5c2-4ec4-9a5e-93857670b165
c1bd4ebc-0a02-4fea-9fee-66f29f055fb9	30bcda76-5a1a-4369-a6f3-ed2584ad4031	d2ce4bc4-45c9-47bb-8623-f22b540da0f6	active	ae90eec5-4c4a-4cf4-83f3-238eb3d162e7	c1bd4ebc-0a02-4fea-9fee-66f29f055fb9
246bd8f5-a162-469d-94d2-dc0fc37518be	30bcda76-5a1a-4369-a6f3-ed2584ad4031	f9631259-7d78-4ecf-a94d-941d769c5084	active	ea04b09e-6bcf-4718-9480-1461698f30ac	246bd8f5-a162-469d-94d2-dc0fc37518be
7be5b6a5-0337-4e7a-bef5-1207c3f51253	30bcda76-5a1a-4369-a6f3-ed2584ad4031	1d7180fa-9e9d-46a0-ad05-9ab69efc774f	active	ea04b09e-6bcf-4718-9480-1461698f30ac	7be5b6a5-0337-4e7a-bef5-1207c3f51253
3121eb9c-0735-43e6-a18e-8011a463cfb5	30bcda76-5a1a-4369-a6f3-ed2584ad4031	03ff86ed-50c4-495a-9264-6680e479c1b5	deleted	ea04b09e-6bcf-4718-9480-1461698f30ac	3121eb9c-0735-43e6-a18e-8011a463cfb5
19ac5fc3-97b8-4ba3-9d72-359d952e55f6	a8f061a9-6ba5-46df-89cd-6e65bfa28fe5	517528cf-48ce-4495-8d55-78f96cf6b13d	active	9ef4d8c5-6298-450e-8cfe-09b683b28b92	19ac5fc3-97b8-4ba3-9d72-359d952e55f6
26641102-1956-479b-a933-7769dd1c54e9	a8f061a9-6ba5-46df-89cd-6e65bfa28fe5	90d603f6-c175-4a13-98b5-4692581b294c	active	9ef4d8c5-6298-450e-8cfe-09b683b28b92	26641102-1956-479b-a933-7769dd1c54e9
61192d9e-b3b7-47a1-8464-4e37c57f75fb	a8f061a9-6ba5-46df-89cd-6e65bfa28fe5	e8a4383f-b9bf-44c2-ab85-421406a5d069	active	9ef4d8c5-6298-450e-8cfe-09b683b28b92	61192d9e-b3b7-47a1-8464-4e37c57f75fb
800b18fa-b921-4569-bbfd-b07a0425ac42	a8f061a9-6ba5-46df-89cd-6e65bfa28fe5	23f8e389-394e-45ea-b71e-fcbf0bada070	active	9ef4d8c5-6298-450e-8cfe-09b683b28b92	800b18fa-b921-4569-bbfd-b07a0425ac42
0343f2b1-8536-4ad8-8829-f5fe66187569	5c29c0cd-e773-4697-8172-ab1b075490c2	01e3a3ad-3b21-4973-a581-8c8ad9938f68	active	28169ed8-3c47-4522-a8d5-4474173aca5c	0343f2b1-8536-4ad8-8829-f5fe66187569
a337042a-56ca-4336-9264-0c0c6b7efb6e	5c29c0cd-e773-4697-8172-ab1b075490c2	7d8a923a-2a0c-406c-9c36-141a0324cb61	active	28169ed8-3c47-4522-a8d5-4474173aca5c	a337042a-56ca-4336-9264-0c0c6b7efb6e
f3dd0c52-7359-45f3-b33a-449b19c233b6	3c175c09-a896-4a88-9603-2b5ea27ef1a1	4cc6503a-742d-473e-9e6c-11624b7e8c58	active	99223c1a-1e29-42d1-8256-85f44520866f	f3dd0c52-7359-45f3-b33a-449b19c233b6
22b36c20-44a5-4c06-acea-e3f82d3bfaf3	3c175c09-a896-4a88-9603-2b5ea27ef1a1	0f248678-dc01-469e-8c34-d9c1e2c0caee	active	99223c1a-1e29-42d1-8256-85f44520866f	22b36c20-44a5-4c06-acea-e3f82d3bfaf3
765169c5-f038-40db-993b-b698786cc802	3c175c09-a896-4a88-9603-2b5ea27ef1a1	9b2a0ebd-c9d5-4c1c-bd75-41263d755c3b	active	99223c1a-1e29-42d1-8256-85f44520866f	765169c5-f038-40db-993b-b698786cc802
7505c563-3650-406d-8d66-26af1591cf7e	2364edf3-baf9-4a60-a75e-46387f235726	9b2a0ebd-c9d5-4c1c-bd75-41263d755c3b	active	2f410629-bce8-453d-bac0-fc0b1e286dce	7505c563-3650-406d-8d66-26af1591cf7e
6dee7615-f50c-48c9-94b1-a36bb02c7103	2364edf3-baf9-4a60-a75e-46387f235726	2c08add6-301e-4273-bc09-56c3cf51c00b	active	2f410629-bce8-453d-bac0-fc0b1e286dce	6dee7615-f50c-48c9-94b1-a36bb02c7103
c12c9116-0f99-400a-bd9f-0ac425d81919	624552ff-a7cd-427d-88e3-f31ec6dba89b	6a1062c8-afb6-45d3-9b3f-302d223c8943	active	440a2815-bfe0-486e-8a47-7e3a125f8c91	c12c9116-0f99-400a-bd9f-0ac425d81919
b4213149-fafb-46a3-9a79-193c2f56c0e5	624552ff-a7cd-427d-88e3-f31ec6dba89b	1b2a9770-8542-400b-b2c4-4743032a4ff2	active	440a2815-bfe0-486e-8a47-7e3a125f8c91	b4213149-fafb-46a3-9a79-193c2f56c0e5
e67d2cbf-e9ed-4b71-9f32-971417603967	624552ff-a7cd-427d-88e3-f31ec6dba89b	ad516677-fb7f-42e8-9e00-51be02bfff39	active	440a2815-bfe0-486e-8a47-7e3a125f8c91	e67d2cbf-e9ed-4b71-9f32-971417603967
f1ce3435-01bb-48a1-a9de-0e66001f71d1	4dbf7c31-5115-4700-963d-91f23f76aaa4	06483163-62aa-491a-b118-cbfa7a6fb1c9	active	e96a0ae8-1830-40ae-bdd3-7d2f25961373	f1ce3435-01bb-48a1-a9de-0e66001f71d1
1d7f11e9-78a8-492f-8d21-1a4276fa60e3	4dbf7c31-5115-4700-963d-91f23f76aaa4	1b2a9770-8542-400b-b2c4-4743032a4ff2	active	e96a0ae8-1830-40ae-bdd3-7d2f25961373	1d7f11e9-78a8-492f-8d21-1a4276fa60e3
8f5367ec-ffcc-4905-a962-de64c5bad479	8d447067-389f-4c39-ba51-63430a736df4	f8eecc43-fefb-4202-8113-cd5ce0de917c	active	9704b3e5-ce20-4be1-8a7d-d9cb211f0cf6	8f5367ec-ffcc-4905-a962-de64c5bad479
7e982f8c-38a9-41a2-adcc-6793fb1c74f0	8d447067-389f-4c39-ba51-63430a736df4	f59be7f4-6494-42a9-b21f-388930fca8cd	active	9704b3e5-ce20-4be1-8a7d-d9cb211f0cf6	7e982f8c-38a9-41a2-adcc-6793fb1c74f0
7330a697-976d-4801-900f-fe4356065d3c	641c249c-f473-4d8e-bd8e-f385157f2682	50250d17-669d-4203-b47f-41ab706120d3	active	b5adad2b-96ce-4b33-90c0-108f760a18d9	7330a697-976d-4801-900f-fe4356065d3c
9b13d911-85b1-462c-beec-87895236dc4a	641c249c-f473-4d8e-bd8e-f385157f2682	aa907186-83cf-4307-bb57-e02f3aec858f	active	b5adad2b-96ce-4b33-90c0-108f760a18d9	9b13d911-85b1-462c-beec-87895236dc4a
d24dbc6e-cc4f-46ff-96d5-30a507a406ca	0a048cd8-5468-4fcd-bd67-50675c83002d	f59be7f4-6494-42a9-b21f-388930fca8cd	active	add4fc8c-cacc-4c21-a011-10586b13504c	d24dbc6e-cc4f-46ff-96d5-30a507a406ca
04fdd4e1-c8b8-4e5e-87d6-a7defea857b6	0a048cd8-5468-4fcd-bd67-50675c83002d	cbf2c5a9-2f74-440c-ac6b-e93bdf9b3f28	active	add4fc8c-cacc-4c21-a011-10586b13504c	04fdd4e1-c8b8-4e5e-87d6-a7defea857b6
a2307a21-6294-4d86-a187-eb48a14ed989	0a048cd8-5468-4fcd-bd67-50675c83002d	1694ffba-704f-4aa0-b1c4-a4037869972d	active	add4fc8c-cacc-4c21-a011-10586b13504c	a2307a21-6294-4d86-a187-eb48a14ed989
1f606951-5f2b-4c94-acb8-16560a86f352	584d3863-eecc-4595-8a18-145ba2b213f7	c9ca84a2-f86d-4915-b3f4-48344ff4ceeb	active	bc33ab95-a7ce-4722-8c71-55da9972020d	1f606951-5f2b-4c94-acb8-16560a86f352
9fa56913-d20f-41d0-9503-f69d92ce454c	584d3863-eecc-4595-8a18-145ba2b213f7	f59be7f4-6494-42a9-b21f-388930fca8cd	active	bc33ab95-a7ce-4722-8c71-55da9972020d	9fa56913-d20f-41d0-9503-f69d92ce454c
33b1002d-2d6f-40ae-853f-582acfc38c4c	584d3863-eecc-4595-8a18-145ba2b213f7	713e34bc-6b1c-48fe-8030-c755f956251e	active	bc33ab95-a7ce-4722-8c71-55da9972020d	33b1002d-2d6f-40ae-853f-582acfc38c4c
eb5a6270-b576-4e5c-ab71-2eb4548b4e8f	529d4aba-d25d-44d6-ba1b-d6ad314d6158	f59be7f4-6494-42a9-b21f-388930fca8cd	active	95696de0-b33b-4771-b20d-9b71dff9c316	eb5a6270-b576-4e5c-ab71-2eb4548b4e8f
6a60f67f-8a20-49b0-85c3-7616e2044c44	529d4aba-d25d-44d6-ba1b-d6ad314d6158	d60df706-4b72-4f4d-9651-7cba326de6ac	active	95696de0-b33b-4771-b20d-9b71dff9c316	6a60f67f-8a20-49b0-85c3-7616e2044c44
b427f78d-1fa5-4a8d-b099-d35c88a2e23c	529d4aba-d25d-44d6-ba1b-d6ad314d6158	e921ebf0-76d3-4435-912d-f3ae9292a706	active	95696de0-b33b-4771-b20d-9b71dff9c316	b427f78d-1fa5-4a8d-b099-d35c88a2e23c
8935e03e-a2d1-4bf5-9a94-e4ab49251e52	8d7560cf-6d61-45dd-bf05-44ae257e97a4	32a67c24-0082-46fb-ad13-6329df70ac2f	active	fbd13c36-5e50-49d2-abd4-049e7e027453	8935e03e-a2d1-4bf5-9a94-e4ab49251e52
4331f816-6ae7-4b18-a835-25da1535b0ac	8d7560cf-6d61-45dd-bf05-44ae257e97a4	f59be7f4-6494-42a9-b21f-388930fca8cd	active	fbd13c36-5e50-49d2-abd4-049e7e027453	4331f816-6ae7-4b18-a835-25da1535b0ac
15082a16-3d66-4eb1-98e0-42df0a2ab5d8	02970c3a-2240-4a74-8fd3-18af09a9cd61	f59be7f4-6494-42a9-b21f-388930fca8cd	active	74d9b0ab-1a2e-4016-9f18-1afa11ead13b	15082a16-3d66-4eb1-98e0-42df0a2ab5d8
b7d4c808-2eb5-438e-be0c-360b8d1760bf	02970c3a-2240-4a74-8fd3-18af09a9cd61	4795e4e6-ad26-49af-bee3-0561571bb728	active	74d9b0ab-1a2e-4016-9f18-1afa11ead13b	b7d4c808-2eb5-438e-be0c-360b8d1760bf
0065d905-784c-4fbc-b7ae-76abf126a482	02970c3a-2240-4a74-8fd3-18af09a9cd61	896438ce-8705-4cc8-bc5b-8212b9cca4c6	active	74d9b0ab-1a2e-4016-9f18-1afa11ead13b	0065d905-784c-4fbc-b7ae-76abf126a482
6a5d10e5-3ca1-47cd-b6a3-708526a7c9b9	02970c3a-2240-4a74-8fd3-18af09a9cd61	284b86f0-43c9-4079-b62d-ec572aa48cf7	active	74d9b0ab-1a2e-4016-9f18-1afa11ead13b	6a5d10e5-3ca1-47cd-b6a3-708526a7c9b9
c4d6eb08-9f75-46ea-9d24-3c5a0306d8df	4acf41b9-9c8b-4a1e-a32e-a754abdce116	f59be7f4-6494-42a9-b21f-388930fca8cd	active	12d7a85a-8498-40e0-ae5a-24239d9c82f7	c4d6eb08-9f75-46ea-9d24-3c5a0306d8df
2d924b7c-1ec8-41d6-b75c-db89a4a0b3f9	4acf41b9-9c8b-4a1e-a32e-a754abdce116	4d699059-2886-444e-9c0b-95540ff4bf93	active	12d7a85a-8498-40e0-ae5a-24239d9c82f7	2d924b7c-1ec8-41d6-b75c-db89a4a0b3f9
fae10c5e-3f76-48f9-9a1b-001c0249b08a	4acf41b9-9c8b-4a1e-a32e-a754abdce116	b6813c1f-5d9c-474d-885d-e839f43e100e	active	12d7a85a-8498-40e0-ae5a-24239d9c82f7	fae10c5e-3f76-48f9-9a1b-001c0249b08a
9b2a328d-6e76-45dd-83ac-20ab7fcab1bd	5a3d4806-974f-4754-b6cb-65a7dfa27548	780ba1c1-34a2-4573-98f9-9a8c6661e44c	active	75cb2baa-b33b-4762-b981-b4f97364ed22	9b2a328d-6e76-45dd-83ac-20ab7fcab1bd
f517ac12-baca-4618-8e62-90fac8c2e42c	5a3d4806-974f-4754-b6cb-65a7dfa27548	896438ce-8705-4cc8-bc5b-8212b9cca4c6	active	75cb2baa-b33b-4762-b981-b4f97364ed22	f517ac12-baca-4618-8e62-90fac8c2e42c
e14031e5-9eb5-4dcf-aaf4-3ac558b14bda	5a3d4806-974f-4754-b6cb-65a7dfa27548	79a75000-387f-45e9-b858-a7766c451f00	active	75cb2baa-b33b-4762-b981-b4f97364ed22	e14031e5-9eb5-4dcf-aaf4-3ac558b14bda
88a13d1c-2ccc-4a37-b1f9-5a4298b2c723	5a3d4806-974f-4754-b6cb-65a7dfa27548	f59be7f4-6494-42a9-b21f-388930fca8cd	active	75cb2baa-b33b-4762-b981-b4f97364ed22	88a13d1c-2ccc-4a37-b1f9-5a4298b2c723
6a2144ec-fa7d-4e64-837c-92a7a737959c	9db98dbb-0a64-4588-8e57-533f05a6e050	48b28754-6373-4a72-a431-654bf4e5d58e	active	33125ba6-51d0-49db-88f0-d15ab1cfbb0e	6a2144ec-fa7d-4e64-837c-92a7a737959c
22cf0b2a-bbd5-446f-b579-0fbe68151f71	9db98dbb-0a64-4588-8e57-533f05a6e050	f59be7f4-6494-42a9-b21f-388930fca8cd	active	33125ba6-51d0-49db-88f0-d15ab1cfbb0e	22cf0b2a-bbd5-446f-b579-0fbe68151f71
bf1a4b7d-dd1b-44c5-be0a-21381e8201cc	205c33b6-106f-40c3-804c-a2835f6104a9	f59be7f4-6494-42a9-b21f-388930fca8cd	active	7ffae5cf-57bd-40cf-ac63-1d66fb93e429	bf1a4b7d-dd1b-44c5-be0a-21381e8201cc
062d9607-11d3-4ffe-ae66-6800daf124a3	205c33b6-106f-40c3-804c-a2835f6104a9	5c72b096-cb94-4c1d-a976-3822e2690dc7	active	7ffae5cf-57bd-40cf-ac63-1d66fb93e429	062d9607-11d3-4ffe-ae66-6800daf124a3
27cd3fe7-4661-469d-8e0f-e159a841f44a	f7a32926-f029-47f4-8649-e3b2997f69d3	4462f385-b858-4c8f-8088-7fd85b9c9537	active	a945bf8f-ad7d-43e1-9374-bacf83b24c8b	27cd3fe7-4661-469d-8e0f-e159a841f44a
88c916a2-bc7c-4a1a-80af-4f2289151281	f7a32926-f029-47f4-8649-e3b2997f69d3	f59be7f4-6494-42a9-b21f-388930fca8cd	active	a945bf8f-ad7d-43e1-9374-bacf83b24c8b	88c916a2-bc7c-4a1a-80af-4f2289151281
4e795149-5b50-4e14-ba22-b02338082d3f	f7a32926-f029-47f4-8649-e3b2997f69d3	ae3a5e55-cbfd-45cc-adbd-1d4e74add7d9	active	a945bf8f-ad7d-43e1-9374-bacf83b24c8b	4e795149-5b50-4e14-ba22-b02338082d3f
04887173-fbbd-4604-a557-59a826ff2425	ced8947c-7c6b-4874-ad5e-c28ba91f8073	23c37819-576e-4ad0-bca6-2667137bfe99	active	2eb6042c-7740-4c4f-b636-76ce8ce6a357	04887173-fbbd-4604-a557-59a826ff2425
b16b4987-6d06-4019-892b-fc0d9919107c	ced8947c-7c6b-4874-ad5e-c28ba91f8073	f59be7f4-6494-42a9-b21f-388930fca8cd	active	2eb6042c-7740-4c4f-b636-76ce8ce6a357	b16b4987-6d06-4019-892b-fc0d9919107c
84d88583-e649-4118-a058-e9b8ff2a7d8b	ced8947c-7c6b-4874-ad5e-c28ba91f8073	4d699059-2886-444e-9c0b-95540ff4bf93	active	2eb6042c-7740-4c4f-b636-76ce8ce6a357	84d88583-e649-4118-a058-e9b8ff2a7d8b
3522fdb1-f155-4a8f-a4dd-6aa8ad2137f0	b9582bd1-bfff-41e1-990f-962c18084f4d	f59be7f4-6494-42a9-b21f-388930fca8cd	active	9bdd4aa6-2e18-4e58-8914-1c4adf1b8916	3522fdb1-f155-4a8f-a4dd-6aa8ad2137f0
1aeecfbb-c4e7-4dd0-9c79-4fb306ec4c74	b9582bd1-bfff-41e1-990f-962c18084f4d	7b407771-8e80-41ab-9223-8cafa6fa4ba4	active	9bdd4aa6-2e18-4e58-8914-1c4adf1b8916	1aeecfbb-c4e7-4dd0-9c79-4fb306ec4c74
e6780945-ea9c-426b-84c5-b1af3655f240	b9582bd1-bfff-41e1-990f-962c18084f4d	7d11d541-24f7-45fa-b2b7-0c8c663426a5	active	9bdd4aa6-2e18-4e58-8914-1c4adf1b8916	e6780945-ea9c-426b-84c5-b1af3655f240
44655d81-4036-4221-a9fb-2467ab2cf45e	1c17435c-508d-4194-9d06-f923d31c60cf	f59be7f4-6494-42a9-b21f-388930fca8cd	active	1504af47-63ff-4fbf-b415-13f245e3530f	44655d81-4036-4221-a9fb-2467ab2cf45e
cbd6ce82-8c94-4309-a141-c2c6261f260c	1c17435c-508d-4194-9d06-f923d31c60cf	844950d1-bc39-4374-aa5e-3228164fd656	active	1504af47-63ff-4fbf-b415-13f245e3530f	cbd6ce82-8c94-4309-a141-c2c6261f260c
8c4c9c09-14a8-4ff5-ba7f-78d7e8873c6d	e3623259-d93b-4596-930a-0282a07b5666	15932183-9b6f-4cd9-b180-351824d71d96	active	f29df221-7759-4fe2-bf70-c1c0f0f4d049	8c4c9c09-14a8-4ff5-ba7f-78d7e8873c6d
94f85963-9039-4bb5-890d-cb589007ca8c	b57f2ed1-ee10-469b-afcc-a4d7636d39c7	c1faa2e7-035c-47d1-9d35-cc497728b8d6	active	b349135d-a405-4e84-a347-9acbd6b9c0a5	94f85963-9039-4bb5-890d-cb589007ca8c
656b2889-1ccb-4802-8095-d3ad2678f311	b57f2ed1-ee10-469b-afcc-a4d7636d39c7	f59be7f4-6494-42a9-b21f-388930fca8cd	active	b349135d-a405-4e84-a347-9acbd6b9c0a5	656b2889-1ccb-4802-8095-d3ad2678f311
33c8d761-f54d-446e-9dc2-7b8debbebfbb	f22a7938-303f-4ac6-92da-526a4ad2a207	f1cfeeff-4ba7-4172-ba51-550d8183db28	active	5f4eb519-36a4-444a-bed2-c545d3f4d20b	33c8d761-f54d-446e-9dc2-7b8debbebfbb
b704dcc6-61a2-4d87-9ae5-874100dbafde	f22a7938-303f-4ac6-92da-526a4ad2a207	27eecd38-da7f-437c-aa78-e0468be5b594	active	5f4eb519-36a4-444a-bed2-c545d3f4d20b	b704dcc6-61a2-4d87-9ae5-874100dbafde
7dc75136-1eaf-4f0b-819e-2da37e1e916d	b99894af-7866-4a81-beee-30e0e384b708	27eecd38-da7f-437c-aa78-e0468be5b594	active	b87e9ad0-7f68-473d-a15b-64ca1f253bfc	7dc75136-1eaf-4f0b-819e-2da37e1e916d
79b5708e-fe89-4cff-9f96-1117ad5b36b2	b99894af-7866-4a81-beee-30e0e384b708	f59be7f4-6494-42a9-b21f-388930fca8cd	active	b87e9ad0-7f68-473d-a15b-64ca1f253bfc	79b5708e-fe89-4cff-9f96-1117ad5b36b2
a76189a3-342a-4665-9eeb-547bd691d85e	b99894af-7866-4a81-beee-30e0e384b708	c6152eae-a552-4cc0-8b5e-a0c72a6987b0	active	b87e9ad0-7f68-473d-a15b-64ca1f253bfc	a76189a3-342a-4665-9eeb-547bd691d85e
7ee11be3-5b19-4d6b-ad56-76871e549011	3d4e64cc-54c0-4b3e-b865-2fff3d9845e7	c6152eae-a552-4cc0-8b5e-a0c72a6987b0	active	117f797d-1662-4d4f-8779-08a5af2ca1aa	7ee11be3-5b19-4d6b-ad56-76871e549011
51d70922-bb25-49d6-a02d-6fc71ad81589	3d4e64cc-54c0-4b3e-b865-2fff3d9845e7	27eecd38-da7f-437c-aa78-e0468be5b594	active	117f797d-1662-4d4f-8779-08a5af2ca1aa	51d70922-bb25-49d6-a02d-6fc71ad81589
1378a69e-4b01-4d40-8dcd-8c68862f0db6	3d4e64cc-54c0-4b3e-b865-2fff3d9845e7	f59be7f4-6494-42a9-b21f-388930fca8cd	active	117f797d-1662-4d4f-8779-08a5af2ca1aa	1378a69e-4b01-4d40-8dcd-8c68862f0db6
f2438ce5-8bf4-45f7-8ea9-ca9c0d84a13e	83e56067-9ee5-48b2-83d0-91e723eb8b3d	713e34bc-6b1c-48fe-8030-c755f956251e	active	b5c703cf-ee4d-4b5d-b9fe-e5385976b7d9	f2438ce5-8bf4-45f7-8ea9-ca9c0d84a13e
35734760-1f8d-4d3a-af90-45a4eac89e2d	83e56067-9ee5-48b2-83d0-91e723eb8b3d	59fc41c4-2a4d-459b-b489-54ad20f26fe7	active	b5c703cf-ee4d-4b5d-b9fe-e5385976b7d9	35734760-1f8d-4d3a-af90-45a4eac89e2d
46b46082-3b31-4527-82ca-6dad2e812625	83e56067-9ee5-48b2-83d0-91e723eb8b3d	ef2f172c-e71a-497a-8373-56c47d9cbe5a	active	b5c703cf-ee4d-4b5d-b9fe-e5385976b7d9	46b46082-3b31-4527-82ca-6dad2e812625
76e079d8-cd7c-4a5c-822a-bed23f5befad	e1b56ce2-aea6-4d44-b877-86a13f92697c	f59be7f4-6494-42a9-b21f-388930fca8cd	active	b4a1d15b-e861-453a-a288-467e743dd51b	76e079d8-cd7c-4a5c-822a-bed23f5befad
83558327-9d1d-4dac-99ef-9d3d18516def	e1b56ce2-aea6-4d44-b877-86a13f92697c	59fc41c4-2a4d-459b-b489-54ad20f26fe7	active	b4a1d15b-e861-453a-a288-467e743dd51b	83558327-9d1d-4dac-99ef-9d3d18516def
42c11b44-9b1c-4de1-9445-61c61c55b1c9	e1b56ce2-aea6-4d44-b877-86a13f92697c	713e34bc-6b1c-48fe-8030-c755f956251e	active	b4a1d15b-e861-453a-a288-467e743dd51b	42c11b44-9b1c-4de1-9445-61c61c55b1c9
117d45e3-10fd-4ecd-99ff-e9e1fd5d3e41	d6c6d3f9-5d8d-46c8-bc92-d8507d1e6f04	5315cfeb-aa6e-49e1-b42f-12daed6ad2fa	active	a7e3dd94-6c86-413f-abfe-3bed55bf9d85	117d45e3-10fd-4ecd-99ff-e9e1fd5d3e41
414ffeb3-f96e-4624-8fb9-133dd5467c92	d6c6d3f9-5d8d-46c8-bc92-d8507d1e6f04	f59be7f4-6494-42a9-b21f-388930fca8cd	active	a7e3dd94-6c86-413f-abfe-3bed55bf9d85	414ffeb3-f96e-4624-8fb9-133dd5467c92
6b57f9a0-d2f9-4e2a-aa9c-4d97f16f6677	d6c6d3f9-5d8d-46c8-bc92-d8507d1e6f04	91dea717-03c4-4fbb-81e0-07bfdc3ec10d	active	a7e3dd94-6c86-413f-abfe-3bed55bf9d85	6b57f9a0-d2f9-4e2a-aa9c-4d97f16f6677
363b37c1-e91e-42dd-b7d5-69396e195f48	d6c6d3f9-5d8d-46c8-bc92-d8507d1e6f04	55546b47-fe3c-40bc-acc9-f78d285d9f13	active	a7e3dd94-6c86-413f-abfe-3bed55bf9d85	363b37c1-e91e-42dd-b7d5-69396e195f48
841c4aec-47f3-4b88-8449-3709edae73a3	8a7d516b-f3c2-4a5b-afde-d2bdff371937	f59be7f4-6494-42a9-b21f-388930fca8cd	active	ce9bcc80-ad33-4db0-82d4-fb3cab033fd5	841c4aec-47f3-4b88-8449-3709edae73a3
f342ac86-fb21-47da-b18d-5d3a380e9d8a	8a7d516b-f3c2-4a5b-afde-d2bdff371937	5315cfeb-aa6e-49e1-b42f-12daed6ad2fa	active	ce9bcc80-ad33-4db0-82d4-fb3cab033fd5	f342ac86-fb21-47da-b18d-5d3a380e9d8a
447315df-c5c8-4697-808c-7f556af764c8	8a7d516b-f3c2-4a5b-afde-d2bdff371937	b8d19818-8529-4dce-9f46-12035ac43098	active	ce9bcc80-ad33-4db0-82d4-fb3cab033fd5	447315df-c5c8-4697-808c-7f556af764c8
310d31bc-18c6-468f-a63a-d81b9c47558c	fe7cd753-376f-4f22-a721-caa482aa1116	3a1a6c2d-976e-41a2-a797-3e59b8165ebd	active	34579160-706c-4b4e-86e7-1deddb37f9e0	310d31bc-18c6-468f-a63a-d81b9c47558c
37c00005-d6cb-4fad-a94b-3f2736e86244	fe7cd753-376f-4f22-a721-caa482aa1116	8de57ce1-e9cd-4eb3-8432-64aba816c41d	active	34579160-706c-4b4e-86e7-1deddb37f9e0	37c00005-d6cb-4fad-a94b-3f2736e86244
65b03e32-4fdb-408e-914f-1b573349dc75	fe7cd753-376f-4f22-a721-caa482aa1116	df234aea-eb2b-4510-ac40-53b599633686	active	34579160-706c-4b4e-86e7-1deddb37f9e0	65b03e32-4fdb-408e-914f-1b573349dc75
6fbd44e5-769c-4b7e-a909-1d38c35ca9c0	fe7cd753-376f-4f22-a721-caa482aa1116	ccb3fac5-0925-43b0-8ca8-5a797a6bc18f	active	34579160-706c-4b4e-86e7-1deddb37f9e0	6fbd44e5-769c-4b7e-a909-1d38c35ca9c0
d5318895-140d-4ca5-bde5-1bc038e460ec	fe7cd753-376f-4f22-a721-caa482aa1116	f59be7f4-6494-42a9-b21f-388930fca8cd	active	34579160-706c-4b4e-86e7-1deddb37f9e0	d5318895-140d-4ca5-bde5-1bc038e460ec
ea783b65-b09f-42f1-a585-840ba1491d0b	60e23204-8e78-487c-92bd-5de0c6102067	7ef1856f-5ec1-4c92-aebd-9ec3e4bb78e3	active	9072590d-3b6f-4ac1-89d3-0751de5632a7	ea783b65-b09f-42f1-a585-840ba1491d0b
740e3aa4-ec65-410f-acf8-5082eaa26f22	60e23204-8e78-487c-92bd-5de0c6102067	f59be7f4-6494-42a9-b21f-388930fca8cd	active	9072590d-3b6f-4ac1-89d3-0751de5632a7	740e3aa4-ec65-410f-acf8-5082eaa26f22
e71787b8-649d-41e3-bbbc-a8658666c08d	60e23204-8e78-487c-92bd-5de0c6102067	aa907186-83cf-4307-bb57-e02f3aec858f	active	9072590d-3b6f-4ac1-89d3-0751de5632a7	e71787b8-649d-41e3-bbbc-a8658666c08d
280e25eb-98a2-40f6-be3d-47dd514c5dea	4654898f-58f4-482f-a91f-23aa5e192fd8	f59be7f4-6494-42a9-b21f-388930fca8cd	active	2d7fa951-5b6e-494f-ad7e-a7afcea2cd4f	280e25eb-98a2-40f6-be3d-47dd514c5dea
fd8f6f19-0e67-4a63-9932-0e69e2a80303	4654898f-58f4-482f-a91f-23aa5e192fd8	27eecd38-da7f-437c-aa78-e0468be5b594	active	2d7fa951-5b6e-494f-ad7e-a7afcea2cd4f	fd8f6f19-0e67-4a63-9932-0e69e2a80303
cffe6c61-b7f5-491a-99c5-8771908a4788	4654898f-58f4-482f-a91f-23aa5e192fd8	c6152eae-a552-4cc0-8b5e-a0c72a6987b0	active	2d7fa951-5b6e-494f-ad7e-a7afcea2cd4f	cffe6c61-b7f5-491a-99c5-8771908a4788
cc523ea9-8432-4937-8af6-10079435016e	20100c39-31ae-4fd4-ad35-bfeabe396b5f	f49977cb-1a77-436c-bfb1-02844992933f	active	12caea82-db74-4ffa-b7ed-c149e2352e9a	cc523ea9-8432-4937-8af6-10079435016e
77bc4616-63ec-492d-9d70-8fc95efb7369	20100c39-31ae-4fd4-ad35-bfeabe396b5f	23f8e389-394e-45ea-b71e-fcbf0bada070	active	12caea82-db74-4ffa-b7ed-c149e2352e9a	77bc4616-63ec-492d-9d70-8fc95efb7369
53b35c4b-55da-4a85-b068-5b6232d05403	20100c39-31ae-4fd4-ad35-bfeabe396b5f	90d603f6-c175-4a13-98b5-4692581b294c	active	12caea82-db74-4ffa-b7ed-c149e2352e9a	53b35c4b-55da-4a85-b068-5b6232d05403
d3169837-850b-41af-8d1a-6e0b7bdd7cb2	497e8d74-14c2-401e-bc0d-a4b473f77eb1	67067ff6-231d-4cb0-bf1c-53d232693248	active	fc63ab3d-50cd-4753-9ff3-12aa14ce6692	d3169837-850b-41af-8d1a-6e0b7bdd7cb2
24d95415-43fd-4273-a369-a0d41771b83a	497e8d74-14c2-401e-bc0d-a4b473f77eb1	0fa92041-ce27-4e68-b3d3-c9b43f3c6de6	active	fc63ab3d-50cd-4753-9ff3-12aa14ce6692	24d95415-43fd-4273-a369-a0d41771b83a
30dce56a-08d9-48ed-a778-3474e0fd59e1	497e8d74-14c2-401e-bc0d-a4b473f77eb1	3ac4b1c0-ef85-4a8a-978d-790935bf856a	active	fc63ab3d-50cd-4753-9ff3-12aa14ce6692	30dce56a-08d9-48ed-a778-3474e0fd59e1
0401285a-82e4-4b1c-8511-a1aaed0c387a	497e8d74-14c2-401e-bc0d-a4b473f77eb1	62cec790-8fe7-401a-8a14-25854875fc87	active	fc63ab3d-50cd-4753-9ff3-12aa14ce6692	0401285a-82e4-4b1c-8511-a1aaed0c387a
909719c7-27da-4b62-aa34-dfd9874d8b44	497e8d74-14c2-401e-bc0d-a4b473f77eb1	b746c869-367e-4517-8cb6-8e8fff168bcf	active	fc63ab3d-50cd-4753-9ff3-12aa14ce6692	909719c7-27da-4b62-aa34-dfd9874d8b44
48bfcc71-8f01-47fd-930e-0e2cb8c95909	1cf46091-d128-4e38-a7b7-97901d423aaf	5667cc10-9e4c-4a5c-9b5f-a1270ec087f5	active	66b128d0-c36c-48b8-a78a-92b6182586d1	48bfcc71-8f01-47fd-930e-0e2cb8c95909
aa54be22-3284-4e4f-94bd-c61642754d6d	1cf46091-d128-4e38-a7b7-97901d423aaf	a1240961-70a8-4405-8f9d-1f883f120a87	active	66b128d0-c36c-48b8-a78a-92b6182586d1	aa54be22-3284-4e4f-94bd-c61642754d6d
b933fa8b-f141-444c-90b6-d95ec13d71e7	1cf46091-d128-4e38-a7b7-97901d423aaf	f00b6c16-7867-409b-8439-4e50dd7f12e1	active	66b128d0-c36c-48b8-a78a-92b6182586d1	b933fa8b-f141-444c-90b6-d95ec13d71e7
bf3755de-80a5-497e-9f65-f6adf1414c65	1cf46091-d128-4e38-a7b7-97901d423aaf	15bbdb5e-f0f9-4749-bc70-9d3ecd9d4f62	active	66b128d0-c36c-48b8-a78a-92b6182586d1	bf3755de-80a5-497e-9f65-f6adf1414c65
49b69ec5-90fb-4a7a-8347-6d96afaeef68	1cf46091-d128-4e38-a7b7-97901d423aaf	473f15dd-47c0-40a6-89e9-3a053ab172a4	active	66b128d0-c36c-48b8-a78a-92b6182586d1	49b69ec5-90fb-4a7a-8347-6d96afaeef68
b78c9b4a-396c-40db-b7db-4ec987f4c85e	ece794a5-613f-4607-9046-fb37906f87ce	896438ce-8705-4cc8-bc5b-8212b9cca4c6	active	1cc6d560-7a4a-4505-81e8-290e440c9c0b	b78c9b4a-396c-40db-b7db-4ec987f4c85e
06c79ad3-91a9-425c-8137-278685f9ea60	ece794a5-613f-4607-9046-fb37906f87ce	f1214aeb-9ad3-4e93-b298-2c6618a02f7e	active	1cc6d560-7a4a-4505-81e8-290e440c9c0b	06c79ad3-91a9-425c-8137-278685f9ea60
b5951999-b2f8-49c9-9461-03857afcdcc6	ece794a5-613f-4607-9046-fb37906f87ce	3060b98a-0207-404a-b5a4-96e8e6885767	active	1cc6d560-7a4a-4505-81e8-290e440c9c0b	b5951999-b2f8-49c9-9461-03857afcdcc6
91594332-e472-4f78-829d-ed696c483d8a	ece794a5-613f-4607-9046-fb37906f87ce	41ccd9ba-7563-4db6-a0a2-31e93dbf21c5	active	1cc6d560-7a4a-4505-81e8-290e440c9c0b	91594332-e472-4f78-829d-ed696c483d8a
4080f62e-cbf6-43e4-8ddc-68fa3bf7bb06	ece794a5-613f-4607-9046-fb37906f87ce	59177438-4307-4673-b274-0963552ee8b7	active	1cc6d560-7a4a-4505-81e8-290e440c9c0b	4080f62e-cbf6-43e4-8ddc-68fa3bf7bb06
7a82c38a-e38b-4f65-a71c-79544102167e	ece794a5-613f-4607-9046-fb37906f87ce	705d6aed-b1d5-4b89-ad38-be4a1daba35d	active	1cc6d560-7a4a-4505-81e8-290e440c9c0b	7a82c38a-e38b-4f65-a71c-79544102167e
b86bcd87-92e8-4232-9cfd-62e52299a386	ece794a5-613f-4607-9046-fb37906f87ce	dbdc596b-44c1-42c5-8116-f7d1968cbf13	active	1cc6d560-7a4a-4505-81e8-290e440c9c0b	b86bcd87-92e8-4232-9cfd-62e52299a386
a651c708-845b-4a46-bc59-45e37dfb5070	d794f07a-06d3-4b59-a969-c00af70ff8db	59177438-4307-4673-b274-0963552ee8b7	active	5ec1bdc2-fcbf-4932-b6a6-247c87ed9377	a651c708-845b-4a46-bc59-45e37dfb5070
20754bc2-562c-43e0-96ef-66f6814f9598	d794f07a-06d3-4b59-a969-c00af70ff8db	3060b98a-0207-404a-b5a4-96e8e6885767	active	5ec1bdc2-fcbf-4932-b6a6-247c87ed9377	20754bc2-562c-43e0-96ef-66f6814f9598
98c31b41-9727-4b3b-bc35-dce772f915fc	d794f07a-06d3-4b59-a969-c00af70ff8db	f1214aeb-9ad3-4e93-b298-2c6618a02f7e	active	5ec1bdc2-fcbf-4932-b6a6-247c87ed9377	98c31b41-9727-4b3b-bc35-dce772f915fc
09488764-6ff1-424c-864c-f2b61bb0c06b	d794f07a-06d3-4b59-a969-c00af70ff8db	896438ce-8705-4cc8-bc5b-8212b9cca4c6	active	5ec1bdc2-fcbf-4932-b6a6-247c87ed9377	09488764-6ff1-424c-864c-f2b61bb0c06b
25fba1e6-59c8-4129-8a73-030f9dc6ccb3	d794f07a-06d3-4b59-a969-c00af70ff8db	41ccd9ba-7563-4db6-a0a2-31e93dbf21c5	active	5ec1bdc2-fcbf-4932-b6a6-247c87ed9377	25fba1e6-59c8-4129-8a73-030f9dc6ccb3
f991dc6d-50f2-4e07-a810-e183a5d60a9d	d794f07a-06d3-4b59-a969-c00af70ff8db	705d6aed-b1d5-4b89-ad38-be4a1daba35d	active	5ec1bdc2-fcbf-4932-b6a6-247c87ed9377	f991dc6d-50f2-4e07-a810-e183a5d60a9d
10f6e9fb-511b-451d-8eec-171516743cc6	d794f07a-06d3-4b59-a969-c00af70ff8db	dbdc596b-44c1-42c5-8116-f7d1968cbf13	active	5ec1bdc2-fcbf-4932-b6a6-247c87ed9377	10f6e9fb-511b-451d-8eec-171516743cc6
1682f9e2-7f41-4d67-a070-cb43f049d0cc	5efedd90-782d-4129-8e71-fdd3b6e1c7df	705d6aed-b1d5-4b89-ad38-be4a1daba35d	active	195959a3-77de-4e3d-95e4-8c5989ddd65d	1682f9e2-7f41-4d67-a070-cb43f049d0cc
af6d0b94-148c-4199-8e58-d83b56687dbe	5efedd90-782d-4129-8e71-fdd3b6e1c7df	dbdc596b-44c1-42c5-8116-f7d1968cbf13	active	195959a3-77de-4e3d-95e4-8c5989ddd65d	af6d0b94-148c-4199-8e58-d83b56687dbe
a93022ac-1b23-4839-b89d-931d7550b7c9	5efedd90-782d-4129-8e71-fdd3b6e1c7df	3060b98a-0207-404a-b5a4-96e8e6885767	active	195959a3-77de-4e3d-95e4-8c5989ddd65d	a93022ac-1b23-4839-b89d-931d7550b7c9
e8113246-f746-4e57-b3d6-c3f3783cb31d	5efedd90-782d-4129-8e71-fdd3b6e1c7df	59177438-4307-4673-b274-0963552ee8b7	active	195959a3-77de-4e3d-95e4-8c5989ddd65d	e8113246-f746-4e57-b3d6-c3f3783cb31d
c1f5fcde-eabb-4250-b617-1a65d1598864	5efedd90-782d-4129-8e71-fdd3b6e1c7df	896438ce-8705-4cc8-bc5b-8212b9cca4c6	active	195959a3-77de-4e3d-95e4-8c5989ddd65d	c1f5fcde-eabb-4250-b617-1a65d1598864
958dee35-44ce-4aca-bb08-01445d8b853b	5efedd90-782d-4129-8e71-fdd3b6e1c7df	41ccd9ba-7563-4db6-a0a2-31e93dbf21c5	active	195959a3-77de-4e3d-95e4-8c5989ddd65d	958dee35-44ce-4aca-bb08-01445d8b853b
fc288d85-b987-4db0-948e-e94efba97d95	5efedd90-782d-4129-8e71-fdd3b6e1c7df	f1214aeb-9ad3-4e93-b298-2c6618a02f7e	active	195959a3-77de-4e3d-95e4-8c5989ddd65d	fc288d85-b987-4db0-948e-e94efba97d95
e1ce66e2-eb55-4b82-931b-145ec39d7024	f1261a91-9d52-4520-837e-e9c793f28dcc	59177438-4307-4673-b274-0963552ee8b7	active	df459aea-8e94-463f-835f-cdcd6ec1327c	e1ce66e2-eb55-4b82-931b-145ec39d7024
ee3fbabb-1c04-4e9f-9c41-cef1f7929011	f1261a91-9d52-4520-837e-e9c793f28dcc	41ccd9ba-7563-4db6-a0a2-31e93dbf21c5	active	df459aea-8e94-463f-835f-cdcd6ec1327c	ee3fbabb-1c04-4e9f-9c41-cef1f7929011
1d8cf078-165e-41ef-95cf-e8aee9687af3	f1261a91-9d52-4520-837e-e9c793f28dcc	705d6aed-b1d5-4b89-ad38-be4a1daba35d	active	df459aea-8e94-463f-835f-cdcd6ec1327c	1d8cf078-165e-41ef-95cf-e8aee9687af3
a64d7da3-de28-4e08-83cf-f295b9116906	f1261a91-9d52-4520-837e-e9c793f28dcc	3060b98a-0207-404a-b5a4-96e8e6885767	active	df459aea-8e94-463f-835f-cdcd6ec1327c	a64d7da3-de28-4e08-83cf-f295b9116906
2eb342c8-d136-42b7-b48f-b05e1ad9cf38	f1261a91-9d52-4520-837e-e9c793f28dcc	896438ce-8705-4cc8-bc5b-8212b9cca4c6	active	df459aea-8e94-463f-835f-cdcd6ec1327c	2eb342c8-d136-42b7-b48f-b05e1ad9cf38
3e6d989d-94ee-4ce0-b0bc-25b6191540c3	f1261a91-9d52-4520-837e-e9c793f28dcc	dbdc596b-44c1-42c5-8116-f7d1968cbf13	active	df459aea-8e94-463f-835f-cdcd6ec1327c	3e6d989d-94ee-4ce0-b0bc-25b6191540c3
c6fe6976-7471-4bce-ab39-0ca475bb46d7	f1261a91-9d52-4520-837e-e9c793f28dcc	f1214aeb-9ad3-4e93-b298-2c6618a02f7e	active	df459aea-8e94-463f-835f-cdcd6ec1327c	c6fe6976-7471-4bce-ab39-0ca475bb46d7
d328989f-3089-4364-90e1-0453efca3b4e	df63f81c-7a27-49d1-86c8-8d5e49883d40	ee1bf582-8672-4f86-a84e-c958ff2e7205	active	0f7316bd-5b12-443c-b846-ea48cd376a1c	d328989f-3089-4364-90e1-0453efca3b4e
52a76871-e1d1-4515-9d86-7cf6ebb794f2	df63f81c-7a27-49d1-86c8-8d5e49883d40	5fe1c7b0-f733-44c4-abcf-04659911d91a	active	0f7316bd-5b12-443c-b846-ea48cd376a1c	52a76871-e1d1-4515-9d86-7cf6ebb794f2
16914a20-1a9d-474d-bddf-6ae67c723bba	df63f81c-7a27-49d1-86c8-8d5e49883d40	2b55a614-018b-47c8-a07c-8acc2071a433	active	0f7316bd-5b12-443c-b846-ea48cd376a1c	16914a20-1a9d-474d-bddf-6ae67c723bba
ec8bc2f6-39e0-4d85-b823-f1fd3187b546	8d9cf757-de83-4774-919b-00c45c43efd4	071a3720-55dd-4638-a31f-40762c38b6e5	active	657e1e1a-5a1b-40d4-b09c-61db5208662f	ec8bc2f6-39e0-4d85-b823-f1fd3187b546
71f02ccc-b5a7-4f6f-844b-2d68a0c61e7a	8d9cf757-de83-4774-919b-00c45c43efd4	edaea925-2eef-4da8-a393-faf910b4314f	active	657e1e1a-5a1b-40d4-b09c-61db5208662f	71f02ccc-b5a7-4f6f-844b-2d68a0c61e7a
a2130704-dfae-47d3-815a-3c1f78781550	8d9cf757-de83-4774-919b-00c45c43efd4	a0da534f-3b88-4e01-bdda-f58bf9b11407	active	657e1e1a-5a1b-40d4-b09c-61db5208662f	a2130704-dfae-47d3-815a-3c1f78781550
10a25fe6-d1e3-4da6-8058-7f70a4b6d49e	196340e0-5246-4bc2-8b69-54c66a48b399	d057758e-a4a2-4125-82bd-83b96a2136da	active	1220be1d-b2b7-491a-a02a-708eb1f990d7	10a25fe6-d1e3-4da6-8058-7f70a4b6d49e
f4b3a37a-daa2-48fe-b5db-8fb1a3c9b46b	196340e0-5246-4bc2-8b69-54c66a48b399	5124b3b1-4ada-47c7-863d-db4e72b65371	active	1220be1d-b2b7-491a-a02a-708eb1f990d7	f4b3a37a-daa2-48fe-b5db-8fb1a3c9b46b
fd72b1ca-544b-4ec8-8f97-fb2f2fb1f6d9	196340e0-5246-4bc2-8b69-54c66a48b399	5bd30510-2edd-446a-bb97-091a5179e92d	active	1220be1d-b2b7-491a-a02a-708eb1f990d7	fd72b1ca-544b-4ec8-8f97-fb2f2fb1f6d9
90a45f6c-1177-4f12-8dae-40fa8f4a7170	196340e0-5246-4bc2-8b69-54c66a48b399	27eecd38-da7f-437c-aa78-e0468be5b594	active	1220be1d-b2b7-491a-a02a-708eb1f990d7	90a45f6c-1177-4f12-8dae-40fa8f4a7170
390dd4fc-e438-4850-b85c-d8d7df7c5cb4	196340e0-5246-4bc2-8b69-54c66a48b399	2d518686-9f62-426f-9a2b-1b2fc94b90e4	active	1220be1d-b2b7-491a-a02a-708eb1f990d7	390dd4fc-e438-4850-b85c-d8d7df7c5cb4
46433feb-eb27-41dc-9546-12dbe9d9bde1	196340e0-5246-4bc2-8b69-54c66a48b399	3b95f7ef-56e7-4d11-aa64-0c078a4ba24c	active	1220be1d-b2b7-491a-a02a-708eb1f990d7	46433feb-eb27-41dc-9546-12dbe9d9bde1
30f45143-0e9b-492c-8157-5efab4d9317d	196340e0-5246-4bc2-8b69-54c66a48b399	4007f503-7979-4147-98de-2c29348abc43	active	1220be1d-b2b7-491a-a02a-708eb1f990d7	30f45143-0e9b-492c-8157-5efab4d9317d
04d3a5e6-f4fe-466d-91da-f90698a36372	196340e0-5246-4bc2-8b69-54c66a48b399	f73dd96b-0c6a-4d09-bd4a-313fe368ddbe	active	1220be1d-b2b7-491a-a02a-708eb1f990d7	04d3a5e6-f4fe-466d-91da-f90698a36372
e0834d40-e60a-4de8-a7ab-f6bd8a664bb9	196340e0-5246-4bc2-8b69-54c66a48b399	3c7cf1a0-26ba-4460-bdf0-f282b2964c02	active	1220be1d-b2b7-491a-a02a-708eb1f990d7	e0834d40-e60a-4de8-a7ab-f6bd8a664bb9
7c877b38-4241-4df2-be92-4189a0848f6a	7f6c30c6-d6a5-4d39-ae5d-e1ae4cc2d3ef	a75a070f-44a9-4a8d-8818-368ed36a895d	active	daf6450f-138d-42d9-acc4-c2f02339def3	7c877b38-4241-4df2-be92-4189a0848f6a
48c348a8-f38d-46ab-ab38-7435f80706f6	7f6c30c6-d6a5-4d39-ae5d-e1ae4cc2d3ef	44b7a7ef-c7f5-4f0e-bfe9-066ad966f577	active	daf6450f-138d-42d9-acc4-c2f02339def3	48c348a8-f38d-46ab-ab38-7435f80706f6
6fb38e22-accd-45c0-8ef5-d1118c19d88a	7f6c30c6-d6a5-4d39-ae5d-e1ae4cc2d3ef	4233e616-3f33-49fb-aa6c-7b54554dec19	active	fb039b32-eb70-48ac-8532-ac1572e12acc	6fb38e22-accd-45c0-8ef5-d1118c19d88a
fe095f6a-3f75-4f0e-ae75-b60f50f50ff3	cdc13d67-6360-43a6-bb99-cd68b64ee3f3	4d699059-2886-444e-9c0b-95540ff4bf93	active	081aa116-4b83-4ecc-b179-41fc2f9c398b	fe095f6a-3f75-4f0e-ae75-b60f50f50ff3
6e336f12-6624-405e-ae39-f546b2a99eae	cdc13d67-6360-43a6-bb99-cd68b64ee3f3	a0da534f-3b88-4e01-bdda-f58bf9b11407	active	081aa116-4b83-4ecc-b179-41fc2f9c398b	6e336f12-6624-405e-ae39-f546b2a99eae
ab6ed41f-5549-40de-b83a-57ecc44627ed	cdc13d67-6360-43a6-bb99-cd68b64ee3f3	6fdeda39-0549-4a0f-964b-51beae1d914c	active	081aa116-4b83-4ecc-b179-41fc2f9c398b	ab6ed41f-5549-40de-b83a-57ecc44627ed
ffa1e935-ccbe-470d-872f-e8212f8c1361	b99894af-7866-4a81-beee-30e0e384b708	4e29bdcb-88d1-4b1d-8e85-4ab68f1e4db7	active	f579ee41-b9dd-4c74-a8e7-e8260d76ce8b	ffa1e935-ccbe-470d-872f-e8212f8c1361
77b1f859-9497-4457-bed1-c88aea2ba9b8	ac051eb3-275f-40a5-b160-e224d13902e7	920f0530-0a9e-49c0-9978-f3d9ff3925c4	active	9bd678be-b57f-4582-9c02-1a5c106f9f2c	77b1f859-9497-4457-bed1-c88aea2ba9b8
63ed86b3-e580-4c86-ac38-d297b4149a25	ac051eb3-275f-40a5-b160-e224d13902e7	473f15dd-47c0-40a6-89e9-3a053ab172a4	active	9bd678be-b57f-4582-9c02-1a5c106f9f2c	63ed86b3-e580-4c86-ac38-d297b4149a25
c1ddb79d-1682-4a73-9fab-b8401cf44fc3	ac051eb3-275f-40a5-b160-e224d13902e7	1812b303-186d-4734-a4cb-1345949485d9	active	9bd678be-b57f-4582-9c02-1a5c106f9f2c	c1ddb79d-1682-4a73-9fab-b8401cf44fc3
8e2f1ce9-f82f-49f8-bd6e-5927a00fdd10	67906f75-4298-4b6a-aa62-d8314be33f15	ee1bf582-8672-4f86-a84e-c958ff2e7205	active	6e196cec-2bdc-4b09-b540-8d55debe949b	8e2f1ce9-f82f-49f8-bd6e-5927a00fdd10
dca56ed6-d348-450e-97e7-1325675d9449	67906f75-4298-4b6a-aa62-d8314be33f15	1812b303-186d-4734-a4cb-1345949485d9	active	6e196cec-2bdc-4b09-b540-8d55debe949b	dca56ed6-d348-450e-97e7-1325675d9449
0203f99c-f61d-4f4b-9eae-8532fddf545b	67906f75-4298-4b6a-aa62-d8314be33f15	aac980e1-0aa5-41e0-b6e0-eebbab19c7c9	active	6e196cec-2bdc-4b09-b540-8d55debe949b	0203f99c-f61d-4f4b-9eae-8532fddf545b
e6092105-855d-4442-8d66-b9be92b06d9f	67906f75-4298-4b6a-aa62-d8314be33f15	920f0530-0a9e-49c0-9978-f3d9ff3925c4	active	6e196cec-2bdc-4b09-b540-8d55debe949b	e6092105-855d-4442-8d66-b9be92b06d9f
adc0b6d4-3691-417f-b652-174cb31f3b04	67906f75-4298-4b6a-aa62-d8314be33f15	b57f29c3-0179-4d53-8f0e-f400acab0e07	active	6e196cec-2bdc-4b09-b540-8d55debe949b	adc0b6d4-3691-417f-b652-174cb31f3b04
156c912d-716d-463e-9f1b-add249a2237c	67906f75-4298-4b6a-aa62-d8314be33f15	a6428b13-2aea-4468-b051-a7b7b2c81ad2	active	6e196cec-2bdc-4b09-b540-8d55debe949b	156c912d-716d-463e-9f1b-add249a2237c
34f3a48a-71e8-43f0-840e-a1b4ece471a4	84b91384-8ec9-4b55-8dc9-28ff8c6db62f	3640e8d5-1d55-4a85-968e-539f45ed137e	active	e4086bee-133a-43fd-b352-10bacd65ee70	34f3a48a-71e8-43f0-840e-a1b4ece471a4
d93160e4-04b5-47c7-bac3-be510f037859	84b91384-8ec9-4b55-8dc9-28ff8c6db62f	896438ce-8705-4cc8-bc5b-8212b9cca4c6	active	e4086bee-133a-43fd-b352-10bacd65ee70	d93160e4-04b5-47c7-bac3-be510f037859
43226a13-e430-4d20-88d8-b1609cdf3652	84b91384-8ec9-4b55-8dc9-28ff8c6db62f	f13fdde8-8913-46b8-852f-8508edfc112c	active	e4086bee-133a-43fd-b352-10bacd65ee70	43226a13-e430-4d20-88d8-b1609cdf3652
6f6f025a-ac3a-45ac-b254-4391435f1c72	1dacf074-ad54-432a-a04f-cecd3a068d0c	adcb0b79-7ada-4467-8f7d-ca6ce7a60405	active	5c5b9cbd-eac0-40d0-86f0-0d9c9ae096b7	6f6f025a-ac3a-45ac-b254-4391435f1c72
1e436203-d6f8-4636-848d-dbf3ff85e6ca	1dacf074-ad54-432a-a04f-cecd3a068d0c	f1cfeeff-4ba7-4172-ba51-550d8183db28	active	5c5b9cbd-eac0-40d0-86f0-0d9c9ae096b7	1e436203-d6f8-4636-848d-dbf3ff85e6ca
ee90a2f3-f02b-48e2-a6b3-0b5fb4d29c81	32ccab1e-e85e-4f52-84f5-69bbcc5fa53d	0192674f-4aab-4a85-9451-91de8fb06d35	active	10ac057b-4a62-4be2-9333-99cbb69c179a	ee90a2f3-f02b-48e2-a6b3-0b5fb4d29c81
d5121069-3a0b-45f1-99c7-46fc3dc5b214	32ccab1e-e85e-4f52-84f5-69bbcc5fa53d	265b6084-04e7-4f95-85a7-5e9ae3612438	active	10ac057b-4a62-4be2-9333-99cbb69c179a	d5121069-3a0b-45f1-99c7-46fc3dc5b214
46b0c5fb-ec0f-40cd-ac25-51647caad9d7	32ccab1e-e85e-4f52-84f5-69bbcc5fa53d	16d6bc5a-fbb0-4356-9ac9-899576f74460	active	10ac057b-4a62-4be2-9333-99cbb69c179a	46b0c5fb-ec0f-40cd-ac25-51647caad9d7
ea6b755f-ce23-42c7-acee-09e8a2deb1d9	32ccab1e-e85e-4f52-84f5-69bbcc5fa53d	aa5647cc-7f19-419c-88d2-c643289824bf	active	10ac057b-4a62-4be2-9333-99cbb69c179a	ea6b755f-ce23-42c7-acee-09e8a2deb1d9
93b790b4-4db9-4fe2-9e38-0f297e1d206c	32ccab1e-e85e-4f52-84f5-69bbcc5fa53d	2d518686-9f62-426f-9a2b-1b2fc94b90e4	active	10ac057b-4a62-4be2-9333-99cbb69c179a	93b790b4-4db9-4fe2-9e38-0f297e1d206c
a3129391-410f-4912-aedf-ba97dd4a7f28	32ccab1e-e85e-4f52-84f5-69bbcc5fa53d	4233e616-3f33-49fb-aa6c-7b54554dec19	active	10ac057b-4a62-4be2-9333-99cbb69c179a	a3129391-410f-4912-aedf-ba97dd4a7f28
f5e6c9e6-780c-481d-878e-05da02b3982a	89a894cc-c5c8-44e2-9ca3-85ab9a0130f9	34940451-48bb-40f3-9bcf-8fc1a2df5bda	active	d7f22ef7-54bb-4348-b287-62fcb6da90f0	f5e6c9e6-780c-481d-878e-05da02b3982a
b8e46306-9ba3-41b6-b16f-41224b59f35a	89a894cc-c5c8-44e2-9ca3-85ab9a0130f9	90d603f6-c175-4a13-98b5-4692581b294c	active	d7f22ef7-54bb-4348-b287-62fcb6da90f0	b8e46306-9ba3-41b6-b16f-41224b59f35a
a1779e38-301d-44b4-80f9-4c28a3dcf208	89a894cc-c5c8-44e2-9ca3-85ab9a0130f9	ab727572-b10b-4a31-bb9c-fd40fbf9bba6	active	d7f22ef7-54bb-4348-b287-62fcb6da90f0	a1779e38-301d-44b4-80f9-4c28a3dcf208
d5fde912-6e33-4073-b975-bb1084b13348	89a894cc-c5c8-44e2-9ca3-85ab9a0130f9	27eecd38-da7f-437c-aa78-e0468be5b594	active	d7f22ef7-54bb-4348-b287-62fcb6da90f0	d5fde912-6e33-4073-b975-bb1084b13348
bedee48c-362b-4eaf-bfb1-40287a435236	89a894cc-c5c8-44e2-9ca3-85ab9a0130f9	d057758e-a4a2-4125-82bd-83b96a2136da	active	d7f22ef7-54bb-4348-b287-62fcb6da90f0	bedee48c-362b-4eaf-bfb1-40287a435236
6b730dda-b9d2-4530-a64b-f5d1ff96de46	89a894cc-c5c8-44e2-9ca3-85ab9a0130f9	12cf3b7a-04a7-464c-be9c-db71b554ddf8	active	d7f22ef7-54bb-4348-b287-62fcb6da90f0	6b730dda-b9d2-4530-a64b-f5d1ff96de46
ffb2ab48-ff5a-449b-a5a1-ac50b0fb01b2	89a894cc-c5c8-44e2-9ca3-85ab9a0130f9	3c7cf1a0-26ba-4460-bdf0-f282b2964c02	active	d7f22ef7-54bb-4348-b287-62fcb6da90f0	ffb2ab48-ff5a-449b-a5a1-ac50b0fb01b2
b6f54e88-24fc-4866-9ed3-d31e6c122330	89a894cc-c5c8-44e2-9ca3-85ab9a0130f9	2a33d5a2-9d58-4d8e-975d-ee07da3d6b0e	active	d7f22ef7-54bb-4348-b287-62fcb6da90f0	b6f54e88-24fc-4866-9ed3-d31e6c122330
462ecc73-7e12-4d54-8b18-cf6cffbb47ba	89a894cc-c5c8-44e2-9ca3-85ab9a0130f9	4233e616-3f33-49fb-aa6c-7b54554dec19	active	d7f22ef7-54bb-4348-b287-62fcb6da90f0	462ecc73-7e12-4d54-8b18-cf6cffbb47ba
91a502d4-aefc-46a4-b4f9-b06149bb4862	89a894cc-c5c8-44e2-9ca3-85ab9a0130f9	10eda8bb-9840-479a-ba70-b1a6c632db68	active	d7f22ef7-54bb-4348-b287-62fcb6da90f0	91a502d4-aefc-46a4-b4f9-b06149bb4862
389a273a-c5fc-4df6-b2ae-23b95b6d407b	5b23d4f4-058e-44e0-945d-ae9035fb1e15	a75a070f-44a9-4a8d-8818-368ed36a895d	active	c358b6bb-4b0a-48ee-9421-0854d1f68fca	389a273a-c5fc-4df6-b2ae-23b95b6d407b
b1246808-603f-421c-affb-343f40327a63	159b6644-94ed-406d-8e1e-1f002f265396	edaea925-2eef-4da8-a393-faf910b4314f	active	502b47d9-44a6-4b77-8f21-1f36c2d6eeb9	b1246808-603f-421c-affb-343f40327a63
ad0eb8e0-57c3-4b3f-bb6c-02d438c267ae	159b6644-94ed-406d-8e1e-1f002f265396	10eda8bb-9840-479a-ba70-b1a6c632db68	active	502b47d9-44a6-4b77-8f21-1f36c2d6eeb9	ad0eb8e0-57c3-4b3f-bb6c-02d438c267ae
75042bb5-182c-4d16-941c-8f84134b67db	159b6644-94ed-406d-8e1e-1f002f265396	071a3720-55dd-4638-a31f-40762c38b6e5	active	502b47d9-44a6-4b77-8f21-1f36c2d6eeb9	75042bb5-182c-4d16-941c-8f84134b67db
20e1ee2b-1c00-4f2b-88ac-8edb455b1abb	be516eed-8a37-436c-af75-b623f0806f39	04d92cc3-efaf-4033-a5f6-40f3856e855e	active	df68a822-74c8-41c1-8cfe-d0d1a685c74f	20e1ee2b-1c00-4f2b-88ac-8edb455b1abb
80b3cde1-6b7d-41e7-a049-adf9cd89d24c	be516eed-8a37-436c-af75-b623f0806f39	0b672960-f467-436e-9300-fd0019de40c6	active	df68a822-74c8-41c1-8cfe-d0d1a685c74f	80b3cde1-6b7d-41e7-a049-adf9cd89d24c
3927f8f9-68a4-4ee2-a487-0175b0df5b37	be516eed-8a37-436c-af75-b623f0806f39	a75a070f-44a9-4a8d-8818-368ed36a895d	active	df68a822-74c8-41c1-8cfe-d0d1a685c74f	3927f8f9-68a4-4ee2-a487-0175b0df5b37
c1b40feb-4d78-4ede-b921-acc4c36150f8	be516eed-8a37-436c-af75-b623f0806f39	a58d7975-f96e-4089-8e24-64cbdba09a1f	active	df68a822-74c8-41c1-8cfe-d0d1a685c74f	c1b40feb-4d78-4ede-b921-acc4c36150f8
56f96cb2-181e-444e-b5fa-c3622db2b159	be516eed-8a37-436c-af75-b623f0806f39	6ead3562-71c5-4cdb-837e-878cc2da2534	active	df68a822-74c8-41c1-8cfe-d0d1a685c74f	56f96cb2-181e-444e-b5fa-c3622db2b159
c959be05-b204-480b-8942-37dbc427d3a5	0e14dccb-9c28-4f89-b3b2-cb1011be06d1	e13f7c8f-e29f-4074-ad2e-84177da25028	active	0b54823d-ebef-4a0a-934c-e408c127861a	c959be05-b204-480b-8942-37dbc427d3a5
f68a71bf-8e26-4753-9198-1efa7fe2bfcc	0e14dccb-9c28-4f89-b3b2-cb1011be06d1	2bc8f9aa-0a7a-400c-ac77-1ccc3cd41150	active	0b54823d-ebef-4a0a-934c-e408c127861a	f68a71bf-8e26-4753-9198-1efa7fe2bfcc
651b7de2-17d1-49b3-8936-2c2978e2f32c	0e14dccb-9c28-4f89-b3b2-cb1011be06d1	5ff7e7e2-383d-479b-90f7-6b0d3bcaa51a	active	0b54823d-ebef-4a0a-934c-e408c127861a	651b7de2-17d1-49b3-8936-2c2978e2f32c
4bac16ba-88fe-4816-b46b-1e8225f69799	02970c3a-2240-4a74-8fd3-18af09a9cd61	b6afb46b-4d63-46d0-8b7e-f71d6d2fe500	active	9af8b293-f532-43bf-b8cb-06195f021079	4bac16ba-88fe-4816-b46b-1e8225f69799
0554d2a0-cf58-45f3-8d25-dc770c7d7c1c	02970c3a-2240-4a74-8fd3-18af09a9cd61	be807861-8861-4f83-80fd-ad22da22d1d8	active	9af8b293-f532-43bf-b8cb-06195f021079	0554d2a0-cf58-45f3-8d25-dc770c7d7c1c
7ab83874-3f41-4426-9ae3-a8fc64cc22c7	be516eed-8a37-436c-af75-b623f0806f39	f59be7f4-6494-42a9-b21f-388930fca8cd	active	58a992bd-8ee9-4627-b719-e8cc083d4344	7ab83874-3f41-4426-9ae3-a8fc64cc22c7
d8770518-bb87-439f-ac71-50ca180f6984	fe7cd753-376f-4f22-a721-caa482aa1116	713e34bc-6b1c-48fe-8030-c755f956251e	active	22c78088-f8e8-4d24-b35a-fc6c6c65ea47	d8770518-bb87-439f-ac71-50ca180f6984
05aeaf86-fedf-4fef-97dc-1b8633b707f8	fe7cd753-376f-4f22-a721-caa482aa1116	d83fcda2-9fcb-429f-8fc5-4b421478a4ca	active	22c78088-f8e8-4d24-b35a-fc6c6c65ea47	05aeaf86-fedf-4fef-97dc-1b8633b707f8
3e28a5f7-9a33-4fec-adf4-a736307946b1	fe7cd753-376f-4f22-a721-caa482aa1116	59fc41c4-2a4d-459b-b489-54ad20f26fe7	active	22c78088-f8e8-4d24-b35a-fc6c6c65ea47	3e28a5f7-9a33-4fec-adf4-a736307946b1
996165ea-1131-469c-8a31-4a95248bc912	8a7d516b-f3c2-4a5b-afde-d2bdff371937	4503e0a6-4871-45bb-ab12-1021a0a4d873	active	30c271f8-7b1c-4a14-855c-9dc9420f1ca9	996165ea-1131-469c-8a31-4a95248bc912
ae3c0590-63ec-41b9-8b0c-6986ddae3b5e	8a7d516b-f3c2-4a5b-afde-d2bdff371937	37a1d187-97fe-4243-9579-f7e0f12c3d9b	active	30c271f8-7b1c-4a14-855c-9dc9420f1ca9	ae3c0590-63ec-41b9-8b0c-6986ddae3b5e
2b597020-7a75-4dd5-aa8a-f358af646d21	8a7d516b-f3c2-4a5b-afde-d2bdff371937	b8d71981-30ab-402a-b29c-da315610bb73	active	30c271f8-7b1c-4a14-855c-9dc9420f1ca9	2b597020-7a75-4dd5-aa8a-f358af646d21
5b2612b3-60f8-49b5-9cb1-399b308cc4f9	8a7d516b-f3c2-4a5b-afde-d2bdff371937	0c2e2d99-7fd3-41c4-aff6-c7db6c8c91f1	active	30c271f8-7b1c-4a14-855c-9dc9420f1ca9	5b2612b3-60f8-49b5-9cb1-399b308cc4f9
e1ba9b46-8299-4d43-852e-58ea18577ca7	8a7d516b-f3c2-4a5b-afde-d2bdff371937	dd951909-8a84-4b47-8e70-9b3a083f30ab	active	30c271f8-7b1c-4a14-855c-9dc9420f1ca9	e1ba9b46-8299-4d43-852e-58ea18577ca7
f4bcbda2-4a1c-4d5f-aef7-ba364b49e001	8a7d516b-f3c2-4a5b-afde-d2bdff371937	4a789077-a8ad-48dc-880e-328e2f99f63a	active	30c271f8-7b1c-4a14-855c-9dc9420f1ca9	f4bcbda2-4a1c-4d5f-aef7-ba364b49e001
b40f1688-7764-4bfb-9d53-93a06d3e3635	8a7d516b-f3c2-4a5b-afde-d2bdff371937	877e6c87-50ab-4b0d-8ed7-40be4f5109c4	active	30c271f8-7b1c-4a14-855c-9dc9420f1ca9	b40f1688-7764-4bfb-9d53-93a06d3e3635
447315df-c5c8-4697-808c-7f556af764c8	8a7d516b-f3c2-4a5b-afde-d2bdff371937	b8d19818-8529-4dce-9f46-12035ac43098	deleted	30c271f8-7b1c-4a14-855c-9dc9420f1ca9	447315df-c5c8-4697-808c-7f556af764c8
646c5f41-50fd-4ad1-a1d6-bbc2b0f84fe5	1dacf074-ad54-432a-a04f-cecd3a068d0c	001a45c6-9af1-460b-8814-801da17619d3	active	ee816bc2-0316-4adc-ac10-300df9306594	646c5f41-50fd-4ad1-a1d6-bbc2b0f84fe5
7fc431e2-e1f3-4dbf-a4a4-e52359e07073	df6c89f3-4473-424b-a0b0-119977da62c5	b59b9b95-d0f4-4c43-9204-4328b391accb	active	177926cc-1263-4323-9dad-14032641b0a5	7fc431e2-e1f3-4dbf-a4a4-e52359e07073
bdb43bac-1d33-4f4a-96c4-82034a3279b8	df6c89f3-4473-424b-a0b0-119977da62c5	f59be7f4-6494-42a9-b21f-388930fca8cd	active	177926cc-1263-4323-9dad-14032641b0a5	bdb43bac-1d33-4f4a-96c4-82034a3279b8
d6d86ab5-3990-4513-8b47-88879159a415	df6c89f3-4473-424b-a0b0-119977da62c5	cecfa504-4a92-4103-beb6-e1d15bbac444	active	177926cc-1263-4323-9dad-14032641b0a5	d6d86ab5-3990-4513-8b47-88879159a415
834afcc2-9a4d-4b66-89ad-8f9842a15910	df6c89f3-4473-424b-a0b0-119977da62c5	78115c49-086a-4799-be1d-e6ef6eef97a5	active	177926cc-1263-4323-9dad-14032641b0a5	834afcc2-9a4d-4b66-89ad-8f9842a15910
d9b99d96-ca73-4145-b7a2-13d7d84b3ca6	df6c89f3-4473-424b-a0b0-119977da62c5	9f47f113-6785-4448-b15c-8b3eaf2032c9	active	177926cc-1263-4323-9dad-14032641b0a5	d9b99d96-ca73-4145-b7a2-13d7d84b3ca6
5a9ed3e1-0c6f-404a-822c-32184ca1c7a6	df6c89f3-4473-424b-a0b0-119977da62c5	7b099d32-3519-45f6-9b83-542e0fdd6ec8	active	177926cc-1263-4323-9dad-14032641b0a5	5a9ed3e1-0c6f-404a-822c-32184ca1c7a6
67d2f6f3-4f1f-4bca-ad2e-f95409dadab2	df6c89f3-4473-424b-a0b0-119977da62c5	b7438d75-793c-46a4-aa9d-c61fcfa17632	active	177926cc-1263-4323-9dad-14032641b0a5	67d2f6f3-4f1f-4bca-ad2e-f95409dadab2
1138f08a-8ba7-48a0-ac07-c25a6b62152e	0460ea96-a830-40bd-adfb-140aad4c31ca	f2d5f66f-3e64-432c-ad74-9df59e78c3e0	active	2b5ac88c-ed8c-4fee-b013-103238447a18	1138f08a-8ba7-48a0-ac07-c25a6b62152e
be52f89b-ffed-4c9d-82c2-4464077cb0f1	0460ea96-a830-40bd-adfb-140aad4c31ca	d3fe7c4e-9bc0-4718-ab5d-6184e261b926	active	2b5ac88c-ed8c-4fee-b013-103238447a18	be52f89b-ffed-4c9d-82c2-4464077cb0f1
0dd05a36-1b72-4a81-9a76-8415b6b63aab	0460ea96-a830-40bd-adfb-140aad4c31ca	2b526ead-4e35-4bc6-900e-5bf1b32c854e	active	2b5ac88c-ed8c-4fee-b013-103238447a18	0dd05a36-1b72-4a81-9a76-8415b6b63aab
5bc6fe29-307b-4785-a100-fa20bc670001	0460ea96-a830-40bd-adfb-140aad4c31ca	edaea925-2eef-4da8-a393-faf910b4314f	active	2b5ac88c-ed8c-4fee-b013-103238447a18	5bc6fe29-307b-4785-a100-fa20bc670001
ad0eb8e0-57c3-4b3f-bb6c-02d438c267ae	159b6644-94ed-406d-8e1e-1f002f265396	10eda8bb-9840-479a-ba70-b1a6c632db68	deleted	d8097172-e1a3-4d79-b40a-3c3ec12be908	ad0eb8e0-57c3-4b3f-bb6c-02d438c267ae
d7adb9cb-96ed-4c22-8aef-182de537f777	159b6644-94ed-406d-8e1e-1f002f265396	f13fdde8-8913-46b8-852f-8508edfc112c	active	d8097172-e1a3-4d79-b40a-3c3ec12be908	d7adb9cb-96ed-4c22-8aef-182de537f777
4c83ab8d-1bfb-4a31-959a-50c185ba9b71	159b6644-94ed-406d-8e1e-1f002f265396	a6d6facd-9d1f-4c47-8d38-efab698b3e0d	active	d8097172-e1a3-4d79-b40a-3c3ec12be908	4c83ab8d-1bfb-4a31-959a-50c185ba9b71
0231e6c5-0526-41fd-80ca-9a8f193dd8e7	159b6644-94ed-406d-8e1e-1f002f265396	f2d5f66f-3e64-432c-ad74-9df59e78c3e0	active	d8097172-e1a3-4d79-b40a-3c3ec12be908	0231e6c5-0526-41fd-80ca-9a8f193dd8e7
ee61a843-8865-4575-a462-768b93ad9e35	641c249c-f473-4d8e-bd8e-f385157f2682	23cb8375-5249-43a8-adb2-a8bc3fc7784c	active	903899a1-b57f-44c8-9818-15fc47ead4da	ee61a843-8865-4575-a462-768b93ad9e35
538e6b36-9807-4fe3-be04-2b758d33aa64	641c249c-f473-4d8e-bd8e-f385157f2682	c3dce0b0-ce3f-475b-8bae-91f6dc03e0aa	active	903899a1-b57f-44c8-9818-15fc47ead4da	538e6b36-9807-4fe3-be04-2b758d33aa64
fe4cba4c-d51f-4d17-bd0a-b48f1c7e0a62	641c249c-f473-4d8e-bd8e-f385157f2682	66261447-7807-4f0a-a19e-a14dde5e68cb	active	903899a1-b57f-44c8-9818-15fc47ead4da	fe4cba4c-d51f-4d17-bd0a-b48f1c7e0a62
f1cfa510-eea9-4506-b9ae-3c274b702e0b	641c249c-f473-4d8e-bd8e-f385157f2682	5b0e137b-78e2-45a4-8ab2-bfad40306d69	active	903899a1-b57f-44c8-9818-15fc47ead4da	f1cfa510-eea9-4506-b9ae-3c274b702e0b
33d8375e-06e6-486f-9baa-fffcc2217d94	641c249c-f473-4d8e-bd8e-f385157f2682	7b099d32-3519-45f6-9b83-542e0fdd6ec8	active	903899a1-b57f-44c8-9818-15fc47ead4da	33d8375e-06e6-486f-9baa-fffcc2217d94
57adb25c-0ece-4552-b12f-b26da00a12ca	641c249c-f473-4d8e-bd8e-f385157f2682	4233e616-3f33-49fb-aa6c-7b54554dec19	active	903899a1-b57f-44c8-9818-15fc47ead4da	57adb25c-0ece-4552-b12f-b26da00a12ca
21f3a257-b6f8-4c5f-b67b-734e81df32c7	641c249c-f473-4d8e-bd8e-f385157f2682	08719c78-ea0a-4731-816c-c8d57d7db76a	active	903899a1-b57f-44c8-9818-15fc47ead4da	21f3a257-b6f8-4c5f-b67b-734e81df32c7
19c480a5-cef1-4abc-9bd2-bbb70edf77b0	641c249c-f473-4d8e-bd8e-f385157f2682	d76057c8-5d41-4a7a-861a-2b558f8081c9	active	903899a1-b57f-44c8-9818-15fc47ead4da	19c480a5-cef1-4abc-9bd2-bbb70edf77b0
d6abecb1-b3b8-479f-8a3a-c1a37a7dacfb	89a894cc-c5c8-44e2-9ca3-85ab9a0130f9	4007f503-7979-4147-98de-2c29348abc43	active	474d3077-dbdb-4340-b4a4-2be5b64fa86d	d6abecb1-b3b8-479f-8a3a-c1a37a7dacfb
a1779e38-301d-44b4-80f9-4c28a3dcf208	89a894cc-c5c8-44e2-9ca3-85ab9a0130f9	ab727572-b10b-4a31-bb9c-fd40fbf9bba6	deleted	474d3077-dbdb-4340-b4a4-2be5b64fa86d	a1779e38-301d-44b4-80f9-4c28a3dcf208
d23a3374-d195-4dc3-828b-77cc28604d49	1cf46091-d128-4e38-a7b7-97901d423aaf	3a931aa9-250e-4119-9826-be94e485cb69	active	95f05f43-c667-4588-8eec-97492bbe098d	d23a3374-d195-4dc3-828b-77cc28604d49
2d078cf0-fe87-4ad6-b127-0097cfe2cd5b	1cf46091-d128-4e38-a7b7-97901d423aaf	64a66b0a-6a92-4149-ab19-2c5d40856e82	active	95f05f43-c667-4588-8eec-97492bbe098d	2d078cf0-fe87-4ad6-b127-0097cfe2cd5b
19c44ed2-8022-4866-8efb-913ea31be2e1	3c175c09-a896-4a88-9603-2b5ea27ef1a1	ca6045bc-34bc-452d-9668-75dc38319ef7	active	3c03ffa2-7549-4757-9869-8bc3aa21aab5	19c44ed2-8022-4866-8efb-913ea31be2e1
b900dac0-ded3-4906-9cba-caa5dd74fe26	fea6dcd6-00d6-4ad5-ab2f-eb40f533a5db	68580412-9553-4778-aef8-6d36f1136b28	active	cc7f9237-21a1-4e74-ac5f-5cfa6dc1c499	b900dac0-ded3-4906-9cba-caa5dd74fe26
05100f27-b69a-4af4-b432-d9ab696cf8ca	fea6dcd6-00d6-4ad5-ab2f-eb40f533a5db	a0da534f-3b88-4e01-bdda-f58bf9b11407	active	cc7f9237-21a1-4e74-ac5f-5cfa6dc1c499	05100f27-b69a-4af4-b432-d9ab696cf8ca
edd862e1-2bc8-4a67-aeb9-5c4f2144b47a	fea6dcd6-00d6-4ad5-ab2f-eb40f533a5db	f59be7f4-6494-42a9-b21f-388930fca8cd	active	cc7f9237-21a1-4e74-ac5f-5cfa6dc1c499	edd862e1-2bc8-4a67-aeb9-5c4f2144b47a
c89b93a6-1731-4c1e-9e79-41c07685d1e3	fea6dcd6-00d6-4ad5-ab2f-eb40f533a5db	3e50182f-2d55-4375-becb-9e9c0f19b0e1	active	cc7f9237-21a1-4e74-ac5f-5cfa6dc1c499	c89b93a6-1731-4c1e-9e79-41c07685d1e3
64543062-b26a-4a46-b4c5-9306d3a64a7a	fea6dcd6-00d6-4ad5-ab2f-eb40f533a5db	634397b7-b735-4260-a30c-7e03302f263e	active	cc7f9237-21a1-4e74-ac5f-5cfa6dc1c499	64543062-b26a-4a46-b4c5-9306d3a64a7a
99556c21-d299-4c86-8a2d-1c02d7acab5b	fea6dcd6-00d6-4ad5-ab2f-eb40f533a5db	c7a4044b-2612-4208-9fe8-ef14878071a7	active	cc7f9237-21a1-4e74-ac5f-5cfa6dc1c499	99556c21-d299-4c86-8a2d-1c02d7acab5b
3a69836a-8401-444e-8969-0223b4755ec6	fea6dcd6-00d6-4ad5-ab2f-eb40f533a5db	a7cee6ce-5b52-448c-8a41-c612a5d0b3b9	active	cc7f9237-21a1-4e74-ac5f-5cfa6dc1c499	3a69836a-8401-444e-8969-0223b4755ec6
915cff59-e496-48fb-ad9e-e00a9a0a4abc	fea6dcd6-00d6-4ad5-ab2f-eb40f533a5db	cecfa504-4a92-4103-beb6-e1d15bbac444	active	cc7f9237-21a1-4e74-ac5f-5cfa6dc1c499	915cff59-e496-48fb-ad9e-e00a9a0a4abc
c417e6fa-4823-4c4c-8840-ac97b3bcf50a	fea6dcd6-00d6-4ad5-ab2f-eb40f533a5db	957ba93c-80c9-4709-b716-94089518f4a0	active	cc7f9237-21a1-4e74-ac5f-5cfa6dc1c499	c417e6fa-4823-4c4c-8840-ac97b3bcf50a
e305d159-71ff-4bb0-bd00-0e36ec31c12e	fea6dcd6-00d6-4ad5-ab2f-eb40f533a5db	a75a070f-44a9-4a8d-8818-368ed36a895d	active	cc7f9237-21a1-4e74-ac5f-5cfa6dc1c499	e305d159-71ff-4bb0-bd00-0e36ec31c12e
ce4286bc-18ba-41c6-a328-714cd8732a9c	fea6dcd6-00d6-4ad5-ab2f-eb40f533a5db	4cc50dc6-97e2-416e-96c2-c0b747199fa6	active	cc7f9237-21a1-4e74-ac5f-5cfa6dc1c499	ce4286bc-18ba-41c6-a328-714cd8732a9c
7a5ae58a-c49c-407a-a51e-be48e8484a13	4235252c-aa21-46b5-8c52-110f95bdc583	3007a18b-d717-44fd-8281-943c0bd3d7f9	active	9b89818a-d5ff-4870-bbcf-7580d008a9dd	7a5ae58a-c49c-407a-a51e-be48e8484a13
fa2b59e6-0950-448a-8f2c-b017af28081f	f6c6aac7-3c9b-4a3c-80bc-d6709bc95d4b	3007a18b-d717-44fd-8281-943c0bd3d7f9	active	c710cf20-1e45-4734-8d38-abaa584b67af	fa2b59e6-0950-448a-8f2c-b017af28081f
d365741d-16ec-4cb6-9fff-f6cb9c4e67e1	de5557e1-bf16-433b-87ff-401323a97df5	89f5db50-4b21-4808-a4fe-523ec4ff414c	active	9f2365d7-35db-4301-8a4c-351671cc2694	d365741d-16ec-4cb6-9fff-f6cb9c4e67e1
04b81e24-137c-4a9e-b071-7e096c0eb474	de5557e1-bf16-433b-87ff-401323a97df5	1986e4ca-61a8-41a6-95c2-940e526d50f1	active	9f2365d7-35db-4301-8a4c-351671cc2694	04b81e24-137c-4a9e-b071-7e096c0eb474
4da5d6a0-2943-4d5c-8de7-e213644692a7	de5557e1-bf16-433b-87ff-401323a97df5	3007a18b-d717-44fd-8281-943c0bd3d7f9	active	9f2365d7-35db-4301-8a4c-351671cc2694	4da5d6a0-2943-4d5c-8de7-e213644692a7
498ac86b-18e5-4624-8cce-8b66a94fac7d	de5557e1-bf16-433b-87ff-401323a97df5	e8584566-2520-4ffc-bcf6-202169e737a7	active	9f2365d7-35db-4301-8a4c-351671cc2694	498ac86b-18e5-4624-8cce-8b66a94fac7d
406ca2a3-f0ac-49bb-9f24-6ead19aa9d1d	47034ede-0506-4650-9fb4-1948168440ca	1986e4ca-61a8-41a6-95c2-940e526d50f1	active	985b1c06-355c-4311-9f30-47457e636266	406ca2a3-f0ac-49bb-9f24-6ead19aa9d1d
4b5d9ecd-a403-4959-955e-198e6981406b	47034ede-0506-4650-9fb4-1948168440ca	3007a18b-d717-44fd-8281-943c0bd3d7f9	active	985b1c06-355c-4311-9f30-47457e636266	4b5d9ecd-a403-4959-955e-198e6981406b
21b976cf-f3e0-4951-87f7-6ed7c834c4e4	47034ede-0506-4650-9fb4-1948168440ca	89f5db50-4b21-4808-a4fe-523ec4ff414c	active	985b1c06-355c-4311-9f30-47457e636266	21b976cf-f3e0-4951-87f7-6ed7c834c4e4
4ccf0986-3cdf-451c-ac15-91d0726844ee	47034ede-0506-4650-9fb4-1948168440ca	e8584566-2520-4ffc-bcf6-202169e737a7	active	985b1c06-355c-4311-9f30-47457e636266	4ccf0986-3cdf-451c-ac15-91d0726844ee
2cc8f004-ee6b-4e31-893c-12c9389e94d9	47034ede-0506-4650-9fb4-1948168440ca	72cd5937-eeda-41d2-9482-13017802414d	active	1cd82cdd-40c4-42dd-b398-44c43ff1b2b1	2cc8f004-ee6b-4e31-893c-12c9389e94d9
d978a4bd-c881-4bf4-a7d9-4e8aaf3d95fc	de5557e1-bf16-433b-87ff-401323a97df5	72cd5937-eeda-41d2-9482-13017802414d	active	18fafa4e-7382-4ce9-a04f-ec636c51d56a	d978a4bd-c881-4bf4-a7d9-4e8aaf3d95fc
4603be8a-840b-4774-b179-9810c717395f	bfd1388a-ec10-4a7b-9d94-916f56f52f98	c90f528f-b9c6-456e-a467-3ca145bb4528	active	5037ad29-b65d-490a-bd23-d79c405ec466	4603be8a-840b-4774-b179-9810c717395f
b8e00210-784f-42c1-a55a-59cb8af7eb7d	bfd1388a-ec10-4a7b-9d94-916f56f52f98	4233e616-3f33-49fb-aa6c-7b54554dec19	active	5037ad29-b65d-490a-bd23-d79c405ec466	b8e00210-784f-42c1-a55a-59cb8af7eb7d
6b1ca109-7711-4fa7-8700-3702c10d0f0a	bfd1388a-ec10-4a7b-9d94-916f56f52f98	34d831fd-404b-4ae7-b4d6-b5d70749ff75	active	5037ad29-b65d-490a-bd23-d79c405ec466	6b1ca109-7711-4fa7-8700-3702c10d0f0a
e4a637c5-08ec-4f82-a534-ed8bd93daf83	bfd1388a-ec10-4a7b-9d94-916f56f52f98	dbdd1313-54e2-4816-a108-6e2f2f70002f	active	5037ad29-b65d-490a-bd23-d79c405ec466	e4a637c5-08ec-4f82-a534-ed8bd93daf83
1495b50f-8849-4705-b421-7779540d87d5	8708a912-1b80-441d-9ba3-d607dd2f0c7c	5c943c63-92fa-4038-95af-7c2bc9decf74	active	153a48b3-24af-44e4-ab07-9d5610e890da	1495b50f-8849-4705-b421-7779540d87d5
ba08139f-e130-482c-a2b4-6dc3064ea4bb	8708a912-1b80-441d-9ba3-d607dd2f0c7c	f13fdde8-8913-46b8-852f-8508edfc112c	active	153a48b3-24af-44e4-ab07-9d5610e890da	ba08139f-e130-482c-a2b4-6dc3064ea4bb
220074fe-902c-41d3-b6b7-2484d2e8fc32	8708a912-1b80-441d-9ba3-d607dd2f0c7c	f7c7e083-9b25-47eb-8153-b719b907d907	active	153a48b3-24af-44e4-ab07-9d5610e890da	220074fe-902c-41d3-b6b7-2484d2e8fc32
9996c64c-d82e-4532-971b-953505618092	8708a912-1b80-441d-9ba3-d607dd2f0c7c	91a6b94f-c0c1-44c2-8ae6-15d3b1ae4b60	active	153a48b3-24af-44e4-ab07-9d5610e890da	9996c64c-d82e-4532-971b-953505618092
75d872c8-e3e1-4fcc-853d-a06e1272c80d	25dd2269-e0f3-4653-98ac-33f64f09d4d3	f59be7f4-6494-42a9-b21f-388930fca8cd	active	4bba233a-f5ab-48de-ab8d-8f9f386fbf77	75d872c8-e3e1-4fcc-853d-a06e1272c80d
9db63356-0600-49c1-996b-70a1f5b767b5	25dd2269-e0f3-4653-98ac-33f64f09d4d3	e8584566-2520-4ffc-bcf6-202169e737a7	active	4bba233a-f5ab-48de-ab8d-8f9f386fbf77	9db63356-0600-49c1-996b-70a1f5b767b5
b469b8ac-a9db-4f1e-9c39-5eefeceb6449	25dd2269-e0f3-4653-98ac-33f64f09d4d3	d057758e-a4a2-4125-82bd-83b96a2136da	active	4bba233a-f5ab-48de-ab8d-8f9f386fbf77	b469b8ac-a9db-4f1e-9c39-5eefeceb6449
99bc7934-6f81-4c32-b248-7ed1f146c587	25dd2269-e0f3-4653-98ac-33f64f09d4d3	c061a5ce-5435-47f8-840a-e36a4f315367	active	4bba233a-f5ab-48de-ab8d-8f9f386fbf77	99bc7934-6f81-4c32-b248-7ed1f146c587
6e337be2-d635-4d4c-8727-cb3ee3da7c3f	25dd2269-e0f3-4653-98ac-33f64f09d4d3	b7438d75-793c-46a4-aa9d-c61fcfa17632	active	4bba233a-f5ab-48de-ab8d-8f9f386fbf77	6e337be2-d635-4d4c-8727-cb3ee3da7c3f
a7d562ce-a3ff-4f23-8f49-31b91ebc2621	25dd2269-e0f3-4653-98ac-33f64f09d4d3	9f47f113-6785-4448-b15c-8b3eaf2032c9	active	4bba233a-f5ab-48de-ab8d-8f9f386fbf77	a7d562ce-a3ff-4f23-8f49-31b91ebc2621
23dea012-88c6-49bb-8ae3-46d2255b32a7	25dd2269-e0f3-4653-98ac-33f64f09d4d3	3007a18b-d717-44fd-8281-943c0bd3d7f9	active	4bba233a-f5ab-48de-ab8d-8f9f386fbf77	23dea012-88c6-49bb-8ae3-46d2255b32a7
c442b9fa-e951-4ae3-a1e7-1790eb45a9d0	25dd2269-e0f3-4653-98ac-33f64f09d4d3	a7cee6ce-5b52-448c-8a41-c612a5d0b3b9	active	4bba233a-f5ab-48de-ab8d-8f9f386fbf77	c442b9fa-e951-4ae3-a1e7-1790eb45a9d0
96d05cf9-27d6-4440-a74a-4c426c471585	b815db66-cadf-4c3c-ae0b-73ad5bf1a46e	877e6c87-50ab-4b0d-8ed7-40be4f5109c4	active	78218970-639e-4d24-93ed-244cd4decfcb	96d05cf9-27d6-4440-a74a-4c426c471585
ac2d0f47-b441-41e4-8712-bc24b8a57a64	b815db66-cadf-4c3c-ae0b-73ad5bf1a46e	c1610461-01ce-4a34-89a7-0e93f74f67e7	active	78218970-639e-4d24-93ed-244cd4decfcb	ac2d0f47-b441-41e4-8712-bc24b8a57a64
bec7f88c-d292-4d5d-ad16-06e4201d4c6f	b815db66-cadf-4c3c-ae0b-73ad5bf1a46e	94e91072-a71c-4b7d-85a4-76d88683c2a0	active	78218970-639e-4d24-93ed-244cd4decfcb	bec7f88c-d292-4d5d-ad16-06e4201d4c6f
869bdf52-ec33-4522-a668-5fc76a359869	b815db66-cadf-4c3c-ae0b-73ad5bf1a46e	f59be7f4-6494-42a9-b21f-388930fca8cd	active	78218970-639e-4d24-93ed-244cd4decfcb	869bdf52-ec33-4522-a668-5fc76a359869
efc703ac-f058-4638-ace7-441670dff8ab	b815db66-cadf-4c3c-ae0b-73ad5bf1a46e	c061a5ce-5435-47f8-840a-e36a4f315367	active	78218970-639e-4d24-93ed-244cd4decfcb	efc703ac-f058-4638-ace7-441670dff8ab
c8ed1fb5-4ed5-4b88-b074-892b3e9f9980	b815db66-cadf-4c3c-ae0b-73ad5bf1a46e	26e502aa-c39c-48a2-91ab-6569af21ae9e	active	78218970-639e-4d24-93ed-244cd4decfcb	c8ed1fb5-4ed5-4b88-b074-892b3e9f9980
286887c1-a93f-4dff-a199-14931eaca336	b815db66-cadf-4c3c-ae0b-73ad5bf1a46e	a0da534f-3b88-4e01-bdda-f58bf9b11407	active	78218970-639e-4d24-93ed-244cd4decfcb	286887c1-a93f-4dff-a199-14931eaca336
56437574-306d-41bb-b1b4-07ee2a4a9ace	b815db66-cadf-4c3c-ae0b-73ad5bf1a46e	73b0d2dd-0b1d-4d67-b8f9-e7a9a61d2e1b	active	78218970-639e-4d24-93ed-244cd4decfcb	56437574-306d-41bb-b1b4-07ee2a4a9ace
314cb5c3-44f8-4799-8b12-a934bf3145b1	b815db66-cadf-4c3c-ae0b-73ad5bf1a46e	b0aef3fc-2551-44ce-9e59-e2f5e848748a	active	78218970-639e-4d24-93ed-244cd4decfcb	314cb5c3-44f8-4799-8b12-a934bf3145b1
7004c03e-ab6b-4173-a2c8-915654c9874c	b815db66-cadf-4c3c-ae0b-73ad5bf1a46e	b7438d75-793c-46a4-aa9d-c61fcfa17632	active	78218970-639e-4d24-93ed-244cd4decfcb	7004c03e-ab6b-4173-a2c8-915654c9874c
4495b74b-1692-4030-af8a-e8eb4147d513	b815db66-cadf-4c3c-ae0b-73ad5bf1a46e	151588d7-81bf-4f3d-a866-891e5849a939	active	78218970-639e-4d24-93ed-244cd4decfcb	4495b74b-1692-4030-af8a-e8eb4147d513
4c1a161e-df65-413e-9c80-1cf6b3db7944	b815db66-cadf-4c3c-ae0b-73ad5bf1a46e	a7cee6ce-5b52-448c-8a41-c612a5d0b3b9	active	78218970-639e-4d24-93ed-244cd4decfcb	4c1a161e-df65-413e-9c80-1cf6b3db7944
3083fb28-2f6c-4966-a43f-7f688a60fbf4	275e4c19-2885-4630-b049-e365374c27fb	5ff7e7e2-383d-479b-90f7-6b0d3bcaa51a	active	35fc3cd3-516a-494d-b6fa-b82140444685	3083fb28-2f6c-4966-a43f-7f688a60fbf4
9594a82d-fbfa-4f4a-99ad-645323146985	275e4c19-2885-4630-b049-e365374c27fb	87e157c1-1674-49ad-a7c9-14f54cd1b192	active	35fc3cd3-516a-494d-b6fa-b82140444685	9594a82d-fbfa-4f4a-99ad-645323146985
fb39a8dd-5bc2-4994-b7e2-200cb283828c	275e4c19-2885-4630-b049-e365374c27fb	e8584566-2520-4ffc-bcf6-202169e737a7	active	35fc3cd3-516a-494d-b6fa-b82140444685	fb39a8dd-5bc2-4994-b7e2-200cb283828c
63b5bd14-7e99-4683-ab4d-228862fe7818	275e4c19-2885-4630-b049-e365374c27fb	72cd5937-eeda-41d2-9482-13017802414d	active	35fc3cd3-516a-494d-b6fa-b82140444685	63b5bd14-7e99-4683-ab4d-228862fe7818
7ab9b525-9139-46f2-81e7-7c36b1219e1c	275e4c19-2885-4630-b049-e365374c27fb	b7475bec-cae2-48b0-a8fe-1f70658fb5ef	active	35fc3cd3-516a-494d-b6fa-b82140444685	7ab9b525-9139-46f2-81e7-7c36b1219e1c
0850c0f4-29c3-4b87-9527-191db7cf91bc	275e4c19-2885-4630-b049-e365374c27fb	a85647c2-fc12-4766-a70b-88f4ff6a8465	active	35fc3cd3-516a-494d-b6fa-b82140444685	0850c0f4-29c3-4b87-9527-191db7cf91bc
e92b5441-1b1a-422a-a80d-b9268645f546	275e4c19-2885-4630-b049-e365374c27fb	ca903ad5-d738-4dac-b6c2-dfd847522650	active	35fc3cd3-516a-494d-b6fa-b82140444685	e92b5441-1b1a-422a-a80d-b9268645f546
459f486f-4733-45fb-adbd-72bd8118d92e	e3e52ca7-2e9e-4f87-a818-5a808823089b	7fde6772-145d-4443-9e39-fc19041008d9	active	31206ec8-7ac4-40c3-b06d-5f0e5f4f4da0	459f486f-4733-45fb-adbd-72bd8118d92e
8fb6e931-cf52-42de-ac4e-e2d2a81a054c	e3e52ca7-2e9e-4f87-a818-5a808823089b	0fa92041-ce27-4e68-b3d3-c9b43f3c6de6	active	31206ec8-7ac4-40c3-b06d-5f0e5f4f4da0	8fb6e931-cf52-42de-ac4e-e2d2a81a054c
44e732e0-4a6d-48f0-be0d-be5b609d338a	e3e52ca7-2e9e-4f87-a818-5a808823089b	2900d3c6-e08a-459e-b132-69f5a4456acf	active	31206ec8-7ac4-40c3-b06d-5f0e5f4f4da0	44e732e0-4a6d-48f0-be0d-be5b609d338a
22c29811-68e4-4c6d-b6f3-4813b65adcf9	e3e52ca7-2e9e-4f87-a818-5a808823089b	a739f123-1033-496e-a5fe-87511494480d	active	31206ec8-7ac4-40c3-b06d-5f0e5f4f4da0	22c29811-68e4-4c6d-b6f3-4813b65adcf9
221084c6-89c5-4f37-8c36-0fe2b86ec8f3	e3e52ca7-2e9e-4f87-a818-5a808823089b	9fd054d5-5bf7-402d-9a4b-bcc990552c1c	active	31206ec8-7ac4-40c3-b06d-5f0e5f4f4da0	221084c6-89c5-4f37-8c36-0fe2b86ec8f3
56618c5b-29f1-4f34-8381-bb05e487b31e	e3e52ca7-2e9e-4f87-a818-5a808823089b	0192601d-b976-4977-8264-1f517aaa780b	active	31206ec8-7ac4-40c3-b06d-5f0e5f4f4da0	56618c5b-29f1-4f34-8381-bb05e487b31e
7d531401-c829-4703-9649-1c6809debfa5	e3e52ca7-2e9e-4f87-a818-5a808823089b	43801850-5d9c-47d5-bc71-31c3aa4a18c5	active	31206ec8-7ac4-40c3-b06d-5f0e5f4f4da0	7d531401-c829-4703-9649-1c6809debfa5
c7bc0886-f429-4f9f-808b-d332a1a52f0d	e3e52ca7-2e9e-4f87-a818-5a808823089b	b83b6bd3-9559-4c39-9280-1f66345034a2	active	31206ec8-7ac4-40c3-b06d-5f0e5f4f4da0	c7bc0886-f429-4f9f-808b-d332a1a52f0d
f1bdfd21-0159-497c-9f7c-8ccfd13948d7	e3e52ca7-2e9e-4f87-a818-5a808823089b	f7d4c27e-998c-4f03-970c-509739212887	active	31206ec8-7ac4-40c3-b06d-5f0e5f4f4da0	f1bdfd21-0159-497c-9f7c-8ccfd13948d7
839e189b-4286-40cb-bcd8-ba9beabb0604	e3e52ca7-2e9e-4f87-a818-5a808823089b	45a0920e-01b6-4f46-9169-98b95fc5f193	active	31206ec8-7ac4-40c3-b06d-5f0e5f4f4da0	839e189b-4286-40cb-bcd8-ba9beabb0604
fc97aab6-3821-4495-be9b-8548a226bd94	e3e52ca7-2e9e-4f87-a818-5a808823089b	ab7981ff-d3a3-4ce0-af23-6c47307a62ce	active	31206ec8-7ac4-40c3-b06d-5f0e5f4f4da0	fc97aab6-3821-4495-be9b-8548a226bd94
16c15eb7-4379-4b7b-9c49-40da174f24c3	1399fe4b-2c07-4bda-a720-9df928d51816	0ec35598-db54-4019-864f-5e4d310662d2	active	46739a51-d0ab-416a-9dff-632a03351fcf	16c15eb7-4379-4b7b-9c49-40da174f24c3
638adb79-df2e-47e6-af4d-928eea49cae1	1399fe4b-2c07-4bda-a720-9df928d51816	b6afb46b-4d63-46d0-8b7e-f71d6d2fe500	active	46739a51-d0ab-416a-9dff-632a03351fcf	638adb79-df2e-47e6-af4d-928eea49cae1
44d6207b-bf96-4469-b407-2d93291f6d06	1399fe4b-2c07-4bda-a720-9df928d51816	87e157c1-1674-49ad-a7c9-14f54cd1b192	active	46739a51-d0ab-416a-9dff-632a03351fcf	44d6207b-bf96-4469-b407-2d93291f6d06
5b094084-f086-4640-988f-1e83a49025cf	cea11492-fdec-4cfc-a179-a4bbc05cac0b	d057758e-a4a2-4125-82bd-83b96a2136da	active	369831c1-22de-4dea-b0b7-b9a33cef2875	5b094084-f086-4640-988f-1e83a49025cf
5583815e-6393-4f36-80f8-18952115da3b	cea11492-fdec-4cfc-a179-a4bbc05cac0b	fd6ac7dd-6519-4f44-a78d-486fc41579eb	active	369831c1-22de-4dea-b0b7-b9a33cef2875	5583815e-6393-4f36-80f8-18952115da3b
36abd121-d9ba-400f-b957-63c4486e938f	cea11492-fdec-4cfc-a179-a4bbc05cac0b	b7475bec-cae2-48b0-a8fe-1f70658fb5ef	active	369831c1-22de-4dea-b0b7-b9a33cef2875	36abd121-d9ba-400f-b957-63c4486e938f
0502a7a4-4139-432f-9095-4c3ac09726ca	cea11492-fdec-4cfc-a179-a4bbc05cac0b	87e157c1-1674-49ad-a7c9-14f54cd1b192	active	369831c1-22de-4dea-b0b7-b9a33cef2875	0502a7a4-4139-432f-9095-4c3ac09726ca
2c23da45-0e36-4485-8d25-43a5826d7e47	41b0a731-3378-42bd-9e08-8b69a1fee83a	3ee14257-d6ea-40ee-8f8b-3293ab90cb79	active	0d252ab1-5819-41f4-af54-4036c3226e98	2c23da45-0e36-4485-8d25-43a5826d7e47
94625d74-5ef2-4a2a-8f4a-4853fdd5a46d	41b0a731-3378-42bd-9e08-8b69a1fee83a	89f5db50-4b21-4808-a4fe-523ec4ff414c	active	0d252ab1-5819-41f4-af54-4036c3226e98	94625d74-5ef2-4a2a-8f4a-4853fdd5a46d
53dd2252-ea9e-4dd6-b8aa-d396854e655f	41b0a731-3378-42bd-9e08-8b69a1fee83a	9f47f113-6785-4448-b15c-8b3eaf2032c9	active	0d252ab1-5819-41f4-af54-4036c3226e98	53dd2252-ea9e-4dd6-b8aa-d396854e655f
41e52d99-f758-4ed2-90ba-c422553e1bca	41b0a731-3378-42bd-9e08-8b69a1fee83a	3007a18b-d717-44fd-8281-943c0bd3d7f9	active	0d252ab1-5819-41f4-af54-4036c3226e98	41e52d99-f758-4ed2-90ba-c422553e1bca
654bcd86-62e6-43ea-a004-88869ff311bd	41b0a731-3378-42bd-9e08-8b69a1fee83a	d057758e-a4a2-4125-82bd-83b96a2136da	active	0d252ab1-5819-41f4-af54-4036c3226e98	654bcd86-62e6-43ea-a004-88869ff311bd
f3a09b8b-95d8-4f09-abd5-80c99a072b0b	41b0a731-3378-42bd-9e08-8b69a1fee83a	a7cee6ce-5b52-448c-8a41-c612a5d0b3b9	active	0d252ab1-5819-41f4-af54-4036c3226e98	f3a09b8b-95d8-4f09-abd5-80c99a072b0b
8ec29bb9-8040-46f7-9e7f-4e73a7351cda	41b0a731-3378-42bd-9e08-8b69a1fee83a	0a14592d-4d81-4ea4-a78a-884d16d67baa	active	0d252ab1-5819-41f4-af54-4036c3226e98	8ec29bb9-8040-46f7-9e7f-4e73a7351cda
f256d0e5-ca66-44fc-b0e6-ac0b5d03d747	41b0a731-3378-42bd-9e08-8b69a1fee83a	f59be7f4-6494-42a9-b21f-388930fca8cd	active	0d252ab1-5819-41f4-af54-4036c3226e98	f256d0e5-ca66-44fc-b0e6-ac0b5d03d747
952f4f62-5c73-4a65-8879-29d9bd53af8b	41b0a731-3378-42bd-9e08-8b69a1fee83a	e8584566-2520-4ffc-bcf6-202169e737a7	active	0d252ab1-5819-41f4-af54-4036c3226e98	952f4f62-5c73-4a65-8879-29d9bd53af8b
f1955559-b352-47d1-b6ad-cf914ead7d93	41b0a731-3378-42bd-9e08-8b69a1fee83a	71052f94-3fc6-4260-a2e4-dc0354275d88	active	0d252ab1-5819-41f4-af54-4036c3226e98	f1955559-b352-47d1-b6ad-cf914ead7d93
8eecd90d-b76e-4d6c-b2ae-f3a242fe9551	c4556598-bcc7-4c45-8ae8-bdafc367eaa2	e8584566-2520-4ffc-bcf6-202169e737a7	active	16ca20be-8985-498c-a6b3-29ecc4358399	8eecd90d-b76e-4d6c-b2ae-f3a242fe9551
c022f427-30eb-4c91-b14e-f906ff25b264	c4556598-bcc7-4c45-8ae8-bdafc367eaa2	87e157c1-1674-49ad-a7c9-14f54cd1b192	active	16ca20be-8985-498c-a6b3-29ecc4358399	c022f427-30eb-4c91-b14e-f906ff25b264
30424b16-5688-4188-93f1-c59d995ba798	c4556598-bcc7-4c45-8ae8-bdafc367eaa2	e2fbbd65-d33f-46a9-b1d6-2a49bd1c8497	active	16ca20be-8985-498c-a6b3-29ecc4358399	30424b16-5688-4188-93f1-c59d995ba798
1b892372-0a80-41f7-9072-b2b0ad723fbf	c4556598-bcc7-4c45-8ae8-bdafc367eaa2	d057758e-a4a2-4125-82bd-83b96a2136da	active	16ca20be-8985-498c-a6b3-29ecc4358399	1b892372-0a80-41f7-9072-b2b0ad723fbf
f66b8ddb-1992-44d5-83b7-b290986e08d0	c4556598-bcc7-4c45-8ae8-bdafc367eaa2	71052f94-3fc6-4260-a2e4-dc0354275d88	active	16ca20be-8985-498c-a6b3-29ecc4358399	f66b8ddb-1992-44d5-83b7-b290986e08d0
192f2255-066f-4174-b5b2-df938d70bd6c	c4556598-bcc7-4c45-8ae8-bdafc367eaa2	0f11fb91-d0f4-41e4-8934-53c2d6a8b598	active	16ca20be-8985-498c-a6b3-29ecc4358399	192f2255-066f-4174-b5b2-df938d70bd6c
8f259b93-56c5-4b6d-8bfc-b805d35d5cfb	41b0a731-3378-42bd-9e08-8b69a1fee83a	87e157c1-1674-49ad-a7c9-14f54cd1b192	active	1abb1bc3-9af2-4d48-ac1f-6ecbb7b8f3d0	8f259b93-56c5-4b6d-8bfc-b805d35d5cfb
f08751b2-5921-417d-b193-c1c3ece013ef	1399fe4b-2c07-4bda-a720-9df928d51816	71052f94-3fc6-4260-a2e4-dc0354275d88	active	59317601-caee-4b10-bc04-8f4ce5006fcc	f08751b2-5921-417d-b193-c1c3ece013ef
75893af9-eb1a-4bfa-b965-038350ac1243	1399fe4b-2c07-4bda-a720-9df928d51816	233655da-e83d-43e2-bb2a-cce9c6f3f391	active	59317601-caee-4b10-bc04-8f4ce5006fcc	75893af9-eb1a-4bfa-b965-038350ac1243
123b6af9-32fe-4ccc-959d-cbfe6ab2f9d0	1399fe4b-2c07-4bda-a720-9df928d51816	9cdf19fd-7d75-4e61-b6b2-0ebf17582683	active	59317601-caee-4b10-bc04-8f4ce5006fcc	123b6af9-32fe-4ccc-959d-cbfe6ab2f9d0
ca830eb5-f520-4e0a-af65-92635e5c62bf	1399fe4b-2c07-4bda-a720-9df928d51816	bf721b6b-74c7-43da-b80d-fc9c086ffc6b	active	59317601-caee-4b10-bc04-8f4ce5006fcc	ca830eb5-f520-4e0a-af65-92635e5c62bf
31e103fc-363b-493c-b0fc-b4020de8641a	1399fe4b-2c07-4bda-a720-9df928d51816	cc18bf9c-d21e-4ea2-9cf2-b1b9f16855b1	active	59317601-caee-4b10-bc04-8f4ce5006fcc	31e103fc-363b-493c-b0fc-b4020de8641a
9396b552-12f1-4639-8e8f-a47ee9966978	2a4bae91-082b-4ae5-9729-08c86e000ab5	be807861-8861-4f83-80fd-ad22da22d1d8	active	0a8e67c3-482a-4ef4-ac82-1a64eb975d4a	9396b552-12f1-4639-8e8f-a47ee9966978
240cf534-997d-48c4-bda8-986b9bcf0dec	2a4bae91-082b-4ae5-9729-08c86e000ab5	7cb00ab4-0502-4fe1-8314-db484a3781f3	active	0a8e67c3-482a-4ef4-ac82-1a64eb975d4a	240cf534-997d-48c4-bda8-986b9bcf0dec
1a85335a-fa99-4eb7-8823-d2971967aef0	2a4bae91-082b-4ae5-9729-08c86e000ab5	cf947468-a778-4c4b-8c5b-fc4ce7cd9bc0	active	0a8e67c3-482a-4ef4-ac82-1a64eb975d4a	1a85335a-fa99-4eb7-8823-d2971967aef0
308983a3-0f68-4531-b23e-455433130c3c	2a4bae91-082b-4ae5-9729-08c86e000ab5	3b95f7ef-56e7-4d11-aa64-0c078a4ba24c	active	0a8e67c3-482a-4ef4-ac82-1a64eb975d4a	308983a3-0f68-4531-b23e-455433130c3c
10f4aed3-def8-4402-9c2e-72ca34ed5401	2a4bae91-082b-4ae5-9729-08c86e000ab5	9aaf0eec-fc2a-4117-a8c4-c4e160b53db5	active	0a8e67c3-482a-4ef4-ac82-1a64eb975d4a	10f4aed3-def8-4402-9c2e-72ca34ed5401
cf94e7e0-4a60-4aaf-b147-32d35b5b7ae0	2a4bae91-082b-4ae5-9729-08c86e000ab5	c6152eae-a552-4cc0-8b5e-a0c72a6987b0	active	0a8e67c3-482a-4ef4-ac82-1a64eb975d4a	cf94e7e0-4a60-4aaf-b147-32d35b5b7ae0
9de1caa7-b5e0-40e7-92ca-1347453cbcef	2a4bae91-082b-4ae5-9729-08c86e000ab5	5ff8ddd6-e698-4a94-a563-f28d6cdf06bc	active	0a8e67c3-482a-4ef4-ac82-1a64eb975d4a	9de1caa7-b5e0-40e7-92ca-1347453cbcef
d3fd5931-c239-4718-b324-cbc6d7603939	2a4bae91-082b-4ae5-9729-08c86e000ab5	27eecd38-da7f-437c-aa78-e0468be5b594	active	0a8e67c3-482a-4ef4-ac82-1a64eb975d4a	d3fd5931-c239-4718-b324-cbc6d7603939
85f6b12d-3c22-4982-94a8-347859ad52c9	cd42a806-cac1-452c-9b0d-116d8ead4d64	a7cee6ce-5b52-448c-8a41-c612a5d0b3b9	active	85ec5f06-1543-41ef-9aaa-fa4f60123d60	85f6b12d-3c22-4982-94a8-347859ad52c9
f53aefaa-c9c6-4dab-b8cb-5f60ea426885	cd42a806-cac1-452c-9b0d-116d8ead4d64	fd6ac7dd-6519-4f44-a78d-486fc41579eb	active	85ec5f06-1543-41ef-9aaa-fa4f60123d60	f53aefaa-c9c6-4dab-b8cb-5f60ea426885
6adc4869-c189-4254-bb23-9865054c9644	cd42a806-cac1-452c-9b0d-116d8ead4d64	9f47f113-6785-4448-b15c-8b3eaf2032c9	active	85ec5f06-1543-41ef-9aaa-fa4f60123d60	6adc4869-c189-4254-bb23-9865054c9644
8e5c895b-f22e-4616-a13a-9ecadfb00bc3	cd42a806-cac1-452c-9b0d-116d8ead4d64	e8584566-2520-4ffc-bcf6-202169e737a7	active	85ec5f06-1543-41ef-9aaa-fa4f60123d60	8e5c895b-f22e-4616-a13a-9ecadfb00bc3
6fdd356b-4d8c-4bb9-9b5b-a52586ccd274	cd42a806-cac1-452c-9b0d-116d8ead4d64	3007a18b-d717-44fd-8281-943c0bd3d7f9	active	85ec5f06-1543-41ef-9aaa-fa4f60123d60	6fdd356b-4d8c-4bb9-9b5b-a52586ccd274
51d16926-a876-4147-8d64-599181770722	cd42a806-cac1-452c-9b0d-116d8ead4d64	c061a5ce-5435-47f8-840a-e36a4f315367	active	85ec5f06-1543-41ef-9aaa-fa4f60123d60	51d16926-a876-4147-8d64-599181770722
01a7b1c2-4e57-4c45-a240-029f66d00c7f	cd42a806-cac1-452c-9b0d-116d8ead4d64	d057758e-a4a2-4125-82bd-83b96a2136da	active	85ec5f06-1543-41ef-9aaa-fa4f60123d60	01a7b1c2-4e57-4c45-a240-029f66d00c7f
92b21f90-9a84-4142-8420-51dff344483a	e657011b-cf83-47ab-8bc8-62f6498046a6	be807861-8861-4f83-80fd-ad22da22d1d8	active	5ff6213f-387b-4fa1-b818-fd7c5e9151bc	92b21f90-9a84-4142-8420-51dff344483a
619be932-002b-4887-981b-a33e8c65874c	e657011b-cf83-47ab-8bc8-62f6498046a6	9aaf0eec-fc2a-4117-a8c4-c4e160b53db5	active	5ff6213f-387b-4fa1-b818-fd7c5e9151bc	619be932-002b-4887-981b-a33e8c65874c
0556c7f4-a484-4b2b-9f39-ef32ecc115ef	e657011b-cf83-47ab-8bc8-62f6498046a6	64b894ec-5075-4176-8f3b-ddb173f1deaf	active	5ff6213f-387b-4fa1-b818-fd7c5e9151bc	0556c7f4-a484-4b2b-9f39-ef32ecc115ef
642d0e7a-b380-4abc-b061-6da5524fbd8b	e657011b-cf83-47ab-8bc8-62f6498046a6	4b6b96b1-115c-40c9-815c-25a5110597ba	active	5ff6213f-387b-4fa1-b818-fd7c5e9151bc	642d0e7a-b380-4abc-b061-6da5524fbd8b
eba965e6-de87-4411-ba63-477c733f47c0	e657011b-cf83-47ab-8bc8-62f6498046a6	c6152eae-a552-4cc0-8b5e-a0c72a6987b0	active	5ff6213f-387b-4fa1-b818-fd7c5e9151bc	eba965e6-de87-4411-ba63-477c733f47c0
5d123234-b2c1-475c-b376-9fef68f7824b	e657011b-cf83-47ab-8bc8-62f6498046a6	3b95f7ef-56e7-4d11-aa64-0c078a4ba24c	active	5ff6213f-387b-4fa1-b818-fd7c5e9151bc	5d123234-b2c1-475c-b376-9fef68f7824b
8ccfb3e5-fa88-4457-94ad-075665a2d86f	e657011b-cf83-47ab-8bc8-62f6498046a6	9a74cff3-b7c7-4128-bb65-ff076be66019	active	5ff6213f-387b-4fa1-b818-fd7c5e9151bc	8ccfb3e5-fa88-4457-94ad-075665a2d86f
59ddf576-b047-455a-9b7f-0ed4682c095c	e657011b-cf83-47ab-8bc8-62f6498046a6	27eecd38-da7f-437c-aa78-e0468be5b594	active	5ff6213f-387b-4fa1-b818-fd7c5e9151bc	59ddf576-b047-455a-9b7f-0ed4682c095c
a0df62e6-a0ab-45b7-b98e-f6613eecca61	e657011b-cf83-47ab-8bc8-62f6498046a6	5ff8ddd6-e698-4a94-a563-f28d6cdf06bc	active	5ff6213f-387b-4fa1-b818-fd7c5e9151bc	a0df62e6-a0ab-45b7-b98e-f6613eecca61
da67eaf7-117b-4262-81f5-23a9f7c45ba7	2a4bae91-082b-4ae5-9729-08c86e000ab5	cf449447-3f45-4c68-8aac-8b5a4ec96f25	active	c5319ccb-aff6-41c5-a33d-6b63b203253d	da67eaf7-117b-4262-81f5-23a9f7c45ba7
2d254c7f-a266-4844-8e7c-cee0fa53d9b2	e657011b-cf83-47ab-8bc8-62f6498046a6	cf449447-3f45-4c68-8aac-8b5a4ec96f25	active	a08487f0-d7d1-4e72-be99-f37b95410ba4	2d254c7f-a266-4844-8e7c-cee0fa53d9b2
b524f6ca-6c88-4229-9242-9a83a346ea59	61d87eb7-e3d3-4f90-a3a8-b43b5362db1a	3007a18b-d717-44fd-8281-943c0bd3d7f9	active	b062326e-1f5d-48e3-a67b-9114ca9e15a4	b524f6ca-6c88-4229-9242-9a83a346ea59
2e0b3c2c-75a5-46f9-8dfa-b098723aeb8a	61d87eb7-e3d3-4f90-a3a8-b43b5362db1a	76b6bb6a-de74-4522-b4db-14a74a7320ba	active	b062326e-1f5d-48e3-a67b-9114ca9e15a4	2e0b3c2c-75a5-46f9-8dfa-b098723aeb8a
e3f00e75-00cf-4e34-9575-3e021a293c9b	61d87eb7-e3d3-4f90-a3a8-b43b5362db1a	f8ebae5a-f81c-40d6-9a08-5c1f375c4acf	active	b062326e-1f5d-48e3-a67b-9114ca9e15a4	e3f00e75-00cf-4e34-9575-3e021a293c9b
eb9eb97a-abdd-41c9-97aa-e6e7739c83b5	61d87eb7-e3d3-4f90-a3a8-b43b5362db1a	7fdbeb86-6300-4260-ac9a-4327519c6bb7	active	b062326e-1f5d-48e3-a67b-9114ca9e15a4	eb9eb97a-abdd-41c9-97aa-e6e7739c83b5
79eae32b-9b62-4364-8ada-8b6ef45247fb	61d87eb7-e3d3-4f90-a3a8-b43b5362db1a	920f0530-0a9e-49c0-9978-f3d9ff3925c4	active	b062326e-1f5d-48e3-a67b-9114ca9e15a4	79eae32b-9b62-4364-8ada-8b6ef45247fb
f1547c54-e148-4d0c-89b3-4ad3836a1cbb	61d87eb7-e3d3-4f90-a3a8-b43b5362db1a	5c72b096-cb94-4c1d-a976-3822e2690dc7	active	b062326e-1f5d-48e3-a67b-9114ca9e15a4	f1547c54-e148-4d0c-89b3-4ad3836a1cbb
0be6caae-4fc9-4314-a3be-be1f517ab7e1	61d87eb7-e3d3-4f90-a3a8-b43b5362db1a	d057758e-a4a2-4125-82bd-83b96a2136da	active	b062326e-1f5d-48e3-a67b-9114ca9e15a4	0be6caae-4fc9-4314-a3be-be1f517ab7e1
315839c4-4175-4274-85f8-9e0344c89820	61d87eb7-e3d3-4f90-a3a8-b43b5362db1a	c061a5ce-5435-47f8-840a-e36a4f315367	active	b062326e-1f5d-48e3-a67b-9114ca9e15a4	315839c4-4175-4274-85f8-9e0344c89820
0680d36d-c913-441c-9d22-2d062eee071d	61d87eb7-e3d3-4f90-a3a8-b43b5362db1a	c34cb669-4bf2-4571-895f-d9dfe3f945bf	active	b062326e-1f5d-48e3-a67b-9114ca9e15a4	0680d36d-c913-441c-9d22-2d062eee071d
3e389945-bbc2-4ac4-b626-f294343b0476	61d87eb7-e3d3-4f90-a3a8-b43b5362db1a	e8584566-2520-4ffc-bcf6-202169e737a7	active	b062326e-1f5d-48e3-a67b-9114ca9e15a4	3e389945-bbc2-4ac4-b626-f294343b0476
55aa0572-75c6-42e3-bfd9-81e53841ccf1	aac3a30b-36a9-4887-8aab-81c552bfc7d7	e8584566-2520-4ffc-bcf6-202169e737a7	active	ec886521-f454-451d-af59-53aadbcf4bbc	55aa0572-75c6-42e3-bfd9-81e53841ccf1
aa14c4ed-35cc-4347-960a-db8165b4db91	aac3a30b-36a9-4887-8aab-81c552bfc7d7	c061a5ce-5435-47f8-840a-e36a4f315367	active	ec886521-f454-451d-af59-53aadbcf4bbc	aa14c4ed-35cc-4347-960a-db8165b4db91
ad9902ca-2beb-4971-ac77-13983519ded2	aac3a30b-36a9-4887-8aab-81c552bfc7d7	a7cee6ce-5b52-448c-8a41-c612a5d0b3b9	active	ec886521-f454-451d-af59-53aadbcf4bbc	ad9902ca-2beb-4971-ac77-13983519ded2
dd87f9ae-c573-4d6b-b381-b45aacc25105	f1b3849e-9568-4cae-a3a0-3cca7f42c079	a7cee6ce-5b52-448c-8a41-c612a5d0b3b9	active	9fbb919a-209f-482e-89aa-7fd9e82a7989	dd87f9ae-c573-4d6b-b381-b45aacc25105
202cba8f-3e63-480b-b0ac-fadb251b9d7d	f1b3849e-9568-4cae-a3a0-3cca7f42c079	c061a5ce-5435-47f8-840a-e36a4f315367	active	9fbb919a-209f-482e-89aa-7fd9e82a7989	202cba8f-3e63-480b-b0ac-fadb251b9d7d
79abf9a1-0a5f-4d88-b0b7-c631bce47c9c	f1b3849e-9568-4cae-a3a0-3cca7f42c079	d057758e-a4a2-4125-82bd-83b96a2136da	active	9fbb919a-209f-482e-89aa-7fd9e82a7989	79abf9a1-0a5f-4d88-b0b7-c631bce47c9c
b60933b6-c962-4050-baa9-4810d0edb0be	f1b3849e-9568-4cae-a3a0-3cca7f42c079	76b6bb6a-de74-4522-b4db-14a74a7320ba	active	9fbb919a-209f-482e-89aa-7fd9e82a7989	b60933b6-c962-4050-baa9-4810d0edb0be
eb941ae1-0602-4dd5-80f7-fd3dfd1fcc96	aac3a30b-36a9-4887-8aab-81c552bfc7d7	f8ebae5a-f81c-40d6-9a08-5c1f375c4acf	active	6c8aeb30-34d5-4425-bfd7-c61adc9b2d8d	eb941ae1-0602-4dd5-80f7-fd3dfd1fcc96
079fa64f-21b9-4660-855e-08d55a39972d	27597355-d542-4574-adc8-6493883d1454	eb470e55-aafe-4855-968e-f6b29cfc849a	active	4859fec8-5318-4618-83d3-564fa1dcffd9	079fa64f-21b9-4660-855e-08d55a39972d
a6e62f5a-b7db-4b1e-9046-93367163f6b7	27597355-d542-4574-adc8-6493883d1454	7cf0b9f2-0688-4a33-becf-c4b375d4b1f9	active	4859fec8-5318-4618-83d3-564fa1dcffd9	a6e62f5a-b7db-4b1e-9046-93367163f6b7
dd8ec625-7660-494e-9d65-9b8fa76cb2c6	27597355-d542-4574-adc8-6493883d1454	1b7c7542-cbeb-4d25-84dd-acd74583925c	active	4859fec8-5318-4618-83d3-564fa1dcffd9	dd8ec625-7660-494e-9d65-9b8fa76cb2c6
49f1bcb9-fa5c-4623-8f09-e0081052bc31	27597355-d542-4574-adc8-6493883d1454	212a4b69-4d95-4262-8572-0892788ba9a3	active	4859fec8-5318-4618-83d3-564fa1dcffd9	49f1bcb9-fa5c-4623-8f09-e0081052bc31
c3d22762-0d9e-4cb7-a28c-0e4d6b4d80a4	27597355-d542-4574-adc8-6493883d1454	88028489-490a-4507-9f87-2d9a6e2d50bc	active	8cade445-98c7-4340-8aaa-34f0c304d0e9	c3d22762-0d9e-4cb7-a28c-0e4d6b4d80a4
71fce3f5-9694-45a0-8cc6-9aae4dd7817b	27597355-d542-4574-adc8-6493883d1454	babf872e-41d5-470e-88b1-8dedc68cf97d	active	8cade445-98c7-4340-8aaa-34f0c304d0e9	71fce3f5-9694-45a0-8cc6-9aae4dd7817b
8f0cb708-b4e5-4b7b-ae63-48957ba716e0	382ceece-628f-43b1-8847-ea92ff04376f	fd6ac7dd-6519-4f44-a78d-486fc41579eb	active	d982c3cc-785b-44af-9d31-fd3fb152558b	8f0cb708-b4e5-4b7b-ae63-48957ba716e0
2d12128d-da2e-4fb0-9c3f-332faef0b839	382ceece-628f-43b1-8847-ea92ff04376f	d057758e-a4a2-4125-82bd-83b96a2136da	active	d982c3cc-785b-44af-9d31-fd3fb152558b	2d12128d-da2e-4fb0-9c3f-332faef0b839
cc4710c3-e0af-4b08-8e9b-b7e235fadbc1	382ceece-628f-43b1-8847-ea92ff04376f	c6152eae-a552-4cc0-8b5e-a0c72a6987b0	active	d982c3cc-785b-44af-9d31-fd3fb152558b	cc4710c3-e0af-4b08-8e9b-b7e235fadbc1
265aa9bd-9c1f-4d09-bdf0-5a4e3bbcc6b5	382ceece-628f-43b1-8847-ea92ff04376f	71052f94-3fc6-4260-a2e4-dc0354275d88	active	d982c3cc-785b-44af-9d31-fd3fb152558b	265aa9bd-9c1f-4d09-bdf0-5a4e3bbcc6b5
ffb353f6-0b87-4416-958e-b20a94332db3	382ceece-628f-43b1-8847-ea92ff04376f	c90a28e2-4831-4ad0-bd51-c0649a3c54ee	active	d982c3cc-785b-44af-9d31-fd3fb152558b	ffb353f6-0b87-4416-958e-b20a94332db3
eb6a35d8-1002-477c-b643-a77ab300ae1d	382ceece-628f-43b1-8847-ea92ff04376f	87e157c1-1674-49ad-a7c9-14f54cd1b192	active	d982c3cc-785b-44af-9d31-fd3fb152558b	eb6a35d8-1002-477c-b643-a77ab300ae1d
6c64fb76-5d85-4687-82c9-7ce4de3a4e8c	382ceece-628f-43b1-8847-ea92ff04376f	97e4fca1-424e-45f2-aeee-db6db61d1737	active	d982c3cc-785b-44af-9d31-fd3fb152558b	6c64fb76-5d85-4687-82c9-7ce4de3a4e8c
4bdc7f8a-e2ef-48ca-aa81-cc3c5a1ebc4c	4f8c2ed1-52a1-4c94-854e-631daeb1a154	705d6aed-b1d5-4b89-ad38-be4a1daba35d	active	b4fc3c0a-6704-495c-b092-cbeec8f14ace	4bdc7f8a-e2ef-48ca-aa81-cc3c5a1ebc4c
28480c4f-a265-48ef-a5da-2e84247171ef	4f8c2ed1-52a1-4c94-854e-631daeb1a154	f839795f-58b2-4351-ad75-3c8d3df7f794	active	b4fc3c0a-6704-495c-b092-cbeec8f14ace	28480c4f-a265-48ef-a5da-2e84247171ef
3f65a516-c02d-4e72-bc40-d5c0a1477402	4f8c2ed1-52a1-4c94-854e-631daeb1a154	601cf29e-2b2d-405d-88a9-0dd7c3ae09e3	active	b4fc3c0a-6704-495c-b092-cbeec8f14ace	3f65a516-c02d-4e72-bc40-d5c0a1477402
801e51bc-6596-412a-bd1f-8a3fb83de173	4f8c2ed1-52a1-4c94-854e-631daeb1a154	c51c7ba1-34f9-4eea-9b79-ba2f9fa99f20	active	b4fc3c0a-6704-495c-b092-cbeec8f14ace	801e51bc-6596-412a-bd1f-8a3fb83de173
76079978-10ba-40d4-b18e-b5a64a9c7066	4f8c2ed1-52a1-4c94-854e-631daeb1a154	57a112e5-f2d5-4724-9aa3-c8730f1c19a4	active	b4fc3c0a-6704-495c-b092-cbeec8f14ace	76079978-10ba-40d4-b18e-b5a64a9c7066
2d09486d-efd7-4616-b2df-798972b7ec3f	4f8c2ed1-52a1-4c94-854e-631daeb1a154	247438c8-f5a4-489a-8918-afd6574bda6c	active	b4fc3c0a-6704-495c-b092-cbeec8f14ace	2d09486d-efd7-4616-b2df-798972b7ec3f
f6b2799a-511d-4c40-a6bb-af82afaa1e5e	4f8c2ed1-52a1-4c94-854e-631daeb1a154	2d518686-9f62-426f-9a2b-1b2fc94b90e4	active	b4fc3c0a-6704-495c-b092-cbeec8f14ace	f6b2799a-511d-4c40-a6bb-af82afaa1e5e
4aee7973-a182-45bf-97ce-6b9c61468dd5	4f8c2ed1-52a1-4c94-854e-631daeb1a154	0ab529c6-4551-432e-a566-bbfcfabc15b8	active	b4fc3c0a-6704-495c-b092-cbeec8f14ace	4aee7973-a182-45bf-97ce-6b9c61468dd5
f6b2799a-511d-4c40-a6bb-af82afaa1e5e	4f8c2ed1-52a1-4c94-854e-631daeb1a154	2d518686-9f62-426f-9a2b-1b2fc94b90e4	deleted	363e3792-e7f3-4248-84bc-3c828c049ba3	f6b2799a-511d-4c40-a6bb-af82afaa1e5e
2ff3194d-fea1-49a0-bd82-3ae5f941df27	e6833b4c-3f1e-4394-a547-790258b451e5	9aaf0eec-fc2a-4117-a8c4-c4e160b53db5	active	da99599d-79c0-47b0-8f59-3f2fc4bf3bed	2ff3194d-fea1-49a0-bd82-3ae5f941df27
3c651dac-8307-4f01-b051-e2d980d41b89	e6833b4c-3f1e-4394-a547-790258b451e5	1812b303-186d-4734-a4cb-1345949485d9	active	da99599d-79c0-47b0-8f59-3f2fc4bf3bed	3c651dac-8307-4f01-b051-e2d980d41b89
79f3a614-4329-42dc-b41f-1ee299daa45b	e6833b4c-3f1e-4394-a547-790258b451e5	7fdbeb86-6300-4260-ac9a-4327519c6bb7	active	da99599d-79c0-47b0-8f59-3f2fc4bf3bed	79f3a614-4329-42dc-b41f-1ee299daa45b
e2ef9941-9068-4a2f-bca2-e5407166d1aa	e6833b4c-3f1e-4394-a547-790258b451e5	473f15dd-47c0-40a6-89e9-3a053ab172a4	active	da99599d-79c0-47b0-8f59-3f2fc4bf3bed	e2ef9941-9068-4a2f-bca2-e5407166d1aa
6c9e276a-0ef6-4606-a1f4-21ea865998d7	e6833b4c-3f1e-4394-a547-790258b451e5	0485e497-11ba-4033-b412-fcb97816c5b6	active	da99599d-79c0-47b0-8f59-3f2fc4bf3bed	6c9e276a-0ef6-4606-a1f4-21ea865998d7
4f65c13d-8433-45e6-b9ff-bf5344781645	e6833b4c-3f1e-4394-a547-790258b451e5	6535de51-8e81-49ba-9a0f-c81f3688b890	active	da99599d-79c0-47b0-8f59-3f2fc4bf3bed	4f65c13d-8433-45e6-b9ff-bf5344781645
610e94e2-5671-45c5-9c69-04b8b36e3ae6	e6833b4c-3f1e-4394-a547-790258b451e5	6462e1a0-5395-4bb3-aa23-c73ae5877c25	active	da99599d-79c0-47b0-8f59-3f2fc4bf3bed	610e94e2-5671-45c5-9c69-04b8b36e3ae6
8b609621-3046-45a1-bcc2-f8f0d0614960	e6833b4c-3f1e-4394-a547-790258b451e5	bf811c75-eb5f-47e1-8b87-c4119912c88c	active	da99599d-79c0-47b0-8f59-3f2fc4bf3bed	8b609621-3046-45a1-bcc2-f8f0d0614960
7ac28701-979e-499e-bd11-6825e82a33a0	e6833b4c-3f1e-4394-a547-790258b451e5	27eecd38-da7f-437c-aa78-e0468be5b594	active	da99599d-79c0-47b0-8f59-3f2fc4bf3bed	7ac28701-979e-499e-bd11-6825e82a33a0
\.


--
-- Data for Name: rating; Type: TABLE DATA; Schema: public; Owner: ckantest
--

COPY rating (id, user_id, user_ip_address, package_id, rating, created) FROM stdin;
f215d02f-a875-4f37-98ba-7dd9fc29252e	\N	82.230.236.176	587ed76e-1c2f-4cc7-a23a-f9beb2415c77	5	2010-11-28 03:53:02.879329
e45ebcb9-a4c6-4a0b-9fcf-122c0f88c5b7	85c45de1-ea32-46c3-b737-c22b5351f523	\N	1901d722-a38d-4e79-a13c-ca51d61bae30	5	2010-11-28 04:05:11.838884
ec8aab24-b859-4295-94ac-bbd7d5c333dc	85c45de1-ea32-46c3-b737-c22b5351f523	\N	587ed76e-1c2f-4cc7-a23a-f9beb2415c77	3	2010-11-28 04:09:25.198758
6d3b2d08-b0b0-4190-8471-a01a3eb6750b	\N	78.114.86.208	4402487d-3e8d-4618-8444-b400c6337834	4	2010-11-28 12:39:47.496477
35290521-29a8-41cc-aa76-2c96aae0dbb8	\N	88.168.235.30	4402487d-3e8d-4618-8444-b400c6337834	5	2010-11-28 12:53:43.105123
569ca0e3-3fda-42b4-b24f-ae6a63c7a5de	\N	83.201.1.25	1901d722-a38d-4e79-a13c-ca51d61bae30	5	2010-11-30 10:52:50.691252
4a8b08b5-889d-415b-b42e-1f898c0e4005	bde1f833-bd6e-4d15-99ef-790062a28a01	\N	43c3cc44-3a6c-469b-80fe-913927d2c283	4	2010-12-02 11:38:52.457282
2c866c6d-25c0-4298-8d61-29056b300bb2	\N	93.182.216.28	43c3cc44-3a6c-469b-80fe-913927d2c283	5	2010-12-02 20:24:06.361702
b368850a-9f87-424f-afa4-3985849d45bf	\N	91.205.96.19	43c3cc44-3a6c-469b-80fe-913927d2c283	5	2010-12-03 03:02:05.722215
6a817ca8-683a-49cd-b5e5-49974b361b64	\N	82.80.230.228	65d7e18e-c5ab-4736-bb9e-c47de2dc41e1	5	2010-12-04 13:16:04.075664
09cac762-ca11-45a7-9893-57ecd8343d8d	\N	91.205.96.19	5b23d4f4-058e-44e0-945d-ae9035fb1e15	2	2010-12-03 03:05:15.1377
c151135d-58c2-44a8-a1ab-42fd01930018	\N	91.205.96.19	587ed76e-1c2f-4cc7-a23a-f9beb2415c77	5	2010-12-03 03:01:27.688148
f52f420f-951c-4f79-a5be-3f96167ebf18	\N	91.205.96.19	4402487d-3e8d-4618-8444-b400c6337834	5	2010-12-03 03:06:39.556747
64d9d98a-2a3f-415f-a414-a90bb179b4eb	\N	91.205.96.19	5e86134f-2cb5-40e9-affa-f80d934a14b9	1	2010-12-03 03:06:30.042806
46aa6cfd-e5ec-48ce-bb3f-8f327da9a55c	\N	91.205.96.19	be516eed-8a37-436c-af75-b623f0806f39	1	2010-12-03 03:07:20.313907
a0ab411b-b620-4db6-9825-533ba14cd680	\N	193.52.108.46	1901d722-a38d-4e79-a13c-ca51d61bae30	4	2010-12-03 10:43:46.061834
de05f74a-92cd-40d5-8a5a-bf2de09661cf	\N	85.115.60.180	43c3cc44-3a6c-469b-80fe-913927d2c283	5	2010-12-03 10:56:11.923669
8076bb49-a304-4e4a-8a63-a6a323787889	\N	78.125.244.239	4402487d-3e8d-4618-8444-b400c6337834	4	2010-12-13 04:02:29.396582
10005c38-b024-4acf-a75f-786fc9d310f6	\N	79.141.205.40	4402487d-3e8d-4618-8444-b400c6337834	4	2010-12-19 01:50:50.932326
60924f51-714e-4864-b535-57d983c586c6	\N	79.141.205.40	3aa0d5ce-cef6-4158-b51e-ddee8ece7b5e	5	2010-12-19 01:59:10.618148
2e6be810-7a33-412c-915d-f931d4a39519	\N	82.80.230.228	be516eed-8a37-436c-af75-b623f0806f39	5	2010-12-04 13:11:52.59733
1878dd52-462a-4a77-bfa0-b16e4d8b6779	\N	82.80.230.228	4402487d-3e8d-4618-8444-b400c6337834	5	2010-12-04 13:16:42.188464
f3197767-4d13-4671-8b82-b38fa2b70379	\N	82.80.230.228	e4c69e90-1056-4f46-9619-57d0a18d1737	5	2010-12-04 13:21:10.737544
60284be6-81c4-422d-b8fd-9ef0d33c2c09	\N	82.80.230.228	1901d722-a38d-4e79-a13c-ca51d61bae30	5	2010-12-04 13:12:30.271233
8fe09b5b-b4e8-43fb-a4a4-72896a76524b	\N	82.230.236.176	34269022-c891-4a8e-a814-3af2b0fea526	1	2011-01-04 11:37:32.072982
aef7d621-f5c8-4742-b071-bc8fd0206d55	\N	82.80.230.228	5b23d4f4-058e-44e0-945d-ae9035fb1e15	5	2010-12-04 13:17:26.641269
4142c853-53ec-4aab-af97-a89dfcddc5e1	\N	82.80.230.228	6d999f74-d520-4a8c-8188-5a5c13c6bbec	5	2010-12-04 13:13:11.187545
0ac44a7e-0389-46a2-98d6-a8c4668725f0	\N	92.130.236.154	4402487d-3e8d-4618-8444-b400c6337834	5	2011-03-10 22:19:17.707251
425eff7d-4759-4407-8f52-e0cb534ebf7a	\N	82.80.230.228	43c3cc44-3a6c-469b-80fe-913927d2c283	5	2010-12-04 13:13:54.659111
f374b022-701d-449b-89ea-cf68cfe94337	\N	82.80.230.228	587ed76e-1c2f-4cc7-a23a-f9beb2415c77	5	2010-12-04 13:22:06.236292
2ac73324-ec1b-4a01-a59b-543b2e1dfb78	\N	82.80.230.228	5e86134f-2cb5-40e9-affa-f80d934a14b9	5	2010-12-04 13:18:10.148451
9ac7737e-81a0-48f4-a23c-018f8dca6b26	\N	82.80.230.228	3aa0d5ce-cef6-4158-b51e-ddee8ece7b5e	5	2010-12-04 13:14:37.10462
04106e7d-7c23-4721-89ba-8a03206e1658	\N	79.83.162.152	1901d722-a38d-4e79-a13c-ca51d61bae30	5	2010-12-04 19:57:52.752745
eaae1e01-bef4-4f4e-a57f-37f04adec1dc	\N	82.229.192.221	34269022-c891-4a8e-a814-3af2b0fea526	5	2010-12-04 20:59:04.368347
4747a96b-7e58-4450-aedd-9acddaf21e06	\N	82.80.230.228	db34f769-ed94-45d3-8b66-5ebaf9b091ff	5	2010-12-04 13:15:21.681408
f2bf52dc-b9c4-4ab1-bf58-a4ac1c4a32e4	\N	82.80.230.228	e3424ea9-f7c0-4d80-832b-890c3de0f744	5	2010-12-04 13:18:50.601356
a7da437a-17ca-4f58-924e-2bb9234da174	a8593e73-81e1-40f7-b53a-e21e2f1a8a6f	\N	a1019da5-cdac-4e09-8b60-831994b5f275	1	2010-12-05 11:19:23.81076
683da3e5-5bcf-4007-9bc5-977b33ffbba5	\N	88.168.238.200	6968ef13-1d2f-4de3-b533-706bc9c0f604	5	2010-12-05 19:17:13.076447
53bd03db-7cb6-48e6-858f-7d0e4460186a	\N	212.99.95.116	5e86134f-2cb5-40e9-affa-f80d934a14b9	5	2010-12-06 08:20:17.260887
c75591d3-9da6-4a6b-9a4c-5a9bdaf656e0	\N	195.6.127.12	0e14dccb-9c28-4f89-b3b2-cb1011be06d1	5	2010-12-06 14:33:00.994743
ad2fa738-5ed8-4a44-81fd-5e1eb1d807f6	\N	82.80.230.228	4235252c-aa21-46b5-8c52-110f95bdc583	5	2010-12-04 13:19:32.99238
4e90b310-fc93-4da4-a608-5d930b77bd63	\N	77.204.20.2	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	5	2010-12-07 16:10:36.827467
93547d97-c85c-434c-8946-2b44ac74ba2c	\N	90.1.91.197	34269022-c891-4a8e-a814-3af2b0fea526	5	2010-12-08 22:38:24.811436
388dbc94-8fe8-49fb-9634-b378678fafd4	\N	86.64.30.195	be516eed-8a37-436c-af75-b623f0806f39	2	2010-12-09 08:48:27.460757
a6ded87e-6f3e-4e8a-9955-8accf6fc7a41	\N	82.80.230.228	97b2cf1e-91f4-4b08-a7d8-2e6bd1dca37e	5	2010-12-04 13:20:20.865235
622758d9-baa1-48c2-bff3-286f1d9ca6c0	\N	86.64.30.195	1901d722-a38d-4e79-a13c-ca51d61bae30	2	2010-12-09 08:49:04.272687
5f0d8dd0-469e-4706-8a45-30c6651f87d6	\N	86.64.30.195	6d999f74-d520-4a8c-8188-5a5c13c6bbec	1	2010-12-09 08:49:50.208664
f47a51a1-5053-40fe-8787-6f4c029bb032	\N	150.70.64.203	be516eed-8a37-436c-af75-b623f0806f39	2	2010-12-09 08:51:01.534096
4a8b9355-e77a-4735-b4e9-2afb0e2d4b0d	\N	86.64.30.195	34269022-c891-4a8e-a814-3af2b0fea526	3	2010-12-09 08:51:40.070779
61583e8a-69ec-4785-a174-3cf40580a35a	\N	150.70.64.203	6d999f74-d520-4a8c-8188-5a5c13c6bbec	1	2010-12-09 08:53:16.545574
b78e19bc-fbc6-490e-8adb-95acc58b5d34	\N	150.70.75.28	1901d722-a38d-4e79-a13c-ca51d61bae30	2	2010-12-09 09:05:05.224312
cd290e68-e0ad-4579-bfa6-7e2288c507c9	\N	82.229.12.55	34269022-c891-4a8e-a814-3af2b0fea526	5	2011-01-21 17:49:10.460615
22ef3cc0-48ba-42a5-9afb-5671b1fde5fe	\N	82.127.104.31	43c3cc44-3a6c-469b-80fe-913927d2c283	4	2011-02-04 08:55:55.431154
32c7041b-f5ec-448c-838b-dd31c58ac73e	\N	193.55.96.13	0e14dccb-9c28-4f89-b3b2-cb1011be06d1	5	2011-03-04 17:23:49.879993
70bff548-b104-4c83-a4df-2600d0d9f0bd	\N	88.161.154.132	a1019da5-cdac-4e09-8b60-831994b5f275	1	2011-03-21 14:07:07.313426
e5337998-61e8-4b89-affe-4ce727284726	\N	212.113.37.105	587ed76e-1c2f-4cc7-a23a-f9beb2415c77	5	2011-03-15 13:46:41.782366
ecb99010-df58-461a-a1ca-24677f1b7749	\N	193.252.149.13	4276f7df-c7e9-44e1-8886-20ad41ebda0a	1	2011-03-22 15:04:31.237671
7441a83e-28c9-4ee3-bf4a-226471db9261	\N	192.86.100.29	430e39ad-4906-44ba-83bc-8f2bc6f2d039	5	2011-03-22 15:24:53.789504
4ca59c24-3a5d-49bb-a4e7-f98d49688cea	\N	81.52.143.33	4276f7df-c7e9-44e1-8886-20ad41ebda0a	2	2011-03-28 17:20:26.277625
34bd43da-8e02-447c-9fbe-670b1061ef0a	\N	84.14.82.2	6968ef13-1d2f-4de3-b533-706bc9c0f604	5	2011-03-28 18:19:33.177817
27ef8f00-ef2f-4b13-9777-42f140e95bf2	\N	81.52.143.30	4276f7df-c7e9-44e1-8886-20ad41ebda0a	5	2011-03-30 15:21:59.251937
12967f41-1f32-4f73-8072-f999f939a58a	\N	81.52.143.37	4276f7df-c7e9-44e1-8886-20ad41ebda0a	3	2011-04-01 17:19:27.131783
f65a7c8d-6b1b-4067-a75e-3a39a36914b4	\N	193.252.118.176	4276f7df-c7e9-44e1-8886-20ad41ebda0a	4	2011-04-03 01:11:24.321348
2bba1069-8b79-4c6f-9171-4f08e53e1a52	\N	207.241.237.227	4402487d-3e8d-4618-8444-b400c6337834	2	2011-09-08 03:14:28.465838
e37e0bf7-b325-4b8b-8fa1-073f24beb7a4	\N	183.178.84.87	e3424ea9-f7c0-4d80-832b-890c3de0f744	1	2011-09-08 07:13:32.787676
a750b4a3-7f6c-4b5c-92f6-4106d3645528	\N	72.14.164.72	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	4	2011-08-27 12:11:54.36096
ccffebcf-0f68-449b-879b-159493627d7f	\N	207.241.237.227	48a03f6f-f8f4-4758-8672-f8ab8bd10acb	2	2011-09-26 18:37:28.141837
396efa8e-62d7-45d4-8f68-c35ceadd405f	\N	93.1.23.35	0e14dccb-9c28-4f89-b3b2-cb1011be06d1	5	2011-09-20 16:02:14.612661
669d6826-45da-4cba-96b4-72d35966e03b	\N	183.178.84.87	0e14dccb-9c28-4f89-b3b2-cb1011be06d1	2	2011-09-21 06:07:57.674952
d1d2d945-06c9-4961-a1cf-16311858ce63	\N	72.14.164.72	6d999f74-d520-4a8c-8188-5a5c13c6bbec	3	2011-08-27 12:17:09.893032
928709a2-5ab7-4193-b342-bdd541d6e565	\N	207.241.237.227	4dbf7c31-5115-4700-963d-91f23f76aaa4	3	2011-09-17 05:04:17.634558
4e158d17-e0c5-410f-a70e-bddf22b99810	\N	72.14.164.72	30bcda76-5a1a-4369-a6f3-ed2584ad4031	3	2011-08-27 12:23:10.766071
f52d616a-1288-4a26-8045-27e1239eb891	\N	183.178.84.87	fe7cd753-376f-4f22-a721-caa482aa1116	3	2011-08-28 22:40:28.6562
fc58a831-0b99-4a00-908a-e0038820de6a	\N	207.241.237.227	205c33b6-106f-40c3-804c-a2835f6104a9	5	2011-08-31 06:03:34.469031
8cd68ef7-8210-45e3-a580-e15ae6d1b063	\N	38.101.148.126	4402487d-3e8d-4618-8444-b400c6337834	5	2011-04-05 23:22:09.68004
675534fd-7800-490c-8cca-beda1d73ad51	\N	213.41.246.210	5e86134f-2cb5-40e9-affa-f80d934a14b9	1	2011-04-12 14:32:15.208701
427bbe3f-13c8-4acf-bc0b-1ad79c15bad0	bb4ee2e5-b33c-4b71-b698-d582b4cf8277	\N	78e9e396-2ab2-4d61-9eea-fe08b840dbf9	5	2011-04-20 13:32:18.40403
f485f875-c976-4ba6-9bdc-40f94c4923cd	\N	88.186.144.220	1901d722-a38d-4e79-a13c-ca51d61bae30	5	2011-04-27 17:05:00.057402
9240cea5-89eb-48ba-9bab-f6884bf8726f	\N	193.213.29.29	5b23d4f4-058e-44e0-945d-ae9035fb1e15	1	2011-07-19 15:05:39.628391
f66667e2-62f4-4086-a3a5-de9e21a70e65	\N	207.241.237.227	8d7560cf-6d61-45dd-bf05-44ae257e97a4	1	2011-08-31 16:22:12.050243
758c0edd-ca42-46c1-b801-c26811c4bf61	\N	207.241.237.227	8a7d516b-f3c2-4a5b-afde-d2bdff371937	2	2011-08-16 21:14:17.762471
39f7987a-b2d4-4399-910a-2251cc4b8d86	\N	193.213.29.29	5b23d4f4-058e-44e0-945d-ae9035fb1e15	4	2011-07-19 15:05:39.66962
19a4b326-313b-432a-aec0-34452518a3c9	\N	207.241.237.227	83e56067-9ee5-48b2-83d0-91e723eb8b3d	5	2011-08-09 22:14:40.957035
cbd70b4a-2103-4d29-82d6-6b1053ae0d8d	\N	207.241.237.227	78e9e396-2ab2-4d61-9eea-fe08b840dbf9	3	2011-08-11 10:57:59.260954
220b7d8f-5b9b-41e7-aaf1-2dfff983281f	\N	207.241.237.227	30bcda76-5a1a-4369-a6f3-ed2584ad4031	1	2011-09-03 16:49:43.918618
3240f1d3-c591-43b4-ae80-0dcdf84b73a0	\N	183.178.84.87	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	3	2011-09-02 21:17:06.931916
6cd11856-d523-4773-82c8-52b3992fd021	\N	207.241.237.227	34269022-c891-4a8e-a814-3af2b0fea526	3	2011-08-14 17:16:33.298513
ba23405c-3f2b-4565-9058-b2d5ab82b149	\N	207.241.237.227	b9582bd1-bfff-41e1-990f-962c18084f4d	1	2011-08-15 06:09:25.030243
0f701adf-8b16-4f0e-84e7-258c0d42d24d	\N	183.178.84.87	9382520e-adb5-4403-848d-5bd5ea476202	5	2011-08-17 21:44:26.201511
9ebd762b-f601-4f0b-85d1-7770c6b32fb2	\N	207.241.237.227	4654898f-58f4-482f-a91f-23aa5e192fd8	5	2011-08-30 03:48:54.09134
28a4d549-e169-40ed-9c7a-cd803c28de32	\N	183.178.84.87	3d4e64cc-54c0-4b3e-b865-2fff3d9845e7	2	2011-08-22 01:04:45.861879
4cc6ee7c-bf12-487b-bf8d-0fdd9ff48e1c	\N	70.51.14.92	65d7e18e-c5ab-4736-bb9e-c47de2dc41e1	1	2011-08-23 12:26:43.069371
666dac33-a69f-4583-8079-5ad025ea9980	\N	183.178.84.87	29772378-f226-4fc8-8e01-9a87c5e43a00	1	2011-08-14 01:47:20.27529
4034b7d6-d731-40e0-87ce-629f2be816a3	\N	207.241.237.227	584d3863-eecc-4595-8a18-145ba2b213f7	2	2011-08-17 12:53:18.72594
b6c0c5da-beb3-41fc-926e-31fd6232783f	\N	183.178.84.87	587ed76e-1c2f-4cc7-a23a-f9beb2415c77	5	2011-08-12 19:29:25.79081
57ff685c-7a00-486c-a70a-73f5e15d930a	\N	207.241.237.227	09d5ff25-7a8a-4228-9093-bb437bb70f1a	4	2011-09-06 05:55:21.326047
cb4670e1-6fd9-47c7-9795-f8c663de777c	\N	72.14.164.72	f6c6aac7-3c9b-4a3c-80bc-d6709bc95d4b	5	2011-08-27 12:04:17.127043
2668f5aa-907d-42c3-8e54-39c2229b5a37	\N	183.178.84.87	97b2cf1e-91f4-4b08-a7d8-2e6bd1dca37e	4	2011-09-07 13:14:50.913582
fe663121-9be4-4398-b504-57df2519db97	\N	212.85.152.17	8d9cf757-de83-4774-919b-00c45c43efd4	3	2011-09-09 10:32:36.722422
5ce47a3e-fc77-45cf-a92e-a470f36bdef5	\N	80.14.145.200	8d9cf757-de83-4774-919b-00c45c43efd4	1	2011-09-09 17:05:01.439438
502227a3-6dca-4490-94c7-998449fd79fa	\N	207.241.237.227	641c249c-f473-4d8e-bd8e-f385157f2682	2	2011-09-25 03:48:34.633099
e4e77f03-e9a4-4dd9-a989-5a59a2e8bfd3	\N	178.79.140.240	5a3d4806-974f-4754-b6cb-65a7dfa27548	5	2011-10-01 23:51:11.698381
949cb1af-d549-4756-97d3-768d7c69f089	\N	183.178.84.87	8a7d516b-f3c2-4a5b-afde-d2bdff371937	4	2011-09-25 18:49:17.477841
ebcd1121-f56e-4322-a2bb-e6dec9c68141	\N	207.241.237.227	430e39ad-4906-44ba-83bc-8f2bc6f2d039	4	2011-09-24 21:40:53.141948
fe498eec-1193-47bc-b2b6-03bfbf4e7647	\N	207.241.237.227	1901d722-a38d-4e79-a13c-ca51d61bae30	1	2011-09-28 14:22:53.219635
d45446b0-65fb-4a97-af7f-d8a16d4d0adc	\N	183.178.84.87	e1b56ce2-aea6-4d44-b877-86a13f92697c	3	2011-09-23 21:17:23.128332
84779791-81c2-4524-9596-fc58a92e728a	\N	183.178.84.87	ced8947c-7c6b-4874-ad5e-c28ba91f8073	4	2011-09-27 02:08:30.272056
d32a2393-b20c-4276-905f-981a010e6669	\N	183.178.84.87	83e56067-9ee5-48b2-83d0-91e723eb8b3d	1	2011-09-23 16:18:49.884242
6e66265a-44c8-4ff2-85cc-166dc1a22d70	\N	183.178.84.87	5efedd90-782d-4129-8e71-fdd3b6e1c7df	3	2011-09-22 03:07:05.991855
5bd0888f-61d9-4724-aab4-6245ac99614b	\N	178.79.140.240	78e9e396-2ab2-4d61-9eea-fe08b840dbf9	5	2011-10-01 23:51:11.467504
a06f475f-d978-4183-96e5-08d87eebe3f1	\N	178.79.140.240	f1261a91-9d52-4520-837e-e9c793f28dcc	5	2011-10-01 23:51:11.823084
668dafe0-82f1-476e-907c-86e67effb45e	\N	178.79.140.240	5efedd90-782d-4129-8e71-fdd3b6e1c7df	5	2011-10-01 23:51:12.04884
f5270905-4ce3-40b9-b9ac-1c8f5b64e33f	\N	178.79.140.240	cd2385b8-fa33-4be9-82a8-9ceda07fdc75	5	2011-10-01 23:51:12.306822
33061735-c5cc-4231-9ec3-09868095f25d	\N	178.79.140.240	4402487d-3e8d-4618-8444-b400c6337834	5	2011-10-01 23:51:12.587624
50b173cf-19dd-473f-9c70-c9dff60eb04e	\N	178.79.140.240	6d999f74-d520-4a8c-8188-5a5c13c6bbec	5	2011-10-01 23:51:12.817174
fd08b345-e041-4387-a74d-3b3c638578b5	\N	178.79.140.240	30bcda76-5a1a-4369-a6f3-ed2584ad4031	5	2011-10-01 23:51:12.922439
29c024e5-e71e-4abb-9401-760ca56a9545	\N	178.79.140.240	e4c69e90-1056-4f46-9619-57d0a18d1737	5	2011-10-01 23:51:14.483506
5fe81d96-8742-4123-8cc6-94ed94b065e2	\N	20.142.116.36	8d7560cf-6d61-45dd-bf05-44ae257e97a4	1	2011-10-13 12:19:04.789374
1b577414-51bb-4879-bd3b-8a669f333175	\N	183.178.84.87	f3d8ca3c-32b9-4485-95d9-0b1fd4a5dd4e	5	2011-09-21 13:18:26.526995
ad5052d9-d869-4064-8a19-850b8ba3bfb5	\N	176.74.192.87	0e14dccb-9c28-4f89-b3b2-cb1011be06d1	1	2011-10-14 00:08:23.836171
18672425-a43e-4b56-90eb-0f28fa262ab9	\N	176.74.192.87	5efedd90-782d-4129-8e71-fdd3b6e1c7df	1	2011-10-14 00:08:27.006995
0d7aec98-ec25-4e52-af4f-554a53e7d8d4	\N	176.74.192.87	48a03f6f-f8f4-4758-8672-f8ab8bd10acb	1	2011-10-14 00:08:31.666925
45b45b4d-4f08-428a-a62c-e67256c88e08	\N	176.74.192.87	d794f07a-06d3-4b59-a969-c00af70ff8db	3	2011-10-14 00:08:27.838506
6fb704fd-f8a4-4607-af5b-149129858960	\N	176.74.192.87	e3424ea9-f7c0-4d80-832b-890c3de0f744	1	2011-10-14 00:08:32.825875
f78f8b2e-7ef4-4bdb-b548-3f8bae6270bb	\N	176.74.192.87	34269022-c891-4a8e-a814-3af2b0fea526	1	2011-10-14 00:08:42.554461
5401d2d4-42e8-4b0d-9586-12526d45f86a	\N	176.74.192.87	205c33b6-106f-40c3-804c-a2835f6104a9	1	2011-10-14 00:08:45.017378
ee52f12a-7ef8-41c4-a03a-b395a3f32391	\N	176.74.192.87	4235252c-aa21-46b5-8c52-110f95bdc583	2	2011-10-14 00:08:54.550951
60e9271d-a833-4aad-b391-d2b42f51d2a4	\N	176.74.192.87	20100c39-31ae-4fd4-ad35-bfeabe396b5f	2	2011-10-14 00:08:59.920888
99ceab25-b4dd-4124-acc5-1cedd51d162d	\N	176.74.192.87	584d3863-eecc-4595-8a18-145ba2b213f7	2	2011-10-14 00:08:50.117232
b17bcbf5-dd40-4e75-a79c-ff5f9265613f	\N	176.74.192.87	60e23204-8e78-487c-92bd-5de0c6102067	1	2011-10-14 00:09:10.165422
92dc562d-0ee7-4505-ab6c-8cc0b12bbfbf	\N	176.74.192.87	1c17435c-508d-4194-9d06-f923d31c60cf	1	2011-10-14 00:08:26.721866
6cd8fec4-dfc5-4e83-955c-67bc3043993f	\N	176.74.192.87	624552ff-a7cd-427d-88e3-f31ec6dba89b	1	2011-10-14 00:09:19.972466
e8779392-8ed0-4ca9-87e6-117a4d545cae	\N	176.74.192.87	4276f7df-c7e9-44e1-8886-20ad41ebda0a	4	2011-10-14 00:08:23.402781
a7fa1002-e565-40a1-a927-48fcac09d233	\N	176.74.192.87	69361720-3428-417e-beb4-d21df542992c	1	2011-10-14 00:09:02.012336
ebae4308-f24d-4539-bc87-8b7b3d764296	\N	176.74.192.87	b57f2ed1-ee10-469b-afcc-a4d7636d39c7	4	2011-10-14 00:08:51.338319
5c05cb20-dc87-403b-bc10-ac5c77a2f52d	\N	176.74.192.87	f4517261-c1ee-4380-b3ad-0de5a0edc09a	1	2011-10-14 00:08:22.963891
dcc37409-8ea3-41aa-b889-746ab8e8e3c2	\N	176.74.192.87	8d447067-389f-4c39-ba51-63430a736df4	1	2011-10-14 00:08:22.835957
4195a4e7-f8a0-41bb-b51b-f5aa579c5c8f	\N	176.74.192.87	9db98dbb-0a64-4588-8e57-533f05a6e050	1	2011-10-14 00:09:33.545592
7b12944d-2324-498c-a2bf-869f9c07710f	\N	176.74.192.87	9382520e-adb5-4403-848d-5bd5ea476202	1	2011-10-14 00:08:34.507218
9c7fbc9b-5f03-4712-8e55-14a2befad533	\N	176.74.192.87	78e9e396-2ab2-4d61-9eea-fe08b840dbf9	2	2011-10-14 00:08:28.122859
68b2c4e1-0ce3-4192-a9be-72a83b7011c0	\N	176.74.192.87	b99894af-7866-4a81-beee-30e0e384b708	1	2011-10-14 00:08:34.361325
a1940a32-6d5b-4ba7-9ed3-2768bfd076b5	\N	176.74.192.87	641c249c-f473-4d8e-bd8e-f385157f2682	1	2011-10-14 00:08:37.998454
bcedcf61-7ccb-4d11-aca1-8bf35de5a49d	\N	176.74.192.87	3d4e64cc-54c0-4b3e-b865-2fff3d9845e7	1	2011-10-14 00:08:39.404626
8a5329ca-822b-4511-ab78-116f2423b6c3	\N	176.74.192.87	df63f81c-7a27-49d1-86c8-8d5e49883d40	1	2011-10-14 00:08:47.840021
2d1e5804-dfa6-4541-b9e5-48f3dcfdc012	\N	176.74.192.87	587ed76e-1c2f-4cc7-a23a-f9beb2415c77	2	2011-10-14 00:08:22.20414
c2690be6-7375-458f-90c3-967144242fae	\N	176.74.192.87	4402487d-3e8d-4618-8444-b400c6337834	1	2011-10-14 00:08:52.799402
2b0705cc-320d-4275-ae14-3754b883d2b9	\N	176.74.192.87	b9582bd1-bfff-41e1-990f-962c18084f4d	1	2011-10-14 00:09:00.304336
c3a398dc-c917-4a7d-bfe2-63d1db2184ed	\N	176.74.192.87	1901d722-a38d-4e79-a13c-ca51d61bae30	1	2011-10-14 00:09:07.263964
0482ef4a-63d4-4044-8681-e7e460d764ca	\N	176.74.192.87	ece794a5-613f-4607-9046-fb37906f87ce	3	2011-10-14 00:08:37.088579
5ab4951f-9692-4d52-8f3b-962b39da4e27	\N	176.74.192.87	ced8947c-7c6b-4874-ad5e-c28ba91f8073	2	2011-10-14 00:09:07.633063
81e5ff15-e1e0-4e27-b368-00a8fbcc7090	\N	176.74.192.87	4dbf7c31-5115-4700-963d-91f23f76aaa4	2	2011-10-14 00:09:08.466181
102bc206-2a88-4e36-b9f3-8653f64af5ac	\N	176.74.192.87	f3d8ca3c-32b9-4485-95d9-0b1fd4a5dd4e	1	2011-10-14 00:09:17.238513
bf6bc3a5-de7b-4403-8e10-d067394fea1c	\N	176.74.192.87	5a3d4806-974f-4754-b6cb-65a7dfa27548	1	2011-10-14 00:08:34.006056
4a797fa5-6e90-493b-a9f6-450c22c6f821	\N	176.74.192.87	e4c69e90-1056-4f46-9619-57d0a18d1737	2	2011-10-14 00:09:18.145567
6e7ada3e-bacd-4576-b5a1-e1353913f875	\N	176.74.192.87	6968ef13-1d2f-4de3-b533-706bc9c0f604	1	2011-10-14 00:09:03.325808
f894b133-c3a5-4360-973c-0b9e1188785a	\N	176.74.192.87	f1261a91-9d52-4520-837e-e9c793f28dcc	2	2011-10-14 00:09:23.489681
921589f2-856b-42e4-ad61-15e7c9ef1a2c	\N	176.74.192.87	a8f061a9-6ba5-46df-89cd-6e65bfa28fe5	1	2011-10-14 00:09:30.500819
d4954cee-7c21-455d-a929-54a2662c0b7d	\N	176.74.192.87	8d7560cf-6d61-45dd-bf05-44ae257e97a4	2	2011-10-14 00:09:31.852959
7891f764-11a5-440a-ab2e-452d7c932ca7	\N	176.74.192.87	6c0ea5a3-dd48-4015-8f65-77d56bf54bb3	1	2011-10-14 00:09:32.775707
6dc470bb-38a6-4ccf-870e-e3583c61d23c	\N	176.74.192.87	f22a7938-303f-4ac6-92da-526a4ad2a207	3	2011-10-14 00:09:09.908383
025144b7-090c-483c-b2fa-9ef43b0a433a	\N	176.74.192.87	529d4aba-d25d-44d6-ba1b-d6ad314d6158	1	2011-10-14 00:09:34.612456
5b33e794-d78f-4e7b-b256-d3a5cff59b52	\N	176.74.192.87	3fabe36b-965b-498d-9b3a-0649bbbfd0a5	2	2011-10-14 00:08:45.893894
38295f41-0570-4ae1-8d1f-563a0d4ea6f7	\N	176.74.192.87	83e56067-9ee5-48b2-83d0-91e723eb8b3d	1	2011-10-14 00:09:37.940851
2fb5386f-aa46-412a-ac72-b375747ba002	\N	176.74.192.87	8a7d516b-f3c2-4a5b-afde-d2bdff371937	2	2011-10-14 00:09:38.432988
d4ee89de-4f4e-4794-81c9-a45cd9e70dcc	\N	176.74.192.87	e1b56ce2-aea6-4d44-b877-86a13f92697c	5	2011-10-14 00:08:49.621185
a17ebbff-9676-455e-a16c-ee2f1a9e0845	\N	176.74.192.87	3aa0d5ce-cef6-4158-b51e-ddee8ece7b5e	1	2011-10-14 00:08:43.215165
a4474ca9-e3ee-4444-b10c-3642ecc05018	\N	176.74.192.87	4acf41b9-9c8b-4a1e-a32e-a754abdce116	3	2011-10-14 00:08:55.53315
426b41e4-84fc-49bc-99ac-1f6d447ee4b8	\N	176.74.192.87	f7a32926-f029-47f4-8649-e3b2997f69d3	1	2011-10-14 00:09:51.194423
e90ff5af-c173-4823-b96d-812111cee921	\N	210.6.239.29	ced8947c-7c6b-4874-ad5e-c28ba91f8073	5	2011-10-28 15:36:22.217027
84cbf796-95eb-4025-89b1-5fceac23e02f	960b876a-86f6-428c-af44-0d4684f245e7	\N	b99894af-7866-4a81-beee-30e0e384b708	3	2011-10-28 18:08:15.828967
26e3a983-d3b4-420e-93de-3f7a9eccf780	\N	194.199.7.22	a1019da5-cdac-4e09-8b60-831994b5f275	5	2011-10-17 15:16:28.43777
15634019-7a06-459c-8ee2-6aa2e6bab21f	\N	194.199.7.22	65d7e18e-c5ab-4736-bb9e-c47de2dc41e1	5	2011-10-17 15:22:35.770108
3895bad5-fe4c-46ff-8afc-62f5427c2c92	\N	194.199.7.22	e3424ea9-f7c0-4d80-832b-890c3de0f744	5	2011-10-17 15:38:19.523536
a4b8df5b-ee95-46b8-a337-844a10c68090	\N	194.199.7.22	3fabe36b-965b-498d-9b3a-0649bbbfd0a5	5	2011-10-17 15:55:01.13469
fe3146d8-ae8f-4a86-b3cb-b13cd63383b1	\N	194.199.7.22	97b2cf1e-91f4-4b08-a7d8-2e6bd1dca37e	5	2011-10-17 16:01:00.636945
89e806d7-5a0f-44aa-8c0c-dc25fc2fe924	\N	194.199.7.22	4235252c-aa21-46b5-8c52-110f95bdc583	5	2011-10-17 15:41:58.439307
59a2aaa1-10b3-48a7-b702-c15d179afc33	\N	194.199.7.22	f6c6aac7-3c9b-4a3c-80bc-d6709bc95d4b	5	2011-10-17 15:49:59.997421
43cd967d-9c8d-493b-a7aa-d297137090b0	\N	194.199.7.22	3aa0d5ce-cef6-4158-b51e-ddee8ece7b5e	5	2011-10-17 14:59:52.959528
2c2ff6f5-3c34-40aa-bd2a-a09cafe95fd9	\N	194.199.7.22	0e14dccb-9c28-4f89-b3b2-cb1011be06d1	5	2011-10-17 15:10:43.289983
bd284b9e-67b1-4ca8-97ae-d8698b9dd0f5	\N	194.199.7.22	f3d8ca3c-32b9-4485-95d9-0b1fd4a5dd4e	5	2011-10-17 15:33:45.513755
e32564ec-5804-4751-9392-0e796212dd9b	\N	194.199.7.22	5b23d4f4-058e-44e0-945d-ae9035fb1e15	5	2011-10-17 15:29:02.511562
84e7d0b3-98f5-416d-915f-821a548803d4	\N	194.199.7.22	34269022-c891-4a8e-a814-3af2b0fea526	5	2011-10-17 14:55:15.010634
554ef366-0eca-4aab-802b-565b09e29ca0	\N	210.6.239.29	0e14dccb-9c28-4f89-b3b2-cb1011be06d1	4	2011-10-31 20:23:57.622758
c9472249-339f-4986-9885-e924f68d4e2e	\N	210.6.239.29	3c175c09-a896-4a88-9603-2b5ea27ef1a1	5	2011-10-31 21:39:58.050267
b004369b-08d2-469b-9f27-d5d341f27aaa	\N	210.6.239.29	a1019da5-cdac-4e09-8b60-831994b5f275	4	2011-10-23 13:31:48.881008
1a974321-00cd-4761-9fdd-18cdcc58d154	\N	210.6.239.29	5efedd90-782d-4129-8e71-fdd3b6e1c7df	1	2011-10-19 18:29:47.50302
b6491b36-0f73-4ff7-a315-1120956e2304	\N	210.6.239.29	8a7d516b-f3c2-4a5b-afde-d2bdff371937	1	2011-11-01 17:12:10.399922
fe1c6f71-bcd3-4f71-b653-1478fcaeb963	\N	210.6.239.29	d794f07a-06d3-4b59-a969-c00af70ff8db	5	2011-10-23 03:58:14.594851
b2609fa4-4078-4db0-8bb5-07dfe68028aa	\N	192.114.71.13	34269022-c891-4a8e-a814-3af2b0fea526	2	2011-11-07 07:59:53.854695
7a07a3cd-0e0c-4a9f-9655-0dd7724278d3	\N	192.114.71.13	34269022-c891-4a8e-a814-3af2b0fea526	4	2011-11-07 07:59:53.855619
2e708038-2d81-4f3b-a4c0-915ce879a7eb	\N	192.114.71.13	f3d8ca3c-32b9-4485-95d9-0b1fd4a5dd4e	4	2011-11-07 07:59:56.962455
aef42e98-0910-4b39-9ccc-000a97062069	\N	192.114.71.13	df63f81c-7a27-49d1-86c8-8d5e49883d40	2	2011-11-07 08:00:02.626239
ec17260d-9946-4c44-ac5d-5623d083659c	\N	192.114.71.13	df63f81c-7a27-49d1-86c8-8d5e49883d40	4	2011-11-07 08:00:03.140909
e57b44f7-fd54-402a-b44d-eac2a33f5156	\N	192.114.71.13	df63f81c-7a27-49d1-86c8-8d5e49883d40	5	2011-11-07 08:00:03.236357
80482231-90d4-4d81-a0af-d1a27c2acdd3	\N	192.114.71.13	df63f81c-7a27-49d1-86c8-8d5e49883d40	3	2011-11-07 08:00:03.198633
b8eb0dd0-f086-4271-8205-28b4b9c9e04b	\N	192.114.71.13	78e9e396-2ab2-4d61-9eea-fe08b840dbf9	1	2011-11-07 08:00:05.174696
367a7318-2368-4707-8cde-2e7709b4e71c	\N	192.114.71.13	60e23204-8e78-487c-92bd-5de0c6102067	4	2011-11-07 08:00:06.078412
1b2e5278-a855-4c59-9217-0ad4aaba8e72	\N	192.114.71.13	5a3d4806-974f-4754-b6cb-65a7dfa27548	5	2011-11-07 08:00:07.063904
c9052d4a-6735-45d2-8af7-1466c9d1a5e0	\N	192.114.71.13	5a3d4806-974f-4754-b6cb-65a7dfa27548	2	2011-11-07 08:00:07.075034
0422b0ad-a6af-4e87-976b-66708742cbfc	\N	192.114.71.13	5a3d4806-974f-4754-b6cb-65a7dfa27548	1	2011-11-07 08:00:07.519111
612bd558-af74-45e9-8d42-7e6972fe6f3c	\N	192.114.71.13	1901d722-a38d-4e79-a13c-ca51d61bae30	3	2011-11-07 08:00:11.720078
8ed93407-932a-4bb5-96c8-dfdf11f9411f	\N	192.114.71.13	1901d722-a38d-4e79-a13c-ca51d61bae30	2	2011-11-07 08:00:11.751621
ed4a4560-6cc7-4e10-a72d-b712690b4e5f	\N	192.114.71.13	1901d722-a38d-4e79-a13c-ca51d61bae30	4	2011-11-07 08:00:11.841189
1b02bf56-e1bb-4a68-a23d-62aa107b57f0	\N	192.114.71.13	1901d722-a38d-4e79-a13c-ca51d61bae30	5	2011-11-07 08:00:12.867509
d7ee970a-3bcc-485f-97d2-3a834b4d45ea	\N	192.114.71.13	1901d722-a38d-4e79-a13c-ca51d61bae30	1	2011-11-07 08:00:13.3378
df799923-b37c-4aab-a6a2-7bfdbd27d4ef	\N	192.114.71.13	d6c6d3f9-5d8d-46c8-bc92-d8507d1e6f04	2	2011-11-07 07:59:59.69656
681ddf67-95ed-46f3-b342-8a399e0a0693	\N	58.106.95.156	1901d722-a38d-4e79-a13c-ca51d61bae30	2	2011-11-15 12:28:45.174832
c1ffe61b-14d0-403d-b427-502c669bbe9f	\N	221.194.134.185	b57f2ed1-ee10-469b-afcc-a4d7636d39c7	3	2011-11-16 17:45:16.94126
b28fd0f6-e7f5-4173-a068-89c018d55b56	\N	221.194.134.182	4acf41b9-9c8b-4a1e-a32e-a754abdce116	4	2011-11-16 17:45:29.654752
e999168e-6f63-441f-8677-d4a92ef53cfd	\N	221.194.134.182	5a3d4806-974f-4754-b6cb-65a7dfa27548	2	2011-11-16 17:46:00.609706
85c94bd9-4bf4-4665-8630-017b45c1152b	\N	221.194.134.183	205c33b6-106f-40c3-804c-a2835f6104a9	2	2011-11-16 17:46:34.970542
d767ac3a-1d5e-4f6b-a8b5-27b96b8f3f09	\N	221.194.134.185	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	3	2011-11-16 17:46:35.838179
75601009-42e6-4a6a-b094-57137675c441	\N	221.194.134.182	02970c3a-2240-4a74-8fd3-18af09a9cd61	3	2011-11-16 17:46:55.403136
3b70b5aa-0831-4ea1-86a0-dab4a5464fdf	\N	221.194.134.181	a8f061a9-6ba5-46df-89cd-6e65bfa28fe5	4	2011-11-16 17:46:57.410291
2bfa8735-3a48-40df-bfe2-638709b4d8c0	\N	221.194.134.185	6d999f74-d520-4a8c-8188-5a5c13c6bbec	4	2011-11-16 17:46:59.56897
e1107325-93f7-4075-97b2-0a4758b88f6f	\N	221.194.134.183	43c3cc44-3a6c-469b-80fe-913927d2c283	2	2011-11-16 17:47:04.34421
4073348d-e4c8-4272-a075-b828b612b045	\N	221.194.134.181	5a3d4806-974f-4754-b6cb-65a7dfa27548	2	2011-11-16 17:47:47.750432
3b82d9b1-66ac-4dc9-9ca0-cc628db939ef	\N	221.194.134.183	6c0ea5a3-dd48-4015-8f65-77d56bf54bb3	3	2011-11-16 17:48:29.055434
e4940895-e0c1-429a-bd84-f7f8282fb6f4	\N	221.194.134.185	529d4aba-d25d-44d6-ba1b-d6ad314d6158	4	2011-11-16 17:48:45.717184
bed45679-6daa-4481-8ac8-afc03d9b3865	\N	221.194.134.183	8d7560cf-6d61-45dd-bf05-44ae257e97a4	2	2011-11-16 17:49:23.548493
57831cb1-4b8a-4260-b6f1-112d648131f8	\N	221.194.134.182	fe7cd753-376f-4f22-a721-caa482aa1116	4	2011-11-16 17:49:55.134902
b84a990a-e8ee-4c45-9c33-4c221acfb43b	\N	221.194.134.182	3aa0d5ce-cef6-4158-b51e-ddee8ece7b5e	4	2011-11-16 17:49:56.74027
e0063c4c-43e9-4aad-ba2d-95d66016b7fe	\N	221.194.134.181	db34f769-ed94-45d3-8b66-5ebaf9b091ff	4	2011-11-16 17:50:28.64143
4bb044d2-b61d-4ac6-b9a2-bc8737cfd3b6	\N	221.194.134.182	3d4e64cc-54c0-4b3e-b865-2fff3d9845e7	3	2011-11-16 17:51:43.256568
ba70148e-fad4-4306-a7d4-10389c93ca82	\N	221.194.134.181	6968ef13-1d2f-4de3-b533-706bc9c0f604	2	2011-11-16 17:51:47.105952
2446d3a9-4250-4d0d-a410-63c04b79e3e4	\N	221.194.134.181	69361720-3428-417e-beb4-d21df542992c	1	2011-11-16 17:51:54.349111
7c70d2eb-7ead-4a89-9285-1ee1f32c4dc4	\N	221.194.134.181	a1019da5-cdac-4e09-8b60-831994b5f275	4	2011-11-16 17:52:04.167427
16173238-4803-4bb3-ba39-ec81da312e8c	\N	221.194.134.183	65d7e18e-c5ab-4736-bb9e-c47de2dc41e1	4	2011-11-16 17:52:07.627256
e34b8eb4-b11b-4158-b500-c8044cc797f8	\N	221.194.134.182	69361720-3428-417e-beb4-d21df542992c	5	2011-11-16 17:52:25.736848
72aaefdb-4463-4b01-b8fd-99c8abc36561	\N	221.194.134.185	78e9e396-2ab2-4d61-9eea-fe08b840dbf9	4	2011-11-16 17:52:28.578111
d3047bc1-307f-4764-b482-27dc0e8706b0	\N	221.194.134.181	1cf46091-d128-4e38-a7b7-97901d423aaf	3	2011-11-16 17:52:37.351627
0f19053d-3986-4ac6-b286-c2cba6eb416f	\N	221.194.134.182	9382520e-adb5-4403-848d-5bd5ea476202	3	2011-11-16 17:52:49.141693
63bb33c6-beba-458e-8693-c4447576ebf7	\N	221.194.134.181	48a03f6f-f8f4-4758-8672-f8ab8bd10acb	1	2011-11-16 17:53:29.66595
b0894065-df5f-48e7-977c-ffa162ee65bf	\N	221.194.134.185	8a7d516b-f3c2-4a5b-afde-d2bdff371937	2	2011-11-16 17:53:29.999062
cc4d9b2f-2b3b-4de7-b7c2-af36398442b4	\N	221.194.134.183	48a03f6f-f8f4-4758-8672-f8ab8bd10acb	5	2011-11-16 17:54:03.640086
a77598f4-c1a3-4308-abb2-a64597464122	\N	221.194.134.183	1901d722-a38d-4e79-a13c-ca51d61bae30	4	2011-11-16 17:54:19.922186
86941e5a-47e7-4adb-aa8e-75bd21efed0d	\N	194.199.7.22	db34f769-ed94-45d3-8b66-5ebaf9b091ff	5	2011-10-17 15:06:18.831871
3f604f80-ff4d-451b-b7d9-58024d7eb0a8	\N	194.199.7.22	e4c69e90-1056-4f46-9619-57d0a18d1737	5	2011-10-17 16:05:24.841013
97759843-0112-476d-9f5e-59d5e54966bb	\N	194.199.7.22	587ed76e-1c2f-4cc7-a23a-f9beb2415c77	5	2011-10-17 16:09:57.791097
a0401a6a-5473-468c-9450-334ffdb4fc62	\N	194.199.7.22	be516eed-8a37-436c-af75-b623f0806f39	5	2011-10-17 14:34:02.571425
e6889bb0-d804-4074-870d-79959fd402b6	\N	194.199.7.22	6d999f74-d520-4a8c-8188-5a5c13c6bbec	5	2011-10-17 14:43:08.213165
7bc4d777-1d52-41b3-9f98-1922e83be00a	\N	194.199.7.22	1901d722-a38d-4e79-a13c-ca51d61bae30	5	2011-10-17 14:38:25.667412
f34bba61-5ef5-48d4-a4f2-e65501e2d987	\N	221.194.134.182	29772378-f226-4fc8-8e01-9a87c5e43a00	1	2011-11-16 17:54:49.650728
ad12f2e4-315c-4e6b-98af-deda4cf357b3	\N	221.194.134.185	43c3cc44-3a6c-469b-80fe-913927d2c283	2	2011-11-16 17:55:07.297536
80442d17-72e8-4f99-ac35-e04f9cc9fd40	\N	221.194.134.185	29772378-f226-4fc8-8e01-9a87c5e43a00	5	2011-11-16 17:55:16.104312
15c32246-7701-4ee1-af6d-422492c12e29	\N	221.194.134.181	196340e0-5246-4bc2-8b69-54c66a48b399	2	2011-11-16 17:55:22.936765
aff69231-0bf1-4ae7-b695-112c7e880c75	\N	221.194.134.183	2502f9a7-15fa-439d-8a48-f61f38cb6f55	1	2011-11-16 17:55:37.415804
10f0ae00-3ee1-4d97-8d9c-f3957198a642	\N	221.194.134.181	34269022-c891-4a8e-a814-3af2b0fea526	3	2011-11-16 17:56:09.949612
ec8e25fb-3c46-4083-b407-db272e7710fa	\N	221.194.134.183	f3d8ca3c-32b9-4485-95d9-0b1fd4a5dd4e	5	2011-11-16 17:56:34.591601
f974f35a-5d3f-4749-a1cc-932b6cf3193e	\N	221.194.134.183	3c175c09-a896-4a88-9603-2b5ea27ef1a1	3	2011-11-16 17:56:52.63733
ca1e1be2-3c9e-42af-bad6-6c7a61d8e1ee	\N	221.194.134.185	2502f9a7-15fa-439d-8a48-f61f38cb6f55	5	2011-11-16 17:56:54.799628
fb83aebc-9bbe-4e01-9ed2-6f1e6d1f1cd7	\N	221.194.134.182	09d5ff25-7a8a-4228-9093-bb437bb70f1a	2	2011-11-16 17:57:22.564147
4dace646-2887-47d4-85d5-a980f86f1761	\N	221.194.134.182	cd2385b8-fa33-4be9-82a8-9ceda07fdc75	3	2011-11-16 17:57:24.494938
4874b569-4dfd-4f33-b69e-61ddcf30d4d8	\N	221.194.134.181	4235252c-aa21-46b5-8c52-110f95bdc583	4	2011-11-16 17:57:45.723468
5b86c141-5129-445c-9adc-ba7920bca7bb	\N	221.194.134.185	f6c6aac7-3c9b-4a3c-80bc-d6709bc95d4b	4	2011-11-16 17:58:02.272579
bdd1797e-b643-40dc-97f7-8a6f02c8e96e	\N	221.194.134.181	97b2cf1e-91f4-4b08-a7d8-2e6bd1dca37e	2	2011-11-16 17:58:21.837888
940e6150-6715-4576-a1a7-74cc0a421c2d	\N	221.194.134.185	e4c69e90-1056-4f46-9619-57d0a18d1737	1	2011-11-16 17:58:37.141197
0fc7a746-5d8d-4239-90af-ba2f43e640f9	\N	221.194.134.182	e4c69e90-1056-4f46-9619-57d0a18d1737	5	2011-11-16 17:58:56.171611
10f7d678-dad3-4c06-8f13-53c61a5e9905	\N	221.194.134.185	587ed76e-1c2f-4cc7-a23a-f9beb2415c77	5	2011-11-16 17:59:45.986325
d6b984ef-2671-4b16-9a4b-c4bc1e289e71	\N	221.194.134.185	4654898f-58f4-482f-a91f-23aa5e192fd8	1	2011-11-16 17:51:20.172247
27a878b1-388e-4d14-852e-ffee16044248	\N	221.194.134.183	4654898f-58f4-482f-a91f-23aa5e192fd8	5	2011-11-16 17:50:36.70624
4cd6cf6b-d5bb-4c31-b119-6117e63014da	\N	221.194.134.185	f3d8ca3c-32b9-4485-95d9-0b1fd4a5dd4e	5	2011-11-16 17:56:02.656144
8331bf59-0f5d-4e09-841f-9b6704dc8819	\N	221.194.134.183	587ed76e-1c2f-4cc7-a23a-f9beb2415c77	5	2011-11-16 17:59:41.840138
8b1409b3-26ee-4d8a-930c-d00e98823e7b	\N	221.194.134.182	430e39ad-4906-44ba-83bc-8f2bc6f2d039	1	2011-11-16 17:48:48.7816
104d8f17-fa76-4508-90a2-1fb69fb67524	\N	221.194.134.182	83e56067-9ee5-48b2-83d0-91e723eb8b3d	5	2011-11-16 18:41:11.661138
e34a2f63-f92f-4f32-b824-c2558fffddcf	\N	221.194.134.185	641c249c-f473-4d8e-bd8e-f385157f2682	4	2011-11-16 18:42:19.236523
a814ea17-d081-4d81-9f6b-7c2fe30886cf	\N	221.194.134.185	db34f769-ed94-45d3-8b66-5ebaf9b091ff	4	2011-11-16 18:42:30.674577
a09093d3-29f6-45af-9d99-74afdd4436b2	\N	221.194.134.181	8d9cf757-de83-4774-919b-00c45c43efd4	4	2011-11-16 18:42:47.070884
fbae116d-a0e0-4b58-9e18-2d9440fd25d0	\N	221.194.134.181	0e14dccb-9c28-4f89-b3b2-cb1011be06d1	4	2011-11-16 18:43:01.205395
dfdb8349-eab7-4ad9-adfa-af1afc17891f	\N	221.194.134.182	a1019da5-cdac-4e09-8b60-831994b5f275	4	2011-11-16 18:43:45.541496
a19166c3-9cc5-4e2b-b222-e75568003faf	\N	221.194.134.183	6968ef13-1d2f-4de3-b533-706bc9c0f604	2	2011-11-16 18:43:47.3349
4ce8929e-3b14-4975-86ef-b384bccf640e	\N	221.194.134.182	65d7e18e-c5ab-4736-bb9e-c47de2dc41e1	4	2011-11-16 18:44:01.228396
52cf96ae-6786-4025-9d99-f98a9ca3bd10	\N	221.194.134.181	78e9e396-2ab2-4d61-9eea-fe08b840dbf9	4	2011-11-16 18:44:19.138736
f3d24f88-a20b-415d-a2f6-1b2c71c2a449	\N	221.194.134.185	2364edf3-baf9-4a60-a75e-46387f235726	2	2011-11-16 18:44:35.77603
8b3d98de-cae5-437f-b260-f361cb2199ca	\N	221.194.134.185	8d447067-389f-4c39-ba51-63430a736df4	4	2011-11-16 18:44:42.2878
a0f048b3-6055-4613-8b7b-de339ed48507	\N	221.194.134.182	5b23d4f4-058e-44e0-945d-ae9035fb1e15	2	2011-11-16 18:44:51.357264
d05fc963-e6b5-47a2-8c69-3ce03e4f68a4	\N	221.194.134.182	ece794a5-613f-4607-9046-fb37906f87ce	2	2011-11-16 18:45:03.210375
ffed9f28-548a-4388-a8b1-8093bfbe6810	\N	221.194.134.181	d794f07a-06d3-4b59-a969-c00af70ff8db	4	2011-11-16 18:45:05.282092
a9367677-1c25-402e-a959-10f805a653df	\N	221.194.134.183	29772378-f226-4fc8-8e01-9a87c5e43a00	5	2011-11-16 18:45:15.96826
75b30fed-2ef5-4dfc-98ee-7255fe47c1bc	\N	221.194.134.183	d6c6d3f9-5d8d-46c8-bc92-d8507d1e6f04	4	2011-11-16 18:45:34.66362
a3c74b86-14d9-440c-b373-abaa0470ce98	\N	221.194.134.181	cdc13d67-6360-43a6-bb99-cd68b64ee3f3	3	2011-11-16 18:46:00.839806
74908cf8-1c32-4403-ae6e-89c5937b0c7b	\N	221.194.134.182	196340e0-5246-4bc2-8b69-54c66a48b399	2	2011-11-16 18:46:48.494502
9cf01a0f-84de-4358-a849-b1679ea9e4e2	\N	221.194.134.185	584d3863-eecc-4595-8a18-145ba2b213f7	3	2011-11-16 18:47:02.085418
407fdf80-4794-41a2-af69-bc32b8281a7f	\N	221.194.134.182	f4517261-c1ee-4380-b3ad-0de5a0edc09a	4	2011-11-16 18:47:32.970015
29d852b8-544a-4118-b9c7-fdd7eccd7655	\N	221.194.134.183	1c17435c-508d-4194-9d06-f923d31c60cf	2	2011-11-16 18:47:43.001379
f6d748bb-95b9-4000-bcef-8e4eb30db2b1	\N	221.194.134.181	cd2385b8-fa33-4be9-82a8-9ceda07fdc75	3	2011-11-16 18:47:58.814852
7903cea0-a2fc-4aa4-bc8b-c284cfc9d23d	\N	221.194.134.182	e3424ea9-f7c0-4d80-832b-890c3de0f744	2	2011-11-16 18:48:29.992206
b56b16b1-3692-424c-9129-b98f740624bc	\N	221.194.134.182	4235252c-aa21-46b5-8c52-110f95bdc583	4	2011-11-16 18:48:51.626715
8348058f-43ff-4e46-aaec-b09ba8884647	\N	221.194.134.181	df63f81c-7a27-49d1-86c8-8d5e49883d40	4	2011-11-16 18:48:51.731513
2a78a628-5b9c-48a4-8cde-8d000b48a095	\N	221.194.134.183	f6c6aac7-3c9b-4a3c-80bc-d6709bc95d4b	4	2011-11-16 18:48:51.970348
3efd898e-780a-4410-8071-a6f807fabd4d	\N	221.194.134.182	7f6c30c6-d6a5-4d39-ae5d-e1ae4cc2d3ef	4	2011-11-16 18:49:18.142833
9cf04c73-c127-4074-8f8a-ebd685b5aadb	\N	221.194.134.182	9db98dbb-0a64-4588-8e57-533f05a6e050	1	2011-11-16 18:49:21.712135
0f47c423-4758-489c-bf0d-729203f7060c	\N	221.194.134.185	9db98dbb-0a64-4588-8e57-533f05a6e050	5	2011-11-16 18:49:28.538351
fa14bc86-d1d9-4e5d-a531-240bcc8753e9	\N	221.194.134.185	97b2cf1e-91f4-4b08-a7d8-2e6bd1dca37e	2	2011-11-16 18:49:52.067988
36d9cf76-ac13-4539-beff-9fc57edee67e	\N	221.194.134.182	587ed76e-1c2f-4cc7-a23a-f9beb2415c77	1	2011-11-16 18:49:59.878564
092497e7-f472-42ac-81e5-fa92ce9a6e1e	\N	221.194.134.185	e1b56ce2-aea6-4d44-b877-86a13f92697c	1	2011-11-16 18:50:26.946702
384676ab-3a6f-4ed6-b4da-adb680e38bd5	\N	221.194.134.183	e1b56ce2-aea6-4d44-b877-86a13f92697c	5	2011-11-16 18:50:27.752711
2466ff6b-7c7e-40b2-84a9-09c01ca4fda7	\N	221.194.134.185	60e23204-8e78-487c-92bd-5de0c6102067	1	2011-11-16 18:50:50.166685
eac82939-68d6-42fe-a9e4-f7e24e03c2f0	\N	221.194.134.183	60e23204-8e78-487c-92bd-5de0c6102067	5	2011-11-16 18:51:33.123896
d3255ef3-0dda-42e1-88ec-4078e5ac52a1	\N	46.4.88.200	ac051eb3-275f-40a5-b160-e224d13902e7	2	2011-11-17 22:18:19.061393
72dfe76c-fc57-4909-b565-525e9c2590f9	\N	194.199.7.22	3c175c09-a896-4a88-9603-2b5ea27ef1a1	5	2011-11-23 12:05:18.368293
dcf9a0bf-0173-4f52-8183-d842b9e704c6	\N	194.199.7.22	196340e0-5246-4bc2-8b69-54c66a48b399	5	2011-11-23 12:24:17.507057
719d0118-bbc8-4e87-b0f8-d0787efdd1db	\N	194.199.7.22	2364edf3-baf9-4a60-a75e-46387f235726	5	2011-11-23 13:10:14.583492
db255e0a-d71f-4825-9e5c-3be372653147	\N	194.199.7.22	df63f81c-7a27-49d1-86c8-8d5e49883d40	5	2011-11-23 15:23:49.678667
2ecd1b79-81b1-4292-8dd3-ab4ee3cac0c4	\N	194.199.7.22	5c29c0cd-e773-4697-8172-ab1b075490c2	5	2011-11-23 20:14:16.179494
0467c541-d6d6-4cfa-974c-ca6c61935f66	\N	194.199.7.22	624552ff-a7cd-427d-88e3-f31ec6dba89b	5	2011-11-23 14:53:00.692438
d3109d49-f208-4bc3-aa11-91092201609b	\N	194.199.7.22	4dbf7c31-5115-4700-963d-91f23f76aaa4	5	2011-11-23 14:57:19.753185
2d07333e-946d-48f2-9e70-2b7f4c80ec1d	\N	221.194.134.183	83e56067-9ee5-48b2-83d0-91e723eb8b3d	2	2011-11-28 19:03:14.156429
41f0f7db-94fd-4be4-ab49-5844c6816205	\N	221.194.134.183	430e39ad-4906-44ba-83bc-8f2bc6f2d039	5	2011-11-28 19:04:12.709704
d13c36ef-1c31-4122-ae2a-ee8622fe6511	\N	221.194.134.185	3aa0d5ce-cef6-4158-b51e-ddee8ece7b5e	5	2011-11-28 19:03:05.318968
7b3a6e52-d51c-41d9-9ef9-7a0b7b49c0dc	\N	194.199.7.22	c67a2104-aa5f-4e9f-830f-662ce97995d6	5	2011-11-23 19:06:45.921833
d759526d-a12b-4891-ac03-6ad11424fe3d	\N	194.199.7.22	5e86134f-2cb5-40e9-affa-f80d934a14b9	5	2011-11-23 13:54:22.802869
e1a06d82-3f1b-4854-ab88-9a36531be12d	\N	194.199.7.22	29772378-f226-4fc8-8e01-9a87c5e43a00	5	2011-11-23 10:10:29.111512
e0a61329-ef44-4c4e-8f15-f26c70fe3189	\N	194.199.7.22	f4517261-c1ee-4380-b3ad-0de5a0edc09a	5	2011-11-23 13:25:31.075502
8ee5a27c-98b1-46bf-ba73-f938540cd372	\N	194.199.7.22	1dacf074-ad54-432a-a04f-cecd3a068d0c	5	2011-11-23 15:27:48.729105
d90f8809-5b38-47db-9556-62f70e609155	\N	194.199.7.22	67906f75-4298-4b6a-aa62-d8314be33f15	5	2011-11-23 13:14:06.161494
64962714-1a85-49c8-826c-edbd086e8f6f	\N	194.199.7.22	9382520e-adb5-4403-848d-5bd5ea476202	5	2011-11-23 14:08:42.160277
9e2d246f-c048-4c8e-8fa6-5b59141ddae3	\N	194.199.7.22	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	5	2011-11-23 12:10:48.391345
a04e086c-d8e2-41ff-bcc9-6a9a430ed188	\N	194.199.7.22	30bcda76-5a1a-4369-a6f3-ed2584ad4031	5	2011-11-23 13:49:12.88057
00b5fd59-c3ec-4214-8423-521b1d384d40	\N	194.199.7.22	7f6c30c6-d6a5-4d39-ae5d-e1ae4cc2d3ef	5	2011-11-23 12:29:34.990483
1c2d64d1-c5f5-4eff-a779-2d06894bcb46	\N	194.199.7.22	430e39ad-4906-44ba-83bc-8f2bc6f2d039	5	2011-11-23 11:49:16.211193
edfc9eaa-9d7e-4044-9ea2-f8b908dbe0ec	\N	194.199.7.22	3d4e64cc-54c0-4b3e-b865-2fff3d9845e7	5	2011-11-23 15:36:31.610104
80e32724-8de1-41f0-a9e0-d823b70a8723	\N	194.199.7.22	8a7d516b-f3c2-4a5b-afde-d2bdff371937	5	2011-11-23 15:18:52.186996
e70965fe-b2e1-4471-b264-fc0ddba0ae9a	\N	194.199.7.22	83e56067-9ee5-48b2-83d0-91e723eb8b3d	5	2011-11-23 12:39:02.388019
5385e50a-60c7-47d0-b693-2a14c865a155	\N	194.199.7.22	b9582bd1-bfff-41e1-990f-962c18084f4d	5	2011-11-23 16:45:17.272753
9720b7ed-d49a-4861-9d5c-902e5233b347	\N	194.199.7.22	78e9e396-2ab2-4d61-9eea-fe08b840dbf9	5	2011-11-23 13:05:54.757115
85436d59-cebb-404b-84e5-6cc2c41d4b45	\N	194.199.7.22	84b91384-8ec9-4b55-8dc9-28ff8c6db62f	5	2011-11-23 13:17:31.33099
41629d05-3dbe-4bf9-a69f-44a8c770fe0a	\N	194.199.7.22	ece794a5-613f-4607-9046-fb37906f87ce	5	2011-11-23 13:01:04.362826
5bfe0d8a-93aa-41fd-9e97-462394edf21a	\N	194.199.7.22	d794f07a-06d3-4b59-a969-c00af70ff8db	5	2011-11-23 12:00:10.13073
adf3b506-5d2e-4a37-aa6b-d95c840035fd	\N	194.199.7.22	6968ef13-1d2f-4de3-b533-706bc9c0f604	5	2011-11-23 12:33:23.749643
d7ffc2ba-83db-43ce-bb41-7c675e503d13	\N	194.199.7.22	cd2385b8-fa33-4be9-82a8-9ceda07fdc75	5	2011-11-23 13:36:42.476475
1343332b-70a6-41d4-bd54-3442ae5fa39e	\N	194.199.7.22	cdc13d67-6360-43a6-bb99-cd68b64ee3f3	5	2011-11-23 14:31:47.497052
6abb72fd-5b2e-4018-9ccd-6b375b5529dc	\N	194.199.7.22	205c33b6-106f-40c3-804c-a2835f6104a9	5	2011-11-23 15:53:31.140971
18b94cb6-067a-4054-b99a-033c7367909d	\N	194.199.7.22	b99894af-7866-4a81-beee-30e0e384b708	5	2011-11-23 15:41:41.531359
5dcc7122-eff9-4a96-9fa2-19468e9126cd	\N	194.199.7.22	4654898f-58f4-482f-a91f-23aa5e192fd8	5	2011-11-23 15:45:10.536472
b1039d88-1c75-4c78-8f54-cf857792d316	\N	194.199.7.22	4402487d-3e8d-4618-8444-b400c6337834	5	2011-11-23 13:41:59.9136
319bb91a-77e6-4fc5-9a5d-b7aea5aea515	\N	194.199.7.22	f22a7938-303f-4ac6-92da-526a4ad2a207	5	2011-11-23 15:32:12.33247
f30f79e5-dfc2-4cb0-8fdd-ac709404418b	\N	194.199.7.22	ced8947c-7c6b-4874-ad5e-c28ba91f8073	5	2011-11-23 14:22:52.456026
e9c26c96-b28b-4abc-b065-1602370dd848	\N	194.199.7.22	e1b56ce2-aea6-4d44-b877-86a13f92697c	5	2011-11-23 12:47:54.746185
c584703f-5fe8-499c-8d2f-1bc1ef15f6f5	\N	194.199.7.22	a8f061a9-6ba5-46df-89cd-6e65bfa28fe5	5	2011-11-23 12:17:23.324702
1bdb99e1-c3ca-4f1c-902a-ca801bd76f7a	\N	194.199.7.22	48a03f6f-f8f4-4758-8672-f8ab8bd10acb	5	2011-11-23 14:13:29.675828
4768c7f6-73db-49e7-b6d7-99b4e60c4a29	\N	194.199.7.22	20100c39-31ae-4fd4-ad35-bfeabe396b5f	5	2011-11-23 14:18:16.305316
d030925f-3b6e-4c89-8bea-374a4a6cd5c7	\N	194.199.7.22	09d5ff25-7a8a-4228-9093-bb437bb70f1a	5	2011-11-23 13:30:19.998993
e55fb79f-d3da-489e-a03a-f2619163d524	\N	194.199.7.22	6c0ea5a3-dd48-4015-8f65-77d56bf54bb3	5	2011-11-23 14:03:20.338573
7312b6c2-963d-4f5b-b5ba-113bca826bf3	\N	194.199.7.22	8d9cf757-de83-4774-919b-00c45c43efd4	5	2011-11-23 15:14:27.404625
d425743d-48c0-4375-b538-e760ae119976	\N	194.199.7.22	641c249c-f473-4d8e-bd8e-f385157f2682	5	2011-11-23 14:44:22.906539
ec4e24fa-ec9f-4666-8bf0-60061addb69b	\N	194.199.7.22	0a048cd8-5468-4fcd-bd67-50675c83002d	5	2011-11-23 15:59:12.039259
19bc2a0a-69e8-4987-a31b-526f65ee0d3a	\N	194.199.7.22	1cf46091-d128-4e38-a7b7-97901d423aaf	5	2011-11-23 14:36:12.981361
7b0eec07-6e40-4964-98e3-35913d708da5	\N	194.199.7.22	b57f2ed1-ee10-469b-afcc-a4d7636d39c7	5	2011-11-23 15:49:50.500692
3adb94a0-e81b-45da-82ea-1f5a3027d904	\N	194.199.7.22	2502f9a7-15fa-439d-8a48-f61f38cb6f55	5	2011-11-23 15:09:59.16879
9f9effd0-ebfc-4ca6-987d-bc6809f873d0	\N	194.199.7.22	02970c3a-2240-4a74-8fd3-18af09a9cd61	5	2011-11-23 15:01:41.616895
8c56e7ec-d046-4103-bc12-b50f74673b8b	\N	194.199.7.22	4acf41b9-9c8b-4a1e-a32e-a754abdce116	5	2011-11-23 14:27:00.733435
1e851a4b-df45-4661-a6a9-3c9e6935af2b	\N	194.199.7.22	5a3d4806-974f-4754-b6cb-65a7dfa27548	5	2011-11-23 15:05:16.536902
2d52d566-2313-44f7-a200-f89b870dbfe8	\N	194.199.7.22	529d4aba-d25d-44d6-ba1b-d6ad314d6158	5	2011-11-23 16:12:03.420053
0ba6c91d-8117-40a4-b418-8a69f7358f9b	\N	194.199.7.22	fe7cd753-376f-4f22-a721-caa482aa1116	5	2011-11-23 16:20:49.545364
b02dff40-c1f1-454e-83fa-89c31de1415c	\N	194.199.7.22	f7a32926-f029-47f4-8649-e3b2997f69d3	5	2011-11-23 16:25:58.698566
0bf3239f-9403-409f-82b5-af1df33a521b	\N	194.199.7.22	8d447067-389f-4c39-ba51-63430a736df4	5	2011-11-23 16:30:51.801004
c6666b51-e006-4355-8717-608467d8ebe1	\N	194.199.7.22	d6c6d3f9-5d8d-46c8-bc92-d8507d1e6f04	5	2011-11-23 13:58:19.963476
98839442-60ed-424c-b0dc-0596255aea2e	\N	194.199.7.22	584d3863-eecc-4595-8a18-145ba2b213f7	5	2011-11-23 12:43:25.356521
2d587658-841d-40d7-96e2-199322b6b20a	\N	194.199.7.22	60e23204-8e78-487c-92bd-5de0c6102067	5	2011-11-23 14:48:29.498693
6ac41060-c74b-4918-a297-73048bedf560	\N	194.199.7.22	f1261a91-9d52-4520-837e-e9c793f28dcc	5	2011-11-23 12:56:17.783388
8eaed1c1-ab5d-4a9b-b908-8168f4f7b799	\N	194.199.7.22	497e8d74-14c2-401e-bc0d-a4b473f77eb1	5	2011-11-23 23:11:40.577348
6764ef54-7117-44ce-b145-e1a6d37bf9e3	\N	193.49.212.130	65d7e18e-c5ab-4736-bb9e-c47de2dc41e1	4	2011-11-24 11:43:26.151604
04817b99-7365-4238-9b05-dd2cb578a94c	\N	183.178.85.181	ced8947c-7c6b-4874-ad5e-c28ba91f8073	2	2011-11-25 15:36:31.490542
e2fae111-e3f7-492b-8742-d379237b5359	\N	194.199.7.22	e3623259-d93b-4596-930a-0282a07b5666	5	2011-11-23 19:12:43.851004
bc2d6ec0-d5c5-444a-9eba-b31fd60f0589	\N	221.194.134.183	c67a2104-aa5f-4e9f-830f-662ce97995d6	3	2011-11-28 14:57:34.421571
2171f774-5239-49db-bbdc-2e3fa6706808	\N	221.194.134.183	b57f2ed1-ee10-469b-afcc-a4d7636d39c7	4	2011-11-28 14:57:47.570392
85e64323-dd33-47b3-b0a9-c753907a0155	\N	221.194.134.185	4acf41b9-9c8b-4a1e-a32e-a754abdce116	1	2011-11-28 14:57:42.676897
ba7fdb28-02ca-4cf3-8b4b-5a7071877558	\N	221.194.134.183	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	4	2011-11-28 15:09:31.176307
d27dd8ca-6d6e-499a-af69-a8e27c9bf4db	\N	183.60.193.36	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	4	2011-11-29 11:45:56.785137
b8cbba14-bafd-41c9-bec8-8e0b15128086	\N	81.52.143.15	7f6c30c6-d6a5-4d39-ae5d-e1ae4cc2d3ef	4	2011-12-17 13:15:07.028528
fcbd91f4-b965-4986-92b6-dfe703367c51	\N	81.52.143.36	7f6c30c6-d6a5-4d39-ae5d-e1ae4cc2d3ef	2	2011-12-13 19:29:23.880265
e2aeb3d5-66ff-48e5-ad5c-12856fb713b3	\N	81.52.143.29	7f6c30c6-d6a5-4d39-ae5d-e1ae4cc2d3ef	1	2011-12-15 01:37:23.617255
bd7f84fc-2a5b-4e61-9a89-37fd4b188f40	\N	193.252.149.13	7f6c30c6-d6a5-4d39-ae5d-e1ae4cc2d3ef	5	2011-12-17 15:35:17.63934
d0fcf419-26a6-4486-ba88-8f8b2b1ba391	\N	193.252.118.176	7f6c30c6-d6a5-4d39-ae5d-e1ae4cc2d3ef	3	2011-12-18 23:57:54.606657
65f5230c-f251-48fd-842d-c796a26afac6	\N	46.105.5.195	db34f769-ed94-45d3-8b66-5ebaf9b091ff	2	2011-12-20 05:48:15.364952
c7020d90-3e04-4030-bd5b-26ffb7ade408	\N	38.101.148.126	587ed76e-1c2f-4cc7-a23a-f9beb2415c77	3	2011-12-24 06:13:04.228882
502adb40-c2d7-417a-b19a-3504f6c60baf	\N	38.101.148.126	e3424ea9-f7c0-4d80-832b-890c3de0f744	1	2011-12-28 20:00:42.775188
534d4d5e-77ed-4084-89e2-55bab76834a6	\N	38.101.148.126	1901d722-a38d-4e79-a13c-ca51d61bae30	1	2011-12-28 19:53:11.76744
2d1186a8-7810-4652-ba9a-06d686daff48	\N	38.101.148.126	df6c89f3-4473-424b-a0b0-119977da62c5	4	2011-12-30 06:49:37.961969
152f94ab-0d18-4d23-b1f7-b156979a2fe2	\N	38.101.148.126	69361720-3428-417e-beb4-d21df542992c	1	2011-12-30 09:33:44.364939
e8b87472-a727-48a2-89d3-4b94b47e8c00	\N	109.11.240.78	fea6dcd6-00d6-4ad5-ab2f-eb40f533a5db	5	2011-12-31 10:33:59.466693
e23a6a21-2b0d-42c1-95b2-152f48125176	\N	80.12.110.204	cdc13d67-6360-43a6-bb99-cd68b64ee3f3	5	2012-01-02 13:27:06.723362
dde5fda9-c11f-4875-8dac-4ce9b65a565e	\N	90.4.186.186	f6c6aac7-3c9b-4a3c-80bc-d6709bc95d4b	5	2012-01-03 12:06:03.026693
0d9e52ce-6358-4e4e-8313-9af1822935a9	\N	46.4.95.140	27983c75-8b7c-47bd-ad03-10a9e1ca4d25	5	2012-03-05 21:54:56.437571
d1017bfe-51dc-4956-9598-56b83a3e936f	\N	90.4.186.186	f6c6aac7-3c9b-4a3c-80bc-d6709bc95d4b	2	2012-01-03 12:06:02.9854
6687d0ea-50b4-453c-8806-7aa072ce3a73	\N	88.168.238.200	fea6dcd6-00d6-4ad5-ab2f-eb40f533a5db	5	2012-01-08 12:34:31.766384
9c25f143-19ae-4361-b866-6d3ec68499e4	\N	88.168.238.200	fea6dcd6-00d6-4ad5-ab2f-eb40f533a5db	5	2012-01-08 12:34:31.663489
e20aa5f4-dc3e-49ea-8de0-e0efe2996427	\N	193.252.149.18	7f6c30c6-d6a5-4d39-ae5d-e1ae4cc2d3ef	5	2012-01-19 17:01:00.289909
dbefe9bf-5dd2-4819-833e-d1d55d790150	\N	38.101.148.126	4235252c-aa21-46b5-8c52-110f95bdc583	2	2012-02-03 13:45:52.139662
43969b3e-aea4-4843-b30b-102615578e5e	\N	38.101.148.126	d794f07a-06d3-4b59-a969-c00af70ff8db	1	2012-02-03 22:52:03.439758
7a795893-f303-46d1-a47e-ea2ec39f9ba1	\N	38.101.148.126	5efedd90-782d-4129-8e71-fdd3b6e1c7df	3	2012-02-04 02:48:10.255882
c1fa141d-46ee-48d2-bfaa-46378b379ce9	\N	188.24.242.165	78e9e396-2ab2-4d61-9eea-fe08b840dbf9	1	2012-02-24 08:44:36.886741
3af1b9bc-20c5-4443-8d04-53d4273fd30c	\N	38.101.148.126	cdc13d67-6360-43a6-bb99-cd68b64ee3f3	3	2012-02-25 08:33:10.509799
96332b5a-fda3-4f71-8a9f-38430f335cc0	\N	46.4.95.140	60e23204-8e78-487c-92bd-5de0c6102067	5	2012-03-05 21:47:49.322338
1a8fc0c2-94a4-4fdc-8e61-6fe425662fc7	\N	46.4.95.140	3c175c09-a896-4a88-9603-2b5ea27ef1a1	5	2012-03-05 21:39:23.470115
fae21bdd-87b9-49ba-be40-332f8670eeb9	\N	204.236.149.161	30bcda76-5a1a-4369-a6f3-ed2584ad4031	5	2012-02-25 18:21:01.693939
8f681ecb-9f04-412b-80e4-7a76a5ff085b	\N	92.151.164.242	8d9cf757-de83-4774-919b-00c45c43efd4	5	2012-02-26 16:22:56.395066
76f98e58-caab-49c0-8135-89169cec6abe	\N	82.123.34.232	bfd1388a-ec10-4a7b-9d94-916f56f52f98	4	2012-03-03 19:40:34.82953
afbf9276-29aa-4b91-be3a-9762d4846000	\N	46.4.95.140	2502f9a7-15fa-439d-8a48-f61f38cb6f55	5	2012-03-05 21:28:23.243757
06e6f7f4-f2ea-4609-9d86-f3748def222c	\N	46.4.95.140	db34f769-ed94-45d3-8b66-5ebaf9b091ff	5	2012-03-05 21:29:03.592434
9f079780-1dc8-4c1d-a9e4-cf8a3d249d98	\N	46.4.95.140	9382520e-adb5-4403-848d-5bd5ea476202	5	2012-03-05 21:29:58.776674
d8a27a0a-2b15-46d0-9d12-54c3351185a3	\N	46.4.95.140	f4517261-c1ee-4380-b3ad-0de5a0edc09a	5	2012-03-05 21:31:31.513268
b89e8861-0aee-4f1a-ba4a-8299965cb277	\N	46.4.95.140	e4c69e90-1056-4f46-9619-57d0a18d1737	5	2012-03-05 21:32:46.625975
aad9a921-8a83-4b7b-b5d8-9ca237f1d4b4	\N	46.4.95.140	0a048cd8-5468-4fcd-bd67-50675c83002d	5	2012-03-05 21:34:44.794633
46037faf-ff5e-4708-bcbe-6548b73a7fbf	\N	46.4.95.140	5c29c0cd-e773-4697-8172-ab1b075490c2	5	2012-03-05 21:37:05.459349
4aab1de3-b65c-473b-b497-cea8b111b794	\N	46.4.95.140	196340e0-5246-4bc2-8b69-54c66a48b399	5	2012-03-05 21:40:18.547913
059be645-1583-4f52-87c5-24cfada7152e	\N	46.4.95.140	6968ef13-1d2f-4de3-b533-706bc9c0f604	5	2012-03-05 21:53:04.797675
61022e10-08f4-4e71-90cb-0af8f66a4014	\N	46.4.95.140	8d7560cf-6d61-45dd-bf05-44ae257e97a4	5	2012-03-05 21:44:20.406688
360d3eff-4c78-483e-a1b6-40224df60e73	\N	46.4.95.140	b9582bd1-bfff-41e1-990f-962c18084f4d	5	2012-03-05 21:47:17.863775
a56fc594-4365-4c44-9ec6-5e705ba9378d	\N	46.4.95.140	f22a7938-303f-4ac6-92da-526a4ad2a207	5	2012-03-05 21:56:22.15852
c1b04285-b73d-469f-b0e5-d02aef359ed9	\N	46.4.95.140	78e9e396-2ab2-4d61-9eea-fe08b840dbf9	5	2012-03-05 21:51:20.485033
3c221d86-e170-4544-a3fa-70dc82078340	\N	46.4.95.140	1cf46091-d128-4e38-a7b7-97901d423aaf	5	2012-03-05 21:52:25.176554
a28fc7c1-7e65-448c-b44b-6631918fadeb	\N	46.4.95.140	e3623259-d93b-4596-930a-0282a07b5666	5	2012-03-05 21:35:37.476701
c95ce956-667c-4f73-a172-a0c89e8cd6cd	\N	46.4.95.140	ced8947c-7c6b-4874-ad5e-c28ba91f8073	5	2012-03-05 21:43:08.784377
b6290a36-76b1-4a3f-a295-3588f0199cf3	\N	46.4.95.140	f6c6aac7-3c9b-4a3c-80bc-d6709bc95d4b	5	2012-03-05 21:42:09.490239
257f0849-afdb-46b0-98c5-37fe58e5fd0c	\N	46.4.95.140	25dd2269-e0f3-4653-98ac-33f64f09d4d3	5	2012-03-05 21:41:47.079067
09e74e23-5e5d-447a-8197-ba13befbf59b	\N	46.4.95.140	4276f7df-c7e9-44e1-8886-20ad41ebda0a	5	2012-03-05 21:27:03.956309
b1dce765-f34b-4d8b-b861-b8e762508f26	\N	46.4.95.140	30bcda76-5a1a-4369-a6f3-ed2584ad4031	5	2012-03-05 21:50:16.774423
ca9adcb3-a5ee-47ee-8083-187a030d261e	\N	194.199.7.22	1c17435c-508d-4194-9d06-f923d31c60cf	5	2011-11-23 16:35:13.563869
aacc27fb-0f81-4dba-a0e8-e79e0aaf1cca	\N	194.199.7.22	9db98dbb-0a64-4588-8e57-533f05a6e050	5	2011-11-23 16:40:01.530148
14735c4a-d382-4776-85f6-948e329e87e8	\N	46.4.95.140	159b6644-94ed-406d-8e1e-1f002f265396	5	2012-03-05 21:13:48.795549
44150914-2147-4922-842e-61f47cd5fba3	\N	46.4.95.140	1901d722-a38d-4e79-a13c-ca51d61bae30	5	2012-03-05 21:27:16.381489
63d3dbe9-d225-41e7-90b5-2449fd22ce8c	\N	46.4.95.140	43c3cc44-3a6c-469b-80fe-913927d2c283	5	2012-03-05 21:27:37.184799
561e9077-39c4-490c-a8c4-ce0436bd3906	\N	46.4.95.140	587ed76e-1c2f-4cc7-a23a-f9beb2415c77	5	2012-03-05 21:33:36.307883
b34f316e-9867-41fa-940b-a9b4e7578f75	\N	46.4.95.140	1dacf074-ad54-432a-a04f-cecd3a068d0c	5	2012-03-05 21:36:25.31179
b31c8805-ccc3-4aa0-9731-b267c7617763	\N	46.4.95.140	ece794a5-613f-4607-9046-fb37906f87ce	5	2012-03-05 21:42:31.867115
d88fe3af-d793-4380-aaa9-43efcf2e04bb	\N	46.4.95.140	47034ede-0506-4650-9fb4-1948168440ca	5	2012-03-05 21:51:44.890793
f4ccfa57-1d25-420f-a870-14565ca48e44	\N	46.4.95.140	4654898f-58f4-482f-a91f-23aa5e192fd8	5	2012-03-05 21:45:07.236516
283cd119-8b12-47e9-8792-f1f3b6f896eb	\N	46.4.95.140	641c249c-f473-4d8e-bd8e-f385157f2682	5	2012-03-05 21:50:43.061304
d543a7c1-26de-4ef5-b8cb-4ec417c22d0f	\N	46.4.95.140	7f6c30c6-d6a5-4d39-ae5d-e1ae4cc2d3ef	5	2012-03-05 21:49:38.986058
ee068fd7-accb-46cb-9b5d-f9b970bbc3ce	\N	46.4.95.140	df6c89f3-4473-424b-a0b0-119977da62c5	5	2012-03-05 21:45:44.931795
67c8c673-cc35-4b9f-a03b-173ba7a70c8e	\N	46.4.95.140	b815db66-cadf-4c3c-ae0b-73ad5bf1a46e	5	2012-03-05 21:46:10.22145
2c697080-2802-41a1-9c0d-9032ff6e9539	\N	46.4.95.140	83e56067-9ee5-48b2-83d0-91e723eb8b3d	5	2012-03-05 21:52:45.423418
12de823b-e191-4762-829e-1df3e226474f	\N	46.4.95.140	205c33b6-106f-40c3-804c-a2835f6104a9	5	2012-03-05 21:43:48.764187
36a5b16b-35f7-4f9f-9d55-61a697f216f7	\N	46.4.95.140	9db98dbb-0a64-4588-8e57-533f05a6e050	5	2012-03-05 21:46:51.462056
877eb4af-b2bf-48f9-b5db-ebb720ce02fc	\N	46.4.95.140	df63f81c-7a27-49d1-86c8-8d5e49883d40	5	2012-03-05 21:49:08.077258
abab5e20-c746-44fb-a1eb-3e094d09c31b	\N	46.4.95.140	497e8d74-14c2-401e-bc0d-a4b473f77eb1	5	2012-03-05 21:38:23.192481
8035d4a5-111e-4195-9f46-d39221e6b158	\N	82.227.148.7	cd42a806-cac1-452c-9b0d-116d8ead4d64	5	2012-05-23 15:07:27.836294
5456714c-e07e-4ebc-8ed5-5cff8271517a	\N	119.247.226.156	a1019da5-cdac-4e09-8b60-831994b5f275	3	2012-06-04 00:13:23.565382
6ef19f50-be12-47b1-b619-6c28611736c5	\N	46.4.95.140	4dbf7c31-5115-4700-963d-91f23f76aaa4	5	2012-03-05 22:00:32.170136
40218a5d-f7da-473f-a091-00a68c728e44	\N	46.38.174.190	02970c3a-2240-4a74-8fd3-18af09a9cd61	3	2012-03-12 14:31:52.029495
45172fe1-009f-4634-942b-36091d8bd85e	\N	87.25.10.168	5b23d4f4-058e-44e0-945d-ae9035fb1e15	5	2012-03-13 21:15:55.501257
a7b80bd5-745d-4979-b5ef-9fde1d2fb75b	\N	98.173.139.6	ced8947c-7c6b-4874-ad5e-c28ba91f8073	1	2012-03-14 18:02:06.832739
3e554294-a0bc-4a17-bb40-d1e15acaa2b3	\N	98.173.139.6	8d9cf757-de83-4774-919b-00c45c43efd4	1	2012-03-14 18:02:12.608955
8203f60d-aa79-40a2-b220-a2dd2f6b41c7	\N	92.151.174.10	fea6dcd6-00d6-4ad5-ab2f-eb40f533a5db	5	2012-03-15 01:47:41.041286
59518b67-5f75-4dab-9a4b-07fc9d9d7782	\N	88.84.128.150	3fabe36b-965b-498d-9b3a-0649bbbfd0a5	2	2012-03-16 18:20:16.332426
8ba9a5bb-b489-4aed-a661-0d64cab33072	\N	88.84.128.150	cdc13d67-6360-43a6-bb99-cd68b64ee3f3	3	2012-03-16 18:20:17.095072
35f8df3e-d4f2-4f1a-842c-cb18466e7d44	\N	88.84.128.150	69361720-3428-417e-beb4-d21df542992c	4	2012-03-16 18:20:17.199365
75a52c75-2859-4ea9-989f-396a2be618b6	\N	88.84.128.150	25dd2269-e0f3-4653-98ac-33f64f09d4d3	1	2012-03-16 18:20:17.854194
3178ecf4-dca1-4dcf-a853-3c967805bdf7	\N	82.239.197.205	f6c6aac7-3c9b-4a3c-80bc-d6709bc95d4b	2	2012-04-09 23:45:59.850593
5e1f779c-638a-45a6-a749-12524f691ed7	\N	195.101.96.121	41b0a731-3378-42bd-9e08-8b69a1fee83a	5	2012-04-24 09:52:33.098692
c9383590-3a00-4e33-8efc-9a830ff7210b	\N	85.68.69.236	41b0a731-3378-42bd-9e08-8b69a1fee83a	5	2012-05-07 08:57:46.284716
a085d0e9-8ea1-4169-9462-27c88180dfe6	\N	80.11.104.113	69361720-3428-417e-beb4-d21df542992c	3	2012-05-10 14:21:28.625048
7f99b6a6-5e46-4888-be33-ccc9d81c1010	\N	68.68.3.114	69361720-3428-417e-beb4-d21df542992c	5	2012-05-13 19:34:32.218786
e26a9d0c-1c9f-414b-b7fb-ea99632cfa05	\N	46.4.95.140	5e86134f-2cb5-40e9-affa-f80d934a14b9	5	2012-03-05 21:30:55.175781
1f8d2501-4816-4417-a20a-33774f6e6ab6	\N	68.68.3.114	4276f7df-c7e9-44e1-8886-20ad41ebda0a	5	2012-05-13 19:35:33.962791
60ad72e8-9b44-47f1-8c85-dc6b1e787f82	\N	68.68.3.114	1901d722-a38d-4e79-a13c-ca51d61bae30	5	2012-05-13 19:35:43.426401
39bd3f6b-2db2-44cb-80c5-dfec5fad54ef	\N	46.4.95.140	6d999f74-d520-4a8c-8188-5a5c13c6bbec	5	2012-06-14 05:13:32.254074
3ac52cc0-4d46-49f7-99f5-79e4af85b6db	\N	111.13.8.15	89a894cc-c5c8-44e2-9ca3-85ab9a0130f9	5	2012-05-24 15:39:58.2316
6a0ea2eb-1ebe-42cc-a563-06b28f91cede	\N	111.13.8.15	0460ea96-a830-40bd-adfb-140aad4c31ca	5	2012-05-24 15:19:20.650452
89e4ce3a-3bc4-4fbc-8aae-dc06ac200015	\N	68.68.3.114	6d999f74-d520-4a8c-8188-5a5c13c6bbec	5	2012-05-13 19:35:50.67692
61812b7f-18ca-4691-9cc8-37da05f71be1	\N	111.13.8.15	78e9e396-2ab2-4d61-9eea-fe08b840dbf9	5	2012-05-24 15:08:47.362438
5fa975ef-4f00-426f-ab69-9f5ca3c50695	\N	111.13.8.15	2a4bae91-082b-4ae5-9729-08c86e000ab5	2	2012-05-24 15:45:04.712776
d528c363-a5ed-4a68-8ca6-5a3e321846ae	\N	68.68.3.114	43c3cc44-3a6c-469b-80fe-913927d2c283	5	2012-05-13 19:37:24.673111
12d13931-e523-4785-9568-7194d044775e	\N	111.13.8.15	196340e0-5246-4bc2-8b69-54c66a48b399	1	2012-05-24 10:44:29.636188
93d79a6d-594f-47b2-94ed-5c4ec9d777a0	\N	111.13.8.15	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	2	2012-05-24 10:34:44.992336
e55b2585-776c-4dea-accb-40661bee0d0a	\N	68.68.3.114	34269022-c891-4a8e-a814-3af2b0fea526	5	2012-05-13 19:37:31.251715
a934a1a1-f174-4b4b-8983-53865ee8fe46	\N	111.13.8.15	ced8947c-7c6b-4874-ad5e-c28ba91f8073	4	2012-05-29 01:41:32.629353
c3667719-108d-460e-9c77-9e449b8a18a4	69518980-63f7-4b53-a063-320532697987	\N	cd42a806-cac1-452c-9b0d-116d8ead4d64	5	2012-05-31 02:00:17.25121
d1f809f5-7fb9-411b-ab95-ab98d92dafe2	\N	109.214.161.141	cd42a806-cac1-452c-9b0d-116d8ead4d64	5	2012-06-02 14:27:00.444184
a7770ac0-c4c3-4539-be45-41edbe64c9ca	\N	68.68.3.114	2502f9a7-15fa-439d-8a48-f61f38cb6f55	5	2012-05-13 19:37:39.959615
c4156a80-828e-4b8c-b7cb-9843d44ed43a	\N	88.163.80.208	cd42a806-cac1-452c-9b0d-116d8ead4d64	5	2012-05-22 15:00:21.368502
b370ec67-0302-4b43-8264-ad9cb7267b3e	\N	84.101.212.249	2a4bae91-082b-4ae5-9729-08c86e000ab5	5	2012-06-11 00:19:28.271812
683a458c-b3fe-453b-9a74-7e5e630f8805	\N	46.4.95.140	a1019da5-cdac-4e09-8b60-831994b5f275	5	2012-06-14 05:27:45.12234
45f8757d-3442-441d-90a5-4743f323e85f	\N	46.4.95.140	69361720-3428-417e-beb4-d21df542992c	5	2012-06-14 05:07:30.709747
50f67949-df1e-4524-b4af-35674d5902a4	\N	46.4.95.140	34269022-c891-4a8e-a814-3af2b0fea526	5	2012-06-14 05:17:57.428569
6841fd94-4b0b-41eb-9944-bffcb1763868	\N	46.4.95.140	e3424ea9-f7c0-4d80-832b-890c3de0f744	5	2012-06-14 05:42:01.707419
a02eda52-5466-4caf-a302-515f8c4d468c	\N	46.4.95.140	29772378-f226-4fc8-8e01-9a87c5e43a00	5	2012-06-14 05:37:32.798834
fb21665e-ab20-4df1-aa49-47c8a0bad56d	\N	46.4.95.140	3aa0d5ce-cef6-4158-b51e-ddee8ece7b5e	5	2012-06-14 05:22:12.710244
ac88ebf0-9280-4d1a-864f-3e4740f75f64	\N	46.4.95.140	65d7e18e-c5ab-4736-bb9e-c47de2dc41e1	5	2012-06-14 05:30:17.162966
d5e98033-ac98-4a35-be0d-641b51c27879	\N	46.4.95.140	fea6dcd6-00d6-4ad5-ab2f-eb40f533a5db	5	2012-06-14 06:05:33.895932
b71f3553-3720-4fbb-90b5-d0eb62d61b15	\N	46.4.95.140	97b2cf1e-91f4-4b08-a7d8-2e6bd1dca37e	5	2012-06-14 05:46:12.872483
40326736-f57b-4748-9354-f7737c602e80	\N	46.4.95.140	3fabe36b-965b-498d-9b3a-0649bbbfd0a5	5	2012-06-14 05:43:55.433425
e04b6a52-ffb5-4127-9520-a511133194ff	\N	46.4.95.140	cd42a806-cac1-452c-9b0d-116d8ead4d64	5	2012-06-14 06:02:34.936749
d36ecb10-9e28-43a1-9b6f-d42568b9e911	\N	46.4.95.140	41b0a731-3378-42bd-9e08-8b69a1fee83a	5	2012-06-14 06:10:01.818872
9dd8d5b6-abe6-46d8-98f0-461053a383c8	\N	46.4.95.140	67906f75-4298-4b6a-aa62-d8314be33f15	5	2012-06-14 06:14:27.780851
c526bfbb-3ebf-4369-b68b-3afaa9b7374d	\N	46.4.95.140	89a894cc-c5c8-44e2-9ca3-85ab9a0130f9	5	2012-06-14 06:18:49.295627
05e13f98-9487-4828-b309-263897359aa0	\N	46.4.95.140	84b91384-8ec9-4b55-8dc9-28ff8c6db62f	5	2012-06-14 06:20:46.953775
0d8af3c1-5388-4dd4-9763-036c0afd5a62	\N	46.4.95.140	0460ea96-a830-40bd-adfb-140aad4c31ca	5	2012-06-14 06:22:57.497443
41f5161f-02e3-494b-99e2-2fcc9d610a42	\N	46.4.95.140	4235252c-aa21-46b5-8c52-110f95bdc583	5	2012-06-14 06:24:40.694942
08faa305-7a57-42a8-a959-f5f251ea4067	\N	46.4.95.140	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	5	2012-06-14 06:28:16.199281
507b5b60-28dc-4018-b2e9-196a76c33273	\N	46.4.95.140	09d5ff25-7a8a-4228-9093-bb437bb70f1a	5	2012-03-05 22:01:09.434531
5263c004-b8e9-4153-87d5-1242c0cd249f	\N	119.247.226.156	f3d8ca3c-32b9-4485-95d9-0b1fd4a5dd4e	4	2012-06-12 14:27:12.322108
80dd6355-f3d9-4112-8315-94faccc95b77	\N	91.201.64.24	196340e0-5246-4bc2-8b69-54c66a48b399	5	2012-05-25 07:34:05.497635
76f31581-bf16-424f-817c-e512150daee2	\N	119.247.226.156	97b2cf1e-91f4-4b08-a7d8-2e6bd1dca37e	5	2012-06-03 17:20:27.743533
4235e82e-1fac-41ab-8460-fb13fdfab480	\N	119.247.226.156	ece794a5-613f-4607-9046-fb37906f87ce	3	2012-06-13 10:56:45.903525
d0f0a5f5-6c30-4c31-8ad4-da5eeca55fef	\N	46.4.95.140	b57f2ed1-ee10-469b-afcc-a4d7636d39c7	5	2012-06-14 08:36:42.190334
9adf3bee-27be-41d4-acb6-41d132e587c5	\N	46.4.95.140	a8f061a9-6ba5-46df-89cd-6e65bfa28fe5	5	2012-06-14 06:38:41.32829
61d60d47-7dd5-4703-90e5-3ee8a5006ea2	\N	46.4.95.140	e657011b-cf83-47ab-8bc8-62f6498046a6	5	2012-06-14 07:17:07.831925
bb9892dc-05e9-4d22-99d5-8ac8e75fa21a	\N	46.4.95.140	fe7cd753-376f-4f22-a721-caa482aa1116	5	2012-06-14 08:25:54.277904
f225c7f3-2b4a-416f-a9ce-4aa4f552a605	\N	46.4.95.140	430e39ad-4906-44ba-83bc-8f2bc6f2d039	5	2012-06-14 06:40:52.573129
b78dd661-71d4-4143-8b97-c2c2f5368345	\N	46.4.95.140	ac051eb3-275f-40a5-b160-e224d13902e7	5	2012-06-14 07:55:25.991082
c4d5624e-2639-4372-b42f-54ba401980b7	\N	46.4.95.140	3d4e64cc-54c0-4b3e-b865-2fff3d9845e7	5	2012-06-14 07:18:49.659543
20e5d77f-9dc0-4ca8-9f81-f0f46f4afab1	\N	46.4.95.140	c4556598-bcc7-4c45-8ae8-bdafc367eaa2	5	2012-06-14 06:43:18.472187
1df1d09b-0bfc-4223-a2b7-f6f98bac6668	\N	46.4.95.140	cdc13d67-6360-43a6-bb99-cd68b64ee3f3	5	2012-06-14 08:11:44.347836
5f7c8f4b-68b7-471a-83ef-b46ef361d93e	\N	46.4.95.140	5efedd90-782d-4129-8e71-fdd3b6e1c7df	5	2012-06-14 06:48:08.841619
b65851c0-49d7-4833-af6f-ebf994943a2a	\N	46.4.95.140	2a4bae91-082b-4ae5-9729-08c86e000ab5	5	2012-06-14 07:20:55.100886
71638294-59bf-4ac8-bcac-f33b2f28eb74	\N	46.4.95.140	f1261a91-9d52-4520-837e-e9c793f28dcc	5	2012-06-14 06:50:04.483781
a533977b-fbea-4e28-9d25-ed6d6724ca49	\N	46.4.95.140	f3d8ca3c-32b9-4485-95d9-0b1fd4a5dd4e	5	2012-06-14 07:57:30.923174
3f7cdea1-f51e-456d-b94c-9883e3084224	\N	46.4.95.140	d794f07a-06d3-4b59-a969-c00af70ff8db	5	2012-06-14 06:54:22.878652
3773da4f-0c97-4f06-8b9e-fe9d89e829fb	\N	46.4.95.140	b99894af-7866-4a81-beee-30e0e384b708	5	2012-06-14 07:22:51.514093
0c7d25d2-0e82-48c9-9d03-cb444d81a3dd	\N	46.4.95.140	624552ff-a7cd-427d-88e3-f31ec6dba89b	5	2012-06-14 09:55:59.102306
98df524f-96fa-4586-8a59-4f2c0ee0f1be	\N	46.4.95.140	275e4c19-2885-4630-b049-e365374c27fb	5	2012-06-14 06:56:55.880487
c17f2c47-407d-4894-9560-d0a134156254	\N	46.4.95.140	4acf41b9-9c8b-4a1e-a32e-a754abdce116	5	2012-06-14 08:15:56.18938
428894f6-e292-4a7a-9e24-84979c0b0bda	\N	46.4.95.140	be516eed-8a37-436c-af75-b623f0806f39	5	2012-06-14 08:00:32.186742
0d63b110-2f17-4210-a76a-5a03be19caf0	\N	46.4.95.140	4402487d-3e8d-4618-8444-b400c6337834	5	2012-06-14 07:26:56.948083
8bb7b015-a31b-496a-ad98-61030be84353	\N	46.4.95.140	6c0ea5a3-dd48-4015-8f65-77d56bf54bb3	5	2012-06-14 06:59:11.982481
3af45879-5b22-4f96-8318-fef15b338165	\N	46.4.95.140	48a03f6f-f8f4-4758-8672-f8ab8bd10acb	5	2012-06-14 07:03:31.001809
ad6d779a-4072-41bb-a2f4-8605d992c83b	\N	46.4.95.140	bfd1388a-ec10-4a7b-9d94-916f56f52f98	5	2012-06-14 07:34:36.07201
015f4067-4eed-480f-a595-b06ba17a57a7	\N	46.4.95.140	cd2385b8-fa33-4be9-82a8-9ceda07fdc75	5	2012-06-14 07:07:48.772846
0683efaa-afaa-4193-a0ba-5c2b5357e9af	\N	46.4.95.140	584d3863-eecc-4595-8a18-145ba2b213f7	5	2012-06-14 08:30:25.513594
94954180-bad4-4fbc-bb0c-7b3cca9eb4ca	\N	46.4.95.140	5b23d4f4-058e-44e0-945d-ae9035fb1e15	5	2012-06-14 08:03:08.577837
2537a9c2-af23-4491-ba1a-4aaa7da297b9	\N	46.4.95.140	de5557e1-bf16-433b-87ff-401323a97df5	5	2012-06-14 07:09:38.369402
00405049-1197-4131-9bfb-db985874c260	\N	46.4.95.140	32ccab1e-e85e-4f52-84f5-69bbcc5fa53d	5	2012-06-14 07:39:15.361476
c3bb9726-9aa1-48ca-948e-1281378e3b6c	\N	46.4.95.140	20100c39-31ae-4fd4-ad35-bfeabe396b5f	5	2012-06-14 08:18:02.268078
5f7e24d8-5dbf-4335-bc1f-47a6872c6412	\N	46.4.95.140	02970c3a-2240-4a74-8fd3-18af09a9cd61	5	2012-06-14 08:05:27.865116
0e0ad5ff-4231-4d14-9ae3-ea9f1be8a35e	\N	46.4.95.140	8708a912-1b80-441d-9ba3-d607dd2f0c7c	5	2012-06-14 07:41:41.097044
173cd57c-7fef-4690-a047-d392b701718e	\N	222.186.26.41	fea6dcd6-00d6-4ad5-ab2f-eb40f533a5db	3	2012-06-16 13:32:32.140296
44abc484-311a-45b5-b4df-8c5bb96147be	\N	46.4.95.140	529d4aba-d25d-44d6-ba1b-d6ad314d6158	5	2012-06-14 08:41:08.034321
d9fb8d43-a202-4990-b58d-4141c39dd1a8	\N	46.4.95.140	d6c6d3f9-5d8d-46c8-bc92-d8507d1e6f04	5	2012-06-14 07:51:06.057309
d85fc90c-b5e7-4121-aaf0-3ffcbe392169	\N	46.4.95.140	5a3d4806-974f-4754-b6cb-65a7dfa27548	5	2012-06-14 08:07:37.770707
34bfff09-352a-4298-be5b-a50b7ab9ae8b	\N	46.4.95.140	1399fe4b-2c07-4bda-a720-9df928d51816	5	2012-06-14 08:20:48.392908
79512bdb-26a9-4348-a324-9228452d1d97	\N	78.225.193.5	e657011b-cf83-47ab-8bc8-62f6498046a6	5	2012-06-14 08:22:22.86431
0109fcd2-ec93-4f03-9980-54ab033b7d96	\N	46.4.95.140	8d9cf757-de83-4774-919b-00c45c43efd4	5	2012-06-14 08:09:33.218506
ff9733a2-172c-4d1d-af2a-cca44a1ee4be	\N	46.4.95.140	e1b56ce2-aea6-4d44-b877-86a13f92697c	5	2012-06-14 08:32:26.80352
fc26c011-86f7-4faf-a625-9c9540ce2814	\N	46.4.95.140	8d447067-389f-4c39-ba51-63430a736df4	5	2012-06-14 08:51:25.535969
d1e91128-3f0f-4f89-8e45-138327bc4f55	\N	46.4.95.140	0e14dccb-9c28-4f89-b3b2-cb1011be06d1	5	2012-06-14 08:23:08.82607
3ea1c8ae-7895-4f94-b271-b66c93d86055	\N	46.4.95.140	8a7d516b-f3c2-4a5b-afde-d2bdff371937	5	2012-06-14 08:46:29.283988
493ffc30-d268-475d-b396-ab0ce410b4f9	\N	46.4.95.140	cea11492-fdec-4cfc-a179-a4bbc05cac0b	5	2012-06-14 08:34:29.599412
3afe2020-9f43-41a0-ad20-5c2288bf5926	\N	46.4.95.140	c67a2104-aa5f-4e9f-830f-662ce97995d6	5	2012-06-15 04:27:27.068727
d54d7acb-2d3c-4f69-9012-546b123d1fbc	\N	46.4.95.140	1c17435c-508d-4194-9d06-f923d31c60cf	5	2012-06-14 08:53:38.36613
54ee4372-45b9-4ecb-95df-2f0824e4d565	\N	46.4.95.140	f7a32926-f029-47f4-8649-e3b2997f69d3	5	2012-06-14 08:49:00.451487
ca8fae2f-6485-4e53-9e4f-05126cff7a88	\N	46.4.95.140	e3e52ca7-2e9e-4f87-a818-5a808823089b	5	2012-06-15 04:40:52.570077
d617b3b2-7269-452e-a139-43a3c5eb0bd2	\N	46.105.123.87	fea6dcd6-00d6-4ad5-ab2f-eb40f533a5db	4	2012-06-19 01:08:17.835576
52038eda-5e5b-43b8-9889-f1545e9f8555	\N	46.4.95.140	2364edf3-baf9-4a60-a75e-46387f235726	5	2012-06-15 04:30:05.251672
5d66c6db-da46-4dd9-80c9-a9c5962b69b1	\N	81.52.143.30	cd42a806-cac1-452c-9b0d-116d8ead4d64	4	2012-06-23 09:36:26.307108
18642960-f8bb-47db-844a-e9f3d9b0cfbc	\N	81.52.143.37	cd42a806-cac1-452c-9b0d-116d8ead4d64	1	2012-06-23 17:57:07.110211
4f972c13-f47d-44c1-b678-a03602345522	\N	119.247.226.156	6c0ea5a3-dd48-4015-8f65-77d56bf54bb3	4	2012-06-24 00:09:45.109164
555c05f3-21bc-43bf-b203-e2f2597f7f68	\N	119.247.226.156	48a03f6f-f8f4-4758-8672-f8ab8bd10acb	5	2012-06-17 12:58:08.214543
6f0db62e-17b2-4d60-a025-703433702fa6	\N	119.247.226.156	1cf46091-d128-4e38-a7b7-97901d423aaf	3	2012-06-26 07:09:31.139499
f491e2b5-6cd3-488a-9834-d08b5827ec85	\N	79.91.82.184	e657011b-cf83-47ab-8bc8-62f6498046a6	5	2012-06-26 18:56:56.835211
8502ea38-35dc-48d0-86b4-c3d8acb8c4e0	\N	93.27.196.22	f1b3849e-9568-4cae-a3a0-3cca7f42c079	5	2012-06-28 15:19:15.546329
36fe5616-cef4-463a-81a4-d72855baffc2	\N	81.52.143.33	cd42a806-cac1-452c-9b0d-116d8ead4d64	5	2012-06-30 02:13:49.857827
4023f296-6979-4582-ad80-a57ade13f776	\N	119.247.226.156	3c175c09-a896-4a88-9603-2b5ea27ef1a1	2	2012-06-24 19:55:38.881576
a27b74b4-059b-4449-8667-6f7dbdab7e87	\N	91.201.64.24	0460ea96-a830-40bd-adfb-140aad4c31ca	2	2012-06-17 14:45:56.232793
0b6364f8-0c80-4d9e-92d0-aebaf8cc77c8	\N	87.25.10.168	34269022-c891-4a8e-a814-3af2b0fea526	2	2012-06-30 10:29:21.529144
15946fa1-e407-41c0-934f-1d059c2fb25a	\N	119.247.226.156	f22a7938-303f-4ac6-92da-526a4ad2a207	5	2012-07-06 22:40:39.152857
69885f5d-4dcc-4160-b549-3d5093d0a71c	\N	86.70.176.170	aac3a30b-36a9-4887-8aab-81c552bfc7d7	5	2012-07-08 00:42:21.795554
2f83ebad-e39d-4a01-a32b-b174c9193bec	\N	174.37.65.104	29772378-f226-4fc8-8e01-9a87c5e43a00	4	2012-07-18 05:05:22.752962
22a3e86e-90db-4de4-a950-e360f2a2b973	\N	174.37.65.104	3aa0d5ce-cef6-4158-b51e-ddee8ece7b5e	1	2012-07-18 04:02:39.354797
0b0af948-8ca1-40e0-8e65-9f4a0d4b0498	\N	66.172.33.112	27597355-d542-4574-adc8-6493883d1454	5	2012-07-11 18:31:58.670488
de7dc1c7-b313-4863-bd79-524690155785	\N	119.247.226.156	584d3863-eecc-4595-8a18-145ba2b213f7	3	2012-07-13 05:32:07.690982
f3055a81-d406-4492-8acc-6812eb23be8d	\N	119.247.226.156	1901d722-a38d-4e79-a13c-ca51d61bae30	2	2012-07-14 18:03:23.824132
b79a357a-9d2f-4896-b727-8c11bbb96160	\N	119.247.226.156	34269022-c891-4a8e-a814-3af2b0fea526	1	2012-07-07 08:29:16.100954
a5fcd537-b104-4a77-ba7f-889ea568c080	\N	86.214.130.23	8d9cf757-de83-4774-919b-00c45c43efd4	5	2012-07-17 17:36:07.783743
dd41ba43-e488-45e3-8c08-9fd2e55eedc2	\N	174.37.65.104	db34f769-ed94-45d3-8b66-5ebaf9b091ff	5	2012-07-18 07:34:28.250219
b0328c4e-f5be-4c3f-b4f6-755245a4fa7a	\N	174.37.65.104	6d999f74-d520-4a8c-8188-5a5c13c6bbec	2	2012-07-18 06:06:36.05777
c8ae670e-4636-40c8-b3f7-7ff292cb4312	\N	174.37.65.104	78e9e396-2ab2-4d61-9eea-fe08b840dbf9	5	2012-07-18 00:56:42.927642
1522bf8c-6044-4fc2-a648-5eca7dc92ea8	\N	174.37.65.104	e3623259-d93b-4596-930a-0282a07b5666	3	2012-07-18 04:10:40.784609
fc2c28db-c400-44f5-9e6f-3c6e8e047e25	\N	174.37.65.104	61d87eb7-e3d3-4f90-a3a8-b43b5362db1a	4	2012-07-18 01:59:33.031391
0ffd6ac5-c2b6-403c-922c-3788005a9c35	\N	174.37.65.104	65d7e18e-c5ab-4736-bb9e-c47de2dc41e1	2	2012-07-18 05:14:33.370775
d4d1f2e3-6789-45e7-96bf-0a8b9229f28a	\N	174.37.65.104	84b91384-8ec9-4b55-8dc9-28ff8c6db62f	2	2012-07-18 03:18:38.426862
5d412078-6055-4da7-9166-676a7046606a	\N	174.37.65.104	30bcda76-5a1a-4369-a6f3-ed2584ad4031	2	2012-07-18 04:18:38.127923
270ce677-441a-4949-b9ff-c231ff7bf0ab	\N	174.37.65.104	9382520e-adb5-4403-848d-5bd5ea476202	4	2012-07-18 08:02:12.325872
ee9b4d91-a8fc-4208-9759-083d6b2657c6	\N	174.37.65.104	4235252c-aa21-46b5-8c52-110f95bdc583	5	2012-07-18 03:30:27.074725
f71e63fe-5cba-4b25-ab55-d5db6ae0427b	\N	174.37.65.104	69361720-3428-417e-beb4-d21df542992c	4	2012-07-18 06:51:34.616102
7e05cc5b-4086-4186-bec2-b4ebf8753331	\N	174.37.65.104	41b0a731-3378-42bd-9e08-8b69a1fee83a	4	2012-07-18 05:26:49.594433
113660b4-6592-4ae8-bdfe-3ff5826974af	\N	174.37.65.104	1dacf074-ad54-432a-a04f-cecd3a068d0c	5	2012-07-18 04:33:09.435475
c4d13c4c-1ff5-49b1-8092-2c3ad512d6a9	\N	174.37.65.104	0a048cd8-5468-4fcd-bd67-50675c83002d	1	2012-07-18 03:35:45.621109
dd0c5ffc-c786-4f70-af27-d1d58ed78715	\N	174.37.65.104	e3424ea9-f7c0-4d80-832b-890c3de0f744	2	2012-07-18 06:14:26.28543
31c2e91c-aac1-4382-82be-f9e1f6b3ce16	\N	174.37.65.104	e657011b-cf83-47ab-8bc8-62f6498046a6	4	2012-07-18 03:43:37.054884
83cf32c4-c4a0-47b9-973c-8ceb6fc48e57	\N	174.37.65.104	196340e0-5246-4bc2-8b69-54c66a48b399	1	2012-07-18 04:40:21.36366
3da978e5-0cce-4531-a059-a8c5de6f8fb1	\N	174.37.65.104	67906f75-4298-4b6a-aa62-d8314be33f15	4	2012-07-18 03:52:31.259313
eb3f6cd3-e49b-433e-a82c-fbd0b23f4089	\N	174.37.65.104	a8f061a9-6ba5-46df-89cd-6e65bfa28fe5	4	2012-07-18 05:37:48.421579
39564a6d-0b71-48c4-8620-a88d83ede7be	\N	174.37.65.104	5c29c0cd-e773-4697-8172-ab1b075490c2	1	2012-07-18 04:50:32.107513
a51d2f11-0d7c-4f23-8d9c-ca668548d085	\N	174.37.65.104	2502f9a7-15fa-439d-8a48-f61f38cb6f55	2	2012-07-18 06:21:08.678537
a94a1c86-8396-449e-aace-aa9750bd52d6	\N	119.247.226.156	cd2385b8-fa33-4be9-82a8-9ceda07fdc75	4	2012-07-02 16:03:32.552834
1a6d8880-edaa-4cbb-997f-05ea5fbfc006	\N	174.37.65.104	497e8d74-14c2-401e-bc0d-a4b473f77eb1	1	2012-07-18 04:58:15.657256
8737dcbe-d7c4-4a5b-8d43-16631595c5d8	\N	174.37.65.104	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	3	2012-07-18 05:44:54.643573
46990bdd-6830-4133-957b-71e229c5f20b	\N	174.37.65.104	5e86134f-2cb5-40e9-affa-f80d934a14b9	4	2012-07-18 07:44:28.867418
3389b2dc-0901-4b13-aa06-4b0f637b2c38	\N	174.37.65.104	e4c69e90-1056-4f46-9619-57d0a18d1737	4	2012-07-18 06:57:35.309816
3c083a9a-ef3f-4228-a673-c3cd543c0efe	\N	174.37.65.104	89a894cc-c5c8-44e2-9ca3-85ab9a0130f9	4	2012-07-18 05:54:59.611742
ae91b58e-bf25-4eb5-87ff-8a4b9f6f2a40	\N	174.37.65.104	43c3cc44-3a6c-469b-80fe-913927d2c283	3	2012-07-18 06:35:00.81506
7185902f-5fa5-40b4-a9b1-03ade549df79	\N	174.37.65.104	ac051eb3-275f-40a5-b160-e224d13902e7	2	2012-07-18 09:36:37.196635
90c58201-fc28-438f-80e2-15c676d4ef02	\N	174.37.65.104	f3d8ca3c-32b9-4485-95d9-0b1fd4a5dd4e	1	2012-07-18 09:28:30.103118
6f0047fa-2669-4463-bdaa-e606b7ae15b2	\N	174.37.65.104	4276f7df-c7e9-44e1-8886-20ad41ebda0a	3	2012-07-18 07:04:38.655454
5e78da00-072c-4c33-9716-a64cf8fec133	\N	174.37.65.104	97b2cf1e-91f4-4b08-a7d8-2e6bd1dca37e	5	2012-07-18 06:42:51.836439
534d4e30-9b4f-43ff-8b62-437fdd8e93c9	\N	174.37.65.104	587ed76e-1c2f-4cc7-a23a-f9beb2415c77	1	2012-07-18 08:14:30.884758
b99303f3-48b2-4df1-9c84-599281a91d37	\N	174.37.65.104	1901d722-a38d-4e79-a13c-ca51d61bae30	5	2012-07-18 07:52:54.024624
44ada82e-c274-4ea7-9b6c-62efe8bd4714	\N	174.37.65.104	34269022-c891-4a8e-a814-3af2b0fea526	1	2012-07-18 08:32:53.082185
9a1c85b0-199d-419d-b8fe-78154c0a4f49	\N	174.37.65.104	3fabe36b-965b-498d-9b3a-0649bbbfd0a5	3	2012-07-18 09:00:58.485218
22f60462-9564-4bc6-ac29-d37c052f3606	\N	174.37.65.104	a1019da5-cdac-4e09-8b60-831994b5f275	5	2012-07-18 08:26:14.832658
70584724-f1ee-437c-97ca-f5aa5df67c59	\N	174.37.65.104	f4517261-c1ee-4380-b3ad-0de5a0edc09a	3	2012-07-18 08:39:42.183907
62ee72d9-7c74-45da-b9d4-3e44abec55ee	\N	174.37.65.104	f6c6aac7-3c9b-4a3c-80bc-d6709bc95d4b	5	2012-07-18 09:40:46.930049
0e8cea85-3155-4d02-a5e1-1528e760bbb8	\N	174.37.65.104	2a4bae91-082b-4ae5-9729-08c86e000ab5	1	2012-07-18 09:48:32.367393
eb41fea1-6c92-4e6e-a52c-01baecd4946b	\N	174.37.65.104	cd42a806-cac1-452c-9b0d-116d8ead4d64	3	2012-07-18 10:10:42.737644
10db1800-8bf9-46e5-85ff-85c9eff3f2a6	\N	174.37.65.104	27597355-d542-4574-adc8-6493883d1454	2	2012-07-18 10:16:01.850063
3cd63824-5659-416e-bd5b-15a7e461bc2c	\N	174.37.65.104	aac3a30b-36a9-4887-8aab-81c552bfc7d7	2	2012-07-18 10:24:45.131244
0bc340aa-4b1a-4648-92fe-6e4cb9e28234	\N	174.37.65.104	f1b3849e-9568-4cae-a3a0-3cca7f42c079	2	2012-07-18 10:36:45.539698
bd9ffb1c-32eb-491e-a1c0-a488bd8b97ce	\N	174.37.65.104	6968ef13-1d2f-4de3-b533-706bc9c0f604	4	2012-07-18 11:41:23.261551
f30b5503-46bf-450c-a5c3-715d25ab4b38	\N	174.37.65.104	7f6c30c6-d6a5-4d39-ae5d-e1ae4cc2d3ef	3	2012-07-18 11:48:14.269695
df252134-9ee5-4273-b61e-b9045541f76a	\N	174.37.65.104	25dd2269-e0f3-4653-98ac-33f64f09d4d3	1	2012-07-18 11:58:22.056897
0e88543d-c1b4-4175-b596-96e8b3727382	\N	119.247.226.156	159b6644-94ed-406d-8e1e-1f002f265396	1	2012-07-02 12:49:24.663138
932b7c24-6845-42a8-8989-624494934831	\N	174.37.65.104	275e4c19-2885-4630-b049-e365374c27fb	3	2012-07-18 16:19:44.662813
3ca0a2eb-40b6-4364-bbff-5e9e08393ccc	\N	174.37.65.104	b9582bd1-bfff-41e1-990f-962c18084f4d	5	2012-07-18 12:06:47.877744
03b7e82c-8c4a-47f3-9395-f80e23eff2fa	\N	174.37.65.104	df6c89f3-4473-424b-a0b0-119977da62c5	4	2012-07-18 13:29:05.547402
7e52f320-993a-4bc3-9743-6563e64e23a1	\N	174.37.65.104	4654898f-58f4-482f-a91f-23aa5e192fd8	1	2012-07-18 12:11:57.083893
91e9591d-9bd7-47d4-9a36-8ea67c97c6a4	\N	174.37.65.104	be516eed-8a37-436c-af75-b623f0806f39	3	2012-07-18 14:40:18.264754
fb63dfd6-834f-488e-b1e4-c560396d3f8e	\N	174.37.65.104	60e23204-8e78-487c-92bd-5de0c6102067	3	2012-07-18 13:36:15.113227
01e21593-893f-48e2-9f27-3cb2caa11120	\N	174.37.65.104	d6c6d3f9-5d8d-46c8-bc92-d8507d1e6f04	2	2012-07-18 12:19:37.368745
70d6ada9-8b9f-4b0c-aff7-c67207c081a5	\N	174.37.65.104	430e39ad-4906-44ba-83bc-8f2bc6f2d039	5	2012-07-18 15:44:59.925215
18af08bc-5c79-424c-9b06-868f2787caa2	\N	174.37.65.104	f7a32926-f029-47f4-8649-e3b2997f69d3	5	2012-07-18 12:26:01.929907
133712e7-6410-433c-a8ae-743ad1fa8764	\N	174.37.65.104	2364edf3-baf9-4a60-a75e-46387f235726	2	2012-07-18 19:54:24.647907
c9a7e3b0-0bcf-4aee-9a28-9bbd0e8b322f	\N	174.37.65.104	4acf41b9-9c8b-4a1e-a32e-a754abdce116	2	2012-07-18 13:43:52.229003
89e7852d-b1ee-40ad-9352-43997fcf704c	\N	174.37.65.104	3d4e64cc-54c0-4b3e-b865-2fff3d9845e7	2	2012-07-18 12:33:53.042198
bf7f9f5b-6fa8-47b2-8f18-3ce2b44bec95	\N	174.37.65.104	02970c3a-2240-4a74-8fd3-18af09a9cd61	4	2012-07-18 14:50:58.385102
f287bef0-1486-416c-9d5a-72f31513b229	\N	174.37.65.104	f1261a91-9d52-4520-837e-e9c793f28dcc	3	2012-07-18 17:22:37.36751
0648cc88-4e24-46ac-8c3c-10c2f403e6c5	\N	174.37.65.104	b57f2ed1-ee10-469b-afcc-a4d7636d39c7	5	2012-07-18 12:41:19.860009
ccef0b06-9cca-47a0-87cf-dfa8ebd821d6	\N	174.37.65.104	8a7d516b-f3c2-4a5b-afde-d2bdff371937	4	2012-07-18 13:52:37.317737
0909655c-1d13-49c7-bd84-d72cf39078fd	\N	174.37.65.104	5a3d4806-974f-4754-b6cb-65a7dfa27548	1	2012-07-18 12:47:45.678385
2570d408-661e-4bbe-89b8-2afa1ef1c04e	\N	174.37.65.104	47034ede-0506-4650-9fb4-1948168440ca	2	2012-07-18 15:52:37.98577
f504a3e5-ed4a-496a-91e6-4e5b84d78c4d	\N	174.37.65.104	9db98dbb-0a64-4588-8e57-533f05a6e050	5	2012-07-18 14:57:40.809807
b560cda7-d9ec-4d1a-b70c-0ed396daecba	\N	174.37.65.104	b815db66-cadf-4c3c-ae0b-73ad5bf1a46e	5	2012-07-18 14:02:16.34738
ac647453-1dad-4209-8cd9-272ab8b9c289	\N	174.37.65.104	205c33b6-106f-40c3-804c-a2835f6104a9	2	2012-07-18 12:57:50.66587
03d7d7ba-5ff9-4778-8f94-c1e29ffbd9aa	\N	174.37.65.104	584d3863-eecc-4595-8a18-145ba2b213f7	1	2012-07-18 13:03:16.713884
816c68c5-22ff-4b05-9efa-69dd980dbf55	\N	174.37.65.104	cd2385b8-fa33-4be9-82a8-9ceda07fdc75	4	2012-07-18 16:25:23.500149
e32eb15b-8f82-46f2-9ef0-236175db6d09	\N	174.37.65.104	1c17435c-508d-4194-9d06-f923d31c60cf	4	2012-07-18 14:10:36.432949
aea5c685-33e2-4543-b5c5-f62738125e9f	\N	174.37.65.104	e1b56ce2-aea6-4d44-b877-86a13f92697c	5	2012-07-18 13:12:12.277318
e841d4ca-46e2-4311-a3dd-2b916f742dc6	\N	174.37.65.104	fe7cd753-376f-4f22-a721-caa482aa1116	3	2012-07-18 15:05:31.866111
1ad99765-d1aa-47e4-bb95-c81f5046b6f3	\N	174.37.65.104	fea6dcd6-00d6-4ad5-ab2f-eb40f533a5db	1	2012-07-18 13:19:06.169663
5abe6b4c-514f-4492-9702-82ef34c65c66	\N	174.37.65.104	20100c39-31ae-4fd4-ad35-bfeabe396b5f	1	2012-07-18 17:00:30.914569
74b5e429-29fb-4bfa-86b1-66b8fcc51661	\N	174.37.65.104	8d447067-389f-4c39-ba51-63430a736df4	4	2012-07-18 14:17:14.841484
7c2faffa-5734-46d4-9a04-c75ad4071749	\N	174.37.65.104	6c0ea5a3-dd48-4015-8f65-77d56bf54bb3	4	2012-07-18 16:01:31.814087
9ee4734f-48c9-429d-a93f-de0ebcaeacfd	\N	174.37.65.104	ced8947c-7c6b-4874-ad5e-c28ba91f8073	2	2012-07-18 15:14:25.698255
5f51fc4b-6782-4e2b-885e-63aa34448f39	\N	174.37.65.104	4402487d-3e8d-4618-8444-b400c6337834	2	2012-07-18 14:24:16.428828
c8c3eaad-8931-41ce-ab10-cf7e227b3250	\N	174.37.65.104	bfd1388a-ec10-4a7b-9d94-916f56f52f98	3	2012-07-18 18:10:18.770118
47ad939e-73e3-401c-b0d9-d56e44be2123	\N	174.37.65.104	b99894af-7866-4a81-beee-30e0e384b708	2	2012-07-18 14:32:15.106475
5062795e-1aeb-412f-9a2f-0f828b0fe6d9	\N	174.37.65.104	48a03f6f-f8f4-4758-8672-f8ab8bd10acb	4	2012-07-18 16:32:39.503517
a8f43045-1843-4f3b-9fe2-4db9763b1d8e	\N	174.37.65.104	529d4aba-d25d-44d6-ba1b-d6ad314d6158	4	2012-07-18 15:20:25.410774
bb93048c-eab8-45af-adad-cead6c4a96fd	\N	174.37.65.104	de5557e1-bf16-433b-87ff-401323a97df5	3	2012-07-18 16:06:36.074534
a97adcbd-ec9e-4481-bde7-a5aed5ed4084	\N	174.37.65.104	8d7560cf-6d61-45dd-bf05-44ae257e97a4	2	2012-07-18 15:29:11.495349
550ce716-cbf1-4378-b1aa-ff0938b023f9	\N	174.37.65.104	1399fe4b-2c07-4bda-a720-9df928d51816	2	2012-07-18 17:46:32.388504
2dd12e1e-7bc2-4688-8807-4f6a551b4443	\N	174.37.65.104	c4556598-bcc7-4c45-8ae8-bdafc367eaa2	4	2012-07-18 16:12:29.598801
6d1f02c0-7066-4a57-bdae-3bc9a2f208ee	\N	174.37.65.104	cea11492-fdec-4cfc-a179-a4bbc05cac0b	2	2012-07-18 17:07:08.896199
b8b21ff0-0f67-4605-b05d-0ca8e3bc1ee5	\N	174.37.65.104	09d5ff25-7a8a-4228-9093-bb437bb70f1a	4	2012-07-18 16:41:53.948269
a7a588de-a06f-4bc5-852b-26068232e566	\N	174.37.65.104	5efedd90-782d-4129-8e71-fdd3b6e1c7df	5	2012-07-18 17:29:04.219665
2a89ce04-7800-4457-87d7-2279ac7ca2f7	\N	174.37.65.104	f22a7938-303f-4ac6-92da-526a4ad2a207	2	2012-07-18 16:50:54.8709
3784af74-9900-4478-83fe-08f96ff7ffb3	\N	174.37.65.104	d794f07a-06d3-4b59-a969-c00af70ff8db	2	2012-07-18 17:14:22.875425
4c615ab8-114e-43d4-a429-dfd112a251c9	\N	174.37.65.104	4dbf7c31-5115-4700-963d-91f23f76aaa4	4	2012-07-18 19:30:09.292388
e72ee47a-e8bc-46e8-92a6-d16b92da5b06	\N	174.37.65.104	0460ea96-a830-40bd-adfb-140aad4c31ca	1	2012-07-18 18:02:32.034704
83b12688-eea9-41ce-b3dc-25368fdb13de	\N	174.37.65.104	ece794a5-613f-4607-9046-fb37906f87ce	2	2012-07-18 17:35:44.965267
a8e5c76c-384b-469d-aff6-3b8d38190030	\N	174.37.65.104	159b6644-94ed-406d-8e1e-1f002f265396	5	2012-07-18 18:22:22.519211
e33b4a04-c2a1-4be5-8e60-4123892a20df	\N	119.247.226.156	20100c39-31ae-4fd4-ad35-bfeabe396b5f	3	2012-07-20 00:20:38.433385
1fa7db77-072f-4842-a76e-cfd5f5ba3c03	\N	88.188.175.25	f1b3849e-9568-4cae-a3a0-3cca7f42c079	3	2012-07-23 08:21:45.626673
aa1f2861-1ec5-498a-99b4-62c35b3c3c65	\N	174.37.65.104	c67a2104-aa5f-4e9f-830f-662ce97995d6	3	2012-07-18 20:10:14.037638
5bc8ed9d-7347-4c7a-bf16-620e1fb5fd3e	\N	174.37.65.104	624552ff-a7cd-427d-88e3-f31ec6dba89b	1	2012-07-18 20:31:22.555315
a4a4e485-a36e-4fae-8cec-21c3ba6bfb16	\N	119.247.226.156	de5557e1-bf16-433b-87ff-401323a97df5	5	2012-07-25 19:50:21.517114
a8d97c19-27f6-400c-ade6-638951bb7d96	\N	119.247.226.156	fea6dcd6-00d6-4ad5-ab2f-eb40f533a5db	3	2012-07-27 22:24:46.390955
b20b678e-d1bf-41a7-825a-d6ea0300b9f3	\N	119.247.226.156	0e14dccb-9c28-4f89-b3b2-cb1011be06d1	5	2012-07-28 08:53:00.351283
337acf5f-cede-424e-81b9-52d0b0bf9878	\N	119.247.226.156	78e9e396-2ab2-4d61-9eea-fe08b840dbf9	4	2012-07-31 13:31:04.204071
79d182b1-1769-4061-ac6b-bc4d943f25f1	\N	119.247.226.156	ced8947c-7c6b-4874-ad5e-c28ba91f8073	5	2012-07-23 16:07:13.329929
a968ea2f-b319-47bd-9df5-a31d60a928b6	\N	119.247.226.156	30bcda76-5a1a-4369-a6f3-ed2584ad4031	2	2012-07-30 22:06:42.342508
09919cc0-edf6-4814-b660-cedc34ba9c63	\N	77.78.104.141	8d9cf757-de83-4774-919b-00c45c43efd4	1	2012-08-08 17:09:46.94594
eb14f367-9d89-40a0-b94d-0bf614cd923c	\N	119.247.226.156	5efedd90-782d-4129-8e71-fdd3b6e1c7df	5	2012-08-17 00:10:06.862488
a19e2e24-5db1-483b-88f0-b53699300170	\N	194.199.7.23	43c3cc44-3a6c-469b-80fe-913927d2c283	5	2012-10-15 23:31:33.250994
49d17961-d9c6-4e80-8a5b-71ffee3a54d1	\N	82.66.168.200	1901d722-a38d-4e79-a13c-ca51d61bae30	5	2012-09-07 10:03:51.343328
ac850a3c-3984-4c65-95c0-0cb4e2b12e43	\N	91.201.64.24	89a894cc-c5c8-44e2-9ca3-85ab9a0130f9	5	2012-09-07 08:06:41.746943
891d65db-4001-490e-82a7-5974adc5d8e2	\N	89.158.159.37	aac3a30b-36a9-4887-8aab-81c552bfc7d7	5	2012-09-13 12:03:01.635661
cc5f7d0d-6b66-4547-aaaa-40dcd850df54	\N	38.101.148.120	d794f07a-06d3-4b59-a969-c00af70ff8db	1	2012-09-20 08:50:14.420116
89c67742-40b1-490b-8fc6-d4ba24dac22f	\N	92.90.17.1	4235252c-aa21-46b5-8c52-110f95bdc583	5	2012-09-20 22:46:51.405022
1206d304-906c-4539-a786-481be86eaba0	\N	92.90.17.1	47034ede-0506-4650-9fb4-1948168440ca	5	2012-09-20 23:00:00.862354
e198e179-8873-4dd9-9621-a22a9608624e	\N	38.101.148.120	cdc13d67-6360-43a6-bb99-cd68b64ee3f3	3	2012-09-21 11:06:06.023534
d6497068-4b49-4df3-b612-014fbe9ad94d	\N	199.187.122.91	497e8d74-14c2-401e-bc0d-a4b473f77eb1	1	2012-09-26 11:34:20.285158
358810c2-677f-4e87-a642-7dd2fd4c1aac	\N	90.11.104.251	641c249c-f473-4d8e-bd8e-f385157f2682	5	2012-10-02 17:52:08.426476
a26b616e-5899-4a7a-9f7b-608409a8e592	\N	194.199.7.22	4276f7df-c7e9-44e1-8886-20ad41ebda0a	5	2011-11-23 13:21:29.558889
cbea497e-b3bf-4270-912b-47fb9279fdc1	\N	38.101.148.120	587ed76e-1c2f-4cc7-a23a-f9beb2415c77	3	2012-09-21 15:05:55.159949
dcf6e43e-9066-4787-9b4c-e42946994d64	\N	81.253.16.96	e657011b-cf83-47ab-8bc8-62f6498046a6	5	2012-10-08 15:03:34.130137
e825c177-8435-4c38-a046-f006af7dd36e	\N	204.145.91.114	41b0a731-3378-42bd-9e08-8b69a1fee83a	5	2012-10-12 07:04:55.247323
2c7a82c6-004e-4b0b-a11e-fc8244101634	\N	194.199.7.23	e4c69e90-1056-4f46-9619-57d0a18d1737	5	2012-10-16 00:17:29.297828
75b7673d-272b-43c7-92d3-0a1dbade2a75	\N	204.145.91.114	0460ea96-a830-40bd-adfb-140aad4c31ca	5	2012-10-12 07:03:40.658206
3f84841f-d840-41ac-b2d1-e73b45116c00	\N	194.199.7.23	5e86134f-2cb5-40e9-affa-f80d934a14b9	5	2012-10-16 00:01:38.08917
d8d771ea-bdcd-4f8a-860f-db244c8501be	\N	194.199.7.23	69361720-3428-417e-beb4-d21df542992c	5	2012-10-15 23:13:32.368812
eb9ef91f-b4c9-4c75-96a1-396f33d7b2cc	\N	204.145.91.114	cd42a806-cac1-452c-9b0d-116d8ead4d64	5	2012-10-12 07:03:48.401308
c29d96c6-8397-4271-832d-c44b70a37883	\N	194.199.7.23	34269022-c891-4a8e-a814-3af2b0fea526	5	2012-10-15 23:35:05.327253
8e86410d-47d6-455e-98c9-dd38a202c054	\N	204.145.91.114	196340e0-5246-4bc2-8b69-54c66a48b399	3	2012-10-12 07:04:11.865547
1e84ac74-866e-4a33-82ac-3f1514520fbf	\N	194.199.7.23	a1019da5-cdac-4e09-8b60-831994b5f275	5	2012-10-15 23:49:49.091706
3823359f-018a-4374-8346-eb00407dfb50	\N	194.199.7.23	4276f7df-c7e9-44e1-8886-20ad41ebda0a	5	2012-10-15 23:17:33.668708
a26253c0-5ee5-4494-a312-3d8fc008146d	\N	204.145.91.114	89a894cc-c5c8-44e2-9ca3-85ab9a0130f9	4	2012-10-12 07:04:48.221143
c2c5c36d-5288-4e0e-b74e-3aeef66d6791	\N	194.199.7.23	587ed76e-1c2f-4cc7-a23a-f9beb2415c77	1	2012-10-16 00:19:49.854403
f490e9df-8fd4-430c-995a-af16ef0dba33	\N	194.199.7.23	2502f9a7-15fa-439d-8a48-f61f38cb6f55	5	2012-10-15 23:37:49.291418
93ab7896-e1d2-4ed1-99f1-08a5824e0828	\N	204.145.91.114	61d87eb7-e3d3-4f90-a3a8-b43b5362db1a	5	2012-10-12 07:04:52.232098
23a20969-c4b7-42f9-97e0-1ddb13933bd0	\N	194.199.7.23	1901d722-a38d-4e79-a13c-ca51d61bae30	5	2012-10-15 23:23:09.764441
9351c24a-c060-4839-8b64-1225dd31d2b9	\N	91.201.64.24	61d87eb7-e3d3-4f90-a3a8-b43b5362db1a	2	2012-10-16 08:19:35.468174
7da99e2e-df88-4408-8907-631a9b6e1212	\N	194.199.7.23	e3424ea9-f7c0-4d80-832b-890c3de0f744	5	2012-10-16 00:10:09.273835
5a96e272-d4c3-40c5-b2ef-1d7522921a4b	\N	194.199.7.23	65d7e18e-c5ab-4736-bb9e-c47de2dc41e1	5	2012-10-15 23:55:21.330961
08dc91a1-ac7b-4fe5-8edd-128dac9f9fdb	\N	194.199.7.23	6d999f74-d520-4a8c-8188-5a5c13c6bbec	5	2012-10-15 23:27:30.878313
df2362d6-f0c9-4461-b9c2-414460d18786	\N	194.199.7.23	3aa0d5ce-cef6-4158-b51e-ddee8ece7b5e	5	2012-10-15 23:41:19.873775
18c0f024-652d-4fd9-8ae9-17d596b9bf5f	\N	194.199.7.23	29772378-f226-4fc8-8e01-9a87c5e43a00	5	2012-10-16 00:04:39.316998
bc558af3-036b-47f5-bbad-8a6c9c75bd83	\N	194.199.7.23	db34f769-ed94-45d3-8b66-5ebaf9b091ff	5	2012-10-15 23:46:34.97243
96670cd0-6eda-4277-add8-eb2ffdbd1e93	\N	194.199.7.23	9382520e-adb5-4403-848d-5bd5ea476202	5	2012-10-15 23:58:22.155398
1119dfb9-7627-48e3-97e3-1fa25f2f8838	\N	194.199.7.23	97b2cf1e-91f4-4b08-a7d8-2e6bd1dca37e	5	2012-10-16 00:15:39.246355
cc3d7221-1035-4588-94d8-43c6ec6752bd	\N	194.199.7.23	f4517261-c1ee-4380-b3ad-0de5a0edc09a	5	2012-10-16 00:08:02.774219
4618811b-db16-4b21-bfeb-4c56d8042572	\N	194.199.7.23	3fabe36b-965b-498d-9b3a-0649bbbfd0a5	5	2012-10-16 00:12:28.467724
c5177cf2-c2b8-4f06-9446-3c0fd2e10548	\N	194.199.7.22	43c3cc44-3a6c-469b-80fe-913927d2c283	5	2011-10-17 14:48:52.718563
1bcfaae7-1bf4-41e4-ab9d-a436a43beb05	\N	38.101.148.120	e3424ea9-f7c0-4d80-832b-890c3de0f744	1	2012-10-28 21:51:28.994123
d414936e-c809-4cdf-9bb3-cafce5cecddf	\N	194.199.7.22	69361720-3428-417e-beb4-d21df542992c	5	2011-10-17 14:29:41.436404
f681002e-4dc4-48b7-8b16-e389208fcbc3	\N	109.209.41.47	d6c6d3f9-5d8d-46c8-bc92-d8507d1e6f04	5	2012-10-24 22:43:02.541427
926304dc-dddb-4a18-ba27-c7bd0eb44456	\N	38.101.148.120	1901d722-a38d-4e79-a13c-ca51d61bae30	1	2012-10-29 04:58:28.414902
6b338243-136b-4a74-ac8d-98803d794f79	\N	38.101.148.120	4402487d-3e8d-4618-8444-b400c6337834	1	2012-10-29 05:00:28.63099
b8667cd8-3b6b-46e5-a250-c664a5218670	\N	38.101.148.120	df6c89f3-4473-424b-a0b0-119977da62c5	4	2012-10-29 05:13:42.065924
42ab441c-f2cd-48cc-95e9-9fb04b550966	\N	38.101.148.120	69361720-3428-417e-beb4-d21df542992c	1	2012-10-29 05:46:35.390601
56a74bc6-b4ed-41e3-ba53-48d75203dd05	\N	119.247.227.236	48a03f6f-f8f4-4758-8672-f8ab8bd10acb	4	2012-11-02 10:20:33.897516
ffbf8e83-6082-4cde-989b-08d135f00654	\N	199.187.122.91	34269022-c891-4a8e-a814-3af2b0fea526	5	2012-10-31 16:48:34.281666
a6b65ef1-61bb-40dd-a93c-fcf249205020	\N	193.252.118.165	7f6c30c6-d6a5-4d39-ae5d-e1ae4cc2d3ef	1	2012-11-03 02:52:39.371133
d3791d2a-a6fe-4a8d-8bf2-8939d4c66cb9	\N	193.252.118.166	cd42a806-cac1-452c-9b0d-116d8ead4d64	5	2012-11-03 03:43:29.334787
9833a437-2451-4c2d-8a1a-3b0b9b43958e	\N	119.247.227.236	47034ede-0506-4650-9fb4-1948168440ca	4	2012-11-05 19:11:54.009949
6d92b878-4939-483c-9516-ce3d93c27193	\N	119.247.227.236	f6c6aac7-3c9b-4a3c-80bc-d6709bc95d4b	5	2012-11-06 04:46:20.852473
2fc5b3aa-3630-4616-b315-b181fdc42176	\N	119.247.227.236	20100c39-31ae-4fd4-ad35-bfeabe396b5f	4	2012-11-06 08:50:36.158578
6d1d5168-2f70-4231-b21b-700b89da2591	\N	119.247.227.236	32ccab1e-e85e-4f52-84f5-69bbcc5fa53d	4	2012-11-07 02:00:57.641726
8da905ba-b0ec-44f1-a571-69de8891579f	\N	119.247.227.236	f22a7938-303f-4ac6-92da-526a4ad2a207	2	2012-11-07 16:48:00.552426
307f4b99-9466-4fb3-b7e7-85229c7d202f	\N	119.247.227.236	34269022-c891-4a8e-a814-3af2b0fea526	4	2012-11-08 09:05:03.77935
3dbf5d95-7c80-46a3-a08a-a60623829650	\N	213.175.86.45	5efedd90-782d-4129-8e71-fdd3b6e1c7df	5	2012-11-12 19:21:13.650498
1bdb7c0e-f6d2-46b7-9952-0cee9271ef34	\N	213.175.86.45	27983c75-8b7c-47bd-ad03-10a9e1ca4d25	5	2012-11-12 19:12:54.314719
7f538ae2-e5d5-4288-b5f7-f07e9ee07dd1	\N	213.175.86.45	f4517261-c1ee-4380-b3ad-0de5a0edc09a	5	2012-11-12 19:07:26.7822
7d8ea9dc-33f6-439b-88c1-5604cf0c6f96	\N	192.31.21.179	4235252c-aa21-46b5-8c52-110f95bdc583	3	2012-11-09 05:32:50.645887
49643b44-b6b4-46f9-855c-4a4a05ef9421	\N	193.252.118.164	7f6c30c6-d6a5-4d39-ae5d-e1ae4cc2d3ef	4	2012-11-12 09:08:34.007897
71b1d6f0-8e60-44b8-9d34-fe850fe62c2f	\N	213.175.86.45	3aa0d5ce-cef6-4158-b51e-ddee8ece7b5e	5	2012-11-12 19:00:07.210337
a20f8a11-d8c8-40aa-a0e0-cc6f97fe44f6	\N	130.133.5.130	cd42a806-cac1-452c-9b0d-116d8ead4d64	5	2012-11-12 17:39:45.970535
cd31dc56-4296-4f39-89d0-08561b0f9da2	\N	213.175.86.45	1dacf074-ad54-432a-a04f-cecd3a068d0c	5	2012-11-12 19:10:09.105135
afa1b4cf-2d73-4988-8191-eb14e808fbd8	\N	213.175.86.45	db34f769-ed94-45d3-8b66-5ebaf9b091ff	5	2012-11-12 19:00:52.452006
83122525-fd34-4c5a-ad57-096f56c4cdfc	\N	213.175.86.45	69361720-3428-417e-beb4-d21df542992c	5	2012-11-12 18:56:12.955082
a91ef770-e310-4a0f-8a83-e6328d0794bb	\N	213.175.86.45	e3424ea9-f7c0-4d80-832b-890c3de0f744	5	2012-11-12 19:07:42.765811
723590e9-a32d-4b88-b8fe-56b2a7b08836	\N	213.175.86.45	4276f7df-c7e9-44e1-8886-20ad41ebda0a	5	2012-11-12 18:56:52.142074
8a7dcaa9-85c2-47fa-893a-34af04511394	\N	213.175.86.45	a1019da5-cdac-4e09-8b60-831994b5f275	5	2012-11-12 19:03:03.146094
ce36e6eb-895c-481e-ab87-743e1e510af0	\N	213.175.86.45	1901d722-a38d-4e79-a13c-ca51d61bae30	5	2012-11-12 18:57:07.0942
bc904e77-0c42-41d6-9c73-9f422a80a273	\N	213.175.86.45	4402487d-3e8d-4618-8444-b400c6337834	5	2012-11-12 19:20:10.040869
7c1e833e-18d1-4850-9523-d7c0b4b92c25	\N	213.175.86.45	7f6c30c6-d6a5-4d39-ae5d-e1ae4cc2d3ef	5	2012-11-12 19:18:32.3826
1acca0d5-3829-4529-a330-fa61be3b3e99	\N	213.175.86.45	89a894cc-c5c8-44e2-9ca3-85ab9a0130f9	5	2012-11-12 19:15:46.966101
4790fb91-4eba-49b1-a2cf-036906c48253	\N	213.175.86.45	6d999f74-d520-4a8c-8188-5a5c13c6bbec	5	2012-11-12 18:57:51.779949
6cb1b87d-8573-4d7e-8b65-1d475417285e	\N	213.175.86.45	65d7e18e-c5ab-4736-bb9e-c47de2dc41e1	5	2012-11-12 19:03:23.516087
cfab6060-1fb9-488f-b21e-d04148bd749d	\N	213.175.86.45	3fabe36b-965b-498d-9b3a-0649bbbfd0a5	5	2012-11-12 19:07:58.521575
cba9b73b-7bee-4ae9-884d-91a3a2e0b892	\N	213.175.86.45	43c3cc44-3a6c-469b-80fe-913927d2c283	5	2012-11-12 18:58:10.816937
b5551b03-b6f8-4726-b778-044fa7ca4ee7	\N	213.175.86.45	b815db66-cadf-4c3c-ae0b-73ad5bf1a46e	5	2012-11-12 19:11:02.798378
bfb053b5-298d-43c6-be1c-71ebd4799967	\N	213.175.86.45	9382520e-adb5-4403-848d-5bd5ea476202	5	2012-11-12 19:03:40.076022
f3c153ca-f6ff-4451-bebd-877beb717c9b	\N	213.175.86.45	34269022-c891-4a8e-a814-3af2b0fea526	5	2012-11-12 18:59:31.985946
0c3aea37-0c61-4074-9fa1-74b76cba9908	\N	213.175.86.45	e657011b-cf83-47ab-8bc8-62f6498046a6	5	2012-11-12 19:14:04.458481
2ce462c1-7bb3-4019-92a6-1724c6ec0091	\N	213.175.86.45	2502f9a7-15fa-439d-8a48-f61f38cb6f55	5	2012-11-12 18:59:48.098724
c74b2776-710e-4a9a-a00d-72f3bed80828	\N	213.175.86.45	97b2cf1e-91f4-4b08-a7d8-2e6bd1dca37e	5	2012-11-12 19:08:17.188545
5832a6d2-0997-41a7-9832-6b7719593d87	\N	213.175.86.45	5e86134f-2cb5-40e9-affa-f80d934a14b9	5	2012-11-12 19:05:37.139275
19263202-ace0-4271-b77b-968b07bd3424	\N	213.175.86.45	29772378-f226-4fc8-8e01-9a87c5e43a00	5	2012-11-12 19:05:58.568516
d464b3bd-5afd-4077-8357-48f774b4893f	\N	213.175.86.45	e3e52ca7-2e9e-4f87-a818-5a808823089b	5	2012-11-12 19:12:22.57987
2388c590-107b-4209-9dd0-9e4272c2c1bc	\N	213.175.86.45	e4c69e90-1056-4f46-9619-57d0a18d1737	5	2012-11-12 19:08:33.217287
31cdb8f0-f786-455b-8218-583e6594d71c	\N	213.175.86.45	cb3bfee3-26cd-4489-b09f-d7a5a4c6ffab	5	2012-11-12 19:17:02.340491
c02a20e0-c2b2-4835-97d2-454829b41a2e	\N	213.175.86.45	41b0a731-3378-42bd-9e08-8b69a1fee83a	5	2012-11-12 19:14:20.521578
336059c5-65df-480c-9194-b85b668e8a24	\N	213.175.86.45	587ed76e-1c2f-4cc7-a23a-f9beb2415c77	5	2012-11-12 19:08:46.251078
a4227da3-f542-4bc3-8050-258085adef19	\N	213.175.86.45	8708a912-1b80-441d-9ba3-d607dd2f0c7c	5	2012-11-12 19:12:41.281673
3fae37bc-b560-4e42-8f28-9ed15d5badc1	\N	213.175.86.45	c4556598-bcc7-4c45-8ae8-bdafc367eaa2	5	2012-11-12 19:16:02.664138
8731944d-463b-4e22-bb84-b63e80a9085f	\N	213.175.86.45	67906f75-4298-4b6a-aa62-d8314be33f15	5	2012-11-12 19:15:00.993713
255aa001-bd62-4621-9079-40aabb91676f	\N	213.175.86.45	382ceece-628f-43b1-8847-ea92ff04376f	5	2012-11-12 19:19:04.666778
c61bf6b4-dc0a-4076-a530-c530be31ef33	\N	213.175.86.45	30bcda76-5a1a-4369-a6f3-ed2584ad4031	5	2012-11-12 19:17:54.89188
361877cf-d4e6-4465-afcd-9afac2cc1679	\N	213.175.86.45	4235252c-aa21-46b5-8c52-110f95bdc583	5	2012-11-12 19:16:15.622037
6e872b64-3a33-4f0d-ac65-ad68c635db0f	\N	213.175.86.45	430e39ad-4906-44ba-83bc-8f2bc6f2d039	5	2012-11-12 19:18:46.336556
d9a45267-b2b8-4003-b70b-88433f1e625f	\N	213.175.86.45	f1261a91-9d52-4520-837e-e9c793f28dcc	5	2012-11-12 19:21:25.44745
4e2e41f1-96f4-40a9-91aa-e0f5c79595ac	\N	213.175.86.45	ece794a5-613f-4607-9046-fb37906f87ce	5	2012-11-12 19:22:28.679161
97179055-5ea1-4262-a40b-dad3e4e53947	\N	213.175.86.45	cea11492-fdec-4cfc-a179-a4bbc05cac0b	5	2012-11-12 19:26:44.67199
8914f750-b079-4480-9b8b-8a85e7dd80f3	\N	213.175.86.45	d794f07a-06d3-4b59-a969-c00af70ff8db	5	2012-11-12 19:26:30.402385
ddfb73d3-8b63-4b98-b73d-1fa444e9fc81	\N	213.175.86.45	f1b3849e-9568-4cae-a3a0-3cca7f42c079	5	2012-11-12 19:26:58.224957
f08e24ef-88dc-4cf0-9dc8-910e5a2dec85	\N	213.175.86.45	61d87eb7-e3d3-4f90-a3a8-b43b5362db1a	5	2012-11-12 19:28:28.97075
9efaeac7-8249-4769-ab78-f9cc153bb6c1	\N	213.175.86.45	cd42a806-cac1-452c-9b0d-116d8ead4d64	5	2012-11-12 19:28:42.239101
51822528-d515-4f09-b399-c0e558f934d8	\N	213.175.86.45	25dd2269-e0f3-4653-98ac-33f64f09d4d3	5	2012-11-12 19:31:03.038477
7059320d-c4e2-4a1e-a294-d10bf070291e	\N	213.175.86.45	196340e0-5246-4bc2-8b69-54c66a48b399	5	2012-11-12 19:33:28.182714
4b2d516c-169c-4f8d-8b65-b739f1fef9ce	\N	81.52.143.35	cd42a806-cac1-452c-9b0d-116d8ead4d64	3	2012-06-24 07:58:03.285185
64c5619e-bd7f-4224-9d69-4db59e893d25	\N	199.187.122.91	61d87eb7-e3d3-4f90-a3a8-b43b5362db1a	5	2012-11-16 02:36:36.128693
c36be554-a3f0-495f-b432-4f2434eae42a	\N	213.175.86.45	275e4c19-2885-4630-b049-e365374c27fb	5	2012-11-12 19:50:43.310005
a6ace753-8e79-4376-b298-147bf22b23cb	\N	213.175.86.45	f6c6aac7-3c9b-4a3c-80bc-d6709bc95d4b	5	2012-11-12 19:33:41.710564
972fe079-50d0-41a1-ac4a-bbd8caac186b	\N	213.175.86.45	159b6644-94ed-406d-8e1e-1f002f265396	5	2012-11-12 19:41:03.130276
f3426ccd-02ca-4729-a42e-55f4426a0868	\N	213.175.86.45	1399fe4b-2c07-4bda-a720-9df928d51816	5	2012-11-12 19:36:10.912508
be8079ad-5324-4a23-874b-6f5fe87df544	\N	213.175.86.45	cd2385b8-fa33-4be9-82a8-9ceda07fdc75	5	2012-11-12 19:46:28.417502
9a8d2718-c2a2-4aef-aeee-6b4b553e82cf	\N	213.175.86.45	be516eed-8a37-436c-af75-b623f0806f39	5	2012-11-12 19:42:15.592136
44b51f2c-8580-48a6-bd5c-4cfdad9bf4b5	\N	213.175.86.45	ced8947c-7c6b-4874-ad5e-c28ba91f8073	5	2012-11-12 19:36:25.268008
09589a19-20d2-4c9c-a93a-5219b620637b	\N	213.175.86.45	3d4e64cc-54c0-4b3e-b865-2fff3d9845e7	5	2012-11-12 19:49:24.537076
7dfae5ed-7ecc-4ba6-84d0-f0433bd7b75c	\N	213.175.86.45	4acf41b9-9c8b-4a1e-a32e-a754abdce116	5	2012-11-12 19:37:27.777434
a696fd71-e87b-49a5-bb12-5e68d708a0eb	\N	213.175.86.45	205c33b6-106f-40c3-804c-a2835f6104a9	5	2012-11-12 19:54:08.768889
146f107a-1695-4978-ac73-8cc456dcdfd1	\N	213.175.86.45	5b23d4f4-058e-44e0-945d-ae9035fb1e15	5	2012-11-12 19:42:34.233052
b89bcb64-17ff-4767-9cfd-0fdadfca06bb	\N	213.175.86.45	cdc13d67-6360-43a6-bb99-cd68b64ee3f3	5	2012-11-12 19:38:06.952214
d4fb478e-929d-426e-8243-eb61c71e9984	\N	213.175.86.45	df6c89f3-4473-424b-a0b0-119977da62c5	5	2012-11-12 19:46:45.600726
315b2e3c-63b8-485f-a01d-1207962746f2	\N	213.175.86.45	6968ef13-1d2f-4de3-b533-706bc9c0f604	5	2012-11-12 19:38:21.64552
244afd4d-1fbe-431c-b22e-d66948f4a7f9	\N	213.175.86.45	fea6dcd6-00d6-4ad5-ab2f-eb40f533a5db	5	2012-11-12 19:43:25.468566
4dbdf5cc-b6a9-4a62-8336-7caaa368e4cd	\N	213.175.86.45	bfd1388a-ec10-4a7b-9d94-916f56f52f98	5	2012-11-12 19:53:21.039033
590c8bb4-103d-427b-a2ec-2dd1683e675e	\N	213.175.86.45	de5557e1-bf16-433b-87ff-401323a97df5	5	2012-11-12 19:38:33.747896
f2022373-f6d6-44d9-8187-a8d9f33108ac	\N	213.175.86.45	b99894af-7866-4a81-beee-30e0e384b708	5	2012-11-12 19:49:38.990372
53d504e4-0ad5-40d5-9e58-641afce160ee	\N	213.175.86.45	78e9e396-2ab2-4d61-9eea-fe08b840dbf9	5	2012-11-12 19:47:04.058692
32a8c13e-71f4-48dc-bbbe-0a8cce79dce6	\N	213.175.86.45	a8f061a9-6ba5-46df-89cd-6e65bfa28fe5	5	2012-11-12 19:43:42.30935
77d675b5-3df2-4b00-ad4b-3c72245eb4fc	\N	213.175.86.45	47034ede-0506-4650-9fb4-1948168440ca	5	2012-11-12 19:38:46.154221
c8ed91cb-b95a-4358-a65f-6ba04608755b	\N	213.175.86.45	1cf46091-d128-4e38-a7b7-97901d423aaf	5	2012-11-12 19:39:32.035679
66473b41-0c68-4aab-9ef6-6381124e4d45	\N	213.175.86.45	fe7cd753-376f-4f22-a721-caa482aa1116	5	2012-11-12 19:51:04.096495
23c3063e-27a1-4616-bc70-4b20666e5470	\N	213.175.86.45	6c0ea5a3-dd48-4015-8f65-77d56bf54bb3	5	2012-11-12 19:43:58.905817
36c7ab28-e40c-486a-a482-219efca86235	\N	213.175.86.45	ac051eb3-275f-40a5-b160-e224d13902e7	5	2012-11-12 19:40:33.14627
38ef8288-3edd-47c8-8848-721409aa5b31	\N	213.175.86.45	02970c3a-2240-4a74-8fd3-18af09a9cd61	5	2012-11-12 19:47:21.779602
ea388b84-1067-4947-a440-cebd51a93ef6	\N	213.175.86.45	84b91384-8ec9-4b55-8dc9-28ff8c6db62f	5	2012-11-12 19:40:45.949423
f43ca16b-58bd-4179-b650-8c0af9e1ae82	\N	213.175.86.45	20100c39-31ae-4fd4-ad35-bfeabe396b5f	5	2012-11-12 19:44:39.565624
93dd729f-4e60-4c23-b711-cba69c2419ac	\N	213.175.86.45	4654898f-58f4-482f-a91f-23aa5e192fd8	5	2012-11-12 19:49:52.113763
ef843adf-2235-490b-9c02-3bd1a56000df	\N	213.175.86.45	2a4bae91-082b-4ae5-9729-08c86e000ab5	5	2012-11-12 19:47:39.995506
c047e40a-5728-49fa-8015-7a704df17bdf	\N	213.175.86.45	48a03f6f-f8f4-4758-8672-f8ab8bd10acb	5	2012-11-12 19:45:55.580541
bca19a69-beb9-42fc-9f1c-7166188d94d0	\N	213.175.86.45	8a7d516b-f3c2-4a5b-afde-d2bdff371937	5	2012-11-12 19:58:09.712319
4fab119e-6acc-4c88-822e-a78c0e3dcb3f	\N	213.175.86.45	529d4aba-d25d-44d6-ba1b-d6ad314d6158	5	2012-11-12 19:55:02.068183
ed4e04c9-af4b-446f-ad4f-c146c80299a9	\N	213.175.86.45	09d5ff25-7a8a-4228-9093-bb437bb70f1a	5	2012-11-12 19:46:12.213925
00dd4440-40a6-4ca0-ade2-bee725c5a00b	\N	213.175.86.45	83e56067-9ee5-48b2-83d0-91e723eb8b3d	5	2012-11-12 19:51:20.609535
0264ecba-4373-4578-8e46-2cf51559ac84	\N	213.175.86.45	0e14dccb-9c28-4f89-b3b2-cb1011be06d1	5	2012-11-12 19:48:57.360266
26a15469-01a0-48ab-ae06-4c5099a4905c	\N	213.175.86.45	f3d8ca3c-32b9-4485-95d9-0b1fd4a5dd4e	5	2012-11-12 19:50:07.651508
953dee34-a83c-4a33-81fe-4c5d29695443	\N	213.175.86.45	8d9cf757-de83-4774-919b-00c45c43efd4	5	2012-11-12 19:49:11.151433
80ef7090-1125-4924-94c5-23901f9c0315	\N	213.175.86.45	32ccab1e-e85e-4f52-84f5-69bbcc5fa53d	5	2012-11-12 19:53:40.649892
b4cb9f9f-e763-475d-936d-40fb4288f0ea	\N	213.175.86.45	df63f81c-7a27-49d1-86c8-8d5e49883d40	5	2012-11-12 19:50:24.42905
d5bbc4ba-f6df-4f3f-8b3e-32a417b4e32f	\N	213.175.86.45	5a3d4806-974f-4754-b6cb-65a7dfa27548	5	2012-11-12 19:54:24.397509
b79ebae3-0420-4a97-8eb5-6086ee6fec38	\N	213.175.86.45	e1b56ce2-aea6-4d44-b877-86a13f92697c	5	2012-11-12 19:52:35.299538
79569b38-5347-475b-bd37-c83a6a793dc1	\N	119.247.227.223	6968ef13-1d2f-4de3-b533-706bc9c0f604	4	2012-11-14 21:49:14.240483
36514cd2-1753-4bed-85bc-a91af560293c	\N	213.175.86.45	b57f2ed1-ee10-469b-afcc-a4d7636d39c7	5	2012-11-12 19:53:55.683157
2711b52c-fcca-4e07-b6e8-c9d2d46f3d1c	\N	213.175.86.45	641c249c-f473-4d8e-bd8e-f385157f2682	5	2012-11-12 19:53:00.788355
82f36277-0972-4bcd-8867-eab4703464c4	\N	119.247.227.223	bfd1388a-ec10-4a7b-9d94-916f56f52f98	5	2012-11-15 22:21:08.578781
a2599d55-bad6-4f00-8baa-e251ae9701f8	\N	213.175.86.45	8d7560cf-6d61-45dd-bf05-44ae257e97a4	5	2012-11-12 19:56:19.552549
a889c4f0-a9da-41fa-92a7-d9719135b566	\N	213.175.86.45	0a048cd8-5468-4fcd-bd67-50675c83002d	5	2012-11-12 19:54:42.944397
3309de4b-d2a4-4f40-a364-93c2bcc45d90	\N	194.199.7.22	27983c75-8b7c-47bd-ad03-10a9e1ca4d25	5	2012-11-16 13:34:33.585292
70c39dbd-d436-4c28-a878-b339608b52ee	\N	199.187.122.91	cea11492-fdec-4cfc-a179-a4bbc05cac0b	5	2012-11-16 02:36:17.217951
00d475ad-a416-425a-b4e2-b9933ed0fab7	\N	194.199.7.22	8708a912-1b80-441d-9ba3-d607dd2f0c7c	5	2012-11-16 13:06:34.890418
b35e33e4-a6eb-4567-a82c-6c93d84ac403	\N	194.199.7.22	382ceece-628f-43b1-8847-ea92ff04376f	5	2012-11-16 13:40:19.227729
2ae2706d-e003-4ea5-b76f-3c56b086fbfb	\N	194.199.7.22	e3e52ca7-2e9e-4f87-a818-5a808823089b	5	2012-11-16 13:30:58.355254
b42dee8b-6fc4-4846-ba72-068798aee669	\N	194.199.7.22	e657011b-cf83-47ab-8bc8-62f6498046a6	5	2012-11-16 13:46:19.105633
87ad6bc9-20bf-4f25-94e0-7f4254dd90e5	\N	194.199.7.22	41b0a731-3378-42bd-9e08-8b69a1fee83a	5	2012-11-16 13:52:35.070076
d44975db-6db5-4324-9160-9fec0ce517b6	\N	194.199.7.22	89a894cc-c5c8-44e2-9ca3-85ab9a0130f9	5	2012-11-16 14:06:10.076673
11d110c4-e8dc-4039-8b24-e6ffdddb1873	\N	194.199.7.22	61d87eb7-e3d3-4f90-a3a8-b43b5362db1a	5	2012-11-16 15:14:57.887793
25348a24-f1ec-4475-ab5d-961e0db94e57	\N	194.199.7.22	b815db66-cadf-4c3c-ae0b-73ad5bf1a46e	5	2012-11-16 13:01:21.358421
b54fc2d2-e012-4946-8d22-5e5c3d34436c	\N	194.199.7.22	25dd2269-e0f3-4653-98ac-33f64f09d4d3	5	2012-11-16 15:34:41.834942
08c43b19-0e79-4832-94ee-cfde65f66e81	\N	194.199.7.22	df6c89f3-4473-424b-a0b0-119977da62c5	5	2012-11-16 15:40:43.681112
79201496-786e-4224-918a-62b9fc3d8dfc	\N	194.199.7.22	275e4c19-2885-4630-b049-e365374c27fb	5	2012-11-16 16:55:30.32855
388c1196-3a7c-48a1-af04-4b50c60d7443	\N	194.199.7.22	aac3a30b-36a9-4887-8aab-81c552bfc7d7	5	2012-11-16 16:46:09.782477
5ab13918-31ea-47f3-b1cd-8eb5e6f728df	\N	194.199.7.22	cea11492-fdec-4cfc-a179-a4bbc05cac0b	5	2012-11-16 17:49:14.646066
c953ef12-2a55-4b32-bfa8-5b9b4bbb8f6f	\N	194.199.7.22	159b6644-94ed-406d-8e1e-1f002f265396	5	2012-11-16 18:26:27.986779
e6cebab5-024f-4ccd-b1e6-e3178fd05ff1	\N	194.199.7.22	0460ea96-a830-40bd-adfb-140aad4c31ca	5	2012-11-16 18:36:27.36317
e7cadd97-2af1-4479-a776-bd2913d2824c	\N	194.199.7.22	2a4bae91-082b-4ae5-9729-08c86e000ab5	5	2012-11-16 16:34:18.320587
34e0153e-5ff9-49a6-afb9-cee9903d713a	\N	194.199.7.22	cd42a806-cac1-452c-9b0d-116d8ead4d64	5	2012-11-16 15:28:58.276051
66b63ed8-0e36-4d4e-893c-f65ea29c7ec7	\N	194.199.7.22	c4556598-bcc7-4c45-8ae8-bdafc367eaa2	5	2012-11-16 17:34:23.826673
c342a038-cdf7-4ee2-8845-4587497833e2	\N	192.31.21.179	275e4c19-2885-4630-b049-e365374c27fb	5	2012-11-26 09:12:27.479641
071073db-60fa-46b0-9ec8-d5d359d0427f	\N	199.187.122.91	d6c6d3f9-5d8d-46c8-bc92-d8507d1e6f04	5	2012-11-28 15:54:56.880902
8cb25771-e5c4-457a-9394-4eee157d3950	\N	194.199.7.22	1399fe4b-2c07-4bda-a720-9df928d51816	5	2012-11-16 17:29:47.713554
82176ba8-2c6b-49af-9510-815cabb11e4f	\N	59.148.124.29	e1b56ce2-aea6-4d44-b877-86a13f92697c	2	2012-12-03 23:13:33.578527
f29081e1-6f1b-43e5-aa4d-59af52287360	\N	194.199.7.22	de5557e1-bf16-433b-87ff-401323a97df5	5	2012-11-16 16:16:27.417632
20a0f4be-7bfb-4a4e-a8f2-e6f3640d1d4f	\N	194.199.7.22	f1b3849e-9568-4cae-a3a0-3cca7f42c079	5	2012-11-16 16:43:07.418214
3f6b859a-4894-4b56-bb5b-1c0ded3ba3cd	\N	192.31.21.179	78e9e396-2ab2-4d61-9eea-fe08b840dbf9	3	2012-12-04 10:43:27.729413
297fcacb-030e-4d5b-8e7d-7c4490c18c6f	\N	59.148.124.29	4235252c-aa21-46b5-8c52-110f95bdc583	2	2012-12-07 21:05:10.439467
789376ae-af0d-4546-a403-c2833b1b5e2e	\N	194.199.7.22	47034ede-0506-4650-9fb4-1948168440ca	5	2012-11-16 16:19:24.17878
334cb7d7-6dea-4b6e-9f03-f54bd3ce996c	\N	194.199.7.22	8d7560cf-6d61-45dd-bf05-44ae257e97a4	5	2011-11-23 16:15:37.799293
f9f9c45c-6772-4e62-8595-6f79fe9e3461	\N	194.199.7.22	bfd1388a-ec10-4a7b-9d94-916f56f52f98	5	2012-11-16 18:57:57.847922
50960e52-d6bb-4399-b3c7-922f8ebe45b3	\N	194.199.7.22	32ccab1e-e85e-4f52-84f5-69bbcc5fa53d	5	2012-11-16 19:03:04.562616
2ad85eb7-9447-4565-bff7-8a32136fd426	\N	119.247.227.223	f6c6aac7-3c9b-4a3c-80bc-d6709bc95d4b	4	2012-11-16 20:17:51.873031
15b0ed82-9f62-48fd-bad1-2f23e501069f	\N	119.247.227.223	4acf41b9-9c8b-4a1e-a32e-a754abdce116	4	2012-11-19 02:49:37.83674
72d1f72e-025e-4542-a866-8b028b63d983	\N	91.201.64.24	47034ede-0506-4650-9fb4-1948168440ca	4	2012-11-20 14:36:41.735674
85d60a19-3b8c-413d-bc8c-06367dab7a6c	\N	91.201.64.24	25dd2269-e0f3-4653-98ac-33f64f09d4d3	5	2012-11-20 21:11:09.17445
5e3640bd-6dbe-4f54-b9a3-cbebe483b252	\N	91.201.64.24	67906f75-4298-4b6a-aa62-d8314be33f15	1	2012-11-21 21:17:21.207325
5d222a33-2d85-4ddd-b719-b5789ca1e4d3	\N	119.247.226.236	84b91384-8ec9-4b55-8dc9-28ff8c6db62f	4	2012-11-22 02:23:07.940916
bd035caf-b63e-4a38-a79a-ef4831902c34	\N	91.201.64.24	ac051eb3-275f-40a5-b160-e224d13902e7	2	2012-11-22 05:52:25.323845
449b9b0c-aff1-48c5-bf30-323ad04d3a4f	\N	194.199.7.22	fea6dcd6-00d6-4ad5-ab2f-eb40f533a5db	5	2012-11-16 16:02:35.891437
41b219c1-7ad5-414e-a85a-4bd88c851109	\N	194.199.7.22	5efedd90-782d-4129-8e71-fdd3b6e1c7df	5	2011-11-23 12:52:16.8311
3b84b4b2-701e-4415-b230-ba429a8afe30	\N	194.199.7.22	ac051eb3-275f-40a5-b160-e224d13902e7	4	2011-11-23 14:40:52.574235
fc73686c-6f8b-4b3d-a9b9-0c2f9271e90a	\N	119.247.227.49	6968ef13-1d2f-4de3-b533-706bc9c0f604	2	2012-11-24 18:08:01.169306
\.


--
-- Data for Name: revision; Type: TABLE DATA; Schema: public; Owner: ckantest
--

COPY revision (id, "timestamp", author, message, state) FROM stdin;
835c4b71-6c97-47c9-801b-ab556ce11a8c	2010-10-29 16:53:52.143725	system	Initialising the Repository	active
f74141f1-d57b-4f3f-9ee2-d1469d1a00a9	2010-11-21 12:35:32.745173	94.23.170.130		active
6aafed2f-a1a7-48cc-b275-0e0986710b13	2010-11-21 12:40:57.877478	94.23.170.130		active
c0b4ca99-d5d6-4f34-ae28-b6cb84f213e5	2010-11-25 12:04:21.800729	system	Add versioning to groups, group_extras and package_groups	active
9bae0509-72a9-4de7-a4f4-f24c8532fcda	2010-11-25 21:13:13.938083	88.168.238.200		active
eeba716d-d213-4971-a309-2216cdb0165c	2010-11-25 21:27:15.335644	https://www.google.com/accounts/o8/id?id=AItOawkSATsJ9c11r4HbASkXajuZzI-AcQPh8Cw	Détails de l'utilisateur modifiés	active
3167eb79-08a6-4320-a9b5-6556c322c8a9	2010-11-25 21:28:05.015829	https://www.google.com/accounts/o8/id?id=AItOawkmx3REBD20u-MpAd7Lwqkef7nkTce-fh4	Détails de l'utilisateur modifiés	active
db5217fd-ac78-4ac0-9a7a-1dbd76d734eb	2010-11-25 21:41:08.003259	88.168.238.200		active
9bcaa5ea-16b4-48db-980a-e730914c57b5	2010-11-25 22:49:59.519926	88.168.238.200		active
810fc9ab-173c-4806-9cb8-848dc353326b	2010-11-25 23:17:32.791749	88.168.238.200		active
aed06c3b-6bc8-4a06-a28b-aca1d74e2e8c	2010-11-25 23:18:12.177155	88.168.238.200		active
62451862-c224-4170-b5cc-11e88829ac06	2010-11-25 23:18:39.122731	88.168.238.200		active
21bfe10a-a4a0-41bf-abc6-3d500478cc67	2010-11-25 23:30:41.920615	88.168.238.200		active
e538d820-448e-4081-9616-dd0122780c60	2010-11-26 00:53:23.381522	88.168.238.200		active
df47bb1e-48f6-4e37-88ce-367839a97a25	2010-11-26 01:08:21.213657	https://www.google.com/accounts/o8/id?id=AItOawkSATsJ9c11r4HbASkXajuZzI-AcQPh8Cw		active
817afdd6-8c2c-4b47-a925-9cc7d994834c	2010-11-26 01:08:52.71952	https://www.google.com/accounts/o8/id?id=AItOawkSATsJ9c11r4HbASkXajuZzI-AcQPh8Cw		active
21404ab1-66b4-43b3-8bbd-4d3a3644478b	2010-11-26 01:19:15.031898	88.168.238.200		active
43627482-31b6-45a8-a384-1009f06bceb4	2010-11-26 01:19:51.290511	88.168.238.200		active
dbfdfdbf-2d3c-473a-8cee-c5c2d7367ffc	2010-11-26 01:33:23.333308	88.168.238.200		active
4032bd87-a45c-49e3-9414-55ad06c9cb82	2010-11-26 01:52:42.28638	88.168.238.200		active
fbef7487-8d50-4d9d-aa8b-eb81e4a4fefb	2010-11-26 01:53:07.595209	88.168.238.200		active
a318ad2c-bc5c-4c55-a5fe-4f3cfbb61468	2010-11-26 04:06:28.187097	https://www.google.com/accounts/o8/id?id=AItOawkmx3REBD20u-MpAd7Lwqkef7nkTce-fh4		active
235bde9c-3506-4225-8038-e865d0b97e75	2010-11-26 04:06:57.373576	https://www.google.com/accounts/o8/id?id=AItOawkmx3REBD20u-MpAd7Lwqkef7nkTce-fh4		active
5224af1d-3c73-47ef-bb33-777391fd602f	2010-11-26 22:12:24.946747	http://arthur.lutz.myopenid.com/	Détails de l'utilisateur modifiés	active
a6a5efac-b108-40c8-847c-e06530596dae	2010-11-27 16:21:24.358339	78.232.200.105		active
53b7a5cf-ae69-4bb1-b239-940facaeb014	2010-11-27 16:36:12.936099	78.232.200.105		active
46aec451-5c77-4e88-b1bb-b14ef364f759	2010-11-27 16:50:46.719234	78.232.200.105		active
edfc6915-85fb-4f7e-b4b5-1fc9a60bae76	2010-11-27 16:51:57.142127	78.232.200.105		active
e1cdc053-a74b-4b24-8057-cbe623942ce4	2010-11-27 16:54:49.097131	78.232.200.105		active
8562e242-52ef-4521-95fe-53fcf1a8fe0b	2010-11-27 16:55:31.895497	78.232.200.105		active
ceb18013-a90d-44d6-a245-b199633faf0b	2010-11-27 17:09:41.156119	78.232.200.105		active
8ab6af92-18de-4dbc-9cdb-a8d2cc156cea	2010-11-27 17:10:07.0988	78.232.200.105		active
a5bfd523-f3c2-41e2-9e1a-1624d786767c	2010-11-27 17:21:24.993284	78.232.200.105		active
19979634-e047-4bef-b09b-396ebbbf7fd0	2010-11-27 17:28:50.835209	78.232.200.105		active
5b3fb26f-b388-4423-88e3-076c7476b2cc	2010-11-27 18:07:40.397773	https://www.google.com/accounts/o8/id?id=AItOawlvioCwdcjymQflv5S0mQi6sItMskk1J4Q		active
70481e33-e884-48f4-8622-937ca4c775d2	2010-11-27 18:10:32.254506	https://www.google.com/accounts/o8/id?id=AItOawlvioCwdcjymQflv5S0mQi6sItMskk1J4Q	Détails de l'utilisateur modifiés	active
487378c3-79fa-4f69-8a37-3ad81f3fca33	2010-11-27 18:13:58.609035	https://www.google.com/accounts/o8/id?id=AItOawlvioCwdcjymQflv5S0mQi6sItMskk1J4Q	Correction nom du paquet.	active
1e4eae84-e18c-4226-a08b-ddb330973624	2010-11-27 18:21:06.92998	https://www.google.com/accounts/o8/id?id=AItOawlvioCwdcjymQflv5S0mQi6sItMskk1J4Q	Correction fautes d'orthographe et nom du format	active
b2b4b103-d694-4105-86d7-fa937445826f	2010-11-28 04:04:48.322521	http://david.larlet.fr/		active
17737307-867d-490f-8558-a3225789c916	2010-11-28 11:25:16.191309	https://www.google.com/accounts/o8/id?id=AItOawl8Ziz2sBXnxWWzGH-UGNXVClHd1QYz9fI		active
d8e30bba-2d57-45ea-8134-0794051afc25	2010-11-28 12:18:20.789306	78.232.200.105		active
4b18699d-de47-485f-af9e-a8569d139c47	2010-11-28 12:18:37.185861	78.232.200.105		active
0376e537-073c-47ff-8397-bad8797ea48a	2010-11-28 12:19:17.188191	78.232.200.105		active
f9d8651f-75dd-4a22-8190-ea0df1fb83d1	2010-11-28 13:15:02.064353	78.232.200.105		active
e5f47372-8631-4d88-9613-f26a40b1ad80	2010-11-28 18:51:41.626114	78.232.200.105		active
cc6daccc-cffe-480d-9c2f-55825a6408bf	2010-11-30 14:03:05.677377	yannbreliere	Détails de l'utilisateur modifiés	active
4fb5808a-d349-441f-8aba-2163a529b8e6	2010-12-01 23:21:19.239161	https://www.google.com/accounts/o8/id?id=AItOawnC18rvQ45Ge33zWfjkglxHUYuifMs2JeU	Détails de l'utilisateur modifiés	active
d97f123d-06db-4c32-8486-3aaa64351fbf	2010-12-02 11:21:08.891981	https://www.google.com/accounts/o8/id?id=AItOawnDOHJWX9v8IUQBJfEiNifXcg8y_ROJeOE	Détails de l'utilisateur modifiés	active
affa5e72-9823-4011-8ea4-8ef8c2305fe6	2010-12-02 11:53:34.882189	https://www.google.com/accounts/o8/id?id=AItOawnDOHJWX9v8IUQBJfEiNifXcg8y_ROJeOE		active
239b7ae3-757d-4ef7-9469-4f1dc9270f38	2010-12-02 16:18:49.113372	https://www.google.com/accounts/o8/id?id=AItOawkvEuW7sYRdsdAIqfkL_jyvLbqGV4hTPoA	Détails de l'utilisateur modifiés	active
792ec941-9e46-472a-8f28-ee06aeaa4e5b	2010-12-03 17:09:44.226241	84.103.221.222		active
81ae4f0f-e6b1-424a-b17c-870e1642db20	2010-12-03 17:10:39.503397	84.103.221.222		active
7df7eeb0-c854-4690-a1ee-da0f9e9897ab	2010-12-03 17:11:19.586808	84.103.221.222		active
85392283-0794-47c2-a7e4-2862636d3e55	2010-12-04 15:19:01.233359	https://www.google.com/accounts/o8/id?id=AItOawkmx3REBD20u-MpAd7Lwqkef7nkTce-fh4		active
b4aafcd7-ff6c-44e1-8471-c7790e9379fd	2010-12-04 15:20:26.455016	https://www.google.com/accounts/o8/id?id=AItOawkmx3REBD20u-MpAd7Lwqkef7nkTce-fh4		active
a78d4faa-842b-4cec-8ba4-2e9993ff99ca	2010-12-04 15:39:56.570984	https://www.google.com/accounts/o8/id?id=AItOawkmx3REBD20u-MpAd7Lwqkef7nkTce-fh4		active
053a6cde-e92d-4f32-9bcb-d4ee6fe05a74	2010-12-04 15:42:10.954406	https://www.google.com/accounts/o8/id?id=AItOawkmx3REBD20u-MpAd7Lwqkef7nkTce-fh4	correction tags	active
945fbb14-dfc2-4bda-9259-43f438951fa7	2010-12-04 16:19:53.540484	88.168.238.200		active
29796bcf-b80b-4c83-a40e-c792a50e8802	2010-12-04 16:39:11.136591	https://www.google.com/accounts/o8/id?id=AItOawkmx3REBD20u-MpAd7Lwqkef7nkTce-fh4		active
2c169a3a-8172-4566-832b-982d79709f1a	2010-12-04 16:40:41.284492	https://www.google.com/accounts/o8/id?id=AItOawkmx3REBD20u-MpAd7Lwqkef7nkTce-fh4	tag bureaux de vote	active
3eefe87a-10dc-47ae-8e06-ed0f9fd04235	2010-12-04 16:44:29.816551	https://www.google.com/accounts/o8/id?id=AItOawkmx3REBD20u-MpAd7Lwqkef7nkTce-fh4		active
c42aefff-d420-4504-95d7-3d69e49d3c8a	2010-12-04 16:46:06.924527	https://www.google.com/accounts/o8/id?id=AItOawkmx3REBD20u-MpAd7Lwqkef7nkTce-fh4		active
d78247f0-fc65-4fb3-bc7e-81f3ad80e69b	2010-12-04 16:54:40.382227	https://www.google.com/accounts/o8/id?id=AItOawkmx3REBD20u-MpAd7Lwqkef7nkTce-fh4		active
23851c5d-9680-440f-82b7-b0c72d7db67a	2010-12-04 16:58:40.955057	https://www.google.com/accounts/o8/id?id=AItOawkmx3REBD20u-MpAd7Lwqkef7nkTce-fh4		active
1efed480-60dd-42bd-8380-84b7a8c22587	2010-12-04 16:59:00.663051	https://www.google.com/accounts/o8/id?id=AItOawkmx3REBD20u-MpAd7Lwqkef7nkTce-fh4		active
baa66947-52d1-48c5-bfd5-11a3c7353d7d	2010-12-04 16:59:25.134681	https://www.google.com/accounts/o8/id?id=AItOawkmx3REBD20u-MpAd7Lwqkef7nkTce-fh4		active
edd5abf8-0b14-4b71-942a-608f949f3fe0	2010-12-04 16:59:38.439969	https://www.google.com/accounts/o8/id?id=AItOawkmx3REBD20u-MpAd7Lwqkef7nkTce-fh4		active
632fb8b8-5a20-4e3e-b50c-fa86591bdfa1	2010-12-04 17:00:17.952072	https://www.google.com/accounts/o8/id?id=AItOawkmx3REBD20u-MpAd7Lwqkef7nkTce-fh4		active
d37666ea-df46-411a-bc6c-3d1b808ebefc	2010-12-04 17:02:28.558701	https://www.google.com/accounts/o8/id?id=AItOawkmx3REBD20u-MpAd7Lwqkef7nkTce-fh4		active
8b208a3e-558c-4884-9cc1-297a0dc0e174	2010-12-04 17:06:06.83935	https://www.google.com/accounts/o8/id?id=AItOawk9Fk-PfMCD5A7bcU8RsELWznh4eYowLkk		active
e4cf8b5e-d018-4c0b-9c86-f6b0e85edcfd	2010-12-04 17:14:57.672976	88.168.238.200		active
a5675df6-074d-4301-8987-bf9d514050f4	2010-12-04 17:18:15.483054	88.168.238.200		active
dca1567f-bb5c-4f07-ba22-d27778ebde69	2010-12-04 17:41:35.599528	https://www.google.com/accounts/o8/id?id=AItOawkmx3REBD20u-MpAd7Lwqkef7nkTce-fh4		active
fb37d996-fe0c-49bf-8cb0-29b99087b3d2	2010-12-04 17:51:12.861222	88.168.238.200		active
a23213e4-603f-42b1-88e7-f9f17b4bdb6d	2010-12-04 17:54:26.691025	88.168.238.200		active
0f921f9a-fa99-4cb7-90ef-aab5c836c057	2010-12-04 18:00:03.968521	88.168.238.200		active
f059768e-f5ee-4b64-94cb-cdecbde8e898	2010-12-04 18:15:58.759807	88.168.238.200		active
f7eebe7b-6c57-41bb-9ecf-0eefbffd501e	2010-12-04 18:16:18.639911	88.168.238.200		active
37fbb496-6950-4dfe-96b7-1b2dc46a8c68	2010-12-04 18:25:30.785362	http://arthur.lutz.myopenid.com/		active
e771822d-8bb6-409d-bcf8-663b887d0a4c	2010-12-05 11:20:10.676531	http://arthur.lutz.myopenid.com/	ajout d'extras	active
58ff28dc-f3eb-40a2-bcf8-3912f26472e7	2010-12-05 11:21:21.853221	http://arthur.lutz.myopenid.com/	s/extras/tags/	active
14d1f443-8fc7-42d8-a730-c7747178aa8e	2010-12-05 16:18:25.134989	https://www.google.com/accounts/o8/id?id=AItOawnDOHJWX9v8IUQBJfEiNifXcg8y_ROJeOE		active
01a717dc-516b-42d5-9960-76c799f22a2f	2010-12-05 16:18:49.225768	https://www.google.com/accounts/o8/id?id=AItOawnDOHJWX9v8IUQBJfEiNifXcg8y_ROJeOE		active
283dd01a-2719-46a7-a545-7caaac428e31	2010-12-05 16:19:23.203655	https://www.google.com/accounts/o8/id?id=AItOawnDOHJWX9v8IUQBJfEiNifXcg8y_ROJeOE		active
32c35f04-41df-4a73-9a0f-112eeb800058	2010-12-05 16:27:03.094919	https://www.google.com/accounts/o8/id?id=AItOawnDOHJWX9v8IUQBJfEiNifXcg8y_ROJeOE		active
cbeff999-026f-4420-9207-06477ade30be	2010-12-06 01:04:53.960185	https://www.google.com/accounts/o8/id?id=AItOawnDOHJWX9v8IUQBJfEiNifXcg8y_ROJeOE		active
6279dd25-4840-4072-ac60-e988063feae6	2010-12-06 16:22:01.92288	https://www.google.com/accounts/o8/id?id=AItOawnDOHJWX9v8IUQBJfEiNifXcg8y_ROJeOE		active
f2a6db5d-8947-477a-b302-ea0660e033af	2010-12-08 14:38:44.345416	82.225.240.116		active
2f2740b4-eedd-416c-98a0-bd76359cdd12	2010-12-08 18:21:11.713549	82.229.61.197		active
c3d4f682-208d-482a-bc84-08462a334b80	2010-12-08 18:22:01.258699	82.229.61.197		active
bf59cab9-2d7a-47a2-b5a7-f070f5a5fd58	2010-12-08 18:22:45.220027	82.229.61.197		active
39219937-0939-40ca-86a8-f8493a35a337	2010-12-25 15:43:14.423319	https://www.google.com/accounts/o8/id?id=AItOawnDOHJWX9v8IUQBJfEiNifXcg8y_ROJeOE		active
8b876446-18be-45e9-98d2-2ad4a1b1e7fa	2011-01-11 14:15:52.29086	https://www.google.com/accounts/o8/id?id=AItOawnTBnkguRkPV1VKaXChUEccBlcyeA1L_Tw		active
ab96c2af-06af-4bad-8c4f-00ec10f98776	2011-01-11 14:36:06.165124	https://www.google.com/accounts/o8/id?id=AItOawnTBnkguRkPV1VKaXChUEccBlcyeA1L_Tw		active
7992747c-c4c5-4e14-ab70-b2cce7e64096	2011-03-21 10:42:44.058813	http://teymour.myopenid.com/	Détails de l'utilisateur modifiés	active
df6d8a52-2f22-493d-8be5-645488c266ea	2011-03-21 10:49:32.411834	http://teymour.myopenid.com/		active
9a1682ec-e74a-4539-8bc2-a4437c678515	2011-03-21 10:50:15.917805	http://teymour.myopenid.com/		active
c0b8f3fb-e0c0-4ec9-8d66-a6604dcf12bd	2011-03-21 10:58:52.861547	http://teymour.myopenid.com/		active
65cf3b14-0851-41dd-8891-c545d5d33b8f	2011-03-21 11:01:05.295936	http://teymour.myopenid.com/		active
f39b8053-1f8c-44b5-9f81-07236807d0ea	2011-03-21 11:02:11.119409	http://teymour.myopenid.com/		active
79e83d1f-3aa6-4144-a610-76428572404a	2011-03-21 11:02:52.747522	http://teymour.myopenid.com/		active
b937f726-cd40-44b2-9cc5-47d2c3e7ebc3	2011-03-21 12:42:35.107494	88.168.238.200		active
cbb8cf9d-1615-4a30-9c69-bcc03cae3034	2011-03-24 11:37:13.640408	http://teymour.myopenid.com/		active
333fdd79-d6b5-4196-8aca-c31496de0a7b	2011-03-24 11:39:42.688099	http://teymour.myopenid.com/		active
0513d47f-23df-4180-80e9-dc62a6eb95b7	2011-03-28 10:55:49.353655	http://teymour.myopenid.com/		active
0afcdd05-5c6a-4d38-8ccc-62520a9ea0ed	2011-03-28 10:58:44.44019	http://teymour.myopenid.com/		active
b8bede64-bf67-44d3-8697-8261f01f9d7b	2011-03-28 11:03:01.859132	http://teymour.myopenid.com/		active
5fd549d6-e139-4705-94a1-805d6ce85222	2011-03-30 00:40:57.122996	88.168.238.200		active
bdb5cf3d-56bf-428c-9151-2a3bb3c7669a	2011-04-20 13:24:32.65591	https://www.google.com/accounts/o8/id?id=AItOawkmx3REBD20u-MpAd7Lwqkef7nkTce-fh4		active
ae90eec5-4c4a-4cf4-83f3-238eb3d162e7	2011-04-22 16:18:20.246961	82.225.240.116		active
ea04b09e-6bcf-4718-9480-1461698f30ac	2011-04-22 16:45:45.352719	129.199.114.20		active
9ef4d8c5-6298-450e-8cfe-09b683b28b92	2011-04-29 11:03:44.511725	ChristopheBoutet	publication initiale	active
73525b24-71fe-4d8c-bf6e-82479c209548	2011-04-29 11:05:20.487066	ChristopheBoutet	ajout auteur	active
172732b9-20c1-4478-8adb-045bc9d3092c	2011-04-29 11:06:55.674419	ChristopheBoutet		active
28169ed8-3c47-4522-a8d5-4474173aca5c	2011-04-29 11:16:20.604546	ChristopheBoutet	création	active
99223c1a-1e29-42d1-8256-85f44520866f	2011-04-29 11:32:43.61662	ChristopheBoutet	création	active
2f410629-bce8-453d-bac0-fc0b1e286dce	2011-04-29 11:40:05.776345	ChristopheBoutet	création	active
440a2815-bfe0-486e-8a47-7e3a125f8c91	2011-04-29 11:59:32.302851	ChristopheBoutet	création	active
e96a0ae8-1830-40ae-bdd3-7d2f25961373	2011-04-29 12:03:30.605976	ChristopheBoutet	création	active
9704b3e5-ce20-4be1-8a7d-d9cb211f0cf6	2011-04-29 12:11:23.080428	ChristopheBoutet	création	active
8b78ef6a-380d-4f62-a3aa-84f6256a8d15	2011-04-29 12:17:53.166164	ChristopheBoutet	création	active
b5adad2b-96ce-4b33-90c0-108f760a18d9	2011-04-29 12:18:30.236954	ChristopheBoutet	ajout tag	active
add4fc8c-cacc-4c21-a011-10586b13504c	2011-04-29 12:25:26.336027	ChristopheBoutet	création	active
bc33ab95-a7ce-4722-8c71-55da9972020d	2011-04-29 12:31:02.749438	ChristopheBoutet	création	active
95696de0-b33b-4771-b20d-9b71dff9c316	2011-04-29 12:38:01.508057	ChristopheBoutet	création	active
fbd13c36-5e50-49d2-abd4-049e7e027453	2011-04-29 12:51:29.464438	ChristopheBoutet	création	active
74d9b0ab-1a2e-4016-9f18-1afa11ead13b	2011-04-29 13:01:46.510956	ChristopheBoutet	création	active
12d7a85a-8498-40e0-ae5a-24239d9c82f7	2011-04-29 15:14:03.220993	ChristopheBoutet	création	active
36a22994-298b-4c91-aad0-bfe101e12bbe	2011-04-29 15:15:58.873218	ChristopheBoutet	création	active
75cb2baa-b33b-4762-b981-b4f97364ed22	2011-04-29 15:19:02.684307	ChristopheBoutet	création	active
33125ba6-51d0-49db-88f0-d15ab1cfbb0e	2011-04-29 15:23:27.549231	ChristopheBoutet	création	active
7ffae5cf-57bd-40cf-ac63-1d66fb93e429	2011-04-29 15:35:57.206312	ChristopheBoutet	création	active
a945bf8f-ad7d-43e1-9374-bacf83b24c8b	2011-04-29 15:38:46.441059	ChristopheBoutet	création	active
ddf7860e-3a1d-4321-ac1c-65e9157d813a	2011-04-29 15:43:21.589935	ChristopheBoutet	mise à jour lien de téléchargement	active
2eb6042c-7740-4c4f-b636-76ce8ce6a357	2011-04-29 15:51:18.957034	ChristopheBoutet	Création	active
9bdd4aa6-2e18-4e58-8914-1c4adf1b8916	2011-04-29 15:54:22.41718	ChristopheBoutet	création	active
1504af47-63ff-4fbf-b415-13f245e3530f	2011-04-29 16:00:04.778488	ChristopheBoutet	création	active
f29df221-7759-4fe2-bf70-c1c0f0f4d049	2011-04-29 16:02:26.101587	ChristopheBoutet	création	active
b349135d-a405-4e84-a347-9acbd6b9c0a5	2011-04-29 16:12:15.925976	ChristopheBoutet	création	active
5f4eb519-36a4-444a-bed2-c545d3f4d20b	2011-04-29 16:20:44.27823	ChristopheBoutet	création	active
b87e9ad0-7f68-473d-a15b-64ca1f253bfc	2011-04-29 16:25:12.304674	ChristopheBoutet	création	active
117f797d-1662-4d4f-8779-08a5af2ca1aa	2011-04-29 16:34:40.806377	ChristopheBoutet	création	active
b5c703cf-ee4d-4b5d-b9fe-e5385976b7d9	2011-04-29 16:54:56.634659	ChristopheBoutet	création	active
b4a1d15b-e861-453a-a288-467e743dd51b	2011-04-29 16:59:04.614463	ChristopheBoutet	création	active
a7e3dd94-6c86-413f-abfe-3bed55bf9d85	2011-04-29 17:08:21.860376	ChristopheBoutet	création	active
ce9bcc80-ad33-4db0-82d4-fb3cab033fd5	2011-04-29 17:11:25.778353	ChristopheBoutet	création	active
34579160-706c-4b4e-86e7-1deddb37f9e0	2011-04-29 17:21:03.716389	ChristopheBoutet	création	active
9072590d-3b6f-4ac1-89d3-0751de5632a7	2011-05-02 17:22:11.8801	ChristopheBoutet	création	active
2d7fa951-5b6e-494f-ad7e-a7afcea2cd4f	2011-05-02 17:26:10.59848	ChristopheBoutet	création	active
12caea82-db74-4ffa-b7ed-c149e2352e9a	2011-05-02 17:42:50.670586	ChristopheBoutet	Création	active
fc63ab3d-50cd-4753-9ff3-12aa14ce6692	2011-05-27 10:49:57.337633	https://www.google.com/accounts/o8/id?id=AItOawnd9f6R0-BmYIeV195wLyMqjYnw7iS-mqc		active
1d906f97-b22c-408a-b23a-823cf809d1c0	2011-05-31 18:39:12.916342	http://thbz.myopenid.com/	Orthographe.	active
66b128d0-c36c-48b8-a78a-92b6182586d1	2011-06-13 19:43:18.957776	88.168.238.200		active
15736681-e084-4bb1-bd3b-c6a7af777d00	2011-06-14 22:13:13.75089	82.226.134.174		active
1cc6d560-7a4a-4505-81e8-290e440c9c0b	2011-07-18 20:26:47.618722	88.168.238.200		active
5ec1bdc2-fcbf-4932-b6a6-247c87ed9377	2011-07-18 20:34:30.10709	88.168.238.200		active
195959a3-77de-4e3d-95e4-8c5989ddd65d	2011-07-18 20:38:49.893703	88.168.238.200		active
df459aea-8e94-463f-835f-cdcd6ec1327c	2011-07-18 20:38:56.96747	88.168.238.200		active
3731e364-32f0-4a8c-924a-1c94cc311553	2011-07-20 12:20:17.708693	82.225.240.116		active
ca799f60-69a3-4c16-bd13-b8a9e4e8a360	2011-07-20 12:29:43.296475	82.225.240.116		active
0906792a-0391-484a-a503-86206888bdc5	2011-08-04 14:20:17.413825	78.223.180.78		active
0f7316bd-5b12-443c-b846-ea48cd376a1c	2011-08-17 22:55:56.889632	82.225.240.116		active
b1f45939-ae99-4295-88a4-a4ad552f048f	2011-08-18 09:52:52.670564	88.168.238.200		active
f80174f1-c5a2-437a-9e23-df47b0e6b872	2011-09-09 09:45:38.482872	https://www.google.com/accounts/o8/id?id=AItOawnd9f6R0-BmYIeV195wLyMqjYnw7iS-mqc	Détails de l'utilisateur modifiés	active
657e1e1a-5a1b-40d4-b09c-61db5208662f	2011-09-09 10:05:22.614038	https://www.google.com/accounts/o8/id?id=AItOawnd9f6R0-BmYIeV195wLyMqjYnw7iS-mqc		active
55e7285f-efa1-4cb3-bdba-8dc749cbc7df	2011-09-09 10:34:33.14931	212.85.152.17	Mention de l'absence d'accents.	active
1220be1d-b2b7-491a-a02a-708eb1f990d7	2011-10-01 21:03:27.146914	88.168.238.200		active
d5cb2af1-959e-4994-ac00-6b16b90f6a0d	2011-10-01 21:04:11.934317	88.168.238.200		active
91626032-ae06-4cc2-8b0c-19befe231a93	2011-10-01 21:05:23.921816	88.168.238.200		active
78702a51-adfd-4907-84c0-4c82f874ddfa	2011-10-20 14:21:10.8816	http://cyrille37.myopenid.com/	Détails de l'utilisateur modifiés	active
daf6450f-138d-42d9-acc4-c2f02339def3	2011-10-22 18:21:21.625935	http://cyrille37.myopenid.com/		active
a4331fba-6792-42b7-8843-715629e9d2b7	2011-10-27 16:45:05.927446	http://cyrille37.myopenid.com/		active
fb039b32-eb70-48ac-8532-ac1572e12acc	2011-10-27 16:50:11.881481	http://cyrille37.myopenid.com/		active
4cc259ea-31a7-46d3-9db1-9b93ce24ed27	2011-10-27 22:21:54.839983	http://cyrille37.myopenid.com/	Les données d'observation ne sont plus accessible. Le message est\r\n"Forbidden. You don't have permission to access /baster/form_bastermap.php on this server."	active
081aa116-4b83-4ecc-b179-41fc2f9c398b	2011-10-27 22:45:34.015115	http://cyrille37.myopenid.com/		active
f579ee41-b9dd-4c74-a8e7-e8260d76ce8b	2011-10-28 18:07:45.880859	http://cyrille37.myopenid.com/	ces comptes comprennent maintenant l'année 2010	active
2fc5813b-ec95-424e-8d89-7e35a64de673	2011-11-12 10:09:21.224292	https://www.google.com/accounts/o8/id?id=AItOawlp75h4r21oJyEZKyZZXnuxQRU7Nr5TeWY	Détails de l'utilisateur modifiés	active
9bd678be-b57f-4582-9c02-1a5c106f9f2c	2011-11-12 10:19:38.572521	https://www.google.com/accounts/o8/id?id=AItOawlp75h4r21oJyEZKyZZXnuxQRU7Nr5TeWY		active
a778d7d3-e61b-408b-99c7-1f89c7798181	2011-11-12 10:32:25.211961	https://www.google.com/accounts/o8/id?id=AItOawlp75h4r21oJyEZKyZZXnuxQRU7Nr5TeWY		active
b2d865df-9629-4ee2-9b55-17e1b8c7a715	2011-11-21 01:08:45.379005	88.168.238.200		active
b4b51818-eed6-46d0-aa3d-6e139bc60931	2011-11-21 01:12:21.243333	https://www.google.com/accounts/o8/id?id=AItOawkmx3REBD20u-MpAd7Lwqkef7nkTce-fh4		active
6e196cec-2bdc-4b09-b540-8d55debe949b	2011-11-21 01:17:00.658151	https://www.google.com/accounts/o8/id?id=AItOawkmx3REBD20u-MpAd7Lwqkef7nkTce-fh4		active
df2739ce-379a-42e2-acce-04b95b44d349	2011-11-21 01:17:01.882965	https://www.google.com/accounts/o8/id?id=AItOawkmx3REBD20u-MpAd7Lwqkef7nkTce-fh4		active
aca77db3-5f9c-43a0-a515-cd093e4e1428	2011-11-21 01:44:02.698714	https://www.google.com/accounts/o8/id?id=AItOawkmx3REBD20u-MpAd7Lwqkef7nkTce-fh4		active
227f8627-1870-43d9-981c-9391d44f77d6	2011-11-21 08:21:58.928421	https://www.google.com/accounts/o8/id?id=AItOawmychSGHH-XyILMraEPWdO1gOVCoXrLF7Y	Détails de l'utilisateur modifiés	active
e4086bee-133a-43fd-b352-10bacd65ee70	2011-11-21 18:33:25.981945	http://arthur.lutz.myopenid.com/	première version du reférencement	active
0a8e67c3-482a-4ef4-ac82-1a64eb975d4a	2012-05-18 13:47:41.024397	88.168.238.200		active
c5249a7a-fe9d-4d85-ae81-2c8d1c65ebb2	2011-11-21 22:54:49.473461	https://www.google.com/accounts/o8/id?id=AItOawkmx3REBD20u-MpAd7Lwqkef7nkTce-fh4		active
5c5b9cbd-eac0-40d0-86f0-0d9c9ae096b7	2011-11-22 11:40:47.662585	ChristopheBoutet	Création	active
53c90be2-0cdf-4365-adf1-024e2dbae590	2011-11-22 12:10:30.240589	88.168.238.200		active
85ec5f06-1543-41ef-9aaa-fa4f60123d60	2012-05-22 03:33:42.136597	88.168.238.200		active
10ac057b-4a62-4be2-9333-99cbb69c179a	2011-11-23 17:44:17.481594	http://cyrille37.myopenid.com/	Création	active
485c12a1-334b-4fb6-82e6-96f3556f892e	2012-05-22 14:04:21.464527	88.168.238.200		active
f3a1c18d-442b-4ee6-9ba3-66fc7ac3bfa9	2012-05-31 01:59:47.603413	https://www.google.com/accounts/o8/id?id=AItOawl2h-TMm8FkC-MrhOFrERUn_0vQo9OOzck	Détails de l'utilisateur modifiés	active
d7f22ef7-54bb-4348-b287-62fcb6da90f0	2011-11-28 01:02:01.054109	88.168.238.200		active
c358b6bb-4b0a-48ee-9421-0854d1f68fca	2011-11-30 16:40:52.201254	http://manu1400.myopenid.com/		active
502b47d9-44a6-4b77-8f21-1f36c2d6eeb9	2011-11-30 16:54:09.739945	http://manu1400.myopenid.com/		active
df68a822-74c8-41c1-8cfe-d0d1a685c74f	2011-11-30 17:18:53.419113	http://manu1400.myopenid.com/		active
0b54823d-ebef-4a0a-934c-e408c127861a	2011-11-30 17:27:47.658332	http://manu1400.myopenid.com/		active
9af8b293-f532-43bf-b8cb-06195f021079	2011-11-30 18:03:47.63756	http://manu1400.myopenid.com/		active
58a992bd-8ee9-4627-b719-e8cc083d4344	2011-11-30 18:06:47.588155	http://manu1400.myopenid.com/		active
a18e1408-fa8e-444d-bf0f-996db5a55463	2011-11-30 18:10:34.856758	http://manu1400.myopenid.com/		active
22c78088-f8e8-4d24-b35a-fc6c6c65ea47	2011-11-30 18:25:16.225624	http://manu1400.myopenid.com/	Correction d'une erreur de copier-coller. Déjà dans nosdonnees.fr sous le nom de "donnees-cles-du-recensement-agricole-de-2000"	active
30c271f8-7b1c-4a14-855c-9dc9420f1ca9	2011-11-30 18:31:39.28658	http://manu1400.myopenid.com/		active
ee816bc2-0316-4adc-ac10-300df9306594	2011-11-30 18:41:25.064794	http://manu1400.myopenid.com/		active
177926cc-1263-4323-9dad-14032641b0a5	2011-11-30 18:48:11.028475	http://manu1400.myopenid.com/		active
2b5ac88c-ed8c-4fee-b013-103238447a18	2011-11-30 21:22:39.949816	http://manu1400.myopenid.com/		active
d8097172-e1a3-4d79-b40a-3c3ec12be908	2011-11-30 22:04:08.259945	http://manu1400.myopenid.com/		active
903899a1-b57f-44c8-9818-15fc47ead4da	2011-12-01 13:32:04.128715	http://manu1400.myopenid.com/	ajout des fichiers .txt concernant les "DOM-TOM"	active
474d3077-dbdb-4340-b4a4-2be5b64fa86d	2011-12-01 13:50:43.524423	http://manu1400.myopenid.com/		active
95f05f43-c667-4588-8eec-97492bbe098d	2011-12-08 16:30:36.721918	90.19.74.134		active
3c03ffa2-7549-4757-9869-8bc3aa21aab5	2011-12-08 16:42:49.243388	http://manu1400.myopenid.com/	Iframe d'un site qui a changé => données plus disponibles	active
cc7f9237-21a1-4e74-ac5f-5cfa6dc1c499	2011-12-31 02:15:42.111189	88.168.238.200		active
cdcfa48c-0892-463b-8f68-ff3be6344f9b	2011-12-31 02:16:23.663177	88.168.238.200		active
f17f0f9b-f470-4c39-a6bd-a1d31b90ac1b	2012-01-12 14:58:16.869101	82.237.239.169		active
9b89818a-d5ff-4870-bbcf-7580d008a9dd	2012-01-17 22:39:55.364331	82.225.240.116		active
c710cf20-1e45-4734-8d38-abaa584b67af	2012-01-17 22:41:08.412768	82.225.240.116		active
9f2365d7-35db-4301-8a4c-351671cc2694	2012-01-17 22:46:26.026827	82.225.240.116		active
db2345f0-bd43-4f1d-b50d-c263b791d1c2	2012-01-17 22:50:59.364167	82.225.240.116		active
985b1c06-355c-4311-9f30-47457e636266	2012-01-17 22:51:36.928646	82.225.240.116		active
1cd82cdd-40c4-42dd-b398-44c43ff1b2b1	2012-01-17 22:52:15.459956	82.225.240.116		active
18fafa4e-7382-4ce9-a04f-ec636c51d56a	2012-01-17 22:52:29.609146	82.225.240.116		active
2107f175-c0c5-4f9b-8c79-63eaef240f56	2012-01-28 14:02:18.650817	197.200.4.247		active
5368a792-e938-41de-99f1-4936dca45f72	2012-01-29 23:56:21.349885	https://www.google.com/accounts/o8/id?id=AItOawkmx3REBD20u-MpAd7Lwqkef7nkTce-fh4	temp	active
5037ad29-b65d-490a-bd23-d79c405ec466	2012-02-09 15:11:24.525308	82.225.240.116		active
853347f0-4e13-4d06-a24d-c4a4c28d4762	2012-02-09 15:12:00.294765	82.225.240.116		active
153a48b3-24af-44e4-ab07-9d5610e890da	2012-02-12 15:06:25.952419	62.160.23.122		active
4bba233a-f5ab-48de-ab8d-8f9f386fbf77	2012-02-17 17:38:37.731242	88.168.238.200		active
78218970-639e-4d24-93ed-244cd4decfcb	2012-02-17 17:57:28.479354	88.168.238.200		active
35fc3cd3-516a-494d-b6fa-b82140444685	2012-02-23 00:04:19.062663	82.225.240.116		active
cdf50818-ce06-46aa-878f-c837506e82c5	2012-02-24 18:25:13.564473	84.103.210.81		active
31206ec8-7ac4-40c3-b06d-5f0e5f4f4da0	2012-02-25 10:53:19.646661	82.229.175.44		active
8412388c-5c82-452d-ad9e-3247056c0cd2	2012-03-04 23:43:44.588958	88.168.238.200		active
071df672-626c-420e-ad32-08320d35074e	2012-03-04 23:44:08.886013	88.168.238.200		active
373b5c3e-aa91-44eb-8dbf-c943548f9517	2012-03-12 14:30:32.45401	90.150.144.46	dit :En fait, je dois avouer eatre 100% en occard avec toi! Je ne sugge9rais pas vraiment qu'on   convertisse   les conservateurs. Je crois simplement que plus les anne9es passeront, plus les gens vont adopter ces technologies! Pour l'instant c'est effectivement une niche (surtout au Que9bec!) Mais je vois les avantages e0 plus long terme et j'encouragerais tout de meame les entreprises e0 s'y inte9resser meame si le ROI n'y est pas pour le moment.Pour ce qui est du PleaseRobMe  Je pense qu'il est un peu exage9re9 de voir ces technologies comme risque9 au niveau du vol  Si un voleur est assez fute9 pour faire e7a (surveiller vos check-in sur foursquare ) Il est probablement assez fute9 pour observer combien de personnes habitent le0 of9 vous habitez pour ainsi savoir lorsque la maison est vide  Est-ce vraiment si co	active
133e9e8e-01da-481e-909d-367708fce0c2	2012-05-18 13:50:04.200758	88.168.238.200		active
d3237a95-d367-4144-b757-5bbd1a150f21	2012-05-22 12:56:28.332955	88.168.238.200		active
46739a51-d0ab-416a-9dff-632a03351fcf	2012-03-28 14:04:22.780455	https://www.google.com/accounts/o8/id?id=AItOawk6U9K81u0B8JEMf6oWQI2uoF1iKGx6W-0		active
3cc87d4f-2cf8-4a02-877d-a84be8f8f7a6	2012-03-28 14:52:25.482775	88.168.238.200		active
369831c1-22de-4dea-b0b7-b9a33cef2875	2012-04-01 13:15:56.253225	88.168.238.200		active
dee68882-6a23-47e1-a068-572f5a0dcd81	2012-04-19 17:30:22.364756	http://pyhedj.myopenid.com/	Détails de l'utilisateur modifiés	active
4adab9d1-9f9a-4308-8f09-c909d5035454	2012-05-23 14:54:09.528236	https://www.google.com/accounts/o8/id?id=AItOawkqg5AwCPNZ9wRXFrs08Mx9ZlUlJc02Bpc	Détails de l'utilisateur modifiés	active
6976eef5-92e8-45c2-bc2b-9bfc60341674	2012-05-31 13:02:29.151693	88.168.238.200		active
5ff6213f-387b-4fa1-b818-fd7c5e9151bc	2012-06-04 02:00:26.267965	88.168.238.200		active
c5319ccb-aff6-41c5-a33d-6b63b203253d	2012-06-04 02:18:54.665504	88.168.238.200		active
a08487f0-d7d1-4e72-be99-f37b95410ba4	2012-06-04 02:19:04.537972	88.168.238.200		active
8f541934-f087-4b2d-8130-3cf847c85689	2012-06-13 19:00:41.119956	ChristopheBoutet	Ajout gouvernement Ayrault	active
6eccd4c9-6c1b-4e45-a065-05553ba71ff6	2012-06-13 19:31:53.517701	88.168.238.200		active
b062326e-1f5d-48e3-a67b-9114ca9e15a4	2012-06-16 20:03:52.028964	88.168.238.200		active
ec886521-f454-451d-af59-53aadbcf4bbc	2012-06-18 19:07:58.461596	89.158.159.37		active
0d252ab1-5819-41f4-af54-4036c3226e98	2012-04-23 19:57:01.210967	88.168.238.200		active
da5cfa24-ee10-4a43-b6a6-1780c5c56c14	2012-05-03 17:59:27.724167	80.11.104.116		active
16ca20be-8985-498c-a6b3-29ecc4358399	2012-05-12 15:35:30.410983	88.168.238.200		active
6f381a79-d61c-4bf9-bbd2-4c96c8b058d8	2012-05-12 15:36:05.402588	88.168.238.200		active
99b202f2-e5fe-4e54-beed-2722204ba204	2012-05-12 16:10:51.241027	88.168.238.200		active
1abb1bc3-9af2-4d48-ac1f-6ecbb7b8f3d0	2012-05-12 16:15:38.751552	88.168.238.200		active
f47561d1-b04c-4969-bdc1-06cef53149e5	2012-05-12 16:20:10.493349	88.168.238.200		active
5c5d0f67-78c8-4431-8adc-11ee6652d158	2012-05-12 16:21:39.817103	88.168.238.200		active
bc6d4de3-006e-4b29-8a65-5f884d994708	2012-05-12 16:26:02.113661	88.168.238.200		active
c5caedf1-1874-4f69-b34a-af3ae71236d9	2012-05-12 16:29:11.114445	88.168.238.200		active
43600948-f915-4cc3-8ecf-3b1eca937184	2012-05-12 16:29:52.213099	88.168.238.200		active
59317601-caee-4b10-bc04-8f4ce5006fcc	2012-05-12 17:00:30.805488	88.168.238.200		active
11183ab6-8a61-4c67-848f-f51347641664	2012-05-12 17:01:05.249812	88.168.238.200		active
f13aec90-d533-403f-a48e-1cf78bcc8709	2012-06-21 11:31:21.426991	193.54.67.93		active
9fbb919a-209f-482e-89aa-7fd9e82a7989	2012-06-28 13:13:13.68076	93.27.196.22		active
91785866-4772-4249-9659-5484c2c4a91d	2012-06-28 13:27:47.874985	93.27.196.22		active
6c8aeb30-34d5-4425-bfd7-c61adc9b2d8d	2012-07-01 18:07:40.520626	88.168.238.200	ajout taf	active
4859fec8-5318-4618-83d3-564fa1dcffd9	2012-07-02 18:24:07.717821	ChristopheBoutet	création	active
8cade445-98c7-4340-8aaa-34f0c304d0e9	2012-07-03 16:55:45.596373	193.54.67.93		active
253b2edc-2e40-4d29-b353-0354c6636afe	2012-07-23 08:21:21.566338	88.188.175.25		active
d982c3cc-785b-44af-9d31-fd3fb152558b	2012-08-08 14:17:59.345068	193.54.67.93		active
85c539c3-04f1-49e6-8749-07470b4ee6a6	2012-08-08 14:18:27.471275	193.54.67.93		active
b38759cd-8953-4448-8c61-ba3b596923ed	2012-08-08 14:22:46.250909	193.54.67.93		active
c102275a-5305-461f-be5d-99ec2b312329	2012-09-04 15:26:23.817598	ChristopheBoutet	Ajout .csv Ayrault 2	active
63fc2d16-945c-4443-bbc0-0bd4600d9581	2012-09-04 15:26:52.822023	ChristopheBoutet		active
d6fe63e4-8d4f-49c6-8658-6d711c69b848	2012-09-09 16:43:54.696826	82.224.81.187		active
2f7105eb-514c-4a4b-9271-b33aef907680	2012-09-19 11:53:01.177132	https://www.google.com/accounts/o8/id?id=AItOawlNfJULNrroHOtL8o2h8JpyWDNE_YEYv_0	Les anciens liens sur les ressources n'étaient plus accessible sur le serveur du ministère, cause mise à jour des données.	active
c0737967-984c-480f-81ce-d34a53bf21c4	2012-09-26 09:48:41.77602	178.32.45.5		active
d283c9b6-1bf8-4e4c-9893-be095c2af78a	2012-11-05 00:04:44.142259	88.168.238.200		active
82588466-66be-4f7f-bb1e-2f0aee7ae5d3	2012-11-06 02:51:06.371625	88.168.238.200		active
b4fc3c0a-6704-495c-b092-cbeec8f14ace	2012-11-26 01:02:19.891066	82.225.240.116		active
363e3792-e7f3-4248-84bc-3c828c049ba3	2012-11-26 01:03:21.540354	82.225.240.116		active
fdb4b6ae-6ce5-4741-aac1-877119b6d04b	2012-11-26 01:13:27.892594	88.168.238.200		active
da99599d-79c0-47b0-8f59-3f2fc4bf3bed	2012-12-05 09:43:19.255712	88.168.238.200		active
3fb0c1db-fff3-4704-8bea-a69cff4f441e	2012-12-05 10:01:07.174956	ChristopheBoutet	ajout d'une espace	active
a17fc946-239f-4bf6-96ce-076b5342fe5e	2012-12-09 19:04:56.615744	88.168.238.200		active
\.


--
-- Data for Name: role_action; Type: TABLE DATA; Schema: public; Owner: ckantest
--

COPY role_action (id, role, context, action) FROM stdin;
4aaea917-8a1a-4227-b7f6-a8c0b17bec25	editor		edit
d9aab323-ff2d-4d7a-874a-ca69fb95a5fe	editor		create-package
6f05273b-38b9-495e-9cad-90170e77561b	editor		create-group
f4e6940b-327d-4e74-860e-a3e389d55cc4	editor		create-authorization-group
09f29da4-2daf-4a2d-bc22-1b6286bbeaec	editor		read
91021f2e-a668-4f7a-be42-2fe17cc04239	reader		create-package
720c5276-6258-48a0-ad30-7806fb138fd1	reader		read
\.


--
-- Data for Name: system_role; Type: TABLE DATA; Schema: public; Owner: ckantest
--

COPY system_role (user_object_role_id) FROM stdin;
6a2643d1-d69c-4c97-b8b8-a1352b713912
fd079565-fb40-4bd5-82c3-8f0984c652a1
\.


--
-- Data for Name: tag; Type: TABLE DATA; Schema: public; Owner: ckantest
--

COPY tag (id, name) FROM stdin;
3d24f7b8-4401-4ef1-87d2-955c4628689d	impôts
cecfa504-4a92-4103-beb6-e1d15bbac444	régions
d6b5bc12-83dc-42b7-abf3-2839547f6b03	fiscalité
f59be7f4-6494-42a9-b21f-388930fca8cd	communes
27eecd38-da7f-437c-aa78-e0468be5b594	budget
a23706cf-7ada-4bc7-a323-8cdc6f649701	taxes
471360c0-f000-4c1a-b462-3d26a1009d8d	isf
e8584566-2520-4ffc-bcf6-202169e737a7	élections
1986e4ca-61a8-41a6-95c2-940e526d50f1	bureaux_de_vote
89f5db50-4b21-4808-a4fe-523ec4ff414c	résultats_électoraux
4904453a-6192-4b55-90e8-b8d185b31af7	municipales
9d86e388-cc10-4cf2-b2e7-84d8de81ac84	tarn
f50e4f48-a55e-4d54-996e-dea429b042c8	produit
130ae24f-aa62-4d20-8987-265a1d4d1861	import
74f41828-1aad-4c1c-bdb7-06ad82909375	marchandises
7dffaf3a-a450-4435-b385-44a4e9d0ef61	export
5b2978e4-1837-4164-9070-ad935a080c0c	douanes
e27ac12a-a758-4c98-9198-8663e4d52fa6	commerce_extérieur
db2920d7-c288-4ebd-86b8-a4fdf4689c91	pays
705d6aed-b1d5-4b89-ad38-be4a1daba35d	ministère
d58a8241-1622-4e11-936e-4eab9c55ba4b	polution
adcb0b79-7ada-4467-8f7d-ca6ce7a60405	entreprises
dd3612df-5f1b-479e-9a3c-22737dd68f70	écologie
2d6031a5-1753-481d-8c0b-ce6d3cf08464	impots
5e81f122-08fc-491b-9320-55eeb783e1bb	communauté
8b6bc9ac-d129-4a8b-bb7f-d062c566f4b3	gtfs
7e40bdf7-20b4-4b73-a65e-f7fe50feb8a2	rennes
d3cb78ca-0862-45df-9f56-b47a4038adfa	transport
9f47f113-6785-4448-b15c-8b3eaf2032c9	départements
b59b9b95-d0f4-4c43-9204-4328b391accb	arrondissements
b7438d75-793c-46a4-aa9d-c61fcfa17632	cantons
9a09c86e-d08e-4fa9-bb79-6c864acec8d7	polluants
b6813c1f-5d9c-474d-885d-e839f43e100e	pollution
b417e47b-f741-4033-8945-1663a28d3697	maires
b14d995b-b893-4284-b948-eaaeb1f5f252	seine-maritime
bd44cae3-27be-4c3c-b851-ec460a1d0440	mairies
1bef7b23-a8cd-4000-94b9-2a5d2fdd9c58	contact
f3c50e34-5dcb-409b-a06c-8c16d220c756	trafic
d539b83c-b99c-4577-b773-83fa4c6f5518	villes
d984ccec-aa4b-4645-8301-28a3c57392b2	routier
55546b47-fe3c-40bc-acc9-f78d285d9f13	prix
8e7f1f27-d0bb-4860-a969-93960fa02e9e	consommation
4233e616-3f33-49fb-aa6c-7b54554dec19	france
babf872e-41d5-470e-88b1-8dedc68cf97d	données
6e387a45-5862-4587-a6ed-e576a8dfdfa5	hopitaux
430484c2-faac-4f88-b6c5-df6d5db26382	santé
eaff4bf2-c366-495a-b68f-23b9c65e9b7f	protection
2a33d5a2-9d58-4d8e-975d-ee07da3d6b0e	2007-2012
2af7acb6-6f04-4766-b560-efd1b100596b	deputes
7ecb1d10-e6c7-4a8a-8c63-0a1b1e65fc0b	presence
49a7a707-a579-4de2-940f-1a846b22e741	nationale
8ca0b522-b29a-4155-907b-8142c500dcce	amendements
0f779fa2-6ef8-40d9-ba61-6687b5e82fa0	lois
46caf164-0cb1-4ab1-85a7-22ba97d7b8fc	rapports
ca526aec-bf03-499f-943f-d303a222c6cb	sinterventions
c8cc7acf-e055-4755-8aca-da325baeef12	questions
8cdd235e-33ca-4ffe-9c73-eaa92f08f92d	ecrites
c34cb669-4bf2-4571-895f-d9dfe3f945bf	assemblee
473f15dd-47c0-40a6-89e9-3a053ab172a4	parlement
c061a5ce-5435-47f8-840a-e36a4f315367	législatives
76b6bb6a-de74-4522-b4db-14a74a7320ba	redécoupage
a7cee6ce-5b52-448c-8a41-c612a5d0b3b9	circonscriptions
1812b303-186d-4734-a4cb-1345949485d9	députés
5ff7e7e2-383d-479b-90f7-6b0d3bcaa51a	2007
151588d7-81bf-4f3d-a866-891e5849a939	population
d057758e-a4a2-4125-82bd-83b96a2136da	2012
a45f616e-ae34-4a83-aaf3-de06faca7caf	écrites
07b86a93-6171-4f6d-a4ec-8982c30ffbfd	interventions
ee1bf582-8672-4f86-a84e-c958ff2e7205	présence
7fdbeb86-6300-4260-ac9a-4327519c6bb7	assemblée
eb059ff9-81d9-48be-82d9-a2bb74e596de	vote
920f0530-0a9e-49c0-9978-f3d9ff3925c4	assemblée_nationale
b57f29c3-0179-4d53-8f0e-f400acab0e07	2009-2010
aac980e1-0aa5-41e0-b6e0-eebbab19c7c9	sanctions
a6428b13-2aea-4468-b051-a7b7b2c81ad2	opendataday2010
a0da534f-3b88-4e01-bdda-f58bf9b11407	insee
be807861-8861-4f83-80fd-ad22da22d1d8	associations
9aaf0eec-fc2a-4117-a8c4-c4e160b53db5	financement
f1cfeeff-4ba7-4172-ba51-550d8183db28	état
780ba1c1-34a2-4573-98f9-9a8c6661e44c	bibliothèques
3640e8d5-1d55-4a85-968e-539f45ed137e	horaires
f13fdde8-8913-46b8-852f-8508edfc112c	nantes
111088ad-6b35-4bc9-82be-c74e6013cb39	électricité
3f8a8351-34ce-4e10-b785-fb7a57c5e7cd	énergie
711dcc85-fc2a-465e-8e61-bbf63861b31f	pegase
5306f500-62cf-4f9b-a9e4-00c2e76f9756	pétrole
eea77cb1-5d48-4158-bbf3-8e079a744986	gaz
6e982e5e-81cf-4953-a39f-40f2fe80089a	assurance_maladie
cce9f9ec-ea17-43b8-bf15-5f56dbf32f20	geo
73da3e0a-e98a-4da2-8d17-e2559d9d1841	éducation
fd6ac7dd-6519-4f44-a78d-486fc41579eb	candidats
665b67c7-9381-42db-85de-07f33b37217e	cantonales
90d603f6-c175-4a13-98b5-4692581b294c	2011
877d5f3d-b996-4c07-8ffd-b3e3a7a42043	1er_tours
e2fbbd65-d33f-46a9-b1d6-2a49bd1c8497	1er_tour
0f11fb91-d0f4-41e4-8934-53c2d6a8b598	2d_tour
f5fbd7a0-64b5-4051-8780-c8b8e22f2b42	élus
6eecd056-cd48-4bba-9b38-5f18a7c98e04	lobbying
1d7180fa-9e9d-46a0-ad05-9ab69efc774f	influence
7348e0d0-c94b-4f7e-b2ce-f79fe79f1449	auditions
03ff86ed-50c4-495a-9264-6680e479c1b5	intéret
f31876a3-434f-4557-aa0a-dc437ee39b2d	ministre
d2ce4bc4-45c9-47bb-8623-f22b540da0f6	gouvernement
9cdf19fd-7d75-4e61-b6b2-0ebf17582683	déclaration
f9631259-7d78-4ecf-a94d-941d769c5084	intérêt
e8a4383f-b9bf-44c2-ab85-421406a5d069	dotation
23f8e389-394e-45ea-b71e-fcbf0bada070	collectivités
517528cf-48ce-4495-8d55-78f96cf6b13d	dgcl
7d8a923a-2a0c-406c-9c36-141a0324cb61	marée
01e3a3ad-3b21-4973-a581-8c8ad9938f68	shom
4cc6503a-742d-473e-9e6c-11624b7e8c58	ozone
0f248678-dc01-469e-8c34-d9c1e2c0caee	particules
9b2a0ebd-c9d5-4c1c-bd75-41263d755c3b	air
2c08add6-301e-4273-bc09-56c3cf51c00b	qualité
ad516677-fb7f-42e8-9e00-51be02bfff39	équipement
1b2a9770-8542-400b-b2c4-4743032a4ff2	sport
6a1062c8-afb6-45d3-9b3f-302d223c8943	nomenclature
06483163-62aa-491a-b118-cbfa7a6fb1c9	equipements
f8eecc43-fefb-4202-8113-cd5ce0de917c	risques
aa907186-83cf-4307-bb57-e02f3aec858f	séismes
50250d17-669d-4203-b47f-41ab706120d3	épicentres
cbf2c5a9-2f74-440c-ac6b-e93bdf9b3f28	tsunamis
1694ffba-704f-4aa0-b1c4-a4037869972d	seismes
713e34bc-6b1c-48fe-8030-c755f956251e	eaux
c9ca84a2-f86d-4915-b3f4-48344ff4ceeb	baignade
d60df706-4b72-4f4d-9651-7cba326de6ac	coulées_boue
e921ebf0-76d3-4435-912d-f3ae9292a706	mouvements_terrain
32a67c24-0082-46fb-ad13-6329df70ac2f	radars_fixes
896438ce-8705-4cc8-bc5b-8212b9cca4c6	culture
4795e4e6-ad26-49af-bee3-0561571bb728	mérimée
284b86f0-43c9-4079-b62d-ec572aa48cf7	mémoire
4d699059-2886-444e-9c0b-95540ff4bf93	sols
79a75000-387f-45e9-b858-a7766c451f00	vosges
48b28754-6373-4a72-a431-654bf4e5d58e	tourisme
5c72b096-cb94-4c1d-a976-3822e2690dc7	anciens_sites_industriels
ae3a5e55-cbfd-45cc-adbd-1d4e74add7d9	innondations
4462f385-b858-4c8f-8088-7fd85b9c9537	remontées_nappes
23c37819-576e-4ad0-bca6-2667137bfe99	argiles
7b407771-8e80-41ab-9223-8cafa6fa4ba4	histoire
7d11d541-24f7-45fa-b2b7-0c8c663426a5	art
844950d1-bc39-4374-aa5e-3228164fd656	ogm
15932183-9b6f-4cd9-b180-351824d71d96	monuments_nationaux
c1faa2e7-035c-47d1-9d35-cc497728b8d6	intercommunalité
c6152eae-a552-4cc0-8b5e-a0c72a6987b0	comptes
ef2f172c-e71a-497a-8373-56c47d9cbe5a	niveau
59fc41c4-2a4d-459b-b489-54ad20f26fe7	inondations
91dea717-03c4-4fbb-81e0-07bfdc3ec10d	terres
5315cfeb-aa6e-49e1-b42f-12daed6ad2fa	agriculture
b8d19818-8529-4dce-9f46-12035ac43098	recensement_agricole_2000
3a1a6c2d-976e-41a2-a797-3e59b8165ebd	val-de_saône
8de57ce1-e9cd-4eb3-8432-64aba816c41d	bourgogne
df234aea-eb2b-4510-ac40-53b599633686	saône
ccb3fac5-0925-43b0-8ca8-5a797a6bc18f	franche-comté
7ef1856f-5ec1-4c92-aebd-9ec3e4bb78e3	risque
f49977cb-1a77-436c-bfb1-02844992933f	chiffres
0fa92041-ce27-4e68-b3d3-c9b43f3c6de6	construction
b746c869-367e-4517-8cb6-8e8fff168bcf	hlm
67067ff6-231d-4cb0-bf1c-53d232693248	logements
3ac4b1c0-ef85-4a8a-978d-790935bf856a	sociaux
62cec790-8fe7-401a-8a14-25854875fc87	habitation
15bbdb5e-f0f9-4749-bc70-9d3ecd9d4f62	conseil
a1240961-70a8-4405-8f9d-1f883f120a87	constitution
5667cc10-9e4c-4a5c-9b5f-a1270ec087f5	institutions
f00b6c16-7867-409b-8439-4e50dd7f12e1	constitutionnel
f1214aeb-9ad3-4e93-b298-2c6618a02f7e	publics
3060b98a-0207-404a-b5a4-96e8e6885767	marches
dbdc596b-44c1-42c5-8116-f7d1968cbf13	communication
59177438-4307-4673-b274-0963552ee8b7	offre
41ccd9ba-7563-4db6-a0a2-31e93dbf21c5	appels
5fe1c7b0-f733-44c4-abcf-04659911d91a	réseaux_sociaux
2b55a614-018b-47c8-a07c-8acc2071a433	presse
071a3720-55dd-4638-a31f-40762c38b6e5	naissances
edaea925-2eef-4da8-a393-faf910b4314f	prénoms
5124b3b1-4ada-47c7-863d-db4e72b65371	pjl
f73dd96b-0c6a-4d09-bd4a-313fe368ddbe	loi
4007f503-7979-4147-98de-2c29348abc43	dépenses
2d518686-9f62-426f-9a2b-1b2fc94b90e4	de
5bd30510-2edd-446a-bb97-091a5179e92d	projet
3c7cf1a0-26ba-4460-bdf0-f282b2964c02	recettes
3b95f7ef-56e7-4d11-aa64-0c078a4ba24c	finances
a75a070f-44a9-4a8d-8818-368ed36a895d	département
44b7a7ef-c7f5-4f0e-bfe9-066ad966f577	saône-et-loire
6fdeda39-0549-4a0f-964b-51beae1d914c	territoire
4e29bdcb-88d1-4b1d-8e85-4ab68f1e4db7	finance
16d6bc5a-fbb0-4356-9ac9-899576f74460	chômage
265b6084-04e7-4f95-85a7-5e9ae3612438	eurostat
0192674f-4aab-4a85-9451-91de8fb06d35	taux
aa5647cc-7f19-419c-88d2-c643289824bf	banque
34940451-48bb-40f3-9bcf-8fc1a2df5bda	fonctionnaires
ab727572-b10b-4a31-bb9c-fd40fbf9bba6	depenses
12cf3b7a-04a7-464c-be9c-db71b554ddf8	2009
10eda8bb-9840-479a-ba70-b1a6c632db68	2010
a58d7975-f96e-4089-8e24-64cbdba09a1f	agglomérations
6ead3562-71c5-4cdb-837e-878cc2da2534	autoroutes
0b672960-f467-436e-9300-fd0019de40c6	routes
04d92cc3-efaf-4033-a5f6-40f3856e855e	bord
2bc8f9aa-0a7a-400c-ac77-1ccc3cd41150	2008
e13f7c8f-e29f-4074-ad2e-84177da25028	document
b6afb46b-4d63-46d0-8b7e-f71d6d2fe500	patrimoine
d83fcda2-9fcb-429f-8fc5-4b421478a4ca	nature
b8d71981-30ab-402a-b29c-da315610bb73	surfaces
dd951909-8a84-4b47-8e70-9b3a083f30ab	emploi
4503e0a6-4871-45bb-ab12-1021a0a4d873	élevage
37a1d187-97fe-4243-9579-f7e0f12c3d9b	exploitations
0c2e2d99-7fd3-41c4-aff6-c7db6c8c91f1	recensement_agricole
4a789077-a8ad-48dc-880e-328e2f99f63a	2000
877e6c87-50ab-4b0d-8ed7-40be4f5109c4	statistiques
001a45c6-9af1-460b-8814-801da17619d3	1994-2010
7b099d32-3519-45f6-9b83-542e0fdd6ec8	historique
78115c49-086a-4799-be1d-e6ef6eef97a5	1999-2011
f2d5f66f-3e64-432c-ad74-9df59e78c3e0	état-civil
2b526ead-4e35-4bc6-900e-5bf1b32c854e	paris
d3fe7c4e-9bc0-4718-ab5d-6184e261b926	2004-2010
a6d6facd-9d1f-4c47-8d38-efab698b3e0d	2001-2010
23cb8375-5249-43a8-adb2-a8bc3fc7784c	réunion
c3dce0b0-ce3f-475b-8bae-91f6dc03e0aa	mayotte
66261447-7807-4f0a-a19e-a14dde5e68cb	nouvelle-calédonie
5b0e137b-78e2-45a4-8ab2-bfad40306d69	antilles
d76057c8-5d41-4a7a-861a-2b558f8081c9	wallis_et_futuna
08719c78-ea0a-4731-816c-c8d57d7db76a	géolocalisé
64a66b0a-6a92-4149-ab19-2c5d40856e82	décisions
3a931aa9-250e-4119-9826-be94e485cb69	scrapping
ca6045bc-34bc-452d-9668-75dc38319ef7	error_404
3e50182f-2d55-4375-becb-9e9c0f19b0e1	coordonnées
c7a4044b-2612-4208-9fe8-ef14878071a7	préfectures
68580412-9553-4778-aef8-6d36f1136b28	codes
4cc50dc6-97e2-416e-96c2-c0b747199fa6	postal
957ba93c-80c9-4709-b716-94089518f4a0	postaux
634397b7-b735-4260-a30c-7e03302f263e	gps
3007a18b-d717-44fd-8281-943c0bd3d7f9	elections
72cd5937-eeda-41d2-9482-13017802414d	2002
34d831fd-404b-4ae7-b4d6-b5d70749ff75	etalab
dbdd1313-54e2-4816-a108-6e2f2f70002f	csv
c90f528f-b9c6-456e-a467-3ca145bb4528	data.gouv.fr
5c943c63-92fa-4038-95af-7c2bc9decf74	images
f7c7e083-9b25-47eb-8153-b719b907d907	orthophotographie
91a6b94f-c0c1-44c2-8ae6-15d3b1ae4b60	vues_aériennes
73b0d2dd-0b1d-4d67-b8f9-e7a9a61d2e1b	sexe
c1610461-01ce-4a34-89a7-0e93f74f67e7	âge
26e502aa-c39c-48a2-91ab-6569af21ae9e	csp
b0aef3fc-2551-44ce-9e59-e2f5e848748a	ménages
94e91072-a71c-4b7d-85a4-76d88683c2a0	démographie
b7475bec-cae2-48b0-a8fe-1f70658fb5ef	signatures
ca903ad5-d738-4dac-b6c2-dfd847522650	1995
87e157c1-1674-49ad-a7c9-14f54cd1b192	présidentielles
a85647c2-fc12-4766-a70b-88f4ff6a8465	500
43801850-5d9c-47d5-bc71-31c3aa4a18c5	énergies
45a0920e-01b6-4f46-9169-98b95fc5f193	conjoncture
7fde6772-145d-4443-9e39-fc19041008d9	climat
a739f123-1033-496e-a5fe-87511494480d	durable
ab7981ff-d3a3-4ce0-af23-6c47307a62ce	développement
0192601d-b976-4977-8264-1f517aaa780b	environnemen
2900d3c6-e08a-459e-b132-69f5a4456acf	logement
f7d4c27e-998c-4f03-970c-509739212887	et
9fd054d5-5bf7-402d-9a4b-bcc990552c1c	territoires
b83b6bd3-9559-4c39-9280-1f66345034a2	transports
0ec35598-db54-4019-864f-5e4d310662d2	sarkozy
0a14592d-4d81-4ea4-a78a-884d16d67baa	abstention
71052f94-3fc6-4260-a2e4-dc0354275d88	présidentielle
3ee14257-d6ea-40ee-8f8b-3293ab90cb79	participation
233655da-e83d-43e2-bb2a-cce9c6f3f391	hollande
bf721b6b-74c7-43da-b80d-fc9c086ffc6b	president
cc18bf9c-d21e-4ea2-9cf2-b1b9f16855b1	président
5ff8ddd6-e698-4a94-a563-f28d6cdf06bc	transparence
7cb00ab4-0502-4fe1-8314-db484a3781f3	regards
cf947468-a778-4c4b-8c5b-fc4ce7cd9bc0	citoyens
4b6b96b1-115c-40c9-815c-25a5110597ba	agenda
64b894ec-5075-4176-8f3b-ddb173f1deaf	bilan
9a74cff3-b7c7-4128-bb65-ff076be66019	libertic
cf449447-3f45-4c68-8aac-8b5a4ec96f25	assos_transparentes
f8ebae5a-f81c-40d6-9a08-5c1f375c4acf	carte
eb470e55-aafe-4855-968e-f6b29cfc849a	redevance
1b7c7542-cbeb-4d25-84dd-acd74583925c	licence_payante
7cf0b9f2-0688-4a33-becf-c4b375d4b1f9	données_epa
212a4b69-4d95-4262-8572-0892788ba9a3	données_état
88028489-490a-4507-9f87-2d9a6e2d50bc	licences
c90a28e2-4831-4ad0-bd51-c0649a3c54ee	frais
97e4fca1-424e-45f2-aeee-db6db61d1737	campagne
0ab529c6-4551-432e-a566-bbfcfabc15b8	justice
601cf29e-2b2d-405d-88a9-0dd7c3ae09e3	dossiers
c51c7ba1-34f9-4eea-9b79-ba2f9fa99f20	traitement
f839795f-58b2-4351-ad75-3c8d3df7f794	delais
247438c8-f5a4-489a-8918-afd6574bda6c	statistique
57a112e5-f2d5-4724-9aa3-c8730f1c19a4	stock
bf811c75-eb5f-47e1-8b87-c4119912c88c	rattachement
0485e497-11ba-4033-b412-fcb97816c5b6	politiques
6462e1a0-5395-4bb3-aa23-c73ae5877c25	partis
6535de51-8e81-49ba-9a0f-c81f3688b890	financier
\.


--
-- Data for Name: user; Type: TABLE DATA; Schema: public; Owner: ckantest
--

COPY "user" (id, name, apikey, created, about, openid, password, fullname, email) FROM stdin;
6992eb2a-baf3-4eec-b1fc-2d1df9b76368	visitor	4370b2fd-8a45-413d-aa88-b741af540884	2010-10-29 16:53:52.07159	\N	\N	\N	\N	\N
3851105e-cfcf-45bd-b568-5f1ff4671ec0	logged_in	5d05676a-c715-4b7f-a04d-59cd398a8e1c	2010-10-29 16:53:52.072599	\N	\N	\N	\N	\N
23677fff-26f3-43e6-bb00-9c8ab1a73c9d	https://www.google.com/accounts/o8/id?id=AItOawkSATsJ9c11r4HbASkXajuZzI-AcQPh8Cw	4036e907-b00f-44f1-b04a-0be0c40710ba	2010-11-25 21:26:51.702154		https://www.google.com/accounts/o8/id?id=AItOawkSATsJ9c11r4HbASkXajuZzI-AcQPh8Cw	\N	test	
bb4ee2e5-b33c-4b71-b698-d582b4cf8277	https://www.google.com/accounts/o8/id?id=AItOawkmx3REBD20u-MpAd7Lwqkef7nkTce-fh4	d47e5904-0930-4ac0-9814-3318a31c0670	2010-11-25 21:26:18.480251	Co-fondateur de Regards Citoyens	https://www.google.com/accounts/o8/id?id=AItOawkmx3REBD20u-MpAd7Lwqkef7nkTce-fh4	\N	Roux	b.ooghe@gmail.com
e9633622-884b-43a7-b6d8-9ee050194517	https://www.google.com/accounts/o8/id?id=AItOawnIpsCRkMbA9roFwSPT2i15XwXECX5xHjk	dcbbdffc-c1db-4dcb-be6e-af1838b92a2a	2010-11-26 21:01:23.531601	\N	https://www.google.com/accounts/o8/id?id=AItOawnIpsCRkMbA9roFwSPT2i15XwXECX5xHjk	\N	\N	\N
a8593e73-81e1-40f7-b53a-e21e2f1a8a6f	http://arthur.lutz.myopenid.com/	95419297-32b8-47b9-abdb-2048e8a00f88	2010-11-26 19:24:05.848511		http://arthur.lutz.myopenid.com/	\N	Arthur Lutz	arthur.lutz@gmail.com
cf514056-a9f4-48bf-badf-4c28e0a633f7	ogrisel	79913597-1dba-4c3a-bb97-6fd3ee29b53b	2010-11-27 12:39:16.561845	\N	http://ogrisel.myopenid.com/	\N	Olivier Grisel	olivier.grisel@ensta.org
6937df71-4553-44cf-9697-179aa5fa965b	http://openid.ziade.org/tarek@nozilla.com	7f07d928-d686-4bb7-84d4-c633f703f769	2010-11-27 16:51:08.582903	\N	http://openid.ziade.org/tarek@nozilla.com	\N	\N	\N
376b5095-1554-4017-ad2d-2dc6a5471a4f	https://www.google.com/accounts/o8/id?id=AItOawlvioCwdcjymQflv5S0mQi6sItMskk1J4Q	b74d3099-8ee5-4d8f-b0f6-7edac22a23ad	2010-11-27 17:52:11.776768		https://www.google.com/accounts/o8/id?id=AItOawlvioCwdcjymQflv5S0mQi6sItMskk1J4Q	\N	Vincent Privat	vincent.privat@gmail.com
a91a259f-31fc-4fef-a019-27cf81f7ab6d	https://www.google.com/accounts/o8/id?id=AItOawmi7a-OhN45fXgERYMUadWHpvUU4SBOxeI	cd60e824-cc08-4a5e-8b16-72cdfebb3e4b	2010-11-27 23:21:22.475675	\N	https://www.google.com/accounts/o8/id?id=AItOawmi7a-OhN45fXgERYMUadWHpvUU4SBOxeI	\N	\N	\N
85c45de1-ea32-46c3-b737-c22b5351f523	http://david.larlet.fr/	2032e9ad-4826-4689-81d0-a52346ce84df	2010-11-28 03:55:03.062664	\N	http://david.larlet.fr/	\N	David Larlet	david@larlet.fr
d3c3bee4-ee2f-42e7-bca8-b8e3e0384e49	https://www.google.com/accounts/o8/id?id=AItOawkGjEVVloKhTfIR7FV8uRw3dUG9wHenkDU	ea522492-eb98-437c-9e10-e54649d021ad	2010-11-28 04:50:16.281841	\N	https://www.google.com/accounts/o8/id?id=AItOawkGjEVVloKhTfIR7FV8uRw3dUG9wHenkDU	\N	\N	\N
197cc2b0-aad3-45cd-aff1-771e9f96ebbe	http://troncy.myopenid.com/	e4f39ed0-8610-464f-ab1e-43a1bea7aba2	2010-11-28 11:03:10.405072	\N	http://troncy.myopenid.com/	\N	\N	\N
e875fc80-458d-40f2-8a85-1f1051b30187	https://www.google.com/accounts/o8/id?id=AItOawl8Ziz2sBXnxWWzGH-UGNXVClHd1QYz9fI	865d0294-5bf3-409a-9ada-aa88cef08750	2010-11-28 11:24:05.86416	\N	https://www.google.com/accounts/o8/id?id=AItOawl8Ziz2sBXnxWWzGH-UGNXVClHd1QYz9fI	\N	\N	\N
1afc52ec-ab04-4e89-9c8e-285eecf44e8a	https://www.google.com/accounts/o8/id?id=AItOawktbRgi2gSOW14keppjWV9CXY3bBjYvVTc	afb76927-9c43-48c0-b039-d292162c6c33	2010-11-28 12:14:07.982357	\N	https://www.google.com/accounts/o8/id?id=AItOawktbRgi2gSOW14keppjWV9CXY3bBjYvVTc	\N	\N	\N
7d60160a-99b3-44a7-a24a-949cec25d6ca	https://www.google.com/accounts/o8/id?id=AItOawkQ3CWOqkfSl3kuLuYWTmxSBPD4_CRHbdY	1e22562d-26f5-4e29-b95a-084a4761bb19	2010-11-28 22:18:35.040759	\N	https://www.google.com/accounts/o8/id?id=AItOawkQ3CWOqkfSl3kuLuYWTmxSBPD4_CRHbdY	\N	\N	\N
bbc63fec-0bc4-4bf3-9a13-f03800af2429	https://www.google.com/accounts/o8/id?id=AItOawmVnSwClPfoP7SA6ELbPa-38tJKSevc9b0	e36550e9-5993-49b3-90f9-264451bf2b76	2010-11-29 09:42:03.182999	\N	https://www.google.com/accounts/o8/id?id=AItOawmVnSwClPfoP7SA6ELbPa-38tJKSevc9b0	\N	\N	\N
817b567c-9308-4872-9d87-0e952106abd4	https://www.google.com/accounts/o8/id?id=AItOawnTBnkguRkPV1VKaXChUEccBlcyeA1L_Tw	6de6b234-c93b-43a5-8e0b-07a3a040ee22	2010-11-29 23:20:49.187885	\N	https://www.google.com/accounts/o8/id?id=AItOawnTBnkguRkPV1VKaXChUEccBlcyeA1L_Tw	\N	\N	\N
c0a4895d-214a-4eaa-9e13-57a2d03dfd1c	https://www.google.com/accounts/o8/id?id=AItOawmMuUYSDd6ur7ObwHkK4o5zxikmsNnHJUY	067f20ac-b9b9-41c6-a763-c0578295418a	2010-11-30 12:57:33.97502	\N	https://www.google.com/accounts/o8/id?id=AItOawmMuUYSDd6ur7ObwHkK4o5zxikmsNnHJUY	\N	\N	\N
6d4a1dee-c3d8-468e-a9f2-99badcc80c23	yannbreliere	892e2858-2b28-4da9-a6d6-9be561d0698a	2010-11-30 14:02:47.324224		https://launchpad.net/~yannbreliere	\N	Yann Brelière	yannbreliere@gmail.com
01315085-5cce-40ce-88c2-e8c65c10c5a2	https://www.google.com/accounts/o8/id?id=AItOawmOFavlb7atN3hWfJ7M761oXsVPz9c6I_Q	9fb2c211-6ad9-4321-9656-dcdfc034c598	2010-11-30 16:02:58.236428	\N	https://www.google.com/accounts/o8/id?id=AItOawmOFavlb7atN3hWfJ7M761oXsVPz9c6I_Q	\N	\N	\N
ee795192-8bcb-4117-8c68-2affc66c690e	http://bbayol.myopenid.com/	88fcf8ab-a95a-4d58-91f3-add9948effea	2010-11-30 22:07:50.697896	\N	http://bbayol.myopenid.com/	\N	\N	\N
56c37b30-aa7a-4e17-b244-e9e71067b8a8	https://www.google.com/accounts/o8/id?id=AItOawnC18rvQ45Ge33zWfjkglxHUYuifMs2JeU	b7cb9b6f-f588-4045-bc3f-1fb63cad355d	2010-12-01 23:20:59.566459		https://www.google.com/accounts/o8/id?id=AItOawnC18rvQ45Ge33zWfjkglxHUYuifMs2JeU	\N	mcben	mcbennn@gmail.com
6389d806-a529-4179-a002-b463d94cf4b3	https://www.google.com/accounts/o8/id?id=AItOawkdAXUyHVk1xYAeWH_AiJQwPrFYxdMlnN4	9a679311-ce66-43dc-97f0-6a8447f1e8be	2010-12-02 09:36:55.209883	\N	https://www.google.com/accounts/o8/id?id=AItOawkdAXUyHVk1xYAeWH_AiJQwPrFYxdMlnN4	\N	\N	\N
bde1f833-bd6e-4d15-99ef-790062a28a01	https://www.google.com/accounts/o8/id?id=AItOawnDOHJWX9v8IUQBJfEiNifXcg8y_ROJeOE	05f4624e-a1c7-4397-a076-795d73600d92	2010-12-02 11:20:39.864874		https://www.google.com/accounts/o8/id?id=AItOawnDOHJWX9v8IUQBJfEiNifXcg8y_ROJeOE	\N	Sylvain Hellegouarch	sylvain.hellegouarch@gmail.com
3a214ada-5548-48cb-a20c-3f3c6c6866ca	https://www.google.com/accounts/o8/id?id=AItOawkvEuW7sYRdsdAIqfkL_jyvLbqGV4hTPoA	88091d6c-6862-4699-871d-6565ff87a4c1	2010-12-02 16:18:18.163419		https://www.google.com/accounts/o8/id?id=AItOawkvEuW7sYRdsdAIqfkL_jyvLbqGV4hTPoA	\N	Alexis Antoinat	a.antoinat@gmail.com
9ca0e8be-ece2-4ac8-966f-0b2f6edf615a	Oliviergg	46999bd0-97c4-4bc6-9240-6817f6e59459	2010-12-03 15:59:47.390702	\N	http://symboleid.com/	\N	Olivier GOSSE-GARDET	symboleid@gosse-gardet.fr
a00fdc75-e7ba-4516-8daf-ad5ba5eb6e83	ilorium	746471b4-df66-4aa7-abff-1c3ce8ee86e8	2010-12-03 16:16:46.079774	\N	http://www.openidfrance.fr/ilorium	\N	Gilles SEROU	ilorium@rocketmail.com
266c0a99-1253-4081-a9ed-a4aa027b58fe	https://www.google.com/accounts/o8/id?id=AItOawk9Fk-PfMCD5A7bcU8RsELWznh4eYowLkk	de990461-b000-4357-b791-94fe0d3876ac	2010-12-04 15:31:16.162429	\N	https://www.google.com/accounts/o8/id?id=AItOawk9Fk-PfMCD5A7bcU8RsELWznh4eYowLkk	\N	\N	\N
603a6418-5b67-45b8-8335-ed48ce0456cb	heroined	f1caa6f7-3f9f-4ab6-9ce5-893f2b77a61d	2010-12-05 17:26:15.86929	\N	http://www.openidfrance.fr/heroined	\N	Pipo Bimbo	heroined@libertysurf.fr
1aa078ed-c9c2-4f98-af31-25f52ecd7221	https://www.google.com/accounts/o8/id?id=AItOawmIRSxxkfERMyd-JjwDIrdOgl-3MwkZtVs	97c3c5a2-c9c3-423f-a3ec-6758e5044b49	2010-12-06 16:39:00.616158	\N	https://www.google.com/accounts/o8/id?id=AItOawmIRSxxkfERMyd-JjwDIrdOgl-3MwkZtVs	\N	\N	\N
ed1c50e8-1f92-4fe9-8969-2ffd96cc1626	https://www.google.com/accounts/o8/id?id=AItOawnVm48wYSVHLRdhOrTosBwBllcDyIPK5bg	f004cf03-9ac5-42c0-ad20-95e1e931e16f	2010-12-14 10:55:29.751859	\N	https://www.google.com/accounts/o8/id?id=AItOawnVm48wYSVHLRdhOrTosBwBllcDyIPK5bg	\N	\N	\N
d4c8329f-07ce-4aa6-b4b2-0b88b2066f75	https://www.google.com/accounts/o8/id?id=AItOawl6qWkCwwTWOWOlAXi_8HtGyuFfod8vb-A	47506fa5-a7ef-4de9-b085-cd7b2f686f83	2011-01-11 14:04:24.562865	\N	https://www.google.com/accounts/o8/id?id=AItOawl6qWkCwwTWOWOlAXi_8HtGyuFfod8vb-A	\N	\N	\N
dbc09004-1791-49b2-b9e9-20e2b16a6b85	https://www.google.com/accounts/o8/id?id=AItOawnHJeWIPmroe2HT2Jajq-w4Id0lY1zGFR4	e112c865-554f-4f01-ac40-626357bc7e92	2011-01-12 21:00:59.911715	\N	https://www.google.com/accounts/o8/id?id=AItOawnHJeWIPmroe2HT2Jajq-w4Id0lY1zGFR4	\N	\N	\N
f84d8561-df2b-41cc-97ed-d12aac96e5f2	max	ed443414-e3ea-429e-8e7a-dd11278385eb	2011-01-29 19:17:19.167674	\N	http://openid.latitudefrance.org/openid/identity/maximgarbar	\N	maxim	mxg10@yahoo.fr
9e0b6515-eebf-4863-ad75-d128cf513e40	ChristopheBoutet	7188a43e-40d5-4fc7-9741-c4d5e225fba0	2011-03-04 12:46:52.777714	\N	http://cboutet.pip.verisignlabs.com/	\N	Christophe Boutet	christophe@boutet.eu.org
aaa193bb-8f0f-49b0-92a8-2686cb6475f2	http://teymour.myopenid.com/	7ad4c5e0-64e2-4cf7-8599-77972806d536	2011-03-21 10:42:25.994672		http://teymour.myopenid.com/	\N	teymour	tangui@tangui.eu.org
66fc4659-3ec9-4754-ab4e-7c19dd4d6744	https://www.google.com/accounts/o8/id?id=AItOawlzCGWuOx-Z-WaGtht-ERptbF8hqDqJeDE	ccaddf97-a38d-480e-874a-9d7981dbd4b4	2011-03-29 23:54:03.285161	\N	https://www.google.com/accounts/o8/id?id=AItOawlzCGWuOx-Z-WaGtht-ERptbF8hqDqJeDE	\N	\N	\N
87832d87-292e-44b1-9d35-a4788b248874	https://www.google.com/accounts/o8/id?id=AItOawnKUQGvIet-BkyzG6v2abl7hrYzQ7cVSoM	254333f7-6f11-49b3-8b56-e44c6bd8d5b3	2011-04-28 11:27:49.237736	\N	https://www.google.com/accounts/o8/id?id=AItOawnKUQGvIet-BkyzG6v2abl7hrYzQ7cVSoM	\N	\N	\N
05b05b78-c566-47d5-87b3-d6487445210a	https://www.google.com/accounts/o8/id?id=AItOawk1tetj8eU2hN9gMeYLRCW4E6rKKCXH9rs	7c255654-2bf4-4132-99ba-e7d6cc731e9c	2011-05-09 14:56:20.80031	\N	https://www.google.com/accounts/o8/id?id=AItOawk1tetj8eU2hN9gMeYLRCW4E6rKKCXH9rs	\N	\N	\N
722a2c87-80db-4e10-a860-cc332f2b44bb	http://thbz.myopenid.com/	8f4252cf-a84f-4979-a433-604448a466aa	2011-05-31 18:37:38.940498	\N	http://thbz.myopenid.com/	\N	\N	\N
ee1905ac-0aeb-4c66-83b7-734069b012ca	http://thomasg77.myopenid.com/	4f913276-afaa-4884-b88c-d496542a35a4	2011-06-04 03:16:17.598242	\N	http://thomasg77.myopenid.com/	\N	\N	\N
fbebb85b-8d29-4511-a23d-ca6c0f2edddd	https://www.google.com/accounts/o8/id?id=AItOawnd9f6R0-BmYIeV195wLyMqjYnw7iS-mqc	d37b28a4-7dca-4a6b-91a8-5283378f2a0b	2011-05-27 10:47:03.507029		https://www.google.com/accounts/o8/id?id=AItOawnd9f6R0-BmYIeV195wLyMqjYnw7iS-mqc	\N	Nicolas Kayser-Bril	
960b876a-86f6-428c-af44-0d4684f245e7	http://cyrille37.myopenid.com/	6129312e-9af6-4bf2-9774-1808c65bdc64	2011-10-20 14:20:45.149642		http://cyrille37.myopenid.com/	\N	Cyrille Giquello	cyrille37@gmail.com
32c24e0b-a300-4d01-abe0-b2e6c2661749	https://www.google.com/accounts/o8/id?id=AItOawkHDnvDgw0Oz3l2bVMDjMc3vfIqaEwq2Xo	d1e734a0-e1f7-468e-a8f7-3b21d26d73e8	2011-10-26 09:52:40.393289	\N	https://www.google.com/accounts/o8/id?id=AItOawkHDnvDgw0Oz3l2bVMDjMc3vfIqaEwq2Xo	\N	\N	\N
3d7b94b7-ad1d-41d3-b338-d9e5de7bce42	https://www.google.com/accounts/o8/id?id=AItOawn_-50-BJjm96xTalKnigeCqqKmGxmyVwc	92b1557b-19a3-47cf-8850-4f3544217541	2011-11-10 07:24:55.895589	\N	https://www.google.com/accounts/o8/id?id=AItOawn_-50-BJjm96xTalKnigeCqqKmGxmyVwc	\N	\N	\N
eeb01a7b-ae75-4d97-b8e0-d071bb042736	https://www.google.com/accounts/o8/id?id=AItOawlp75h4r21oJyEZKyZZXnuxQRU7Nr5TeWY	c26cd3ee-cf46-4622-b1c8-5dd438b32a83	2011-11-12 10:08:52.996866		https://www.google.com/accounts/o8/id?id=AItOawlp75h4r21oJyEZKyZZXnuxQRU7Nr5TeWY	\N	Alexandre Léchenet	lechenet@lemonde.fr
a8b455e2-6a2b-4da5-b4ad-4ab80d92835f	https://www.google.com/accounts/o8/id?id=AItOawmychSGHH-XyILMraEPWdO1gOVCoXrLF7Y	7d701d64-3b5e-4369-9230-19975928cd15	2011-11-21 08:18:26.165421	33 ans, Cartographe, Ile de La Réunion	https://www.google.com/accounts/o8/id?id=AItOawmychSGHH-XyILMraEPWdO1gOVCoXrLF7Y	\N	Emmanuel MARCADE	emarcade@univ-reunion.fr
9c93b7e2-ec2f-4320-8230-c10ca09b4c3e	http://manu1400.myopenid.com/	cae47518-d215-4a15-ba05-463dd4db6ba6	2011-11-30 16:37:39.084975	\N	http://manu1400.myopenid.com/	\N	\N	\N
8f84e6f6-9aae-4057-865c-05cf3886e929	https://manu1400.myopenid.com/	5d4d48cb-a39c-4a16-a768-b721a22d17c1	2012-02-05 22:03:51.618124	\N	https://manu1400.myopenid.com/	\N	\N	\N
96727271-1bcb-4f9f-be2b-a1448400b06a	https://www.google.com/accounts/o8/id?id=AItOawmW1kYYb17fUHIA6-BQQhgjBh4nK-YOzAw	35822764-d87c-4e6c-b767-faa3626cf314	2012-02-26 18:06:34.957942	\N	https://www.google.com/accounts/o8/id?id=AItOawmW1kYYb17fUHIA6-BQQhgjBh4nK-YOzAw	\N	\N	\N
0b874efd-80d3-4375-92b9-4090f5141207	https://www.google.com/accounts/o8/id?id=AItOawk6U9K81u0B8JEMf6oWQI2uoF1iKGx6W-0	3577f4f4-9bab-40e8-8b12-f374ed13a3e4	2012-03-28 14:03:16.300153	\N	https://www.google.com/accounts/o8/id?id=AItOawk6U9K81u0B8JEMf6oWQI2uoF1iKGx6W-0	\N	\N	\N
22b351ab-7db8-4c96-b3fd-39a72c4a48fb	http://pyhedj.myopenid.com/	ca940e2e-8777-47ef-8079-04f7d72068c3	2012-04-19 17:29:32.56401		http://pyhedj.myopenid.com/	\N	pyhedj	pyhedj+myopenid@gmail.com
5bbe5968-47df-4c04-9f37-f61751986905	https://arthur.lutz.im/	1d99dfcf-63a2-40f7-9fe8-03a4c8393cbb	2012-04-25 10:39:52.326804	\N	https://arthur.lutz.im/	\N	Arthur Lutz	arthur.lutz@gmail.com
9af4694a-63d4-4ff3-8767-0e275372b603	https://www.google.com/accounts/o8/id?id=AItOawkqg5AwCPNZ9wRXFrs08Mx9ZlUlJc02Bpc	90927191-ff69-4f56-b4ef-00c63a7e7b20	2012-05-23 14:52:02.786171		https://www.google.com/accounts/o8/id?id=AItOawkqg5AwCPNZ9wRXFrs08Mx9ZlUlJc02Bpc	\N	Mathieu	kourtois@gmail.com
a524ea3d-064f-4141-a5f5-9e3e615c1744	https://www.google.com/accounts/o8/id?id=AItOawkIHp1eJRN9nS1SsYiS48tTLY8LKk_TV9E	ecadb57a-3eb8-4519-be5d-f7f6f474338b	2012-05-28 18:51:27.327977	\N	https://www.google.com/accounts/o8/id?id=AItOawkIHp1eJRN9nS1SsYiS48tTLY8LKk_TV9E	\N	\N	\N
69518980-63f7-4b53-a063-320532697987	https://www.google.com/accounts/o8/id?id=AItOawl2h-TMm8FkC-MrhOFrERUn_0vQo9OOzck	193483f1-8932-42db-9c1c-31de5fa7a7a7	2012-05-31 01:59:22.341066		https://www.google.com/accounts/o8/id?id=AItOawl2h-TMm8FkC-MrhOFrERUn_0vQo9OOzck	\N	loïc	
8dd12586-1b21-4448-b621-2f26e199bb10	https://www.google.com/accounts/o8/id?id=AItOawnjxuzTSOjfzKYn5kr57IvtH52uImDC5rw	09c0d4d4-5c88-48cb-90c8-b1b45439d9b3	2012-06-18 16:55:05.841236	\N	https://www.google.com/accounts/o8/id?id=AItOawnjxuzTSOjfzKYn5kr57IvtH52uImDC5rw	\N	\N	\N
82489dc6-5082-4f9c-8bf5-4528c217ac1a	https://www.google.com/accounts/o8/id?id=AItOawlNfJULNrroHOtL8o2h8JpyWDNE_YEYv_0	60a06ea3-a51b-4843-8433-d3211ec0dd82	2012-09-19 11:48:48.729186	\N	https://www.google.com/accounts/o8/id?id=AItOawlNfJULNrroHOtL8o2h8JpyWDNE_YEYv_0	\N	\N	\N
\.


--
-- Data for Name: user_object_role; Type: TABLE DATA; Schema: public; Owner: ckantest
--

COPY user_object_role (id, user_id, authorized_group_id, context, role) FROM stdin;
6a2643d1-d69c-4c97-b8b8-a1352b713912	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	System	reader
fd079565-fb40-4bd5-82c3-8f0984c652a1	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	System	editor
598e779b-759b-42fc-8924-33f7592c9600	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
ff24fa50-de23-4f18-a03b-a4fa1b64e6f7	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
c2ff8eb6-fc11-4403-85ec-178e8f55f1da	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
d76bd78b-7efb-477e-8c60-d505370ff781	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
7dd1da41-6e7a-4ace-b504-598bc92601eb	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
49f647ca-2fd9-483c-b677-1b629b44b6ce	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
340e7e82-f25e-4dc0-9cfc-c977042c4944	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
61993bcb-7124-4620-843b-a53da69cabc0	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
c9f5922c-29fe-4923-9ac1-9cd5503dab84	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
6bd66cf4-b714-460c-9994-524224205739	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
ed21c306-305d-4556-8d64-42045a3ddd27	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
61e6691b-879d-4a26-bc8b-5d516e4e5921	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
0fd97672-0b59-4574-b22a-1a53e5518ee6	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
9ef8994a-87a7-49f3-8ef5-714f0d6c4c9e	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
29bf7fbb-43fc-467d-9baa-df9c5b474ccd	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
b6ca7202-fe64-43b7-92d1-80b0dd1751c9	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
5fa640da-17eb-4c73-a007-0740ec880842	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
3d85a6ff-7bf8-4d1c-958c-200b20d7ac2a	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
40e448df-8ff4-4cd1-98e6-128586842f11	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
c9844b00-38e1-41ea-b9e9-e2e418706a42	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
867e9b3c-ff6e-4542-80c0-92589b700a69	376b5095-1554-4017-ad2d-2dc6a5471a4f	\N	Package	admin
c028b37f-d404-4526-988a-8b00a45a5c01	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
8a7a24e9-22f0-499e-bb0b-9bc7b21f6181	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
4fe50cec-967a-4db8-8910-77a7b76766be	85c45de1-ea32-46c3-b737-c22b5351f523	\N	Package	admin
015f0bb5-8075-42b2-91b9-2070a401ac8f	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
93ab98fc-fd23-4b34-8734-fb57d2663274	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
a2e1ad93-b436-4181-b9f1-80a510410105	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
067b184f-b089-42e4-bba0-af4a18e4fd87	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
5c0955e7-beea-412d-b412-e5e4b7b4caa5	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
647b5cfa-96a1-4012-ab92-2a9e5a396d9a	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
fd3f7aa8-8148-4ac8-9615-0ad9102012bb	bde1f833-bd6e-4d15-99ef-790062a28a01	\N	Package	admin
c819c4e3-28e1-4e49-a35d-e16d1a2bf479	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
4f217ee0-cbf7-46ad-ae9f-b51f70cd7cc0	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
620d12ca-35ca-4ef9-9236-53839ae79509	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
ec610b89-0b09-4b3b-865e-0e403e881414	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
bf30030b-e1d0-4ee0-a3ac-5c02d9f3f8a3	bb4ee2e5-b33c-4b71-b698-d582b4cf8277	\N	Package	admin
463c1f22-dcef-4f88-af9e-6146889ece0c	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
c482eebd-bdb4-4b3e-88e7-33241c33ae23	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
0a6b9951-4ebb-48f9-91a5-0168401c86b2	bb4ee2e5-b33c-4b71-b698-d582b4cf8277	\N	Package	admin
be67cc57-1145-4f67-a174-40e1d5fb2e1c	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
6ae317ea-8123-413e-a52d-316eb406bb6d	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
a06d76ca-7747-4e42-944a-8c3319b16074	bb4ee2e5-b33c-4b71-b698-d582b4cf8277	\N	Package	admin
0ceef28a-eca5-4df7-bc9f-af6d57579cc7	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
b3766e5a-94ca-4e05-ae49-7d1f1cabc4c6	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
664c5312-7207-42fb-8403-2bcbe83779e5	bb4ee2e5-b33c-4b71-b698-d582b4cf8277	\N	Package	admin
4f2a1638-ffb1-4305-baa8-f27a53d12661	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
e62af199-e3af-4e34-9117-0db336b918d6	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
744721a9-7e44-4683-a600-99362a68a44b	266c0a99-1253-4081-a9ed-a4aa027b58fe	\N	Package	admin
9a5b2e63-a320-4ab1-977c-9c21659b7e89	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
3c4da846-93f3-4324-9848-c8c9733b7045	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
c879d153-36d1-454e-bb64-61ccb190ef4b	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
5c1541a2-1efc-4c64-94a1-5bbdd9701417	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
7edf0268-981c-4a3d-a81e-50b0af2255a2	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
b8eee993-7bf0-413a-a2d1-09908fc5e0d8	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
dab93e14-fa2b-4424-b9f0-65576ddc9614	a8593e73-81e1-40f7-b53a-e21e2f1a8a6f	\N	Package	admin
67cf321d-e74f-4012-867e-225837a9f5d6	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
e90d3919-95d4-4f66-9c2e-6beefca1a54f	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
08442e90-4240-44c4-85a1-83b53f4fd357	bde1f833-bd6e-4d15-99ef-790062a28a01	\N	Package	admin
67842479-cd88-4c48-9e1c-704b5f33b902	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
da51e49b-70a5-4f47-a398-b7f67f81b727	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
bf1cf1f5-e40c-4d71-a98e-305764b2eb95	bde1f833-bd6e-4d15-99ef-790062a28a01	\N	Package	admin
200c6ed7-0084-441c-b191-feacdd9fdcef	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
2157f13a-0e15-4bd9-b044-0bfe8a653300	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
15b23ed9-81dd-4886-9158-1e929818d8e2	bde1f833-bd6e-4d15-99ef-790062a28a01	\N	Package	admin
4d95b21b-ca54-4f0c-8395-a44a42d78592	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
2c7518d7-ba29-4303-a00d-72d9328969fc	817b567c-9308-4872-9d87-0e952106abd4	\N	Package	admin
6fd9cc14-b617-446d-a336-647def9514ca	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	reader
9852d952-8280-4358-820e-afce9bb306d5	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
4501832e-1121-4f7c-b3e8-31e3f2b0d54e	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
6dea6ba7-de99-456f-9895-d21981075027	817b567c-9308-4872-9d87-0e952106abd4	\N	Package	admin
674d5e58-db09-4262-ad03-c2e8865f883a	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
921a8a1b-a863-4232-b6ed-470879b66916	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
c474ea91-0b8f-454b-9e96-b6f7d90a055c	aaa193bb-8f0f-49b0-92a8-2686cb6475f2	\N	Package	admin
54620246-a52c-47aa-8e7b-ef586d81629b	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
b72c8e85-5575-4921-b0bd-89e7ed53d5d9	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
eff7ace7-7fb0-4cfa-88a5-2fe8a8bacd5f	aaa193bb-8f0f-49b0-92a8-2686cb6475f2	\N	Package	admin
36f7a472-805d-442c-97c2-0b6803573a2f	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
f9ad8797-8293-4eb7-a32f-2606e503af04	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
ef800461-3486-450d-8b4d-defc5c64824a	aaa193bb-8f0f-49b0-92a8-2686cb6475f2	\N	Package	admin
4ee475c0-e956-4b15-8849-cfee166c128b	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
b6b8772d-ec63-4e12-92ab-f7f8a981a788	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
94da7a8e-caa4-486a-a662-5b49fbc4cd8b	aaa193bb-8f0f-49b0-92a8-2686cb6475f2	\N	Package	admin
bd90d607-2a07-46a8-8665-28d6f7dedd17	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
a12541a9-e2c1-4132-9320-b0a14383c285	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
8dd49f0e-420a-477b-afaa-cea7b37bd9df	aaa193bb-8f0f-49b0-92a8-2686cb6475f2	\N	Package	admin
f40cdfca-78d7-4e7e-b8c0-8f3a0879919c	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
56dbc200-297f-4c86-ad88-8f5713abb996	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
5148f322-5c34-40c7-a2a6-cb1dcef354f6	aaa193bb-8f0f-49b0-92a8-2686cb6475f2	\N	Package	admin
0a67db4c-c0ff-4f0f-bcde-a9ba5a9dd5ed	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
82110757-2e86-4bce-8fbb-1f901ec4d550	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
5a8fffbb-7139-4308-b922-05509f5e1bf8	bb4ee2e5-b33c-4b71-b698-d582b4cf8277	\N	Package	admin
5311ba9d-fa7a-436c-8a58-9d79ee1cac54	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
97310ca4-516c-41cb-be59-2ccd5eb6bfe8	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
4322b7e7-7882-4a8d-9b3a-2f4ffb5a558a	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
10fa5ccc-1e25-437e-9d16-1f0e3651a552	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
f4ff656c-a6a6-4b4f-9b31-15ea0263fa9c	9e0b6515-eebf-4863-ad75-d128cf513e40	\N	Package	admin
f9b38171-3190-4c09-997b-84f722145c8e	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
121c9cc0-a6a1-49ea-b2b4-0e432e6232ae	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
b035ada2-0f8e-481c-ba30-e04a341e136a	9e0b6515-eebf-4863-ad75-d128cf513e40	\N	Package	admin
bfc84183-87b2-46a5-80ed-a0b39f68d639	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
aeaa0b88-77a9-41da-95e4-c74741901e98	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
d7e92ed2-6c69-4790-a01a-398f993851f4	9e0b6515-eebf-4863-ad75-d128cf513e40	\N	Package	admin
7651cef1-6277-4822-9e06-19b4ec098d8b	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
d041f12f-d86a-4a2b-a829-29fe1157c19f	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
c4551fb7-6812-4f2d-bdf7-0bcea78f4265	9e0b6515-eebf-4863-ad75-d128cf513e40	\N	Package	admin
d02a1f1b-d6c5-4253-9090-05ac3e6b3822	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
0b93d391-05df-4440-9bd1-524a53879f54	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
284efe6e-4319-483c-804f-ec15f51fccf6	9e0b6515-eebf-4863-ad75-d128cf513e40	\N	Package	admin
a7eae6a4-4dc7-447c-9f61-d181d3c5c42d	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
54a89d58-28e9-4cc9-9ffc-7ecef32015d3	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
9e1b35b6-5993-4fd5-9c9e-db7da2864713	9e0b6515-eebf-4863-ad75-d128cf513e40	\N	Package	admin
5d233493-33ec-4cf1-9435-ac1d13f55e3b	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
b71441ec-b1ee-4deb-a821-8ca2ecdd07b0	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
28cd32f0-c1cc-4920-808c-a61d2bb93a29	9e0b6515-eebf-4863-ad75-d128cf513e40	\N	Package	admin
d4d961b4-557f-4106-bc87-af7e0a68890b	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
854488cb-5bdc-4e8c-8f53-99acec7e150b	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
8b63fa86-682f-48fa-8645-37a97bd3b80f	9e0b6515-eebf-4863-ad75-d128cf513e40	\N	Package	admin
dfa00fe8-a74c-4539-9da4-ac3a97f2afbb	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
3d20faa2-671b-4d7d-a23c-c84019ceaf2a	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
67edc37c-c66e-4b62-b5fd-3e7d2dfc8afc	9e0b6515-eebf-4863-ad75-d128cf513e40	\N	Package	admin
110ad223-42de-4c3a-89b2-4bba2372d5f6	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
efb59a3a-82f4-49a6-9869-47dcfc09df60	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
58949068-acaa-446b-9254-e65ac6c5db3b	9e0b6515-eebf-4863-ad75-d128cf513e40	\N	Package	admin
1cc7ffdf-013d-4038-a1d7-74571f174754	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
4fb7e2a1-d9c7-43a8-98e8-1c433b8130d3	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
e3d960fd-4cbf-4d23-9201-0f845e6d8454	9e0b6515-eebf-4863-ad75-d128cf513e40	\N	Package	admin
384ef8fb-0e06-4169-9596-9530c06282b1	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
73683cb8-043e-4cfe-b68a-ab5ed7c06389	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
218939d2-7006-4b3c-a26c-134db75904e1	9e0b6515-eebf-4863-ad75-d128cf513e40	\N	Package	admin
30e733eb-6d9a-4d7a-b423-007b0fe09c7b	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
8a7058d7-2698-46fc-a060-a6af3308c7ca	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
cc1c1e3e-65e9-4d51-a348-36764337cd0e	9e0b6515-eebf-4863-ad75-d128cf513e40	\N	Package	admin
f9178672-95de-49a5-9ab1-4e4b96aab9b9	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
54b4e543-01d4-4a40-9669-bc1e07ac6536	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
6f821f2c-a18c-4964-8bc2-312070de0d8a	9e0b6515-eebf-4863-ad75-d128cf513e40	\N	Package	admin
95c3f6b3-2713-43f3-bb54-dba3ed57df3b	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
92687892-b808-42b7-8eb7-0cfab7a222e6	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
35d136b0-b203-4473-a22d-51af1c7709c9	9e0b6515-eebf-4863-ad75-d128cf513e40	\N	Package	admin
2e96c1d4-1a80-4565-844e-dab995783d67	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
4667f249-e65d-4eff-927f-93d267483891	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
e4c42f7b-9bf3-4719-9e99-0dfb1f2608a4	9e0b6515-eebf-4863-ad75-d128cf513e40	\N	Package	admin
dbaf33ba-3717-4dd1-ac35-fce958355dfb	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
f7dd5400-a446-4dc8-8e9e-965e3825a2e6	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
6eaa8bf4-079e-40ae-94d8-071b19abb6b6	9e0b6515-eebf-4863-ad75-d128cf513e40	\N	Package	admin
769e3b05-bef4-4556-ac79-963350241541	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
8ea4b134-6213-4442-aa2b-da13c3942ff4	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
a64f3232-0aa4-4cc8-8716-5340635fad7d	9e0b6515-eebf-4863-ad75-d128cf513e40	\N	Package	admin
c6b78f77-ce9c-47bc-9925-7885d2b93325	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
403cb1da-9024-420b-b097-d6266482fddc	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
f4989df6-6b62-40d0-9966-dd37a1fedbf8	9e0b6515-eebf-4863-ad75-d128cf513e40	\N	Package	admin
042723a9-2e7d-4e46-9b17-aec9cf018fce	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
326db9ba-8729-465e-b657-dab6f29bd2f3	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
117df479-11f9-429b-8abe-497be19b8658	9e0b6515-eebf-4863-ad75-d128cf513e40	\N	Package	admin
d97e2acd-6473-487b-bcb9-c84072e1af58	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
6c73a23d-cbc9-40fb-9eea-ee9625a92790	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
ba031fe1-d517-42b9-8ff9-c8790b45192f	9e0b6515-eebf-4863-ad75-d128cf513e40	\N	Package	admin
932d330f-14e0-4d57-b112-92b39a797182	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
2abd977e-a5aa-4516-91d5-dd94d91b5e42	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
1b144d89-fa6a-47b0-a3b6-57171458b0ec	9e0b6515-eebf-4863-ad75-d128cf513e40	\N	Package	admin
6a096396-1d57-459f-b857-846624ecbc38	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
fc90efba-172c-43fd-b16d-f8da94cb971f	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
373ef38c-f10b-41f6-b8ee-6573c2c48f92	9e0b6515-eebf-4863-ad75-d128cf513e40	\N	Package	admin
93d3f724-f8e3-4c96-ae52-2a519e1d533a	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
b67f0c5e-891b-4728-b9cb-8f9d63b246cf	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
6643203f-a170-411a-a28e-74727492333f	9e0b6515-eebf-4863-ad75-d128cf513e40	\N	Package	admin
a2de6d65-7273-47bd-b3f7-997ea4034fc3	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
f0ee8f98-8321-4292-9946-0859de70b50a	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
2e29335c-319b-4766-9929-8e4f8e7be607	9e0b6515-eebf-4863-ad75-d128cf513e40	\N	Package	admin
46645d32-e903-4dee-a1fd-0cd0a4a10e22	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
bfaa3b71-75d1-41c5-bb33-a209c5cba7e0	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
225270b5-bb32-4c66-a8c0-ecda578fdc4a	9e0b6515-eebf-4863-ad75-d128cf513e40	\N	Package	admin
20623454-dbcb-4f93-8e20-0dac9ddeb6d7	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
b3a676f6-e7ef-4ac2-90f4-5a0274e2a502	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
08155421-4582-4d82-84d1-9d4c3d9a7bb9	9e0b6515-eebf-4863-ad75-d128cf513e40	\N	Package	admin
64f530a8-d10c-48e2-9afd-a8ac525a01c7	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
b74dcfa0-aaf8-4f66-8d0b-b8e53669b8c4	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
b76a5b36-9fd2-4854-a7ed-3e65bc027484	9e0b6515-eebf-4863-ad75-d128cf513e40	\N	Package	admin
a0ca310b-727d-42dd-9e42-48fc2498a9eb	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
3cdc2c3c-43a8-485b-a1a5-feadb5683897	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
4f4f551e-8a87-44af-84bd-5e104509101b	9e0b6515-eebf-4863-ad75-d128cf513e40	\N	Package	admin
be0a2595-2d4a-4944-bb54-e04b764efd46	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
9d88f7da-7e1f-445a-bab8-bb36800500be	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
08c02fcd-170e-442e-9819-363a5109c5bb	9e0b6515-eebf-4863-ad75-d128cf513e40	\N	Package	admin
a9042a61-7e7e-4577-b205-47979823c62c	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
fd06e690-051c-4a1d-b82d-0d669da71798	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
b0ec3074-076a-4c45-b18d-229edc447917	9e0b6515-eebf-4863-ad75-d128cf513e40	\N	Package	admin
7b8008a7-17f9-4d8f-a9ca-f5cd29334513	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
5592aee3-ef57-489e-afb9-530c7923c519	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
e74ee73c-8434-4a82-8507-5ceb85068291	9e0b6515-eebf-4863-ad75-d128cf513e40	\N	Package	admin
10c3eb2c-d840-4242-b842-edacb4b55013	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
74ed1c1b-2d0e-4c9e-b7bd-6240f64a180e	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
9c01953f-6c9f-41ad-b7c3-b6bda1b96a64	9e0b6515-eebf-4863-ad75-d128cf513e40	\N	Package	admin
31d7f324-bd98-4340-a33f-ef2eb0963d93	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
2606fe96-c57c-42d3-9acf-ce2c60d8375e	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
9fac9e7c-e96a-41e7-8524-02c3da31f718	9e0b6515-eebf-4863-ad75-d128cf513e40	\N	Package	admin
485a1f74-8268-43ac-b86a-d58de52aeedf	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
00be2cdd-8c76-4e6b-85e5-1fbddac9fe7b	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
08ca8d35-cac6-46d0-91c4-1a3228830fc9	9e0b6515-eebf-4863-ad75-d128cf513e40	\N	Package	admin
1f257a96-a580-4af9-93ba-73773feb3e73	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
5f864fa8-1733-4e44-8235-385c84bedc8f	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
050864f3-e9a1-4587-a74a-6893b049a4b3	fbebb85b-8d29-4511-a23d-ca6c0f2edddd	\N	Package	admin
80c87b7c-3ba7-4ca2-9f94-c17c9869d3df	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
0bad4781-09f6-4e76-85d6-593996489baf	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
ac93483e-3fda-43b0-826e-92dd53a2739b	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
e4230feb-1cdf-414b-9165-3f95740a40aa	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
e5ce8bc1-615b-4be5-bd10-e382d6fc4f5a	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
863f7bbd-a7bf-41e5-b598-98ac8b50b0f3	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
09e81d92-eb13-4a8a-a2ae-01918c7ae72c	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
1283f28b-d12e-428e-b8cc-aae17fb64c1a	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
74cb413e-a9e5-4bb4-839a-e1892d6a5ac7	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
3aab5747-d006-4c05-8bdc-d1d4e01c6bc9	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
448adb89-8795-46d6-9bef-649f1db75fa9	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
d52959e6-971e-482e-97d0-34a832e968bd	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
03bd6a35-5945-4268-8821-22fc12d26d17	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
13fae940-beb6-4837-bb34-e1d30aa6db25	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
16ff5be4-c197-4e38-9d20-773eb3e1d9f6	fbebb85b-8d29-4511-a23d-ca6c0f2edddd	\N	Package	admin
c77cb4fa-826a-4d8a-8922-8868081ffde4	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
02fad430-cc4b-4fad-8b07-f0289cb5f06c	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
8c99c6db-a9c2-4cfc-8758-b5797aafd4b9	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
6d17cd75-3b06-457f-a778-54ee050be956	960b876a-86f6-428c-af44-0d4684f245e7	\N	Package	admin
beb106fd-ddd7-4d5d-a924-d037e30e96cf	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	reader
ce95950f-c183-4210-a573-4d3760d9d153	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
3b8fd299-262d-4fdd-a2a8-8a410530634f	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
f4d8b93b-3f28-4935-b921-8f49b20a27a3	960b876a-86f6-428c-af44-0d4684f245e7	\N	Package	admin
bdbb9d7b-f2f8-42f0-a9db-8cf4f9b1b44f	eeb01a7b-ae75-4d97-b8e0-d071bb042736	\N	Package	admin
c8f8bec4-532b-43e2-995e-c0f433d95eab	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	reader
cfa57c66-474f-4759-ac07-37d17e3acda8	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	reader
2d4f4d0f-4319-42cb-b696-6546a4e2a625	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
973b4f98-2c29-45de-9701-653e9d6ee179	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
eed7a8ea-ac54-497e-a73e-6f752d2412bd	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
b9a88e31-c2c0-47d8-9f23-d0cdbc8b4793	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
b454f8cd-a214-4a35-8818-82037135a5ea	a8593e73-81e1-40f7-b53a-e21e2f1a8a6f	\N	Package	admin
aaca196c-9cbf-401a-881a-005334d9fab6	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
f0f042ba-6221-4cc1-9730-72bf0406fd62	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
30f73203-5002-447c-8572-41ea60c890c4	9e0b6515-eebf-4863-ad75-d128cf513e40	\N	Package	admin
fccdccb6-917a-4387-b41c-07e1dcbe911e	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
9a9094cd-d11a-4cbb-950b-7d252cf4f639	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
7550ec28-5563-418d-949d-90b70feb1491	960b876a-86f6-428c-af44-0d4684f245e7	\N	Package	admin
bad36cda-20c4-4339-a71e-f2c5a6f6e9d3	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
4304a050-1181-4d40-8598-dbc85c163774	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
bdc64f09-a076-4115-85cd-7562efcd59cb	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
4ffb9935-1fcc-407b-b52c-7eec9f5ed0d5	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
49068403-524d-490a-9f51-1966b12942a2	9c93b7e2-ec2f-4320-8230-c10ca09b4c3e	\N	Package	admin
5d68a284-2925-41f2-b381-d0c4bc4a2089	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
a2d99710-1c58-4c35-9ef3-bbbb5c26adb4	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
ed25dbeb-798a-4bee-ab50-13a4cf147f4a	9c93b7e2-ec2f-4320-8230-c10ca09b4c3e	\N	Package	admin
9ffc6d49-6649-4f14-8267-077847eb8cfa	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
e5a13f60-3203-41b5-b62b-9a0b5528658f	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
9159b067-e606-44e5-b958-32710a597004	9c93b7e2-ec2f-4320-8230-c10ca09b4c3e	\N	Package	admin
730a51fa-2304-45cd-8012-ac5e996a7a45	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
6f7c5cb2-03a5-4fd8-9292-105ce9ea485d	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
6de101bf-3bce-415b-9e35-d0029822be6c	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
fb2d5b44-d838-46b5-94b8-65d197bb7782	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
1ae4042c-a987-43bf-84bc-84b2d70756a6	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
7b880bbe-e3ed-4ef1-87e9-6556c290eafc	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
a72dcfa7-88ba-499d-9d28-7bace5475931	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
16101ce3-5848-4ef5-869f-6f459984b30e	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
48830b74-9ab8-4ff9-bd9b-95f6ad16f794	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
aa05bf22-4f07-491b-a13f-90a71d7b4644	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
ac9e7515-5970-40f6-b9cc-0420e72402b2	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
0fe156d9-497b-4fe9-b8b3-4b0fe90acfef	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
6b63bc93-8c29-4e46-8f02-b4957083a788	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
8969f5f6-707f-4127-a617-39d0f13279a7	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
a2cd31ab-a38f-40a5-87e7-330b3456f8e0	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
c908304c-105e-40e4-a888-1c5c9ec6541b	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
c099caac-e4b7-494e-805c-8e5b3e5c6066	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
9a6bcc9b-2d8b-4472-a157-6dc068b4b1b5	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
004ebeda-aa69-43d8-8ff6-9bb12a699988	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
dcc76883-5823-4120-bda1-c616d71da3c2	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
b221cae7-ef89-4e81-851c-aee64177d4a2	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
e0d7134a-1053-4b12-b573-effdb0e31ead	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
88668e03-45df-40df-8764-41e57a90bf63	0b874efd-80d3-4375-92b9-4090f5141207	\N	Package	admin
2f9822bb-f121-4c65-8b65-bea868e083d4	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
efe274fb-3317-4b6e-88cb-aaf6d4deb3ac	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
aea2d180-0441-470b-90ed-319f63f61562	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
71a51cf7-a1ff-4fd6-9a17-3096cd3b1828	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
ab843a02-a81c-443b-bdcf-ba5d27c67ff3	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
9b1e5c22-4782-45e4-9ee6-bfaacd56b31c	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
9ce0226f-0e45-4b5e-9746-458c0db29943	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
21dc43ec-18fa-47b6-9e3c-e7c02e2c51be	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
bb3b1ddf-b3d9-4eab-8c0a-32c3d449b056	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
2f38331a-21fe-4d0d-b6bd-8c7377f2243c	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
dbe90aaf-b073-46b1-8c1b-5c4d077886f1	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
ae6e10e2-2376-4e6b-9755-4e9f63513f51	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
85ced8db-0084-4c61-b168-c0f13e767ff3	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
86264885-907a-4188-a99c-756343d3f773	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
61ed6d84-096e-4755-b2ab-3104f9e8ce0d	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
660fb05d-2d4d-43a2-84db-5ffb92cce3ae	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
3e33b1ef-2c96-43a2-afc7-2d7322857950	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
37e4f178-b76a-4883-a3f0-510e24047ade	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
85caae33-4a9d-40e7-8d8d-d9451304fe27	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
3bcf9467-08b4-4609-bc77-90f43e9662be	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
70bbfe1f-9457-4c83-9d3a-fdd29be2ea5f	9e0b6515-eebf-4863-ad75-d128cf513e40	\N	Package	admin
1434ff18-7624-41d6-ac83-4b3d973044ce	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
3ede5f17-4f16-4eed-bc0e-3e67acc8a856	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
2993089d-4451-424e-9982-6715cf11648d	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
eb1c11f9-608d-4758-a193-815a8db3ccf4	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
d389ba0a-46a9-472c-b65f-8a514c27083a	6992eb2a-baf3-4eec-b1fc-2d1df9b76368	\N	Package	editor
0bf12777-7392-4cc3-8736-4ece7f24701f	3851105e-cfcf-45bd-b568-5f1ff4671ec0	\N	Package	editor
\.


--
-- Name: authorization_group_pkey; Type: CONSTRAINT; Schema: public; Owner: ckantest; Tablespace: 
--

ALTER TABLE ONLY authorization_group
    ADD CONSTRAINT authorization_group_pkey PRIMARY KEY (id);


--
-- Name: authorization_group_role_pkey; Type: CONSTRAINT; Schema: public; Owner: ckantest; Tablespace: 
--

ALTER TABLE ONLY authorization_group_role
    ADD CONSTRAINT authorization_group_role_pkey PRIMARY KEY (user_object_role_id);


--
-- Name: authorization_group_user_pkey; Type: CONSTRAINT; Schema: public; Owner: ckantest; Tablespace: 
--

ALTER TABLE ONLY authorization_group_user
    ADD CONSTRAINT authorization_group_user_pkey PRIMARY KEY (id);


--
-- Name: changemask_pkey; Type: CONSTRAINT; Schema: public; Owner: ckantest; Tablespace: 
--

ALTER TABLE ONLY changemask
    ADD CONSTRAINT changemask_pkey PRIMARY KEY (ref);


--
-- Name: changeset_pkey; Type: CONSTRAINT; Schema: public; Owner: ckantest; Tablespace: 
--

ALTER TABLE ONLY changeset
    ADD CONSTRAINT changeset_pkey PRIMARY KEY (id);


--
-- Name: group_extra_pkey; Type: CONSTRAINT; Schema: public; Owner: ckantest; Tablespace: 
--

ALTER TABLE ONLY group_extra
    ADD CONSTRAINT group_extra_pkey PRIMARY KEY (id);


--
-- Name: group_extra_revision_pkey; Type: CONSTRAINT; Schema: public; Owner: ckantest; Tablespace: 
--

ALTER TABLE ONLY group_extra_revision
    ADD CONSTRAINT group_extra_revision_pkey PRIMARY KEY (id);


--
-- Name: group_name_key; Type: CONSTRAINT; Schema: public; Owner: ckantest; Tablespace: 
--

ALTER TABLE ONLY "group"
    ADD CONSTRAINT group_name_key UNIQUE (name);


--
-- Name: group_pkey; Type: CONSTRAINT; Schema: public; Owner: ckantest; Tablespace: 
--

ALTER TABLE ONLY "group"
    ADD CONSTRAINT group_pkey PRIMARY KEY (id);


--
-- Name: group_revision_name_key; Type: CONSTRAINT; Schema: public; Owner: ckantest; Tablespace: 
--

ALTER TABLE ONLY group_revision
    ADD CONSTRAINT group_revision_name_key UNIQUE (name);


--
-- Name: group_revision_pkey; Type: CONSTRAINT; Schema: public; Owner: ckantest; Tablespace: 
--

ALTER TABLE ONLY group_revision
    ADD CONSTRAINT group_revision_pkey PRIMARY KEY (id);


--
-- Name: group_role_pkey; Type: CONSTRAINT; Schema: public; Owner: ckantest; Tablespace: 
--

ALTER TABLE ONLY group_role
    ADD CONSTRAINT group_role_pkey PRIMARY KEY (user_object_role_id);


--
-- Name: harvest_source_pkey; Type: CONSTRAINT; Schema: public; Owner: ckantest; Tablespace: 
--

ALTER TABLE ONLY harvest_source
    ADD CONSTRAINT harvest_source_pkey PRIMARY KEY (id);


--
-- Name: harvest_source_url_key; Type: CONSTRAINT; Schema: public; Owner: ckantest; Tablespace: 
--

ALTER TABLE ONLY harvest_source
    ADD CONSTRAINT harvest_source_url_key UNIQUE (url);


--
-- Name: harvested_document_pkey; Type: CONSTRAINT; Schema: public; Owner: ckantest; Tablespace: 
--

ALTER TABLE ONLY harvested_document
    ADD CONSTRAINT harvested_document_pkey PRIMARY KEY (id);


--
-- Name: harvesting_job_pkey; Type: CONSTRAINT; Schema: public; Owner: ckantest; Tablespace: 
--

ALTER TABLE ONLY harvesting_job
    ADD CONSTRAINT harvesting_job_pkey PRIMARY KEY (id);


--
-- Name: migrate_version_pkey; Type: CONSTRAINT; Schema: public; Owner: ckantest; Tablespace: 
--

ALTER TABLE ONLY migrate_version
    ADD CONSTRAINT migrate_version_pkey PRIMARY KEY (repository_id);


--
-- Name: package_extra_pkey; Type: CONSTRAINT; Schema: public; Owner: ckantest; Tablespace: 
--

ALTER TABLE ONLY package_extra
    ADD CONSTRAINT package_extra_pkey PRIMARY KEY (id);


--
-- Name: package_extra_revision_pkey; Type: CONSTRAINT; Schema: public; Owner: ckantest; Tablespace: 
--

ALTER TABLE ONLY package_extra_revision
    ADD CONSTRAINT package_extra_revision_pkey PRIMARY KEY (id, revision_id);


--
-- Name: package_group_pkey; Type: CONSTRAINT; Schema: public; Owner: ckantest; Tablespace: 
--

ALTER TABLE ONLY package_group
    ADD CONSTRAINT package_group_pkey PRIMARY KEY (id);


--
-- Name: package_group_revision_pkey; Type: CONSTRAINT; Schema: public; Owner: ckantest; Tablespace: 
--

ALTER TABLE ONLY package_group_revision
    ADD CONSTRAINT package_group_revision_pkey PRIMARY KEY (id);


--
-- Name: package_name_key; Type: CONSTRAINT; Schema: public; Owner: ckantest; Tablespace: 
--

ALTER TABLE ONLY package
    ADD CONSTRAINT package_name_key UNIQUE (name);


--
-- Name: package_pkey; Type: CONSTRAINT; Schema: public; Owner: ckantest; Tablespace: 
--

ALTER TABLE ONLY package
    ADD CONSTRAINT package_pkey PRIMARY KEY (id);


--
-- Name: package_relationship_pkey; Type: CONSTRAINT; Schema: public; Owner: ckantest; Tablespace: 
--

ALTER TABLE ONLY package_relationship
    ADD CONSTRAINT package_relationship_pkey PRIMARY KEY (id);


--
-- Name: package_relationship_revision_pkey; Type: CONSTRAINT; Schema: public; Owner: ckantest; Tablespace: 
--

ALTER TABLE ONLY package_relationship_revision
    ADD CONSTRAINT package_relationship_revision_pkey PRIMARY KEY (id, revision_id);


--
-- Name: package_resource_pkey; Type: CONSTRAINT; Schema: public; Owner: ckantest; Tablespace: 
--

ALTER TABLE ONLY package_resource
    ADD CONSTRAINT package_resource_pkey PRIMARY KEY (id);


--
-- Name: package_resource_revision_pkey; Type: CONSTRAINT; Schema: public; Owner: ckantest; Tablespace: 
--

ALTER TABLE ONLY package_resource_revision
    ADD CONSTRAINT package_resource_revision_pkey PRIMARY KEY (id, revision_id);


--
-- Name: package_revision_pkey; Type: CONSTRAINT; Schema: public; Owner: ckantest; Tablespace: 
--

ALTER TABLE ONLY package_revision
    ADD CONSTRAINT package_revision_pkey PRIMARY KEY (id, revision_id);


--
-- Name: package_role_pkey; Type: CONSTRAINT; Schema: public; Owner: ckantest; Tablespace: 
--

ALTER TABLE ONLY package_role
    ADD CONSTRAINT package_role_pkey PRIMARY KEY (user_object_role_id);


--
-- Name: package_search_pkey; Type: CONSTRAINT; Schema: public; Owner: ckantest; Tablespace: 
--

ALTER TABLE ONLY package_search
    ADD CONSTRAINT package_search_pkey PRIMARY KEY (package_id);


--
-- Name: package_tag_pkey; Type: CONSTRAINT; Schema: public; Owner: ckantest; Tablespace: 
--

ALTER TABLE ONLY package_tag
    ADD CONSTRAINT package_tag_pkey PRIMARY KEY (id);


--
-- Name: package_tag_revision_pkey; Type: CONSTRAINT; Schema: public; Owner: ckantest; Tablespace: 
--

ALTER TABLE ONLY package_tag_revision
    ADD CONSTRAINT package_tag_revision_pkey PRIMARY KEY (id, revision_id);


--
-- Name: rating_pkey; Type: CONSTRAINT; Schema: public; Owner: ckantest; Tablespace: 
--

ALTER TABLE ONLY rating
    ADD CONSTRAINT rating_pkey PRIMARY KEY (id);


--
-- Name: revision_pkey; Type: CONSTRAINT; Schema: public; Owner: ckantest; Tablespace: 
--

ALTER TABLE ONLY revision
    ADD CONSTRAINT revision_pkey PRIMARY KEY (id);


--
-- Name: role_action_pkey; Type: CONSTRAINT; Schema: public; Owner: ckantest; Tablespace: 
--

ALTER TABLE ONLY role_action
    ADD CONSTRAINT role_action_pkey PRIMARY KEY (id);


--
-- Name: system_role_pkey; Type: CONSTRAINT; Schema: public; Owner: ckantest; Tablespace: 
--

ALTER TABLE ONLY system_role
    ADD CONSTRAINT system_role_pkey PRIMARY KEY (user_object_role_id);


--
-- Name: tag_name_key; Type: CONSTRAINT; Schema: public; Owner: ckantest; Tablespace: 
--

ALTER TABLE ONLY tag
    ADD CONSTRAINT tag_name_key UNIQUE (name);


--
-- Name: tag_pkey; Type: CONSTRAINT; Schema: public; Owner: ckantest; Tablespace: 
--

ALTER TABLE ONLY tag
    ADD CONSTRAINT tag_pkey PRIMARY KEY (id);


--
-- Name: user_object_role_pkey; Type: CONSTRAINT; Schema: public; Owner: ckantest; Tablespace: 
--

ALTER TABLE ONLY user_object_role
    ADD CONSTRAINT user_object_role_pkey PRIMARY KEY (id);


--
-- Name: user_pkey; Type: CONSTRAINT; Schema: public; Owner: ckantest; Tablespace: 
--

ALTER TABLE ONLY "user"
    ADD CONSTRAINT user_pkey PRIMARY KEY (id);


--
-- Name: idx_extra_grp_id_pkg_id; Type: INDEX; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE INDEX idx_extra_grp_id_pkg_id ON package_group USING btree (group_id, package_id);


--
-- Name: idx_extra_id_pkg_id; Type: INDEX; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE INDEX idx_extra_id_pkg_id ON package_extra USING btree (id, package_id);


--
-- Name: idx_extra_pkg_id; Type: INDEX; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE INDEX idx_extra_pkg_id ON package_extra USING btree (package_id);


--
-- Name: idx_group_id; Type: INDEX; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE INDEX idx_group_id ON "group" USING btree (id);


--
-- Name: idx_group_name; Type: INDEX; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE INDEX idx_group_name ON "group" USING btree (name);


--
-- Name: idx_group_pkg_id; Type: INDEX; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE INDEX idx_group_pkg_id ON package_group USING btree (package_id);


--
-- Name: idx_package_extra_rev_id; Type: INDEX; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE INDEX idx_package_extra_rev_id ON package_extra_revision USING btree (revision_id);


--
-- Name: idx_package_group_group_id; Type: INDEX; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE INDEX idx_package_group_group_id ON package_group USING btree (group_id);


--
-- Name: idx_package_group_id; Type: INDEX; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE INDEX idx_package_group_id ON package_group USING btree (id);


--
-- Name: idx_package_group_pkg_id; Type: INDEX; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE INDEX idx_package_group_pkg_id ON package_group USING btree (package_id);


--
-- Name: idx_package_group_pkg_id_group_id; Type: INDEX; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE INDEX idx_package_group_pkg_id_group_id ON package_group USING btree (group_id, package_id);


--
-- Name: idx_package_resource_id; Type: INDEX; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE INDEX idx_package_resource_id ON package_resource USING btree (id);


--
-- Name: idx_package_resource_pkg_id; Type: INDEX; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE INDEX idx_package_resource_pkg_id ON package_resource USING btree (package_id);


--
-- Name: idx_package_resource_pkg_id_resource_id; Type: INDEX; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE INDEX idx_package_resource_pkg_id_resource_id ON package_resource USING btree (package_id, id);


--
-- Name: idx_package_resource_rev_id; Type: INDEX; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE INDEX idx_package_resource_rev_id ON package_resource_revision USING btree (revision_id);


--
-- Name: idx_package_resource_url; Type: INDEX; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE INDEX idx_package_resource_url ON package_resource USING btree (url);


--
-- Name: idx_package_tag_id; Type: INDEX; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE INDEX idx_package_tag_id ON package_tag USING btree (id);


--
-- Name: idx_package_tag_pkg_id; Type: INDEX; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE INDEX idx_package_tag_pkg_id ON package_tag USING btree (package_id);


--
-- Name: idx_package_tag_pkg_id_tag_id; Type: INDEX; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE INDEX idx_package_tag_pkg_id_tag_id ON package_tag USING btree (tag_id, package_id);


--
-- Name: idx_package_tag_revision_id; Type: INDEX; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE INDEX idx_package_tag_revision_id ON package_tag_revision USING btree (id);


--
-- Name: idx_package_tag_revision_pkg_id; Type: INDEX; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE INDEX idx_package_tag_revision_pkg_id ON package_tag_revision USING btree (package_id);


--
-- Name: idx_package_tag_revision_pkg_id_tag_id; Type: INDEX; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE INDEX idx_package_tag_revision_pkg_id_tag_id ON package_tag_revision USING btree (tag_id, package_id);


--
-- Name: idx_package_tag_revision_rev_id; Type: INDEX; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE INDEX idx_package_tag_revision_rev_id ON package_tag_revision USING btree (revision_id);


--
-- Name: idx_package_tag_revision_tag_id; Type: INDEX; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE INDEX idx_package_tag_revision_tag_id ON package_tag_revision USING btree (tag_id);


--
-- Name: idx_package_tag_tag_id; Type: INDEX; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE INDEX idx_package_tag_tag_id ON package_tag USING btree (tag_id);


--
-- Name: idx_pkg_id; Type: INDEX; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE INDEX idx_pkg_id ON package USING btree (id);


--
-- Name: idx_pkg_lname; Type: INDEX; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE INDEX idx_pkg_lname ON package USING btree (lower((name)::text));


--
-- Name: idx_pkg_name; Type: INDEX; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE INDEX idx_pkg_name ON package USING btree (name);


--
-- Name: idx_pkg_rev_id; Type: INDEX; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE INDEX idx_pkg_rev_id ON package USING btree (revision_id);


--
-- Name: idx_pkg_revision_id; Type: INDEX; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE INDEX idx_pkg_revision_id ON package_revision USING btree (id);


--
-- Name: idx_pkg_revision_name; Type: INDEX; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE INDEX idx_pkg_revision_name ON package_revision USING btree (name);


--
-- Name: idx_pkg_revision_rev_id; Type: INDEX; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE INDEX idx_pkg_revision_rev_id ON package_revision USING btree (revision_id);


--
-- Name: idx_pkg_sid; Type: INDEX; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE INDEX idx_pkg_sid ON package USING btree (id, state);


--
-- Name: idx_pkg_slname; Type: INDEX; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE INDEX idx_pkg_slname ON package USING btree (lower((name)::text), state);


--
-- Name: idx_pkg_sname; Type: INDEX; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE INDEX idx_pkg_sname ON package USING btree (name, state);


--
-- Name: idx_pkg_srev_id; Type: INDEX; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE INDEX idx_pkg_srev_id ON package USING btree (revision_id, state);


--
-- Name: idx_pkg_stitle; Type: INDEX; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE INDEX idx_pkg_stitle ON package USING btree (title, state);


--
-- Name: idx_pkg_suname; Type: INDEX; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE INDEX idx_pkg_suname ON package USING btree (upper((name)::text), state);


--
-- Name: idx_pkg_title; Type: INDEX; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE INDEX idx_pkg_title ON package USING btree (title);


--
-- Name: idx_pkg_uname; Type: INDEX; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE INDEX idx_pkg_uname ON package USING btree (upper((name)::text));


--
-- Name: idx_ra_action; Type: INDEX; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE INDEX idx_ra_action ON role_action USING btree (action);


--
-- Name: idx_ra_role; Type: INDEX; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE INDEX idx_ra_role ON role_action USING btree (role);


--
-- Name: idx_ra_role_action; Type: INDEX; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE INDEX idx_ra_role_action ON role_action USING btree (action, role);


--
-- Name: idx_rating_id; Type: INDEX; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE INDEX idx_rating_id ON rating USING btree (id);


--
-- Name: idx_rating_package_id; Type: INDEX; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE INDEX idx_rating_package_id ON rating USING btree (package_id);


--
-- Name: idx_rating_user_id; Type: INDEX; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE INDEX idx_rating_user_id ON rating USING btree (user_id);


--
-- Name: idx_rev_state; Type: INDEX; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE INDEX idx_rev_state ON revision USING btree (state);


--
-- Name: idx_tag_id; Type: INDEX; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE INDEX idx_tag_id ON tag USING btree (id);


--
-- Name: idx_tag_name; Type: INDEX; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE INDEX idx_tag_name ON tag USING btree (name);


--
-- Name: idx_uor_context; Type: INDEX; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE INDEX idx_uor_context ON user_object_role USING btree (context);


--
-- Name: idx_uor_id; Type: INDEX; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE INDEX idx_uor_id ON user_object_role USING btree (id);


--
-- Name: idx_uor_role; Type: INDEX; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE INDEX idx_uor_role ON user_object_role USING btree (role);


--
-- Name: idx_uor_user_id; Type: INDEX; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE INDEX idx_uor_user_id ON user_object_role USING btree (user_id);


--
-- Name: idx_uor_user_id_role; Type: INDEX; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE INDEX idx_uor_user_id_role ON user_object_role USING btree (user_id, role);


--
-- Name: idx_user_id; Type: INDEX; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE INDEX idx_user_id ON "user" USING btree (id);


--
-- Name: idx_user_name; Type: INDEX; Schema: public; Owner: ckantest; Tablespace: 
--

CREATE INDEX idx_user_name ON "user" USING btree (name);


--
-- Name: authorization_group_role_authorization_group_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: ckantest
--

ALTER TABLE ONLY authorization_group_role
    ADD CONSTRAINT authorization_group_role_authorization_group_id_fkey FOREIGN KEY (authorization_group_id) REFERENCES authorization_group(id);


--
-- Name: authorization_group_role_user_object_role_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: ckantest
--

ALTER TABLE ONLY authorization_group_role
    ADD CONSTRAINT authorization_group_role_user_object_role_id_fkey FOREIGN KEY (user_object_role_id) REFERENCES user_object_role(id);


--
-- Name: authorization_group_user_authorization_group_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: ckantest
--

ALTER TABLE ONLY authorization_group_user
    ADD CONSTRAINT authorization_group_user_authorization_group_id_fkey FOREIGN KEY (authorization_group_id) REFERENCES authorization_group(id);


--
-- Name: authorization_group_user_user_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: ckantest
--

ALTER TABLE ONLY authorization_group_user
    ADD CONSTRAINT authorization_group_user_user_id_fkey FOREIGN KEY (user_id) REFERENCES "user"(id);


--
-- Name: change_changeset_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: ckantest
--

ALTER TABLE ONLY change
    ADD CONSTRAINT change_changeset_id_fkey FOREIGN KEY (changeset_id) REFERENCES changeset(id);


--
-- Name: changeset_revision_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: ckantest
--

ALTER TABLE ONLY changeset
    ADD CONSTRAINT changeset_revision_id_fkey FOREIGN KEY (revision_id) REFERENCES revision(id);


--
-- Name: group_extra_group_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: ckantest
--

ALTER TABLE ONLY group_extra
    ADD CONSTRAINT group_extra_group_id_fkey FOREIGN KEY (group_id) REFERENCES "group"(id);


--
-- Name: group_extra_revision_continuity_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: ckantest
--

ALTER TABLE ONLY group_extra_revision
    ADD CONSTRAINT group_extra_revision_continuity_id_fkey FOREIGN KEY (continuity_id) REFERENCES "group"(id);


--
-- Name: group_extra_revision_fkey; Type: FK CONSTRAINT; Schema: public; Owner: ckantest
--

ALTER TABLE ONLY group_extra
    ADD CONSTRAINT group_extra_revision_fkey FOREIGN KEY (revision_id) REFERENCES revision(id);


--
-- Name: group_extra_revision_group_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: ckantest
--

ALTER TABLE ONLY group_extra_revision
    ADD CONSTRAINT group_extra_revision_group_id_fkey FOREIGN KEY (group_id) REFERENCES "group"(id);


--
-- Name: group_extra_revision_revision_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: ckantest
--

ALTER TABLE ONLY group_extra_revision
    ADD CONSTRAINT group_extra_revision_revision_id_fkey FOREIGN KEY (revision_id) REFERENCES revision(id);


--
-- Name: group_revision_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: ckantest
--

ALTER TABLE ONLY "group"
    ADD CONSTRAINT group_revision_id_fkey FOREIGN KEY (revision_id) REFERENCES revision(id);


--
-- Name: group_revision_revision_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: ckantest
--

ALTER TABLE ONLY group_revision
    ADD CONSTRAINT group_revision_revision_id_fkey FOREIGN KEY (revision_id) REFERENCES revision(id);


--
-- Name: group_role_group_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: ckantest
--

ALTER TABLE ONLY group_role
    ADD CONSTRAINT group_role_group_id_fkey FOREIGN KEY (group_id) REFERENCES "group"(id);


--
-- Name: group_role_user_object_role_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: ckantest
--

ALTER TABLE ONLY group_role
    ADD CONSTRAINT group_role_user_object_role_id_fkey FOREIGN KEY (user_object_role_id) REFERENCES user_object_role(id);


--
-- Name: harvested_document_package_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: ckantest
--

ALTER TABLE ONLY harvested_document
    ADD CONSTRAINT harvested_document_package_id_fkey FOREIGN KEY (package_id) REFERENCES package(id);


--
-- Name: harvested_document_source_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: ckantest
--

ALTER TABLE ONLY harvested_document
    ADD CONSTRAINT harvested_document_source_id_fkey FOREIGN KEY (source_id) REFERENCES harvest_source(id);


--
-- Name: harvesting_job_source_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: ckantest
--

ALTER TABLE ONLY harvesting_job
    ADD CONSTRAINT harvesting_job_source_id_fkey FOREIGN KEY (source_id) REFERENCES harvest_source(id);


--
-- Name: package_extra_package_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: ckantest
--

ALTER TABLE ONLY package_extra
    ADD CONSTRAINT package_extra_package_id_fkey FOREIGN KEY (package_id) REFERENCES package(id);


--
-- Name: package_extra_revision_continuity_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: ckantest
--

ALTER TABLE ONLY package_extra_revision
    ADD CONSTRAINT package_extra_revision_continuity_id_fkey FOREIGN KEY (continuity_id) REFERENCES package_extra(id);


--
-- Name: package_extra_revision_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: ckantest
--

ALTER TABLE ONLY package_extra
    ADD CONSTRAINT package_extra_revision_id_fkey FOREIGN KEY (revision_id) REFERENCES revision(id);


--
-- Name: package_extra_revision_package_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: ckantest
--

ALTER TABLE ONLY package_extra_revision
    ADD CONSTRAINT package_extra_revision_package_id_fkey FOREIGN KEY (package_id) REFERENCES package(id);


--
-- Name: package_extra_revision_revision_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: ckantest
--

ALTER TABLE ONLY package_extra_revision
    ADD CONSTRAINT package_extra_revision_revision_id_fkey FOREIGN KEY (revision_id) REFERENCES revision(id);


--
-- Name: package_group_group_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: ckantest
--

ALTER TABLE ONLY package_group
    ADD CONSTRAINT package_group_group_id_fkey FOREIGN KEY (group_id) REFERENCES "group"(id);


--
-- Name: package_group_package_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: ckantest
--

ALTER TABLE ONLY package_group
    ADD CONSTRAINT package_group_package_id_fkey FOREIGN KEY (package_id) REFERENCES package(id);


--
-- Name: package_group_revision_continuity_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: ckantest
--

ALTER TABLE ONLY package_group_revision
    ADD CONSTRAINT package_group_revision_continuity_id_fkey FOREIGN KEY (continuity_id) REFERENCES "group"(id);


--
-- Name: package_group_revision_fkey; Type: FK CONSTRAINT; Schema: public; Owner: ckantest
--

ALTER TABLE ONLY package_group
    ADD CONSTRAINT package_group_revision_fkey FOREIGN KEY (revision_id) REFERENCES revision(id);


--
-- Name: package_group_revision_group_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: ckantest
--

ALTER TABLE ONLY package_group_revision
    ADD CONSTRAINT package_group_revision_group_id_fkey FOREIGN KEY (group_id) REFERENCES "group"(id);


--
-- Name: package_group_revision_package_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: ckantest
--

ALTER TABLE ONLY package_group_revision
    ADD CONSTRAINT package_group_revision_package_id_fkey FOREIGN KEY (package_id) REFERENCES package(id);


--
-- Name: package_group_revision_revision_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: ckantest
--

ALTER TABLE ONLY package_group_revision
    ADD CONSTRAINT package_group_revision_revision_id_fkey FOREIGN KEY (revision_id) REFERENCES revision(id);


--
-- Name: package_relationship_object_package_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: ckantest
--

ALTER TABLE ONLY package_relationship
    ADD CONSTRAINT package_relationship_object_package_id_fkey FOREIGN KEY (object_package_id) REFERENCES package(id);


--
-- Name: package_relationship_revision_continuity_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: ckantest
--

ALTER TABLE ONLY package_relationship_revision
    ADD CONSTRAINT package_relationship_revision_continuity_id_fkey FOREIGN KEY (continuity_id) REFERENCES package_relationship(id);


--
-- Name: package_relationship_revision_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: ckantest
--

ALTER TABLE ONLY package_relationship
    ADD CONSTRAINT package_relationship_revision_id_fkey FOREIGN KEY (revision_id) REFERENCES revision(id);


--
-- Name: package_relationship_revision_object_package_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: ckantest
--

ALTER TABLE ONLY package_relationship_revision
    ADD CONSTRAINT package_relationship_revision_object_package_id_fkey FOREIGN KEY (object_package_id) REFERENCES package(id);


--
-- Name: package_relationship_revision_revision_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: ckantest
--

ALTER TABLE ONLY package_relationship_revision
    ADD CONSTRAINT package_relationship_revision_revision_id_fkey FOREIGN KEY (revision_id) REFERENCES revision(id);


--
-- Name: package_relationship_revision_subject_package_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: ckantest
--

ALTER TABLE ONLY package_relationship_revision
    ADD CONSTRAINT package_relationship_revision_subject_package_id_fkey FOREIGN KEY (subject_package_id) REFERENCES package(id);


--
-- Name: package_relationship_subject_package_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: ckantest
--

ALTER TABLE ONLY package_relationship
    ADD CONSTRAINT package_relationship_subject_package_id_fkey FOREIGN KEY (subject_package_id) REFERENCES package(id);


--
-- Name: package_resource_package_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: ckantest
--

ALTER TABLE ONLY package_resource
    ADD CONSTRAINT package_resource_package_id_fkey FOREIGN KEY (package_id) REFERENCES package(id);


--
-- Name: package_resource_revision_continuity_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: ckantest
--

ALTER TABLE ONLY package_resource_revision
    ADD CONSTRAINT package_resource_revision_continuity_id_fkey FOREIGN KEY (continuity_id) REFERENCES package_resource(id);


--
-- Name: package_resource_revision_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: ckantest
--

ALTER TABLE ONLY package_resource
    ADD CONSTRAINT package_resource_revision_id_fkey FOREIGN KEY (revision_id) REFERENCES revision(id);


--
-- Name: package_resource_revision_package_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: ckantest
--

ALTER TABLE ONLY package_resource_revision
    ADD CONSTRAINT package_resource_revision_package_id_fkey FOREIGN KEY (package_id) REFERENCES package(id);


--
-- Name: package_resource_revision_revision_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: ckantest
--

ALTER TABLE ONLY package_resource_revision
    ADD CONSTRAINT package_resource_revision_revision_id_fkey FOREIGN KEY (revision_id) REFERENCES revision(id);


--
-- Name: package_revision_continuity_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: ckantest
--

ALTER TABLE ONLY package_revision
    ADD CONSTRAINT package_revision_continuity_id_fkey FOREIGN KEY (continuity_id) REFERENCES package(id);


--
-- Name: package_revision_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: ckantest
--

ALTER TABLE ONLY package
    ADD CONSTRAINT package_revision_id_fkey FOREIGN KEY (revision_id) REFERENCES revision(id);


--
-- Name: package_revision_revision_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: ckantest
--

ALTER TABLE ONLY package_revision
    ADD CONSTRAINT package_revision_revision_id_fkey FOREIGN KEY (revision_id) REFERENCES revision(id);


--
-- Name: package_role_package_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: ckantest
--

ALTER TABLE ONLY package_role
    ADD CONSTRAINT package_role_package_id_fkey FOREIGN KEY (package_id) REFERENCES package(id);


--
-- Name: package_role_user_object_role_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: ckantest
--

ALTER TABLE ONLY package_role
    ADD CONSTRAINT package_role_user_object_role_id_fkey FOREIGN KEY (user_object_role_id) REFERENCES user_object_role(id);


--
-- Name: package_search_package_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: ckantest
--

ALTER TABLE ONLY package_search
    ADD CONSTRAINT package_search_package_id_fkey FOREIGN KEY (package_id) REFERENCES package(id);


--
-- Name: package_tag_package_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: ckantest
--

ALTER TABLE ONLY package_tag
    ADD CONSTRAINT package_tag_package_id_fkey FOREIGN KEY (package_id) REFERENCES package(id);


--
-- Name: package_tag_revision_continuity_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: ckantest
--

ALTER TABLE ONLY package_tag_revision
    ADD CONSTRAINT package_tag_revision_continuity_id_fkey FOREIGN KEY (continuity_id) REFERENCES package_tag(id);


--
-- Name: package_tag_revision_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: ckantest
--

ALTER TABLE ONLY package_tag
    ADD CONSTRAINT package_tag_revision_id_fkey FOREIGN KEY (revision_id) REFERENCES revision(id);


--
-- Name: package_tag_revision_package_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: ckantest
--

ALTER TABLE ONLY package_tag_revision
    ADD CONSTRAINT package_tag_revision_package_id_fkey FOREIGN KEY (package_id) REFERENCES package(id);


--
-- Name: package_tag_revision_revision_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: ckantest
--

ALTER TABLE ONLY package_tag_revision
    ADD CONSTRAINT package_tag_revision_revision_id_fkey FOREIGN KEY (revision_id) REFERENCES revision(id);


--
-- Name: package_tag_revision_tag_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: ckantest
--

ALTER TABLE ONLY package_tag_revision
    ADD CONSTRAINT package_tag_revision_tag_id_fkey FOREIGN KEY (tag_id) REFERENCES tag(id);


--
-- Name: package_tag_tag_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: ckantest
--

ALTER TABLE ONLY package_tag
    ADD CONSTRAINT package_tag_tag_id_fkey FOREIGN KEY (tag_id) REFERENCES tag(id);


--
-- Name: rating_package_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: ckantest
--

ALTER TABLE ONLY rating
    ADD CONSTRAINT rating_package_id_fkey FOREIGN KEY (package_id) REFERENCES package(id);


--
-- Name: rating_user_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: ckantest
--

ALTER TABLE ONLY rating
    ADD CONSTRAINT rating_user_id_fkey FOREIGN KEY (user_id) REFERENCES "user"(id);


--
-- Name: system_role_user_object_role_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: ckantest
--

ALTER TABLE ONLY system_role
    ADD CONSTRAINT system_role_user_object_role_id_fkey FOREIGN KEY (user_object_role_id) REFERENCES user_object_role(id);


--
-- Name: user_object_role_authorized_group_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: ckantest
--

ALTER TABLE ONLY user_object_role
    ADD CONSTRAINT user_object_role_authorized_group_id_fkey FOREIGN KEY (authorized_group_id) REFERENCES authorization_group(id);


--
-- Name: user_object_role_user_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: ckantest
--

ALTER TABLE ONLY user_object_role
    ADD CONSTRAINT user_object_role_user_id_fkey FOREIGN KEY (user_id) REFERENCES "user"(id);


--
-- Name: public; Type: ACL; Schema: -; Owner: postgres
--

REVOKE ALL ON SCHEMA public FROM PUBLIC;
REVOKE ALL ON SCHEMA public FROM postgres;
GRANT ALL ON SCHEMA public TO postgres;
GRANT ALL ON SCHEMA public TO PUBLIC;


--
-- PostgreSQL database dump complete
--

